/* nodesearch.c generated by valac 0.56.13, the Vala compiler
 * generated from nodesearch.vala, do not modify */

/* find_symbol.vala
 *
 * Copyright 2019 Ben Iofel <ben@iofel.me>
 * Copyright 2020 Princeton Ferro <princetonferro@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <vala.h>
#include <glib-object.h>
#include <gee.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <valagee.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define VLS_TYPE_NODE_SEARCH (vls_node_search_get_type ())
#define VLS_NODE_SEARCH(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VLS_TYPE_NODE_SEARCH, VlsNodeSearch))
#define VLS_NODE_SEARCH_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VLS_TYPE_NODE_SEARCH, VlsNodeSearchClass))
#define VLS_IS_NODE_SEARCH(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VLS_TYPE_NODE_SEARCH))
#define VLS_IS_NODE_SEARCH_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VLS_TYPE_NODE_SEARCH))
#define VLS_NODE_SEARCH_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VLS_TYPE_NODE_SEARCH, VlsNodeSearchClass))

typedef struct _VlsNodeSearch VlsNodeSearch;
typedef struct _VlsNodeSearchClass VlsNodeSearchClass;
typedef struct _VlsNodeSearchPrivate VlsNodeSearchPrivate;

#define LSP_TYPE_POSITION (lsp_position_get_type ())
#define LSP_POSITION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_POSITION, LspPosition))
#define LSP_POSITION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_POSITION, LspPositionClass))
#define LSP_IS_POSITION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_POSITION))
#define LSP_IS_POSITION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_POSITION))
#define LSP_POSITION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_POSITION, LspPositionClass))

typedef struct _LspPosition LspPosition;
typedef struct _LspPositionClass LspPositionClass;
typedef gboolean (*VlsNodeSearchFilter) (ValaCodeNode* needle, ValaCodeNode* hay_node);
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _vala_source_file_unref0(var) ((var == NULL) ? NULL : (var = (vala_source_file_unref (var), NULL)))
#define _vala_code_node_unref0(var) ((var == NULL) ? NULL : (var = (vala_code_node_unref (var), NULL)))
#define _vala_source_reference_unref0(var) ((var == NULL) ? NULL : (var = (vala_source_reference_unref (var), NULL)))

#define LSP_TYPE_RANGE (lsp_range_get_type ())
#define LSP_RANGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_RANGE, LspRange))
#define LSP_RANGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_RANGE, LspRangeClass))
#define LSP_IS_RANGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_RANGE))
#define LSP_IS_RANGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_RANGE))
#define LSP_RANGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_RANGE, LspRangeClass))

typedef struct _LspRange LspRange;
typedef struct _LspRangeClass LspRangeClass;
#define _g_free0(var) (var = (g_free (var), NULL))

struct _VlsNodeSearch {
	ValaCodeVisitor parent_instance;
	VlsNodeSearchPrivate * priv;
	GeeList* result;
};

struct _VlsNodeSearchClass {
	ValaCodeVisitorClass parent_class;
};

struct _VlsNodeSearchPrivate {
	LspPosition* _pos;
	LspPosition* end_pos;
	ValaSourceFile* file;
	gboolean _search_multiline;
	gboolean _must_be_symbol;
	gboolean _inverted;
	GeeHashSet* seen;
	ValaCodeNode* needle;
	VlsNodeSearchFilter filter;
	gboolean include_declaration;
};

static gint VlsNodeSearch_private_offset;
static gpointer vls_node_search_parent_class = NULL;

VALA_EXTERN GType vls_node_search_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VlsNodeSearch, vala_code_visitor_unref)
VALA_EXTERN GType lsp_position_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspPosition, g_object_unref)
static gboolean vls_node_search_match (VlsNodeSearch* self,
                                ValaCodeNode* node);
VALA_EXTERN LspRange* lsp_range_new_from_sourceref (ValaSourceReference* sref);
VALA_EXTERN LspRange* lsp_range_construct_from_sourceref (GType object_type,
                                              ValaSourceReference* sref);
VALA_EXTERN GType lsp_range_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspRange, g_object_unref)
VALA_EXTERN gboolean lsp_range_contains (LspRange* self,
                             LspPosition* pos);
VALA_EXTERN LspPosition* vls_node_search_get_pos (VlsNodeSearch* self);
VALA_EXTERN gboolean vls_node_search_get_search_multiline (VlsNodeSearch* self);
VALA_EXTERN LspPosition* lsp_range_get_start (LspRange* self);
VALA_EXTERN guint lsp_position_get_line (LspPosition* self);
VALA_EXTERN LspPosition* lsp_range_get_end (LspRange* self);
VALA_EXTERN gboolean vls_node_search_get_must_be_symbol (VlsNodeSearch* self);
VALA_EXTERN gboolean vls_node_search_get_inverted (VlsNodeSearch* self);
VALA_EXTERN VlsNodeSearch* vls_node_search_new (ValaSourceFile* file,
                                    LspPosition* pos,
                                    gboolean search_multiline,
                                    LspPosition* end_pos,
                                    gboolean must_be_symbol);
VALA_EXTERN VlsNodeSearch* vls_node_search_construct (GType object_type,
                                          ValaSourceFile* file,
                                          LspPosition* pos,
                                          gboolean search_multiline,
                                          LspPosition* end_pos,
                                          gboolean must_be_symbol);
static void vls_node_search_set_pos (VlsNodeSearch* self,
                              LspPosition* value);
static void vls_node_search_set_search_multiline (VlsNodeSearch* self,
                                           gboolean value);
static void vls_node_search_set_must_be_symbol (VlsNodeSearch* self,
                                         gboolean value);
VALA_EXTERN VlsNodeSearch* vls_node_search_new_within (ValaSourceFile* file,
                                           LspRange* range,
                                           gboolean must_be_symbol);
VALA_EXTERN VlsNodeSearch* vls_node_search_construct_within (GType object_type,
                                                 ValaSourceFile* file,
                                                 LspRange* range,
                                                 gboolean must_be_symbol);
static void vls_node_search_set_inverted (VlsNodeSearch* self,
                                   gboolean value);
VALA_EXTERN VlsNodeSearch* vls_node_search_new_with_filter (ValaSourceFile* file,
                                                ValaCodeNode* needle,
                                                VlsNodeSearchFilter filter_func,
                                                gboolean include_declaration);
VALA_EXTERN VlsNodeSearch* vls_node_search_construct_with_filter (GType object_type,
                                                      ValaSourceFile* file,
                                                      ValaCodeNode* needle,
                                                      VlsNodeSearchFilter filter_func,
                                                      gboolean include_declaration);
static void vls_node_search_real_visit_source_file (ValaCodeVisitor* base,
                                             ValaSourceFile* file);
static void vls_node_search_real_visit_addressof_expression (ValaCodeVisitor* base,
                                                      ValaAddressofExpression* expr);
static void vls_node_search_real_visit_array_creation_expression (ValaCodeVisitor* base,
                                                           ValaArrayCreationExpression* expr);
static void vls_node_search_real_visit_assignment (ValaCodeVisitor* base,
                                            ValaAssignment* a);
static void vls_node_search_real_visit_base_access (ValaCodeVisitor* base,
                                             ValaBaseAccess* expr);
static void vls_node_search_real_visit_binary_expression (ValaCodeVisitor* base,
                                                   ValaBinaryExpression* expr);
static void vls_node_search_real_visit_block (ValaCodeVisitor* base,
                                       ValaBlock* b);
static void vls_node_search_real_visit_boolean_literal (ValaCodeVisitor* base,
                                                 ValaBooleanLiteral* lit);
static void vls_node_search_real_visit_break_statement (ValaCodeVisitor* base,
                                                 ValaBreakStatement* stmt);
static void vls_node_search_real_visit_cast_expression (ValaCodeVisitor* base,
                                                 ValaCastExpression* expr);
static void vls_node_search_real_visit_catch_clause (ValaCodeVisitor* base,
                                              ValaCatchClause* clause);
static void vls_node_search_real_visit_character_literal (ValaCodeVisitor* base,
                                                   ValaCharacterLiteral* lit);
static void vls_node_search_real_visit_class (ValaCodeVisitor* base,
                                       ValaClass* cl);
static void vls_node_search_real_visit_conditional_expression (ValaCodeVisitor* base,
                                                        ValaConditionalExpression* expr);
static void vls_node_search_real_visit_constant (ValaCodeVisitor* base,
                                          ValaConstant* c);
static void vls_node_search_real_visit_constructor (ValaCodeVisitor* base,
                                             ValaConstructor* c);
static void vls_node_search_real_visit_continue_statement (ValaCodeVisitor* base,
                                                    ValaContinueStatement* stmt);
static void vls_node_search_real_visit_creation_method (ValaCodeVisitor* base,
                                                 ValaCreationMethod* m);
static void vls_node_search_real_visit_data_type (ValaCodeVisitor* base,
                                           ValaDataType* type);
static void vls_node_search_real_visit_declaration_statement (ValaCodeVisitor* base,
                                                       ValaDeclarationStatement* stmt);
static void vls_node_search_real_visit_delegate (ValaCodeVisitor* base,
                                          ValaDelegate* cb);
static void vls_node_search_real_visit_delete_statement (ValaCodeVisitor* base,
                                                  ValaDeleteStatement* stmt);
static void vls_node_search_real_visit_destructor (ValaCodeVisitor* base,
                                            ValaDestructor* dtor);
static void vls_node_search_real_visit_do_statement (ValaCodeVisitor* base,
                                              ValaDoStatement* stmt);
static void vls_node_search_real_visit_element_access (ValaCodeVisitor* base,
                                                ValaElementAccess* expr);
static void vls_node_search_real_visit_empty_statement (ValaCodeVisitor* base,
                                                 ValaEmptyStatement* stmt);
static void vls_node_search_real_visit_enum (ValaCodeVisitor* base,
                                      ValaEnum* en);
static void vls_node_search_real_visit_enum_value (ValaCodeVisitor* base,
                                            ValaEnumValue* ev);
static void vls_node_search_real_visit_error_code (ValaCodeVisitor* base,
                                            ValaErrorCode* ecode);
static void vls_node_search_real_visit_error_domain (ValaCodeVisitor* base,
                                              ValaErrorDomain* edomain);
static void vls_node_search_real_visit_expression (ValaCodeVisitor* base,
                                            ValaExpression* expr);
static void vls_node_search_real_visit_expression_statement (ValaCodeVisitor* base,
                                                      ValaExpressionStatement* stmt);
static void vls_node_search_real_visit_field (ValaCodeVisitor* base,
                                       ValaField* f);
static void vls_node_search_real_visit_for_statement (ValaCodeVisitor* base,
                                               ValaForStatement* stmt);
static void vls_node_search_real_visit_foreach_statement (ValaCodeVisitor* base,
                                                   ValaForeachStatement* stmt);
static void vls_node_search_real_visit_formal_parameter (ValaCodeVisitor* base,
                                                  ValaParameter* p);
static void vls_node_search_real_visit_if_statement (ValaCodeVisitor* base,
                                              ValaIfStatement* stmt);
static void vls_node_search_real_visit_initializer_list (ValaCodeVisitor* base,
                                                  ValaInitializerList* list);
static void vls_node_search_real_visit_integer_literal (ValaCodeVisitor* base,
                                                 ValaIntegerLiteral* lit);
static void vls_node_search_real_visit_interface (ValaCodeVisitor* base,
                                           ValaInterface* iface);
static void vls_node_search_real_visit_lambda_expression (ValaCodeVisitor* base,
                                                   ValaLambdaExpression* expr);
static void vls_node_search_real_visit_local_variable (ValaCodeVisitor* base,
                                                ValaLocalVariable* local);
static void vls_node_search_real_visit_lock_statement (ValaCodeVisitor* base,
                                                ValaLockStatement* stmt);
static void vls_node_search_real_visit_loop_statement (ValaCodeVisitor* base,
                                                ValaLoopStatement* stmt);
static void vls_node_search_real_visit_member_access (ValaCodeVisitor* base,
                                               ValaMemberAccess* expr);
static void vls_node_search_real_visit_method (ValaCodeVisitor* base,
                                        ValaMethod* m);
static void vls_node_search_real_visit_method_call (ValaCodeVisitor* base,
                                             ValaMethodCall* expr);
static void vls_node_search_real_visit_namespace (ValaCodeVisitor* base,
                                           ValaNamespace* ns);
static void vls_node_search_real_visit_null_literal (ValaCodeVisitor* base,
                                              ValaNullLiteral* lit);
static void vls_node_search_real_visit_object_creation_expression (ValaCodeVisitor* base,
                                                            ValaObjectCreationExpression* expr);
static void vls_node_search_real_visit_pointer_indirection (ValaCodeVisitor* base,
                                                     ValaPointerIndirection* expr);
static void vls_node_search_real_visit_postfix_expression (ValaCodeVisitor* base,
                                                    ValaPostfixExpression* expr);
static void vls_node_search_real_visit_property (ValaCodeVisitor* base,
                                          ValaProperty* prop);
static void vls_node_search_real_visit_property_accessor (ValaCodeVisitor* base,
                                                   ValaPropertyAccessor* acc);
static void vls_node_search_real_visit_real_literal (ValaCodeVisitor* base,
                                              ValaRealLiteral* lit);
static void vls_node_search_real_visit_reference_transfer_expression (ValaCodeVisitor* base,
                                                               ValaReferenceTransferExpression* expr);
static void vls_node_search_real_visit_regex_literal (ValaCodeVisitor* base,
                                               ValaRegexLiteral* lit);
static void vls_node_search_real_visit_return_statement (ValaCodeVisitor* base,
                                                  ValaReturnStatement* stmt);
static void vls_node_search_real_visit_signal (ValaCodeVisitor* base,
                                        ValaSignal* sig);
static void vls_node_search_real_visit_sizeof_expression (ValaCodeVisitor* base,
                                                   ValaSizeofExpression* expr);
static void vls_node_search_real_visit_slice_expression (ValaCodeVisitor* base,
                                                  ValaSliceExpression* expr);
static void vls_node_search_real_visit_string_literal (ValaCodeVisitor* base,
                                                ValaStringLiteral* lit);
static void vls_node_search_real_visit_struct (ValaCodeVisitor* base,
                                        ValaStruct* st);
static void vls_node_search_real_visit_switch_label (ValaCodeVisitor* base,
                                              ValaSwitchLabel* label);
static void vls_node_search_real_visit_switch_section (ValaCodeVisitor* base,
                                                ValaSwitchSection* section);
static void vls_node_search_real_visit_switch_statement (ValaCodeVisitor* base,
                                                  ValaSwitchStatement* stmt);
static void vls_node_search_real_visit_template (ValaCodeVisitor* base,
                                          ValaTemplate* tmpl);
static void vls_node_search_real_visit_throw_statement (ValaCodeVisitor* base,
                                                 ValaThrowStatement* stmt);
static void vls_node_search_real_visit_try_statement (ValaCodeVisitor* base,
                                               ValaTryStatement* stmt);
static void vls_node_search_real_visit_type_check (ValaCodeVisitor* base,
                                            ValaTypeCheck* expr);
static void vls_node_search_real_visit_type_parameter (ValaCodeVisitor* base,
                                                ValaTypeParameter* p);
static void vls_node_search_real_visit_typeof_expression (ValaCodeVisitor* base,
                                                   ValaTypeofExpression* expr);
static void vls_node_search_real_visit_unary_expression (ValaCodeVisitor* base,
                                                  ValaUnaryExpression* expr);
static void vls_node_search_real_visit_unlock_statement (ValaCodeVisitor* base,
                                                  ValaUnlockStatement* stmt);
static void vls_node_search_real_visit_using_directive (ValaCodeVisitor* base,
                                                 ValaUsingDirective* ud);
static void vls_node_search_real_visit_with_statement (ValaCodeVisitor* base,
                                                ValaWithStatement* stmt);
static void vls_node_search_real_visit_while_statement (ValaCodeVisitor* base,
                                                 ValaWhileStatement* stmt);
static void vls_node_search_real_visit_yield_statement (ValaCodeVisitor* base,
                                                 ValaYieldStatement* stmt);
static void vls_node_search_finalize (ValaCodeVisitor * obj);
static GType vls_node_search_get_type_once (void);

static inline gpointer
vls_node_search_get_instance_private (VlsNodeSearch* self)
{
	return G_STRUCT_MEMBER_P (self, VlsNodeSearch_private_offset);
}

static gpointer
_vala_source_reference_ref0 (gpointer self)
{
	return self ? vala_source_reference_ref (self) : NULL;
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self;
	return result;
}

static gboolean
vls_node_search_match (VlsNodeSearch* self,
                       ValaCodeNode* node)
{
	ValaSourceReference* sr = NULL;
	ValaSourceReference* _tmp0_;
	ValaSourceReference* _tmp1_;
	ValaSourceReference* _tmp2_;
	ValaSourceReference* _tmp3_;
	ValaSourceReference* _tmp4_;
	ValaSourceFile* _tmp5_;
	ValaSourceFile* _tmp6_;
	ValaSourceFile* _tmp7_;
	gboolean _tmp8_ = FALSE;
	ValaSourceReference* _tmp13_;
	ValaSourceLocation _tmp14_ = {0};
	ValaSourceLocation _tmp15_;
	ValaSourceReference* _tmp16_;
	ValaSourceLocation _tmp17_ = {0};
	ValaSourceLocation _tmp18_;
	VlsNodeSearchFilter _tmp27_;
	LspRange* sr_range = NULL;
	ValaSourceReference* _tmp37_;
	LspRange* _tmp38_;
	gboolean _tmp39_;
	gboolean _tmp61_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (node != NULL, FALSE);
	_tmp0_ = vala_code_node_get_source_reference (node);
	_tmp1_ = _tmp0_;
	_tmp2_ = _vala_source_reference_ref0 (_tmp1_);
	sr = _tmp2_;
	_tmp3_ = sr;
	if (_tmp3_ == NULL) {
		result = FALSE;
		_vala_source_reference_unref0 (sr);
		return result;
	}
	_tmp4_ = sr;
	_tmp5_ = vala_source_reference_get_file (_tmp4_);
	_tmp6_ = _tmp5_;
	_tmp7_ = self->priv->file;
	if (_tmp6_ != _tmp7_) {
		result = FALSE;
		_vala_source_reference_unref0 (sr);
		return result;
	}
	if (G_TYPE_CHECK_INSTANCE_TYPE (node, VALA_TYPE_SWITCH_STATEMENT)) {
		ValaSourceReference* _tmp9_;
		LspRange* _tmp10_;
		LspRange* _tmp11_;
		LspPosition* _tmp12_;
		_tmp9_ = sr;
		_tmp10_ = lsp_range_new_from_sourceref (_tmp9_);
		if (_tmp10_) {
			g_object_set_data ((GObject *) _tmp10_, "vala-creation-function", "Vls.NodeSearch.match");
		}
		_tmp11_ = _tmp10_;
		_tmp12_ = self->priv->_pos;
		_tmp8_ = lsp_range_contains (_tmp11_, _tmp12_);
		_g_object_unref0 (_tmp11_);
	} else {
		_tmp8_ = FALSE;
	}
	if (_tmp8_) {
		result = TRUE;
		_vala_source_reference_unref0 (sr);
		return result;
	}
	_tmp13_ = sr;
	vala_source_reference_get_begin (_tmp13_, &_tmp14_);
	_tmp15_ = _tmp14_;
	_tmp16_ = sr;
	vala_source_reference_get_end (_tmp16_, &_tmp17_);
	_tmp18_ = _tmp17_;
	if (_tmp15_.line > _tmp18_.line) {
		const gchar* _tmp19_;
		const gchar* _tmp20_;
		const gchar* _tmp21_;
		ValaSourceReference* _tmp22_;
		gchar* _tmp23_;
		gchar* _tmp24_;
		gchar* _tmp25_;
		gchar* _tmp26_;
		_tmp19_ = vala_code_node_get_type_name (node);
		_tmp20_ = _tmp19_;
		_tmp21_ = string_to_string (_tmp20_);
		_tmp22_ = sr;
		_tmp23_ = vala_source_reference_to_string (_tmp22_);
		_tmp24_ = _tmp23_;
		_tmp25_ = g_strconcat ("wtf vala: ", _tmp21_, ": ", _tmp24_, NULL);
		_tmp26_ = _tmp25_;
		g_warning ("nodesearch.vala:58: %s", _tmp26_);
		_g_free0 (_tmp26_);
		_g_free0 (_tmp24_);
		result = FALSE;
		_vala_source_reference_unref0 (sr);
		return result;
	}
	_tmp27_ = self->priv->filter;
	if (_tmp27_ != NULL) {
		gboolean _tmp28_ = FALSE;
		VlsNodeSearchFilter _tmp35_;
		ValaCodeNode* _tmp36_;
		if (!self->priv->include_declaration) {
			gboolean _tmp29_ = FALSE;
			gboolean _tmp30_ = FALSE;
			ValaCodeNode* _tmp31_;
			_tmp31_ = self->priv->needle;
			if (_tmp31_ == node) {
				ValaCodeNode* _tmp32_;
				_tmp32_ = self->priv->needle;
				_tmp30_ = !G_TYPE_CHECK_INSTANCE_TYPE (_tmp32_, VALA_TYPE_LOCAL_VARIABLE);
			} else {
				_tmp30_ = FALSE;
			}
			if (_tmp30_) {
				_tmp29_ = TRUE;
			} else {
				ValaCodeNode* _tmp33_;
				ValaCodeNode* _tmp34_;
				_tmp33_ = vala_code_node_get_parent_node (node);
				_tmp34_ = _tmp33_;
				_tmp29_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp34_, VALA_TYPE_DECLARATION_STATEMENT);
			}
			_tmp28_ = _tmp29_;
		} else {
			_tmp28_ = FALSE;
		}
		if (_tmp28_) {
			result = FALSE;
			_vala_source_reference_unref0 (sr);
			return result;
		}
		_tmp35_ = self->priv->filter;
		_tmp36_ = self->priv->needle;
		result = _tmp35_ (_tmp36_, node);
		_vala_source_reference_unref0 (sr);
		return result;
	}
	_tmp37_ = sr;
	_tmp38_ = lsp_range_new_from_sourceref (_tmp37_);
	if (_tmp38_) {
		g_object_set_data ((GObject *) _tmp38_, "vala-creation-function", "Vls.NodeSearch.match");
	}
	sr_range = _tmp38_;
	_tmp39_ = self->priv->_search_multiline;
	if (!_tmp39_) {
		LspRange* _tmp40_;
		LspPosition* _tmp41_;
		LspPosition* _tmp42_;
		guint _tmp43_;
		guint _tmp44_;
		LspRange* _tmp45_;
		LspPosition* _tmp46_;
		LspPosition* _tmp47_;
		guint _tmp48_;
		guint _tmp49_;
		LspRange* _tmp50_;
		LspPosition* _tmp51_;
		LspPosition* _tmp52_;
		guint _tmp53_;
		guint _tmp54_;
		LspPosition* _tmp55_;
		guint _tmp56_;
		guint _tmp57_;
		_tmp40_ = sr_range;
		_tmp41_ = lsp_range_get_start (_tmp40_);
		_tmp42_ = _tmp41_;
		_tmp43_ = lsp_position_get_line (_tmp42_);
		_tmp44_ = _tmp43_;
		_tmp45_ = sr_range;
		_tmp46_ = lsp_range_get_end (_tmp45_);
		_tmp47_ = _tmp46_;
		_tmp48_ = lsp_position_get_line (_tmp47_);
		_tmp49_ = _tmp48_;
		if (_tmp44_ != _tmp49_) {
			result = FALSE;
			_g_object_unref0 (sr_range);
			_vala_source_reference_unref0 (sr);
			return result;
		}
		_tmp50_ = sr_range;
		_tmp51_ = lsp_range_get_start (_tmp50_);
		_tmp52_ = _tmp51_;
		_tmp53_ = lsp_position_get_line (_tmp52_);
		_tmp54_ = _tmp53_;
		_tmp55_ = self->priv->_pos;
		_tmp56_ = lsp_position_get_line (_tmp55_);
		_tmp57_ = _tmp56_;
		if (_tmp54_ != _tmp57_) {
			result = FALSE;
			_g_object_unref0 (sr_range);
			_vala_source_reference_unref0 (sr);
			return result;
		}
	} else {
		gboolean _tmp58_;
		_tmp58_ = self->priv->_must_be_symbol;
		if (_tmp58_) {
			gboolean _tmp59_ = FALSE;
			gboolean _tmp60_ = FALSE;
			if (G_TYPE_CHECK_INSTANCE_TYPE (node, VALA_TYPE_STATEMENT)) {
				_tmp60_ = TRUE;
			} else {
				_tmp60_ = G_TYPE_CHECK_INSTANCE_TYPE (node, VALA_TYPE_LAMBDA_EXPRESSION);
			}
			if (_tmp60_) {
				_tmp59_ = TRUE;
			} else {
				_tmp59_ = G_TYPE_CHECK_INSTANCE_TYPE (node, VALA_TYPE_CATCH_CLAUSE);
			}
			if (_tmp59_) {
				result = FALSE;
				_g_object_unref0 (sr_range);
				_vala_source_reference_unref0 (sr);
				return result;
			}
		}
	}
	_tmp61_ = self->priv->_inverted;
	if (!_tmp61_) {
		gboolean _tmp62_ = FALSE;
		LspRange* _tmp63_;
		LspPosition* _tmp64_;
		_tmp63_ = sr_range;
		_tmp64_ = self->priv->_pos;
		if (lsp_range_contains (_tmp63_, _tmp64_)) {
			gboolean _tmp65_ = FALSE;
			LspPosition* _tmp66_;
			_tmp66_ = self->priv->end_pos;
			if (_tmp66_ == NULL) {
				_tmp65_ = TRUE;
			} else {
				LspRange* _tmp67_;
				LspPosition* _tmp68_;
				_tmp67_ = sr_range;
				_tmp68_ = self->priv->end_pos;
				_tmp65_ = lsp_range_contains (_tmp67_, _tmp68_);
			}
			_tmp62_ = _tmp65_;
		} else {
			_tmp62_ = FALSE;
		}
		result = _tmp62_;
		_g_object_unref0 (sr_range);
		_vala_source_reference_unref0 (sr);
		return result;
	} else {
		gboolean _tmp69_ = FALSE;
		LspPosition* _tmp70_;
		LspRange* _tmp71_;
		LspPosition* _tmp72_;
		LspPosition* _tmp73_;
		_tmp70_ = self->priv->_pos;
		_tmp71_ = sr_range;
		_tmp72_ = lsp_range_get_start (_tmp71_);
		_tmp73_ = _tmp72_;
		if (gee_comparable_compare_to ((GeeComparable*) _tmp70_, _tmp73_) <= 0) {
			gboolean _tmp74_ = FALSE;
			LspPosition* _tmp75_;
			_tmp75_ = self->priv->end_pos;
			if (_tmp75_ == NULL) {
				_tmp74_ = TRUE;
			} else {
				LspRange* _tmp76_;
				LspPosition* _tmp77_;
				LspPosition* _tmp78_;
				LspPosition* _tmp79_;
				_tmp76_ = sr_range;
				_tmp77_ = lsp_range_get_start (_tmp76_);
				_tmp78_ = _tmp77_;
				_tmp79_ = self->priv->end_pos;
				_tmp74_ = gee_comparable_compare_to ((GeeComparable*) _tmp78_, _tmp79_) <= 0;
			}
			_tmp69_ = _tmp74_;
		} else {
			_tmp69_ = FALSE;
		}
		result = _tmp69_;
		_g_object_unref0 (sr_range);
		_vala_source_reference_unref0 (sr);
		return result;
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static gpointer
_vala_source_file_ref0 (gpointer self)
{
	return self ? vala_source_file_ref (self) : NULL;
}

VlsNodeSearch*
vls_node_search_construct (GType object_type,
                           ValaSourceFile* file,
                           LspPosition* pos,
                           gboolean search_multiline,
                           LspPosition* end_pos,
                           gboolean must_be_symbol)
{
	VlsNodeSearch* self = NULL;
	LspPosition* _tmp0_;
	ValaSourceFile* _tmp1_;
	g_return_val_if_fail (file != NULL, NULL);
	g_return_val_if_fail (pos != NULL, NULL);
	self = (VlsNodeSearch*) vala_code_visitor_construct (object_type);
	vls_node_search_set_pos (self, pos);
	_tmp0_ = _g_object_ref0 (end_pos);
	_g_object_unref0 (self->priv->end_pos);
	self->priv->end_pos = _tmp0_;
	_tmp1_ = _vala_source_file_ref0 (file);
	_vala_source_file_unref0 (self->priv->file);
	self->priv->file = _tmp1_;
	vls_node_search_set_search_multiline (self, search_multiline);
	vls_node_search_set_must_be_symbol (self, must_be_symbol);
	vala_code_visitor_visit_source_file ((ValaCodeVisitor*) self, file);
	return self;
}

VlsNodeSearch*
vls_node_search_new (ValaSourceFile* file,
                     LspPosition* pos,
                     gboolean search_multiline,
                     LspPosition* end_pos,
                     gboolean must_be_symbol)
{
	return vls_node_search_construct (VLS_TYPE_NODE_SEARCH, file, pos, search_multiline, end_pos, must_be_symbol);
}

/**
     * Search for all code nodes within {@link range}.
     */
VlsNodeSearch*
vls_node_search_construct_within (GType object_type,
                                  ValaSourceFile* file,
                                  LspRange* range,
                                  gboolean must_be_symbol)
{
	VlsNodeSearch* self = NULL;
	LspPosition* _tmp0_;
	LspPosition* _tmp1_;
	LspPosition* _tmp2_;
	LspPosition* _tmp3_;
	LspPosition* _tmp4_;
	ValaSourceFile* _tmp5_;
	g_return_val_if_fail (file != NULL, NULL);
	g_return_val_if_fail (range != NULL, NULL);
	self = (VlsNodeSearch*) vala_code_visitor_construct (object_type);
	_tmp0_ = lsp_range_get_start (range);
	_tmp1_ = _tmp0_;
	vls_node_search_set_pos (self, _tmp1_);
	_tmp2_ = lsp_range_get_end (range);
	_tmp3_ = _tmp2_;
	_tmp4_ = _g_object_ref0 (_tmp3_);
	_g_object_unref0 (self->priv->end_pos);
	self->priv->end_pos = _tmp4_;
	_tmp5_ = _vala_source_file_ref0 (file);
	_vala_source_file_unref0 (self->priv->file);
	self->priv->file = _tmp5_;
	vls_node_search_set_search_multiline (self, TRUE);
	vls_node_search_set_must_be_symbol (self, must_be_symbol);
	vls_node_search_set_inverted (self, TRUE);
	vala_code_visitor_visit_source_file ((ValaCodeVisitor*) self, file);
	return self;
}

VlsNodeSearch*
vls_node_search_new_within (ValaSourceFile* file,
                            LspRange* range,
                            gboolean must_be_symbol)
{
	return vls_node_search_construct_within (VLS_TYPE_NODE_SEARCH, file, range, must_be_symbol);
}

static gpointer
_vala_code_node_ref0 (gpointer self)
{
	return self ? vala_code_node_ref (self) : NULL;
}

VlsNodeSearch*
vls_node_search_construct_with_filter (GType object_type,
                                       ValaSourceFile* file,
                                       ValaCodeNode* needle,
                                       VlsNodeSearchFilter filter_func,
                                       gboolean include_declaration)
{
	VlsNodeSearch* self = NULL;
	ValaSourceFile* _tmp0_;
	ValaCodeNode* _tmp1_;
	g_return_val_if_fail (file != NULL, NULL);
	g_return_val_if_fail (needle != NULL, NULL);
	self = (VlsNodeSearch*) vala_code_visitor_construct (object_type);
	_tmp0_ = _vala_source_file_ref0 (file);
	_vala_source_file_unref0 (self->priv->file);
	self->priv->file = _tmp0_;
	_tmp1_ = _vala_code_node_ref0 (needle);
	_vala_code_node_unref0 (self->priv->needle);
	self->priv->needle = _tmp1_;
	self->priv->filter = filter_func;
	self->priv->include_declaration = include_declaration;
	vala_code_visitor_visit_source_file ((ValaCodeVisitor*) self, file);
	return self;
}

VlsNodeSearch*
vls_node_search_new_with_filter (ValaSourceFile* file,
                                 ValaCodeNode* needle,
                                 VlsNodeSearchFilter filter_func,
                                 gboolean include_declaration)
{
	return vls_node_search_construct_with_filter (VLS_TYPE_NODE_SEARCH, file, needle, filter_func, include_declaration);
}

static void
vls_node_search_real_visit_source_file (ValaCodeVisitor* base,
                                        ValaSourceFile* file)
{
	VlsNodeSearch * self;
	self = (VlsNodeSearch*) base;
	g_return_if_fail (file != NULL);
	vala_source_file_accept_children (file, (ValaCodeVisitor*) self);
	{
		ValaList* _ud_list = NULL;
		ValaList* _tmp0_;
		ValaList* _tmp1_;
		gint _ud_size = 0;
		ValaList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _ud_index = 0;
		_tmp0_ = vala_source_file_get_current_using_directives (file);
		_tmp1_ = _tmp0_;
		_ud_list = _tmp1_;
		_tmp2_ = _ud_list;
		_tmp3_ = vala_collection_get_size ((ValaCollection*) _tmp2_);
		_tmp4_ = _tmp3_;
		_ud_size = _tmp4_;
		_ud_index = -1;
		while (TRUE) {
			gint _tmp5_;
			gint _tmp6_;
			ValaUsingDirective* ud = NULL;
			ValaList* _tmp7_;
			gpointer _tmp8_;
			ValaUsingDirective* _tmp9_;
			_ud_index = _ud_index + 1;
			_tmp5_ = _ud_index;
			_tmp6_ = _ud_size;
			if (!(_tmp5_ < _tmp6_)) {
				break;
			}
			_tmp7_ = _ud_list;
			_tmp8_ = vala_list_get (_tmp7_, _ud_index);
			ud = (ValaUsingDirective*) _tmp8_;
			_tmp9_ = ud;
			if (vls_node_search_match (self, (ValaCodeNode*) _tmp9_)) {
				GeeList* _tmp10_;
				ValaUsingDirective* _tmp11_;
				_tmp10_ = self->result;
				_tmp11_ = ud;
				gee_collection_add ((GeeCollection*) _tmp10_, (ValaCodeNode*) _tmp11_);
			}
			_vala_code_node_unref0 (ud);
		}
	}
}

static void
vls_node_search_real_visit_addressof_expression (ValaCodeVisitor* base,
                                                 ValaAddressofExpression* expr)
{
	VlsNodeSearch * self;
	GeeHashSet* _tmp0_;
	self = (VlsNodeSearch*) base;
	g_return_if_fail (expr != NULL);
	_tmp0_ = self->priv->seen;
	if (!gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) expr)) {
		return;
	}
	if (vls_node_search_match (self, (ValaCodeNode*) expr)) {
		GeeList* _tmp1_;
		_tmp1_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp1_, (ValaCodeNode*) expr);
	}
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}

static void
vls_node_search_real_visit_array_creation_expression (ValaCodeVisitor* base,
                                                      ValaArrayCreationExpression* expr)
{
	VlsNodeSearch * self;
	GeeHashSet* _tmp0_;
	self = (VlsNodeSearch*) base;
	g_return_if_fail (expr != NULL);
	_tmp0_ = self->priv->seen;
	if (!gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) expr)) {
		return;
	}
	if (vls_node_search_match (self, (ValaCodeNode*) expr)) {
		GeeList* _tmp1_;
		_tmp1_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp1_, (ValaCodeNode*) expr);
	}
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}

static void
vls_node_search_real_visit_assignment (ValaCodeVisitor* base,
                                       ValaAssignment* a)
{
	VlsNodeSearch * self;
	GeeHashSet* _tmp0_;
	self = (VlsNodeSearch*) base;
	g_return_if_fail (a != NULL);
	_tmp0_ = self->priv->seen;
	if (!gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) a)) {
		return;
	}
	if (vls_node_search_match (self, (ValaCodeNode*) a)) {
		GeeList* _tmp1_;
		_tmp1_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp1_, (ValaCodeNode*) a);
	}
	vala_code_node_accept_children ((ValaCodeNode*) a, (ValaCodeVisitor*) self);
}

static void
vls_node_search_real_visit_base_access (ValaCodeVisitor* base,
                                        ValaBaseAccess* expr)
{
	VlsNodeSearch * self;
	GeeHashSet* _tmp0_;
	self = (VlsNodeSearch*) base;
	g_return_if_fail (expr != NULL);
	_tmp0_ = self->priv->seen;
	if (!gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) expr)) {
		return;
	}
	if (vls_node_search_match (self, (ValaCodeNode*) expr)) {
		GeeList* _tmp1_;
		_tmp1_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp1_, (ValaCodeNode*) expr);
	}
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}

static void
vls_node_search_real_visit_binary_expression (ValaCodeVisitor* base,
                                              ValaBinaryExpression* expr)
{
	VlsNodeSearch * self;
	GeeHashSet* _tmp0_;
	self = (VlsNodeSearch*) base;
	g_return_if_fail (expr != NULL);
	_tmp0_ = self->priv->seen;
	if (!gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) expr)) {
		return;
	}
	if (vls_node_search_match (self, (ValaCodeNode*) expr)) {
		GeeList* _tmp1_;
		_tmp1_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp1_, (ValaCodeNode*) expr);
	}
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}

static void
vls_node_search_real_visit_block (ValaCodeVisitor* base,
                                  ValaBlock* b)
{
	VlsNodeSearch * self;
	GeeHashSet* _tmp0_;
	self = (VlsNodeSearch*) base;
	g_return_if_fail (b != NULL);
	_tmp0_ = self->priv->seen;
	if (!gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) b)) {
		return;
	}
	if (vls_node_search_match (self, (ValaCodeNode*) b)) {
		GeeList* _tmp1_;
		_tmp1_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp1_, (ValaCodeNode*) b);
	}
	vala_code_node_accept_children ((ValaCodeNode*) b, (ValaCodeVisitor*) self);
}

static void
vls_node_search_real_visit_boolean_literal (ValaCodeVisitor* base,
                                            ValaBooleanLiteral* lit)
{
	VlsNodeSearch * self;
	GeeHashSet* _tmp0_;
	self = (VlsNodeSearch*) base;
	g_return_if_fail (lit != NULL);
	_tmp0_ = self->priv->seen;
	if (!gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) lit)) {
		return;
	}
	if (vls_node_search_match (self, (ValaCodeNode*) lit)) {
		GeeList* _tmp1_;
		_tmp1_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp1_, (ValaCodeNode*) lit);
	}
	vala_code_node_accept_children ((ValaCodeNode*) lit, (ValaCodeVisitor*) self);
}

static void
vls_node_search_real_visit_break_statement (ValaCodeVisitor* base,
                                            ValaBreakStatement* stmt)
{
	VlsNodeSearch * self;
	GeeHashSet* _tmp0_;
	self = (VlsNodeSearch*) base;
	g_return_if_fail (stmt != NULL);
	_tmp0_ = self->priv->seen;
	if (!gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) stmt)) {
		return;
	}
	if (vls_node_search_match (self, (ValaCodeNode*) stmt)) {
		GeeList* _tmp1_;
		_tmp1_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp1_, (ValaCodeNode*) stmt);
	}
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}

static void
vls_node_search_real_visit_cast_expression (ValaCodeVisitor* base,
                                            ValaCastExpression* expr)
{
	VlsNodeSearch * self;
	GeeHashSet* _tmp0_;
	self = (VlsNodeSearch*) base;
	g_return_if_fail (expr != NULL);
	_tmp0_ = self->priv->seen;
	if (!gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) expr)) {
		return;
	}
	if (vls_node_search_match (self, (ValaCodeNode*) expr)) {
		GeeList* _tmp1_;
		_tmp1_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp1_, (ValaCodeNode*) expr);
	}
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}

static void
vls_node_search_real_visit_catch_clause (ValaCodeVisitor* base,
                                         ValaCatchClause* clause)
{
	VlsNodeSearch * self;
	GeeHashSet* _tmp0_;
	self = (VlsNodeSearch*) base;
	g_return_if_fail (clause != NULL);
	_tmp0_ = self->priv->seen;
	if (!gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) clause)) {
		return;
	}
	if (vls_node_search_match (self, (ValaCodeNode*) clause)) {
		GeeList* _tmp1_;
		_tmp1_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp1_, (ValaCodeNode*) clause);
	}
	vala_code_node_accept_children ((ValaCodeNode*) clause, (ValaCodeVisitor*) self);
}

static void
vls_node_search_real_visit_character_literal (ValaCodeVisitor* base,
                                              ValaCharacterLiteral* lit)
{
	VlsNodeSearch * self;
	GeeHashSet* _tmp0_;
	self = (VlsNodeSearch*) base;
	g_return_if_fail (lit != NULL);
	_tmp0_ = self->priv->seen;
	if (!gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) lit)) {
		return;
	}
	if (vls_node_search_match (self, (ValaCodeNode*) lit)) {
		GeeList* _tmp1_;
		_tmp1_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp1_, (ValaCodeNode*) lit);
	}
	vala_code_node_accept_children ((ValaCodeNode*) lit, (ValaCodeVisitor*) self);
}

static void
vls_node_search_real_visit_class (ValaCodeVisitor* base,
                                  ValaClass* cl)
{
	VlsNodeSearch * self;
	GeeHashSet* _tmp0_;
	self = (VlsNodeSearch*) base;
	g_return_if_fail (cl != NULL);
	_tmp0_ = self->priv->seen;
	if (!gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) cl)) {
		return;
	}
	if (vls_node_search_match (self, (ValaCodeNode*) cl)) {
		GeeList* _tmp1_;
		_tmp1_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp1_, (ValaCodeNode*) cl);
	}
	vala_code_node_accept_children ((ValaCodeNode*) cl, (ValaCodeVisitor*) self);
}

static void
vls_node_search_real_visit_conditional_expression (ValaCodeVisitor* base,
                                                   ValaConditionalExpression* expr)
{
	VlsNodeSearch * self;
	GeeHashSet* _tmp0_;
	self = (VlsNodeSearch*) base;
	g_return_if_fail (expr != NULL);
	_tmp0_ = self->priv->seen;
	if (!gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) expr)) {
		return;
	}
	if (vls_node_search_match (self, (ValaCodeNode*) expr)) {
		GeeList* _tmp1_;
		_tmp1_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp1_, (ValaCodeNode*) expr);
	}
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}

static void
vls_node_search_real_visit_constant (ValaCodeVisitor* base,
                                     ValaConstant* c)
{
	VlsNodeSearch * self;
	GeeHashSet* _tmp0_;
	self = (VlsNodeSearch*) base;
	g_return_if_fail (c != NULL);
	_tmp0_ = self->priv->seen;
	if (!gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) c)) {
		return;
	}
	if (vls_node_search_match (self, (ValaCodeNode*) c)) {
		GeeList* _tmp1_;
		_tmp1_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp1_, (ValaCodeNode*) c);
	}
	vala_code_node_accept_children ((ValaCodeNode*) c, (ValaCodeVisitor*) self);
}

static void
vls_node_search_real_visit_constructor (ValaCodeVisitor* base,
                                        ValaConstructor* c)
{
	VlsNodeSearch * self;
	GeeHashSet* _tmp0_;
	self = (VlsNodeSearch*) base;
	g_return_if_fail (c != NULL);
	_tmp0_ = self->priv->seen;
	if (!gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) c)) {
		return;
	}
	if (vls_node_search_match (self, (ValaCodeNode*) c)) {
		GeeList* _tmp1_;
		_tmp1_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp1_, (ValaCodeNode*) c);
	}
	vala_code_node_accept_children ((ValaCodeNode*) c, (ValaCodeVisitor*) self);
}

static void
vls_node_search_real_visit_continue_statement (ValaCodeVisitor* base,
                                               ValaContinueStatement* stmt)
{
	VlsNodeSearch * self;
	GeeHashSet* _tmp0_;
	self = (VlsNodeSearch*) base;
	g_return_if_fail (stmt != NULL);
	_tmp0_ = self->priv->seen;
	if (!gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) stmt)) {
		return;
	}
	if (vls_node_search_match (self, (ValaCodeNode*) stmt)) {
		GeeList* _tmp1_;
		_tmp1_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp1_, (ValaCodeNode*) stmt);
	}
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}

static void
vls_node_search_real_visit_creation_method (ValaCodeVisitor* base,
                                            ValaCreationMethod* m)
{
	VlsNodeSearch * self;
	GeeHashSet* _tmp0_;
	self = (VlsNodeSearch*) base;
	g_return_if_fail (m != NULL);
	_tmp0_ = self->priv->seen;
	if (!gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) m)) {
		return;
	}
	if (vls_node_search_match (self, (ValaCodeNode*) m)) {
		GeeList* _tmp1_;
		_tmp1_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp1_, (ValaCodeNode*) m);
	}
	vala_code_node_accept_children ((ValaCodeNode*) m, (ValaCodeVisitor*) self);
}

static void
vls_node_search_real_visit_data_type (ValaCodeVisitor* base,
                                      ValaDataType* type)
{
	VlsNodeSearch * self;
	GeeHashSet* _tmp0_;
	self = (VlsNodeSearch*) base;
	g_return_if_fail (type != NULL);
	_tmp0_ = self->priv->seen;
	if (!gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) type)) {
		return;
	}
	if (vls_node_search_match (self, (ValaCodeNode*) type)) {
		GeeList* _tmp1_;
		_tmp1_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp1_, (ValaCodeNode*) type);
	}
	vala_code_node_accept_children ((ValaCodeNode*) type, (ValaCodeVisitor*) self);
}

static void
vls_node_search_real_visit_declaration_statement (ValaCodeVisitor* base,
                                                  ValaDeclarationStatement* stmt)
{
	VlsNodeSearch * self;
	GeeHashSet* _tmp0_;
	self = (VlsNodeSearch*) base;
	g_return_if_fail (stmt != NULL);
	_tmp0_ = self->priv->seen;
	if (!gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) stmt)) {
		return;
	}
	if (vls_node_search_match (self, (ValaCodeNode*) stmt)) {
		GeeList* _tmp1_;
		_tmp1_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp1_, (ValaCodeNode*) stmt);
	}
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}

static void
vls_node_search_real_visit_delegate (ValaCodeVisitor* base,
                                     ValaDelegate* cb)
{
	VlsNodeSearch * self;
	GeeHashSet* _tmp0_;
	self = (VlsNodeSearch*) base;
	g_return_if_fail (cb != NULL);
	_tmp0_ = self->priv->seen;
	if (!gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) cb)) {
		return;
	}
	if (vls_node_search_match (self, (ValaCodeNode*) cb)) {
		GeeList* _tmp1_;
		_tmp1_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp1_, (ValaCodeNode*) cb);
	}
	vala_code_node_accept_children ((ValaCodeNode*) cb, (ValaCodeVisitor*) self);
}

static void
vls_node_search_real_visit_delete_statement (ValaCodeVisitor* base,
                                             ValaDeleteStatement* stmt)
{
	VlsNodeSearch * self;
	GeeHashSet* _tmp0_;
	self = (VlsNodeSearch*) base;
	g_return_if_fail (stmt != NULL);
	_tmp0_ = self->priv->seen;
	if (!gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) stmt)) {
		return;
	}
	if (vls_node_search_match (self, (ValaCodeNode*) stmt)) {
		GeeList* _tmp1_;
		_tmp1_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp1_, (ValaCodeNode*) stmt);
	}
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}

static void
vls_node_search_real_visit_destructor (ValaCodeVisitor* base,
                                       ValaDestructor* dtor)
{
	VlsNodeSearch * self;
	GeeHashSet* _tmp0_;
	self = (VlsNodeSearch*) base;
	g_return_if_fail (dtor != NULL);
	_tmp0_ = self->priv->seen;
	if (!gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) dtor)) {
		return;
	}
	if (vls_node_search_match (self, (ValaCodeNode*) dtor)) {
		GeeList* _tmp1_;
		_tmp1_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp1_, (ValaCodeNode*) dtor);
	}
	vala_code_node_accept_children ((ValaCodeNode*) dtor, (ValaCodeVisitor*) self);
}

static void
vls_node_search_real_visit_do_statement (ValaCodeVisitor* base,
                                         ValaDoStatement* stmt)
{
	VlsNodeSearch * self;
	GeeHashSet* _tmp0_;
	self = (VlsNodeSearch*) base;
	g_return_if_fail (stmt != NULL);
	_tmp0_ = self->priv->seen;
	if (!gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) stmt)) {
		return;
	}
	if (vls_node_search_match (self, (ValaCodeNode*) stmt)) {
		GeeList* _tmp1_;
		_tmp1_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp1_, (ValaCodeNode*) stmt);
	}
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}

static void
vls_node_search_real_visit_element_access (ValaCodeVisitor* base,
                                           ValaElementAccess* expr)
{
	VlsNodeSearch * self;
	GeeHashSet* _tmp0_;
	self = (VlsNodeSearch*) base;
	g_return_if_fail (expr != NULL);
	_tmp0_ = self->priv->seen;
	if (!gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) expr)) {
		return;
	}
	if (vls_node_search_match (self, (ValaCodeNode*) expr)) {
		GeeList* _tmp1_;
		_tmp1_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp1_, (ValaCodeNode*) expr);
	}
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}

static void
vls_node_search_real_visit_empty_statement (ValaCodeVisitor* base,
                                            ValaEmptyStatement* stmt)
{
	VlsNodeSearch * self;
	GeeHashSet* _tmp0_;
	self = (VlsNodeSearch*) base;
	g_return_if_fail (stmt != NULL);
	_tmp0_ = self->priv->seen;
	if (!gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) stmt)) {
		return;
	}
	if (vls_node_search_match (self, (ValaCodeNode*) stmt)) {
		GeeList* _tmp1_;
		_tmp1_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp1_, (ValaCodeNode*) stmt);
	}
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}

static void
vls_node_search_real_visit_enum (ValaCodeVisitor* base,
                                 ValaEnum* en)
{
	VlsNodeSearch * self;
	GeeHashSet* _tmp0_;
	self = (VlsNodeSearch*) base;
	g_return_if_fail (en != NULL);
	_tmp0_ = self->priv->seen;
	if (!gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) en)) {
		return;
	}
	if (vls_node_search_match (self, (ValaCodeNode*) en)) {
		GeeList* _tmp1_;
		_tmp1_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp1_, (ValaCodeNode*) en);
	}
	vala_code_node_accept_children ((ValaCodeNode*) en, (ValaCodeVisitor*) self);
}

static void
vls_node_search_real_visit_enum_value (ValaCodeVisitor* base,
                                       ValaEnumValue* ev)
{
	VlsNodeSearch * self;
	GeeHashSet* _tmp0_;
	self = (VlsNodeSearch*) base;
	g_return_if_fail (ev != NULL);
	_tmp0_ = self->priv->seen;
	if (!gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) ev)) {
		return;
	}
	if (vls_node_search_match (self, (ValaCodeNode*) ev)) {
		GeeList* _tmp1_;
		_tmp1_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp1_, (ValaCodeNode*) ev);
	}
	vala_code_node_accept_children ((ValaCodeNode*) ev, (ValaCodeVisitor*) self);
}

static void
vls_node_search_real_visit_error_code (ValaCodeVisitor* base,
                                       ValaErrorCode* ecode)
{
	VlsNodeSearch * self;
	GeeHashSet* _tmp0_;
	self = (VlsNodeSearch*) base;
	g_return_if_fail (ecode != NULL);
	_tmp0_ = self->priv->seen;
	if (!gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) ecode)) {
		return;
	}
	if (vls_node_search_match (self, (ValaCodeNode*) ecode)) {
		GeeList* _tmp1_;
		_tmp1_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp1_, (ValaCodeNode*) ecode);
	}
	vala_code_node_accept_children ((ValaCodeNode*) ecode, (ValaCodeVisitor*) self);
}

static void
vls_node_search_real_visit_error_domain (ValaCodeVisitor* base,
                                         ValaErrorDomain* edomain)
{
	VlsNodeSearch * self;
	GeeHashSet* _tmp0_;
	self = (VlsNodeSearch*) base;
	g_return_if_fail (edomain != NULL);
	_tmp0_ = self->priv->seen;
	if (!gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) edomain)) {
		return;
	}
	if (vls_node_search_match (self, (ValaCodeNode*) edomain)) {
		GeeList* _tmp1_;
		_tmp1_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp1_, (ValaCodeNode*) edomain);
	}
	vala_code_node_accept_children ((ValaCodeNode*) edomain, (ValaCodeVisitor*) self);
}

static void
vls_node_search_real_visit_expression (ValaCodeVisitor* base,
                                       ValaExpression* expr)
{
	VlsNodeSearch * self;
	GeeHashSet* _tmp0_;
	self = (VlsNodeSearch*) base;
	g_return_if_fail (expr != NULL);
	_tmp0_ = self->priv->seen;
	if (!gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) expr)) {
		return;
	}
	if (vls_node_search_match (self, (ValaCodeNode*) expr)) {
		GeeList* _tmp1_;
		_tmp1_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp1_, (ValaCodeNode*) expr);
	}
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}

static void
vls_node_search_real_visit_expression_statement (ValaCodeVisitor* base,
                                                 ValaExpressionStatement* stmt)
{
	VlsNodeSearch * self;
	GeeHashSet* _tmp0_;
	self = (VlsNodeSearch*) base;
	g_return_if_fail (stmt != NULL);
	_tmp0_ = self->priv->seen;
	if (!gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) stmt)) {
		return;
	}
	if (vls_node_search_match (self, (ValaCodeNode*) stmt)) {
		GeeList* _tmp1_;
		_tmp1_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp1_, (ValaCodeNode*) stmt);
	}
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}

static void
vls_node_search_real_visit_field (ValaCodeVisitor* base,
                                  ValaField* f)
{
	VlsNodeSearch * self;
	GeeHashSet* _tmp0_;
	self = (VlsNodeSearch*) base;
	g_return_if_fail (f != NULL);
	_tmp0_ = self->priv->seen;
	if (!gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) f)) {
		return;
	}
	if (vls_node_search_match (self, (ValaCodeNode*) f)) {
		GeeList* _tmp1_;
		_tmp1_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp1_, (ValaCodeNode*) f);
	}
	vala_code_node_accept_children ((ValaCodeNode*) f, (ValaCodeVisitor*) self);
}

static void
vls_node_search_real_visit_for_statement (ValaCodeVisitor* base,
                                          ValaForStatement* stmt)
{
	VlsNodeSearch * self;
	GeeHashSet* _tmp0_;
	self = (VlsNodeSearch*) base;
	g_return_if_fail (stmt != NULL);
	_tmp0_ = self->priv->seen;
	if (!gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) stmt)) {
		return;
	}
	if (vls_node_search_match (self, (ValaCodeNode*) stmt)) {
		GeeList* _tmp1_;
		_tmp1_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp1_, (ValaCodeNode*) stmt);
	}
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}

static void
vls_node_search_real_visit_foreach_statement (ValaCodeVisitor* base,
                                              ValaForeachStatement* stmt)
{
	VlsNodeSearch * self;
	GeeHashSet* _tmp0_;
	self = (VlsNodeSearch*) base;
	g_return_if_fail (stmt != NULL);
	_tmp0_ = self->priv->seen;
	if (!gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) stmt)) {
		return;
	}
	if (vls_node_search_match (self, (ValaCodeNode*) stmt)) {
		GeeList* _tmp1_;
		_tmp1_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp1_, (ValaCodeNode*) stmt);
	}
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}

static void
vls_node_search_real_visit_formal_parameter (ValaCodeVisitor* base,
                                             ValaParameter* p)
{
	VlsNodeSearch * self;
	GeeHashSet* _tmp0_;
	self = (VlsNodeSearch*) base;
	g_return_if_fail (p != NULL);
	_tmp0_ = self->priv->seen;
	if (!gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) p)) {
		return;
	}
	if (vls_node_search_match (self, (ValaCodeNode*) p)) {
		GeeList* _tmp1_;
		_tmp1_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp1_, (ValaCodeNode*) p);
	}
	vala_code_node_accept_children ((ValaCodeNode*) p, (ValaCodeVisitor*) self);
}

static void
vls_node_search_real_visit_if_statement (ValaCodeVisitor* base,
                                         ValaIfStatement* stmt)
{
	VlsNodeSearch * self;
	GeeHashSet* _tmp0_;
	self = (VlsNodeSearch*) base;
	g_return_if_fail (stmt != NULL);
	_tmp0_ = self->priv->seen;
	if (!gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) stmt)) {
		return;
	}
	if (vls_node_search_match (self, (ValaCodeNode*) stmt)) {
		GeeList* _tmp1_;
		_tmp1_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp1_, (ValaCodeNode*) stmt);
	}
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}

static void
vls_node_search_real_visit_initializer_list (ValaCodeVisitor* base,
                                             ValaInitializerList* list)
{
	VlsNodeSearch * self;
	GeeHashSet* _tmp0_;
	self = (VlsNodeSearch*) base;
	g_return_if_fail (list != NULL);
	_tmp0_ = self->priv->seen;
	if (!gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) list)) {
		return;
	}
	if (vls_node_search_match (self, (ValaCodeNode*) list)) {
		GeeList* _tmp1_;
		_tmp1_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp1_, (ValaCodeNode*) list);
	}
	vala_code_node_accept_children ((ValaCodeNode*) list, (ValaCodeVisitor*) self);
}

static void
vls_node_search_real_visit_integer_literal (ValaCodeVisitor* base,
                                            ValaIntegerLiteral* lit)
{
	VlsNodeSearch * self;
	GeeHashSet* _tmp0_;
	self = (VlsNodeSearch*) base;
	g_return_if_fail (lit != NULL);
	_tmp0_ = self->priv->seen;
	if (!gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) lit)) {
		return;
	}
	if (vls_node_search_match (self, (ValaCodeNode*) lit)) {
		GeeList* _tmp1_;
		_tmp1_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp1_, (ValaCodeNode*) lit);
	}
	vala_code_node_accept_children ((ValaCodeNode*) lit, (ValaCodeVisitor*) self);
}

static void
vls_node_search_real_visit_interface (ValaCodeVisitor* base,
                                      ValaInterface* iface)
{
	VlsNodeSearch * self;
	GeeHashSet* _tmp0_;
	self = (VlsNodeSearch*) base;
	g_return_if_fail (iface != NULL);
	_tmp0_ = self->priv->seen;
	if (!gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) iface)) {
		return;
	}
	if (vls_node_search_match (self, (ValaCodeNode*) iface)) {
		GeeList* _tmp1_;
		_tmp1_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp1_, (ValaCodeNode*) iface);
	}
	vala_code_node_accept_children ((ValaCodeNode*) iface, (ValaCodeVisitor*) self);
}

static void
vls_node_search_real_visit_lambda_expression (ValaCodeVisitor* base,
                                              ValaLambdaExpression* expr)
{
	VlsNodeSearch * self;
	GeeHashSet* _tmp0_;
	self = (VlsNodeSearch*) base;
	g_return_if_fail (expr != NULL);
	_tmp0_ = self->priv->seen;
	if (!gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) expr)) {
		return;
	}
	if (vls_node_search_match (self, (ValaCodeNode*) expr)) {
		GeeList* _tmp1_;
		_tmp1_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp1_, (ValaCodeNode*) expr);
	}
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}

static void
vls_node_search_real_visit_local_variable (ValaCodeVisitor* base,
                                           ValaLocalVariable* local)
{
	VlsNodeSearch * self;
	GeeHashSet* _tmp0_;
	self = (VlsNodeSearch*) base;
	g_return_if_fail (local != NULL);
	_tmp0_ = self->priv->seen;
	if (!gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) local)) {
		return;
	}
	if (vls_node_search_match (self, (ValaCodeNode*) local)) {
		GeeList* _tmp1_;
		_tmp1_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp1_, (ValaCodeNode*) local);
	}
	vala_code_node_accept_children ((ValaCodeNode*) local, (ValaCodeVisitor*) self);
}

static void
vls_node_search_real_visit_lock_statement (ValaCodeVisitor* base,
                                           ValaLockStatement* stmt)
{
	VlsNodeSearch * self;
	GeeHashSet* _tmp0_;
	self = (VlsNodeSearch*) base;
	g_return_if_fail (stmt != NULL);
	_tmp0_ = self->priv->seen;
	if (!gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) stmt)) {
		return;
	}
	if (vls_node_search_match (self, (ValaCodeNode*) stmt)) {
		GeeList* _tmp1_;
		_tmp1_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp1_, (ValaCodeNode*) stmt);
	}
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}

static void
vls_node_search_real_visit_loop_statement (ValaCodeVisitor* base,
                                           ValaLoopStatement* stmt)
{
	VlsNodeSearch * self;
	GeeHashSet* _tmp0_;
	self = (VlsNodeSearch*) base;
	g_return_if_fail (stmt != NULL);
	_tmp0_ = self->priv->seen;
	if (!gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) stmt)) {
		return;
	}
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}

static void
vls_node_search_real_visit_member_access (ValaCodeVisitor* base,
                                          ValaMemberAccess* expr)
{
	VlsNodeSearch * self;
	GeeHashSet* _tmp0_;
	self = (VlsNodeSearch*) base;
	g_return_if_fail (expr != NULL);
	_tmp0_ = self->priv->seen;
	if (!gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) expr)) {
		return;
	}
	if (vls_node_search_match (self, (ValaCodeNode*) expr)) {
		GeeList* _tmp1_;
		_tmp1_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp1_, (ValaCodeNode*) expr);
	}
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}

static void
vls_node_search_real_visit_method (ValaCodeVisitor* base,
                                   ValaMethod* m)
{
	VlsNodeSearch * self;
	GeeHashSet* _tmp0_;
	self = (VlsNodeSearch*) base;
	g_return_if_fail (m != NULL);
	_tmp0_ = self->priv->seen;
	if (!gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) m)) {
		return;
	}
	if (vls_node_search_match (self, (ValaCodeNode*) m)) {
		GeeList* _tmp1_;
		_tmp1_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp1_, (ValaCodeNode*) m);
	}
	vala_code_node_accept_children ((ValaCodeNode*) m, (ValaCodeVisitor*) self);
}

static void
vls_node_search_real_visit_method_call (ValaCodeVisitor* base,
                                        ValaMethodCall* expr)
{
	VlsNodeSearch * self;
	GeeHashSet* _tmp0_;
	self = (VlsNodeSearch*) base;
	g_return_if_fail (expr != NULL);
	_tmp0_ = self->priv->seen;
	if (!gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) expr)) {
		return;
	}
	if (vls_node_search_match (self, (ValaCodeNode*) expr)) {
		GeeList* _tmp1_;
		_tmp1_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp1_, (ValaCodeNode*) expr);
	}
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}

static void
vls_node_search_real_visit_namespace (ValaCodeVisitor* base,
                                      ValaNamespace* ns)
{
	VlsNodeSearch * self;
	GeeHashSet* _tmp0_;
	self = (VlsNodeSearch*) base;
	g_return_if_fail (ns != NULL);
	_tmp0_ = self->priv->seen;
	if (!gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) ns)) {
		return;
	}
	if (vls_node_search_match (self, (ValaCodeNode*) ns)) {
		GeeList* _tmp1_;
		_tmp1_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp1_, (ValaCodeNode*) ns);
	}
	vala_code_node_accept_children ((ValaCodeNode*) ns, (ValaCodeVisitor*) self);
}

static void
vls_node_search_real_visit_null_literal (ValaCodeVisitor* base,
                                         ValaNullLiteral* lit)
{
	VlsNodeSearch * self;
	GeeHashSet* _tmp0_;
	self = (VlsNodeSearch*) base;
	g_return_if_fail (lit != NULL);
	_tmp0_ = self->priv->seen;
	if (!gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) lit)) {
		return;
	}
	if (vls_node_search_match (self, (ValaCodeNode*) lit)) {
		GeeList* _tmp1_;
		_tmp1_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp1_, (ValaCodeNode*) lit);
	}
	vala_code_node_accept_children ((ValaCodeNode*) lit, (ValaCodeVisitor*) self);
}

static void
vls_node_search_real_visit_object_creation_expression (ValaCodeVisitor* base,
                                                       ValaObjectCreationExpression* expr)
{
	VlsNodeSearch * self;
	GeeHashSet* _tmp0_;
	self = (VlsNodeSearch*) base;
	g_return_if_fail (expr != NULL);
	_tmp0_ = self->priv->seen;
	if (!gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) expr)) {
		return;
	}
	if (vls_node_search_match (self, (ValaCodeNode*) expr)) {
		GeeList* _tmp1_;
		_tmp1_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp1_, (ValaCodeNode*) expr);
	}
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}

static void
vls_node_search_real_visit_pointer_indirection (ValaCodeVisitor* base,
                                                ValaPointerIndirection* expr)
{
	VlsNodeSearch * self;
	GeeHashSet* _tmp0_;
	self = (VlsNodeSearch*) base;
	g_return_if_fail (expr != NULL);
	_tmp0_ = self->priv->seen;
	if (!gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) expr)) {
		return;
	}
	if (vls_node_search_match (self, (ValaCodeNode*) expr)) {
		GeeList* _tmp1_;
		_tmp1_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp1_, (ValaCodeNode*) expr);
	}
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}

static void
vls_node_search_real_visit_postfix_expression (ValaCodeVisitor* base,
                                               ValaPostfixExpression* expr)
{
	VlsNodeSearch * self;
	GeeHashSet* _tmp0_;
	self = (VlsNodeSearch*) base;
	g_return_if_fail (expr != NULL);
	_tmp0_ = self->priv->seen;
	if (!gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) expr)) {
		return;
	}
	if (vls_node_search_match (self, (ValaCodeNode*) expr)) {
		GeeList* _tmp1_;
		_tmp1_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp1_, (ValaCodeNode*) expr);
	}
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}

static void
vls_node_search_real_visit_property (ValaCodeVisitor* base,
                                     ValaProperty* prop)
{
	VlsNodeSearch * self;
	GeeHashSet* _tmp0_;
	self = (VlsNodeSearch*) base;
	g_return_if_fail (prop != NULL);
	_tmp0_ = self->priv->seen;
	if (!gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) prop)) {
		return;
	}
	if (vls_node_search_match (self, (ValaCodeNode*) prop)) {
		GeeList* _tmp1_;
		_tmp1_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp1_, (ValaCodeNode*) prop);
	}
	vala_code_node_accept_children ((ValaCodeNode*) prop, (ValaCodeVisitor*) self);
}

static void
vls_node_search_real_visit_property_accessor (ValaCodeVisitor* base,
                                              ValaPropertyAccessor* acc)
{
	VlsNodeSearch * self;
	GeeHashSet* _tmp0_;
	self = (VlsNodeSearch*) base;
	g_return_if_fail (acc != NULL);
	_tmp0_ = self->priv->seen;
	if (!gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) acc)) {
		return;
	}
	if (vls_node_search_match (self, (ValaCodeNode*) acc)) {
		GeeList* _tmp1_;
		_tmp1_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp1_, (ValaCodeNode*) acc);
	}
	vala_code_node_accept_children ((ValaCodeNode*) acc, (ValaCodeVisitor*) self);
}

static void
vls_node_search_real_visit_real_literal (ValaCodeVisitor* base,
                                         ValaRealLiteral* lit)
{
	VlsNodeSearch * self;
	GeeHashSet* _tmp0_;
	self = (VlsNodeSearch*) base;
	g_return_if_fail (lit != NULL);
	_tmp0_ = self->priv->seen;
	if (!gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) lit)) {
		return;
	}
	if (vls_node_search_match (self, (ValaCodeNode*) lit)) {
		GeeList* _tmp1_;
		_tmp1_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp1_, (ValaCodeNode*) lit);
	}
	vala_code_node_accept_children ((ValaCodeNode*) lit, (ValaCodeVisitor*) self);
}

static void
vls_node_search_real_visit_reference_transfer_expression (ValaCodeVisitor* base,
                                                          ValaReferenceTransferExpression* expr)
{
	VlsNodeSearch * self;
	GeeHashSet* _tmp0_;
	self = (VlsNodeSearch*) base;
	g_return_if_fail (expr != NULL);
	_tmp0_ = self->priv->seen;
	if (!gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) expr)) {
		return;
	}
	if (vls_node_search_match (self, (ValaCodeNode*) expr)) {
		GeeList* _tmp1_;
		_tmp1_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp1_, (ValaCodeNode*) expr);
	}
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}

static void
vls_node_search_real_visit_regex_literal (ValaCodeVisitor* base,
                                          ValaRegexLiteral* lit)
{
	VlsNodeSearch * self;
	GeeHashSet* _tmp0_;
	self = (VlsNodeSearch*) base;
	g_return_if_fail (lit != NULL);
	_tmp0_ = self->priv->seen;
	if (!gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) lit)) {
		return;
	}
	if (vls_node_search_match (self, (ValaCodeNode*) lit)) {
		GeeList* _tmp1_;
		_tmp1_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp1_, (ValaCodeNode*) lit);
	}
	vala_code_node_accept_children ((ValaCodeNode*) lit, (ValaCodeVisitor*) self);
}

static void
vls_node_search_real_visit_return_statement (ValaCodeVisitor* base,
                                             ValaReturnStatement* stmt)
{
	VlsNodeSearch * self;
	GeeHashSet* _tmp0_;
	self = (VlsNodeSearch*) base;
	g_return_if_fail (stmt != NULL);
	_tmp0_ = self->priv->seen;
	if (!gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) stmt)) {
		return;
	}
	if (vls_node_search_match (self, (ValaCodeNode*) stmt)) {
		GeeList* _tmp1_;
		_tmp1_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp1_, (ValaCodeNode*) stmt);
	}
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}

static void
vls_node_search_real_visit_signal (ValaCodeVisitor* base,
                                   ValaSignal* sig)
{
	VlsNodeSearch * self;
	GeeHashSet* _tmp0_;
	self = (VlsNodeSearch*) base;
	g_return_if_fail (sig != NULL);
	_tmp0_ = self->priv->seen;
	if (!gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) sig)) {
		return;
	}
	if (vls_node_search_match (self, (ValaCodeNode*) sig)) {
		GeeList* _tmp1_;
		_tmp1_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp1_, (ValaCodeNode*) sig);
	}
	vala_code_node_accept_children ((ValaCodeNode*) sig, (ValaCodeVisitor*) self);
}

static void
vls_node_search_real_visit_sizeof_expression (ValaCodeVisitor* base,
                                              ValaSizeofExpression* expr)
{
	VlsNodeSearch * self;
	GeeHashSet* _tmp0_;
	self = (VlsNodeSearch*) base;
	g_return_if_fail (expr != NULL);
	_tmp0_ = self->priv->seen;
	if (!gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) expr)) {
		return;
	}
	if (vls_node_search_match (self, (ValaCodeNode*) expr)) {
		GeeList* _tmp1_;
		_tmp1_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp1_, (ValaCodeNode*) expr);
	}
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}

static void
vls_node_search_real_visit_slice_expression (ValaCodeVisitor* base,
                                             ValaSliceExpression* expr)
{
	VlsNodeSearch * self;
	GeeHashSet* _tmp0_;
	self = (VlsNodeSearch*) base;
	g_return_if_fail (expr != NULL);
	_tmp0_ = self->priv->seen;
	if (!gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) expr)) {
		return;
	}
	if (vls_node_search_match (self, (ValaCodeNode*) expr)) {
		GeeList* _tmp1_;
		_tmp1_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp1_, (ValaCodeNode*) expr);
	}
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}

static void
vls_node_search_real_visit_string_literal (ValaCodeVisitor* base,
                                           ValaStringLiteral* lit)
{
	VlsNodeSearch * self;
	GeeHashSet* _tmp0_;
	self = (VlsNodeSearch*) base;
	g_return_if_fail (lit != NULL);
	_tmp0_ = self->priv->seen;
	if (!gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) lit)) {
		return;
	}
	if (vls_node_search_match (self, (ValaCodeNode*) lit)) {
		GeeList* _tmp1_;
		_tmp1_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp1_, (ValaCodeNode*) lit);
	}
	vala_code_node_accept_children ((ValaCodeNode*) lit, (ValaCodeVisitor*) self);
}

static void
vls_node_search_real_visit_struct (ValaCodeVisitor* base,
                                   ValaStruct* st)
{
	VlsNodeSearch * self;
	GeeHashSet* _tmp0_;
	self = (VlsNodeSearch*) base;
	g_return_if_fail (st != NULL);
	_tmp0_ = self->priv->seen;
	if (!gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) st)) {
		return;
	}
	if (vls_node_search_match (self, (ValaCodeNode*) st)) {
		GeeList* _tmp1_;
		_tmp1_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp1_, (ValaCodeNode*) st);
	}
	vala_code_node_accept_children ((ValaCodeNode*) st, (ValaCodeVisitor*) self);
}

static void
vls_node_search_real_visit_switch_label (ValaCodeVisitor* base,
                                         ValaSwitchLabel* label)
{
	VlsNodeSearch * self;
	GeeHashSet* _tmp0_;
	self = (VlsNodeSearch*) base;
	g_return_if_fail (label != NULL);
	_tmp0_ = self->priv->seen;
	if (!gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) label)) {
		return;
	}
	if (vls_node_search_match (self, (ValaCodeNode*) label)) {
		GeeList* _tmp1_;
		_tmp1_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp1_, (ValaCodeNode*) label);
	}
	vala_code_node_accept_children ((ValaCodeNode*) label, (ValaCodeVisitor*) self);
}

static void
vls_node_search_real_visit_switch_section (ValaCodeVisitor* base,
                                           ValaSwitchSection* section)
{
	VlsNodeSearch * self;
	GeeHashSet* _tmp0_;
	self = (VlsNodeSearch*) base;
	g_return_if_fail (section != NULL);
	_tmp0_ = self->priv->seen;
	if (!gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) section)) {
		return;
	}
	if (vls_node_search_match (self, (ValaCodeNode*) section)) {
		GeeList* _tmp1_;
		_tmp1_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp1_, (ValaCodeNode*) section);
	}
	vala_code_node_accept_children ((ValaCodeNode*) section, (ValaCodeVisitor*) self);
}

static void
vls_node_search_real_visit_switch_statement (ValaCodeVisitor* base,
                                             ValaSwitchStatement* stmt)
{
	VlsNodeSearch * self;
	GeeHashSet* _tmp0_;
	self = (VlsNodeSearch*) base;
	g_return_if_fail (stmt != NULL);
	_tmp0_ = self->priv->seen;
	if (!gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) stmt)) {
		return;
	}
	if (vls_node_search_match (self, (ValaCodeNode*) stmt)) {
		GeeList* _tmp1_;
		_tmp1_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp1_, (ValaCodeNode*) stmt);
	}
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}

static void
vls_node_search_real_visit_template (ValaCodeVisitor* base,
                                     ValaTemplate* tmpl)
{
	VlsNodeSearch * self;
	GeeHashSet* _tmp0_;
	self = (VlsNodeSearch*) base;
	g_return_if_fail (tmpl != NULL);
	_tmp0_ = self->priv->seen;
	if (!gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) tmpl)) {
		return;
	}
	if (vls_node_search_match (self, (ValaCodeNode*) tmpl)) {
		GeeList* _tmp1_;
		_tmp1_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp1_, (ValaCodeNode*) tmpl);
	}
	vala_code_node_accept_children ((ValaCodeNode*) tmpl, (ValaCodeVisitor*) self);
}

static void
vls_node_search_real_visit_throw_statement (ValaCodeVisitor* base,
                                            ValaThrowStatement* stmt)
{
	VlsNodeSearch * self;
	GeeHashSet* _tmp0_;
	self = (VlsNodeSearch*) base;
	g_return_if_fail (stmt != NULL);
	_tmp0_ = self->priv->seen;
	if (!gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) stmt)) {
		return;
	}
	if (vls_node_search_match (self, (ValaCodeNode*) stmt)) {
		GeeList* _tmp1_;
		_tmp1_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp1_, (ValaCodeNode*) stmt);
	}
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}

static void
vls_node_search_real_visit_try_statement (ValaCodeVisitor* base,
                                          ValaTryStatement* stmt)
{
	VlsNodeSearch * self;
	GeeHashSet* _tmp0_;
	self = (VlsNodeSearch*) base;
	g_return_if_fail (stmt != NULL);
	_tmp0_ = self->priv->seen;
	if (!gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) stmt)) {
		return;
	}
	if (vls_node_search_match (self, (ValaCodeNode*) stmt)) {
		GeeList* _tmp1_;
		_tmp1_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp1_, (ValaCodeNode*) stmt);
	}
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}

static void
vls_node_search_real_visit_type_check (ValaCodeVisitor* base,
                                       ValaTypeCheck* expr)
{
	VlsNodeSearch * self;
	GeeHashSet* _tmp0_;
	self = (VlsNodeSearch*) base;
	g_return_if_fail (expr != NULL);
	_tmp0_ = self->priv->seen;
	if (!gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) expr)) {
		return;
	}
	if (vls_node_search_match (self, (ValaCodeNode*) expr)) {
		GeeList* _tmp1_;
		_tmp1_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp1_, (ValaCodeNode*) expr);
	}
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}

static void
vls_node_search_real_visit_type_parameter (ValaCodeVisitor* base,
                                           ValaTypeParameter* p)
{
	VlsNodeSearch * self;
	GeeHashSet* _tmp0_;
	self = (VlsNodeSearch*) base;
	g_return_if_fail (p != NULL);
	_tmp0_ = self->priv->seen;
	if (!gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) p)) {
		return;
	}
	if (vls_node_search_match (self, (ValaCodeNode*) p)) {
		GeeList* _tmp1_;
		_tmp1_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp1_, (ValaCodeNode*) p);
	}
	vala_code_node_accept_children ((ValaCodeNode*) p, (ValaCodeVisitor*) self);
}

static void
vls_node_search_real_visit_typeof_expression (ValaCodeVisitor* base,
                                              ValaTypeofExpression* expr)
{
	VlsNodeSearch * self;
	GeeHashSet* _tmp0_;
	self = (VlsNodeSearch*) base;
	g_return_if_fail (expr != NULL);
	_tmp0_ = self->priv->seen;
	if (!gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) expr)) {
		return;
	}
	if (vls_node_search_match (self, (ValaCodeNode*) expr)) {
		GeeList* _tmp1_;
		_tmp1_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp1_, (ValaCodeNode*) expr);
	}
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}

static void
vls_node_search_real_visit_unary_expression (ValaCodeVisitor* base,
                                             ValaUnaryExpression* expr)
{
	VlsNodeSearch * self;
	GeeHashSet* _tmp0_;
	self = (VlsNodeSearch*) base;
	g_return_if_fail (expr != NULL);
	_tmp0_ = self->priv->seen;
	if (!gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) expr)) {
		return;
	}
	if (vls_node_search_match (self, (ValaCodeNode*) expr)) {
		GeeList* _tmp1_;
		_tmp1_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp1_, (ValaCodeNode*) expr);
	}
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}

static void
vls_node_search_real_visit_unlock_statement (ValaCodeVisitor* base,
                                             ValaUnlockStatement* stmt)
{
	VlsNodeSearch * self;
	GeeHashSet* _tmp0_;
	self = (VlsNodeSearch*) base;
	g_return_if_fail (stmt != NULL);
	_tmp0_ = self->priv->seen;
	if (!gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) stmt)) {
		return;
	}
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}

static void
vls_node_search_real_visit_using_directive (ValaCodeVisitor* base,
                                            ValaUsingDirective* ud)
{
	VlsNodeSearch * self;
	GeeHashSet* _tmp0_;
	self = (VlsNodeSearch*) base;
	g_return_if_fail (ud != NULL);
	_tmp0_ = self->priv->seen;
	if (!gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) ud)) {
		return;
	}
	if (vls_node_search_match (self, (ValaCodeNode*) ud)) {
		GeeList* _tmp1_;
		_tmp1_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp1_, (ValaCodeNode*) ud);
	}
	vala_code_node_accept_children ((ValaCodeNode*) ud, (ValaCodeVisitor*) self);
}

static void
vls_node_search_real_visit_with_statement (ValaCodeVisitor* base,
                                           ValaWithStatement* stmt)
{
	VlsNodeSearch * self;
	GeeHashSet* _tmp0_;
	self = (VlsNodeSearch*) base;
	g_return_if_fail (stmt != NULL);
	_tmp0_ = self->priv->seen;
	if (!gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) stmt)) {
		return;
	}
	if (vls_node_search_match (self, (ValaCodeNode*) stmt)) {
		GeeList* _tmp1_;
		_tmp1_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp1_, (ValaCodeNode*) stmt);
	}
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}

static void
vls_node_search_real_visit_while_statement (ValaCodeVisitor* base,
                                            ValaWhileStatement* stmt)
{
	VlsNodeSearch * self;
	GeeHashSet* _tmp0_;
	self = (VlsNodeSearch*) base;
	g_return_if_fail (stmt != NULL);
	_tmp0_ = self->priv->seen;
	if (!gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) stmt)) {
		return;
	}
	if (vls_node_search_match (self, (ValaCodeNode*) stmt)) {
		GeeList* _tmp1_;
		_tmp1_ = self->result;
		gee_collection_add ((GeeCollection*) _tmp1_, (ValaCodeNode*) stmt);
	}
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}

static void
vls_node_search_real_visit_yield_statement (ValaCodeVisitor* base,
                                            ValaYieldStatement* stmt)
{
	VlsNodeSearch * self;
	GeeHashSet* _tmp0_;
	self = (VlsNodeSearch*) base;
	g_return_if_fail (stmt != NULL);
	_tmp0_ = self->priv->seen;
	if (!gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) stmt)) {
		return;
	}
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}

LspPosition*
vls_node_search_get_pos (VlsNodeSearch* self)
{
	LspPosition* result;
	LspPosition* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_pos;
	result = _tmp0_;
	return result;
}

static void
vls_node_search_set_pos (VlsNodeSearch* self,
                         LspPosition* value)
{
	LspPosition* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = _g_object_ref0 (value);
	_g_object_unref0 (self->priv->_pos);
	self->priv->_pos = _tmp0_;
}

gboolean
vls_node_search_get_search_multiline (VlsNodeSearch* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_search_multiline;
	return result;
}

static void
vls_node_search_set_search_multiline (VlsNodeSearch* self,
                                      gboolean value)
{
	g_return_if_fail (self != NULL);
	self->priv->_search_multiline = value;
}

gboolean
vls_node_search_get_must_be_symbol (VlsNodeSearch* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_must_be_symbol;
	return result;
}

static void
vls_node_search_set_must_be_symbol (VlsNodeSearch* self,
                                    gboolean value)
{
	g_return_if_fail (self != NULL);
	self->priv->_must_be_symbol = value;
}

gboolean
vls_node_search_get_inverted (VlsNodeSearch* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_inverted;
	return result;
}

static void
vls_node_search_set_inverted (VlsNodeSearch* self,
                              gboolean value)
{
	g_return_if_fail (self != NULL);
	self->priv->_inverted = value;
}

static void
vls_node_search_class_init (VlsNodeSearchClass * klass,
                            gpointer klass_data)
{
	vls_node_search_parent_class = g_type_class_peek_parent (klass);
	((ValaCodeVisitorClass *) klass)->finalize = vls_node_search_finalize;
	g_type_class_adjust_private_offset (klass, &VlsNodeSearch_private_offset);
	((ValaCodeVisitorClass *) klass)->visit_source_file = (void (*) (ValaCodeVisitor*, ValaSourceFile*)) vls_node_search_real_visit_source_file;
	((ValaCodeVisitorClass *) klass)->visit_addressof_expression = (void (*) (ValaCodeVisitor*, ValaAddressofExpression*)) vls_node_search_real_visit_addressof_expression;
	((ValaCodeVisitorClass *) klass)->visit_array_creation_expression = (void (*) (ValaCodeVisitor*, ValaArrayCreationExpression*)) vls_node_search_real_visit_array_creation_expression;
	((ValaCodeVisitorClass *) klass)->visit_assignment = (void (*) (ValaCodeVisitor*, ValaAssignment*)) vls_node_search_real_visit_assignment;
	((ValaCodeVisitorClass *) klass)->visit_base_access = (void (*) (ValaCodeVisitor*, ValaBaseAccess*)) vls_node_search_real_visit_base_access;
	((ValaCodeVisitorClass *) klass)->visit_binary_expression = (void (*) (ValaCodeVisitor*, ValaBinaryExpression*)) vls_node_search_real_visit_binary_expression;
	((ValaCodeVisitorClass *) klass)->visit_block = (void (*) (ValaCodeVisitor*, ValaBlock*)) vls_node_search_real_visit_block;
	((ValaCodeVisitorClass *) klass)->visit_boolean_literal = (void (*) (ValaCodeVisitor*, ValaBooleanLiteral*)) vls_node_search_real_visit_boolean_literal;
	((ValaCodeVisitorClass *) klass)->visit_break_statement = (void (*) (ValaCodeVisitor*, ValaBreakStatement*)) vls_node_search_real_visit_break_statement;
	((ValaCodeVisitorClass *) klass)->visit_cast_expression = (void (*) (ValaCodeVisitor*, ValaCastExpression*)) vls_node_search_real_visit_cast_expression;
	((ValaCodeVisitorClass *) klass)->visit_catch_clause = (void (*) (ValaCodeVisitor*, ValaCatchClause*)) vls_node_search_real_visit_catch_clause;
	((ValaCodeVisitorClass *) klass)->visit_character_literal = (void (*) (ValaCodeVisitor*, ValaCharacterLiteral*)) vls_node_search_real_visit_character_literal;
	((ValaCodeVisitorClass *) klass)->visit_class = (void (*) (ValaCodeVisitor*, ValaClass*)) vls_node_search_real_visit_class;
	((ValaCodeVisitorClass *) klass)->visit_conditional_expression = (void (*) (ValaCodeVisitor*, ValaConditionalExpression*)) vls_node_search_real_visit_conditional_expression;
	((ValaCodeVisitorClass *) klass)->visit_constant = (void (*) (ValaCodeVisitor*, ValaConstant*)) vls_node_search_real_visit_constant;
	((ValaCodeVisitorClass *) klass)->visit_constructor = (void (*) (ValaCodeVisitor*, ValaConstructor*)) vls_node_search_real_visit_constructor;
	((ValaCodeVisitorClass *) klass)->visit_continue_statement = (void (*) (ValaCodeVisitor*, ValaContinueStatement*)) vls_node_search_real_visit_continue_statement;
	((ValaCodeVisitorClass *) klass)->visit_creation_method = (void (*) (ValaCodeVisitor*, ValaCreationMethod*)) vls_node_search_real_visit_creation_method;
	((ValaCodeVisitorClass *) klass)->visit_data_type = (void (*) (ValaCodeVisitor*, ValaDataType*)) vls_node_search_real_visit_data_type;
	((ValaCodeVisitorClass *) klass)->visit_declaration_statement = (void (*) (ValaCodeVisitor*, ValaDeclarationStatement*)) vls_node_search_real_visit_declaration_statement;
	((ValaCodeVisitorClass *) klass)->visit_delegate = (void (*) (ValaCodeVisitor*, ValaDelegate*)) vls_node_search_real_visit_delegate;
	((ValaCodeVisitorClass *) klass)->visit_delete_statement = (void (*) (ValaCodeVisitor*, ValaDeleteStatement*)) vls_node_search_real_visit_delete_statement;
	((ValaCodeVisitorClass *) klass)->visit_destructor = (void (*) (ValaCodeVisitor*, ValaDestructor*)) vls_node_search_real_visit_destructor;
	((ValaCodeVisitorClass *) klass)->visit_do_statement = (void (*) (ValaCodeVisitor*, ValaDoStatement*)) vls_node_search_real_visit_do_statement;
	((ValaCodeVisitorClass *) klass)->visit_element_access = (void (*) (ValaCodeVisitor*, ValaElementAccess*)) vls_node_search_real_visit_element_access;
	((ValaCodeVisitorClass *) klass)->visit_empty_statement = (void (*) (ValaCodeVisitor*, ValaEmptyStatement*)) vls_node_search_real_visit_empty_statement;
	((ValaCodeVisitorClass *) klass)->visit_enum = (void (*) (ValaCodeVisitor*, ValaEnum*)) vls_node_search_real_visit_enum;
	((ValaCodeVisitorClass *) klass)->visit_enum_value = (void (*) (ValaCodeVisitor*, ValaEnumValue*)) vls_node_search_real_visit_enum_value;
	((ValaCodeVisitorClass *) klass)->visit_error_code = (void (*) (ValaCodeVisitor*, ValaErrorCode*)) vls_node_search_real_visit_error_code;
	((ValaCodeVisitorClass *) klass)->visit_error_domain = (void (*) (ValaCodeVisitor*, ValaErrorDomain*)) vls_node_search_real_visit_error_domain;
	((ValaCodeVisitorClass *) klass)->visit_expression = (void (*) (ValaCodeVisitor*, ValaExpression*)) vls_node_search_real_visit_expression;
	((ValaCodeVisitorClass *) klass)->visit_expression_statement = (void (*) (ValaCodeVisitor*, ValaExpressionStatement*)) vls_node_search_real_visit_expression_statement;
	((ValaCodeVisitorClass *) klass)->visit_field = (void (*) (ValaCodeVisitor*, ValaField*)) vls_node_search_real_visit_field;
	((ValaCodeVisitorClass *) klass)->visit_for_statement = (void (*) (ValaCodeVisitor*, ValaForStatement*)) vls_node_search_real_visit_for_statement;
	((ValaCodeVisitorClass *) klass)->visit_foreach_statement = (void (*) (ValaCodeVisitor*, ValaForeachStatement*)) vls_node_search_real_visit_foreach_statement;
	((ValaCodeVisitorClass *) klass)->visit_formal_parameter = (void (*) (ValaCodeVisitor*, ValaParameter*)) vls_node_search_real_visit_formal_parameter;
	((ValaCodeVisitorClass *) klass)->visit_if_statement = (void (*) (ValaCodeVisitor*, ValaIfStatement*)) vls_node_search_real_visit_if_statement;
	((ValaCodeVisitorClass *) klass)->visit_initializer_list = (void (*) (ValaCodeVisitor*, ValaInitializerList*)) vls_node_search_real_visit_initializer_list;
	((ValaCodeVisitorClass *) klass)->visit_integer_literal = (void (*) (ValaCodeVisitor*, ValaIntegerLiteral*)) vls_node_search_real_visit_integer_literal;
	((ValaCodeVisitorClass *) klass)->visit_interface = (void (*) (ValaCodeVisitor*, ValaInterface*)) vls_node_search_real_visit_interface;
	((ValaCodeVisitorClass *) klass)->visit_lambda_expression = (void (*) (ValaCodeVisitor*, ValaLambdaExpression*)) vls_node_search_real_visit_lambda_expression;
	((ValaCodeVisitorClass *) klass)->visit_local_variable = (void (*) (ValaCodeVisitor*, ValaLocalVariable*)) vls_node_search_real_visit_local_variable;
	((ValaCodeVisitorClass *) klass)->visit_lock_statement = (void (*) (ValaCodeVisitor*, ValaLockStatement*)) vls_node_search_real_visit_lock_statement;
	((ValaCodeVisitorClass *) klass)->visit_loop_statement = (void (*) (ValaCodeVisitor*, ValaLoopStatement*)) vls_node_search_real_visit_loop_statement;
	((ValaCodeVisitorClass *) klass)->visit_member_access = (void (*) (ValaCodeVisitor*, ValaMemberAccess*)) vls_node_search_real_visit_member_access;
	((ValaCodeVisitorClass *) klass)->visit_method = (void (*) (ValaCodeVisitor*, ValaMethod*)) vls_node_search_real_visit_method;
	((ValaCodeVisitorClass *) klass)->visit_method_call = (void (*) (ValaCodeVisitor*, ValaMethodCall*)) vls_node_search_real_visit_method_call;
	((ValaCodeVisitorClass *) klass)->visit_namespace = (void (*) (ValaCodeVisitor*, ValaNamespace*)) vls_node_search_real_visit_namespace;
	((ValaCodeVisitorClass *) klass)->visit_null_literal = (void (*) (ValaCodeVisitor*, ValaNullLiteral*)) vls_node_search_real_visit_null_literal;
	((ValaCodeVisitorClass *) klass)->visit_object_creation_expression = (void (*) (ValaCodeVisitor*, ValaObjectCreationExpression*)) vls_node_search_real_visit_object_creation_expression;
	((ValaCodeVisitorClass *) klass)->visit_pointer_indirection = (void (*) (ValaCodeVisitor*, ValaPointerIndirection*)) vls_node_search_real_visit_pointer_indirection;
	((ValaCodeVisitorClass *) klass)->visit_postfix_expression = (void (*) (ValaCodeVisitor*, ValaPostfixExpression*)) vls_node_search_real_visit_postfix_expression;
	((ValaCodeVisitorClass *) klass)->visit_property = (void (*) (ValaCodeVisitor*, ValaProperty*)) vls_node_search_real_visit_property;
	((ValaCodeVisitorClass *) klass)->visit_property_accessor = (void (*) (ValaCodeVisitor*, ValaPropertyAccessor*)) vls_node_search_real_visit_property_accessor;
	((ValaCodeVisitorClass *) klass)->visit_real_literal = (void (*) (ValaCodeVisitor*, ValaRealLiteral*)) vls_node_search_real_visit_real_literal;
	((ValaCodeVisitorClass *) klass)->visit_reference_transfer_expression = (void (*) (ValaCodeVisitor*, ValaReferenceTransferExpression*)) vls_node_search_real_visit_reference_transfer_expression;
	((ValaCodeVisitorClass *) klass)->visit_regex_literal = (void (*) (ValaCodeVisitor*, ValaRegexLiteral*)) vls_node_search_real_visit_regex_literal;
	((ValaCodeVisitorClass *) klass)->visit_return_statement = (void (*) (ValaCodeVisitor*, ValaReturnStatement*)) vls_node_search_real_visit_return_statement;
	((ValaCodeVisitorClass *) klass)->visit_signal = (void (*) (ValaCodeVisitor*, ValaSignal*)) vls_node_search_real_visit_signal;
	((ValaCodeVisitorClass *) klass)->visit_sizeof_expression = (void (*) (ValaCodeVisitor*, ValaSizeofExpression*)) vls_node_search_real_visit_sizeof_expression;
	((ValaCodeVisitorClass *) klass)->visit_slice_expression = (void (*) (ValaCodeVisitor*, ValaSliceExpression*)) vls_node_search_real_visit_slice_expression;
	((ValaCodeVisitorClass *) klass)->visit_string_literal = (void (*) (ValaCodeVisitor*, ValaStringLiteral*)) vls_node_search_real_visit_string_literal;
	((ValaCodeVisitorClass *) klass)->visit_struct = (void (*) (ValaCodeVisitor*, ValaStruct*)) vls_node_search_real_visit_struct;
	((ValaCodeVisitorClass *) klass)->visit_switch_label = (void (*) (ValaCodeVisitor*, ValaSwitchLabel*)) vls_node_search_real_visit_switch_label;
	((ValaCodeVisitorClass *) klass)->visit_switch_section = (void (*) (ValaCodeVisitor*, ValaSwitchSection*)) vls_node_search_real_visit_switch_section;
	((ValaCodeVisitorClass *) klass)->visit_switch_statement = (void (*) (ValaCodeVisitor*, ValaSwitchStatement*)) vls_node_search_real_visit_switch_statement;
	((ValaCodeVisitorClass *) klass)->visit_template = (void (*) (ValaCodeVisitor*, ValaTemplate*)) vls_node_search_real_visit_template;
	((ValaCodeVisitorClass *) klass)->visit_throw_statement = (void (*) (ValaCodeVisitor*, ValaThrowStatement*)) vls_node_search_real_visit_throw_statement;
	((ValaCodeVisitorClass *) klass)->visit_try_statement = (void (*) (ValaCodeVisitor*, ValaTryStatement*)) vls_node_search_real_visit_try_statement;
	((ValaCodeVisitorClass *) klass)->visit_type_check = (void (*) (ValaCodeVisitor*, ValaTypeCheck*)) vls_node_search_real_visit_type_check;
	((ValaCodeVisitorClass *) klass)->visit_type_parameter = (void (*) (ValaCodeVisitor*, ValaTypeParameter*)) vls_node_search_real_visit_type_parameter;
	((ValaCodeVisitorClass *) klass)->visit_typeof_expression = (void (*) (ValaCodeVisitor*, ValaTypeofExpression*)) vls_node_search_real_visit_typeof_expression;
	((ValaCodeVisitorClass *) klass)->visit_unary_expression = (void (*) (ValaCodeVisitor*, ValaUnaryExpression*)) vls_node_search_real_visit_unary_expression;
	((ValaCodeVisitorClass *) klass)->visit_unlock_statement = (void (*) (ValaCodeVisitor*, ValaUnlockStatement*)) vls_node_search_real_visit_unlock_statement;
	((ValaCodeVisitorClass *) klass)->visit_using_directive = (void (*) (ValaCodeVisitor*, ValaUsingDirective*)) vls_node_search_real_visit_using_directive;
	((ValaCodeVisitorClass *) klass)->visit_with_statement = (void (*) (ValaCodeVisitor*, ValaWithStatement*)) vls_node_search_real_visit_with_statement;
	((ValaCodeVisitorClass *) klass)->visit_while_statement = (void (*) (ValaCodeVisitor*, ValaWhileStatement*)) vls_node_search_real_visit_while_statement;
	((ValaCodeVisitorClass *) klass)->visit_yield_statement = (void (*) (ValaCodeVisitor*, ValaYieldStatement*)) vls_node_search_real_visit_yield_statement;
}

static void
vls_node_search_instance_init (VlsNodeSearch * self,
                               gpointer klass)
{
	GeeArrayList* _tmp0_;
	GeeHashSet* _tmp1_;
	self->priv = vls_node_search_get_instance_private (self);
	_tmp0_ = gee_array_list_new (VALA_TYPE_CODE_NODE, (GBoxedCopyFunc) vala_code_node_ref, (GDestroyNotify) vala_code_node_unref, NULL, NULL, NULL);
	if (_tmp0_) {
		g_object_set_data ((GObject *) _tmp0_, "vala-creation-function", "");
	}
	self->result = (GeeList*) _tmp0_;
	_tmp1_ = gee_hash_set_new (VALA_TYPE_CODE_NODE, (GBoxedCopyFunc) vala_code_node_ref, (GDestroyNotify) vala_code_node_unref, NULL, NULL, NULL, NULL, NULL, NULL);
	if (_tmp1_) {
		g_object_set_data ((GObject *) _tmp1_, "vala-creation-function", "");
	}
	self->priv->seen = _tmp1_;
	self->priv->include_declaration = TRUE;
}

static void
vls_node_search_finalize (ValaCodeVisitor * obj)
{
	VlsNodeSearch * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VLS_TYPE_NODE_SEARCH, VlsNodeSearch);
	_g_object_unref0 (self->priv->_pos);
	_g_object_unref0 (self->priv->end_pos);
	_vala_source_file_unref0 (self->priv->file);
	_g_object_unref0 (self->result);
	_g_object_unref0 (self->priv->seen);
	_vala_code_node_unref0 (self->priv->needle);
	VALA_CODE_VISITOR_CLASS (vls_node_search_parent_class)->finalize (obj);
}

/**
 * A code visitor for any position queries.
 */
 G_GNUC_NO_INLINE static GType
vls_node_search_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (VlsNodeSearchClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vls_node_search_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (VlsNodeSearch), 0, (GInstanceInitFunc) vls_node_search_instance_init, NULL };
	GType vls_node_search_type_id;
	vls_node_search_type_id = g_type_register_static (VALA_TYPE_CODE_VISITOR, "VlsNodeSearch", &g_define_type_info, 0);
	VlsNodeSearch_private_offset = g_type_add_instance_private (vls_node_search_type_id, sizeof (VlsNodeSearchPrivate));
	return vls_node_search_type_id;
}

GType
vls_node_search_get_type (void)
{
	static gsize vls_node_search_type_id__once = 0;
	if (g_once_init_enter (&vls_node_search_type_id__once)) {
		GType vls_node_search_type_id;
		vls_node_search_type_id = vls_node_search_get_type_once ();
		g_once_init_leave (&vls_node_search_type_id__once, vls_node_search_type_id);
	}
	return vls_node_search_type_id__once;
}

