/* symbolvisitor.c generated by valac 0.56.13, the Vala compiler
 * generated from symbolvisitor.vala, do not modify */

/* symbolvisitor.vala
 *
 * Copyright 2020 Princeton Ferro <princetonferro@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <vala.h>
#include <glib-object.h>
#include <gee.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <valagee.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define VLS_TYPE_SYMBOL_VISITOR (vls_symbol_visitor_get_type ())
#define VLS_SYMBOL_VISITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VLS_TYPE_SYMBOL_VISITOR, VlsSymbolVisitor))
#define VLS_SYMBOL_VISITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VLS_TYPE_SYMBOL_VISITOR, VlsSymbolVisitorClass))
#define VLS_IS_SYMBOL_VISITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VLS_TYPE_SYMBOL_VISITOR))
#define VLS_IS_SYMBOL_VISITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VLS_TYPE_SYMBOL_VISITOR))
#define VLS_SYMBOL_VISITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VLS_TYPE_SYMBOL_VISITOR, VlsSymbolVisitorClass))

typedef struct _VlsSymbolVisitor VlsSymbolVisitor;
typedef struct _VlsSymbolVisitorClass VlsSymbolVisitorClass;
typedef struct _VlsSymbolVisitorPrivate VlsSymbolVisitorPrivate;
typedef void (*VlsSymbolVisitorFunc) (ValaCodeNode* code_node, gpointer user_data);
#define _vala_source_file_unref0(var) ((var == NULL) ? NULL : (var = (vala_source_file_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _vala_source_reference_unref0(var) ((var == NULL) ? NULL : (var = (vala_source_reference_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _vala_code_node_unref0(var) ((var == NULL) ? NULL : (var = (vala_code_node_unref (var), NULL)))

struct _VlsSymbolVisitor {
	ValaCodeVisitor parent_instance;
	VlsSymbolVisitorPrivate * priv;
};

struct _VlsSymbolVisitorClass {
	ValaCodeVisitorClass parent_class;
};

struct _VlsSymbolVisitorPrivate {
	ValaSourceFile* file;
	GeeHashSet* seen;
	gboolean include_declaration;
	VlsSymbolVisitorFunc func;
	gpointer func_target;
	GDestroyNotify func_target_destroy_notify;
};

static gint VlsSymbolVisitor_private_offset;
static gpointer vls_symbol_visitor_parent_class = NULL;

VALA_EXTERN GType vls_symbol_visitor_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VlsSymbolVisitor, vala_code_visitor_unref)
VALA_EXTERN VlsSymbolVisitor* vls_symbol_visitor_new (ValaSourceFile* file,
                                          ValaSymbol* symbol,
                                          gboolean include_declaration,
                                          VlsSymbolVisitorFunc func,
                                          gpointer func_target,
                                          GDestroyNotify func_target_destroy_notify);
VALA_EXTERN VlsSymbolVisitor* vls_symbol_visitor_construct (GType object_type,
                                                ValaSourceFile* file,
                                                ValaSymbol* symbol,
                                                gboolean include_declaration,
                                                VlsSymbolVisitorFunc func,
                                                gpointer func_target,
                                                GDestroyNotify func_target_destroy_notify);
static gboolean vls_symbol_visitor_filter (VlsSymbolVisitor* self,
                                    ValaCodeNode* node);
static void vls_symbol_visitor_real_visit_source_file (ValaCodeVisitor* base,
                                                ValaSourceFile* source_file);
static void vls_symbol_visitor_real_visit_addressof_expression (ValaCodeVisitor* base,
                                                         ValaAddressofExpression* expr);
static void vls_symbol_visitor_real_visit_array_creation_expression (ValaCodeVisitor* base,
                                                              ValaArrayCreationExpression* expr);
static void vls_symbol_visitor_real_visit_assignment (ValaCodeVisitor* base,
                                               ValaAssignment* a);
static void vls_symbol_visitor_real_visit_base_access (ValaCodeVisitor* base,
                                                ValaBaseAccess* expr);
static void vls_symbol_visitor_real_visit_binary_expression (ValaCodeVisitor* base,
                                                      ValaBinaryExpression* expr);
static void vls_symbol_visitor_real_visit_block (ValaCodeVisitor* base,
                                          ValaBlock* b);
static void vls_symbol_visitor_real_visit_boolean_literal (ValaCodeVisitor* base,
                                                    ValaBooleanLiteral* lit);
static void vls_symbol_visitor_real_visit_break_statement (ValaCodeVisitor* base,
                                                    ValaBreakStatement* stmt);
static void vls_symbol_visitor_real_visit_cast_expression (ValaCodeVisitor* base,
                                                    ValaCastExpression* expr);
static void vls_symbol_visitor_real_visit_catch_clause (ValaCodeVisitor* base,
                                                 ValaCatchClause* clause);
static void vls_symbol_visitor_real_visit_character_literal (ValaCodeVisitor* base,
                                                      ValaCharacterLiteral* lit);
static void vls_symbol_visitor_real_visit_class (ValaCodeVisitor* base,
                                          ValaClass* cl);
static void vls_symbol_visitor_real_visit_conditional_expression (ValaCodeVisitor* base,
                                                           ValaConditionalExpression* expr);
static void vls_symbol_visitor_real_visit_constant (ValaCodeVisitor* base,
                                             ValaConstant* c);
static void vls_symbol_visitor_real_visit_constructor (ValaCodeVisitor* base,
                                                ValaConstructor* c);
static void vls_symbol_visitor_real_visit_continue_statement (ValaCodeVisitor* base,
                                                       ValaContinueStatement* stmt);
static void vls_symbol_visitor_real_visit_creation_method (ValaCodeVisitor* base,
                                                    ValaCreationMethod* m);
static void vls_symbol_visitor_real_visit_data_type (ValaCodeVisitor* base,
                                              ValaDataType* type);
static void vls_symbol_visitor_real_visit_declaration_statement (ValaCodeVisitor* base,
                                                          ValaDeclarationStatement* stmt);
static void vls_symbol_visitor_real_visit_delegate (ValaCodeVisitor* base,
                                             ValaDelegate* cb);
static void vls_symbol_visitor_real_visit_delete_statement (ValaCodeVisitor* base,
                                                     ValaDeleteStatement* stmt);
static void vls_symbol_visitor_real_visit_destructor (ValaCodeVisitor* base,
                                               ValaDestructor* dtor);
static void vls_symbol_visitor_real_visit_do_statement (ValaCodeVisitor* base,
                                                 ValaDoStatement* stmt);
static void vls_symbol_visitor_real_visit_element_access (ValaCodeVisitor* base,
                                                   ValaElementAccess* expr);
static void vls_symbol_visitor_real_visit_empty_statement (ValaCodeVisitor* base,
                                                    ValaEmptyStatement* stmt);
static void vls_symbol_visitor_real_visit_enum (ValaCodeVisitor* base,
                                         ValaEnum* en);
static void vls_symbol_visitor_real_visit_enum_value (ValaCodeVisitor* base,
                                               ValaEnumValue* ev);
static void vls_symbol_visitor_real_visit_error_code (ValaCodeVisitor* base,
                                               ValaErrorCode* ecode);
static void vls_symbol_visitor_real_visit_error_domain (ValaCodeVisitor* base,
                                                 ValaErrorDomain* edomain);
static void vls_symbol_visitor_real_visit_expression (ValaCodeVisitor* base,
                                               ValaExpression* expr);
static void vls_symbol_visitor_real_visit_expression_statement (ValaCodeVisitor* base,
                                                         ValaExpressionStatement* stmt);
static void vls_symbol_visitor_real_visit_field (ValaCodeVisitor* base,
                                          ValaField* f);
static void vls_symbol_visitor_real_visit_for_statement (ValaCodeVisitor* base,
                                                  ValaForStatement* stmt);
static void vls_symbol_visitor_real_visit_foreach_statement (ValaCodeVisitor* base,
                                                      ValaForeachStatement* stmt);
static void vls_symbol_visitor_real_visit_formal_parameter (ValaCodeVisitor* base,
                                                     ValaParameter* p);
static void vls_symbol_visitor_real_visit_if_statement (ValaCodeVisitor* base,
                                                 ValaIfStatement* stmt);
static void vls_symbol_visitor_real_visit_initializer_list (ValaCodeVisitor* base,
                                                     ValaInitializerList* list);
static void vls_symbol_visitor_real_visit_integer_literal (ValaCodeVisitor* base,
                                                    ValaIntegerLiteral* lit);
static void vls_symbol_visitor_real_visit_interface (ValaCodeVisitor* base,
                                              ValaInterface* iface);
static void vls_symbol_visitor_real_visit_lambda_expression (ValaCodeVisitor* base,
                                                      ValaLambdaExpression* expr);
static void vls_symbol_visitor_real_visit_local_variable (ValaCodeVisitor* base,
                                                   ValaLocalVariable* local);
static void vls_symbol_visitor_real_visit_lock_statement (ValaCodeVisitor* base,
                                                   ValaLockStatement* stmt);
static void vls_symbol_visitor_real_visit_loop_statement (ValaCodeVisitor* base,
                                                   ValaLoopStatement* stmt);
static void vls_symbol_visitor_real_visit_member_access (ValaCodeVisitor* base,
                                                  ValaMemberAccess* expr);
static void vls_symbol_visitor_real_visit_method (ValaCodeVisitor* base,
                                           ValaMethod* m);
static void vls_symbol_visitor_real_visit_method_call (ValaCodeVisitor* base,
                                                ValaMethodCall* expr);
static void vls_symbol_visitor_real_visit_namespace (ValaCodeVisitor* base,
                                              ValaNamespace* ns);
static void vls_symbol_visitor_real_visit_null_literal (ValaCodeVisitor* base,
                                                 ValaNullLiteral* lit);
static void vls_symbol_visitor_real_visit_object_creation_expression (ValaCodeVisitor* base,
                                                               ValaObjectCreationExpression* expr);
static void vls_symbol_visitor_real_visit_pointer_indirection (ValaCodeVisitor* base,
                                                        ValaPointerIndirection* expr);
static void vls_symbol_visitor_real_visit_postfix_expression (ValaCodeVisitor* base,
                                                       ValaPostfixExpression* expr);
static void vls_symbol_visitor_real_visit_property (ValaCodeVisitor* base,
                                             ValaProperty* prop);
static void vls_symbol_visitor_real_visit_property_accessor (ValaCodeVisitor* base,
                                                      ValaPropertyAccessor* acc);
static void vls_symbol_visitor_real_visit_real_literal (ValaCodeVisitor* base,
                                                 ValaRealLiteral* lit);
static void vls_symbol_visitor_real_visit_reference_transfer_expression (ValaCodeVisitor* base,
                                                                  ValaReferenceTransferExpression* expr);
static void vls_symbol_visitor_real_visit_regex_literal (ValaCodeVisitor* base,
                                                  ValaRegexLiteral* lit);
static void vls_symbol_visitor_real_visit_return_statement (ValaCodeVisitor* base,
                                                     ValaReturnStatement* stmt);
static void vls_symbol_visitor_real_visit_signal (ValaCodeVisitor* base,
                                           ValaSignal* sig);
static void vls_symbol_visitor_real_visit_sizeof_expression (ValaCodeVisitor* base,
                                                      ValaSizeofExpression* expr);
static void vls_symbol_visitor_real_visit_slice_expression (ValaCodeVisitor* base,
                                                     ValaSliceExpression* expr);
static void vls_symbol_visitor_real_visit_string_literal (ValaCodeVisitor* base,
                                                   ValaStringLiteral* lit);
static void vls_symbol_visitor_real_visit_struct (ValaCodeVisitor* base,
                                           ValaStruct* st);
static void vls_symbol_visitor_real_visit_switch_label (ValaCodeVisitor* base,
                                                 ValaSwitchLabel* label);
static void vls_symbol_visitor_real_visit_switch_section (ValaCodeVisitor* base,
                                                   ValaSwitchSection* section);
static void vls_symbol_visitor_real_visit_switch_statement (ValaCodeVisitor* base,
                                                     ValaSwitchStatement* stmt);
static void vls_symbol_visitor_real_visit_template (ValaCodeVisitor* base,
                                             ValaTemplate* tmpl);
static void vls_symbol_visitor_real_visit_throw_statement (ValaCodeVisitor* base,
                                                    ValaThrowStatement* stmt);
static void vls_symbol_visitor_real_visit_try_statement (ValaCodeVisitor* base,
                                                  ValaTryStatement* stmt);
static void vls_symbol_visitor_real_visit_type_check (ValaCodeVisitor* base,
                                               ValaTypeCheck* expr);
static void vls_symbol_visitor_real_visit_type_parameter (ValaCodeVisitor* base,
                                                   ValaTypeParameter* p);
static void vls_symbol_visitor_real_visit_typeof_expression (ValaCodeVisitor* base,
                                                      ValaTypeofExpression* expr);
static void vls_symbol_visitor_real_visit_unary_expression (ValaCodeVisitor* base,
                                                     ValaUnaryExpression* expr);
static void vls_symbol_visitor_real_visit_unlock_statement (ValaCodeVisitor* base,
                                                     ValaUnlockStatement* stmt);
static void vls_symbol_visitor_real_visit_using_directive (ValaCodeVisitor* base,
                                                    ValaUsingDirective* ud);
static void vls_symbol_visitor_real_visit_yield_statement (ValaCodeVisitor* base,
                                                    ValaYieldStatement* stmt);
static void vls_symbol_visitor_real_visit_with_statement (ValaCodeVisitor* base,
                                                   ValaWithStatement* stmt);
static void vls_symbol_visitor_finalize (ValaCodeVisitor * obj);
static GType vls_symbol_visitor_get_type_once (void);

static inline gpointer
vls_symbol_visitor_get_instance_private (VlsSymbolVisitor* self)
{
	return G_STRUCT_MEMBER_P (self, VlsSymbolVisitor_private_offset);
}

static gpointer
_vala_source_file_ref0 (gpointer self)
{
	return self ? vala_source_file_ref (self) : NULL;
}

VlsSymbolVisitor*
vls_symbol_visitor_construct (GType object_type,
                              ValaSourceFile* file,
                              ValaSymbol* symbol,
                              gboolean include_declaration,
                              VlsSymbolVisitorFunc func,
                              gpointer func_target,
                              GDestroyNotify func_target_destroy_notify)
{
	VlsSymbolVisitor* self = NULL;
	ValaSourceFile* _tmp0_;
	GeeHashSet* _tmp1_;
	VlsSymbolVisitorFunc _tmp2_;
	gpointer _tmp2__target;
	GDestroyNotify _tmp2__target_destroy_notify;
	gboolean _tmp3_ = FALSE;
	g_return_val_if_fail (file != NULL, NULL);
	g_return_val_if_fail (symbol != NULL, NULL);
	self = (VlsSymbolVisitor*) vala_code_visitor_construct (object_type);
	_tmp0_ = _vala_source_file_ref0 (file);
	_vala_source_file_unref0 (self->priv->file);
	self->priv->file = _tmp0_;
	_tmp1_ = gee_hash_set_new (VALA_TYPE_CODE_NODE, (GBoxedCopyFunc) vala_code_node_ref, (GDestroyNotify) vala_code_node_unref, NULL, NULL, NULL, NULL, NULL, NULL);
	if (_tmp1_) {
		g_object_set_data ((GObject *) _tmp1_, "vala-creation-function", "Vls.SymbolVisitor.new");
	}
	_g_object_unref0 (self->priv->seen);
	self->priv->seen = _tmp1_;
	self->priv->include_declaration = include_declaration;
	_tmp2_ = func;
	_tmp2__target = func_target;
	_tmp2__target_destroy_notify = func_target_destroy_notify;
	func = NULL;
	func_target = NULL;
	func_target_destroy_notify = NULL;
	(self->priv->func_target_destroy_notify == NULL) ? NULL : (self->priv->func_target_destroy_notify (self->priv->func_target), NULL);
	self->priv->func = NULL;
	self->priv->func_target = NULL;
	self->priv->func_target_destroy_notify = NULL;
	self->priv->func = _tmp2_;
	self->priv->func_target = _tmp2__target;
	self->priv->func_target_destroy_notify = _tmp2__target_destroy_notify;
	vala_code_visitor_visit_source_file ((ValaCodeVisitor*) self, file);
	if (G_TYPE_CHECK_INSTANCE_TYPE (symbol, VALA_TYPE_LOCAL_VARIABLE)) {
		_tmp3_ = vls_symbol_visitor_filter (self, (ValaCodeNode*) symbol);
	} else {
		_tmp3_ = FALSE;
	}
	if (_tmp3_) {
		VlsSymbolVisitorFunc _tmp4_;
		gpointer _tmp4__target;
		_tmp4_ = self->priv->func;
		_tmp4__target = self->priv->func_target;
		_tmp4_ ((ValaCodeNode*) symbol, _tmp4__target);
	}
	(func_target_destroy_notify == NULL) ? NULL : (func_target_destroy_notify (func_target), NULL);
	func = NULL;
	func_target = NULL;
	func_target_destroy_notify = NULL;
	return self;
}

VlsSymbolVisitor*
vls_symbol_visitor_new (ValaSourceFile* file,
                        ValaSymbol* symbol,
                        gboolean include_declaration,
                        VlsSymbolVisitorFunc func,
                        gpointer func_target,
                        GDestroyNotify func_target_destroy_notify)
{
	return vls_symbol_visitor_construct (VLS_TYPE_SYMBOL_VISITOR, file, symbol, include_declaration, func, func_target, func_target_destroy_notify);
}

static gpointer
_vala_source_reference_ref0 (gpointer self)
{
	return self ? vala_source_reference_ref (self) : NULL;
}

static gboolean
vls_symbol_visitor_filter (VlsSymbolVisitor* self,
                           ValaCodeNode* node)
{
	ValaSourceReference* sr = NULL;
	ValaSourceReference* _tmp0_;
	ValaSourceReference* _tmp1_;
	ValaSourceReference* _tmp2_;
	ValaSourceReference* _tmp3_;
	ValaSourceReference* _tmp4_;
	ValaSourceFile* _tmp5_;
	ValaSourceFile* _tmp6_;
	ValaSourceFile* _tmp7_;
	ValaSourceReference* _tmp8_;
	ValaSourceLocation _tmp9_ = {0};
	ValaSourceLocation _tmp10_;
	ValaSourceReference* _tmp11_;
	ValaSourceLocation _tmp12_ = {0};
	ValaSourceLocation _tmp13_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (node != NULL, FALSE);
	_tmp0_ = vala_code_node_get_source_reference (node);
	_tmp1_ = _tmp0_;
	_tmp2_ = _vala_source_reference_ref0 (_tmp1_);
	sr = _tmp2_;
	_tmp3_ = sr;
	if (_tmp3_ == NULL) {
		result = FALSE;
		_vala_source_reference_unref0 (sr);
		return result;
	}
	_tmp4_ = sr;
	_tmp5_ = vala_source_reference_get_file (_tmp4_);
	_tmp6_ = _tmp5_;
	_tmp7_ = self->priv->file;
	if (_tmp6_ != _tmp7_) {
		result = FALSE;
		_vala_source_reference_unref0 (sr);
		return result;
	}
	_tmp8_ = sr;
	vala_source_reference_get_begin (_tmp8_, &_tmp9_);
	_tmp10_ = _tmp9_;
	_tmp11_ = sr;
	vala_source_reference_get_end (_tmp11_, &_tmp12_);
	_tmp13_ = _tmp12_;
	if (_tmp10_.line > _tmp13_.line) {
		const gchar* _tmp14_;
		const gchar* _tmp15_;
		ValaSourceReference* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
		_tmp14_ = vala_code_node_get_type_name (node);
		_tmp15_ = _tmp14_;
		_tmp16_ = sr;
		_tmp17_ = vala_source_reference_to_string (_tmp16_);
		_tmp18_ = _tmp17_;
		g_warning ("symbolvisitor.vala:56: wtf Vala: %s @ %s", _tmp15_, _tmp18_);
		_g_free0 (_tmp18_);
		result = FALSE;
		_vala_source_reference_unref0 (sr);
		return result;
	}
	result = TRUE;
	_vala_source_reference_unref0 (sr);
	return result;
}

static void
vls_symbol_visitor_real_visit_source_file (ValaCodeVisitor* base,
                                           ValaSourceFile* source_file)
{
	VlsSymbolVisitor * self;
	self = (VlsSymbolVisitor*) base;
	g_return_if_fail (source_file != NULL);
	vala_source_file_accept_children (source_file, (ValaCodeVisitor*) self);
	{
		ValaList* _using_directive_list = NULL;
		ValaList* _tmp0_;
		ValaList* _tmp1_;
		gint _using_directive_size = 0;
		ValaList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _using_directive_index = 0;
		_tmp0_ = vala_source_file_get_current_using_directives (source_file);
		_tmp1_ = _tmp0_;
		_using_directive_list = _tmp1_;
		_tmp2_ = _using_directive_list;
		_tmp3_ = vala_collection_get_size ((ValaCollection*) _tmp2_);
		_tmp4_ = _tmp3_;
		_using_directive_size = _tmp4_;
		_using_directive_index = -1;
		while (TRUE) {
			gint _tmp5_;
			gint _tmp6_;
			ValaUsingDirective* using_directive = NULL;
			ValaList* _tmp7_;
			gpointer _tmp8_;
			ValaUsingDirective* _tmp9_;
			_using_directive_index = _using_directive_index + 1;
			_tmp5_ = _using_directive_index;
			_tmp6_ = _using_directive_size;
			if (!(_tmp5_ < _tmp6_)) {
				break;
			}
			_tmp7_ = _using_directive_list;
			_tmp8_ = vala_list_get (_tmp7_, _using_directive_index);
			using_directive = (ValaUsingDirective*) _tmp8_;
			_tmp9_ = using_directive;
			vala_code_visitor_visit_using_directive ((ValaCodeVisitor*) self, _tmp9_);
			_vala_code_node_unref0 (using_directive);
		}
	}
}

static void
vls_symbol_visitor_real_visit_addressof_expression (ValaCodeVisitor* base,
                                                    ValaAddressofExpression* expr)
{
	VlsSymbolVisitor * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsSymbolVisitor*) base;
	g_return_if_fail (expr != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) expr)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) expr);
	if (vls_symbol_visitor_filter (self, (ValaCodeNode*) expr)) {
		VlsSymbolVisitorFunc _tmp2_;
		gpointer _tmp2__target;
		_tmp2_ = self->priv->func;
		_tmp2__target = self->priv->func_target;
		_tmp2_ ((ValaCodeNode*) expr, _tmp2__target);
	}
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}

static void
vls_symbol_visitor_real_visit_array_creation_expression (ValaCodeVisitor* base,
                                                         ValaArrayCreationExpression* expr)
{
	VlsSymbolVisitor * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsSymbolVisitor*) base;
	g_return_if_fail (expr != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) expr)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) expr);
	if (vls_symbol_visitor_filter (self, (ValaCodeNode*) expr)) {
		VlsSymbolVisitorFunc _tmp2_;
		gpointer _tmp2__target;
		_tmp2_ = self->priv->func;
		_tmp2__target = self->priv->func_target;
		_tmp2_ ((ValaCodeNode*) expr, _tmp2__target);
	}
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}

static void
vls_symbol_visitor_real_visit_assignment (ValaCodeVisitor* base,
                                          ValaAssignment* a)
{
	VlsSymbolVisitor * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsSymbolVisitor*) base;
	g_return_if_fail (a != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) a)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) a);
	if (vls_symbol_visitor_filter (self, (ValaCodeNode*) a)) {
		VlsSymbolVisitorFunc _tmp2_;
		gpointer _tmp2__target;
		_tmp2_ = self->priv->func;
		_tmp2__target = self->priv->func_target;
		_tmp2_ ((ValaCodeNode*) a, _tmp2__target);
	}
	vala_code_node_accept_children ((ValaCodeNode*) a, (ValaCodeVisitor*) self);
}

static void
vls_symbol_visitor_real_visit_base_access (ValaCodeVisitor* base,
                                           ValaBaseAccess* expr)
{
	VlsSymbolVisitor * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsSymbolVisitor*) base;
	g_return_if_fail (expr != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) expr)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) expr);
	if (vls_symbol_visitor_filter (self, (ValaCodeNode*) expr)) {
		VlsSymbolVisitorFunc _tmp2_;
		gpointer _tmp2__target;
		_tmp2_ = self->priv->func;
		_tmp2__target = self->priv->func_target;
		_tmp2_ ((ValaCodeNode*) expr, _tmp2__target);
	}
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}

static void
vls_symbol_visitor_real_visit_binary_expression (ValaCodeVisitor* base,
                                                 ValaBinaryExpression* expr)
{
	VlsSymbolVisitor * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsSymbolVisitor*) base;
	g_return_if_fail (expr != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) expr)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) expr);
	if (vls_symbol_visitor_filter (self, (ValaCodeNode*) expr)) {
		VlsSymbolVisitorFunc _tmp2_;
		gpointer _tmp2__target;
		_tmp2_ = self->priv->func;
		_tmp2__target = self->priv->func_target;
		_tmp2_ ((ValaCodeNode*) expr, _tmp2__target);
	}
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}

static void
vls_symbol_visitor_real_visit_block (ValaCodeVisitor* base,
                                     ValaBlock* b)
{
	VlsSymbolVisitor * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsSymbolVisitor*) base;
	g_return_if_fail (b != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) b)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) b);
	if (vls_symbol_visitor_filter (self, (ValaCodeNode*) b)) {
		VlsSymbolVisitorFunc _tmp2_;
		gpointer _tmp2__target;
		_tmp2_ = self->priv->func;
		_tmp2__target = self->priv->func_target;
		_tmp2_ ((ValaCodeNode*) b, _tmp2__target);
	}
	vala_code_node_accept_children ((ValaCodeNode*) b, (ValaCodeVisitor*) self);
}

static void
vls_symbol_visitor_real_visit_boolean_literal (ValaCodeVisitor* base,
                                               ValaBooleanLiteral* lit)
{
	VlsSymbolVisitor * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsSymbolVisitor*) base;
	g_return_if_fail (lit != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) lit)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) lit);
	if (vls_symbol_visitor_filter (self, (ValaCodeNode*) lit)) {
		VlsSymbolVisitorFunc _tmp2_;
		gpointer _tmp2__target;
		_tmp2_ = self->priv->func;
		_tmp2__target = self->priv->func_target;
		_tmp2_ ((ValaCodeNode*) lit, _tmp2__target);
	}
	vala_code_node_accept_children ((ValaCodeNode*) lit, (ValaCodeVisitor*) self);
}

static void
vls_symbol_visitor_real_visit_break_statement (ValaCodeVisitor* base,
                                               ValaBreakStatement* stmt)
{
	VlsSymbolVisitor * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsSymbolVisitor*) base;
	g_return_if_fail (stmt != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) stmt)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) stmt);
	if (vls_symbol_visitor_filter (self, (ValaCodeNode*) stmt)) {
		VlsSymbolVisitorFunc _tmp2_;
		gpointer _tmp2__target;
		_tmp2_ = self->priv->func;
		_tmp2__target = self->priv->func_target;
		_tmp2_ ((ValaCodeNode*) stmt, _tmp2__target);
	}
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}

static void
vls_symbol_visitor_real_visit_cast_expression (ValaCodeVisitor* base,
                                               ValaCastExpression* expr)
{
	VlsSymbolVisitor * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsSymbolVisitor*) base;
	g_return_if_fail (expr != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) expr)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) expr);
	if (vls_symbol_visitor_filter (self, (ValaCodeNode*) expr)) {
		VlsSymbolVisitorFunc _tmp2_;
		gpointer _tmp2__target;
		_tmp2_ = self->priv->func;
		_tmp2__target = self->priv->func_target;
		_tmp2_ ((ValaCodeNode*) expr, _tmp2__target);
	}
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}

static void
vls_symbol_visitor_real_visit_catch_clause (ValaCodeVisitor* base,
                                            ValaCatchClause* clause)
{
	VlsSymbolVisitor * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsSymbolVisitor*) base;
	g_return_if_fail (clause != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) clause)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) clause);
	if (vls_symbol_visitor_filter (self, (ValaCodeNode*) clause)) {
		VlsSymbolVisitorFunc _tmp2_;
		gpointer _tmp2__target;
		_tmp2_ = self->priv->func;
		_tmp2__target = self->priv->func_target;
		_tmp2_ ((ValaCodeNode*) clause, _tmp2__target);
	}
	vala_code_node_accept_children ((ValaCodeNode*) clause, (ValaCodeVisitor*) self);
}

static void
vls_symbol_visitor_real_visit_character_literal (ValaCodeVisitor* base,
                                                 ValaCharacterLiteral* lit)
{
	VlsSymbolVisitor * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsSymbolVisitor*) base;
	g_return_if_fail (lit != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) lit)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) lit);
	if (vls_symbol_visitor_filter (self, (ValaCodeNode*) lit)) {
		VlsSymbolVisitorFunc _tmp2_;
		gpointer _tmp2__target;
		_tmp2_ = self->priv->func;
		_tmp2__target = self->priv->func_target;
		_tmp2_ ((ValaCodeNode*) lit, _tmp2__target);
	}
	vala_code_node_accept_children ((ValaCodeNode*) lit, (ValaCodeVisitor*) self);
}

static void
vls_symbol_visitor_real_visit_class (ValaCodeVisitor* base,
                                     ValaClass* cl)
{
	VlsSymbolVisitor * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	gboolean _tmp2_ = FALSE;
	self = (VlsSymbolVisitor*) base;
	g_return_if_fail (cl != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) cl)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) cl);
	if (vls_symbol_visitor_filter (self, (ValaCodeNode*) cl)) {
		_tmp2_ = self->priv->include_declaration;
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		VlsSymbolVisitorFunc _tmp3_;
		gpointer _tmp3__target;
		_tmp3_ = self->priv->func;
		_tmp3__target = self->priv->func_target;
		_tmp3_ ((ValaCodeNode*) cl, _tmp3__target);
	}
	vala_code_node_accept_children ((ValaCodeNode*) cl, (ValaCodeVisitor*) self);
}

static void
vls_symbol_visitor_real_visit_conditional_expression (ValaCodeVisitor* base,
                                                      ValaConditionalExpression* expr)
{
	VlsSymbolVisitor * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsSymbolVisitor*) base;
	g_return_if_fail (expr != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) expr)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) expr);
	if (vls_symbol_visitor_filter (self, (ValaCodeNode*) expr)) {
		VlsSymbolVisitorFunc _tmp2_;
		gpointer _tmp2__target;
		_tmp2_ = self->priv->func;
		_tmp2__target = self->priv->func_target;
		_tmp2_ ((ValaCodeNode*) expr, _tmp2__target);
	}
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}

static void
vls_symbol_visitor_real_visit_constant (ValaCodeVisitor* base,
                                        ValaConstant* c)
{
	VlsSymbolVisitor * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	gboolean _tmp2_ = FALSE;
	self = (VlsSymbolVisitor*) base;
	g_return_if_fail (c != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) c)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) c);
	if (vls_symbol_visitor_filter (self, (ValaCodeNode*) c)) {
		_tmp2_ = self->priv->include_declaration;
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		VlsSymbolVisitorFunc _tmp3_;
		gpointer _tmp3__target;
		_tmp3_ = self->priv->func;
		_tmp3__target = self->priv->func_target;
		_tmp3_ ((ValaCodeNode*) c, _tmp3__target);
	}
	vala_code_node_accept_children ((ValaCodeNode*) c, (ValaCodeVisitor*) self);
}

static void
vls_symbol_visitor_real_visit_constructor (ValaCodeVisitor* base,
                                           ValaConstructor* c)
{
	VlsSymbolVisitor * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	gboolean _tmp2_ = FALSE;
	self = (VlsSymbolVisitor*) base;
	g_return_if_fail (c != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) c)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) c);
	if (vls_symbol_visitor_filter (self, (ValaCodeNode*) c)) {
		_tmp2_ = self->priv->include_declaration;
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		VlsSymbolVisitorFunc _tmp3_;
		gpointer _tmp3__target;
		_tmp3_ = self->priv->func;
		_tmp3__target = self->priv->func_target;
		_tmp3_ ((ValaCodeNode*) c, _tmp3__target);
	}
	vala_code_node_accept_children ((ValaCodeNode*) c, (ValaCodeVisitor*) self);
}

static void
vls_symbol_visitor_real_visit_continue_statement (ValaCodeVisitor* base,
                                                  ValaContinueStatement* stmt)
{
	VlsSymbolVisitor * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsSymbolVisitor*) base;
	g_return_if_fail (stmt != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) stmt)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) stmt);
	if (vls_symbol_visitor_filter (self, (ValaCodeNode*) stmt)) {
		VlsSymbolVisitorFunc _tmp2_;
		gpointer _tmp2__target;
		_tmp2_ = self->priv->func;
		_tmp2__target = self->priv->func_target;
		_tmp2_ ((ValaCodeNode*) stmt, _tmp2__target);
	}
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}

static void
vls_symbol_visitor_real_visit_creation_method (ValaCodeVisitor* base,
                                               ValaCreationMethod* m)
{
	VlsSymbolVisitor * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	gboolean _tmp2_ = FALSE;
	self = (VlsSymbolVisitor*) base;
	g_return_if_fail (m != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) m)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) m);
	if (vls_symbol_visitor_filter (self, (ValaCodeNode*) m)) {
		_tmp2_ = self->priv->include_declaration;
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		VlsSymbolVisitorFunc _tmp3_;
		gpointer _tmp3__target;
		_tmp3_ = self->priv->func;
		_tmp3__target = self->priv->func_target;
		_tmp3_ ((ValaCodeNode*) m, _tmp3__target);
	}
	vala_code_node_accept_children ((ValaCodeNode*) m, (ValaCodeVisitor*) self);
}

static void
vls_symbol_visitor_real_visit_data_type (ValaCodeVisitor* base,
                                         ValaDataType* type)
{
	VlsSymbolVisitor * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsSymbolVisitor*) base;
	g_return_if_fail (type != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) type)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) type);
	if (vls_symbol_visitor_filter (self, (ValaCodeNode*) type)) {
		VlsSymbolVisitorFunc _tmp2_;
		gpointer _tmp2__target;
		_tmp2_ = self->priv->func;
		_tmp2__target = self->priv->func_target;
		_tmp2_ ((ValaCodeNode*) type, _tmp2__target);
	}
	vala_code_node_accept_children ((ValaCodeNode*) type, (ValaCodeVisitor*) self);
}

static void
vls_symbol_visitor_real_visit_declaration_statement (ValaCodeVisitor* base,
                                                     ValaDeclarationStatement* stmt)
{
	VlsSymbolVisitor * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsSymbolVisitor*) base;
	g_return_if_fail (stmt != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) stmt)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) stmt);
	if (vls_symbol_visitor_filter (self, (ValaCodeNode*) stmt)) {
		VlsSymbolVisitorFunc _tmp2_;
		gpointer _tmp2__target;
		_tmp2_ = self->priv->func;
		_tmp2__target = self->priv->func_target;
		_tmp2_ ((ValaCodeNode*) stmt, _tmp2__target);
	}
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}

static void
vls_symbol_visitor_real_visit_delegate (ValaCodeVisitor* base,
                                        ValaDelegate* cb)
{
	VlsSymbolVisitor * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	gboolean _tmp2_ = FALSE;
	self = (VlsSymbolVisitor*) base;
	g_return_if_fail (cb != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) cb)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) cb);
	if (vls_symbol_visitor_filter (self, (ValaCodeNode*) cb)) {
		_tmp2_ = self->priv->include_declaration;
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		VlsSymbolVisitorFunc _tmp3_;
		gpointer _tmp3__target;
		_tmp3_ = self->priv->func;
		_tmp3__target = self->priv->func_target;
		_tmp3_ ((ValaCodeNode*) cb, _tmp3__target);
	}
	vala_code_node_accept_children ((ValaCodeNode*) cb, (ValaCodeVisitor*) self);
}

static void
vls_symbol_visitor_real_visit_delete_statement (ValaCodeVisitor* base,
                                                ValaDeleteStatement* stmt)
{
	VlsSymbolVisitor * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsSymbolVisitor*) base;
	g_return_if_fail (stmt != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) stmt)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) stmt);
	if (vls_symbol_visitor_filter (self, (ValaCodeNode*) stmt)) {
		VlsSymbolVisitorFunc _tmp2_;
		gpointer _tmp2__target;
		_tmp2_ = self->priv->func;
		_tmp2__target = self->priv->func_target;
		_tmp2_ ((ValaCodeNode*) stmt, _tmp2__target);
	}
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}

static void
vls_symbol_visitor_real_visit_destructor (ValaCodeVisitor* base,
                                          ValaDestructor* dtor)
{
	VlsSymbolVisitor * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	gboolean _tmp2_ = FALSE;
	self = (VlsSymbolVisitor*) base;
	g_return_if_fail (dtor != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) dtor)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) dtor);
	if (vls_symbol_visitor_filter (self, (ValaCodeNode*) dtor)) {
		_tmp2_ = self->priv->include_declaration;
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		VlsSymbolVisitorFunc _tmp3_;
		gpointer _tmp3__target;
		_tmp3_ = self->priv->func;
		_tmp3__target = self->priv->func_target;
		_tmp3_ ((ValaCodeNode*) dtor, _tmp3__target);
	}
	vala_code_node_accept_children ((ValaCodeNode*) dtor, (ValaCodeVisitor*) self);
}

static void
vls_symbol_visitor_real_visit_do_statement (ValaCodeVisitor* base,
                                            ValaDoStatement* stmt)
{
	VlsSymbolVisitor * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsSymbolVisitor*) base;
	g_return_if_fail (stmt != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) stmt)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) stmt);
	if (vls_symbol_visitor_filter (self, (ValaCodeNode*) stmt)) {
		VlsSymbolVisitorFunc _tmp2_;
		gpointer _tmp2__target;
		_tmp2_ = self->priv->func;
		_tmp2__target = self->priv->func_target;
		_tmp2_ ((ValaCodeNode*) stmt, _tmp2__target);
	}
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}

static void
vls_symbol_visitor_real_visit_element_access (ValaCodeVisitor* base,
                                              ValaElementAccess* expr)
{
	VlsSymbolVisitor * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsSymbolVisitor*) base;
	g_return_if_fail (expr != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) expr)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) expr);
	if (vls_symbol_visitor_filter (self, (ValaCodeNode*) expr)) {
		VlsSymbolVisitorFunc _tmp2_;
		gpointer _tmp2__target;
		_tmp2_ = self->priv->func;
		_tmp2__target = self->priv->func_target;
		_tmp2_ ((ValaCodeNode*) expr, _tmp2__target);
	}
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}

static void
vls_symbol_visitor_real_visit_empty_statement (ValaCodeVisitor* base,
                                               ValaEmptyStatement* stmt)
{
	VlsSymbolVisitor * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsSymbolVisitor*) base;
	g_return_if_fail (stmt != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) stmt)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) stmt);
	if (vls_symbol_visitor_filter (self, (ValaCodeNode*) stmt)) {
		VlsSymbolVisitorFunc _tmp2_;
		gpointer _tmp2__target;
		_tmp2_ = self->priv->func;
		_tmp2__target = self->priv->func_target;
		_tmp2_ ((ValaCodeNode*) stmt, _tmp2__target);
	}
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}

static void
vls_symbol_visitor_real_visit_enum (ValaCodeVisitor* base,
                                    ValaEnum* en)
{
	VlsSymbolVisitor * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	gboolean _tmp2_ = FALSE;
	self = (VlsSymbolVisitor*) base;
	g_return_if_fail (en != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) en)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) en);
	if (vls_symbol_visitor_filter (self, (ValaCodeNode*) en)) {
		_tmp2_ = self->priv->include_declaration;
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		VlsSymbolVisitorFunc _tmp3_;
		gpointer _tmp3__target;
		_tmp3_ = self->priv->func;
		_tmp3__target = self->priv->func_target;
		_tmp3_ ((ValaCodeNode*) en, _tmp3__target);
	}
	vala_code_node_accept_children ((ValaCodeNode*) en, (ValaCodeVisitor*) self);
}

static void
vls_symbol_visitor_real_visit_enum_value (ValaCodeVisitor* base,
                                          ValaEnumValue* ev)
{
	VlsSymbolVisitor * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	gboolean _tmp2_ = FALSE;
	self = (VlsSymbolVisitor*) base;
	g_return_if_fail (ev != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) ev)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) ev);
	if (vls_symbol_visitor_filter (self, (ValaCodeNode*) ev)) {
		_tmp2_ = self->priv->include_declaration;
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		VlsSymbolVisitorFunc _tmp3_;
		gpointer _tmp3__target;
		_tmp3_ = self->priv->func;
		_tmp3__target = self->priv->func_target;
		_tmp3_ ((ValaCodeNode*) ev, _tmp3__target);
	}
	vala_code_node_accept_children ((ValaCodeNode*) ev, (ValaCodeVisitor*) self);
}

static void
vls_symbol_visitor_real_visit_error_code (ValaCodeVisitor* base,
                                          ValaErrorCode* ecode)
{
	VlsSymbolVisitor * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	gboolean _tmp2_ = FALSE;
	self = (VlsSymbolVisitor*) base;
	g_return_if_fail (ecode != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) ecode)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) ecode);
	if (vls_symbol_visitor_filter (self, (ValaCodeNode*) ecode)) {
		_tmp2_ = self->priv->include_declaration;
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		VlsSymbolVisitorFunc _tmp3_;
		gpointer _tmp3__target;
		_tmp3_ = self->priv->func;
		_tmp3__target = self->priv->func_target;
		_tmp3_ ((ValaCodeNode*) ecode, _tmp3__target);
	}
	vala_code_node_accept_children ((ValaCodeNode*) ecode, (ValaCodeVisitor*) self);
}

static void
vls_symbol_visitor_real_visit_error_domain (ValaCodeVisitor* base,
                                            ValaErrorDomain* edomain)
{
	VlsSymbolVisitor * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	gboolean _tmp2_ = FALSE;
	self = (VlsSymbolVisitor*) base;
	g_return_if_fail (edomain != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) edomain)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) edomain);
	if (vls_symbol_visitor_filter (self, (ValaCodeNode*) edomain)) {
		_tmp2_ = self->priv->include_declaration;
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		VlsSymbolVisitorFunc _tmp3_;
		gpointer _tmp3__target;
		_tmp3_ = self->priv->func;
		_tmp3__target = self->priv->func_target;
		_tmp3_ ((ValaCodeNode*) edomain, _tmp3__target);
	}
	vala_code_node_accept_children ((ValaCodeNode*) edomain, (ValaCodeVisitor*) self);
}

static void
vls_symbol_visitor_real_visit_expression (ValaCodeVisitor* base,
                                          ValaExpression* expr)
{
	VlsSymbolVisitor * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsSymbolVisitor*) base;
	g_return_if_fail (expr != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) expr)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) expr);
	if (vls_symbol_visitor_filter (self, (ValaCodeNode*) expr)) {
		VlsSymbolVisitorFunc _tmp2_;
		gpointer _tmp2__target;
		_tmp2_ = self->priv->func;
		_tmp2__target = self->priv->func_target;
		_tmp2_ ((ValaCodeNode*) expr, _tmp2__target);
	}
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}

static void
vls_symbol_visitor_real_visit_expression_statement (ValaCodeVisitor* base,
                                                    ValaExpressionStatement* stmt)
{
	VlsSymbolVisitor * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsSymbolVisitor*) base;
	g_return_if_fail (stmt != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) stmt)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) stmt);
	if (vls_symbol_visitor_filter (self, (ValaCodeNode*) stmt)) {
		VlsSymbolVisitorFunc _tmp2_;
		gpointer _tmp2__target;
		_tmp2_ = self->priv->func;
		_tmp2__target = self->priv->func_target;
		_tmp2_ ((ValaCodeNode*) stmt, _tmp2__target);
	}
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}

static void
vls_symbol_visitor_real_visit_field (ValaCodeVisitor* base,
                                     ValaField* f)
{
	VlsSymbolVisitor * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	gboolean _tmp2_ = FALSE;
	self = (VlsSymbolVisitor*) base;
	g_return_if_fail (f != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) f)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) f);
	if (vls_symbol_visitor_filter (self, (ValaCodeNode*) f)) {
		_tmp2_ = self->priv->include_declaration;
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		VlsSymbolVisitorFunc _tmp3_;
		gpointer _tmp3__target;
		_tmp3_ = self->priv->func;
		_tmp3__target = self->priv->func_target;
		_tmp3_ ((ValaCodeNode*) f, _tmp3__target);
	}
	vala_code_node_accept_children ((ValaCodeNode*) f, (ValaCodeVisitor*) self);
}

static void
vls_symbol_visitor_real_visit_for_statement (ValaCodeVisitor* base,
                                             ValaForStatement* stmt)
{
	VlsSymbolVisitor * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsSymbolVisitor*) base;
	g_return_if_fail (stmt != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) stmt)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) stmt);
	if (vls_symbol_visitor_filter (self, (ValaCodeNode*) stmt)) {
		VlsSymbolVisitorFunc _tmp2_;
		gpointer _tmp2__target;
		_tmp2_ = self->priv->func;
		_tmp2__target = self->priv->func_target;
		_tmp2_ ((ValaCodeNode*) stmt, _tmp2__target);
	}
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}

static void
vls_symbol_visitor_real_visit_foreach_statement (ValaCodeVisitor* base,
                                                 ValaForeachStatement* stmt)
{
	VlsSymbolVisitor * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsSymbolVisitor*) base;
	g_return_if_fail (stmt != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) stmt)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) stmt);
	if (vls_symbol_visitor_filter (self, (ValaCodeNode*) stmt)) {
		VlsSymbolVisitorFunc _tmp2_;
		gpointer _tmp2__target;
		_tmp2_ = self->priv->func;
		_tmp2__target = self->priv->func_target;
		_tmp2_ ((ValaCodeNode*) stmt, _tmp2__target);
	}
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}

static void
vls_symbol_visitor_real_visit_formal_parameter (ValaCodeVisitor* base,
                                                ValaParameter* p)
{
	VlsSymbolVisitor * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	gboolean _tmp2_ = FALSE;
	self = (VlsSymbolVisitor*) base;
	g_return_if_fail (p != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) p)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) p);
	if (vls_symbol_visitor_filter (self, (ValaCodeNode*) p)) {
		_tmp2_ = self->priv->include_declaration;
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		VlsSymbolVisitorFunc _tmp3_;
		gpointer _tmp3__target;
		_tmp3_ = self->priv->func;
		_tmp3__target = self->priv->func_target;
		_tmp3_ ((ValaCodeNode*) p, _tmp3__target);
	}
	vala_code_node_accept_children ((ValaCodeNode*) p, (ValaCodeVisitor*) self);
}

static void
vls_symbol_visitor_real_visit_if_statement (ValaCodeVisitor* base,
                                            ValaIfStatement* stmt)
{
	VlsSymbolVisitor * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsSymbolVisitor*) base;
	g_return_if_fail (stmt != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) stmt)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) stmt);
	if (vls_symbol_visitor_filter (self, (ValaCodeNode*) stmt)) {
		VlsSymbolVisitorFunc _tmp2_;
		gpointer _tmp2__target;
		_tmp2_ = self->priv->func;
		_tmp2__target = self->priv->func_target;
		_tmp2_ ((ValaCodeNode*) stmt, _tmp2__target);
	}
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}

static void
vls_symbol_visitor_real_visit_initializer_list (ValaCodeVisitor* base,
                                                ValaInitializerList* list)
{
	VlsSymbolVisitor * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsSymbolVisitor*) base;
	g_return_if_fail (list != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) list)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) list);
	if (vls_symbol_visitor_filter (self, (ValaCodeNode*) list)) {
		VlsSymbolVisitorFunc _tmp2_;
		gpointer _tmp2__target;
		_tmp2_ = self->priv->func;
		_tmp2__target = self->priv->func_target;
		_tmp2_ ((ValaCodeNode*) list, _tmp2__target);
	}
	vala_code_node_accept_children ((ValaCodeNode*) list, (ValaCodeVisitor*) self);
}

static void
vls_symbol_visitor_real_visit_integer_literal (ValaCodeVisitor* base,
                                               ValaIntegerLiteral* lit)
{
	VlsSymbolVisitor * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsSymbolVisitor*) base;
	g_return_if_fail (lit != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) lit)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) lit);
	if (vls_symbol_visitor_filter (self, (ValaCodeNode*) lit)) {
		VlsSymbolVisitorFunc _tmp2_;
		gpointer _tmp2__target;
		_tmp2_ = self->priv->func;
		_tmp2__target = self->priv->func_target;
		_tmp2_ ((ValaCodeNode*) lit, _tmp2__target);
	}
	vala_code_node_accept_children ((ValaCodeNode*) lit, (ValaCodeVisitor*) self);
}

static void
vls_symbol_visitor_real_visit_interface (ValaCodeVisitor* base,
                                         ValaInterface* iface)
{
	VlsSymbolVisitor * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	gboolean _tmp2_ = FALSE;
	self = (VlsSymbolVisitor*) base;
	g_return_if_fail (iface != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) iface)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) iface);
	if (vls_symbol_visitor_filter (self, (ValaCodeNode*) iface)) {
		_tmp2_ = self->priv->include_declaration;
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		VlsSymbolVisitorFunc _tmp3_;
		gpointer _tmp3__target;
		_tmp3_ = self->priv->func;
		_tmp3__target = self->priv->func_target;
		_tmp3_ ((ValaCodeNode*) iface, _tmp3__target);
	}
	vala_code_node_accept_children ((ValaCodeNode*) iface, (ValaCodeVisitor*) self);
}

static void
vls_symbol_visitor_real_visit_lambda_expression (ValaCodeVisitor* base,
                                                 ValaLambdaExpression* expr)
{
	VlsSymbolVisitor * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsSymbolVisitor*) base;
	g_return_if_fail (expr != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) expr)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) expr);
	if (vls_symbol_visitor_filter (self, (ValaCodeNode*) expr)) {
		VlsSymbolVisitorFunc _tmp2_;
		gpointer _tmp2__target;
		_tmp2_ = self->priv->func;
		_tmp2__target = self->priv->func_target;
		_tmp2_ ((ValaCodeNode*) expr, _tmp2__target);
	}
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}

static void
vls_symbol_visitor_real_visit_local_variable (ValaCodeVisitor* base,
                                              ValaLocalVariable* local)
{
	VlsSymbolVisitor * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	gboolean _tmp2_ = FALSE;
	self = (VlsSymbolVisitor*) base;
	g_return_if_fail (local != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) local)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) local);
	if (vls_symbol_visitor_filter (self, (ValaCodeNode*) local)) {
		gboolean _tmp3_ = FALSE;
		if (self->priv->include_declaration) {
			_tmp3_ = TRUE;
		} else {
			ValaCodeNode* _tmp4_;
			ValaCodeNode* _tmp5_;
			_tmp4_ = vala_code_node_get_parent_node ((ValaCodeNode*) local);
			_tmp5_ = _tmp4_;
			_tmp3_ = !G_TYPE_CHECK_INSTANCE_TYPE (_tmp5_, VALA_TYPE_DECLARATION_STATEMENT);
		}
		_tmp2_ = _tmp3_;
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		VlsSymbolVisitorFunc _tmp6_;
		gpointer _tmp6__target;
		_tmp6_ = self->priv->func;
		_tmp6__target = self->priv->func_target;
		_tmp6_ ((ValaCodeNode*) local, _tmp6__target);
	}
	vala_code_node_accept_children ((ValaCodeNode*) local, (ValaCodeVisitor*) self);
}

static void
vls_symbol_visitor_real_visit_lock_statement (ValaCodeVisitor* base,
                                              ValaLockStatement* stmt)
{
	VlsSymbolVisitor * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsSymbolVisitor*) base;
	g_return_if_fail (stmt != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) stmt)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) stmt);
	if (vls_symbol_visitor_filter (self, (ValaCodeNode*) stmt)) {
		VlsSymbolVisitorFunc _tmp2_;
		gpointer _tmp2__target;
		_tmp2_ = self->priv->func;
		_tmp2__target = self->priv->func_target;
		_tmp2_ ((ValaCodeNode*) stmt, _tmp2__target);
	}
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}

static void
vls_symbol_visitor_real_visit_loop_statement (ValaCodeVisitor* base,
                                              ValaLoopStatement* stmt)
{
	VlsSymbolVisitor * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsSymbolVisitor*) base;
	g_return_if_fail (stmt != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) stmt)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) stmt);
	if (vls_symbol_visitor_filter (self, (ValaCodeNode*) stmt)) {
		VlsSymbolVisitorFunc _tmp2_;
		gpointer _tmp2__target;
		_tmp2_ = self->priv->func;
		_tmp2__target = self->priv->func_target;
		_tmp2_ ((ValaCodeNode*) stmt, _tmp2__target);
	}
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}

static void
vls_symbol_visitor_real_visit_member_access (ValaCodeVisitor* base,
                                             ValaMemberAccess* expr)
{
	VlsSymbolVisitor * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsSymbolVisitor*) base;
	g_return_if_fail (expr != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) expr)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) expr);
	if (vls_symbol_visitor_filter (self, (ValaCodeNode*) expr)) {
		VlsSymbolVisitorFunc _tmp2_;
		gpointer _tmp2__target;
		_tmp2_ = self->priv->func;
		_tmp2__target = self->priv->func_target;
		_tmp2_ ((ValaCodeNode*) expr, _tmp2__target);
	}
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}

static void
vls_symbol_visitor_real_visit_method (ValaCodeVisitor* base,
                                      ValaMethod* m)
{
	VlsSymbolVisitor * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	gboolean _tmp2_ = FALSE;
	self = (VlsSymbolVisitor*) base;
	g_return_if_fail (m != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) m)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) m);
	if (vls_symbol_visitor_filter (self, (ValaCodeNode*) m)) {
		_tmp2_ = self->priv->include_declaration;
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		VlsSymbolVisitorFunc _tmp3_;
		gpointer _tmp3__target;
		_tmp3_ = self->priv->func;
		_tmp3__target = self->priv->func_target;
		_tmp3_ ((ValaCodeNode*) m, _tmp3__target);
	}
	vala_code_node_accept_children ((ValaCodeNode*) m, (ValaCodeVisitor*) self);
}

static void
vls_symbol_visitor_real_visit_method_call (ValaCodeVisitor* base,
                                           ValaMethodCall* expr)
{
	VlsSymbolVisitor * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsSymbolVisitor*) base;
	g_return_if_fail (expr != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) expr)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) expr);
	if (vls_symbol_visitor_filter (self, (ValaCodeNode*) expr)) {
		VlsSymbolVisitorFunc _tmp2_;
		gpointer _tmp2__target;
		_tmp2_ = self->priv->func;
		_tmp2__target = self->priv->func_target;
		_tmp2_ ((ValaCodeNode*) expr, _tmp2__target);
	}
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}

static void
vls_symbol_visitor_real_visit_namespace (ValaCodeVisitor* base,
                                         ValaNamespace* ns)
{
	VlsSymbolVisitor * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsSymbolVisitor*) base;
	g_return_if_fail (ns != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) ns)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) ns);
	if (vls_symbol_visitor_filter (self, (ValaCodeNode*) ns)) {
		VlsSymbolVisitorFunc _tmp2_;
		gpointer _tmp2__target;
		_tmp2_ = self->priv->func;
		_tmp2__target = self->priv->func_target;
		_tmp2_ ((ValaCodeNode*) ns, _tmp2__target);
	}
	vala_code_node_accept_children ((ValaCodeNode*) ns, (ValaCodeVisitor*) self);
}

static void
vls_symbol_visitor_real_visit_null_literal (ValaCodeVisitor* base,
                                            ValaNullLiteral* lit)
{
	VlsSymbolVisitor * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsSymbolVisitor*) base;
	g_return_if_fail (lit != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) lit)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) lit);
	if (vls_symbol_visitor_filter (self, (ValaCodeNode*) lit)) {
		VlsSymbolVisitorFunc _tmp2_;
		gpointer _tmp2__target;
		_tmp2_ = self->priv->func;
		_tmp2__target = self->priv->func_target;
		_tmp2_ ((ValaCodeNode*) lit, _tmp2__target);
	}
	vala_code_node_accept_children ((ValaCodeNode*) lit, (ValaCodeVisitor*) self);
}

static void
vls_symbol_visitor_real_visit_object_creation_expression (ValaCodeVisitor* base,
                                                          ValaObjectCreationExpression* expr)
{
	VlsSymbolVisitor * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsSymbolVisitor*) base;
	g_return_if_fail (expr != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) expr)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) expr);
	if (vls_symbol_visitor_filter (self, (ValaCodeNode*) expr)) {
		VlsSymbolVisitorFunc _tmp2_;
		gpointer _tmp2__target;
		_tmp2_ = self->priv->func;
		_tmp2__target = self->priv->func_target;
		_tmp2_ ((ValaCodeNode*) expr, _tmp2__target);
	}
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}

static void
vls_symbol_visitor_real_visit_pointer_indirection (ValaCodeVisitor* base,
                                                   ValaPointerIndirection* expr)
{
	VlsSymbolVisitor * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsSymbolVisitor*) base;
	g_return_if_fail (expr != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) expr)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) expr);
	if (vls_symbol_visitor_filter (self, (ValaCodeNode*) expr)) {
		VlsSymbolVisitorFunc _tmp2_;
		gpointer _tmp2__target;
		_tmp2_ = self->priv->func;
		_tmp2__target = self->priv->func_target;
		_tmp2_ ((ValaCodeNode*) expr, _tmp2__target);
	}
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}

static void
vls_symbol_visitor_real_visit_postfix_expression (ValaCodeVisitor* base,
                                                  ValaPostfixExpression* expr)
{
	VlsSymbolVisitor * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsSymbolVisitor*) base;
	g_return_if_fail (expr != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) expr)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) expr);
	if (vls_symbol_visitor_filter (self, (ValaCodeNode*) expr)) {
		VlsSymbolVisitorFunc _tmp2_;
		gpointer _tmp2__target;
		_tmp2_ = self->priv->func;
		_tmp2__target = self->priv->func_target;
		_tmp2_ ((ValaCodeNode*) expr, _tmp2__target);
	}
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}

static void
vls_symbol_visitor_real_visit_property (ValaCodeVisitor* base,
                                        ValaProperty* prop)
{
	VlsSymbolVisitor * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	gboolean _tmp2_ = FALSE;
	self = (VlsSymbolVisitor*) base;
	g_return_if_fail (prop != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) prop)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) prop);
	if (vls_symbol_visitor_filter (self, (ValaCodeNode*) prop)) {
		_tmp2_ = self->priv->include_declaration;
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		VlsSymbolVisitorFunc _tmp3_;
		gpointer _tmp3__target;
		_tmp3_ = self->priv->func;
		_tmp3__target = self->priv->func_target;
		_tmp3_ ((ValaCodeNode*) prop, _tmp3__target);
	}
	vala_code_node_accept_children ((ValaCodeNode*) prop, (ValaCodeVisitor*) self);
}

static void
vls_symbol_visitor_real_visit_property_accessor (ValaCodeVisitor* base,
                                                 ValaPropertyAccessor* acc)
{
	VlsSymbolVisitor * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	gboolean _tmp2_ = FALSE;
	self = (VlsSymbolVisitor*) base;
	g_return_if_fail (acc != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) acc)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) acc);
	if (vls_symbol_visitor_filter (self, (ValaCodeNode*) acc)) {
		_tmp2_ = self->priv->include_declaration;
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		VlsSymbolVisitorFunc _tmp3_;
		gpointer _tmp3__target;
		_tmp3_ = self->priv->func;
		_tmp3__target = self->priv->func_target;
		_tmp3_ ((ValaCodeNode*) acc, _tmp3__target);
	}
	vala_code_node_accept_children ((ValaCodeNode*) acc, (ValaCodeVisitor*) self);
}

static void
vls_symbol_visitor_real_visit_real_literal (ValaCodeVisitor* base,
                                            ValaRealLiteral* lit)
{
	VlsSymbolVisitor * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsSymbolVisitor*) base;
	g_return_if_fail (lit != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) lit)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) lit);
	if (vls_symbol_visitor_filter (self, (ValaCodeNode*) lit)) {
		VlsSymbolVisitorFunc _tmp2_;
		gpointer _tmp2__target;
		_tmp2_ = self->priv->func;
		_tmp2__target = self->priv->func_target;
		_tmp2_ ((ValaCodeNode*) lit, _tmp2__target);
	}
	vala_code_node_accept_children ((ValaCodeNode*) lit, (ValaCodeVisitor*) self);
}

static void
vls_symbol_visitor_real_visit_reference_transfer_expression (ValaCodeVisitor* base,
                                                             ValaReferenceTransferExpression* expr)
{
	VlsSymbolVisitor * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsSymbolVisitor*) base;
	g_return_if_fail (expr != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) expr)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) expr);
	if (vls_symbol_visitor_filter (self, (ValaCodeNode*) expr)) {
		VlsSymbolVisitorFunc _tmp2_;
		gpointer _tmp2__target;
		_tmp2_ = self->priv->func;
		_tmp2__target = self->priv->func_target;
		_tmp2_ ((ValaCodeNode*) expr, _tmp2__target);
	}
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}

static void
vls_symbol_visitor_real_visit_regex_literal (ValaCodeVisitor* base,
                                             ValaRegexLiteral* lit)
{
	VlsSymbolVisitor * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsSymbolVisitor*) base;
	g_return_if_fail (lit != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) lit)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) lit);
	if (vls_symbol_visitor_filter (self, (ValaCodeNode*) lit)) {
		VlsSymbolVisitorFunc _tmp2_;
		gpointer _tmp2__target;
		_tmp2_ = self->priv->func;
		_tmp2__target = self->priv->func_target;
		_tmp2_ ((ValaCodeNode*) lit, _tmp2__target);
	}
	vala_code_node_accept_children ((ValaCodeNode*) lit, (ValaCodeVisitor*) self);
}

static void
vls_symbol_visitor_real_visit_return_statement (ValaCodeVisitor* base,
                                                ValaReturnStatement* stmt)
{
	VlsSymbolVisitor * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsSymbolVisitor*) base;
	g_return_if_fail (stmt != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) stmt)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) stmt);
	if (vls_symbol_visitor_filter (self, (ValaCodeNode*) stmt)) {
		VlsSymbolVisitorFunc _tmp2_;
		gpointer _tmp2__target;
		_tmp2_ = self->priv->func;
		_tmp2__target = self->priv->func_target;
		_tmp2_ ((ValaCodeNode*) stmt, _tmp2__target);
	}
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}

static void
vls_symbol_visitor_real_visit_signal (ValaCodeVisitor* base,
                                      ValaSignal* sig)
{
	VlsSymbolVisitor * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	gboolean _tmp2_ = FALSE;
	self = (VlsSymbolVisitor*) base;
	g_return_if_fail (sig != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) sig)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) sig);
	if (vls_symbol_visitor_filter (self, (ValaCodeNode*) sig)) {
		_tmp2_ = self->priv->include_declaration;
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		VlsSymbolVisitorFunc _tmp3_;
		gpointer _tmp3__target;
		_tmp3_ = self->priv->func;
		_tmp3__target = self->priv->func_target;
		_tmp3_ ((ValaCodeNode*) sig, _tmp3__target);
	}
	vala_code_node_accept_children ((ValaCodeNode*) sig, (ValaCodeVisitor*) self);
}

static void
vls_symbol_visitor_real_visit_sizeof_expression (ValaCodeVisitor* base,
                                                 ValaSizeofExpression* expr)
{
	VlsSymbolVisitor * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsSymbolVisitor*) base;
	g_return_if_fail (expr != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) expr)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) expr);
	if (vls_symbol_visitor_filter (self, (ValaCodeNode*) expr)) {
		VlsSymbolVisitorFunc _tmp2_;
		gpointer _tmp2__target;
		_tmp2_ = self->priv->func;
		_tmp2__target = self->priv->func_target;
		_tmp2_ ((ValaCodeNode*) expr, _tmp2__target);
	}
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}

static void
vls_symbol_visitor_real_visit_slice_expression (ValaCodeVisitor* base,
                                                ValaSliceExpression* expr)
{
	VlsSymbolVisitor * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsSymbolVisitor*) base;
	g_return_if_fail (expr != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) expr)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) expr);
	if (vls_symbol_visitor_filter (self, (ValaCodeNode*) expr)) {
		VlsSymbolVisitorFunc _tmp2_;
		gpointer _tmp2__target;
		_tmp2_ = self->priv->func;
		_tmp2__target = self->priv->func_target;
		_tmp2_ ((ValaCodeNode*) expr, _tmp2__target);
	}
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}

static void
vls_symbol_visitor_real_visit_string_literal (ValaCodeVisitor* base,
                                              ValaStringLiteral* lit)
{
	VlsSymbolVisitor * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsSymbolVisitor*) base;
	g_return_if_fail (lit != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) lit)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) lit);
	if (vls_symbol_visitor_filter (self, (ValaCodeNode*) lit)) {
		VlsSymbolVisitorFunc _tmp2_;
		gpointer _tmp2__target;
		_tmp2_ = self->priv->func;
		_tmp2__target = self->priv->func_target;
		_tmp2_ ((ValaCodeNode*) lit, _tmp2__target);
	}
	vala_code_node_accept_children ((ValaCodeNode*) lit, (ValaCodeVisitor*) self);
}

static void
vls_symbol_visitor_real_visit_struct (ValaCodeVisitor* base,
                                      ValaStruct* st)
{
	VlsSymbolVisitor * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	gboolean _tmp2_ = FALSE;
	self = (VlsSymbolVisitor*) base;
	g_return_if_fail (st != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) st)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) st);
	if (vls_symbol_visitor_filter (self, (ValaCodeNode*) st)) {
		_tmp2_ = self->priv->include_declaration;
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		VlsSymbolVisitorFunc _tmp3_;
		gpointer _tmp3__target;
		_tmp3_ = self->priv->func;
		_tmp3__target = self->priv->func_target;
		_tmp3_ ((ValaCodeNode*) st, _tmp3__target);
	}
	vala_code_node_accept_children ((ValaCodeNode*) st, (ValaCodeVisitor*) self);
}

static void
vls_symbol_visitor_real_visit_switch_label (ValaCodeVisitor* base,
                                            ValaSwitchLabel* label)
{
	VlsSymbolVisitor * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsSymbolVisitor*) base;
	g_return_if_fail (label != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) label)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) label);
	if (vls_symbol_visitor_filter (self, (ValaCodeNode*) label)) {
		VlsSymbolVisitorFunc _tmp2_;
		gpointer _tmp2__target;
		_tmp2_ = self->priv->func;
		_tmp2__target = self->priv->func_target;
		_tmp2_ ((ValaCodeNode*) label, _tmp2__target);
	}
	vala_code_node_accept_children ((ValaCodeNode*) label, (ValaCodeVisitor*) self);
}

static void
vls_symbol_visitor_real_visit_switch_section (ValaCodeVisitor* base,
                                              ValaSwitchSection* section)
{
	VlsSymbolVisitor * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsSymbolVisitor*) base;
	g_return_if_fail (section != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) section)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) section);
	if (vls_symbol_visitor_filter (self, (ValaCodeNode*) section)) {
		VlsSymbolVisitorFunc _tmp2_;
		gpointer _tmp2__target;
		_tmp2_ = self->priv->func;
		_tmp2__target = self->priv->func_target;
		_tmp2_ ((ValaCodeNode*) section, _tmp2__target);
	}
	vala_code_node_accept_children ((ValaCodeNode*) section, (ValaCodeVisitor*) self);
}

static void
vls_symbol_visitor_real_visit_switch_statement (ValaCodeVisitor* base,
                                                ValaSwitchStatement* stmt)
{
	VlsSymbolVisitor * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsSymbolVisitor*) base;
	g_return_if_fail (stmt != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) stmt)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) stmt);
	if (vls_symbol_visitor_filter (self, (ValaCodeNode*) stmt)) {
		VlsSymbolVisitorFunc _tmp2_;
		gpointer _tmp2__target;
		_tmp2_ = self->priv->func;
		_tmp2__target = self->priv->func_target;
		_tmp2_ ((ValaCodeNode*) stmt, _tmp2__target);
	}
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}

static void
vls_symbol_visitor_real_visit_template (ValaCodeVisitor* base,
                                        ValaTemplate* tmpl)
{
	VlsSymbolVisitor * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsSymbolVisitor*) base;
	g_return_if_fail (tmpl != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) tmpl)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) tmpl);
	if (vls_symbol_visitor_filter (self, (ValaCodeNode*) tmpl)) {
		VlsSymbolVisitorFunc _tmp2_;
		gpointer _tmp2__target;
		_tmp2_ = self->priv->func;
		_tmp2__target = self->priv->func_target;
		_tmp2_ ((ValaCodeNode*) tmpl, _tmp2__target);
	}
	vala_code_node_accept_children ((ValaCodeNode*) tmpl, (ValaCodeVisitor*) self);
}

static void
vls_symbol_visitor_real_visit_throw_statement (ValaCodeVisitor* base,
                                               ValaThrowStatement* stmt)
{
	VlsSymbolVisitor * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsSymbolVisitor*) base;
	g_return_if_fail (stmt != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) stmt)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) stmt);
	if (vls_symbol_visitor_filter (self, (ValaCodeNode*) stmt)) {
		VlsSymbolVisitorFunc _tmp2_;
		gpointer _tmp2__target;
		_tmp2_ = self->priv->func;
		_tmp2__target = self->priv->func_target;
		_tmp2_ ((ValaCodeNode*) stmt, _tmp2__target);
	}
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}

static void
vls_symbol_visitor_real_visit_try_statement (ValaCodeVisitor* base,
                                             ValaTryStatement* stmt)
{
	VlsSymbolVisitor * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsSymbolVisitor*) base;
	g_return_if_fail (stmt != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) stmt)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) stmt);
	if (vls_symbol_visitor_filter (self, (ValaCodeNode*) stmt)) {
		VlsSymbolVisitorFunc _tmp2_;
		gpointer _tmp2__target;
		_tmp2_ = self->priv->func;
		_tmp2__target = self->priv->func_target;
		_tmp2_ ((ValaCodeNode*) stmt, _tmp2__target);
	}
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}

static void
vls_symbol_visitor_real_visit_type_check (ValaCodeVisitor* base,
                                          ValaTypeCheck* expr)
{
	VlsSymbolVisitor * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsSymbolVisitor*) base;
	g_return_if_fail (expr != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) expr)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) expr);
	if (vls_symbol_visitor_filter (self, (ValaCodeNode*) expr)) {
		VlsSymbolVisitorFunc _tmp2_;
		gpointer _tmp2__target;
		_tmp2_ = self->priv->func;
		_tmp2__target = self->priv->func_target;
		_tmp2_ ((ValaCodeNode*) expr, _tmp2__target);
	}
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}

static void
vls_symbol_visitor_real_visit_type_parameter (ValaCodeVisitor* base,
                                              ValaTypeParameter* p)
{
	VlsSymbolVisitor * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsSymbolVisitor*) base;
	g_return_if_fail (p != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) p)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) p);
	if (vls_symbol_visitor_filter (self, (ValaCodeNode*) p)) {
		VlsSymbolVisitorFunc _tmp2_;
		gpointer _tmp2__target;
		_tmp2_ = self->priv->func;
		_tmp2__target = self->priv->func_target;
		_tmp2_ ((ValaCodeNode*) p, _tmp2__target);
	}
	vala_code_node_accept_children ((ValaCodeNode*) p, (ValaCodeVisitor*) self);
}

static void
vls_symbol_visitor_real_visit_typeof_expression (ValaCodeVisitor* base,
                                                 ValaTypeofExpression* expr)
{
	VlsSymbolVisitor * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsSymbolVisitor*) base;
	g_return_if_fail (expr != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) expr)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) expr);
	if (vls_symbol_visitor_filter (self, (ValaCodeNode*) expr)) {
		VlsSymbolVisitorFunc _tmp2_;
		gpointer _tmp2__target;
		_tmp2_ = self->priv->func;
		_tmp2__target = self->priv->func_target;
		_tmp2_ ((ValaCodeNode*) expr, _tmp2__target);
	}
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}

static void
vls_symbol_visitor_real_visit_unary_expression (ValaCodeVisitor* base,
                                                ValaUnaryExpression* expr)
{
	VlsSymbolVisitor * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsSymbolVisitor*) base;
	g_return_if_fail (expr != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) expr)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) expr);
	if (vls_symbol_visitor_filter (self, (ValaCodeNode*) expr)) {
		VlsSymbolVisitorFunc _tmp2_;
		gpointer _tmp2__target;
		_tmp2_ = self->priv->func;
		_tmp2__target = self->priv->func_target;
		_tmp2_ ((ValaCodeNode*) expr, _tmp2__target);
	}
	vala_code_node_accept_children ((ValaCodeNode*) expr, (ValaCodeVisitor*) self);
}

static void
vls_symbol_visitor_real_visit_unlock_statement (ValaCodeVisitor* base,
                                                ValaUnlockStatement* stmt)
{
	VlsSymbolVisitor * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsSymbolVisitor*) base;
	g_return_if_fail (stmt != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) stmt)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) stmt);
	if (vls_symbol_visitor_filter (self, (ValaCodeNode*) stmt)) {
		VlsSymbolVisitorFunc _tmp2_;
		gpointer _tmp2__target;
		_tmp2_ = self->priv->func;
		_tmp2__target = self->priv->func_target;
		_tmp2_ ((ValaCodeNode*) stmt, _tmp2__target);
	}
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}

static void
vls_symbol_visitor_real_visit_using_directive (ValaCodeVisitor* base,
                                               ValaUsingDirective* ud)
{
	VlsSymbolVisitor * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsSymbolVisitor*) base;
	g_return_if_fail (ud != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) ud)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) ud);
	if (vls_symbol_visitor_filter (self, (ValaCodeNode*) ud)) {
		VlsSymbolVisitorFunc _tmp2_;
		gpointer _tmp2__target;
		_tmp2_ = self->priv->func;
		_tmp2__target = self->priv->func_target;
		_tmp2_ ((ValaCodeNode*) ud, _tmp2__target);
	}
	vala_code_node_accept_children ((ValaCodeNode*) ud, (ValaCodeVisitor*) self);
}

static void
vls_symbol_visitor_real_visit_yield_statement (ValaCodeVisitor* base,
                                               ValaYieldStatement* stmt)
{
	VlsSymbolVisitor * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsSymbolVisitor*) base;
	g_return_if_fail (stmt != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) stmt)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) stmt);
	if (vls_symbol_visitor_filter (self, (ValaCodeNode*) stmt)) {
		VlsSymbolVisitorFunc _tmp2_;
		gpointer _tmp2__target;
		_tmp2_ = self->priv->func;
		_tmp2__target = self->priv->func_target;
		_tmp2_ ((ValaCodeNode*) stmt, _tmp2__target);
	}
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}

static void
vls_symbol_visitor_real_visit_with_statement (ValaCodeVisitor* base,
                                              ValaWithStatement* stmt)
{
	VlsSymbolVisitor * self;
	GeeHashSet* _tmp0_;
	GeeHashSet* _tmp1_;
	self = (VlsSymbolVisitor*) base;
	g_return_if_fail (stmt != NULL);
	_tmp0_ = self->priv->seen;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (ValaCodeNode*) stmt)) {
		return;
	}
	_tmp1_ = self->priv->seen;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, (ValaCodeNode*) stmt);
	if (vls_symbol_visitor_filter (self, (ValaCodeNode*) stmt)) {
		VlsSymbolVisitorFunc _tmp2_;
		gpointer _tmp2__target;
		_tmp2_ = self->priv->func;
		_tmp2__target = self->priv->func_target;
		_tmp2_ ((ValaCodeNode*) stmt, _tmp2__target);
	}
	vala_code_node_accept_children ((ValaCodeNode*) stmt, (ValaCodeVisitor*) self);
}

static void
vls_symbol_visitor_class_init (VlsSymbolVisitorClass * klass,
                               gpointer klass_data)
{
	vls_symbol_visitor_parent_class = g_type_class_peek_parent (klass);
	((ValaCodeVisitorClass *) klass)->finalize = vls_symbol_visitor_finalize;
	g_type_class_adjust_private_offset (klass, &VlsSymbolVisitor_private_offset);
	((ValaCodeVisitorClass *) klass)->visit_source_file = (void (*) (ValaCodeVisitor*, ValaSourceFile*)) vls_symbol_visitor_real_visit_source_file;
	((ValaCodeVisitorClass *) klass)->visit_addressof_expression = (void (*) (ValaCodeVisitor*, ValaAddressofExpression*)) vls_symbol_visitor_real_visit_addressof_expression;
	((ValaCodeVisitorClass *) klass)->visit_array_creation_expression = (void (*) (ValaCodeVisitor*, ValaArrayCreationExpression*)) vls_symbol_visitor_real_visit_array_creation_expression;
	((ValaCodeVisitorClass *) klass)->visit_assignment = (void (*) (ValaCodeVisitor*, ValaAssignment*)) vls_symbol_visitor_real_visit_assignment;
	((ValaCodeVisitorClass *) klass)->visit_base_access = (void (*) (ValaCodeVisitor*, ValaBaseAccess*)) vls_symbol_visitor_real_visit_base_access;
	((ValaCodeVisitorClass *) klass)->visit_binary_expression = (void (*) (ValaCodeVisitor*, ValaBinaryExpression*)) vls_symbol_visitor_real_visit_binary_expression;
	((ValaCodeVisitorClass *) klass)->visit_block = (void (*) (ValaCodeVisitor*, ValaBlock*)) vls_symbol_visitor_real_visit_block;
	((ValaCodeVisitorClass *) klass)->visit_boolean_literal = (void (*) (ValaCodeVisitor*, ValaBooleanLiteral*)) vls_symbol_visitor_real_visit_boolean_literal;
	((ValaCodeVisitorClass *) klass)->visit_break_statement = (void (*) (ValaCodeVisitor*, ValaBreakStatement*)) vls_symbol_visitor_real_visit_break_statement;
	((ValaCodeVisitorClass *) klass)->visit_cast_expression = (void (*) (ValaCodeVisitor*, ValaCastExpression*)) vls_symbol_visitor_real_visit_cast_expression;
	((ValaCodeVisitorClass *) klass)->visit_catch_clause = (void (*) (ValaCodeVisitor*, ValaCatchClause*)) vls_symbol_visitor_real_visit_catch_clause;
	((ValaCodeVisitorClass *) klass)->visit_character_literal = (void (*) (ValaCodeVisitor*, ValaCharacterLiteral*)) vls_symbol_visitor_real_visit_character_literal;
	((ValaCodeVisitorClass *) klass)->visit_class = (void (*) (ValaCodeVisitor*, ValaClass*)) vls_symbol_visitor_real_visit_class;
	((ValaCodeVisitorClass *) klass)->visit_conditional_expression = (void (*) (ValaCodeVisitor*, ValaConditionalExpression*)) vls_symbol_visitor_real_visit_conditional_expression;
	((ValaCodeVisitorClass *) klass)->visit_constant = (void (*) (ValaCodeVisitor*, ValaConstant*)) vls_symbol_visitor_real_visit_constant;
	((ValaCodeVisitorClass *) klass)->visit_constructor = (void (*) (ValaCodeVisitor*, ValaConstructor*)) vls_symbol_visitor_real_visit_constructor;
	((ValaCodeVisitorClass *) klass)->visit_continue_statement = (void (*) (ValaCodeVisitor*, ValaContinueStatement*)) vls_symbol_visitor_real_visit_continue_statement;
	((ValaCodeVisitorClass *) klass)->visit_creation_method = (void (*) (ValaCodeVisitor*, ValaCreationMethod*)) vls_symbol_visitor_real_visit_creation_method;
	((ValaCodeVisitorClass *) klass)->visit_data_type = (void (*) (ValaCodeVisitor*, ValaDataType*)) vls_symbol_visitor_real_visit_data_type;
	((ValaCodeVisitorClass *) klass)->visit_declaration_statement = (void (*) (ValaCodeVisitor*, ValaDeclarationStatement*)) vls_symbol_visitor_real_visit_declaration_statement;
	((ValaCodeVisitorClass *) klass)->visit_delegate = (void (*) (ValaCodeVisitor*, ValaDelegate*)) vls_symbol_visitor_real_visit_delegate;
	((ValaCodeVisitorClass *) klass)->visit_delete_statement = (void (*) (ValaCodeVisitor*, ValaDeleteStatement*)) vls_symbol_visitor_real_visit_delete_statement;
	((ValaCodeVisitorClass *) klass)->visit_destructor = (void (*) (ValaCodeVisitor*, ValaDestructor*)) vls_symbol_visitor_real_visit_destructor;
	((ValaCodeVisitorClass *) klass)->visit_do_statement = (void (*) (ValaCodeVisitor*, ValaDoStatement*)) vls_symbol_visitor_real_visit_do_statement;
	((ValaCodeVisitorClass *) klass)->visit_element_access = (void (*) (ValaCodeVisitor*, ValaElementAccess*)) vls_symbol_visitor_real_visit_element_access;
	((ValaCodeVisitorClass *) klass)->visit_empty_statement = (void (*) (ValaCodeVisitor*, ValaEmptyStatement*)) vls_symbol_visitor_real_visit_empty_statement;
	((ValaCodeVisitorClass *) klass)->visit_enum = (void (*) (ValaCodeVisitor*, ValaEnum*)) vls_symbol_visitor_real_visit_enum;
	((ValaCodeVisitorClass *) klass)->visit_enum_value = (void (*) (ValaCodeVisitor*, ValaEnumValue*)) vls_symbol_visitor_real_visit_enum_value;
	((ValaCodeVisitorClass *) klass)->visit_error_code = (void (*) (ValaCodeVisitor*, ValaErrorCode*)) vls_symbol_visitor_real_visit_error_code;
	((ValaCodeVisitorClass *) klass)->visit_error_domain = (void (*) (ValaCodeVisitor*, ValaErrorDomain*)) vls_symbol_visitor_real_visit_error_domain;
	((ValaCodeVisitorClass *) klass)->visit_expression = (void (*) (ValaCodeVisitor*, ValaExpression*)) vls_symbol_visitor_real_visit_expression;
	((ValaCodeVisitorClass *) klass)->visit_expression_statement = (void (*) (ValaCodeVisitor*, ValaExpressionStatement*)) vls_symbol_visitor_real_visit_expression_statement;
	((ValaCodeVisitorClass *) klass)->visit_field = (void (*) (ValaCodeVisitor*, ValaField*)) vls_symbol_visitor_real_visit_field;
	((ValaCodeVisitorClass *) klass)->visit_for_statement = (void (*) (ValaCodeVisitor*, ValaForStatement*)) vls_symbol_visitor_real_visit_for_statement;
	((ValaCodeVisitorClass *) klass)->visit_foreach_statement = (void (*) (ValaCodeVisitor*, ValaForeachStatement*)) vls_symbol_visitor_real_visit_foreach_statement;
	((ValaCodeVisitorClass *) klass)->visit_formal_parameter = (void (*) (ValaCodeVisitor*, ValaParameter*)) vls_symbol_visitor_real_visit_formal_parameter;
	((ValaCodeVisitorClass *) klass)->visit_if_statement = (void (*) (ValaCodeVisitor*, ValaIfStatement*)) vls_symbol_visitor_real_visit_if_statement;
	((ValaCodeVisitorClass *) klass)->visit_initializer_list = (void (*) (ValaCodeVisitor*, ValaInitializerList*)) vls_symbol_visitor_real_visit_initializer_list;
	((ValaCodeVisitorClass *) klass)->visit_integer_literal = (void (*) (ValaCodeVisitor*, ValaIntegerLiteral*)) vls_symbol_visitor_real_visit_integer_literal;
	((ValaCodeVisitorClass *) klass)->visit_interface = (void (*) (ValaCodeVisitor*, ValaInterface*)) vls_symbol_visitor_real_visit_interface;
	((ValaCodeVisitorClass *) klass)->visit_lambda_expression = (void (*) (ValaCodeVisitor*, ValaLambdaExpression*)) vls_symbol_visitor_real_visit_lambda_expression;
	((ValaCodeVisitorClass *) klass)->visit_local_variable = (void (*) (ValaCodeVisitor*, ValaLocalVariable*)) vls_symbol_visitor_real_visit_local_variable;
	((ValaCodeVisitorClass *) klass)->visit_lock_statement = (void (*) (ValaCodeVisitor*, ValaLockStatement*)) vls_symbol_visitor_real_visit_lock_statement;
	((ValaCodeVisitorClass *) klass)->visit_loop_statement = (void (*) (ValaCodeVisitor*, ValaLoopStatement*)) vls_symbol_visitor_real_visit_loop_statement;
	((ValaCodeVisitorClass *) klass)->visit_member_access = (void (*) (ValaCodeVisitor*, ValaMemberAccess*)) vls_symbol_visitor_real_visit_member_access;
	((ValaCodeVisitorClass *) klass)->visit_method = (void (*) (ValaCodeVisitor*, ValaMethod*)) vls_symbol_visitor_real_visit_method;
	((ValaCodeVisitorClass *) klass)->visit_method_call = (void (*) (ValaCodeVisitor*, ValaMethodCall*)) vls_symbol_visitor_real_visit_method_call;
	((ValaCodeVisitorClass *) klass)->visit_namespace = (void (*) (ValaCodeVisitor*, ValaNamespace*)) vls_symbol_visitor_real_visit_namespace;
	((ValaCodeVisitorClass *) klass)->visit_null_literal = (void (*) (ValaCodeVisitor*, ValaNullLiteral*)) vls_symbol_visitor_real_visit_null_literal;
	((ValaCodeVisitorClass *) klass)->visit_object_creation_expression = (void (*) (ValaCodeVisitor*, ValaObjectCreationExpression*)) vls_symbol_visitor_real_visit_object_creation_expression;
	((ValaCodeVisitorClass *) klass)->visit_pointer_indirection = (void (*) (ValaCodeVisitor*, ValaPointerIndirection*)) vls_symbol_visitor_real_visit_pointer_indirection;
	((ValaCodeVisitorClass *) klass)->visit_postfix_expression = (void (*) (ValaCodeVisitor*, ValaPostfixExpression*)) vls_symbol_visitor_real_visit_postfix_expression;
	((ValaCodeVisitorClass *) klass)->visit_property = (void (*) (ValaCodeVisitor*, ValaProperty*)) vls_symbol_visitor_real_visit_property;
	((ValaCodeVisitorClass *) klass)->visit_property_accessor = (void (*) (ValaCodeVisitor*, ValaPropertyAccessor*)) vls_symbol_visitor_real_visit_property_accessor;
	((ValaCodeVisitorClass *) klass)->visit_real_literal = (void (*) (ValaCodeVisitor*, ValaRealLiteral*)) vls_symbol_visitor_real_visit_real_literal;
	((ValaCodeVisitorClass *) klass)->visit_reference_transfer_expression = (void (*) (ValaCodeVisitor*, ValaReferenceTransferExpression*)) vls_symbol_visitor_real_visit_reference_transfer_expression;
	((ValaCodeVisitorClass *) klass)->visit_regex_literal = (void (*) (ValaCodeVisitor*, ValaRegexLiteral*)) vls_symbol_visitor_real_visit_regex_literal;
	((ValaCodeVisitorClass *) klass)->visit_return_statement = (void (*) (ValaCodeVisitor*, ValaReturnStatement*)) vls_symbol_visitor_real_visit_return_statement;
	((ValaCodeVisitorClass *) klass)->visit_signal = (void (*) (ValaCodeVisitor*, ValaSignal*)) vls_symbol_visitor_real_visit_signal;
	((ValaCodeVisitorClass *) klass)->visit_sizeof_expression = (void (*) (ValaCodeVisitor*, ValaSizeofExpression*)) vls_symbol_visitor_real_visit_sizeof_expression;
	((ValaCodeVisitorClass *) klass)->visit_slice_expression = (void (*) (ValaCodeVisitor*, ValaSliceExpression*)) vls_symbol_visitor_real_visit_slice_expression;
	((ValaCodeVisitorClass *) klass)->visit_string_literal = (void (*) (ValaCodeVisitor*, ValaStringLiteral*)) vls_symbol_visitor_real_visit_string_literal;
	((ValaCodeVisitorClass *) klass)->visit_struct = (void (*) (ValaCodeVisitor*, ValaStruct*)) vls_symbol_visitor_real_visit_struct;
	((ValaCodeVisitorClass *) klass)->visit_switch_label = (void (*) (ValaCodeVisitor*, ValaSwitchLabel*)) vls_symbol_visitor_real_visit_switch_label;
	((ValaCodeVisitorClass *) klass)->visit_switch_section = (void (*) (ValaCodeVisitor*, ValaSwitchSection*)) vls_symbol_visitor_real_visit_switch_section;
	((ValaCodeVisitorClass *) klass)->visit_switch_statement = (void (*) (ValaCodeVisitor*, ValaSwitchStatement*)) vls_symbol_visitor_real_visit_switch_statement;
	((ValaCodeVisitorClass *) klass)->visit_template = (void (*) (ValaCodeVisitor*, ValaTemplate*)) vls_symbol_visitor_real_visit_template;
	((ValaCodeVisitorClass *) klass)->visit_throw_statement = (void (*) (ValaCodeVisitor*, ValaThrowStatement*)) vls_symbol_visitor_real_visit_throw_statement;
	((ValaCodeVisitorClass *) klass)->visit_try_statement = (void (*) (ValaCodeVisitor*, ValaTryStatement*)) vls_symbol_visitor_real_visit_try_statement;
	((ValaCodeVisitorClass *) klass)->visit_type_check = (void (*) (ValaCodeVisitor*, ValaTypeCheck*)) vls_symbol_visitor_real_visit_type_check;
	((ValaCodeVisitorClass *) klass)->visit_type_parameter = (void (*) (ValaCodeVisitor*, ValaTypeParameter*)) vls_symbol_visitor_real_visit_type_parameter;
	((ValaCodeVisitorClass *) klass)->visit_typeof_expression = (void (*) (ValaCodeVisitor*, ValaTypeofExpression*)) vls_symbol_visitor_real_visit_typeof_expression;
	((ValaCodeVisitorClass *) klass)->visit_unary_expression = (void (*) (ValaCodeVisitor*, ValaUnaryExpression*)) vls_symbol_visitor_real_visit_unary_expression;
	((ValaCodeVisitorClass *) klass)->visit_unlock_statement = (void (*) (ValaCodeVisitor*, ValaUnlockStatement*)) vls_symbol_visitor_real_visit_unlock_statement;
	((ValaCodeVisitorClass *) klass)->visit_using_directive = (void (*) (ValaCodeVisitor*, ValaUsingDirective*)) vls_symbol_visitor_real_visit_using_directive;
	((ValaCodeVisitorClass *) klass)->visit_yield_statement = (void (*) (ValaCodeVisitor*, ValaYieldStatement*)) vls_symbol_visitor_real_visit_yield_statement;
	((ValaCodeVisitorClass *) klass)->visit_with_statement = (void (*) (ValaCodeVisitor*, ValaWithStatement*)) vls_symbol_visitor_real_visit_with_statement;
}

static void
vls_symbol_visitor_instance_init (VlsSymbolVisitor * self,
                                  gpointer klass)
{
	self->priv = vls_symbol_visitor_get_instance_private (self);
}

static void
vls_symbol_visitor_finalize (ValaCodeVisitor * obj)
{
	VlsSymbolVisitor * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VLS_TYPE_SYMBOL_VISITOR, VlsSymbolVisitor);
	_vala_source_file_unref0 (self->priv->file);
	_g_object_unref0 (self->priv->seen);
	(self->priv->func_target_destroy_notify == NULL) ? NULL : (self->priv->func_target_destroy_notify (self->priv->func_target), NULL);
	self->priv->func = NULL;
	self->priv->func_target = NULL;
	self->priv->func_target_destroy_notify = NULL;
	VALA_CODE_VISITOR_CLASS (vls_symbol_visitor_parent_class)->finalize (obj);
}

/**
 * Useful for when we need to iterate over the nodes in a document
 * in a generic fashion, in search of a code node that matches a given
 * symbol in some way, or that we can perform an operation on, given
 * knowledge of a symbol to compare, custom user data, and the code
 * node we are presently exploring.
 */
 G_GNUC_NO_INLINE static GType
vls_symbol_visitor_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (VlsSymbolVisitorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vls_symbol_visitor_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (VlsSymbolVisitor), 0, (GInstanceInitFunc) vls_symbol_visitor_instance_init, NULL };
	GType vls_symbol_visitor_type_id;
	vls_symbol_visitor_type_id = g_type_register_static (VALA_TYPE_CODE_VISITOR, "VlsSymbolVisitor", &g_define_type_info, 0);
	VlsSymbolVisitor_private_offset = g_type_add_instance_private (vls_symbol_visitor_type_id, sizeof (VlsSymbolVisitorPrivate));
	return vls_symbol_visitor_type_id;
}

GType
vls_symbol_visitor_get_type (void)
{
	static gsize vls_symbol_visitor_type_id__once = 0;
	if (g_once_init_enter (&vls_symbol_visitor_type_id__once)) {
		GType vls_symbol_visitor_type_id;
		vls_symbol_visitor_type_id = vls_symbol_visitor_get_type_once ();
		g_once_init_leave (&vls_symbol_visitor_type_id__once, vls_symbol_visitor_type_id);
	}
	return vls_symbol_visitor_type_id__once;
}

