/* textdocument.c generated by valac 0.56.13, the Vala compiler
 * generated from textdocument.vala, do not modify */

/* textdocument.vala
 *
 * Copyright 2020 Princeton Ferro <princetonferro@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <vala.h>
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <glib/gstdio.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define VLS_TYPE_TEXT_DOCUMENT (vls_text_document_get_type ())
#define VLS_TEXT_DOCUMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VLS_TYPE_TEXT_DOCUMENT, VlsTextDocument))
#define VLS_TEXT_DOCUMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VLS_TYPE_TEXT_DOCUMENT, VlsTextDocumentClass))
#define VLS_IS_TEXT_DOCUMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VLS_TYPE_TEXT_DOCUMENT))
#define VLS_IS_TEXT_DOCUMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VLS_TYPE_TEXT_DOCUMENT))
#define VLS_TEXT_DOCUMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VLS_TYPE_TEXT_DOCUMENT, VlsTextDocumentClass))

typedef struct _VlsTextDocument VlsTextDocument;
typedef struct _VlsTextDocumentClass VlsTextDocumentClass;
typedef struct _VlsTextDocumentPrivate VlsTextDocumentPrivate;
#define _g_time_zone_unref0(var) ((var == NULL) ? NULL : (var = (g_time_zone_unref (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _vala_source_file_unref0(var) ((var == NULL) ? NULL : (var = (vala_source_file_unref (var), NULL)))

struct _VlsTextDocument {
	ValaSourceFile parent_instance;
	VlsTextDocumentPrivate * priv;
};

struct _VlsTextDocumentClass {
	ValaSourceFileClass parent_class;
};

struct _VlsTextDocumentPrivate {
	GDateTime* _last_updated;
	gint _version;
	gint _last_saved_version;
	gchar* _last_saved_content;
	gchar* _last_fresh_content;
};

static gint VlsTextDocument_private_offset;
static gpointer vls_text_document_parent_class = NULL;

VALA_EXTERN GType vls_text_document_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VlsTextDocument, vala_source_file_unref)
VALA_EXTERN VlsTextDocument* vls_text_document_new (ValaCodeContext* context,
                                        GFile* file,
                                        const gchar* content,
                                        gboolean cmdline,
                                        GError** error);
VALA_EXTERN VlsTextDocument* vls_text_document_construct (GType object_type,
                                              ValaCodeContext* context,
                                              GFile* file,
                                              const gchar* content,
                                              gboolean cmdline,
                                              GError** error);
VALA_EXTERN gchar* vls_util_realpath (const gchar* name,
                          const gchar* cwd);
VALA_EXTERN GDateTime* vls_text_document_get_last_updated (VlsTextDocument* self);
VALA_EXTERN void vls_text_document_set_last_updated (VlsTextDocument* self,
                                         GDateTime* value);
VALA_EXTERN gint vls_text_document_get_version (VlsTextDocument* self);
VALA_EXTERN void vls_text_document_set_version (VlsTextDocument* self,
                                    gint value);
VALA_EXTERN gint vls_text_document_get_last_saved_version (VlsTextDocument* self);
static void vls_text_document_set_last_saved_version (VlsTextDocument* self,
                                               gint value);
VALA_EXTERN const gchar* vls_text_document_get_last_saved_content (VlsTextDocument* self);
VALA_EXTERN void vls_text_document_set_last_saved_content (VlsTextDocument* self,
                                               const gchar* value);
VALA_EXTERN const gchar* vls_text_document_get_last_fresh_content (VlsTextDocument* self);
VALA_EXTERN void vls_text_document_set_last_fresh_content (VlsTextDocument* self,
                                               const gchar* value);
static void vls_text_document_finalize (ValaSourceFile * obj);
static GType vls_text_document_get_type_once (void);

static inline gpointer
vls_text_document_get_instance_private (VlsTextDocument* self)
{
	return G_STRUCT_MEMBER_P (self, VlsTextDocument_private_offset);
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self;
	return result;
}

VlsTextDocument*
vls_text_document_construct (GType object_type,
                             ValaCodeContext* context,
                             GFile* file,
                             const gchar* content,
                             gboolean cmdline,
                             GError** error)
{
	VlsTextDocument* self = NULL;
	gchar* cont = NULL;
	gchar* _tmp0_;
	gchar* uri = NULL;
	gchar* _tmp1_;
	gchar* path = NULL;
	gchar* _tmp2_;
	gchar* _tmp3_ = NULL;
	const gchar* _tmp4_;
	gchar* _tmp7_;
	gboolean _tmp8_ = FALSE;
	const gchar* _tmp9_;
	ValaSourceFileType ftype = 0;
	gboolean _tmp22_ = FALSE;
	const gchar* _tmp23_;
	const gchar* _tmp29_ = NULL;
	const gchar* _tmp30_;
	const gchar* _tmp32_;
	GError* _inner_error0_ = NULL;
	g_return_val_if_fail (context != NULL, NULL);
	g_return_val_if_fail (file != NULL, NULL);
	_tmp0_ = g_strdup (content);
	cont = _tmp0_;
	_tmp1_ = g_file_get_uri (file);
	uri = _tmp1_;
	_tmp2_ = g_file_get_path (file);
	path = _tmp2_;
	_tmp4_ = path;
	if (_tmp4_ != NULL) {
		const gchar* _tmp5_;
		gchar* _tmp6_;
		_tmp5_ = path;
		_tmp6_ = vls_util_realpath (_tmp5_, NULL);
		_g_free0 (_tmp3_);
		_tmp3_ = _tmp6_;
	} else {
		_g_free0 (_tmp3_);
		_tmp3_ = NULL;
	}
	_tmp7_ = g_strdup (_tmp3_);
	_g_free0 (path);
	path = _tmp7_;
	_tmp9_ = path;
	if (_tmp9_ != NULL) {
		const gchar* _tmp10_;
		_tmp10_ = cont;
		_tmp8_ = _tmp10_ == NULL;
	} else {
		_tmp8_ = FALSE;
	}
	if (_tmp8_) {
		const gchar* _tmp11_;
		gchar* _tmp12_ = NULL;
		_tmp11_ = path;
		g_file_get_contents (_tmp11_, &_tmp12_, NULL, &_inner_error0_);
		_g_free0 (cont);
		cont = _tmp12_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_FILE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_g_free0 (_tmp3_);
				_g_free0 (path);
				_g_free0 (uri);
				_g_free0 (cont);
				_vala_source_file_unref0 (self);
				return NULL;
			} else {
				_g_free0 (_tmp3_);
				_g_free0 (path);
				_g_free0 (uri);
				_g_free0 (cont);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return NULL;
			}
		}
	} else {
		gboolean _tmp13_ = FALSE;
		const gchar* _tmp14_;
		_tmp14_ = path;
		if (_tmp14_ == NULL) {
			const gchar* _tmp15_;
			_tmp15_ = cont;
			_tmp13_ = _tmp15_ == NULL;
		} else {
			_tmp13_ = FALSE;
		}
		if (_tmp13_) {
			const gchar* _tmp16_;
			const gchar* _tmp17_;
			gchar* _tmp18_;
			gchar* _tmp19_;
			GError* _tmp20_;
			GError* _tmp21_;
			_tmp16_ = uri;
			_tmp17_ = string_to_string (_tmp16_);
			_tmp18_ = g_strconcat ("file ", _tmp17_, " does not exist either on the system or in memory", NULL);
			_tmp19_ = _tmp18_;
			_tmp20_ = g_error_new_literal (G_FILE_ERROR, G_FILE_ERROR_NOENT, _tmp19_);
			_tmp21_ = _tmp20_;
			_g_free0 (_tmp19_);
			_inner_error0_ = _tmp21_;
			if (_inner_error0_->domain == G_FILE_ERROR) {
				g_propagate_error (error, _inner_error0_);
				_g_free0 (_tmp3_);
				_g_free0 (path);
				_g_free0 (uri);
				_g_free0 (cont);
				_vala_source_file_unref0 (self);
				return NULL;
			} else {
				_g_free0 (_tmp3_);
				_g_free0 (path);
				_g_free0 (uri);
				_g_free0 (cont);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return NULL;
			}
		}
	}
	_tmp23_ = uri;
	if (g_str_has_suffix (_tmp23_, ".vapi")) {
		_tmp22_ = TRUE;
	} else {
		const gchar* _tmp24_;
		_tmp24_ = uri;
		_tmp22_ = g_str_has_suffix (_tmp24_, ".gir");
	}
	if (_tmp22_) {
		ftype = VALA_SOURCE_FILE_TYPE_PACKAGE;
	} else {
		gboolean _tmp25_ = FALSE;
		const gchar* _tmp26_;
		_tmp26_ = uri;
		if (g_str_has_suffix (_tmp26_, ".vala")) {
			_tmp25_ = TRUE;
		} else {
			const gchar* _tmp27_;
			_tmp27_ = uri;
			_tmp25_ = g_str_has_suffix (_tmp27_, ".gs");
		}
		if (_tmp25_) {
			ftype = VALA_SOURCE_FILE_TYPE_SOURCE;
		} else {
			const gchar* _tmp28_;
			ftype = VALA_SOURCE_FILE_TYPE_NONE;
			_tmp28_ = uri;
			g_warning ("textdocument.vala:75: TextDocument: file %s is neither a package nor a" \
" source file", _tmp28_);
		}
	}
	_tmp30_ = path;
	_tmp29_ = _tmp30_;
	if (_tmp29_ == NULL) {
		const gchar* _tmp31_;
		_tmp31_ = uri;
		_tmp29_ = _tmp31_;
	}
	_tmp32_ = cont;
	self = (VlsTextDocument*) vala_source_file_construct (object_type, context, ftype, _tmp29_, _tmp32_, cmdline);
	_g_free0 (_tmp3_);
	_g_free0 (path);
	_g_free0 (uri);
	_g_free0 (cont);
	return self;
}

VlsTextDocument*
vls_text_document_new (ValaCodeContext* context,
                       GFile* file,
                       const gchar* content,
                       gboolean cmdline,
                       GError** error)
{
	return vls_text_document_construct (VLS_TYPE_TEXT_DOCUMENT, context, file, content, cmdline, error);
}

GDateTime*
vls_text_document_get_last_updated (VlsTextDocument* self)
{
	GDateTime* result;
	GDateTime* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_last_updated;
	result = _tmp0_;
	return result;
}

static gpointer
_g_date_time_ref0 (gpointer self)
{
	return self ? g_date_time_ref (self) : NULL;
}

void
vls_text_document_set_last_updated (VlsTextDocument* self,
                                    GDateTime* value)
{
	GDateTime* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = _g_date_time_ref0 (value);
	_g_date_time_unref0 (self->priv->_last_updated);
	self->priv->_last_updated = _tmp0_;
}

gint
vls_text_document_get_version (VlsTextDocument* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_version;
	return result;
}

void
vls_text_document_set_version (VlsTextDocument* self,
                               gint value)
{
	g_return_if_fail (self != NULL);
	self->priv->_version = value;
}

gint
vls_text_document_get_last_saved_version (VlsTextDocument* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_last_saved_version;
	return result;
}

static void
vls_text_document_set_last_saved_version (VlsTextDocument* self,
                                          gint value)
{
	g_return_if_fail (self != NULL);
	self->priv->_last_saved_version = value;
}

const gchar*
vls_text_document_get_last_saved_content (VlsTextDocument* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	const gchar* _tmp3_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_last_saved_content;
	if (_tmp0_ == NULL) {
		const gchar* _tmp1_;
		const gchar* _tmp2_;
		_tmp1_ = vala_source_file_get_content ((ValaSourceFile*) self);
		_tmp2_ = _tmp1_;
		result = _tmp2_;
		return result;
	}
	_tmp3_ = self->priv->_last_saved_content;
	result = _tmp3_;
	return result;
}

void
vls_text_document_set_last_saved_content (VlsTextDocument* self,
                                          const gchar* value)
{
	gchar* _tmp0_;
	gint _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_strdup (value);
	_g_free0 (self->priv->_last_saved_content);
	self->priv->_last_saved_content = _tmp0_;
	_tmp1_ = self->priv->_version;
	vls_text_document_set_last_saved_version (self, _tmp1_);
}

const gchar*
vls_text_document_get_last_fresh_content (VlsTextDocument* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	const gchar* _tmp3_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_last_fresh_content;
	if (_tmp0_ == NULL) {
		const gchar* _tmp1_;
		const gchar* _tmp2_;
		_tmp1_ = vala_source_file_get_content ((ValaSourceFile*) self);
		_tmp2_ = _tmp1_;
		result = _tmp2_;
		return result;
	}
	_tmp3_ = self->priv->_last_fresh_content;
	result = _tmp3_;
	return result;
}

void
vls_text_document_set_last_fresh_content (VlsTextDocument* self,
                                          const gchar* value)
{
	gchar* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_strdup (value);
	_g_free0 (self->priv->_last_fresh_content);
	self->priv->_last_fresh_content = _tmp0_;
}

static void
vls_text_document_class_init (VlsTextDocumentClass * klass,
                              gpointer klass_data)
{
	vls_text_document_parent_class = g_type_class_peek_parent (klass);
	((ValaSourceFileClass *) klass)->finalize = vls_text_document_finalize;
	g_type_class_adjust_private_offset (klass, &VlsTextDocument_private_offset);
}

static void
vls_text_document_instance_init (VlsTextDocument * self,
                                 gpointer klass)
{
	GTimeZone* _tmp0_;
	GTimeZone* _tmp1_;
	GDateTime* _tmp2_;
	self->priv = vls_text_document_get_instance_private (self);
	_tmp0_ = g_time_zone_new_local ();
	_tmp1_ = _tmp0_;
	_tmp2_ = g_date_time_new_now (_tmp1_);
	self->priv->_last_updated = _tmp2_;
	_g_time_zone_unref0 (_tmp1_);
	self->priv->_last_saved_content = NULL;
	self->priv->_last_fresh_content = NULL;
}

static void
vls_text_document_finalize (ValaSourceFile * obj)
{
	VlsTextDocument * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VLS_TYPE_TEXT_DOCUMENT, VlsTextDocument);
	_g_date_time_unref0 (self->priv->_last_updated);
	_g_free0 (self->priv->_last_saved_content);
	_g_free0 (self->priv->_last_fresh_content);
	VALA_SOURCE_FILE_CLASS (vls_text_document_parent_class)->finalize (obj);
}

 G_GNUC_NO_INLINE static GType
vls_text_document_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (VlsTextDocumentClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vls_text_document_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (VlsTextDocument), 0, (GInstanceInitFunc) vls_text_document_instance_init, NULL };
	GType vls_text_document_type_id;
	vls_text_document_type_id = g_type_register_static (VALA_TYPE_SOURCE_FILE, "VlsTextDocument", &g_define_type_info, 0);
	VlsTextDocument_private_offset = g_type_add_instance_private (vls_text_document_type_id, sizeof (VlsTextDocumentPrivate));
	return vls_text_document_type_id;
}

GType
vls_text_document_get_type (void)
{
	static gsize vls_text_document_type_id__once = 0;
	if (g_once_init_enter (&vls_text_document_type_id__once)) {
		GType vls_text_document_type_id;
		vls_text_document_type_id = vls_text_document_get_type_once ();
		g_once_init_leave (&vls_text_document_type_id__once, vls_text_document_type_id);
	}
	return vls_text_document_type_id__once;
}

