/* reporter.c generated by valac 0.56.13, the Vala compiler
 * generated from reporter.vala, do not modify */

/* reporter.vala
 *
 * Copyright 2017-2018 Ben Iofel <ben@iofel.me>
 * Copyright 2020 Princeton Ferro <princetonferro@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib-object.h>
#include <vala.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gobject/gvaluecollector.h>
#include <gee.h>
#include <stdio.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define VLS_TYPE_SOURCE_MESSAGE (vls_source_message_get_type ())
#define VLS_SOURCE_MESSAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VLS_TYPE_SOURCE_MESSAGE, VlsSourceMessage))
#define VLS_SOURCE_MESSAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VLS_TYPE_SOURCE_MESSAGE, VlsSourceMessageClass))
#define VLS_IS_SOURCE_MESSAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VLS_TYPE_SOURCE_MESSAGE))
#define VLS_IS_SOURCE_MESSAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VLS_TYPE_SOURCE_MESSAGE))
#define VLS_SOURCE_MESSAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VLS_TYPE_SOURCE_MESSAGE, VlsSourceMessageClass))

typedef struct _VlsSourceMessage VlsSourceMessage;
typedef struct _VlsSourceMessageClass VlsSourceMessageClass;
typedef struct _VlsSourceMessagePrivate VlsSourceMessagePrivate;
typedef enum  {
	LSP_DIAGNOSTIC_SEVERITY_Unset = 0,
	LSP_DIAGNOSTIC_SEVERITY_Error = 1,
	LSP_DIAGNOSTIC_SEVERITY_Warning = 2,
	LSP_DIAGNOSTIC_SEVERITY_Information = 3,
	LSP_DIAGNOSTIC_SEVERITY_Hint = 4
} LspDiagnosticSeverity;

#define LSP_TYPE_DIAGNOSTIC_SEVERITY (lsp_diagnostic_severity_get_type ())
#define _vala_source_reference_unref0(var) ((var == NULL) ? NULL : (var = (vala_source_reference_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _VlsParamSpecSourceMessage VlsParamSpecSourceMessage;

#define VLS_TYPE_REPORTER (vls_reporter_get_type ())
#define VLS_REPORTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VLS_TYPE_REPORTER, VlsReporter))
#define VLS_REPORTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VLS_TYPE_REPORTER, VlsReporterClass))
#define VLS_IS_REPORTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VLS_TYPE_REPORTER))
#define VLS_IS_REPORTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VLS_TYPE_REPORTER))
#define VLS_REPORTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VLS_TYPE_REPORTER, VlsReporterClass))

typedef struct _VlsReporter VlsReporter;
typedef struct _VlsReporterClass VlsReporterClass;
typedef struct _VlsReporterPrivate VlsReporterPrivate;
#define _g_ptr_array_unref0(var) ((var == NULL) ? NULL : (var = (g_ptr_array_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _VlsSourceMessage {
	GTypeInstance parent_instance;
	volatile int ref_count;
	VlsSourceMessagePrivate * priv;
	ValaSourceReference* loc;
	gchar* message;
	LspDiagnosticSeverity severity;
};

struct _VlsSourceMessageClass {
	GTypeClass parent_class;
	void (*finalize) (VlsSourceMessage *self);
};

struct _VlsParamSpecSourceMessage {
	GParamSpec parent_instance;
};

struct _VlsReporter {
	ValaReport parent_instance;
	VlsReporterPrivate * priv;
	GPtrArray* messages;
};

struct _VlsReporterClass {
	ValaReportClass parent_class;
};

struct _VlsReporterPrivate {
	gboolean _fatal_warnings;
	GeeHashMap* messages_by_srcref;
};

static gpointer vls_source_message_parent_class = NULL;
static gint VlsReporter_private_offset;
static gpointer vls_reporter_parent_class = NULL;

VALA_EXTERN gpointer vls_source_message_ref (gpointer instance);
VALA_EXTERN void vls_source_message_unref (gpointer instance);
VALA_EXTERN GParamSpec* vls_param_spec_source_message (const gchar* name,
                                           const gchar* nick,
                                           const gchar* blurb,
                                           GType object_type,
                                           GParamFlags flags);
VALA_EXTERN void vls_value_set_source_message (GValue* value,
                                   gpointer v_object);
VALA_EXTERN void vls_value_take_source_message (GValue* value,
                                    gpointer v_object);
VALA_EXTERN gpointer vls_value_get_source_message (const GValue* value);
VALA_EXTERN GType vls_source_message_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VlsSourceMessage, vls_source_message_unref)
VALA_EXTERN GType lsp_diagnostic_severity_get_type (void) G_GNUC_CONST ;
VALA_EXTERN VlsSourceMessage* vls_source_message_new (ValaSourceReference* loc,
                                          const gchar* message,
                                          LspDiagnosticSeverity severity);
VALA_EXTERN VlsSourceMessage* vls_source_message_construct (GType object_type,
                                                ValaSourceReference* loc,
                                                const gchar* message,
                                                LspDiagnosticSeverity severity);
static void vls_source_message_finalize (VlsSourceMessage * obj);
static GType vls_source_message_get_type_once (void);
VALA_EXTERN GType vls_reporter_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VlsReporter, vala_report_unref)
static void _vls_source_message_unref0_ (gpointer var);
VALA_EXTERN VlsReporter* vls_reporter_new (gboolean fatal_warnings);
VALA_EXTERN VlsReporter* vls_reporter_construct (GType object_type,
                                     gboolean fatal_warnings);
static void vls_reporter_set_fatal_warnings (VlsReporter* self,
                                      gboolean value);
VALA_EXTERN void vls_reporter_add_message (VlsReporter* self,
                               ValaSourceReference* source,
                               const gchar* message,
                               LspDiagnosticSeverity severity);
static void vls_reporter_real_depr (ValaReport* base,
                             ValaSourceReference* source,
                             const gchar* message);
VALA_EXTERN gboolean vls_reporter_get_fatal_warnings (VlsReporter* self);
static void vls_reporter_real_err (ValaReport* base,
                            ValaSourceReference* source,
                            const gchar* message);
static void vls_reporter_real_note (ValaReport* base,
                             ValaSourceReference* source,
                             const gchar* message);
static void vls_reporter_real_warn (ValaReport* base,
                             ValaSourceReference* source,
                             const gchar* message);
static void vls_reporter_finalize (ValaReport * obj);
static GType vls_reporter_get_type_once (void);

static gpointer
_vala_source_reference_ref0 (gpointer self)
{
	return self ? vala_source_reference_ref (self) : NULL;
}

VlsSourceMessage*
vls_source_message_construct (GType object_type,
                              ValaSourceReference* loc,
                              const gchar* message,
                              LspDiagnosticSeverity severity)
{
	VlsSourceMessage* self = NULL;
	ValaSourceReference* _tmp0_;
	gchar* _tmp1_;
	g_return_val_if_fail (message != NULL, NULL);
	self = (VlsSourceMessage*) g_type_create_instance (object_type);
	_tmp0_ = _vala_source_reference_ref0 (loc);
	_vala_source_reference_unref0 (self->loc);
	self->loc = _tmp0_;
	_tmp1_ = g_strdup (message);
	_g_free0 (self->message);
	self->message = _tmp1_;
	self->severity = severity;
	return self;
}

VlsSourceMessage*
vls_source_message_new (ValaSourceReference* loc,
                        const gchar* message,
                        LspDiagnosticSeverity severity)
{
	return vls_source_message_construct (VLS_TYPE_SOURCE_MESSAGE, loc, message, severity);
}

static void
vls_value_source_message_init (GValue* value)
{
	value->data[0].v_pointer = NULL;
}

static void
vls_value_source_message_free_value (GValue* value)
{
	if (value->data[0].v_pointer) {
		vls_source_message_unref (value->data[0].v_pointer);
	}
}

static void
vls_value_source_message_copy_value (const GValue* src_value,
                                     GValue* dest_value)
{
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = vls_source_message_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}

static gpointer
vls_value_source_message_peek_pointer (const GValue* value)
{
	return value->data[0].v_pointer;
}

static gchar*
vls_value_source_message_collect_value (GValue* value,
                                        guint n_collect_values,
                                        GTypeCValue* collect_values,
                                        guint collect_flags)
{
	if (collect_values[0].v_pointer) {
		VlsSourceMessage * object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = vls_source_message_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}

static gchar*
vls_value_source_message_lcopy_value (const GValue* value,
                                      guint n_collect_values,
                                      GTypeCValue* collect_values,
                                      guint collect_flags)
{
	VlsSourceMessage ** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = vls_source_message_ref (value->data[0].v_pointer);
	}
	return NULL;
}

GParamSpec*
vls_param_spec_source_message (const gchar* name,
                               const gchar* nick,
                               const gchar* blurb,
                               GType object_type,
                               GParamFlags flags)
{
	VlsParamSpecSourceMessage* spec;
	g_return_val_if_fail (g_type_is_a (object_type, VLS_TYPE_SOURCE_MESSAGE), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}

gpointer
vls_value_get_source_message (const GValue* value)
{
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, VLS_TYPE_SOURCE_MESSAGE), NULL);
	return value->data[0].v_pointer;
}

void
vls_value_set_source_message (GValue* value,
                              gpointer v_object)
{
	VlsSourceMessage * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, VLS_TYPE_SOURCE_MESSAGE));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, VLS_TYPE_SOURCE_MESSAGE));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		vls_source_message_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		vls_source_message_unref (old);
	}
}

void
vls_value_take_source_message (GValue* value,
                               gpointer v_object)
{
	VlsSourceMessage * old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, VLS_TYPE_SOURCE_MESSAGE));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, VLS_TYPE_SOURCE_MESSAGE));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		vls_source_message_unref (old);
	}
}

static void
vls_source_message_class_init (VlsSourceMessageClass * klass,
                               gpointer klass_data)
{
	vls_source_message_parent_class = g_type_class_peek_parent (klass);
	((VlsSourceMessageClass *) klass)->finalize = vls_source_message_finalize;
}

static void
vls_source_message_instance_init (VlsSourceMessage * self,
                                  gpointer klass)
{
	self->ref_count = 1;
}

static void
vls_source_message_finalize (VlsSourceMessage * obj)
{
	VlsSourceMessage * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VLS_TYPE_SOURCE_MESSAGE, VlsSourceMessage);
	g_signal_handlers_destroy (self);
	_vala_source_reference_unref0 (self->loc);
	_g_free0 (self->message);
}

 G_GNUC_NO_INLINE static GType
vls_source_message_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { vls_value_source_message_init, vls_value_source_message_free_value, vls_value_source_message_copy_value, vls_value_source_message_peek_pointer, "p", vls_value_source_message_collect_value, "p", vls_value_source_message_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (VlsSourceMessageClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vls_source_message_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (VlsSourceMessage), 0, (GInstanceInitFunc) vls_source_message_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType vls_source_message_type_id;
	vls_source_message_type_id = g_type_register_fundamental (g_type_fundamental_next (), "VlsSourceMessage", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return vls_source_message_type_id;
}

GType
vls_source_message_get_type (void)
{
	static gsize vls_source_message_type_id__once = 0;
	if (g_once_init_enter (&vls_source_message_type_id__once)) {
		GType vls_source_message_type_id;
		vls_source_message_type_id = vls_source_message_get_type_once ();
		g_once_init_leave (&vls_source_message_type_id__once, vls_source_message_type_id);
	}
	return vls_source_message_type_id__once;
}

gpointer
vls_source_message_ref (gpointer instance)
{
	VlsSourceMessage * self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}

void
vls_source_message_unref (gpointer instance)
{
	VlsSourceMessage * self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		VLS_SOURCE_MESSAGE_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}

static inline gpointer
vls_reporter_get_instance_private (VlsReporter* self)
{
	return G_STRUCT_MEMBER_P (self, VlsReporter_private_offset);
}

static void
_vls_source_message_unref0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (vls_source_message_unref (var), NULL));
}

VlsReporter*
vls_reporter_construct (GType object_type,
                        gboolean fatal_warnings)
{
	VlsReporter* self = NULL;
	self = (VlsReporter*) vala_report_construct (object_type);
	vls_reporter_set_fatal_warnings (self, fatal_warnings);
	return self;
}

VlsReporter*
vls_reporter_new (gboolean fatal_warnings)
{
	return vls_reporter_construct (VLS_TYPE_REPORTER, fatal_warnings);
}

void
vls_reporter_add_message (VlsReporter* self,
                          ValaSourceReference* source,
                          const gchar* message,
                          LspDiagnosticSeverity severity)
{
	GeeHashMap* messages_count = NULL;
	GeeHashMap* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gpointer _tmp3_;
	GeeHashMap* _tmp4_;
	gboolean _tmp5_;
	GeeHashMap* _tmp11_;
	GeeHashMap* _tmp13_;
	GeeHashMap* _tmp14_;
	gpointer _tmp15_;
	gboolean _tmp16_ = FALSE;
	GPtrArray* _tmp23_;
	VlsSourceMessage* _tmp24_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (message != NULL);
	messages_count = NULL;
	_tmp0_ = self->priv->messages_by_srcref;
	_tmp1_ = vala_source_reference_to_string (source);
	_tmp2_ = _tmp1_;
	_tmp3_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, _tmp2_);
	_g_object_unref0 (messages_count);
	messages_count = (GeeHashMap*) _tmp3_;
	_tmp4_ = messages_count;
	_tmp5_ = _tmp4_ == NULL;
	_g_free0 (_tmp2_);
	if (_tmp5_) {
		GeeHashMap* _tmp6_;
		GeeHashMap* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		GeeHashMap* _tmp10_;
		_tmp6_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_UINT, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
		if (_tmp6_) {
			g_object_set_data ((GObject *) _tmp6_, "vala-creation-function", "Vls.Reporter.add_message");
		}
		_g_object_unref0 (messages_count);
		messages_count = _tmp6_;
		_tmp7_ = self->priv->messages_by_srcref;
		_tmp8_ = vala_source_reference_to_string (source);
		_tmp9_ = _tmp8_;
		_tmp10_ = messages_count;
		gee_abstract_map_set ((GeeAbstractMap*) _tmp7_, _tmp9_, _tmp10_);
		_g_free0 (_tmp9_);
	}
	_tmp11_ = messages_count;
	if (!gee_abstract_map_has_key ((GeeAbstractMap*) _tmp11_, message)) {
		GeeHashMap* _tmp12_;
		_tmp12_ = messages_count;
		gee_abstract_map_set ((GeeAbstractMap*) _tmp12_, message, (gpointer) ((guintptr) 0));
	}
	_tmp13_ = messages_count;
	_tmp14_ = messages_count;
	_tmp15_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp14_, message);
	gee_abstract_map_set ((GeeAbstractMap*) _tmp13_, message, (gpointer) ((guintptr) (((guint) ((guintptr) _tmp15_)) + 1)));
	if (source != NULL) {
		GeeHashMap* _tmp17_;
		gpointer _tmp18_;
		_tmp17_ = messages_count;
		_tmp18_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp17_, message);
		_tmp16_ = ((guint) ((guintptr) _tmp18_)) >= ((guint) 100);
	} else {
		_tmp16_ = FALSE;
	}
	if (_tmp16_) {
		gchar* _tmp19_;
		gchar* _tmp20_;
		GeeHashMap* _tmp21_;
		gpointer _tmp22_;
		_tmp19_ = vala_source_reference_to_string (source);
		_tmp20_ = _tmp19_;
		_tmp21_ = messages_count;
		_tmp22_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp21_, message);
		g_error ("parser infinite loop detected! (seen \"%s\" @ %s at least %u times)\n" "note: please report this bug with the source code that causes this err" \
"or at https://gitlab.gnome.org/GNOME/vala", message, _tmp20_, (guint) ((guintptr) _tmp22_));
		_g_free0 (_tmp20_);
	}
	_tmp23_ = self->messages;
	_tmp24_ = vls_source_message_new (source, message, severity);
	g_ptr_array_add (_tmp23_, _tmp24_);
	_g_object_unref0 (messages_count);
}

static void
vls_reporter_real_depr (ValaReport* base,
                        ValaSourceReference* source,
                        const gchar* message)
{
	VlsReporter * self;
	gboolean _tmp0_;
	self = (VlsReporter*) base;
	g_return_if_fail (message != NULL);
	_tmp0_ = self->priv->_fatal_warnings;
	if (_tmp0_) {
		vala_report_err ((ValaReport*) self, source, message);
	} else {
		gint _tmp1_;
		vls_reporter_add_message (self, source, message, LSP_DIAGNOSTIC_SEVERITY_Warning);
		((ValaReport*) self)->warnings = ((ValaReport*) self)->warnings + 1;
		_tmp1_ = ((ValaReport*) self)->warnings;
	}
}

static void
vls_reporter_real_err (ValaReport* base,
                       ValaSourceReference* source,
                       const gchar* message)
{
	VlsReporter * self;
	self = (VlsReporter*) base;
	g_return_if_fail (message != NULL);
	if (source == NULL) {
		FILE* _tmp0_;
		_tmp0_ = stderr;
		fprintf (_tmp0_, "Error: %s\n", message);
	} else {
		gint _tmp1_;
		vls_reporter_add_message (self, source, message, LSP_DIAGNOSTIC_SEVERITY_Error);
		((ValaReport*) self)->errors = ((ValaReport*) self)->errors + 1;
		_tmp1_ = ((ValaReport*) self)->errors;
	}
}

static void
vls_reporter_real_note (ValaReport* base,
                        ValaSourceReference* source,
                        const gchar* message)
{
	VlsReporter * self;
	gboolean _tmp0_;
	self = (VlsReporter*) base;
	g_return_if_fail (message != NULL);
	_tmp0_ = self->priv->_fatal_warnings;
	if (_tmp0_) {
		vala_report_err ((ValaReport*) self, source, message);
	} else {
		gint _tmp1_;
		vls_reporter_add_message (self, source, message, LSP_DIAGNOSTIC_SEVERITY_Information);
		((ValaReport*) self)->warnings = ((ValaReport*) self)->warnings + 1;
		_tmp1_ = ((ValaReport*) self)->warnings;
	}
}

static void
vls_reporter_real_warn (ValaReport* base,
                        ValaSourceReference* source,
                        const gchar* message)
{
	VlsReporter * self;
	gboolean _tmp0_;
	self = (VlsReporter*) base;
	g_return_if_fail (message != NULL);
	_tmp0_ = self->priv->_fatal_warnings;
	if (_tmp0_) {
		vala_report_err ((ValaReport*) self, source, message);
	} else {
		gint _tmp1_;
		vls_reporter_add_message (self, source, message, LSP_DIAGNOSTIC_SEVERITY_Warning);
		((ValaReport*) self)->warnings = ((ValaReport*) self)->warnings + 1;
		_tmp1_ = ((ValaReport*) self)->warnings;
	}
}

gboolean
vls_reporter_get_fatal_warnings (VlsReporter* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_fatal_warnings;
	return result;
}

static void
vls_reporter_set_fatal_warnings (VlsReporter* self,
                                 gboolean value)
{
	g_return_if_fail (self != NULL);
	self->priv->_fatal_warnings = value;
}

static void
vls_reporter_class_init (VlsReporterClass * klass,
                         gpointer klass_data)
{
	vls_reporter_parent_class = g_type_class_peek_parent (klass);
	((ValaReportClass *) klass)->finalize = vls_reporter_finalize;
	g_type_class_adjust_private_offset (klass, &VlsReporter_private_offset);
	((ValaReportClass *) klass)->depr = (void (*) (ValaReport*, ValaSourceReference*, const gchar*)) vls_reporter_real_depr;
	((ValaReportClass *) klass)->err = (void (*) (ValaReport*, ValaSourceReference*, const gchar*)) vls_reporter_real_err;
	((ValaReportClass *) klass)->note = (void (*) (ValaReport*, ValaSourceReference*, const gchar*)) vls_reporter_real_note;
	((ValaReportClass *) klass)->warn = (void (*) (ValaReport*, ValaSourceReference*, const gchar*)) vls_reporter_real_warn;
}

static void
vls_reporter_instance_init (VlsReporter * self,
                            gpointer klass)
{
	GPtrArray* _tmp0_;
	GeeHashMap* _tmp1_;
	self->priv = vls_reporter_get_instance_private (self);
	_tmp0_ = g_ptr_array_new_full ((guint) 0, _vls_source_message_unref0_);
	self->messages = _tmp0_;
	_tmp1_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, GEE_TYPE_HASH_MAP, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	if (_tmp1_) {
		g_object_set_data ((GObject *) _tmp1_, "vala-creation-function", "");
	}
	self->priv->messages_by_srcref = _tmp1_;
}

static void
vls_reporter_finalize (ValaReport * obj)
{
	VlsReporter * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VLS_TYPE_REPORTER, VlsReporter);
	_g_ptr_array_unref0 (self->messages);
	_g_object_unref0 (self->priv->messages_by_srcref);
	VALA_REPORT_CLASS (vls_reporter_parent_class)->finalize (obj);
}

 G_GNUC_NO_INLINE static GType
vls_reporter_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (VlsReporterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vls_reporter_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (VlsReporter), 0, (GInstanceInitFunc) vls_reporter_instance_init, NULL };
	GType vls_reporter_type_id;
	vls_reporter_type_id = g_type_register_static (VALA_TYPE_REPORT, "VlsReporter", &g_define_type_info, 0);
	VlsReporter_private_offset = g_type_add_instance_private (vls_reporter_type_id, sizeof (VlsReporterPrivate));
	return vls_reporter_type_id;
}

GType
vls_reporter_get_type (void)
{
	static gsize vls_reporter_type_id__once = 0;
	if (g_once_init_enter (&vls_reporter_type_id__once)) {
		GType vls_reporter_type_id;
		vls_reporter_type_id = vls_reporter_get_type_once ();
		g_once_init_leave (&vls_reporter_type_id__once, vls_reporter_type_id);
	}
	return vls_reporter_type_id__once;
}

