/* server.c generated by valac 0.56.13, the Vala compiler
 * generated from server.vala, do not modify */

/* server.vala
 *
 * Copyright 2017-2019 Ben Iofel <ben@iofel.me>
 * Copyright 2017-2020 Princeton Ferro <princetonferro@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <jsonrpc-glib.h>
#include <glib-object.h>
#include <glib.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <unistd.h>
#include <gio/gunixinputstream.h>
#include <gio/gunixoutputstream.h>
#include <glib-unix.h>
#include <stdarg.h>
#include <vala.h>
#include <valagee.h>
#include <json-glib/json-glib.h>
#include <signal.h>
#include <stdio.h>

#define VLS_SERVER_check_update_context_period_ms ((guint) 100)
#define VLS_SERVER_update_context_delay_inc_us ((gint64) (500 * 1000))
#define VLS_SERVER_update_context_delay_max_us ((gint64) (1000 * 1000))
#define VLS_SERVER_wait_for_context_update_delay_ms ((guint) 200)
#define CONFIG_PROJECT_VERSION "0.48.7"
#define CONFIG_PROJECT_BUGSITE "https://github.com/vala-lang/vala-language-server/issues"
#define CONFIG_PROJECT_NAME "vala-language-server"
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define VLS_TYPE_SERVER (vls_server_get_type ())
#define VLS_SERVER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VLS_TYPE_SERVER, VlsServer))
#define VLS_SERVER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VLS_TYPE_SERVER, VlsServerClass))
#define VLS_IS_SERVER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VLS_TYPE_SERVER))
#define VLS_IS_SERVER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VLS_TYPE_SERVER))
#define VLS_SERVER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VLS_TYPE_SERVER, VlsServerClass))

typedef struct _VlsServer VlsServer;
typedef struct _VlsServerClass VlsServerClass;
typedef struct _VlsServerPrivate VlsServerPrivate;

#define LSP_TYPE_INITIALIZE_PARAMS (lsp_initialize_params_get_type ())
#define LSP_INITIALIZE_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_INITIALIZE_PARAMS, LspInitializeParams))
#define LSP_INITIALIZE_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_INITIALIZE_PARAMS, LspInitializeParamsClass))
#define LSP_IS_INITIALIZE_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_INITIALIZE_PARAMS))
#define LSP_IS_INITIALIZE_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_INITIALIZE_PARAMS))
#define LSP_INITIALIZE_PARAMS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_INITIALIZE_PARAMS, LspInitializeParamsClass))

typedef struct _LspInitializeParams LspInitializeParams;
typedef struct _LspInitializeParamsClass LspInitializeParamsClass;

#define VLS_TYPE_GIR_DOCUMENTATION (vls_gir_documentation_get_type ())
#define VLS_GIR_DOCUMENTATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VLS_TYPE_GIR_DOCUMENTATION, VlsGirDocumentation))
#define VLS_GIR_DOCUMENTATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VLS_TYPE_GIR_DOCUMENTATION, VlsGirDocumentationClass))
#define VLS_IS_GIR_DOCUMENTATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VLS_TYPE_GIR_DOCUMENTATION))
#define VLS_IS_GIR_DOCUMENTATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VLS_TYPE_GIR_DOCUMENTATION))
#define VLS_GIR_DOCUMENTATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VLS_TYPE_GIR_DOCUMENTATION, VlsGirDocumentationClass))

typedef struct _VlsGirDocumentation VlsGirDocumentation;
typedef struct _VlsGirDocumentationClass VlsGirDocumentationClass;

#define VLS_TYPE_REQUEST (vls_request_get_type ())
#define VLS_REQUEST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VLS_TYPE_REQUEST, VlsRequest))
#define VLS_REQUEST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VLS_TYPE_REQUEST, VlsRequestClass))
#define VLS_IS_REQUEST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VLS_TYPE_REQUEST))
#define VLS_IS_REQUEST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VLS_TYPE_REQUEST))
#define VLS_REQUEST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VLS_TYPE_REQUEST, VlsRequestClass))

typedef struct _VlsRequest VlsRequest;
typedef struct _VlsRequestClass VlsRequestClass;

#define VLS_TYPE_PROJECT (vls_project_get_type ())
#define VLS_PROJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VLS_TYPE_PROJECT, VlsProject))
#define VLS_PROJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VLS_TYPE_PROJECT, VlsProjectClass))
#define VLS_IS_PROJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VLS_TYPE_PROJECT))
#define VLS_IS_PROJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VLS_TYPE_PROJECT))
#define VLS_PROJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VLS_TYPE_PROJECT, VlsProjectClass))

typedef struct _VlsProject VlsProject;
typedef struct _VlsProjectClass VlsProjectClass;

#define VLS_TYPE_DEFAULT_PROJECT (vls_default_project_get_type ())
#define VLS_DEFAULT_PROJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VLS_TYPE_DEFAULT_PROJECT, VlsDefaultProject))
#define VLS_DEFAULT_PROJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VLS_TYPE_DEFAULT_PROJECT, VlsDefaultProjectClass))
#define VLS_IS_DEFAULT_PROJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VLS_TYPE_DEFAULT_PROJECT))
#define VLS_IS_DEFAULT_PROJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VLS_TYPE_DEFAULT_PROJECT))
#define VLS_DEFAULT_PROJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VLS_TYPE_DEFAULT_PROJECT, VlsDefaultProjectClass))

typedef struct _VlsDefaultProject VlsDefaultProject;
typedef struct _VlsDefaultProjectClass VlsDefaultProjectClass;

#define VLS_TYPE_FILE_CACHE (vls_file_cache_get_type ())
#define VLS_FILE_CACHE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VLS_TYPE_FILE_CACHE, VlsFileCache))
#define VLS_FILE_CACHE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VLS_TYPE_FILE_CACHE, VlsFileCacheClass))
#define VLS_IS_FILE_CACHE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VLS_TYPE_FILE_CACHE))
#define VLS_IS_FILE_CACHE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VLS_TYPE_FILE_CACHE))
#define VLS_FILE_CACHE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VLS_TYPE_FILE_CACHE, VlsFileCacheClass))

typedef struct _VlsFileCache VlsFileCache;
typedef struct _VlsFileCacheClass VlsFileCacheClass;
enum  {
	VLS_SERVER_0_PROPERTY,
	VLS_SERVER_NUM_PROPERTIES
};
static GParamSpec* vls_server_properties[VLS_SERVER_NUM_PROPERTIES];
#define _g_main_loop_unref0(var) ((var == NULL) ? NULL : (var = (g_main_loop_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _vls_gir_documentation_unref0(var) ((var == NULL) ? NULL : (var = (vls_gir_documentation_unref (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_variant_type_free0(var) ((var == NULL) ? NULL : (var = (g_variant_type_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_variant_builder_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_builder_unref (var), NULL)))

#define VLS_TYPE_BUILD_TARGET (vls_build_target_get_type ())
#define VLS_BUILD_TARGET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VLS_TYPE_BUILD_TARGET, VlsBuildTarget))
#define VLS_BUILD_TARGET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VLS_TYPE_BUILD_TARGET, VlsBuildTargetClass))
#define VLS_IS_BUILD_TARGET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VLS_TYPE_BUILD_TARGET))
#define VLS_IS_BUILD_TARGET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VLS_TYPE_BUILD_TARGET))
#define VLS_BUILD_TARGET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VLS_TYPE_BUILD_TARGET, VlsBuildTargetClass))

typedef struct _VlsBuildTarget VlsBuildTarget;
typedef struct _VlsBuildTargetClass VlsBuildTargetClass;

#define VLS_TYPE_COMPILATION (vls_compilation_get_type ())
#define VLS_COMPILATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VLS_TYPE_COMPILATION, VlsCompilation))
#define VLS_COMPILATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VLS_TYPE_COMPILATION, VlsCompilationClass))
#define VLS_IS_COMPILATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VLS_TYPE_COMPILATION))
#define VLS_IS_COMPILATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VLS_TYPE_COMPILATION))
#define VLS_COMPILATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VLS_TYPE_COMPILATION, VlsCompilationClass))

typedef struct _VlsCompilation VlsCompilation;
typedef struct _VlsCompilationClass VlsCompilationClass;

#define VLS_TYPE_PAIR (vls_pair_get_type ())
#define VLS_PAIR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VLS_TYPE_PAIR, VlsPair))
#define VLS_PAIR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VLS_TYPE_PAIR, VlsPairClass))
#define VLS_IS_PAIR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VLS_TYPE_PAIR))
#define VLS_IS_PAIR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VLS_TYPE_PAIR))
#define VLS_PAIR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VLS_TYPE_PAIR, VlsPairClass))

typedef struct _VlsPair VlsPair;
typedef struct _VlsPairClass VlsPairClass;
typedef enum  {
	LSP_MESSAGE_TYPE_Error = 1,
	LSP_MESSAGE_TYPE_Warning = 2,
	LSP_MESSAGE_TYPE_Info = 3,
	LSP_MESSAGE_TYPE_Log = 4
} LspMessageType;

#define LSP_TYPE_MESSAGE_TYPE (lsp_message_type_get_type ())
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef enum  {
	LSP_TEXT_DOCUMENT_SYNC_KIND_Unset = -1,
	LSP_TEXT_DOCUMENT_SYNC_KIND_None = 0,
	LSP_TEXT_DOCUMENT_SYNC_KIND_Full = 1,
	LSP_TEXT_DOCUMENT_SYNC_KIND_Incremental = 2
} LspTextDocumentSyncKind;

#define LSP_TYPE_TEXT_DOCUMENT_SYNC_KIND (lsp_text_document_sync_kind_get_type ())

#define VLS_TYPE_MESON_PROJECT (vls_meson_project_get_type ())
#define VLS_MESON_PROJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VLS_TYPE_MESON_PROJECT, VlsMesonProject))
#define VLS_MESON_PROJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VLS_TYPE_MESON_PROJECT, VlsMesonProjectClass))
#define VLS_IS_MESON_PROJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VLS_TYPE_MESON_PROJECT))
#define VLS_IS_MESON_PROJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VLS_TYPE_MESON_PROJECT))
#define VLS_MESON_PROJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VLS_TYPE_MESON_PROJECT, VlsMesonProjectClass))

typedef struct _VlsMesonProject VlsMesonProject;
typedef struct _VlsMesonProjectClass VlsMesonProjectClass;

#define VLS_TYPE_PROJECT_ERROR (vls_project_error_get_type ())

#define VLS_TYPE_CC_PROJECT (vls_cc_project_get_type ())
#define VLS_CC_PROJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VLS_TYPE_CC_PROJECT, VlsCcProject))
#define VLS_CC_PROJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VLS_TYPE_CC_PROJECT, VlsCcProjectClass))
#define VLS_IS_CC_PROJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VLS_TYPE_CC_PROJECT))
#define VLS_IS_CC_PROJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VLS_TYPE_CC_PROJECT))
#define VLS_CC_PROJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VLS_TYPE_CC_PROJECT, VlsCcProjectClass))

typedef struct _VlsCcProject VlsCcProject;
typedef struct _VlsCcProjectClass VlsCcProjectClass;
#define _vala_source_file_unref0(var) ((var == NULL) ? NULL : (var = (vala_source_file_unref (var), NULL)))

#define VLS_TYPE_TEXT_DOCUMENT (vls_text_document_get_type ())
#define VLS_TEXT_DOCUMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VLS_TYPE_TEXT_DOCUMENT, VlsTextDocument))
#define VLS_TEXT_DOCUMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VLS_TYPE_TEXT_DOCUMENT, VlsTextDocumentClass))
#define VLS_IS_TEXT_DOCUMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VLS_TYPE_TEXT_DOCUMENT))
#define VLS_IS_TEXT_DOCUMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VLS_TYPE_TEXT_DOCUMENT))
#define VLS_TEXT_DOCUMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VLS_TYPE_TEXT_DOCUMENT, VlsTextDocumentClass))

typedef struct _VlsTextDocument VlsTextDocument;
typedef struct _VlsTextDocumentClass VlsTextDocumentClass;

#define LSP_TYPE_TEXT_DOCUMENT_CONTENT_CHANGE_EVENT (lsp_text_document_content_change_event_get_type ())
#define LSP_TEXT_DOCUMENT_CONTENT_CHANGE_EVENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_TEXT_DOCUMENT_CONTENT_CHANGE_EVENT, LspTextDocumentContentChangeEvent))
#define LSP_TEXT_DOCUMENT_CONTENT_CHANGE_EVENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_TEXT_DOCUMENT_CONTENT_CHANGE_EVENT, LspTextDocumentContentChangeEventClass))
#define LSP_IS_TEXT_DOCUMENT_CONTENT_CHANGE_EVENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_TEXT_DOCUMENT_CONTENT_CHANGE_EVENT))
#define LSP_IS_TEXT_DOCUMENT_CONTENT_CHANGE_EVENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_TEXT_DOCUMENT_CONTENT_CHANGE_EVENT))
#define LSP_TEXT_DOCUMENT_CONTENT_CHANGE_EVENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_TEXT_DOCUMENT_CONTENT_CHANGE_EVENT, LspTextDocumentContentChangeEventClass))

typedef struct _LspTextDocumentContentChangeEvent LspTextDocumentContentChangeEvent;
typedef struct _LspTextDocumentContentChangeEventClass LspTextDocumentContentChangeEventClass;

#define LSP_TYPE_RANGE (lsp_range_get_type ())
#define LSP_RANGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_RANGE, LspRange))
#define LSP_RANGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_RANGE, LspRangeClass))
#define LSP_IS_RANGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_RANGE))
#define LSP_IS_RANGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_RANGE))
#define LSP_RANGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_RANGE, LspRangeClass))

typedef struct _LspRange LspRange;
typedef struct _LspRangeClass LspRangeClass;

#define LSP_TYPE_POSITION (lsp_position_get_type ())
#define LSP_POSITION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_POSITION, LspPosition))
#define LSP_POSITION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_POSITION, LspPositionClass))
#define LSP_IS_POSITION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_POSITION))
#define LSP_IS_POSITION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_POSITION))
#define LSP_POSITION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_POSITION, LspPositionClass))

typedef struct _LspPosition LspPosition;
typedef struct _LspPositionClass LspPositionClass;
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_time_zone_unref0(var) ((var == NULL) ? NULL : (var = (g_time_zone_unref (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _g_variant_iter_free0(var) ((var == NULL) ? NULL : (var = (g_variant_iter_free (var), NULL)))
typedef void (*VlsServerOnContextUpdatedFunc) (gboolean request_cancelled, gpointer user_data);
typedef struct _Block29Data Block29Data;
typedef struct _Block30Data Block30Data;
#define _json_array_unref0(var) ((var == NULL) ? NULL : (var = (json_array_unref (var), NULL)))

#define VLS_TYPE_REPORTER (vls_reporter_get_type ())
#define VLS_REPORTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VLS_TYPE_REPORTER, VlsReporter))
#define VLS_REPORTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VLS_TYPE_REPORTER, VlsReporterClass))
#define VLS_IS_REPORTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VLS_TYPE_REPORTER))
#define VLS_IS_REPORTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VLS_TYPE_REPORTER))
#define VLS_REPORTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VLS_TYPE_REPORTER, VlsReporterClass))

typedef struct _VlsReporter VlsReporter;
typedef struct _VlsReporterClass VlsReporterClass;
typedef struct _VlsReporterPrivate VlsReporterPrivate;

#define VLS_TYPE_SOURCE_MESSAGE (vls_source_message_get_type ())
#define VLS_SOURCE_MESSAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VLS_TYPE_SOURCE_MESSAGE, VlsSourceMessage))
#define VLS_SOURCE_MESSAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VLS_TYPE_SOURCE_MESSAGE, VlsSourceMessageClass))
#define VLS_IS_SOURCE_MESSAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VLS_TYPE_SOURCE_MESSAGE))
#define VLS_IS_SOURCE_MESSAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VLS_TYPE_SOURCE_MESSAGE))
#define VLS_SOURCE_MESSAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VLS_TYPE_SOURCE_MESSAGE, VlsSourceMessageClass))

typedef struct _VlsSourceMessage VlsSourceMessage;
typedef struct _VlsSourceMessageClass VlsSourceMessageClass;
typedef struct _VlsSourceMessagePrivate VlsSourceMessagePrivate;
typedef enum  {
	LSP_DIAGNOSTIC_SEVERITY_Unset = 0,
	LSP_DIAGNOSTIC_SEVERITY_Error = 1,
	LSP_DIAGNOSTIC_SEVERITY_Warning = 2,
	LSP_DIAGNOSTIC_SEVERITY_Information = 3,
	LSP_DIAGNOSTIC_SEVERITY_Hint = 4
} LspDiagnosticSeverity;

#define LSP_TYPE_DIAGNOSTIC_SEVERITY (lsp_diagnostic_severity_get_type ())

#define LSP_TYPE_DIAGNOSTIC (lsp_diagnostic_get_type ())
#define LSP_DIAGNOSTIC(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_DIAGNOSTIC, LspDiagnostic))
#define LSP_DIAGNOSTIC_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_DIAGNOSTIC, LspDiagnosticClass))
#define LSP_IS_DIAGNOSTIC(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_DIAGNOSTIC))
#define LSP_IS_DIAGNOSTIC_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_DIAGNOSTIC))
#define LSP_DIAGNOSTIC_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_DIAGNOSTIC, LspDiagnosticClass))

typedef struct _LspDiagnostic LspDiagnostic;
typedef struct _LspDiagnosticClass LspDiagnosticClass;
#define __vala_JsonNode_free0(var) ((var == NULL) ? NULL : (var = (_vala_JsonNode_free (var), NULL)))

#define VLS_TYPE_NODE_SEARCH (vls_node_search_get_type ())
#define VLS_NODE_SEARCH(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VLS_TYPE_NODE_SEARCH, VlsNodeSearch))
#define VLS_NODE_SEARCH_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VLS_TYPE_NODE_SEARCH, VlsNodeSearchClass))
#define VLS_IS_NODE_SEARCH(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VLS_TYPE_NODE_SEARCH))
#define VLS_IS_NODE_SEARCH_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VLS_TYPE_NODE_SEARCH))
#define VLS_NODE_SEARCH_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VLS_TYPE_NODE_SEARCH, VlsNodeSearchClass))

typedef struct _VlsNodeSearch VlsNodeSearch;
typedef struct _VlsNodeSearchClass VlsNodeSearchClass;
typedef struct _VlsNodeSearchPrivate VlsNodeSearchPrivate;
#define _vala_code_node_unref0(var) ((var == NULL) ? NULL : (var = (vala_code_node_unref (var), NULL)))

#define LSP_TYPE_TEXT_DOCUMENT_POSITION_PARAMS (lsp_text_document_position_params_get_type ())
#define LSP_TEXT_DOCUMENT_POSITION_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_TEXT_DOCUMENT_POSITION_PARAMS, LspTextDocumentPositionParams))
#define LSP_TEXT_DOCUMENT_POSITION_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_TEXT_DOCUMENT_POSITION_PARAMS, LspTextDocumentPositionParamsClass))
#define LSP_IS_TEXT_DOCUMENT_POSITION_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_TEXT_DOCUMENT_POSITION_PARAMS))
#define LSP_IS_TEXT_DOCUMENT_POSITION_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_TEXT_DOCUMENT_POSITION_PARAMS))
#define LSP_TEXT_DOCUMENT_POSITION_PARAMS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_TEXT_DOCUMENT_POSITION_PARAMS, LspTextDocumentPositionParamsClass))

typedef struct _LspTextDocumentPositionParams LspTextDocumentPositionParams;
typedef struct _LspTextDocumentPositionParamsClass LspTextDocumentPositionParamsClass;
typedef struct _Block31Data Block31Data;

#define LSP_TYPE_TEXT_DOCUMENT_IDENTIFIER (lsp_text_document_identifier_get_type ())
#define LSP_TEXT_DOCUMENT_IDENTIFIER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_TEXT_DOCUMENT_IDENTIFIER, LspTextDocumentIdentifier))
#define LSP_TEXT_DOCUMENT_IDENTIFIER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_TEXT_DOCUMENT_IDENTIFIER, LspTextDocumentIdentifierClass))
#define LSP_IS_TEXT_DOCUMENT_IDENTIFIER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_TEXT_DOCUMENT_IDENTIFIER))
#define LSP_IS_TEXT_DOCUMENT_IDENTIFIER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_TEXT_DOCUMENT_IDENTIFIER))
#define LSP_TEXT_DOCUMENT_IDENTIFIER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_TEXT_DOCUMENT_IDENTIFIER, LspTextDocumentIdentifierClass))

typedef struct _LspTextDocumentIdentifier LspTextDocumentIdentifier;
typedef struct _LspTextDocumentIdentifierClass LspTextDocumentIdentifierClass;
#define _vala_code_visitor_unref0(var) ((var == NULL) ? NULL : (var = (vala_code_visitor_unref (var), NULL)))

#define LSP_TYPE_LOCATION (lsp_location_get_type ())
#define LSP_LOCATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_LOCATION, LspLocation))
#define LSP_LOCATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_LOCATION, LspLocationClass))
#define LSP_IS_LOCATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_LOCATION))
#define LSP_IS_LOCATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_LOCATION))
#define LSP_LOCATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_LOCATION, LspLocationClass))

typedef struct _LspLocation LspLocation;
typedef struct _LspLocationClass LspLocationClass;
typedef struct _Block32Data Block32Data;

#define VLS_TYPE_SYMBOL_ENUMERATOR (vls_symbol_enumerator_get_type ())
#define VLS_SYMBOL_ENUMERATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VLS_TYPE_SYMBOL_ENUMERATOR, VlsSymbolEnumerator))
#define VLS_SYMBOL_ENUMERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VLS_TYPE_SYMBOL_ENUMERATOR, VlsSymbolEnumeratorClass))
#define VLS_IS_SYMBOL_ENUMERATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VLS_TYPE_SYMBOL_ENUMERATOR))
#define VLS_IS_SYMBOL_ENUMERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VLS_TYPE_SYMBOL_ENUMERATOR))
#define VLS_SYMBOL_ENUMERATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VLS_TYPE_SYMBOL_ENUMERATOR, VlsSymbolEnumeratorClass))

typedef struct _VlsSymbolEnumerator VlsSymbolEnumerator;
typedef struct _VlsSymbolEnumeratorClass VlsSymbolEnumeratorClass;

#define LSP_TYPE_CLIENT_CAPABILITIES (lsp_client_capabilities_get_type ())
#define LSP_CLIENT_CAPABILITIES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_CLIENT_CAPABILITIES, LspClientCapabilities))
#define LSP_CLIENT_CAPABILITIES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_CLIENT_CAPABILITIES, LspClientCapabilitiesClass))
#define LSP_IS_CLIENT_CAPABILITIES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_CLIENT_CAPABILITIES))
#define LSP_IS_CLIENT_CAPABILITIES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_CLIENT_CAPABILITIES))
#define LSP_CLIENT_CAPABILITIES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_CLIENT_CAPABILITIES, LspClientCapabilitiesClass))

typedef struct _LspClientCapabilities LspClientCapabilities;
typedef struct _LspClientCapabilitiesClass LspClientCapabilitiesClass;

#define LSP_TYPE_TEXT_DOCUMENT_CLIENT_CAPABILITIES (lsp_text_document_client_capabilities_get_type ())
#define LSP_TEXT_DOCUMENT_CLIENT_CAPABILITIES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_TEXT_DOCUMENT_CLIENT_CAPABILITIES, LspTextDocumentClientCapabilities))
#define LSP_TEXT_DOCUMENT_CLIENT_CAPABILITIES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_TEXT_DOCUMENT_CLIENT_CAPABILITIES, LspTextDocumentClientCapabilitiesClass))
#define LSP_IS_TEXT_DOCUMENT_CLIENT_CAPABILITIES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_TEXT_DOCUMENT_CLIENT_CAPABILITIES))
#define LSP_IS_TEXT_DOCUMENT_CLIENT_CAPABILITIES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_TEXT_DOCUMENT_CLIENT_CAPABILITIES))
#define LSP_TEXT_DOCUMENT_CLIENT_CAPABILITIES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_TEXT_DOCUMENT_CLIENT_CAPABILITIES, LspTextDocumentClientCapabilitiesClass))

typedef struct _LspTextDocumentClientCapabilities LspTextDocumentClientCapabilities;
typedef struct _LspTextDocumentClientCapabilitiesClass LspTextDocumentClientCapabilitiesClass;

#define LSP_TYPE_DOCUMENT_SYMBOL_CAPABILITIES (lsp_document_symbol_capabilities_get_type ())
#define LSP_DOCUMENT_SYMBOL_CAPABILITIES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_DOCUMENT_SYMBOL_CAPABILITIES, LspDocumentSymbolCapabilities))
#define LSP_DOCUMENT_SYMBOL_CAPABILITIES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_DOCUMENT_SYMBOL_CAPABILITIES, LspDocumentSymbolCapabilitiesClass))
#define LSP_IS_DOCUMENT_SYMBOL_CAPABILITIES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_DOCUMENT_SYMBOL_CAPABILITIES))
#define LSP_IS_DOCUMENT_SYMBOL_CAPABILITIES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_DOCUMENT_SYMBOL_CAPABILITIES))
#define LSP_DOCUMENT_SYMBOL_CAPABILITIES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_DOCUMENT_SYMBOL_CAPABILITIES, LspDocumentSymbolCapabilitiesClass))

typedef struct _LspDocumentSymbolCapabilities LspDocumentSymbolCapabilities;
typedef struct _LspDocumentSymbolCapabilitiesClass LspDocumentSymbolCapabilitiesClass;

#define LSP_TYPE_DOCUMENT_SYMBOL (lsp_document_symbol_get_type ())
#define LSP_DOCUMENT_SYMBOL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_DOCUMENT_SYMBOL, LspDocumentSymbol))
#define LSP_DOCUMENT_SYMBOL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_DOCUMENT_SYMBOL, LspDocumentSymbolClass))
#define LSP_IS_DOCUMENT_SYMBOL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_DOCUMENT_SYMBOL))
#define LSP_IS_DOCUMENT_SYMBOL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_DOCUMENT_SYMBOL))
#define LSP_DOCUMENT_SYMBOL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_DOCUMENT_SYMBOL, LspDocumentSymbolClass))

typedef struct _LspDocumentSymbol LspDocumentSymbol;
typedef struct _LspDocumentSymbolClass LspDocumentSymbolClass;

#define LSP_TYPE_SYMBOL_INFORMATION (lsp_symbol_information_get_type ())
#define LSP_SYMBOL_INFORMATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_SYMBOL_INFORMATION, LspSymbolInformation))
#define LSP_SYMBOL_INFORMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_SYMBOL_INFORMATION, LspSymbolInformationClass))
#define LSP_IS_SYMBOL_INFORMATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_SYMBOL_INFORMATION))
#define LSP_IS_SYMBOL_INFORMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_SYMBOL_INFORMATION))
#define LSP_SYMBOL_INFORMATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_SYMBOL_INFORMATION, LspSymbolInformationClass))

typedef struct _LspSymbolInformation LspSymbolInformation;
typedef struct _LspSymbolInformationClass LspSymbolInformationClass;

#define VLS_TYPE_DOC_COMMENT (vls_doc_comment_get_type ())
#define VLS_DOC_COMMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VLS_TYPE_DOC_COMMENT, VlsDocComment))
#define VLS_DOC_COMMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VLS_TYPE_DOC_COMMENT, VlsDocCommentClass))
#define VLS_IS_DOC_COMMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VLS_TYPE_DOC_COMMENT))
#define VLS_IS_DOC_COMMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VLS_TYPE_DOC_COMMENT))
#define VLS_DOC_COMMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VLS_TYPE_DOC_COMMENT, VlsDocCommentClass))

typedef struct _VlsDocComment VlsDocComment;
typedef struct _VlsDocCommentClass VlsDocCommentClass;
#define _vala_comment_unref0(var) ((var == NULL) ? NULL : (var = (vala_comment_unref (var), NULL)))
#define _vls_doc_comment_unref0(var) ((var == NULL) ? NULL : (var = (vls_doc_comment_unref (var), NULL)))

#define LSP_TYPE_COMPLETION_PARAMS (lsp_completion_params_get_type ())
#define LSP_COMPLETION_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_COMPLETION_PARAMS, LspCompletionParams))
#define LSP_COMPLETION_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_COMPLETION_PARAMS, LspCompletionParamsClass))
#define LSP_IS_COMPLETION_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_COMPLETION_PARAMS))
#define LSP_IS_COMPLETION_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_COMPLETION_PARAMS))
#define LSP_COMPLETION_PARAMS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_COMPLETION_PARAMS, LspCompletionParamsClass))

typedef struct _LspCompletionParams LspCompletionParams;
typedef struct _LspCompletionParamsClass LspCompletionParamsClass;

#define LSP_TYPE_COMPLETION_CONTEXT (lsp_completion_context_get_type ())
#define LSP_COMPLETION_CONTEXT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_COMPLETION_CONTEXT, LspCompletionContext))
#define LSP_COMPLETION_CONTEXT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_COMPLETION_CONTEXT, LspCompletionContextClass))
#define LSP_IS_COMPLETION_CONTEXT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_COMPLETION_CONTEXT))
#define LSP_IS_COMPLETION_CONTEXT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_COMPLETION_CONTEXT))
#define LSP_COMPLETION_CONTEXT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_COMPLETION_CONTEXT, LspCompletionContextClass))

typedef struct _LspCompletionContext LspCompletionContext;
typedef struct _LspCompletionContextClass LspCompletionContextClass;
typedef struct _Block33Data Block33Data;

#define VLS_TYPE_FIND_SCOPE (vls_find_scope_get_type ())
#define VLS_FIND_SCOPE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VLS_TYPE_FIND_SCOPE, VlsFindScope))
#define VLS_FIND_SCOPE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VLS_TYPE_FIND_SCOPE, VlsFindScopeClass))
#define VLS_IS_FIND_SCOPE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VLS_TYPE_FIND_SCOPE))
#define VLS_IS_FIND_SCOPE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VLS_TYPE_FIND_SCOPE))
#define VLS_FIND_SCOPE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VLS_TYPE_FIND_SCOPE, VlsFindScopeClass))

typedef struct _VlsFindScope VlsFindScope;
typedef struct _VlsFindScopeClass VlsFindScopeClass;
#define _vala_scope_unref0(var) ((var == NULL) ? NULL : (var = (vala_scope_unref (var), NULL)))
#define _vala_iterable_unref0(var) ((var == NULL) ? NULL : (var = (vala_iterable_unref (var), NULL)))

#define LSP_TYPE_HOVER (lsp_hover_get_type ())
#define LSP_HOVER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_HOVER, LspHover))
#define LSP_HOVER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_HOVER, LspHoverClass))
#define LSP_IS_HOVER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_HOVER))
#define LSP_IS_HOVER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_HOVER))
#define LSP_HOVER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_HOVER, LspHoverClass))

typedef struct _LspHover LspHover;
typedef struct _LspHoverClass LspHoverClass;

#define LSP_TYPE_MARKED_STRING (lsp_marked_string_get_type ())
#define LSP_MARKED_STRING(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_MARKED_STRING, LspMarkedString))
#define LSP_MARKED_STRING_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_MARKED_STRING, LspMarkedStringClass))
#define LSP_IS_MARKED_STRING(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_MARKED_STRING))
#define LSP_IS_MARKED_STRING_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_MARKED_STRING))
#define LSP_MARKED_STRING_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_MARKED_STRING, LspMarkedStringClass))

typedef struct _LspMarkedString LspMarkedString;
typedef struct _LspMarkedStringClass LspMarkedStringClass;
typedef enum  {
	LSP_DOCUMENT_HIGHLIGHT_KIND_Text = 1,
	LSP_DOCUMENT_HIGHLIGHT_KIND_Read = 2,
	LSP_DOCUMENT_HIGHLIGHT_KIND_Write = 3
} LspDocumentHighlightKind;

#define LSP_TYPE_DOCUMENT_HIGHLIGHT_KIND (lsp_document_highlight_kind_get_type ())

#define LSP_TYPE_REFERENCE_PARAMS (lsp_reference_params_get_type ())
#define LSP_REFERENCE_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_REFERENCE_PARAMS, LspReferenceParams))
#define LSP_REFERENCE_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_REFERENCE_PARAMS, LspReferenceParamsClass))
#define LSP_IS_REFERENCE_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_REFERENCE_PARAMS))
#define LSP_IS_REFERENCE_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_REFERENCE_PARAMS))
#define LSP_REFERENCE_PARAMS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_REFERENCE_PARAMS, LspReferenceParamsClass))

typedef struct _LspReferenceParams LspReferenceParams;
typedef struct _LspReferenceParamsClass LspReferenceParamsClass;
typedef struct _Block34Data Block34Data;

#define LSP_REFERENCE_PARAMS_TYPE_REFERENCE_CONTEXT (lsp_reference_params_reference_context_get_type ())
#define LSP_REFERENCE_PARAMS_REFERENCE_CONTEXT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_REFERENCE_PARAMS_TYPE_REFERENCE_CONTEXT, LspReferenceParamsReferenceContext))
#define LSP_REFERENCE_PARAMS_REFERENCE_CONTEXT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_REFERENCE_PARAMS_TYPE_REFERENCE_CONTEXT, LspReferenceParamsReferenceContextClass))
#define LSP_REFERENCE_PARAMS_IS_REFERENCE_CONTEXT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_REFERENCE_PARAMS_TYPE_REFERENCE_CONTEXT))
#define LSP_REFERENCE_PARAMS_IS_REFERENCE_CONTEXT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_REFERENCE_PARAMS_TYPE_REFERENCE_CONTEXT))
#define LSP_REFERENCE_PARAMS_REFERENCE_CONTEXT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_REFERENCE_PARAMS_TYPE_REFERENCE_CONTEXT, LspReferenceParamsReferenceContextClass))

typedef struct _LspReferenceParamsReferenceContext LspReferenceParamsReferenceContext;
typedef struct _LspReferenceParamsReferenceContextClass LspReferenceParamsReferenceContextClass;

#define LSP_TYPE_DOCUMENT_HIGHLIGHT (lsp_document_highlight_get_type ())
#define LSP_DOCUMENT_HIGHLIGHT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_DOCUMENT_HIGHLIGHT, LspDocumentHighlight))
#define LSP_DOCUMENT_HIGHLIGHT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_DOCUMENT_HIGHLIGHT, LspDocumentHighlightClass))
#define LSP_IS_DOCUMENT_HIGHLIGHT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_DOCUMENT_HIGHLIGHT))
#define LSP_IS_DOCUMENT_HIGHLIGHT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_DOCUMENT_HIGHLIGHT))
#define LSP_DOCUMENT_HIGHLIGHT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_DOCUMENT_HIGHLIGHT, LspDocumentHighlightClass))

typedef struct _LspDocumentHighlight LspDocumentHighlight;
typedef struct _LspDocumentHighlightClass LspDocumentHighlightClass;
typedef struct _Block35Data Block35Data;
typedef gboolean (*VlsNodeSearchFilter) (ValaCodeNode* needle, ValaCodeNode* hay_node);

#define LSP_TYPE_DOCUMENT_RANGE_FORMATTING_PARAMS (lsp_document_range_formatting_params_get_type ())
#define LSP_DOCUMENT_RANGE_FORMATTING_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_DOCUMENT_RANGE_FORMATTING_PARAMS, LspDocumentRangeFormattingParams))
#define LSP_DOCUMENT_RANGE_FORMATTING_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_DOCUMENT_RANGE_FORMATTING_PARAMS, LspDocumentRangeFormattingParamsClass))
#define LSP_IS_DOCUMENT_RANGE_FORMATTING_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_DOCUMENT_RANGE_FORMATTING_PARAMS))
#define LSP_IS_DOCUMENT_RANGE_FORMATTING_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_DOCUMENT_RANGE_FORMATTING_PARAMS))
#define LSP_DOCUMENT_RANGE_FORMATTING_PARAMS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_DOCUMENT_RANGE_FORMATTING_PARAMS, LspDocumentRangeFormattingParamsClass))

typedef struct _LspDocumentRangeFormattingParams LspDocumentRangeFormattingParams;
typedef struct _LspDocumentRangeFormattingParamsClass LspDocumentRangeFormattingParamsClass;

#define LSP_TYPE_TEXT_EDIT (lsp_text_edit_get_type ())
#define LSP_TEXT_EDIT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_TEXT_EDIT, LspTextEdit))
#define LSP_TEXT_EDIT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_TEXT_EDIT, LspTextEditClass))
#define LSP_IS_TEXT_EDIT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_TEXT_EDIT))
#define LSP_IS_TEXT_EDIT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_TEXT_EDIT))
#define LSP_TEXT_EDIT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_TEXT_EDIT, LspTextEditClass))

typedef struct _LspTextEdit LspTextEdit;
typedef struct _LspTextEditClass LspTextEditClass;

#define VLS_TYPE_CODE_STYLE_ANALYZER (vls_code_style_analyzer_get_type ())
#define VLS_CODE_STYLE_ANALYZER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VLS_TYPE_CODE_STYLE_ANALYZER, VlsCodeStyleAnalyzer))
#define VLS_CODE_STYLE_ANALYZER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VLS_TYPE_CODE_STYLE_ANALYZER, VlsCodeStyleAnalyzerClass))
#define VLS_IS_CODE_STYLE_ANALYZER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VLS_TYPE_CODE_STYLE_ANALYZER))
#define VLS_IS_CODE_STYLE_ANALYZER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VLS_TYPE_CODE_STYLE_ANALYZER))
#define VLS_CODE_STYLE_ANALYZER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VLS_TYPE_CODE_STYLE_ANALYZER, VlsCodeStyleAnalyzerClass))

typedef struct _VlsCodeStyleAnalyzer VlsCodeStyleAnalyzer;
typedef struct _VlsCodeStyleAnalyzerClass VlsCodeStyleAnalyzerClass;

#define LSP_TYPE_FORMATTING_OPTIONS (lsp_formatting_options_get_type ())
#define LSP_FORMATTING_OPTIONS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_FORMATTING_OPTIONS, LspFormattingOptions))
#define LSP_FORMATTING_OPTIONS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_FORMATTING_OPTIONS, LspFormattingOptionsClass))
#define LSP_IS_FORMATTING_OPTIONS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_FORMATTING_OPTIONS))
#define LSP_IS_FORMATTING_OPTIONS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_FORMATTING_OPTIONS))
#define LSP_FORMATTING_OPTIONS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_FORMATTING_OPTIONS, LspFormattingOptionsClass))

typedef struct _LspFormattingOptions LspFormattingOptions;
typedef struct _LspFormattingOptionsClass LspFormattingOptionsClass;

#define TYPE_FORMATTING_ERROR (formatting_error_get_type ())

#define LSP_TYPE_CODE_ACTION_PARAMS (lsp_code_action_params_get_type ())
#define LSP_CODE_ACTION_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_CODE_ACTION_PARAMS, LspCodeActionParams))
#define LSP_CODE_ACTION_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_CODE_ACTION_PARAMS, LspCodeActionParamsClass))
#define LSP_IS_CODE_ACTION_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_CODE_ACTION_PARAMS))
#define LSP_IS_CODE_ACTION_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_CODE_ACTION_PARAMS))
#define LSP_CODE_ACTION_PARAMS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_CODE_ACTION_PARAMS, LspCodeActionParamsClass))

typedef struct _LspCodeActionParams LspCodeActionParams;
typedef struct _LspCodeActionParamsClass LspCodeActionParamsClass;

#define LSP_TYPE_CODE_ACTION (lsp_code_action_get_type ())
#define LSP_CODE_ACTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_CODE_ACTION, LspCodeAction))
#define LSP_CODE_ACTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_CODE_ACTION, LspCodeActionClass))
#define LSP_IS_CODE_ACTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_CODE_ACTION))
#define LSP_IS_CODE_ACTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_CODE_ACTION))
#define LSP_CODE_ACTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_CODE_ACTION, LspCodeActionClass))

typedef struct _LspCodeAction LspCodeAction;
typedef struct _LspCodeActionClass LspCodeActionClass;

#define LSP_TYPE_CODE_ACTION_CONTEXT (lsp_code_action_context_get_type ())
#define LSP_CODE_ACTION_CONTEXT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_CODE_ACTION_CONTEXT, LspCodeActionContext))
#define LSP_CODE_ACTION_CONTEXT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_CODE_ACTION_CONTEXT, LspCodeActionContextClass))
#define LSP_IS_CODE_ACTION_CONTEXT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_CODE_ACTION_CONTEXT))
#define LSP_IS_CODE_ACTION_CONTEXT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_CODE_ACTION_CONTEXT))
#define LSP_CODE_ACTION_CONTEXT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_CODE_ACTION_CONTEXT, LspCodeActionContextClass))

typedef struct _LspCodeActionContext LspCodeActionContext;
typedef struct _LspCodeActionContextClass LspCodeActionContextClass;
#define _vala_iterator_unref0(var) ((var == NULL) ? NULL : (var = (vala_iterator_unref (var), NULL)))
typedef struct _Block36Data Block36Data;
typedef struct _Block37Data Block37Data;
typedef struct _Block38Data Block38Data;

#define LSP_TYPE_VERSIONED_TEXT_DOCUMENT_IDENTIFIER (lsp_versioned_text_document_identifier_get_type ())
#define LSP_VERSIONED_TEXT_DOCUMENT_IDENTIFIER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_VERSIONED_TEXT_DOCUMENT_IDENTIFIER, LspVersionedTextDocumentIdentifier))
#define LSP_VERSIONED_TEXT_DOCUMENT_IDENTIFIER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_VERSIONED_TEXT_DOCUMENT_IDENTIFIER, LspVersionedTextDocumentIdentifierClass))
#define LSP_IS_VERSIONED_TEXT_DOCUMENT_IDENTIFIER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_VERSIONED_TEXT_DOCUMENT_IDENTIFIER))
#define LSP_IS_VERSIONED_TEXT_DOCUMENT_IDENTIFIER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_VERSIONED_TEXT_DOCUMENT_IDENTIFIER))
#define LSP_VERSIONED_TEXT_DOCUMENT_IDENTIFIER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_VERSIONED_TEXT_DOCUMENT_IDENTIFIER, LspVersionedTextDocumentIdentifierClass))

typedef struct _LspVersionedTextDocumentIdentifier LspVersionedTextDocumentIdentifier;
typedef struct _LspVersionedTextDocumentIdentifierClass LspVersionedTextDocumentIdentifierClass;

#define LSP_TYPE_TEXT_DOCUMENT_EDIT (lsp_text_document_edit_get_type ())
#define LSP_TEXT_DOCUMENT_EDIT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_TEXT_DOCUMENT_EDIT, LspTextDocumentEdit))
#define LSP_TEXT_DOCUMENT_EDIT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_TEXT_DOCUMENT_EDIT, LspTextDocumentEditClass))
#define LSP_IS_TEXT_DOCUMENT_EDIT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_TEXT_DOCUMENT_EDIT))
#define LSP_IS_TEXT_DOCUMENT_EDIT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_TEXT_DOCUMENT_EDIT))
#define LSP_TEXT_DOCUMENT_EDIT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_TEXT_DOCUMENT_EDIT, LspTextDocumentEditClass))

typedef struct _LspTextDocumentEdit LspTextDocumentEdit;
typedef struct _LspTextDocumentEditClass LspTextDocumentEditClass;
typedef struct _Block39Data Block39Data;

#define LSP_TYPE_CALL_HIERARCHY_ITEM (lsp_call_hierarchy_item_get_type ())
#define LSP_CALL_HIERARCHY_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_CALL_HIERARCHY_ITEM, LspCallHierarchyItem))
#define LSP_CALL_HIERARCHY_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_CALL_HIERARCHY_ITEM, LspCallHierarchyItemClass))
#define LSP_IS_CALL_HIERARCHY_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_CALL_HIERARCHY_ITEM))
#define LSP_IS_CALL_HIERARCHY_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_CALL_HIERARCHY_ITEM))
#define LSP_CALL_HIERARCHY_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_CALL_HIERARCHY_ITEM, LspCallHierarchyItemClass))

typedef struct _LspCallHierarchyItem LspCallHierarchyItem;
typedef struct _LspCallHierarchyItemClass LspCallHierarchyItemClass;

#define LSP_TYPE_CALL_HIERARCHY_INCOMING_CALL (lsp_call_hierarchy_incoming_call_get_type ())
#define LSP_CALL_HIERARCHY_INCOMING_CALL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_CALL_HIERARCHY_INCOMING_CALL, LspCallHierarchyIncomingCall))
#define LSP_CALL_HIERARCHY_INCOMING_CALL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_CALL_HIERARCHY_INCOMING_CALL, LspCallHierarchyIncomingCallClass))
#define LSP_IS_CALL_HIERARCHY_INCOMING_CALL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_CALL_HIERARCHY_INCOMING_CALL))
#define LSP_IS_CALL_HIERARCHY_INCOMING_CALL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_CALL_HIERARCHY_INCOMING_CALL))
#define LSP_CALL_HIERARCHY_INCOMING_CALL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_CALL_HIERARCHY_INCOMING_CALL, LspCallHierarchyIncomingCallClass))

typedef struct _LspCallHierarchyIncomingCall LspCallHierarchyIncomingCall;
typedef struct _LspCallHierarchyIncomingCallClass LspCallHierarchyIncomingCallClass;

#define LSP_TYPE_CALL_HIERARCHY_OUTGOING_CALL (lsp_call_hierarchy_outgoing_call_get_type ())
#define LSP_CALL_HIERARCHY_OUTGOING_CALL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_CALL_HIERARCHY_OUTGOING_CALL, LspCallHierarchyOutgoingCall))
#define LSP_CALL_HIERARCHY_OUTGOING_CALL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_CALL_HIERARCHY_OUTGOING_CALL, LspCallHierarchyOutgoingCallClass))
#define LSP_IS_CALL_HIERARCHY_OUTGOING_CALL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_CALL_HIERARCHY_OUTGOING_CALL))
#define LSP_IS_CALL_HIERARCHY_OUTGOING_CALL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_CALL_HIERARCHY_OUTGOING_CALL))
#define LSP_CALL_HIERARCHY_OUTGOING_CALL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_CALL_HIERARCHY_OUTGOING_CALL, LspCallHierarchyOutgoingCallClass))

typedef struct _LspCallHierarchyOutgoingCall LspCallHierarchyOutgoingCall;
typedef struct _LspCallHierarchyOutgoingCallClass LspCallHierarchyOutgoingCallClass;

#define LSP_TYPE_INLAY_HINT_PARAMS (lsp_inlay_hint_params_get_type ())
#define LSP_INLAY_HINT_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_INLAY_HINT_PARAMS, LspInlayHintParams))
#define LSP_INLAY_HINT_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_INLAY_HINT_PARAMS, LspInlayHintParamsClass))
#define LSP_IS_INLAY_HINT_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_INLAY_HINT_PARAMS))
#define LSP_IS_INLAY_HINT_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_INLAY_HINT_PARAMS))
#define LSP_INLAY_HINT_PARAMS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_INLAY_HINT_PARAMS, LspInlayHintParamsClass))

typedef struct _LspInlayHintParams LspInlayHintParams;
typedef struct _LspInlayHintParamsClass LspInlayHintParamsClass;

#define LSP_TYPE_INLAY_HINT (lsp_inlay_hint_get_type ())
#define LSP_INLAY_HINT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_INLAY_HINT, LspInlayHint))
#define LSP_INLAY_HINT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_INLAY_HINT, LspInlayHintClass))
#define LSP_IS_INLAY_HINT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_INLAY_HINT))
#define LSP_IS_INLAY_HINT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_INLAY_HINT))
#define LSP_INLAY_HINT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_INLAY_HINT, LspInlayHintClass))

typedef struct _LspInlayHint LspInlayHint;
typedef struct _LspInlayHintClass LspInlayHintClass;
typedef enum  {
	LSP_INLAY_HINT_KIND_UNSET,
	LSP_INLAY_HINT_KIND_TYPE,
	LSP_INLAY_HINT_KIND_PARAMETER
} LspInlayHintKind;

#define LSP_TYPE_INLAY_HINT_KIND (lsp_inlay_hint_kind_get_type ())
#define _g_match_info_unref0(var) ((var == NULL) ? NULL : (var = (g_match_info_unref (var), NULL)))

#define LSP_TYPE_TYPEHIERARCHY_ITEM (lsp_typehierarchy_item_get_type ())
#define LSP_TYPEHIERARCHY_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_TYPEHIERARCHY_ITEM, LspTypeHierarchyItem))
#define LSP_TYPEHIERARCHY_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_TYPEHIERARCHY_ITEM, LspTypeHierarchyItemClass))
#define LSP_IS_TYPEHIERARCHY_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_TYPEHIERARCHY_ITEM))
#define LSP_IS_TYPEHIERARCHY_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_TYPEHIERARCHY_ITEM))
#define LSP_TYPEHIERARCHY_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_TYPEHIERARCHY_ITEM, LspTypeHierarchyItemClass))

typedef struct _LspTypeHierarchyItem LspTypeHierarchyItem;
typedef struct _LspTypeHierarchyItemClass LspTypeHierarchyItemClass;
#define _g_option_context_free0(var) ((var == NULL) ? NULL : (var = (g_option_context_free (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _VlsServer {
	JsonrpcServer parent_instance;
	VlsServerPrivate * priv;
};

struct _VlsServerClass {
	JsonrpcServerClass parent_class;
};

struct _VlsServerPrivate {
	GMainLoop* loop;
	LspInitializeParams* init_params;
	VlsGirDocumentation* documentation;
	GeeHashSet* pending_requests;
	gboolean shutting_down;
	guint* g_sources;
	gint g_sources_length1;
	gint _g_sources_size_;
	gulong client_closed_event_id;
	GHashTable* projects;
	VlsDefaultProject* default_project;
	GeeHashSet* discarded_files;
	GeeHashSet* open_files;
	VlsFileCache* file_cache;
	JsonrpcClient* update_context_client;
	gint64 update_context_requests;
	gint64 update_context_time_us;
};

typedef enum  {
	VLS_PROJECT_ERROR_VERSION_UNSUPPORTED,
	VLS_PROJECT_ERROR_INTROSPECTION,
	VLS_PROJECT_ERROR_CONFIGURATION,
	VLS_PROJECT_ERROR_TASK_FAILED,
	VLS_PROJECT_ERROR_NOT_FOUND
} VlsProjectError;
#define VLS_PROJECT_ERROR vls_project_error_quark ()

struct _Block29Data {
	int _ref_count_;
	VlsServer* self;
	VlsRequest* req;
	VlsServerOnContextUpdatedFunc on_context_updated_func;
	gpointer on_context_updated_func_target;
	GDestroyNotify on_context_updated_func_target_destroy_notify;
};

struct _Block30Data {
	int _ref_count_;
	VlsServer* self;
	JsonArray* diags_without_source;
	GeeHashMap* doc_diags;
	VlsCompilation* target;
};

struct _VlsReporter {
	ValaReport parent_instance;
	VlsReporterPrivate * priv;
	GPtrArray* messages;
};

struct _VlsReporterClass {
	ValaReportClass parent_class;
};

struct _VlsSourceMessage {
	GTypeInstance parent_instance;
	volatile int ref_count;
	VlsSourceMessagePrivate * priv;
	ValaSourceReference* loc;
	gchar* message;
	LspDiagnosticSeverity severity;
};

struct _VlsSourceMessageClass {
	GTypeClass parent_class;
	void (*finalize) (VlsSourceMessage *self);
};

struct _VlsNodeSearch {
	ValaCodeVisitor parent_instance;
	VlsNodeSearchPrivate * priv;
	GeeList* result;
};

struct _VlsNodeSearchClass {
	ValaCodeVisitorClass parent_class;
};

struct _Block31Data {
	int _ref_count_;
	VlsServer* self;
	LspTextDocumentPositionParams* p;
	JsonrpcClient* client;
	gchar* method;
	GVariant* id;
};

struct _Block32Data {
	int _ref_count_;
	VlsServer* self;
	LspTextDocumentPositionParams* p;
	JsonrpcClient* client;
	gchar* method;
	GVariant* id;
};

struct _Block33Data {
	int _ref_count_;
	VlsServer* self;
	LspTextDocumentPositionParams* p;
	JsonrpcClient* client;
	gchar* method;
	GVariant* id;
};

struct _Block34Data {
	int _ref_count_;
	VlsServer* self;
	LspReferenceParams* p;
	JsonrpcClient* client;
	gchar* method;
	GVariant* id;
};

struct _Block35Data {
	int _ref_count_;
	VlsServer* self;
	LspTextDocumentPositionParams* p;
	JsonrpcClient* client;
	gchar* method;
	GVariant* id;
};

typedef enum  {
	FORMATTING_ERROR_FORMAT,
	FORMATTING_ERROR_READ
} FormattingError;
#define FORMATTING_ERROR formatting_error_quark ()

struct _Block36Data {
	int _ref_count_;
	VlsServer* self;
	gchar* query;
	JsonrpcClient* client;
	gchar* method;
	GVariant* id;
};

struct _Block37Data {
	int _ref_count_;
	Block36Data * _data36_;
	JsonArray* json_array;
};

struct _Block38Data {
	int _ref_count_;
	VlsServer* self;
	gchar* new_name;
	LspTextDocumentPositionParams* p;
	JsonrpcClient* client;
	gchar* method;
	GVariant* id;
};

struct _Block39Data {
	int _ref_count_;
	VlsServer* self;
	LspTextDocumentPositionParams* p;
	JsonrpcClient* client;
	gchar* method;
	GVariant* id;
};

static gint VlsServer_private_offset;
static gpointer vls_server_parent_class = NULL;
static gboolean vls_server_received_signal;
static gboolean vls_server_received_signal = FALSE;
VALA_EXTERN GCancellable* vls_server_cancellable;
GCancellable* vls_server_cancellable = NULL;
VALA_EXTERN gboolean opt_version;
gboolean opt_version = FALSE;

VALA_EXTERN GType vls_server_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VlsServer, g_object_unref)
VALA_EXTERN GType lsp_initialize_params_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspInitializeParams, g_object_unref)
VALA_EXTERN gpointer vls_gir_documentation_ref (gpointer instance);
VALA_EXTERN void vls_gir_documentation_unref (gpointer instance);
VALA_EXTERN GParamSpec* vls_param_spec_gir_documentation (const gchar* name,
                                              const gchar* nick,
                                              const gchar* blurb,
                                              GType object_type,
                                              GParamFlags flags);
VALA_EXTERN void vls_value_set_gir_documentation (GValue* value,
                                      gpointer v_object);
VALA_EXTERN void vls_value_take_gir_documentation (GValue* value,
                                       gpointer v_object);
VALA_EXTERN gpointer vls_value_get_gir_documentation (const GValue* value);
VALA_EXTERN GType vls_gir_documentation_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VlsGirDocumentation, vls_gir_documentation_unref)
VALA_EXTERN GType vls_request_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VlsRequest, g_object_unref)
VALA_EXTERN GType vls_project_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VlsProject, g_object_unref)
VALA_EXTERN GType vls_default_project_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VlsDefaultProject, g_object_unref)
VALA_EXTERN GType vls_file_cache_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VlsFileCache, g_object_unref)
VALA_EXTERN VlsFileCache* vls_file_cache_new (void);
VALA_EXTERN VlsFileCache* vls_file_cache_construct (GType object_type);
VALA_EXTERN VlsServer* vls_server_new (GMainLoop* loop);
VALA_EXTERN VlsServer* vls_server_construct (GType object_type,
                                 GMainLoop* loop);
static gboolean vls_server_check_signal (VlsServer* self);
static gboolean _vls_server_check_signal_gsource_func (gpointer self);
static void _vala_array_add23 (guint* * array,
                        gint* length,
                        gint* size,
                        guint value);
VALA_EXTERN guint vls_request_hash (VlsRequest* req);
static guint _vls_request_hash_gee_hash_data_func (gconstpointer v,
                                            gpointer self);
VALA_EXTERN gboolean vls_request_equal (VlsRequest* reqA,
                            VlsRequest* reqB);
static gboolean _vls_request_equal_gee_equal_data_func (gconstpointer a,
                                                 gconstpointer b,
                                                 gpointer self);
static void _g_object_unref0_ (gpointer var);
static void vls_server_real_notification (JsonrpcServer* base,
                                   JsonrpcClient* client,
                                   const gchar* method,
                                   GVariant* parameters);
static void vls_server_exit (VlsServer* self);
static void vls_server_cancel_request (VlsServer* self,
                                JsonrpcClient* client,
                                GVariant* params);
static void vls_server_text_document_did_open (VlsServer* self,
                                        JsonrpcClient* client,
                                        GVariant* params);
static void vls_server_text_document_did_save (VlsServer* self,
                                        JsonrpcClient* client,
                                        GVariant* params);
static void vls_server_text_document_did_close (VlsServer* self,
                                         JsonrpcClient* client,
                                         GVariant* params);
static void vls_server_text_document_did_change (VlsServer* self,
                                          JsonrpcClient* client,
                                          GVariant* params);
static gboolean vls_server_real_handle_call (JsonrpcServer* base,
                                      JsonrpcClient* client,
                                      const gchar* method,
                                      GVariant* id,
                                      GVariant* parameters);
static void vls_server_initialize (VlsServer* self,
                            JsonrpcClient* client,
                            const gchar* method,
                            GVariant* id,
                            GVariant* params);
static void vls_server_shutdown (VlsServer* self);
VALA_EXTERN void vls_server_reply_null (GVariant* id,
                            JsonrpcClient* client,
                            const gchar* method);
static void vls_server_goto_definition (VlsServer* self,
                                 JsonrpcClient* client,
                                 const gchar* method,
                                 GVariant* id,
                                 GVariant* params);
static void vls_server_document_symbol_outline (VlsServer* self,
                                         JsonrpcClient* client,
                                         const gchar* method,
                                         GVariant* id,
                                         GVariant* params);
static void vls_server_show_completion (VlsServer* self,
                                 JsonrpcClient* client,
                                 const gchar* method,
                                 GVariant* id,
                                 GVariant* params);
static void vls_server_show_signature_help (VlsServer* self,
                                     JsonrpcClient* client,
                                     const gchar* method,
                                     GVariant* id,
                                     GVariant* params);
static void vls_server_hover (VlsServer* self,
                       JsonrpcClient* client,
                       const gchar* method,
                       GVariant* id,
                       GVariant* params);
static void vls_server_format (VlsServer* self,
                        JsonrpcClient* client,
                        const gchar* method,
                        GVariant* id,
                        GVariant* params);
static void vls_server_code_action (VlsServer* self,
                             JsonrpcClient* client,
                             const gchar* method,
                             GVariant* id,
                             GVariant* params);
static void vls_server_show_references (VlsServer* self,
                                 JsonrpcClient* client,
                                 const gchar* method,
                                 GVariant* id,
                                 GVariant* params);
static void vls_server_show_implementations (VlsServer* self,
                                      JsonrpcClient* client,
                                      const gchar* method,
                                      GVariant* id,
                                      GVariant* params);
static void vls_server_search_workspace_symbols (VlsServer* self,
                                          JsonrpcClient* client,
                                          const gchar* method,
                                          GVariant* id,
                                          GVariant* params);
static void vls_server_rename_symbol (VlsServer* self,
                               JsonrpcClient* client,
                               const gchar* method,
                               GVariant* id,
                               GVariant* params);
static void vls_server_prepare_rename_symbol (VlsServer* self,
                                       JsonrpcClient* client,
                                       const gchar* method,
                                       GVariant* id,
                                       GVariant* params);
static void vls_server_code_lens (VlsServer* self,
                           JsonrpcClient* client,
                           const gchar* method,
                           GVariant* id,
                           GVariant* params);
static void vls_server_prepare_call_hierarchy (VlsServer* self,
                                        JsonrpcClient* client,
                                        const gchar* method,
                                        GVariant* id,
                                        GVariant* params);
static void vls_server_call_hierarchy_incoming_calls (VlsServer* self,
                                               JsonrpcClient* client,
                                               const gchar* method,
                                               GVariant* id,
                                               GVariant* params);
static void vls_server_call_hierarchy_outgoing_calls (VlsServer* self,
                                               JsonrpcClient* client,
                                               const gchar* method,
                                               GVariant* id,
                                               GVariant* params);
static void vls_server_show_inlay_hints (VlsServer* self,
                                  JsonrpcClient* client,
                                  const gchar* method,
                                  GVariant* id,
                                  GVariant* params);
static void vls_server_prepare_type_hierarchy (VlsServer* self,
                                        JsonrpcClient* client,
                                        const gchar* method,
                                        GVariant* id,
                                        GVariant* params);
static void vls_server_show_type_hierarchy (VlsServer* self,
                                     JsonrpcClient* client,
                                     const gchar* method,
                                     GVariant* id,
                                     GVariant* params,
                                     gboolean supertypes);
static void vls_server_real_client_closed (JsonrpcServer* base,
                                    JsonrpcClient* client);
VALA_EXTERN GVariant* vls_server_build_dict (VlsServer* self,
                                 ...);
VALA_EXTERN GType vls_build_target_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VlsBuildTarget, g_object_unref)
VALA_EXTERN GType vls_compilation_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VlsCompilation, g_object_unref)
static ValaSourceFile* vls_server_find_file (VlsServer* self,
                                      const gchar* uri,
                                      VlsCompilation** compilation,
                                      VlsProject** project);
VALA_EXTERN GType vls_pair_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VlsPair, g_object_unref)
VALA_EXTERN GeeArrayList* vls_project_lookup_compile_input_source_file (VlsProject* self,
                                                            const gchar* escaped_uri);
VALA_EXTERN gconstpointer vls_pair_get_second (VlsPair* self);
VALA_EXTERN gconstpointer vls_pair_get_first (VlsPair* self);
VALA_EXTERN GType lsp_message_type_get_type (void) G_GNUC_CONST ;
static void vls_server_show_message (VlsServer* self,
                              JsonrpcClient* client,
                              const gchar* message,
                              LspMessageType type);
VALA_EXTERN gpointer vls_util_parse_variant (GType t_type,
                                 GBoxedCopyFunc t_dup_func,
                                 GDestroyNotify t_destroy_func,
                                 GVariant* variant);
VALA_EXTERN const gchar* lsp_initialize_params_get_rootUri (LspInitializeParams* self);
VALA_EXTERN const gchar* lsp_initialize_params_get_rootPath (LspInitializeParams* self);
VALA_EXTERN gchar* vls_util_realpath (const gchar* name,
                          const gchar* cwd);
VALA_EXTERN GType lsp_text_document_sync_kind_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GeeArrayList* vls_util_find_files (GFile* dir,
                                   GRegex* basename_pattern,
                                   guint max_depth,
                                   GCancellable* cancellable,
                                   GeeArrayList* found,
                                   GError** error);
VALA_EXTERN GType vls_meson_project_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VlsMesonProject, g_object_unref)
VALA_EXTERN VlsMesonProject* vls_meson_project_new (const gchar* root_path,
                                        VlsFileCache* file_cache,
                                        GCancellable* cancellable,
                                        GError** error);
VALA_EXTERN VlsMesonProject* vls_meson_project_construct (GType object_type,
                                              const gchar* root_path,
                                              VlsFileCache* file_cache,
                                              GCancellable* cancellable,
                                              GError** error);
VALA_EXTERN GQuark vls_project_error_quark (void);
VALA_EXTERN GType vls_project_error_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType vls_cc_project_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VlsCcProject, g_object_unref)
VALA_EXTERN VlsCcProject* vls_cc_project_new (const gchar* root_path,
                                  const gchar* cc_location,
                                  VlsFileCache* file_cache,
                                  GCancellable* cancellable,
                                  GError** error);
VALA_EXTERN VlsCcProject* vls_cc_project_construct (GType object_type,
                                        const gchar* root_path,
                                        const gchar* cc_location,
                                        VlsFileCache* file_cache,
                                        GCancellable* cancellable,
                                        GError** error);
VALA_EXTERN VlsDefaultProject* vls_default_project_new (const gchar* root_path,
                                            VlsFileCache* file_cache);
VALA_EXTERN VlsDefaultProject* vls_default_project_construct (GType object_type,
                                                  const gchar* root_path,
                                                  VlsFileCache* file_cache);
VALA_EXTERN void vls_project_build_if_stale (VlsProject* self,
                                 GCancellable* cancellable,
                                 GError** error);
VALA_EXTERN GeeArrayList* vls_project_get_compilations (VlsProject* self);
static void vls_server_publish_diagnostics (VlsServer* self,
                                     VlsProject* project,
                                     VlsCompilation* target,
                                     JsonrpcClient* client);
VALA_EXTERN guint vls_util_file_hash (GFile* file);
static guint _vls_util_file_hash_gee_hash_data_func (gconstpointer v,
                                              gpointer self);
VALA_EXTERN gboolean vls_util_file_equal (GFile* file1,
                              GFile* file2);
static gboolean _vls_util_file_equal_gee_equal_data_func (gconstpointer a,
                                                   gconstpointer b,
                                                   gpointer self);
VALA_EXTERN GeeCollection* vls_project_get_packages (VlsProject* self);
VALA_EXTERN GeeCollection* vls_project_get_custom_gir_dirs (VlsProject* self);
VALA_EXTERN VlsGirDocumentation* vls_gir_documentation_new (GeeCollection* vala_packages,
                                                GeeCollection* custom_gir_dirs);
VALA_EXTERN VlsGirDocumentation* vls_gir_documentation_construct (GType object_type,
                                                      GeeCollection* vala_packages,
                                                      GeeCollection* custom_gir_dirs);
static gboolean vls_server_check_update_context (VlsServer* self);
static gboolean _vls_server_check_update_context_gsource_func (gpointer self);
static void _vala_array_add24 (guint* * array,
                        gint* length,
                        gint* size,
                        guint value);
static void vls_server_project_changed_event (VlsServer* self);
static void _vls_server_project_changed_event_vls_project_changed (VlsProject* _sender,
                                                            gpointer self);
static void vls_server_request_context_update (VlsServer* self,
                                        JsonrpcClient* client);
VALA_EXTERN VlsRequest* vls_request_new (GVariant* id,
                             const gchar* method);
VALA_EXTERN VlsRequest* vls_request_construct (GType object_type,
                                   GVariant* id,
                                   const gchar* method);
static gchar* _variant_get3 (GVariant* value);
static gchar* _variant_get4 (GVariant* value);
static gchar* _variant_get5 (GVariant* value);
VALA_EXTERN GeeArrayList* vls_project_open (VlsProject* self,
                                const gchar* escaped_uri,
                                const gchar* content,
                                GCancellable* cancellable,
                                GError** error);
VALA_EXTERN void vls_gir_documentation_add_package_from_source_file (VlsGirDocumentation* self,
                                                         ValaSourceFile* vapi_pkg);
VALA_EXTERN GType vls_text_document_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VlsTextDocument, vala_source_file_unref)
VALA_EXTERN void vls_text_document_set_last_saved_content (VlsTextDocument* self,
                                               const gchar* value);
static gchar* _variant_get6 (GVariant* value);
static VlsProject** _vala_array_dup13 (VlsProject** self,
                                gssize length);
static void _vala_array_add25 (VlsProject** * array,
                        gint* length,
                        gint* size,
                        VlsProject* value);
VALA_EXTERN gint vls_text_document_get_last_saved_version (VlsTextDocument* self);
static gchar* _variant_get7 (GVariant* value);
static VlsProject** _vala_array_dup14 (VlsProject** self,
                                gssize length);
static void _vala_array_add26 (VlsProject** * array,
                        gint* length,
                        gint* size,
                        VlsProject* value);
VALA_EXTERN gboolean vls_project_close (VlsProject* self,
                            const gchar* escaped_uri,
                            GError** error);
static gchar* _variant_get8 (GVariant* value);
static gint64 _variant_get9 (GVariant* value);
static VlsProject** _vala_array_dup15 (VlsProject** self,
                                gssize length);
static void _vala_array_add27 (VlsProject** * array,
                        gint* length,
                        gint* size,
                        VlsProject* value);
VALA_EXTERN gint vls_text_document_get_version (VlsTextDocument* self);
VALA_EXTERN GType lsp_text_document_content_change_event_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspTextDocumentContentChangeEvent, g_object_unref)
VALA_EXTERN GType lsp_range_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspRange, g_object_unref)
VALA_EXTERN LspRange* lsp_text_document_content_change_event_get_range (LspTextDocumentContentChangeEvent* self);
VALA_EXTERN const gchar* lsp_text_document_content_change_event_get_text (LspTextDocumentContentChangeEvent* self);
VALA_EXTERN GType lsp_position_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspPosition, g_object_unref)
VALA_EXTERN LspPosition* lsp_range_get_start (LspRange* self);
VALA_EXTERN LspPosition* lsp_range_get_end (LspRange* self);
VALA_EXTERN gsize vls_util_get_string_pos (const gchar* str,
                               guint lineno,
                               guint charno);
VALA_EXTERN guint lsp_position_get_line (LspPosition* self);
VALA_EXTERN guint lsp_position_get_character (LspPosition* self);
VALA_EXTERN void vls_text_document_set_last_updated (VlsTextDocument* self,
                                         GDateTime* value);
VALA_EXTERN void vls_text_document_set_version (VlsTextDocument* self,
                                    gint value);
static VlsProject** _vala_array_dup16 (VlsProject** self,
                                gssize length);
static void _vala_array_add28 (VlsProject** * array,
                        gint* length,
                        gint* size,
                        VlsProject* value);
VALA_EXTERN gboolean vls_project_reconfigure_if_stale (VlsProject* self,
                                           GCancellable* cancellable,
                                           GError** error);
VALA_EXTERN GeeCollection* vls_compilation_get_project_files (VlsCompilation* self);
static gchar* _________lambda49_ (VlsServer* self,
                           ValaSourceFile* f);
static gpointer __________lambda49__gee_map_func (gpointer g,
                                           gpointer self);
VALA_EXTERN ValaCodeContext* vls_compilation_get_code_context (VlsCompilation* self);
VALA_EXTERN void vls_gir_documentation_rebuild_if_stale (VlsGirDocumentation* self);
VALA_EXTERN void vls_server_wait_for_context_update (VlsServer* self,
                                         GVariant* id,
                                         VlsServerOnContextUpdatedFunc on_context_updated_func,
                                         gpointer on_context_updated_func_target,
                                         GDestroyNotify on_context_updated_func_target_destroy_notify);
VALA_EXTERN gchar* vls_request_to_string (VlsRequest* self);
static void vls_server_wait_for_context_update_aux (VlsServer* self,
                                             VlsRequest* req,
                                             VlsServerOnContextUpdatedFunc on_context_updated_func,
                                             gpointer on_context_updated_func_target,
                                             GDestroyNotify on_context_updated_func_target_destroy_notify);
static Block29Data* block29_data_ref (Block29Data* _data29_);
static void block29_data_unref (void * _userdata_);
static gboolean ___lambda50_ (Block29Data* _data29_);
static gboolean ____lambda50__gsource_func (gpointer self);
static Block30Data* block30_data_ref (Block30Data* _data30_);
static void block30_data_unref (void * _userdata_);
VALA_EXTERN const gchar* vls_build_target_get_id (VlsBuildTarget* self);
VALA_EXTERN GType vls_reporter_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VlsReporter, vala_report_unref)
VALA_EXTERN VlsReporter* vls_compilation_get_reporter (VlsCompilation* self);
VALA_EXTERN gpointer vls_source_message_ref (gpointer instance);
VALA_EXTERN void vls_source_message_unref (gpointer instance);
VALA_EXTERN GParamSpec* vls_param_spec_source_message (const gchar* name,
                                           const gchar* nick,
                                           const gchar* blurb,
                                           GType object_type,
                                           GParamFlags flags);
VALA_EXTERN void vls_value_set_source_message (GValue* value,
                                   gpointer v_object);
VALA_EXTERN void vls_value_take_source_message (GValue* value,
                                    gpointer v_object);
VALA_EXTERN gpointer vls_value_get_source_message (const GValue* value);
VALA_EXTERN GType vls_source_message_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VlsSourceMessage, vls_source_message_unref)
static void __lambda48_ (Block30Data* _data30_,
                  VlsSourceMessage* err);
VALA_EXTERN GType lsp_diagnostic_severity_get_type (void) G_GNUC_CONST ;
VALA_EXTERN LspPosition* lsp_position_new (void);
VALA_EXTERN LspPosition* lsp_position_construct (GType object_type);
VALA_EXTERN void lsp_position_set_line (LspPosition* self,
                            guint value);
VALA_EXTERN void lsp_position_set_character (LspPosition* self,
                                 guint value);
VALA_EXTERN LspRange* lsp_range_new (void);
VALA_EXTERN LspRange* lsp_range_construct (GType object_type);
VALA_EXTERN void lsp_range_set_start (LspRange* self,
                          LspPosition* value);
VALA_EXTERN void lsp_range_set_end (LspRange* self,
                        LspPosition* value);
VALA_EXTERN GType lsp_diagnostic_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspDiagnostic, g_object_unref)
VALA_EXTERN LspDiagnostic* lsp_diagnostic_new (void);
VALA_EXTERN LspDiagnostic* lsp_diagnostic_construct (GType object_type);
VALA_EXTERN void lsp_diagnostic_set_range (LspDiagnostic* self,
                               LspRange* value);
VALA_EXTERN void lsp_diagnostic_set_severity (LspDiagnostic* self,
                                  LspDiagnosticSeverity value);
VALA_EXTERN void lsp_diagnostic_set_message (LspDiagnostic* self,
                                 const gchar* value);
static JsonNode* _vala_JsonNode_copy (JsonNode* self);
static void _vala_JsonNode_free (JsonNode* self);
static void ___lambda48__gfunc (gconstpointer data,
                         gpointer self);
VALA_EXTERN const gchar* vls_project_get_root_path (VlsProject* self);
VALA_EXTERN GType vls_node_search_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VlsNodeSearch, vala_code_visitor_unref)
VALA_EXTERN ValaCodeNode* vls_server_get_best (VlsNodeSearch* fs,
                                   ValaSourceFile* file);
VALA_EXTERN LspPosition* lsp_position_new_from_libvala (ValaSourceLocation* sloc);
VALA_EXTERN LspPosition* lsp_position_construct_from_libvala (GType object_type,
                                                  ValaSourceLocation* sloc);
VALA_EXTERN GType lsp_text_document_position_params_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspTextDocumentPositionParams, g_object_unref)
static Block31Data* block31_data_ref (Block31Data* _data31_);
static void block31_data_unref (void * _userdata_);
static void __lambda51_ (Block31Data* _data31_,
                  gboolean request_cancelled);
VALA_EXTERN GType lsp_text_document_identifier_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspTextDocumentIdentifier, g_object_unref)
VALA_EXTERN LspTextDocumentIdentifier* lsp_text_document_position_params_get_textDocument (LspTextDocumentPositionParams* self);
VALA_EXTERN const gchar* lsp_text_document_identifier_get_uri (LspTextDocumentIdentifier* self);
VALA_EXTERN LspPosition* lsp_text_document_position_params_get_position (LspTextDocumentPositionParams* self);
VALA_EXTERN VlsNodeSearch* vls_node_search_new (ValaSourceFile* file,
                                    LspPosition* pos,
                                    gboolean search_multiline,
                                    LspPosition* end_pos,
                                    gboolean must_be_symbol);
VALA_EXTERN VlsNodeSearch* vls_node_search_construct (GType object_type,
                                          ValaSourceFile* file,
                                          LspPosition* pos,
                                          gboolean search_multiline,
                                          LspPosition* end_pos,
                                          gboolean must_be_symbol);
VALA_EXTERN ValaSymbol* vls_symbol_references_get_symbol_data_type_refers_to (ValaDataType* data_type);
VALA_EXTERN ValaSymbol* vls_symbol_references_find_real_symbol (VlsProject* project,
                                                    ValaSymbol* symbol);
VALA_EXTERN GType lsp_location_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspLocation, g_object_unref)
VALA_EXTERN LspLocation* lsp_location_new_from_sourceref (ValaSourceReference* sref);
VALA_EXTERN LspLocation* lsp_location_construct_from_sourceref (GType object_type,
                                                    ValaSourceReference* sref);
VALA_EXTERN const gchar* lsp_location_get_uri (LspLocation* self);
VALA_EXTERN GVariant* vls_util_object_to_variant (GObject* object,
                                      GError** error);
static void ___lambda51__vls_server_on_context_updated_func (gboolean request_cancelled,
                                                      gpointer self);
static Block32Data* block32_data_ref (Block32Data* _data32_);
static void block32_data_unref (void * _userdata_);
static void __lambda52_ (Block32Data* _data32_,
                  gboolean request_cancelled);
VALA_EXTERN GType vls_symbol_enumerator_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VlsSymbolEnumerator, vala_code_visitor_unref)
VALA_EXTERN gpointer vls_compilation_get_analysis_for_file (VlsCompilation* self,
                                                GType t_type,
                                                GBoxedCopyFunc t_dup_func,
                                                GDestroyNotify t_destroy_func,
                                                ValaSourceFile* source);
VALA_EXTERN GType lsp_client_capabilities_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspClientCapabilities, g_object_unref)
VALA_EXTERN LspClientCapabilities* lsp_initialize_params_get_capabilities (LspInitializeParams* self);
VALA_EXTERN GType lsp_text_document_client_capabilities_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspTextDocumentClientCapabilities, g_object_unref)
VALA_EXTERN LspTextDocumentClientCapabilities* lsp_client_capabilities_get_textDocument (LspClientCapabilities* self);
VALA_EXTERN GType lsp_document_symbol_capabilities_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspDocumentSymbolCapabilities, g_object_unref)
VALA_EXTERN LspDocumentSymbolCapabilities* lsp_text_document_client_capabilities_get_documentSymbol (LspTextDocumentClientCapabilities* self);
VALA_EXTERN gboolean lsp_document_symbol_capabilities_get_hierarchicalDocumentSymbolSupport (LspDocumentSymbolCapabilities* self);
VALA_EXTERN GType lsp_document_symbol_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspDocumentSymbol, g_object_unref)
VALA_EXTERN GeeIterator* vls_symbol_enumerator_iterator (VlsSymbolEnumerator* self);
VALA_EXTERN GType lsp_symbol_information_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspSymbolInformation, g_object_unref)
VALA_EXTERN GeeIterable* vls_symbol_enumerator_flattened (VlsSymbolEnumerator* self);
static void ___lambda52__vls_server_on_context_updated_func (gboolean request_cancelled,
                                                      gpointer self);
VALA_EXTERN gpointer vls_doc_comment_ref (gpointer instance);
VALA_EXTERN void vls_doc_comment_unref (gpointer instance);
VALA_EXTERN GParamSpec* vls_param_spec_doc_comment (const gchar* name,
                                        const gchar* nick,
                                        const gchar* blurb,
                                        GType object_type,
                                        GParamFlags flags);
VALA_EXTERN void vls_value_set_doc_comment (GValue* value,
                                gpointer v_object);
VALA_EXTERN void vls_value_take_doc_comment (GValue* value,
                                 gpointer v_object);
VALA_EXTERN gpointer vls_value_get_doc_comment (const GValue* value);
VALA_EXTERN GType vls_doc_comment_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VlsDocComment, vls_doc_comment_unref)
VALA_EXTERN VlsDocComment* vls_server_get_symbol_documentation (VlsServer* self,
                                                    VlsProject* project,
                                                    ValaSymbol* sym);
VALA_EXTERN ValaSymbol* vls_gir_documentation_find_gir_symbol (VlsGirDocumentation* self,
                                                   ValaSymbol* sym);
VALA_EXTERN VlsDocComment* vls_doc_comment_new_from_gir_comment (ValaComment* comment,
                                                     VlsGirDocumentation* documentation,
                                                     VlsCompilation* compilation,
                                                     GError** error);
VALA_EXTERN VlsDocComment* vls_doc_comment_construct_from_gir_comment (GType object_type,
                                                           ValaComment* comment,
                                                           VlsGirDocumentation* documentation,
                                                           VlsCompilation* compilation,
                                                           GError** error);
VALA_EXTERN VlsDocComment* vls_doc_comment_new_from_valadoc_comment (ValaComment* comment,
                                                         ValaSymbol* symbol,
                                                         VlsCompilation* compilation,
                                                         GError** error);
VALA_EXTERN VlsDocComment* vls_doc_comment_construct_from_valadoc_comment (GType object_type,
                                                               ValaComment* comment,
                                                               ValaSymbol* symbol,
                                                               VlsCompilation* compilation,
                                                               GError** error);
VALA_EXTERN GeeHashMap* vls_doc_comment_get_parameters (VlsDocComment* self);
VALA_EXTERN VlsDocComment* vls_doc_comment_new (const gchar* markdown_doc);
VALA_EXTERN VlsDocComment* vls_doc_comment_construct (GType object_type,
                                          const gchar* markdown_doc);
VALA_EXTERN GType lsp_completion_params_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspCompletionParams, g_object_unref)
VALA_EXTERN GType lsp_completion_context_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspCompletionContext, g_object_unref)
VALA_EXTERN void vls_completion_engine_begin_response (VlsServer* lang_serv,
                                           VlsProject* project,
                                           JsonrpcClient* client,
                                           GVariant* id,
                                           const gchar* method,
                                           ValaSourceFile* doc,
                                           VlsCompilation* compilation,
                                           LspPosition* pos,
                                           LspCompletionContext* completion_context);
VALA_EXTERN LspCompletionContext* lsp_completion_params_get_context (LspCompletionParams* self);
VALA_EXTERN void vls_signature_help_engine_begin_response (VlsServer* lang_serv,
                                               VlsProject* project,
                                               JsonrpcClient* client,
                                               GVariant* id,
                                               const gchar* method,
                                               ValaSourceFile* doc,
                                               VlsCompilation* compilation,
                                               LspPosition* pos);
static Block33Data* block33_data_ref (Block33Data* _data33_);
static void block33_data_unref (void * _userdata_);
static void __lambda65_ (Block33Data* _data33_,
                  gboolean request_cancelled);
VALA_EXTERN VlsFindScope* vls_find_scope_new (ValaSourceFile* file,
                                  LspPosition* pos,
                                  gboolean before_context_update);
VALA_EXTERN VlsFindScope* vls_find_scope_construct (GType object_type,
                                        ValaSourceFile* file,
                                        LspPosition* pos,
                                        gboolean before_context_update);
VALA_EXTERN GType vls_find_scope_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VlsFindScope, vala_code_visitor_unref)
VALA_EXTERN ValaSymbol* vls_find_scope_get_best_block (VlsFindScope* self);
VALA_EXTERN GType lsp_hover_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspHover, g_object_unref)
VALA_EXTERN LspHover* lsp_hover_new (void);
VALA_EXTERN LspHover* lsp_hover_construct (GType object_type);
VALA_EXTERN LspRange* vls_symbol_references_get_replacement_range (ValaCodeNode* code_node,
                                                       ValaSymbol* symbol);
VALA_EXTERN gboolean lsp_range_contains (LspRange* self,
                             LspPosition* pos);
VALA_EXTERN GeeCollection* vls_symbol_references_get_visible_components_of_code_node (ValaCodeNode* code_node);
VALA_EXTERN void lsp_hover_set_range (LspHover* self,
                          LspRange* value);
VALA_EXTERN LspRange* lsp_range_new_from_sourceref (ValaSourceReference* sref);
VALA_EXTERN LspRange* lsp_range_construct_from_sourceref (GType object_type,
                                              ValaSourceReference* sref);
VALA_EXTERN gchar* vls_code_help_get_symbol_representation (ValaDataType* data_type,
                                                ValaSymbol* sym,
                                                ValaScope* scope,
                                                gboolean allow_show_parent_member,
                                                ValaList* method_type_arguments,
                                                const gchar* override_name,
                                                gboolean show_initializers,
                                                gboolean is_parent_symbol,
                                                ValaList* ellipsis_overrides,
                                                gboolean show_parameter_direction);
VALA_EXTERN GType lsp_marked_string_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspMarkedString, g_object_unref)
VALA_EXTERN GeeList* lsp_hover_get_contents (LspHover* self);
VALA_EXTERN LspMarkedString* lsp_marked_string_new (void);
VALA_EXTERN LspMarkedString* lsp_marked_string_construct (GType object_type);
VALA_EXTERN void lsp_marked_string_set_language (LspMarkedString* self,
                                     const gchar* value);
VALA_EXTERN void lsp_marked_string_set_value (LspMarkedString* self,
                                  const gchar* value);
VALA_EXTERN const gchar* vls_doc_comment_get_body (VlsDocComment* self);
static void ___lambda65__vls_server_on_context_updated_func (gboolean request_cancelled,
                                                      gpointer self);
VALA_EXTERN GType lsp_document_highlight_kind_get_type (void) G_GNUC_CONST ;
static LspDocumentHighlightKind vls_server_determine_node_highlight_kind (VlsServer* self,
                                                                   ValaCodeNode* node);
VALA_EXTERN GType lsp_reference_params_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspReferenceParams, g_object_unref)
static Block34Data* block34_data_ref (Block34Data* _data34_);
static void block34_data_unref (void * _userdata_);
static void __lambda66_ (Block34Data* _data34_,
                  gboolean request_cancelled);
VALA_EXTERN GType lsp_reference_params_reference_context_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspReferenceParamsReferenceContext, g_object_unref)
VALA_EXTERN LspReferenceParamsReferenceContext* lsp_reference_params_get_context (LspReferenceParams* self);
VALA_EXTERN gboolean lsp_reference_params_reference_context_get_includeDeclaration (LspReferenceParamsReferenceContext* self);
VALA_EXTERN void vls_symbol_references_list_in_file (ValaSourceFile* file,
                                         ValaSymbol* symbol,
                                         gboolean include_declaration,
                                         gboolean include_invisible,
                                         GeeHashMap* references);
VALA_EXTERN GeeArrayList* vls_build_target_get_output (VlsBuildTarget* self);
VALA_EXTERN GeeCollection* vls_symbol_references_get_compilations_using_symbol (VlsProject* project,
                                                                    ValaSymbol* symbol);
VALA_EXTERN GType lsp_document_highlight_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspDocumentHighlight, g_object_unref)
VALA_EXTERN LspDocumentHighlight* lsp_document_highlight_new (void);
VALA_EXTERN LspDocumentHighlight* lsp_document_highlight_construct (GType object_type);
VALA_EXTERN void lsp_document_highlight_set_range (LspDocumentHighlight* self,
                                       LspRange* value);
VALA_EXTERN void lsp_document_highlight_set_kind (LspDocumentHighlight* self,
                                      LspDocumentHighlightKind value);
VALA_EXTERN LspLocation* lsp_location_new (const gchar* filename,
                               LspRange* range);
VALA_EXTERN LspLocation* lsp_location_construct (GType object_type,
                                     const gchar* filename,
                                     LspRange* range);
static void ___lambda66__vls_server_on_context_updated_func (gboolean request_cancelled,
                                                      gpointer self);
static Block35Data* block35_data_ref (Block35Data* _data35_);
static void block35_data_unref (void * _userdata_);
static void __lambda67_ (Block35Data* _data35_,
                  gboolean request_cancelled);
static gboolean _______lambda68_ (ValaCodeNode* needle,
                           ValaCodeNode* node);
static gboolean ________lambda68__vls_node_search_filter (ValaCodeNode* needle,
                                                   ValaCodeNode* hay_node);
VALA_EXTERN VlsNodeSearch* vls_node_search_new_with_filter (ValaSourceFile* file,
                                                ValaCodeNode* needle,
                                                VlsNodeSearchFilter filter_func,
                                                gboolean include_declaration);
VALA_EXTERN VlsNodeSearch* vls_node_search_construct_with_filter (GType object_type,
                                                      ValaSourceFile* file,
                                                      ValaCodeNode* needle,
                                                      VlsNodeSearchFilter filter_func,
                                                      gboolean include_declaration);
static gboolean ________lambda69_ (ValaCodeNode* needle,
                            ValaCodeNode* node);
static gboolean _________lambda69__vls_node_search_filter (ValaCodeNode* needle,
                                                    ValaCodeNode* hay_node);
static gboolean ________lambda70_ (ValaCodeNode* needle,
                            ValaCodeNode* node);
static gboolean _________lambda70__vls_node_search_filter (ValaCodeNode* needle,
                                                    ValaCodeNode* hay_node);
static void ___lambda67__vls_server_on_context_updated_func (gboolean request_cancelled,
                                                      gpointer self);
VALA_EXTERN GType lsp_document_range_formatting_params_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspDocumentRangeFormattingParams, g_object_unref)
VALA_EXTERN LspTextDocumentIdentifier* lsp_document_range_formatting_params_get_textDocument (LspDocumentRangeFormattingParams* self);
VALA_EXTERN GType lsp_text_edit_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspTextEdit, g_object_unref)
VALA_EXTERN GType vls_code_style_analyzer_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VlsCodeStyleAnalyzer, vala_code_visitor_unref)
VALA_EXTERN GType lsp_formatting_options_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspFormattingOptions, g_object_unref)
VALA_EXTERN GQuark formatting_error_quark (void);
VALA_EXTERN GType formatting_error_get_type (void) G_GNUC_CONST ;
VALA_EXTERN LspTextEdit* vls_formatter_format (LspFormattingOptions* options,
                                   VlsCodeStyleAnalyzer* analyzed_style,
                                   ValaSourceFile* source,
                                   LspRange* range,
                                   GCancellable* cancellable,
                                   GError** error);
VALA_EXTERN LspFormattingOptions* lsp_document_range_formatting_params_get_options (LspDocumentRangeFormattingParams* self);
VALA_EXTERN LspRange* lsp_document_range_formatting_params_get_range (LspDocumentRangeFormattingParams* self);
VALA_EXTERN GType lsp_code_action_params_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspCodeActionParams, g_object_unref)
VALA_EXTERN LspTextDocumentIdentifier* lsp_code_action_params_get_textDocument (LspCodeActionParams* self);
VALA_EXTERN GType lsp_code_action_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspCodeAction, g_object_unref)
VALA_EXTERN GType lsp_code_action_context_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspCodeActionContext, g_object_unref)
VALA_EXTERN ValaCollection* vls_code_actions_extract (LspCodeActionContext* context,
                                          VlsCompilation* compilation,
                                          VlsTextDocument* file,
                                          LspRange* range,
                                          const gchar* uri);
VALA_EXTERN LspCodeActionContext* lsp_code_action_params_get_context (LspCodeActionParams* self);
VALA_EXTERN LspRange* lsp_code_action_params_get_range (LspCodeActionParams* self);
static Block36Data* block36_data_ref (Block36Data* _data36_);
static void block36_data_unref (void * _userdata_);
static gchar* _variant_get10 (GVariant* value);
static void __lambda71_ (Block36Data* _data36_,
                  gboolean request_cancelled);
static Block37Data* block37_data_ref (Block37Data* _data37_);
static void block37_data_unref (void * _userdata_);
static VlsProject** _vala_array_dup17 (VlsProject** self,
                                gssize length);
static void _vala_array_add29 (VlsProject** * array,
                        gint* length,
                        gint* size,
                        VlsProject* value);
VALA_EXTERN GeeIterable* vls_project_get_project_source_files (VlsProject* self);
static gboolean _______lambda72_ (Block37Data* _data37_,
                           LspSymbolInformation* dsym);
VALA_EXTERN const gchar* lsp_symbol_information_get_name (LspSymbolInformation* self);
static gboolean ________lambda72__gee_predicate (gconstpointer g,
                                          gpointer self);
static gboolean _______lambda73_ (Block37Data* _data37_,
                           LspSymbolInformation* dsym);
static gboolean ________lambda73__gee_forall_func (gpointer g,
                                            gpointer self);
static void ___lambda71__vls_server_on_context_updated_func (gboolean request_cancelled,
                                                      gpointer self);
static Block38Data* block38_data_ref (Block38Data* _data38_);
static void block38_data_unref (void * _userdata_);
static gchar* _variant_get11 (GVariant* value);
static void __lambda74_ (Block38Data* _data38_,
                  gboolean request_cancelled);
VALA_EXTERN void vls_symbol_references_list_implementations_of_virtual_symbol (ValaSourceFile* file,
                                                                   ValaSymbol* symbol,
                                                                   GeeHashMap* references);
VALA_EXTERN gchar* vls_code_help_get_code_node_source (ValaCodeNode* node);
VALA_EXTERN LspTextEdit* lsp_text_edit_new (LspRange* range,
                                const gchar* new_text);
VALA_EXTERN LspTextEdit* lsp_text_edit_construct (GType object_type,
                                      LspRange* range,
                                      const gchar* new_text);
VALA_EXTERN GType lsp_versioned_text_document_identifier_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspVersionedTextDocumentIdentifier, g_object_unref)
VALA_EXTERN LspVersionedTextDocumentIdentifier* lsp_versioned_text_document_identifier_new (void);
VALA_EXTERN LspVersionedTextDocumentIdentifier* lsp_versioned_text_document_identifier_construct (GType object_type);
VALA_EXTERN void lsp_versioned_text_document_identifier_set_version (LspVersionedTextDocumentIdentifier* self,
                                                         gint value);
VALA_EXTERN void lsp_text_document_identifier_set_uri (LspTextDocumentIdentifier* self,
                                           const gchar* value);
VALA_EXTERN GType lsp_text_document_edit_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspTextDocumentEdit, g_object_unref)
VALA_EXTERN LspTextDocumentEdit* lsp_text_document_edit_new (LspVersionedTextDocumentIdentifier* text_document);
VALA_EXTERN LspTextDocumentEdit* lsp_text_document_edit_construct (GType object_type,
                                                       LspVersionedTextDocumentIdentifier* text_document);
VALA_EXTERN void lsp_text_document_edit_set_edits (LspTextDocumentEdit* self,
                                       GeeArrayList* value);
static void ___lambda74__vls_server_on_context_updated_func (gboolean request_cancelled,
                                                      gpointer self);
static Block39Data* block39_data_ref (Block39Data* _data39_);
static void block39_data_unref (void * _userdata_);
static void __lambda75_ (Block39Data* _data39_,
                  gboolean request_cancelled);
static void ___lambda75__vls_server_on_context_updated_func (gboolean request_cancelled,
                                                      gpointer self);
static gchar* _variant_get12 (GVariant* value);
VALA_EXTERN void vls_code_lens_engine_begin_response (VlsServer* lang_serv,
                                          VlsProject* project,
                                          JsonrpcClient* client,
                                          GVariant* id,
                                          const gchar* method,
                                          ValaSourceFile* doc,
                                          VlsCompilation* compilation);
VALA_EXTERN LspCallHierarchyItem* lsp_call_hierarchy_item_new_from_symbol (ValaSymbol* symbol);
VALA_EXTERN LspCallHierarchyItem* lsp_call_hierarchy_item_construct_from_symbol (GType object_type,
                                                                     ValaSymbol* symbol);
VALA_EXTERN GType lsp_call_hierarchy_item_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspCallHierarchyItem, g_object_unref)
VALA_EXTERN const gchar* lsp_call_hierarchy_item_get_uri (LspCallHierarchyItem* self);
VALA_EXTERN ValaSymbol* vls_code_help_lookup_symbol_full_name (const gchar* full_name,
                                                   ValaScope* scope,
                                                   GeeArrayList** components);
VALA_EXTERN const gchar* lsp_call_hierarchy_item_get_name (LspCallHierarchyItem* self);
VALA_EXTERN GType lsp_call_hierarchy_incoming_call_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspCallHierarchyIncomingCall, g_object_unref)
VALA_EXTERN LspCallHierarchyIncomingCall** vls_call_hierarchy_get_incoming_calls (VlsProject* project,
                                                                      ValaSymbol* callable,
                                                                      gint* result_length1);
static void _vala_array_add30 (GVariant** * array,
                        gint* length,
                        gint* size,
                        GVariant* value);
VALA_EXTERN GType lsp_call_hierarchy_outgoing_call_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspCallHierarchyOutgoingCall, g_object_unref)
VALA_EXTERN LspCallHierarchyOutgoingCall** vls_call_hierarchy_get_outgoing_calls (VlsProject* project,
                                                                      ValaSubroutine* subroutine,
                                                                      gint* result_length1);
static void _vala_array_add31 (GVariant** * array,
                        gint* length,
                        gint* size,
                        GVariant* value);
VALA_EXTERN GType lsp_inlay_hint_params_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspInlayHintParams, g_object_unref)
VALA_EXTERN LspTextDocumentIdentifier* lsp_inlay_hint_params_get_textDocument (LspInlayHintParams* self);
VALA_EXTERN LspRange* lsp_inlay_hint_params_get_range (LspInlayHintParams* self);
VALA_EXTERN VlsNodeSearch* vls_node_search_new_within (ValaSourceFile* file,
                                           LspRange* range,
                                           gboolean must_be_symbol);
VALA_EXTERN VlsNodeSearch* vls_node_search_construct_within (GType object_type,
                                                 ValaSourceFile* file,
                                                 LspRange* range,
                                                 gboolean must_be_symbol);
VALA_EXTERN gchar* lsp_range_to_string (LspRange* self);
VALA_EXTERN GType lsp_inlay_hint_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspInlayHint, g_object_unref)
VALA_EXTERN GeeHashSet* vls_compilation_get_var_decls (VlsCompilation* self);
VALA_EXTERN gchar* vls_code_help_get_data_type_representation (ValaDataType* data_type,
                                                   ValaScope* scope,
                                                   gboolean hide_imported_namespace_parent);
VALA_EXTERN GType lsp_inlay_hint_kind_get_type (void) G_GNUC_CONST ;
VALA_EXTERN LspInlayHint* lsp_inlay_hint_new (void);
VALA_EXTERN LspInlayHint* lsp_inlay_hint_construct (GType object_type);
VALA_EXTERN void lsp_inlay_hint_set_position (LspInlayHint* self,
                                  LspPosition* value);
VALA_EXTERN void lsp_inlay_hint_set_label (LspInlayHint* self,
                               const gchar* value);
VALA_EXTERN void lsp_inlay_hint_set_kind (LspInlayHint* self,
                              LspInlayHintKind value);
VALA_EXTERN void lsp_inlay_hint_set_paddingLeft (LspInlayHint* self,
                                     gboolean value);
static void _vala_array_add32 (LspInlayHint** * array,
                        gint* length,
                        gint* size,
                        LspInlayHint* value);
VALA_EXTERN LspRange* vls_symbol_references_get_narrowed_source_reference (ValaSourceReference* source_reference,
                                                               const gchar* representation,
                                                               gint start,
                                                               gint end);
static void _vala_array_add33 (LspInlayHint** * array,
                        gint* length,
                        gint* size,
                        LspInlayHint* value);
VALA_EXTERN void lsp_inlay_hint_set_paddingRight (LspInlayHint* self,
                                      gboolean value);
static void _vala_array_add34 (LspInlayHint** * array,
                        gint* length,
                        gint* size,
                        LspInlayHint* value);
VALA_EXTERN GeeHashMap* vls_compilation_get_method_calls (VlsCompilation* self);
static void _vala_array_add35 (LspInlayHint** * array,
                        gint* length,
                        gint* size,
                        LspInlayHint* value);
static void _vala_array_add36 (GVariant** * array,
                        gint* length,
                        gint* size,
                        GVariant* value);
VALA_EXTERN LspTypeHierarchyItem* lsp_typehierarchy_item_new_from_symbol (ValaTypeSymbol* symbol);
VALA_EXTERN LspTypeHierarchyItem* lsp_typehierarchy_item_construct_from_symbol (GType object_type,
                                                                    ValaTypeSymbol* symbol);
VALA_EXTERN GType lsp_typehierarchy_item_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspTypeHierarchyItem, g_object_unref)
VALA_EXTERN const gchar* lsp_typehierarchy_item_get_uri (LspTypeHierarchyItem* self);
VALA_EXTERN const gchar* lsp_typehierarchy_item_get_name (LspTypeHierarchyItem* self);
VALA_EXTERN LspTypeHierarchyItem** vls_type_hierarchy_get_supertypes (VlsProject* project,
                                                          ValaTypeSymbol* symbol,
                                                          gint* result_length1);
static void _vala_array_add37 (GVariant** * array,
                        gint* length,
                        gint* size,
                        GVariant* value);
VALA_EXTERN LspTypeHierarchyItem** vls_type_hierarchy_get_subtypes (VlsProject* project,
                                                        ValaTypeSymbol* symbol,
                                                        gint* result_length1);
static void _vala_array_add38 (GVariant** * array,
                        gint* length,
                        gint* size,
                        GVariant* value);
static GVariant* _variant_new1 (GVariant** value,
                         gint value_length1);
static void _vls_server___lambda77_ (void);
static void __vls_server___lambda77____sighandler_t (gint signum);
static void _vls_server___lambda78_ (void);
static void __vls_server___lambda78____sighandler_t (gint signum);
static void vls_server_finalize (GObject * obj);
static GType vls_server_get_type_once (void);
static gint _vala_main (gchar** args,
                 gint args_length1);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static GRegex* _tmp_regex_0 = NULL;
static GRegex* _tmp_regex_1 = NULL;
static GRegex* _tmp_regex_2 = NULL;
const GOptionEntry entries[2] = {{"version", 'v', (gint) G_OPTION_FLAG_NONE, G_OPTION_ARG_NONE, &opt_version, "Print the version and commit info", NULL}, {0}};

static inline gpointer
vls_server_get_instance_private (VlsServer* self)
{
	return G_STRUCT_MEMBER_P (self, VlsServer_private_offset);
}

static gpointer
_g_main_loop_ref0 (gpointer self)
{
	return self ? g_main_loop_ref (self) : NULL;
}

static gboolean
_vls_server_check_signal_gsource_func (gpointer self)
{
	gboolean result;
	result = vls_server_check_signal ((VlsServer*) self);
	return result;
}

static void
_vala_array_add23 (guint* * array,
                   gint* length,
                   gint* size,
                   guint value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (guint, *array, *size);
	}
	(*array)[(*length)++] = value;
}

static guint
_vls_request_hash_gee_hash_data_func (gconstpointer v,
                                      gpointer self)
{
	guint result;
	result = vls_request_hash ((VlsRequest*) v);
	return result;
}

static gboolean
_vls_request_equal_gee_equal_data_func (gconstpointer a,
                                        gconstpointer b,
                                        gpointer self)
{
	gboolean result;
	result = vls_request_equal ((VlsRequest*) a, (VlsRequest*) b);
	return result;
}

static void
_g_object_unref0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
}

VlsServer*
vls_server_construct (GType object_type,
                      GMainLoop* loop)
{
	VlsServer * self = NULL;
	GMainLoop* _tmp0_;
	gint new_stdout_fd = 0;
	GUnixInputStream* input_stream = NULL;
	GUnixInputStream* _tmp1_;
	GUnixOutputStream* output_stream = NULL;
	GUnixOutputStream* _tmp2_;
	GUnixInputStream* _tmp6_;
	GUnixOutputStream* _tmp7_;
	GSimpleIOStream* _tmp8_;
	GSimpleIOStream* _tmp9_;
	GeeHashSet* _tmp10_;
	GHashFunc _tmp11_;
	GEqualFunc _tmp12_;
	GHashTable* _tmp13_;
	GError* _inner_error0_ = NULL;
	g_return_val_if_fail (loop != NULL, NULL);
	self = (VlsServer*) g_object_new (object_type, NULL);
	_tmp0_ = _g_main_loop_ref0 (loop);
	_g_main_loop_unref0 (self->priv->loop);
	self->priv->loop = _tmp0_;
	new_stdout_fd = dup (STDOUT_FILENO);
	close (STDOUT_FILENO);
	dup2 (STDERR_FILENO, STDOUT_FILENO);
	_tmp1_ = (GUnixInputStream*) g_unix_input_stream_new (STDIN_FILENO, FALSE);
	if (_tmp1_) {
		g_object_set_data ((GObject *) _tmp1_, "vala-creation-function", "Vls.Server.new");
	}
	input_stream = _tmp1_;
	_tmp2_ = (GUnixOutputStream*) g_unix_output_stream_new (new_stdout_fd, FALSE);
	if (_tmp2_) {
		g_object_set_data ((GObject *) _tmp2_, "vala-creation-function", "Vls.Server.new");
	}
	output_stream = _tmp2_;
	{
		gboolean _tmp3_ = FALSE;
		gboolean _tmp4_ = FALSE;
		_tmp4_ = g_unix_set_fd_nonblocking (STDIN_FILENO, TRUE, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		if (!_tmp4_) {
			_tmp3_ = TRUE;
		} else {
			gboolean _tmp5_ = FALSE;
			_tmp5_ = g_unix_set_fd_nonblocking (new_stdout_fd, TRUE, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				goto __catch0_g_error;
			}
			_tmp3_ = !_tmp5_;
		}
		if (_tmp3_) {
			g_error ("server.vala:108: could not set pipes to nonblocking.\n");
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		g_clear_error (&_inner_error0_);
		g_warning ("server.vala:110: failed to set FDs to nonblocking");
		g_main_loop_quit (loop);
		_g_object_unref0 (output_stream);
		_g_object_unref0 (input_stream);
		return self;
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_object_unref0 (output_stream);
		_g_object_unref0 (input_stream);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
	_vala_array_add23 (&self->priv->g_sources, &self->priv->g_sources_length1, &self->priv->_g_sources_size_, g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 1000, _vls_server_check_signal_gsource_func, g_object_ref (self), g_object_unref));
	_tmp6_ = input_stream;
	_tmp7_ = output_stream;
	_tmp8_ = (GSimpleIOStream*) g_simple_io_stream_new ((GInputStream*) _tmp6_, (GOutputStream*) _tmp7_);
	if (_tmp8_) {
		g_object_set_data ((GObject *) _tmp8_, "vala-creation-function", "Vls.Server.new");
	}
	_tmp9_ = _tmp8_;
	jsonrpc_server_accept_io_stream ((JsonrpcServer*) self, (GIOStream*) _tmp9_);
	_g_object_unref0 (_tmp9_);
	_tmp10_ = gee_hash_set_new (VLS_TYPE_REQUEST, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _vls_request_hash_gee_hash_data_func, NULL, NULL, _vls_request_equal_gee_equal_data_func, NULL, NULL);
	if (_tmp10_) {
		g_object_set_data ((GObject *) _tmp10_, "vala-creation-function", "Vls.Server.new");
	}
	_g_object_unref0 (self->priv->pending_requests);
	self->priv->pending_requests = _tmp10_;
	_tmp11_ = g_direct_hash;
	_tmp12_ = g_direct_equal;
	_tmp13_ = g_hash_table_new_full (_tmp11_, _tmp12_, _g_object_unref0_, NULL);
	_g_hash_table_unref0 (self->priv->projects);
	self->priv->projects = _tmp13_;
	g_debug ("server.vala:125: Finished constructing");
	_g_object_unref0 (output_stream);
	_g_object_unref0 (input_stream);
	return self;
}

VlsServer*
vls_server_new (GMainLoop* loop)
{
	return vls_server_construct (VLS_TYPE_SERVER, loop);
}

static void
vls_server_real_notification (JsonrpcServer* base,
                              JsonrpcClient* client,
                              const gchar* method,
                              GVariant* parameters)
{
	VlsServer * self;
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
	static GQuark _tmp1_label0 = 0;
	static GQuark _tmp1_label1 = 0;
	static GQuark _tmp1_label2 = 0;
	static GQuark _tmp1_label3 = 0;
	static GQuark _tmp1_label4 = 0;
	static GQuark _tmp1_label5 = 0;
	self = (VlsServer*) base;
	g_return_if_fail (client != NULL);
	g_return_if_fail (method != NULL);
	g_return_if_fail (parameters != NULL);
	_tmp0_ = method;
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("exit")))) {
		switch (0) {
			default:
			{
				vls_server_exit (self);
				break;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string ("$/cancelRequest")))) {
		switch (0) {
			default:
			{
				vls_server_cancel_request (self, client, parameters);
				break;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label2) ? _tmp1_label2 : (_tmp1_label2 = g_quark_from_static_string ("textDocument/didOpen")))) {
		switch (0) {
			default:
			{
				vls_server_text_document_did_open (self, client, parameters);
				break;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label3) ? _tmp1_label3 : (_tmp1_label3 = g_quark_from_static_string ("textDocument/didSave")))) {
		switch (0) {
			default:
			{
				vls_server_text_document_did_save (self, client, parameters);
				break;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label4) ? _tmp1_label4 : (_tmp1_label4 = g_quark_from_static_string ("textDocument/didClose")))) {
		switch (0) {
			default:
			{
				vls_server_text_document_did_close (self, client, parameters);
				break;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label5) ? _tmp1_label5 : (_tmp1_label5 = g_quark_from_static_string ("textDocument/didChange")))) {
		switch (0) {
			default:
			{
				vls_server_text_document_did_change (self, client, parameters);
				break;
			}
		}
	} else {
		switch (0) {
			default:
			{
				g_warning ("server.vala:155: unhandled notification `%s'", method);
				break;
			}
		}
	}
}

static gboolean
vls_server_real_handle_call (JsonrpcServer* base,
                             JsonrpcClient* client,
                             const gchar* method,
                             GVariant* id,
                             GVariant* parameters)
{
	VlsServer * self;
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
	static GQuark _tmp1_label0 = 0;
	static GQuark _tmp1_label1 = 0;
	static GQuark _tmp1_label2 = 0;
	static GQuark _tmp1_label3 = 0;
	static GQuark _tmp1_label4 = 0;
	static GQuark _tmp1_label5 = 0;
	static GQuark _tmp1_label6 = 0;
	static GQuark _tmp1_label7 = 0;
	static GQuark _tmp1_label8 = 0;
	static GQuark _tmp1_label9 = 0;
	static GQuark _tmp1_label10 = 0;
	static GQuark _tmp1_label11 = 0;
	static GQuark _tmp1_label12 = 0;
	static GQuark _tmp1_label13 = 0;
	static GQuark _tmp1_label14 = 0;
	static GQuark _tmp1_label15 = 0;
	static GQuark _tmp1_label16 = 0;
	static GQuark _tmp1_label17 = 0;
	static GQuark _tmp1_label18 = 0;
	static GQuark _tmp1_label19 = 0;
	static GQuark _tmp1_label20 = 0;
	static GQuark _tmp1_label21 = 0;
	static GQuark _tmp1_label22 = 0;
	static GQuark _tmp1_label23 = 0;
	gboolean result;
	self = (VlsServer*) base;
	g_return_val_if_fail (client != NULL, FALSE);
	g_return_val_if_fail (method != NULL, FALSE);
	g_return_val_if_fail (id != NULL, FALSE);
	g_return_val_if_fail (parameters != NULL, FALSE);
	_tmp0_ = method;
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("initialize")))) {
		switch (0) {
			default:
			{
				vls_server_initialize (self, client, method, id, parameters);
				break;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string ("shutdown")))) {
		switch (0) {
			default:
			{
				vls_server_shutdown (self);
				vls_server_reply_null (id, client, method);
				break;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label2) ? _tmp1_label2 : (_tmp1_label2 = g_quark_from_static_string ("textDocument/definition")))) {
		switch (0) {
			default:
			{
				vls_server_goto_definition (self, client, method, id, parameters);
				break;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label3) ? _tmp1_label3 : (_tmp1_label3 = g_quark_from_static_string ("textDocument/documentSymbol")))) {
		switch (0) {
			default:
			{
				vls_server_document_symbol_outline (self, client, method, id, parameters);
				break;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label4) ? _tmp1_label4 : (_tmp1_label4 = g_quark_from_static_string ("textDocument/completion")))) {
		switch (0) {
			default:
			{
				vls_server_show_completion (self, client, method, id, parameters);
				break;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label5) ? _tmp1_label5 : (_tmp1_label5 = g_quark_from_static_string ("textDocument/signatureHelp")))) {
		switch (0) {
			default:
			{
				vls_server_show_signature_help (self, client, method, id, parameters);
				break;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label6) ? _tmp1_label6 : (_tmp1_label6 = g_quark_from_static_string ("textDocument/hover")))) {
		switch (0) {
			default:
			{
				vls_server_hover (self, client, method, id, parameters);
				break;
			}
		}
	} else if ((_tmp2_ == ((0 != _tmp1_label7) ? _tmp1_label7 : (_tmp1_label7 = g_quark_from_static_string ("textDocument/formatting")))) || (_tmp2_ == ((0 != _tmp1_label8) ? _tmp1_label8 : (_tmp1_label8 = g_quark_from_static_string ("textDocument/rangeFormatting"))))) {
		switch (0) {
			default:
			{
				vls_server_format (self, client, method, id, parameters);
				break;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label9) ? _tmp1_label9 : (_tmp1_label9 = g_quark_from_static_string ("textDocument/codeAction")))) {
		switch (0) {
			default:
			{
				vls_server_code_action (self, client, method, id, parameters);
				break;
			}
		}
	} else if ((_tmp2_ == ((0 != _tmp1_label10) ? _tmp1_label10 : (_tmp1_label10 = g_quark_from_static_string ("textDocument/references")))) || (_tmp2_ == ((0 != _tmp1_label11) ? _tmp1_label11 : (_tmp1_label11 = g_quark_from_static_string ("textDocument/documentHighlight"))))) {
		switch (0) {
			default:
			{
				vls_server_show_references (self, client, method, id, parameters);
				break;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label12) ? _tmp1_label12 : (_tmp1_label12 = g_quark_from_static_string ("textDocument/implementation")))) {
		switch (0) {
			default:
			{
				vls_server_show_implementations (self, client, method, id, parameters);
				break;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label13) ? _tmp1_label13 : (_tmp1_label13 = g_quark_from_static_string ("workspace/symbol")))) {
		switch (0) {
			default:
			{
				vls_server_search_workspace_symbols (self, client, method, id, parameters);
				break;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label14) ? _tmp1_label14 : (_tmp1_label14 = g_quark_from_static_string ("textDocument/rename")))) {
		switch (0) {
			default:
			{
				vls_server_rename_symbol (self, client, method, id, parameters);
				break;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label15) ? _tmp1_label15 : (_tmp1_label15 = g_quark_from_static_string ("textDocument/prepareRename")))) {
		switch (0) {
			default:
			{
				vls_server_prepare_rename_symbol (self, client, method, id, parameters);
				break;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label16) ? _tmp1_label16 : (_tmp1_label16 = g_quark_from_static_string ("textDocument/codeLens")))) {
		switch (0) {
			default:
			{
				vls_server_code_lens (self, client, method, id, parameters);
				break;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label17) ? _tmp1_label17 : (_tmp1_label17 = g_quark_from_static_string ("textDocument/prepareCallHierarchy")))) {
		switch (0) {
			default:
			{
				vls_server_prepare_call_hierarchy (self, client, method, id, parameters);
				break;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label18) ? _tmp1_label18 : (_tmp1_label18 = g_quark_from_static_string ("callHierarchy/incomingCalls")))) {
		switch (0) {
			default:
			{
				vls_server_call_hierarchy_incoming_calls (self, client, method, id, parameters);
				break;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label19) ? _tmp1_label19 : (_tmp1_label19 = g_quark_from_static_string ("callHierarchy/outgoingCalls")))) {
		switch (0) {
			default:
			{
				vls_server_call_hierarchy_outgoing_calls (self, client, method, id, parameters);
				break;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label20) ? _tmp1_label20 : (_tmp1_label20 = g_quark_from_static_string ("textDocument/inlayHint")))) {
		switch (0) {
			default:
			{
				vls_server_show_inlay_hints (self, client, method, id, parameters);
				break;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label21) ? _tmp1_label21 : (_tmp1_label21 = g_quark_from_static_string ("textDocument/prepareTypeHierarchy")))) {
		switch (0) {
			default:
			{
				vls_server_prepare_type_hierarchy (self, client, method, id, parameters);
				break;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label22) ? _tmp1_label22 : (_tmp1_label22 = g_quark_from_static_string ("typeHierarchy/supertypes")))) {
		switch (0) {
			default:
			{
				vls_server_show_type_hierarchy (self, client, method, id, parameters, TRUE);
				break;
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label23) ? _tmp1_label23 : (_tmp1_label23 = g_quark_from_static_string ("typeHierarchy/subtypes")))) {
		switch (0) {
			default:
			{
				vls_server_show_type_hierarchy (self, client, method, id, parameters, FALSE);
				break;
			}
		}
	} else {
		switch (0) {
			default:
			{
				g_warning ("server.vala:254: unhandled call `%s'", method);
				result = FALSE;
				return result;
			}
		}
	}
	result = TRUE;
	return result;
}

static void
vls_server_real_client_closed (JsonrpcServer* base,
                               JsonrpcClient* client)
{
	VlsServer * self;
	self = (VlsServer*) base;
	g_return_if_fail (client != NULL);
	vls_server_shutdown (self);
	vls_server_exit (self);
}

static gboolean
vls_server_check_signal (VlsServer* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	if (vls_server_received_signal) {
		vls_server_shutdown (self);
		vls_server_exit (self);
		result = G_SOURCE_REMOVE;
		return result;
	}
	result = !self->priv->shutting_down;
	return result;
}

static gpointer
_g_variant_ref0 (gpointer self)
{
	return self ? g_variant_ref (self) : NULL;
}

GVariant*
vls_server_build_dict (VlsServer* self,
                       ...)
{
	GVariantBuilder* builder = NULL;
	GVariantType* _tmp0_;
	GVariantType* _tmp1_;
	GVariantBuilder* _tmp2_;
	GVariantBuilder* _tmp3_;
	va_list l = {0};
	GVariantBuilder* _tmp12_;
	GVariant* _tmp13_;
	GVariant* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_variant_type_new ("a{sv}");
	_tmp1_ = _tmp0_;
	_tmp2_ = g_variant_builder_new (_tmp1_);
	_tmp3_ = _tmp2_;
	_g_variant_type_free0 (_tmp1_);
	builder = _tmp3_;
	va_start (l, self);
	while (TRUE) {
		gchar* key = NULL;
		const gchar* _tmp4_;
		gchar* _tmp5_;
		const gchar* _tmp6_;
		GVariant* val = NULL;
		GVariant* _tmp7_;
		GVariant* _tmp8_;
		GVariantBuilder* _tmp9_;
		const gchar* _tmp10_;
		GVariant* _tmp11_;
		_tmp4_ = va_arg (l, gchar*);
		_tmp5_ = g_strdup (_tmp4_);
		key = _tmp5_;
		_tmp6_ = key;
		if (_tmp6_ == NULL) {
			_g_free0 (key);
			break;
		}
		_tmp7_ = va_arg (l, GVariant*);
		_tmp8_ = _g_variant_ref0 (_tmp7_);
		val = _tmp8_;
		_tmp9_ = builder;
		_tmp10_ = key;
		_tmp11_ = val;
		g_variant_builder_add (_tmp9_, "{sv}", _tmp10_, _tmp11_, NULL);
		_g_variant_unref0 (val);
		_g_free0 (key);
	}
	_tmp12_ = builder;
	_tmp13_ = g_variant_builder_end (_tmp12_);
	g_variant_ref_sink (_tmp13_);
	result = _tmp13_;
	va_end (l);
	_g_variant_builder_unref0 (builder);
	return result;
}

/**
     * Find a file with a URI. Will pick the first match.
     *
     * @param uri the URI of the file. may contain escape characters
     */
static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static gpointer
_vala_source_file_ref0 (gpointer self)
{
	return self ? vala_source_file_ref (self) : NULL;
}

static ValaSourceFile*
vls_server_find_file (VlsServer* self,
                      const gchar* uri,
                      VlsCompilation** compilation,
                      VlsProject** project)
{
	VlsCompilation* _vala_compilation = NULL;
	VlsProject* _vala_project = NULL;
	GeeArrayList* results = NULL;
	GeeArrayList* _tmp0_;
	VlsProject* selected_project = NULL;
	GHashTable* _tmp1_;
	guint _tmp2_ = 0;
	gconstpointer* _tmp3_;
	VlsProject* _tmp11_;
	VlsProject* _tmp19_;
	ValaSourceFile* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (uri != NULL, NULL);
	_tmp0_ = gee_array_list_new (VLS_TYPE_PAIR, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	if (_tmp0_) {
		g_object_set_data ((GObject *) _tmp0_, "vala-creation-function", "Vls.Server.find_file");
	}
	results = _tmp0_;
	selected_project = NULL;
	_tmp1_ = self->priv->projects;
	_tmp3_ = g_hash_table_get_keys_as_array (_tmp1_, &_tmp2_);
	{
		VlsProject** p_collection = NULL;
		gint p_collection_length1 = 0;
		gint _p_collection_size_ = 0;
		gint p_it = 0;
		p_collection = _tmp3_;
		p_collection_length1 = _tmp2_;
		for (p_it = 0; p_it < p_collection_length1; p_it = p_it + 1) {
			VlsProject* p = NULL;
			p = p_collection[p_it];
			{
				VlsProject* _tmp4_;
				GeeArrayList* _tmp5_;
				GeeArrayList* _tmp6_;
				gboolean _tmp7_;
				gboolean _tmp8_;
				_tmp4_ = p;
				_tmp5_ = vls_project_lookup_compile_input_source_file (_tmp4_, uri);
				_g_object_unref0 (results);
				results = _tmp5_;
				_tmp6_ = results;
				_tmp7_ = gee_collection_get_is_empty ((GeeCollection*) _tmp6_);
				_tmp8_ = _tmp7_;
				if (!_tmp8_) {
					VlsProject* _tmp9_;
					VlsProject* _tmp10_;
					_tmp9_ = p;
					_tmp10_ = _g_object_ref0 (_tmp9_);
					_g_object_unref0 (selected_project);
					selected_project = _tmp10_;
					break;
				}
			}
		}
		p_collection = (g_free (p_collection), NULL);
	}
	_tmp11_ = selected_project;
	if (_tmp11_ == NULL) {
		VlsDefaultProject* _tmp12_;
		GeeArrayList* _tmp13_;
		GeeArrayList* _tmp14_;
		gboolean _tmp15_;
		gboolean _tmp16_;
		_tmp12_ = self->priv->default_project;
		_tmp13_ = vls_project_lookup_compile_input_source_file ((VlsProject*) _tmp12_, uri);
		_g_object_unref0 (results);
		results = _tmp13_;
		_tmp14_ = results;
		_tmp15_ = gee_collection_get_is_empty ((GeeCollection*) _tmp14_);
		_tmp16_ = _tmp15_;
		if (!_tmp16_) {
			VlsDefaultProject* _tmp17_;
			VlsProject* _tmp18_;
			_tmp17_ = self->priv->default_project;
			_tmp18_ = _g_object_ref0 ((VlsProject*) _tmp17_);
			_g_object_unref0 (selected_project);
			selected_project = _tmp18_;
		}
	}
	_tmp19_ = selected_project;
	if (_tmp19_ != NULL) {
		VlsProject* _tmp20_;
		VlsProject* _tmp21_;
		GeeArrayList* _tmp22_;
		gpointer _tmp23_;
		VlsPair* _tmp24_;
		gconstpointer _tmp25_;
		gconstpointer _tmp26_;
		VlsCompilation* _tmp27_;
		GeeArrayList* _tmp28_;
		gpointer _tmp29_;
		VlsPair* _tmp30_;
		gconstpointer _tmp31_;
		gconstpointer _tmp32_;
		ValaSourceFile* _tmp33_;
		ValaSourceFile* _tmp34_;
		_tmp20_ = selected_project;
		_tmp21_ = _g_object_ref0 (_tmp20_);
		_g_object_unref0 (_vala_project);
		_vala_project = _tmp21_;
		_tmp22_ = results;
		_tmp23_ = gee_abstract_list_get ((GeeAbstractList*) _tmp22_, 0);
		_tmp24_ = (VlsPair*) _tmp23_;
		_tmp25_ = vls_pair_get_second (_tmp24_);
		_tmp26_ = _tmp25_;
		_tmp27_ = _g_object_ref0 ((VlsCompilation*) _tmp26_);
		_g_object_unref0 (_vala_compilation);
		_vala_compilation = _tmp27_;
		_g_object_unref0 (_tmp24_);
		_tmp28_ = results;
		_tmp29_ = gee_abstract_list_get ((GeeAbstractList*) _tmp28_, 0);
		_tmp30_ = (VlsPair*) _tmp29_;
		_tmp31_ = vls_pair_get_first (_tmp30_);
		_tmp32_ = _tmp31_;
		_tmp33_ = _vala_source_file_ref0 ((ValaSourceFile*) _tmp32_);
		_tmp34_ = _tmp33_;
		_g_object_unref0 (_tmp30_);
		result = _tmp34_;
		_g_object_unref0 (selected_project);
		_g_object_unref0 (results);
		if (compilation) {
			*compilation = _vala_compilation;
		} else {
			_g_object_unref0 (_vala_compilation);
		}
		if (project) {
			*project = _vala_project;
		} else {
			_g_object_unref0 (_vala_project);
		}
		return result;
	}
	_g_object_unref0 (_vala_project);
	_vala_project = NULL;
	_g_object_unref0 (_vala_compilation);
	_vala_compilation = NULL;
	result = NULL;
	_g_object_unref0 (selected_project);
	_g_object_unref0 (results);
	if (compilation) {
		*compilation = _vala_compilation;
	} else {
		_g_object_unref0 (_vala_compilation);
	}
	if (project) {
		*project = _vala_project;
	} else {
		_g_object_unref0 (_vala_project);
	}
	return result;
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self;
	return result;
}

static void
vls_server_show_message (VlsServer* self,
                         JsonrpcClient* client,
                         const gchar* message,
                         LspMessageType type)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (client != NULL);
	g_return_if_fail (message != NULL);
	if (type == LSP_MESSAGE_TYPE_Error) {
		g_warning ("server.vala:326: %s", message);
	}
	{
		GVariant* _tmp0_;
		GVariant* _tmp1_;
		GVariant* _tmp2_;
		GVariant* _tmp3_;
		GVariant* _tmp4_;
		GVariant* _tmp5_;
		GCancellable* _tmp6_;
		_tmp0_ = g_variant_new_int16 ((gint16) type);
		g_variant_ref_sink (_tmp0_);
		_tmp1_ = _tmp0_;
		_tmp2_ = g_variant_new_string (message);
		g_variant_ref_sink (_tmp2_);
		_tmp3_ = _tmp2_;
		_tmp4_ = vls_server_build_dict (self, "type", _tmp1_, "message", _tmp3_, NULL);
		_tmp5_ = _tmp4_;
		_tmp6_ = vls_server_cancellable;
		jsonrpc_client_send_notification (client, "window/showMessage", _tmp5_, _tmp6_, &_inner_error0_);
		_g_variant_unref0 (_tmp5_);
		_g_variant_unref0 (_tmp3_);
		_g_variant_unref0 (_tmp1_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp7_;
		const gchar* _tmp8_;
		const gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp7_ = e;
		_tmp8_ = _tmp7_->message;
		_tmp9_ = string_to_string (_tmp8_);
		_tmp10_ = g_strconcat ("showMessage: failed to notify client: ", _tmp9_, NULL);
		_tmp11_ = _tmp10_;
		g_debug ("server.vala:333: %s", _tmp11_);
		_g_free0 (_tmp11_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

static inline GRegex*
_thread_safe_regex_init (GRegex** re,
                         const gchar * pattern,
                         GRegexCompileFlags compile_flags)
{
	if (g_once_init_enter ((gsize*) re)) {
		GRegex* val = g_regex_new (pattern, compile_flags, 0, NULL);
		g_once_init_leave ((gsize*) re, (gsize) val);
	}
	return *re;
}

static guint
_vls_util_file_hash_gee_hash_data_func (gconstpointer v,
                                        gpointer self)
{
	guint result;
	result = vls_util_file_hash ((GFile*) v);
	return result;
}

static gboolean
_vls_util_file_equal_gee_equal_data_func (gconstpointer a,
                                          gconstpointer b,
                                          gpointer self)
{
	gboolean result;
	result = vls_util_file_equal ((GFile*) a, (GFile*) b);
	return result;
}

static gboolean
_vls_server_check_update_context_gsource_func (gpointer self)
{
	gboolean result;
	result = vls_server_check_update_context ((VlsServer*) self);
	return result;
}

static void
_vala_array_add24 (guint* * array,
                   gint* length,
                   gint* size,
                   guint value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (guint, *array, *size);
	}
	(*array)[(*length)++] = value;
}

static void
_vls_server_project_changed_event_vls_project_changed (VlsProject* _sender,
                                                       gpointer self)
{
	vls_server_project_changed_event ((VlsServer*) self);
}

static void
vls_server_initialize (VlsServer* self,
                       JsonrpcClient* client,
                       const gchar* method,
                       GVariant* id,
                       GVariant* params)
{
	gpointer _tmp0_;
	GFile* root_dir = NULL;
	LspInitializeParams* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	GFile* _tmp18_;
	gchar* root_path = NULL;
	GFile* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	gchar* _tmp23_;
	const gchar* _tmp24_;
	const gchar* _tmp25_;
	gchar* _tmp26_;
	gchar* _tmp27_;
	GFile* meson_file = NULL;
	GFile* _tmp96_;
	GFile* _tmp97_;
	GeeArrayList* cc_files = NULL;
	GeeArrayList* _tmp98_;
	GeeArrayList* new_projects = NULL;
	GeeArrayList* _tmp108_;
	VlsProject* backend_project = NULL;
	GFile* _tmp109_;
	GCancellable* _tmp110_;
	gboolean _tmp123_ = FALSE;
	VlsProject* _tmp124_;
	VlsProject* _tmp152_;
	const gchar* _tmp163_;
	VlsFileCache* _tmp164_;
	VlsDefaultProject* _tmp165_;
	GeeHashSet* packages = NULL;
	GeeHashSet* _tmp191_;
	GeeHashSet* custom_gir_dirs = NULL;
	GeeHashSet* _tmp192_;
	GeeHashSet* _tmp209_;
	GeeHashSet* _tmp210_;
	VlsGirDocumentation* _tmp211_;
	JsonrpcClient* _tmp212_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (client != NULL);
	g_return_if_fail (method != NULL);
	g_return_if_fail (id != NULL);
	g_return_if_fail (params != NULL);
	_tmp0_ = vls_util_parse_variant (LSP_TYPE_INITIALIZE_PARAMS, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, params);
	_g_object_unref0 (self->priv->init_params);
	self->priv->init_params = (LspInitializeParams*) _tmp0_;
	_tmp1_ = self->priv->init_params;
	_tmp2_ = lsp_initialize_params_get_rootUri (_tmp1_);
	_tmp3_ = _tmp2_;
	if (_tmp3_ != NULL) {
		LspInitializeParams* _tmp4_;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		GFile* _tmp7_;
		_tmp4_ = self->priv->init_params;
		_tmp5_ = lsp_initialize_params_get_rootUri (_tmp4_);
		_tmp6_ = _tmp5_;
		_tmp7_ = g_file_new_for_uri (_tmp6_);
		_g_object_unref0 (root_dir);
		root_dir = _tmp7_;
	} else {
		LspInitializeParams* _tmp8_;
		const gchar* _tmp9_;
		const gchar* _tmp10_;
		_tmp8_ = self->priv->init_params;
		_tmp9_ = lsp_initialize_params_get_rootPath (_tmp8_);
		_tmp10_ = _tmp9_;
		if (_tmp10_ != NULL) {
			LspInitializeParams* _tmp11_;
			const gchar* _tmp12_;
			const gchar* _tmp13_;
			GFile* _tmp14_;
			_tmp11_ = self->priv->init_params;
			_tmp12_ = lsp_initialize_params_get_rootPath (_tmp11_);
			_tmp13_ = _tmp12_;
			_tmp14_ = g_file_new_for_path (_tmp13_);
			_g_object_unref0 (root_dir);
			root_dir = _tmp14_;
		} else {
			gchar* _tmp15_;
			gchar* _tmp16_;
			GFile* _tmp17_;
			_tmp15_ = g_get_current_dir ();
			_tmp16_ = _tmp15_;
			_tmp17_ = g_file_new_for_path (_tmp16_);
			_g_object_unref0 (root_dir);
			root_dir = _tmp17_;
			_g_free0 (_tmp16_);
		}
	}
	_tmp18_ = root_dir;
	if (!g_file_is_native (_tmp18_)) {
		vls_server_show_message (self, client, "Non-native files not supported", LSP_MESSAGE_TYPE_Error);
		g_error ("server.vala:349: Non-native files not supported");
	}
	_tmp19_ = root_dir;
	_tmp20_ = g_file_get_path (_tmp19_);
	_tmp21_ = (gchar*) _tmp20_;
	_tmp22_ = vls_util_realpath (_tmp21_, NULL);
	_tmp23_ = _tmp22_;
	_g_free0 (_tmp21_);
	root_path = _tmp23_;
	_tmp24_ = root_path;
	_tmp25_ = string_to_string (_tmp24_);
	_tmp26_ = g_strconcat ("[initialize] root path is ", _tmp25_, NULL);
	_tmp27_ = _tmp26_;
	g_debug ("server.vala:352: %s", _tmp27_);
	_g_free0 (_tmp27_);
	{
		GVariant* _tmp28_;
		GVariant* _tmp29_;
		GVariant* _tmp30_;
		GVariant* _tmp31_;
		GVariant* _tmp32_;
		GVariant* _tmp33_;
		gchar* _tmp34_;
		gchar* _tmp35_;
		gchar** _tmp36_;
		gchar** _tmp37_;
		gint _tmp37__length1;
		GVariant* _tmp38_;
		GVariant* _tmp39_;
		GVariant* _tmp40_;
		GVariant* _tmp41_;
		gchar* _tmp42_;
		gchar* _tmp43_;
		gchar* _tmp44_;
		gchar** _tmp45_;
		gchar** _tmp46_;
		gint _tmp46__length1;
		GVariant* _tmp47_;
		GVariant* _tmp48_;
		GVariant* _tmp49_;
		GVariant* _tmp50_;
		GVariant* _tmp51_;
		GVariant* _tmp52_;
		GVariant* _tmp53_;
		GVariant* _tmp54_;
		GVariant* _tmp55_;
		GVariant* _tmp56_;
		GVariant* _tmp57_;
		GVariant* _tmp58_;
		GVariant* _tmp59_;
		GVariant* _tmp60_;
		GVariant* _tmp61_;
		GVariant* _tmp62_;
		GVariant* _tmp63_;
		GVariant* _tmp64_;
		GVariant* _tmp65_;
		GVariant* _tmp66_;
		GVariant* _tmp67_;
		GVariant* _tmp68_;
		GVariant* _tmp69_;
		GVariant* _tmp70_;
		GVariant* _tmp71_;
		GVariant* _tmp72_;
		GVariant* _tmp73_;
		GVariant* _tmp74_;
		GVariant* _tmp75_;
		GVariant* _tmp76_;
		GVariant* _tmp77_;
		GVariant* _tmp78_;
		GVariant* _tmp79_;
		GVariant* _tmp80_;
		GVariant* _tmp81_;
		GVariant* _tmp82_;
		GVariant* _tmp83_;
		GVariant* _tmp84_;
		GVariant* _tmp85_;
		GVariant* _tmp86_;
		GVariant* _tmp87_;
		GVariant* _tmp88_;
		GVariant* _tmp89_;
		GVariant* _tmp90_;
		GCancellable* _tmp91_;
		_tmp28_ = g_variant_new_int16 ((gint16) LSP_TEXT_DOCUMENT_SYNC_KIND_Incremental);
		g_variant_ref_sink (_tmp28_);
		_tmp29_ = _tmp28_;
		_tmp30_ = g_variant_new_boolean (TRUE);
		g_variant_ref_sink (_tmp30_);
		_tmp31_ = _tmp30_;
		_tmp32_ = g_variant_new_boolean (TRUE);
		g_variant_ref_sink (_tmp32_);
		_tmp33_ = _tmp32_;
		_tmp34_ = g_strdup (".");
		_tmp35_ = g_strdup (">");
		_tmp36_ = g_new0 (gchar*, 2 + 1);
		_tmp36_[0] = _tmp34_;
		_tmp36_[1] = _tmp35_;
		_tmp37_ = _tmp36_;
		_tmp37__length1 = 2;
		_tmp38_ = g_variant_new_strv (_tmp37_, 2);
		g_variant_ref_sink (_tmp38_);
		_tmp39_ = _tmp38_;
		_tmp40_ = vls_server_build_dict (self, "triggerCharacters", _tmp39_, NULL);
		_tmp41_ = _tmp40_;
		_tmp42_ = g_strdup ("(");
		_tmp43_ = g_strdup ("[");
		_tmp44_ = g_strdup (",");
		_tmp45_ = g_new0 (gchar*, 3 + 1);
		_tmp45_[0] = _tmp42_;
		_tmp45_[1] = _tmp43_;
		_tmp45_[2] = _tmp44_;
		_tmp46_ = _tmp45_;
		_tmp46__length1 = 3;
		_tmp47_ = g_variant_new_strv (_tmp46_, 3);
		g_variant_ref_sink (_tmp47_);
		_tmp48_ = _tmp47_;
		_tmp49_ = vls_server_build_dict (self, "triggerCharacters", _tmp48_, NULL);
		_tmp50_ = _tmp49_;
		_tmp51_ = g_variant_new_boolean (TRUE);
		g_variant_ref_sink (_tmp51_);
		_tmp52_ = _tmp51_;
		_tmp53_ = g_variant_new_boolean (TRUE);
		g_variant_ref_sink (_tmp53_);
		_tmp54_ = _tmp53_;
		_tmp55_ = g_variant_new_boolean (TRUE);
		g_variant_ref_sink (_tmp55_);
		_tmp56_ = _tmp55_;
		_tmp57_ = g_variant_new_boolean (TRUE);
		g_variant_ref_sink (_tmp57_);
		_tmp58_ = _tmp57_;
		_tmp59_ = g_variant_new_boolean (TRUE);
		g_variant_ref_sink (_tmp59_);
		_tmp60_ = _tmp59_;
		_tmp61_ = g_variant_new_boolean (TRUE);
		g_variant_ref_sink (_tmp61_);
		_tmp62_ = _tmp61_;
		_tmp63_ = g_variant_new_boolean (TRUE);
		g_variant_ref_sink (_tmp63_);
		_tmp64_ = _tmp63_;
		_tmp65_ = g_variant_new_boolean (TRUE);
		g_variant_ref_sink (_tmp65_);
		_tmp66_ = _tmp65_;
		_tmp67_ = g_variant_new_boolean (TRUE);
		g_variant_ref_sink (_tmp67_);
		_tmp68_ = _tmp67_;
		_tmp69_ = vls_server_build_dict (self, "prepareProvider", _tmp68_, NULL);
		_tmp70_ = _tmp69_;
		_tmp71_ = g_variant_new_boolean (FALSE);
		g_variant_ref_sink (_tmp71_);
		_tmp72_ = _tmp71_;
		_tmp73_ = vls_server_build_dict (self, "resolveProvider", _tmp72_, NULL);
		_tmp74_ = _tmp73_;
		_tmp75_ = g_variant_new_boolean (TRUE);
		g_variant_ref_sink (_tmp75_);
		_tmp76_ = _tmp75_;
		_tmp77_ = g_variant_new_boolean (TRUE);
		g_variant_ref_sink (_tmp77_);
		_tmp78_ = _tmp77_;
		_tmp79_ = g_variant_new_boolean (TRUE);
		g_variant_ref_sink (_tmp79_);
		_tmp80_ = _tmp79_;
		_tmp81_ = vls_server_build_dict (self, "textDocumentSync", _tmp29_, "definitionProvider", _tmp31_, "documentSymbolProvider", _tmp33_, "completionProvider", _tmp41_, "signatureHelpProvider", _tmp50_, "codeActionProvider", _tmp52_, "hoverProvider", _tmp54_, "referencesProvider", _tmp56_, "documentHighlightProvider", _tmp58_, "documentFormattingProvider", _tmp60_, "documentRangeFormattingProvider", _tmp62_, "implementationProvider", _tmp64_, "workspaceSymbolProvider", _tmp66_, "renameProvider", _tmp70_, "codeLensProvider", _tmp74_, "callHierarchyProvider", _tmp76_, "inlayHintProvider", _tmp78_, "typeHierarchyProvider", _tmp80_, NULL);
		_tmp82_ = _tmp81_;
		_tmp83_ = g_variant_new_string ("Vala Language Server");
		g_variant_ref_sink (_tmp83_);
		_tmp84_ = _tmp83_;
		_tmp85_ = g_variant_new_string (CONFIG_PROJECT_VERSION);
		g_variant_ref_sink (_tmp85_);
		_tmp86_ = _tmp85_;
		_tmp87_ = vls_server_build_dict (self, "name", _tmp84_, "version", _tmp86_, NULL);
		_tmp88_ = _tmp87_;
		_tmp89_ = vls_server_build_dict (self, "capabilities", _tmp82_, "serverInfo", _tmp88_, NULL);
		_tmp90_ = _tmp89_;
		_tmp91_ = vls_server_cancellable;
		jsonrpc_client_reply (client, id, _tmp90_, _tmp91_, &_inner_error0_);
		_g_variant_unref0 (_tmp90_);
		_g_variant_unref0 (_tmp88_);
		_g_variant_unref0 (_tmp86_);
		_g_variant_unref0 (_tmp84_);
		_g_variant_unref0 (_tmp82_);
		_g_variant_unref0 (_tmp80_);
		_g_variant_unref0 (_tmp78_);
		_g_variant_unref0 (_tmp76_);
		_g_variant_unref0 (_tmp74_);
		_g_variant_unref0 (_tmp72_);
		_g_variant_unref0 (_tmp70_);
		_g_variant_unref0 (_tmp68_);
		_g_variant_unref0 (_tmp66_);
		_g_variant_unref0 (_tmp64_);
		_g_variant_unref0 (_tmp62_);
		_g_variant_unref0 (_tmp60_);
		_g_variant_unref0 (_tmp58_);
		_g_variant_unref0 (_tmp56_);
		_g_variant_unref0 (_tmp54_);
		_g_variant_unref0 (_tmp52_);
		_g_variant_unref0 (_tmp50_);
		_g_variant_unref0 (_tmp48_);
		_tmp46_ = (_vala_array_free (_tmp46_, _tmp46__length1, (GDestroyNotify) g_free), NULL);
		_g_variant_unref0 (_tmp41_);
		_g_variant_unref0 (_tmp39_);
		_tmp37_ = (_vala_array_free (_tmp37_, _tmp37__length1, (GDestroyNotify) g_free), NULL);
		_g_variant_unref0 (_tmp33_);
		_g_variant_unref0 (_tmp31_);
		_g_variant_unref0 (_tmp29_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp92_;
		const gchar* _tmp93_;
		gchar* _tmp94_;
		gchar* _tmp95_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp92_ = e->message;
		_tmp93_ = string_to_string (_tmp92_);
		_tmp94_ = g_strconcat ("[initialize] failed to reply to client: ", _tmp93_, NULL);
		_tmp95_ = _tmp94_;
		g_error ("server.vala:387: %s", _tmp95_);
		_g_free0 (_tmp95_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_free0 (root_path);
		_g_object_unref0 (root_dir);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	_tmp96_ = root_dir;
	_tmp97_ = g_file_get_child (_tmp96_, "meson.build");
	meson_file = _tmp97_;
	_tmp98_ = gee_array_list_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	if (_tmp98_) {
		g_object_set_data ((GObject *) _tmp98_, "vala-creation-function", "Vls.Server.initialize");
	}
	cc_files = _tmp98_;
	{
		GeeArrayList* _tmp99_ = NULL;
		GFile* _tmp100_;
		GeeArrayList* _tmp101_;
		GeeArrayList* _tmp102_;
		GeeArrayList* _tmp103_;
		GeeArrayList* _tmp104_;
		GeeArrayList* _tmp105_;
		_tmp100_ = root_dir;
		_tmp101_ = gee_array_list_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
		if (_tmp101_) {
			g_object_set_data ((GObject *) _tmp101_, "vala-creation-function", "Vls.Server.initialize");
		}
		_tmp102_ = _tmp101_;
		_tmp103_ = vls_util_find_files (_tmp100_, _thread_safe_regex_init (&_tmp_regex_0, "compile_commands\\.json", 0), (guint) 2, NULL, _tmp102_, &_inner_error0_);
		_tmp104_ = _tmp103_;
		_g_object_unref0 (_tmp102_);
		_tmp99_ = _tmp104_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch1_g_error;
		}
		_tmp105_ = _tmp99_;
		_tmp99_ = NULL;
		_g_object_unref0 (cc_files);
		cc_files = _tmp105_;
		_g_object_unref0 (_tmp99_);
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		GError* _tmp106_;
		const gchar* _tmp107_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp106_ = e;
		_tmp107_ = _tmp106_->message;
		g_warning ("server.vala:395: could not enumerate root dir - %s", _tmp107_);
		_g_error_free0 (e);
	}
	__finally1:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_object_unref0 (cc_files);
		_g_object_unref0 (meson_file);
		_g_free0 (root_path);
		_g_object_unref0 (root_dir);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	_tmp108_ = gee_array_list_new (VLS_TYPE_PROJECT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
	if (_tmp108_) {
		g_object_set_data ((GObject *) _tmp108_, "vala-creation-function", "Vls.Server.initialize");
	}
	new_projects = _tmp108_;
	backend_project = NULL;
	_tmp109_ = meson_file;
	_tmp110_ = vls_server_cancellable;
	if (g_file_query_exists (_tmp109_, _tmp110_)) {
		{
			VlsMesonProject* _tmp111_ = NULL;
			const gchar* _tmp112_;
			VlsFileCache* _tmp113_;
			GCancellable* _tmp114_;
			VlsMesonProject* _tmp115_;
			VlsMesonProject* _tmp116_;
			_tmp112_ = root_path;
			_tmp113_ = self->priv->file_cache;
			_tmp114_ = vls_server_cancellable;
			_tmp115_ = vls_meson_project_new (_tmp112_, _tmp113_, _tmp114_, &_inner_error0_);
			if (_tmp115_) {
				g_object_set_data ((GObject *) _tmp115_, "vala-creation-function", "Vls.Server.initialize");
			}
			_tmp111_ = _tmp115_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				goto __catch2_g_error;
			}
			_tmp116_ = _tmp111_;
			_tmp111_ = NULL;
			_g_object_unref0 (backend_project);
			backend_project = (VlsProject*) _tmp116_;
			_g_object_unref0 (_tmp111_);
		}
		goto __finally2;
		__catch2_g_error:
		{
			GError* e = NULL;
			GError* _tmp117_;
			e = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp117_ = e;
			if (!g_error_matches (_tmp117_, VLS_PROJECT_ERROR, VLS_PROJECT_ERROR_VERSION_UNSUPPORTED)) {
				GError* _tmp118_;
				const gchar* _tmp119_;
				const gchar* _tmp120_;
				gchar* _tmp121_;
				gchar* _tmp122_;
				_tmp118_ = e;
				_tmp119_ = _tmp118_->message;
				_tmp120_ = string_to_string (_tmp119_);
				_tmp121_ = g_strconcat ("Failed to initialize Meson project - ", _tmp120_, NULL);
				_tmp122_ = _tmp121_;
				vls_server_show_message (self, client, _tmp122_, LSP_MESSAGE_TYPE_Error);
				_g_free0 (_tmp122_);
			}
			_g_error_free0 (e);
		}
		__finally2:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (backend_project);
			_g_object_unref0 (new_projects);
			_g_object_unref0 (cc_files);
			_g_object_unref0 (meson_file);
			_g_free0 (root_path);
			_g_object_unref0 (root_dir);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_tmp124_ = backend_project;
	if (_tmp124_ == NULL) {
		GeeArrayList* _tmp125_;
		gboolean _tmp126_;
		gboolean _tmp127_;
		_tmp125_ = cc_files;
		_tmp126_ = gee_collection_get_is_empty ((GeeCollection*) _tmp125_);
		_tmp127_ = _tmp126_;
		_tmp123_ = !_tmp127_;
	} else {
		_tmp123_ = FALSE;
	}
	if (_tmp123_) {
		{
			GeeArrayList* _cc_file_list = NULL;
			GeeArrayList* _tmp128_;
			gint _cc_file_size = 0;
			GeeArrayList* _tmp129_;
			gint _tmp130_;
			gint _tmp131_;
			gint _cc_file_index = 0;
			_tmp128_ = cc_files;
			_cc_file_list = _tmp128_;
			_tmp129_ = _cc_file_list;
			_tmp130_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp129_);
			_tmp131_ = _tmp130_;
			_cc_file_size = _tmp131_;
			_cc_file_index = -1;
			while (TRUE) {
				gint _tmp132_;
				gint _tmp133_;
				GFile* cc_file = NULL;
				GeeArrayList* _tmp134_;
				gpointer _tmp135_;
				gchar* cc_file_path = NULL;
				GFile* _tmp136_;
				gchar* _tmp137_;
				gchar* _tmp138_;
				gchar* _tmp139_;
				gchar* _tmp140_;
				_cc_file_index = _cc_file_index + 1;
				_tmp132_ = _cc_file_index;
				_tmp133_ = _cc_file_size;
				if (!(_tmp132_ < _tmp133_)) {
					break;
				}
				_tmp134_ = _cc_file_list;
				_tmp135_ = gee_abstract_list_get ((GeeAbstractList*) _tmp134_, _cc_file_index);
				cc_file = (GFile*) _tmp135_;
				_tmp136_ = cc_file;
				_tmp137_ = g_file_get_path (_tmp136_);
				_tmp138_ = _tmp137_;
				_tmp139_ = vls_util_realpath (_tmp138_, NULL);
				_tmp140_ = _tmp139_;
				_g_free0 (_tmp138_);
				cc_file_path = _tmp140_;
				{
					VlsCcProject* _tmp141_ = NULL;
					const gchar* _tmp142_;
					const gchar* _tmp143_;
					VlsFileCache* _tmp144_;
					GCancellable* _tmp145_;
					VlsCcProject* _tmp146_;
					VlsCcProject* _tmp147_;
					const gchar* _tmp148_;
					_tmp142_ = root_path;
					_tmp143_ = cc_file_path;
					_tmp144_ = self->priv->file_cache;
					_tmp145_ = vls_server_cancellable;
					_tmp146_ = vls_cc_project_new (_tmp142_, _tmp143_, _tmp144_, _tmp145_, &_inner_error0_);
					if (_tmp146_) {
						g_object_set_data ((GObject *) _tmp146_, "vala-creation-function", "Vls.Server.initialize");
					}
					_tmp141_ = _tmp146_;
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						goto __catch3_g_error;
					}
					_tmp147_ = _tmp141_;
					_tmp141_ = NULL;
					_g_object_unref0 (backend_project);
					backend_project = (VlsProject*) _tmp147_;
					_tmp148_ = cc_file_path;
					g_debug ("server.vala:417: [initialize] initialized CcProject with %s", _tmp148_);
					_g_object_unref0 (_tmp141_);
					_g_free0 (cc_file_path);
					_g_object_unref0 (cc_file);
					break;
				}
				goto __finally3;
				__catch3_g_error:
				{
					GError* e = NULL;
					const gchar* _tmp149_;
					GError* _tmp150_;
					const gchar* _tmp151_;
					e = _inner_error0_;
					_inner_error0_ = NULL;
					_tmp149_ = cc_file_path;
					_tmp150_ = e;
					_tmp151_ = _tmp150_->message;
					g_debug ("server.vala:420: [initialize] CcProject failed with %s - %s", _tmp149_, _tmp151_);
					_g_error_free0 (e);
					_g_free0 (cc_file_path);
					_g_object_unref0 (cc_file);
					continue;
				}
				__finally3:
				_g_free0 (cc_file_path);
				_g_object_unref0 (cc_file);
				_g_object_unref0 (backend_project);
				_g_object_unref0 (new_projects);
				_g_object_unref0 (cc_files);
				_g_object_unref0 (meson_file);
				_g_free0 (root_path);
				_g_object_unref0 (root_dir);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
		}
	}
	_tmp152_ = backend_project;
	if (_tmp152_ == NULL) {
		GFile* cmake_file = NULL;
		GFile* _tmp153_;
		GFile* _tmp154_;
		GFile* autogen_sh = NULL;
		GFile* _tmp155_;
		GFile* _tmp156_;
		GFile* _tmp157_;
		GCancellable* _tmp158_;
		GFile* _tmp159_;
		GCancellable* _tmp160_;
		_tmp153_ = root_dir;
		_tmp154_ = g_file_get_child (_tmp153_, "CMakeLists.txt");
		cmake_file = _tmp154_;
		_tmp155_ = root_dir;
		_tmp156_ = g_file_get_child (_tmp155_, "autogen.sh");
		autogen_sh = _tmp156_;
		_tmp157_ = cmake_file;
		_tmp158_ = vls_server_cancellable;
		if (g_file_query_exists (_tmp157_, _tmp158_)) {
			vls_server_show_message (self, client, "CMake build system is not currently supported. Only Meson is. See http" \
"s://github.com/vala-lang/vala-language-server/issues/73", LSP_MESSAGE_TYPE_Warning);
		}
		_tmp159_ = autogen_sh;
		_tmp160_ = vls_server_cancellable;
		if (g_file_query_exists (_tmp159_, _tmp160_)) {
			vls_server_show_message (self, client, "Autotools build system is not currently supported. Consider switching " \
"to Meson.", LSP_MESSAGE_TYPE_Warning);
		}
		_g_object_unref0 (autogen_sh);
		_g_object_unref0 (cmake_file);
	} else {
		GeeArrayList* _tmp161_;
		VlsProject* _tmp162_;
		_tmp161_ = new_projects;
		_tmp162_ = backend_project;
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp161_, _tmp162_);
	}
	_tmp163_ = root_path;
	_tmp164_ = self->priv->file_cache;
	_tmp165_ = vls_default_project_new (_tmp163_, _tmp164_);
	if (_tmp165_) {
		g_object_set_data ((GObject *) _tmp165_, "vala-creation-function", "Vls.Server.initialize");
	}
	_g_object_unref0 (self->priv->default_project);
	self->priv->default_project = _tmp165_;
	{
		GeeArrayList* _project_list = NULL;
		GeeArrayList* _tmp166_;
		gint _project_size = 0;
		GeeArrayList* _tmp167_;
		gint _tmp168_;
		gint _tmp169_;
		gint _project_index = 0;
		_tmp166_ = new_projects;
		_project_list = _tmp166_;
		_tmp167_ = _project_list;
		_tmp168_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp167_);
		_tmp169_ = _tmp168_;
		_project_size = _tmp169_;
		_project_index = -1;
		while (TRUE) {
			gint _tmp170_;
			gint _tmp171_;
			VlsProject* project = NULL;
			GeeArrayList* _tmp172_;
			gpointer _tmp173_;
			_project_index = _project_index + 1;
			_tmp170_ = _project_index;
			_tmp171_ = _project_size;
			if (!(_tmp170_ < _tmp171_)) {
				break;
			}
			_tmp172_ = _project_list;
			_tmp173_ = gee_abstract_list_get ((GeeAbstractList*) _tmp172_, _project_index);
			project = (VlsProject*) _tmp173_;
			{
				VlsProject* _tmp174_;
				g_debug ("server.vala:445: Building project ...");
				_tmp174_ = project;
				vls_project_build_if_stale (_tmp174_, NULL, &_inner_error0_);
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					goto __catch4_g_error;
				}
				g_debug ("server.vala:447: Publishing diagnostics ...");
				{
					GeeArrayList* _compilation_list = NULL;
					VlsProject* _tmp175_;
					GeeArrayList* _tmp176_;
					gint _compilation_size = 0;
					GeeArrayList* _tmp177_;
					gint _tmp178_;
					gint _tmp179_;
					gint _compilation_index = 0;
					_tmp175_ = project;
					_tmp176_ = vls_project_get_compilations (_tmp175_);
					_compilation_list = _tmp176_;
					_tmp177_ = _compilation_list;
					_tmp178_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp177_);
					_tmp179_ = _tmp178_;
					_compilation_size = _tmp179_;
					_compilation_index = -1;
					while (TRUE) {
						gint _tmp180_;
						gint _tmp181_;
						VlsCompilation* compilation = NULL;
						GeeArrayList* _tmp182_;
						gpointer _tmp183_;
						VlsProject* _tmp184_;
						VlsCompilation* _tmp185_;
						_compilation_index = _compilation_index + 1;
						_tmp180_ = _compilation_index;
						_tmp181_ = _compilation_size;
						if (!(_tmp180_ < _tmp181_)) {
							break;
						}
						_tmp182_ = _compilation_list;
						_tmp183_ = gee_abstract_list_get ((GeeAbstractList*) _tmp182_, _compilation_index);
						compilation = (VlsCompilation*) _tmp183_;
						_tmp184_ = project;
						_tmp185_ = compilation;
						vls_server_publish_diagnostics (self, _tmp184_, _tmp185_, client);
						_g_object_unref0 (compilation);
					}
					_g_object_unref0 (_compilation_list);
				}
			}
			goto __finally4;
			__catch4_g_error:
			{
				GError* e = NULL;
				GError* _tmp186_;
				const gchar* _tmp187_;
				const gchar* _tmp188_;
				gchar* _tmp189_;
				gchar* _tmp190_;
				e = _inner_error0_;
				_inner_error0_ = NULL;
				_tmp186_ = e;
				_tmp187_ = _tmp186_->message;
				_tmp188_ = string_to_string (_tmp187_);
				_tmp189_ = g_strconcat ("Failed to build project - ", _tmp188_, NULL);
				_tmp190_ = _tmp189_;
				vls_server_show_message (self, client, _tmp190_, LSP_MESSAGE_TYPE_Error);
				_g_free0 (_tmp190_);
				_g_error_free0 (e);
			}
			__finally4:
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				_g_object_unref0 (project);
				_g_object_unref0 (backend_project);
				_g_object_unref0 (new_projects);
				_g_object_unref0 (cc_files);
				_g_object_unref0 (meson_file);
				_g_free0 (root_path);
				_g_object_unref0 (root_dir);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
			_g_object_unref0 (project);
		}
	}
	_tmp191_ = gee_hash_set_new (VALA_TYPE_SOURCE_FILE, (GBoxedCopyFunc) vala_source_file_ref, (GDestroyNotify) vala_source_file_unref, NULL, NULL, NULL, NULL, NULL, NULL);
	if (_tmp191_) {
		g_object_set_data ((GObject *) _tmp191_, "vala-creation-function", "Vls.Server.initialize");
	}
	packages = _tmp191_;
	_tmp192_ = gee_hash_set_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _vls_util_file_hash_gee_hash_data_func, NULL, NULL, _vls_util_file_equal_gee_equal_data_func, NULL, NULL);
	if (_tmp192_) {
		g_object_set_data ((GObject *) _tmp192_, "vala-creation-function", "Vls.Server.initialize");
	}
	custom_gir_dirs = _tmp192_;
	{
		GeeArrayList* _project_list = NULL;
		GeeArrayList* _tmp193_;
		gint _project_size = 0;
		GeeArrayList* _tmp194_;
		gint _tmp195_;
		gint _tmp196_;
		gint _project_index = 0;
		_tmp193_ = new_projects;
		_project_list = _tmp193_;
		_tmp194_ = _project_list;
		_tmp195_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp194_);
		_tmp196_ = _tmp195_;
		_project_size = _tmp196_;
		_project_index = -1;
		while (TRUE) {
			gint _tmp197_;
			gint _tmp198_;
			VlsProject* project = NULL;
			GeeArrayList* _tmp199_;
			gpointer _tmp200_;
			GeeHashSet* _tmp201_;
			VlsProject* _tmp202_;
			GeeCollection* _tmp203_;
			GeeCollection* _tmp204_;
			GeeHashSet* _tmp205_;
			VlsProject* _tmp206_;
			GeeCollection* _tmp207_;
			GeeCollection* _tmp208_;
			_project_index = _project_index + 1;
			_tmp197_ = _project_index;
			_tmp198_ = _project_size;
			if (!(_tmp197_ < _tmp198_)) {
				break;
			}
			_tmp199_ = _project_list;
			_tmp200_ = gee_abstract_list_get ((GeeAbstractList*) _tmp199_, _project_index);
			project = (VlsProject*) _tmp200_;
			_tmp201_ = packages;
			_tmp202_ = project;
			_tmp203_ = vls_project_get_packages (_tmp202_);
			_tmp204_ = _tmp203_;
			gee_collection_add_all ((GeeCollection*) _tmp201_, _tmp204_);
			_g_object_unref0 (_tmp204_);
			_tmp205_ = custom_gir_dirs;
			_tmp206_ = project;
			_tmp207_ = vls_project_get_custom_gir_dirs (_tmp206_);
			_tmp208_ = _tmp207_;
			gee_collection_add_all ((GeeCollection*) _tmp205_, _tmp208_);
			_g_object_unref0 (_tmp208_);
			_g_object_unref0 (project);
		}
	}
	_tmp209_ = packages;
	_tmp210_ = custom_gir_dirs;
	_tmp211_ = vls_gir_documentation_new ((GeeCollection*) _tmp209_, (GeeCollection*) _tmp210_);
	_vls_gir_documentation_unref0 (self->priv->documentation);
	self->priv->documentation = _tmp211_;
	_tmp212_ = _g_object_ref0 (client);
	_g_object_unref0 (self->priv->update_context_client);
	self->priv->update_context_client = _tmp212_;
	_vala_array_add24 (&self->priv->g_sources, &self->priv->g_sources_length1, &self->priv->_g_sources_size_, g_timeout_add_full (G_PRIORITY_DEFAULT, VLS_SERVER_check_update_context_period_ms, _vls_server_check_update_context_gsource_func, g_object_ref (self), g_object_unref));
	{
		GeeArrayList* _project_list = NULL;
		GeeArrayList* _tmp213_;
		gint _project_size = 0;
		GeeArrayList* _tmp214_;
		gint _tmp215_;
		gint _tmp216_;
		gint _project_index = 0;
		_tmp213_ = new_projects;
		_project_list = _tmp213_;
		_tmp214_ = _project_list;
		_tmp215_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp214_);
		_tmp216_ = _tmp215_;
		_project_size = _tmp216_;
		_project_index = -1;
		while (TRUE) {
			gint _tmp217_;
			gint _tmp218_;
			VlsProject* project = NULL;
			GeeArrayList* _tmp219_;
			gpointer _tmp220_;
			GHashTable* _tmp221_;
			VlsProject* _tmp222_;
			VlsProject* _tmp223_;
			VlsProject* _tmp224_;
			gulong _tmp225_;
			_project_index = _project_index + 1;
			_tmp217_ = _project_index;
			_tmp218_ = _project_size;
			if (!(_tmp217_ < _tmp218_)) {
				break;
			}
			_tmp219_ = _project_list;
			_tmp220_ = gee_abstract_list_get ((GeeAbstractList*) _tmp219_, _project_index);
			project = (VlsProject*) _tmp220_;
			_tmp221_ = self->priv->projects;
			_tmp222_ = project;
			_tmp223_ = _g_object_ref0 (_tmp222_);
			_tmp224_ = project;
			_tmp225_ = g_signal_connect_object (_tmp224_, "changed", (GCallback) _vls_server_project_changed_event_vls_project_changed, self, 0);
			g_hash_table_insert (_tmp221_, _tmp223_, (gpointer) ((guintptr) _tmp225_));
			_g_object_unref0 (project);
		}
	}
	_g_object_unref0 (custom_gir_dirs);
	_g_object_unref0 (packages);
	_g_object_unref0 (backend_project);
	_g_object_unref0 (new_projects);
	_g_object_unref0 (cc_files);
	_g_object_unref0 (meson_file);
	_g_free0 (root_path);
	_g_object_unref0 (root_dir);
}

static void
vls_server_project_changed_event (VlsServer* self)
{
	JsonrpcClient* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->update_context_client;
	vls_server_request_context_update (self, _tmp0_);
	g_debug ("server.vala:475: requested context update for project change event");
}

static void
vls_server_cancel_request (VlsServer* self,
                           JsonrpcClient* client,
                           GVariant* params)
{
	GVariant* id = NULL;
	GVariant* _tmp0_;
	GVariant* _tmp1_;
	VlsRequest* req = NULL;
	GVariant* _tmp2_;
	VlsRequest* _tmp3_;
	GeeHashSet* _tmp4_;
	VlsRequest* _tmp5_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (client != NULL);
	g_return_if_fail (params != NULL);
	_tmp0_ = g_variant_lookup_value (params, "id", NULL);
	id = _tmp0_;
	_tmp1_ = id;
	if (_tmp1_ == NULL) {
		_g_variant_unref0 (id);
		return;
	}
	_tmp2_ = id;
	_tmp3_ = vls_request_new (_tmp2_, NULL);
	if (_tmp3_) {
		g_object_set_data ((GObject *) _tmp3_, "vala-creation-function", "Vls.Server.cancel_request");
	}
	req = _tmp3_;
	_tmp4_ = self->priv->pending_requests;
	_tmp5_ = req;
	gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp4_, _tmp5_);
	_g_object_unref0 (req);
	_g_variant_unref0 (id);
}

void
vls_server_reply_null (GVariant* id,
                       JsonrpcClient* client,
                       const gchar* method)
{
	GError* _inner_error0_ = NULL;
	g_return_if_fail (id != NULL);
	g_return_if_fail (client != NULL);
	g_return_if_fail (method != NULL);
	{
		const GVariantType* _tmp0_;
		GVariant* _tmp1_;
		GVariant* _tmp2_;
		GCancellable* _tmp3_;
		_tmp0_ = G_VARIANT_TYPE_VARIANT;
		_tmp1_ = g_variant_new_maybe (_tmp0_, NULL);
		g_variant_ref_sink (_tmp1_);
		_tmp2_ = _tmp1_;
		_tmp3_ = vls_server_cancellable;
		jsonrpc_client_reply (client, id, _tmp2_, _tmp3_, &_inner_error0_);
		_g_variant_unref0 (_tmp2_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp4_;
		GError* _tmp5_;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp4_ = string_to_string (method);
		_tmp5_ = e;
		_tmp6_ = _tmp5_->message;
		_tmp7_ = string_to_string (_tmp6_);
		_tmp8_ = g_strconcat ("[", _tmp4_, "] failed to reply to client: ", _tmp7_, NULL);
		_tmp9_ = _tmp8_;
		g_debug ("server.vala:495: %s", _tmp9_);
		_g_free0 (_tmp9_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

static gchar*
_variant_get3 (GVariant* value)
{
	return g_variant_dup_string (value, NULL);
}

static gchar*
_variant_get4 (GVariant* value)
{
	return g_variant_dup_string (value, NULL);
}

static gchar*
_variant_get5 (GVariant* value)
{
	return g_variant_dup_string (value, NULL);
}

static void
vls_server_text_document_did_open (VlsServer* self,
                                   JsonrpcClient* client,
                                   GVariant* params)
{
	GVariant* document = NULL;
	const GVariantType* _tmp0_;
	GVariant* _tmp1_;
	gchar* uri = NULL;
	GVariant* _tmp2_;
	const GVariantType* _tmp3_;
	GVariant* _tmp4_;
	GVariant* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* languageId = NULL;
	GVariant* _tmp8_;
	const GVariantType* _tmp9_;
	GVariant* _tmp10_;
	GVariant* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* fileContents = NULL;
	GVariant* _tmp14_;
	const GVariantType* _tmp15_;
	GVariant* _tmp16_;
	GVariant* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gboolean _tmp20_ = FALSE;
	const gchar* _tmp21_;
	const gchar* _tmp27_;
	VlsPair* doc_w_bt = NULL;
	GHashTable* _tmp28_;
	guint _tmp29_ = 0;
	gconstpointer* _tmp30_;
	VlsPair* _tmp44_;
	VlsPair* _tmp67_;
	ValaSourceFile* doc = NULL;
	VlsPair* _tmp69_;
	gconstpointer _tmp70_;
	gconstpointer _tmp71_;
	ValaSourceFile* _tmp72_;
	ValaSourceFile* _tmp73_;
	const gchar* _tmp74_;
	const gchar* _tmp75_;
	ValaSourceFile* _tmp77_;
	GeeHashSet* _tmp100_;
	const gchar* _tmp101_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (client != NULL);
	g_return_if_fail (params != NULL);
	_tmp0_ = G_VARIANT_TYPE_VARDICT;
	_tmp1_ = g_variant_lookup_value (params, "textDocument", _tmp0_);
	document = _tmp1_;
	_tmp2_ = document;
	_tmp3_ = G_VARIANT_TYPE_STRING;
	_tmp4_ = g_variant_lookup_value (_tmp2_, "uri", _tmp3_);
	_tmp5_ = _tmp4_;
	_tmp6_ = _variant_get3 (_tmp5_);
	_tmp7_ = _tmp6_;
	_g_variant_unref0 (_tmp5_);
	uri = _tmp7_;
	_tmp8_ = document;
	_tmp9_ = G_VARIANT_TYPE_STRING;
	_tmp10_ = g_variant_lookup_value (_tmp8_, "languageId", _tmp9_);
	_tmp11_ = _tmp10_;
	_tmp12_ = _variant_get4 (_tmp11_);
	_tmp13_ = _tmp12_;
	_g_variant_unref0 (_tmp11_);
	languageId = _tmp13_;
	_tmp14_ = document;
	_tmp15_ = G_VARIANT_TYPE_STRING;
	_tmp16_ = g_variant_lookup_value (_tmp14_, "text", _tmp15_);
	_tmp17_ = _tmp16_;
	_tmp18_ = _variant_get5 (_tmp17_);
	_tmp19_ = _tmp18_;
	_g_variant_unref0 (_tmp17_);
	fileContents = _tmp19_;
	_tmp21_ = languageId;
	if (g_strcmp0 (_tmp21_, "vala") != 0) {
		const gchar* _tmp22_;
		_tmp22_ = languageId;
		_tmp20_ = g_strcmp0 (_tmp22_, "genie") != 0;
	} else {
		_tmp20_ = FALSE;
	}
	if (_tmp20_) {
		const gchar* _tmp23_;
		const gchar* _tmp24_;
		gchar* _tmp25_;
		gchar* _tmp26_;
		_tmp23_ = languageId;
		_tmp24_ = string_to_string (_tmp23_);
		_tmp25_ = g_strconcat ("[textDocument/didOpen] ", _tmp24_, " file sent to vala language server", NULL);
		_tmp26_ = _tmp25_;
		g_warning ("server.vala:507: %s", _tmp26_);
		_g_free0 (_tmp26_);
		_g_free0 (fileContents);
		_g_free0 (languageId);
		_g_free0 (uri);
		_g_variant_unref0 (document);
		return;
	}
	_tmp27_ = uri;
	if (_tmp27_ == NULL) {
		g_warning ("server.vala:512: %s", "[textDocument/didOpen] null URI sent to vala language server");
		_g_free0 (fileContents);
		_g_free0 (languageId);
		_g_free0 (uri);
		_g_variant_unref0 (document);
		return;
	}
	doc_w_bt = NULL;
	_tmp28_ = self->priv->projects;
	_tmp30_ = g_hash_table_get_keys_as_array (_tmp28_, &_tmp29_);
	{
		VlsProject** project_collection = NULL;
		gint project_collection_length1 = 0;
		gint _project_collection_size_ = 0;
		gint project_it = 0;
		project_collection = _tmp30_;
		project_collection_length1 = _tmp29_;
		for (project_it = 0; project_it < project_collection_length1; project_it = project_it + 1) {
			VlsProject* project = NULL;
			project = project_collection[project_it];
			{
				{
					GeeArrayList* _tmp31_ = NULL;
					VlsProject* _tmp32_;
					const gchar* _tmp33_;
					const gchar* _tmp34_;
					GCancellable* _tmp35_;
					GeeArrayList* _tmp36_;
					gpointer _tmp37_;
					_tmp32_ = project;
					_tmp33_ = uri;
					_tmp34_ = fileContents;
					_tmp35_ = vls_server_cancellable;
					_tmp36_ = vls_project_open (_tmp32_, _tmp33_, _tmp34_, _tmp35_, &_inner_error0_);
					_tmp31_ = _tmp36_;
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						goto __catch0_g_error;
					}
					_tmp37_ = gee_list_first ((GeeList*) _tmp31_);
					_g_object_unref0 (doc_w_bt);
					doc_w_bt = (VlsPair*) _tmp37_;
					_g_object_unref0 (_tmp31_);
					break;
				}
				goto __finally0;
				__catch0_g_error:
				{
					GError* e = NULL;
					GError* _tmp38_;
					e = _inner_error0_;
					_inner_error0_ = NULL;
					_tmp38_ = e;
					if (!g_error_matches (_tmp38_, VLS_PROJECT_ERROR, VLS_PROJECT_ERROR_NOT_FOUND)) {
						const gchar* _tmp39_;
						gchar* _tmp40_;
						gchar* _tmp41_;
						GError* _tmp42_;
						const gchar* _tmp43_;
						_tmp39_ = uri;
						_tmp40_ = g_uri_unescape_string (_tmp39_, NULL);
						_tmp41_ = _tmp40_;
						_tmp42_ = e;
						_tmp43_ = _tmp42_->message;
						g_warning ("server.vala:524: [textDocument/didOpen] failed to open %s - %s", _tmp41_, _tmp43_);
						_g_free0 (_tmp41_);
					}
					_g_error_free0 (e);
				}
				__finally0:
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					project_collection = (g_free (project_collection), NULL);
					_g_object_unref0 (doc_w_bt);
					_g_free0 (fileContents);
					_g_free0 (languageId);
					_g_free0 (uri);
					_g_variant_unref0 (document);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return;
				}
			}
		}
		project_collection = (g_free (project_collection), NULL);
	}
	_tmp44_ = doc_w_bt;
	if (_tmp44_ == NULL) {
		{
			GeeArrayList* _tmp45_ = NULL;
			VlsDefaultProject* _tmp46_;
			const gchar* _tmp47_;
			const gchar* _tmp48_;
			GCancellable* _tmp49_;
			GeeArrayList* _tmp50_;
			gpointer _tmp51_;
			_tmp46_ = self->priv->default_project;
			_tmp47_ = uri;
			_tmp48_ = fileContents;
			_tmp49_ = vls_server_cancellable;
			_tmp50_ = vls_project_open ((VlsProject*) _tmp46_, _tmp47_, _tmp48_, _tmp49_, &_inner_error0_);
			_tmp45_ = _tmp50_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				goto __catch1_g_error;
			}
			_tmp51_ = gee_list_first ((GeeList*) _tmp45_);
			_g_object_unref0 (doc_w_bt);
			doc_w_bt = (VlsPair*) _tmp51_;
			{
				GeeIterator* _pkg_it = NULL;
				VlsDefaultProject* _tmp52_;
				GeeCollection* _tmp53_;
				GeeCollection* _tmp54_;
				GeeIterator* _tmp55_;
				GeeIterator* _tmp56_;
				_tmp52_ = self->priv->default_project;
				_tmp53_ = vls_project_get_packages ((VlsProject*) _tmp52_);
				_tmp54_ = _tmp53_;
				_tmp55_ = gee_iterable_iterator ((GeeIterable*) _tmp54_);
				_tmp56_ = _tmp55_;
				_g_object_unref0 (_tmp54_);
				_pkg_it = _tmp56_;
				while (TRUE) {
					GeeIterator* _tmp57_;
					ValaSourceFile* pkg = NULL;
					GeeIterator* _tmp58_;
					gpointer _tmp59_;
					VlsGirDocumentation* _tmp60_;
					ValaSourceFile* _tmp61_;
					_tmp57_ = _pkg_it;
					if (!gee_iterator_next (_tmp57_)) {
						break;
					}
					_tmp58_ = _pkg_it;
					_tmp59_ = gee_iterator_get (_tmp58_);
					pkg = (ValaSourceFile*) _tmp59_;
					_tmp60_ = self->priv->documentation;
					_tmp61_ = pkg;
					vls_gir_documentation_add_package_from_source_file (_tmp60_, _tmp61_);
					_vala_source_file_unref0 (pkg);
				}
				_g_object_unref0 (_pkg_it);
			}
			vls_server_request_context_update (self, client);
			_g_object_unref0 (_tmp45_);
		}
		goto __finally1;
		__catch1_g_error:
		{
			GError* e = NULL;
			const gchar* _tmp62_;
			gchar* _tmp63_;
			gchar* _tmp64_;
			GError* _tmp65_;
			const gchar* _tmp66_;
			e = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp62_ = uri;
			_tmp63_ = g_uri_unescape_string (_tmp62_, NULL);
			_tmp64_ = _tmp63_;
			_tmp65_ = e;
			_tmp66_ = _tmp65_->message;
			g_warning ("server.vala:539: [textDocumnt/didOpen] failed to open %s - %s", _tmp64_, _tmp66_);
			_g_free0 (_tmp64_);
			_g_error_free0 (e);
		}
		__finally1:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (doc_w_bt);
			_g_free0 (fileContents);
			_g_free0 (languageId);
			_g_free0 (uri);
			_g_variant_unref0 (document);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
	}
	_tmp67_ = doc_w_bt;
	if (_tmp67_ == NULL) {
		const gchar* _tmp68_;
		_tmp68_ = uri;
		g_warning ("server.vala:544: [textDocument/didOpen] could not open %s", _tmp68_);
		_g_object_unref0 (doc_w_bt);
		_g_free0 (fileContents);
		_g_free0 (languageId);
		_g_free0 (uri);
		_g_variant_unref0 (document);
		return;
	}
	_tmp69_ = doc_w_bt;
	_tmp70_ = vls_pair_get_first (_tmp69_);
	_tmp71_ = _tmp70_;
	_tmp72_ = _vala_source_file_ref0 ((ValaSourceFile*) _tmp71_);
	doc = _tmp72_;
	_tmp73_ = doc;
	_tmp74_ = vala_source_file_get_content (_tmp73_);
	_tmp75_ = _tmp74_;
	if (_tmp75_ == NULL) {
		ValaSourceFile* _tmp76_;
		_tmp76_ = doc;
		vala_source_file_get_mapped_contents (_tmp76_);
	}
	_tmp77_ = doc;
	if (VLS_IS_TEXT_DOCUMENT (_tmp77_)) {
		VlsTextDocument* tdoc = NULL;
		ValaSourceFile* _tmp78_;
		VlsTextDocument* _tmp79_;
		const gchar* _tmp80_;
		gchar* _tmp81_;
		gchar* _tmp82_;
		const gchar* _tmp83_;
		gchar* _tmp84_;
		gchar* _tmp85_;
		VlsTextDocument* _tmp86_;
		const gchar* _tmp87_;
		VlsTextDocument* _tmp88_;
		const gchar* _tmp89_;
		const gchar* _tmp90_;
		const gchar* _tmp91_;
		_tmp78_ = doc;
		_tmp79_ = _vala_source_file_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp78_, VLS_TYPE_TEXT_DOCUMENT, VlsTextDocument));
		tdoc = _tmp79_;
		_tmp80_ = uri;
		_tmp81_ = g_uri_unescape_string (_tmp80_, NULL);
		_tmp82_ = _tmp81_;
		_tmp83_ = string_to_string (_tmp82_);
		_tmp84_ = g_strconcat ("[textDocument/didOpen] opened ", _tmp83_, NULL);
		_tmp85_ = _tmp84_;
		g_debug ("server.vala:556: %s", _tmp85_);
		_g_free0 (_tmp85_);
		_g_free0 (_tmp82_);
		_tmp86_ = tdoc;
		_tmp87_ = fileContents;
		vls_text_document_set_last_saved_content (_tmp86_, _tmp87_);
		_tmp88_ = tdoc;
		_tmp89_ = vala_source_file_get_content ((ValaSourceFile*) _tmp88_);
		_tmp90_ = _tmp89_;
		_tmp91_ = fileContents;
		if (g_strcmp0 (_tmp90_, _tmp91_) != 0) {
			VlsTextDocument* _tmp92_;
			const gchar* _tmp93_;
			_tmp92_ = tdoc;
			_tmp93_ = fileContents;
			vala_source_file_set_content ((ValaSourceFile*) _tmp92_, _tmp93_);
			vls_server_request_context_update (self, client);
			g_debug ("server.vala:561: %s", "[textDocument/didOpen] requested context update");
		}
		_vala_source_file_unref0 (tdoc);
	} else {
		const gchar* _tmp94_;
		gchar* _tmp95_;
		gchar* _tmp96_;
		const gchar* _tmp97_;
		gchar* _tmp98_;
		gchar* _tmp99_;
		_tmp94_ = uri;
		_tmp95_ = g_uri_unescape_string (_tmp94_, NULL);
		_tmp96_ = _tmp95_;
		_tmp97_ = string_to_string (_tmp96_);
		_tmp98_ = g_strconcat ("[textDocument/didOpen] opened read-only ", _tmp97_, NULL);
		_tmp99_ = _tmp98_;
		g_debug ("server.vala:564: %s", _tmp99_);
		_g_free0 (_tmp99_);
		_g_free0 (_tmp96_);
	}
	_tmp100_ = self->priv->open_files;
	_tmp101_ = uri;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp100_, _tmp101_);
	_vala_source_file_unref0 (doc);
	_g_object_unref0 (doc_w_bt);
	_g_free0 (fileContents);
	_g_free0 (languageId);
	_g_free0 (uri);
	_g_variant_unref0 (document);
}

static gchar*
_variant_get6 (GVariant* value)
{
	return g_variant_dup_string (value, NULL);
}

static VlsProject**
_vala_array_dup13 (VlsProject** self,
                   gssize length)
{
	if (length >= 0) {
		VlsProject** result;
		gssize i;
		result = g_new0 (VlsProject*, length + 1);
		for (i = 0; i < length; i++) {
			VlsProject* _tmp0_;
			_tmp0_ = _g_object_ref0 (self[i]);
			result[i] = _tmp0_;
		}
		return result;
	}
	return NULL;
}

static void
_vala_array_add25 (VlsProject** * array,
                   gint* length,
                   gint* size,
                   VlsProject* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (VlsProject*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
vls_server_text_document_did_save (VlsServer* self,
                                   JsonrpcClient* client,
                                   GVariant* params)
{
	GVariant* document = NULL;
	const GVariantType* _tmp0_;
	GVariant* _tmp1_;
	gchar* uri = NULL;
	GVariant* _tmp2_;
	const GVariantType* _tmp3_;
	GVariant* _tmp4_;
	GVariant* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	const gchar* _tmp8_;
	VlsProject** all_projects = NULL;
	GHashTable* _tmp9_;
	guint _tmp10_ = 0;
	gconstpointer* _tmp11_;
	VlsProject** _tmp12_;
	gint _tmp12__length1;
	gint all_projects_length1;
	gint _all_projects_size_;
	VlsDefaultProject* _tmp13_;
	VlsProject* _tmp14_;
	VlsProject** _tmp15_;
	gint _tmp15__length1;
	g_return_if_fail (self != NULL);
	g_return_if_fail (client != NULL);
	g_return_if_fail (params != NULL);
	_tmp0_ = G_VARIANT_TYPE_VARDICT;
	_tmp1_ = g_variant_lookup_value (params, "textDocument", _tmp0_);
	document = _tmp1_;
	_tmp2_ = document;
	_tmp3_ = G_VARIANT_TYPE_STRING;
	_tmp4_ = g_variant_lookup_value (_tmp2_, "uri", _tmp3_);
	_tmp5_ = _tmp4_;
	_tmp6_ = _variant_get6 (_tmp5_);
	_tmp7_ = _tmp6_;
	_g_variant_unref0 (_tmp5_);
	uri = _tmp7_;
	_tmp8_ = uri;
	if (_tmp8_ == NULL) {
		g_warning ("server.vala:576: %s", "[textDocument/didSave] null URI sent to vala language server");
		_g_free0 (uri);
		_g_variant_unref0 (document);
		return;
	}
	_tmp9_ = self->priv->projects;
	_tmp11_ = g_hash_table_get_keys_as_array (_tmp9_, &_tmp10_);
	_tmp12_ = (_tmp11_ != NULL) ? _vala_array_dup13 (_tmp11_, _tmp10_) : _tmp11_;
	_tmp12__length1 = _tmp10_;
	_tmp11_ = (g_free (_tmp11_), NULL);
	all_projects = _tmp12_;
	all_projects_length1 = _tmp12__length1;
	_all_projects_size_ = all_projects_length1;
	_tmp13_ = self->priv->default_project;
	_tmp14_ = _g_object_ref0 ((VlsProject*) _tmp13_);
	_vala_array_add25 (&all_projects, &all_projects_length1, &_all_projects_size_, _tmp14_);
	_tmp15_ = all_projects;
	_tmp15__length1 = all_projects_length1;
	{
		VlsProject** project_collection = NULL;
		gint project_collection_length1 = 0;
		gint _project_collection_size_ = 0;
		gint project_it = 0;
		project_collection = _tmp15_;
		project_collection_length1 = _tmp15__length1;
		for (project_it = 0; project_it < project_collection_length1; project_it = project_it + 1) {
			VlsProject* _tmp16_;
			VlsProject* project = NULL;
			_tmp16_ = _g_object_ref0 (project_collection[project_it]);
			project = _tmp16_;
			{
				{
					GeeArrayList* _pair_list = NULL;
					VlsProject* _tmp17_;
					const gchar* _tmp18_;
					GeeArrayList* _tmp19_;
					gint _pair_size = 0;
					GeeArrayList* _tmp20_;
					gint _tmp21_;
					gint _tmp22_;
					gint _pair_index = 0;
					_tmp17_ = project;
					_tmp18_ = uri;
					_tmp19_ = vls_project_lookup_compile_input_source_file (_tmp17_, _tmp18_);
					_pair_list = _tmp19_;
					_tmp20_ = _pair_list;
					_tmp21_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp20_);
					_tmp22_ = _tmp21_;
					_pair_size = _tmp22_;
					_pair_index = -1;
					while (TRUE) {
						gint _tmp23_;
						gint _tmp24_;
						VlsPair* pair = NULL;
						GeeArrayList* _tmp25_;
						gpointer _tmp26_;
						VlsTextDocument* text_document = NULL;
						VlsPair* _tmp27_;
						gconstpointer _tmp28_;
						gconstpointer _tmp29_;
						ValaSourceFile* _tmp30_;
						VlsTextDocument* _tmp31_;
						VlsTextDocument* _tmp32_;
						VlsTextDocument* _tmp33_;
						VlsTextDocument* _tmp34_;
						const gchar* _tmp35_;
						const gchar* _tmp36_;
						const gchar* _tmp37_;
						VlsTextDocument* _tmp38_;
						gint _tmp39_;
						gint _tmp40_;
						_pair_index = _pair_index + 1;
						_tmp23_ = _pair_index;
						_tmp24_ = _pair_size;
						if (!(_tmp23_ < _tmp24_)) {
							break;
						}
						_tmp25_ = _pair_list;
						_tmp26_ = gee_abstract_list_get ((GeeAbstractList*) _tmp25_, _pair_index);
						pair = (VlsPair*) _tmp26_;
						_tmp27_ = pair;
						_tmp28_ = vls_pair_get_first (_tmp27_);
						_tmp29_ = _tmp28_;
						_tmp30_ = (ValaSourceFile*) _tmp29_;
						_tmp31_ = _vala_source_file_ref0 (VLS_IS_TEXT_DOCUMENT (_tmp30_) ? ((VlsTextDocument*) _tmp30_) : NULL);
						text_document = _tmp31_;
						_tmp32_ = text_document;
						if (_tmp32_ == NULL) {
							g_warning ("server.vala:588: [textDocument/didSave] ignoring save to system file");
							_vala_source_file_unref0 (text_document);
							_g_object_unref0 (pair);
							continue;
						}
						_tmp33_ = text_document;
						_tmp34_ = text_document;
						_tmp35_ = vala_source_file_get_content ((ValaSourceFile*) _tmp34_);
						_tmp36_ = _tmp35_;
						vls_text_document_set_last_saved_content (_tmp33_, _tmp36_);
						_tmp37_ = uri;
						_tmp38_ = text_document;
						_tmp39_ = vls_text_document_get_last_saved_version (_tmp38_);
						_tmp40_ = _tmp39_;
						g_debug ("server.vala:594: [textDocument/didSave] last save of %s is now at vers" \
"ion %d", _tmp37_, _tmp40_);
						_vala_source_file_unref0 (text_document);
						_g_object_unref0 (pair);
					}
					_g_object_unref0 (_pair_list);
				}
				_g_object_unref0 (project);
			}
		}
	}
	all_projects = (_vala_array_free (all_projects, all_projects_length1, (GDestroyNotify) g_object_unref), NULL);
	_g_free0 (uri);
	_g_variant_unref0 (document);
}

static gchar*
_variant_get7 (GVariant* value)
{
	return g_variant_dup_string (value, NULL);
}

static VlsProject**
_vala_array_dup14 (VlsProject** self,
                   gssize length)
{
	if (length >= 0) {
		VlsProject** result;
		gssize i;
		result = g_new0 (VlsProject*, length + 1);
		for (i = 0; i < length; i++) {
			VlsProject* _tmp0_;
			_tmp0_ = _g_object_ref0 (self[i]);
			result[i] = _tmp0_;
		}
		return result;
	}
	return NULL;
}

static void
_vala_array_add26 (VlsProject** * array,
                   gint* length,
                   gint* size,
                   VlsProject* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (VlsProject*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
vls_server_text_document_did_close (VlsServer* self,
                                    JsonrpcClient* client,
                                    GVariant* params)
{
	GVariant* document = NULL;
	const GVariantType* _tmp0_;
	GVariant* _tmp1_;
	gchar* uri = NULL;
	GVariant* _tmp2_;
	const GVariantType* _tmp3_;
	GVariant* _tmp4_;
	GVariant* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	const gchar* _tmp8_;
	VlsProject** all_projects = NULL;
	GHashTable* _tmp9_;
	guint _tmp10_ = 0;
	gconstpointer* _tmp11_;
	VlsProject** _tmp12_;
	gint _tmp12__length1;
	gint all_projects_length1;
	gint _all_projects_size_;
	VlsDefaultProject* _tmp13_;
	VlsProject* _tmp14_;
	VlsProject** _tmp15_;
	gint _tmp15__length1;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (client != NULL);
	g_return_if_fail (params != NULL);
	_tmp0_ = G_VARIANT_TYPE_VARDICT;
	_tmp1_ = g_variant_lookup_value (params, "textDocument", _tmp0_);
	document = _tmp1_;
	_tmp2_ = document;
	_tmp3_ = G_VARIANT_TYPE_STRING;
	_tmp4_ = g_variant_lookup_value (_tmp2_, "uri", _tmp3_);
	_tmp5_ = _tmp4_;
	_tmp6_ = _variant_get7 (_tmp5_);
	_tmp7_ = _tmp6_;
	_g_variant_unref0 (_tmp5_);
	uri = _tmp7_;
	_tmp8_ = uri;
	if (_tmp8_ == NULL) {
		g_warning ("server.vala:604: %s", "[textDocument/didClose] null URI sent to vala language server");
		_g_free0 (uri);
		_g_variant_unref0 (document);
		return;
	}
	_tmp9_ = self->priv->projects;
	_tmp11_ = g_hash_table_get_keys_as_array (_tmp9_, &_tmp10_);
	_tmp12_ = (_tmp11_ != NULL) ? _vala_array_dup14 (_tmp11_, _tmp10_) : _tmp11_;
	_tmp12__length1 = _tmp10_;
	_tmp11_ = (g_free (_tmp11_), NULL);
	all_projects = _tmp12_;
	all_projects_length1 = _tmp12__length1;
	_all_projects_size_ = all_projects_length1;
	_tmp13_ = self->priv->default_project;
	_tmp14_ = _g_object_ref0 ((VlsProject*) _tmp13_);
	_vala_array_add26 (&all_projects, &all_projects_length1, &_all_projects_size_, _tmp14_);
	_tmp15_ = all_projects;
	_tmp15__length1 = all_projects_length1;
	{
		VlsProject** project_collection = NULL;
		gint project_collection_length1 = 0;
		gint _project_collection_size_ = 0;
		gint project_it = 0;
		project_collection = _tmp15_;
		project_collection_length1 = _tmp15__length1;
		for (project_it = 0; project_it < project_collection_length1; project_it = project_it + 1) {
			VlsProject* _tmp16_;
			VlsProject* project = NULL;
			_tmp16_ = _g_object_ref0 (project_collection[project_it]);
			project = _tmp16_;
			{
				{
					gboolean _tmp17_ = FALSE;
					VlsProject* _tmp18_;
					const gchar* _tmp19_;
					const gchar* _tmp22_;
					_tmp18_ = project;
					_tmp19_ = uri;
					_tmp17_ = vls_project_close (_tmp18_, _tmp19_, &_inner_error0_);
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						goto __catch0_g_error;
					}
					if (_tmp17_) {
						GeeHashSet* _tmp20_;
						const gchar* _tmp21_;
						_tmp20_ = self->priv->discarded_files;
						_tmp21_ = uri;
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp20_, _tmp21_);
						vls_server_request_context_update (self, client);
						g_debug ("server.vala:616: %s", "[textDocument/didClose] requested context update");
					}
					_tmp22_ = uri;
					g_debug ("server.vala:618: [textDocument/didClose] closed %s", _tmp22_);
				}
				goto __finally0;
				__catch0_g_error:
				{
					GError* e = NULL;
					GError* _tmp23_;
					e = _inner_error0_;
					_inner_error0_ = NULL;
					_tmp23_ = e;
					if (!g_error_matches (_tmp23_, VLS_PROJECT_ERROR, VLS_PROJECT_ERROR_NOT_FOUND)) {
						const gchar* _tmp24_;
						gchar* _tmp25_;
						gchar* _tmp26_;
						GError* _tmp27_;
						const gchar* _tmp28_;
						_tmp24_ = uri;
						_tmp25_ = g_uri_unescape_string (_tmp24_, NULL);
						_tmp26_ = _tmp25_;
						_tmp27_ = e;
						_tmp28_ = _tmp27_->message;
						g_warning ("server.vala:621: [textDocument/didClose] failed to close %s - %s", _tmp26_, _tmp28_);
						_g_free0 (_tmp26_);
					}
					_g_error_free0 (e);
				}
				__finally0:
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					_g_object_unref0 (project);
					all_projects = (_vala_array_free (all_projects, all_projects_length1, (GDestroyNotify) g_object_unref), NULL);
					_g_free0 (uri);
					_g_variant_unref0 (document);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return;
				}
				_g_object_unref0 (project);
			}
		}
	}
	all_projects = (_vala_array_free (all_projects, all_projects_length1, (GDestroyNotify) g_object_unref), NULL);
	_g_free0 (uri);
	_g_variant_unref0 (document);
}

static gchar*
_variant_get8 (GVariant* value)
{
	return g_variant_dup_string (value, NULL);
}

static gint64
_variant_get9 (GVariant* value)
{
	return g_variant_get_int64 (value);
}

static VlsProject**
_vala_array_dup15 (VlsProject** self,
                   gssize length)
{
	if (length >= 0) {
		VlsProject** result;
		gssize i;
		result = g_new0 (VlsProject*, length + 1);
		for (i = 0; i < length; i++) {
			VlsProject* _tmp0_;
			_tmp0_ = _g_object_ref0 (self[i]);
			result[i] = _tmp0_;
		}
		return result;
	}
	return NULL;
}

static void
_vala_array_add27 (VlsProject** * array,
                   gint* length,
                   gint* size,
                   VlsProject* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (VlsProject*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
vls_server_text_document_did_change (VlsServer* self,
                                     JsonrpcClient* client,
                                     GVariant* params)
{
	GVariant* document = NULL;
	const GVariantType* _tmp0_;
	GVariant* _tmp1_;
	GVariant* changes = NULL;
	const GVariantType* _tmp2_;
	GVariant* _tmp3_;
	gchar* uri = NULL;
	GVariant* _tmp4_;
	const GVariantType* _tmp5_;
	GVariant* _tmp6_;
	GVariant* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gint64 version = 0LL;
	GVariant* _tmp10_;
	const GVariantType* _tmp11_;
	GVariant* _tmp12_;
	GVariant* _tmp13_;
	gint64 _tmp14_;
	gint64 _tmp15_;
	VlsProject** all_projects = NULL;
	GHashTable* _tmp16_;
	guint _tmp17_ = 0;
	gconstpointer* _tmp18_;
	VlsProject** _tmp19_;
	gint _tmp19__length1;
	gint all_projects_length1;
	gint _all_projects_size_;
	VlsDefaultProject* _tmp20_;
	VlsProject* _tmp21_;
	VlsProject** _tmp22_;
	gint _tmp22__length1;
	g_return_if_fail (self != NULL);
	g_return_if_fail (client != NULL);
	g_return_if_fail (params != NULL);
	_tmp0_ = G_VARIANT_TYPE_VARDICT;
	_tmp1_ = g_variant_lookup_value (params, "textDocument", _tmp0_);
	document = _tmp1_;
	_tmp2_ = G_VARIANT_TYPE_ARRAY;
	_tmp3_ = g_variant_lookup_value (params, "contentChanges", _tmp2_);
	changes = _tmp3_;
	_tmp4_ = document;
	_tmp5_ = G_VARIANT_TYPE_STRING;
	_tmp6_ = g_variant_lookup_value (_tmp4_, "uri", _tmp5_);
	_tmp7_ = _tmp6_;
	_tmp8_ = _variant_get8 (_tmp7_);
	_tmp9_ = _tmp8_;
	_g_variant_unref0 (_tmp7_);
	uri = _tmp9_;
	_tmp10_ = document;
	_tmp11_ = G_VARIANT_TYPE_INT64;
	_tmp12_ = g_variant_lookup_value (_tmp10_, "version", _tmp11_);
	_tmp13_ = _tmp12_;
	_tmp14_ = _variant_get9 (_tmp13_);
	_tmp15_ = _tmp14_;
	_g_variant_unref0 (_tmp13_);
	version = _tmp15_;
	_tmp16_ = self->priv->projects;
	_tmp18_ = g_hash_table_get_keys_as_array (_tmp16_, &_tmp17_);
	_tmp19_ = (_tmp18_ != NULL) ? _vala_array_dup15 (_tmp18_, _tmp17_) : _tmp18_;
	_tmp19__length1 = _tmp17_;
	_tmp18_ = (g_free (_tmp18_), NULL);
	all_projects = _tmp19_;
	all_projects_length1 = _tmp19__length1;
	_all_projects_size_ = all_projects_length1;
	_tmp20_ = self->priv->default_project;
	_tmp21_ = _g_object_ref0 ((VlsProject*) _tmp20_);
	_vala_array_add27 (&all_projects, &all_projects_length1, &_all_projects_size_, _tmp21_);
	_tmp22_ = all_projects;
	_tmp22__length1 = all_projects_length1;
	{
		VlsProject** project_collection = NULL;
		gint project_collection_length1 = 0;
		gint _project_collection_size_ = 0;
		gint project_it = 0;
		project_collection = _tmp22_;
		project_collection_length1 = _tmp22__length1;
		for (project_it = 0; project_it < project_collection_length1; project_it = project_it + 1) {
			VlsProject* _tmp23_;
			VlsProject* project = NULL;
			_tmp23_ = _g_object_ref0 (project_collection[project_it]);
			project = _tmp23_;
			{
				{
					GeeArrayList* _pair_list = NULL;
					VlsProject* _tmp24_;
					const gchar* _tmp25_;
					GeeArrayList* _tmp26_;
					gint _pair_size = 0;
					GeeArrayList* _tmp27_;
					gint _tmp28_;
					gint _tmp29_;
					gint _pair_index = 0;
					_tmp24_ = project;
					_tmp25_ = uri;
					_tmp26_ = vls_project_lookup_compile_input_source_file (_tmp24_, _tmp25_);
					_pair_list = _tmp26_;
					_tmp27_ = _pair_list;
					_tmp28_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp27_);
					_tmp29_ = _tmp28_;
					_pair_size = _tmp29_;
					_pair_index = -1;
					while (TRUE) {
						gint _tmp30_;
						gint _tmp31_;
						VlsPair* pair = NULL;
						GeeArrayList* _tmp32_;
						gpointer _tmp33_;
						ValaSourceFile* source_file = NULL;
						VlsPair* _tmp34_;
						gconstpointer _tmp35_;
						gconstpointer _tmp36_;
						ValaSourceFile* _tmp37_;
						ValaSourceFile* _tmp38_;
						VlsTextDocument* source = NULL;
						ValaSourceFile* _tmp39_;
						VlsTextDocument* _tmp40_;
						VlsTextDocument* _tmp41_;
						gint _tmp42_;
						gint _tmp43_;
						ValaSourceFile* _tmp50_;
						const gchar* _tmp51_;
						const gchar* _tmp52_;
						GVariantIter* iter = NULL;
						GVariant* _tmp53_;
						GVariantIter* _tmp54_;
						GVariant* elem = NULL;
						GString* sb = NULL;
						VlsTextDocument* _tmp55_;
						const gchar* _tmp56_;
						const gchar* _tmp57_;
						GString* _tmp58_;
						VlsTextDocument* _tmp104_;
						GString* _tmp105_;
						const gchar* _tmp106_;
						VlsTextDocument* _tmp107_;
						GTimeZone* _tmp108_;
						GTimeZone* _tmp109_;
						GDateTime* _tmp110_;
						GDateTime* _tmp111_;
						VlsTextDocument* _tmp112_;
						_pair_index = _pair_index + 1;
						_tmp30_ = _pair_index;
						_tmp31_ = _pair_size;
						if (!(_tmp30_ < _tmp31_)) {
							break;
						}
						_tmp32_ = _pair_list;
						_tmp33_ = gee_abstract_list_get ((GeeAbstractList*) _tmp32_, _pair_index);
						pair = (VlsPair*) _tmp33_;
						_tmp34_ = pair;
						_tmp35_ = vls_pair_get_first (_tmp34_);
						_tmp36_ = _tmp35_;
						_tmp37_ = _vala_source_file_ref0 ((ValaSourceFile*) _tmp36_);
						source_file = _tmp37_;
						_tmp38_ = source_file;
						if (!VLS_IS_TEXT_DOCUMENT (_tmp38_)) {
							g_warning ("server.vala:645: %s", "[textDocument/didChange] Ignoring change to system file");
							_vala_source_file_unref0 (source_file);
							_g_object_unref0 (pair);
							_g_object_unref0 (_pair_list);
							_g_object_unref0 (project);
							all_projects = (_vala_array_free (all_projects, all_projects_length1, (GDestroyNotify) g_object_unref), NULL);
							_g_free0 (uri);
							_g_variant_unref0 (changes);
							_g_variant_unref0 (document);
							return;
						}
						_tmp39_ = source_file;
						_tmp40_ = _vala_source_file_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp39_, VLS_TYPE_TEXT_DOCUMENT, VlsTextDocument));
						source = _tmp40_;
						_tmp41_ = source;
						_tmp42_ = vls_text_document_get_version (_tmp41_);
						_tmp43_ = _tmp42_;
						if (((gint64) _tmp43_) >= version) {
							const gchar* _tmp44_;
							gchar* _tmp45_;
							gchar* _tmp46_;
							const gchar* _tmp47_;
							gchar* _tmp48_;
							gchar* _tmp49_;
							_tmp44_ = uri;
							_tmp45_ = g_uri_unescape_string (_tmp44_, NULL);
							_tmp46_ = _tmp45_;
							_tmp47_ = string_to_string (_tmp46_);
							_tmp48_ = g_strconcat ("[textDocument/didChange] rejecting outdated version of ", _tmp47_, NULL);
							_tmp49_ = _tmp48_;
							g_warning ("server.vala:651: %s", _tmp49_);
							_g_free0 (_tmp49_);
							_g_free0 (_tmp46_);
							_vala_source_file_unref0 (source);
							_vala_source_file_unref0 (source_file);
							_g_object_unref0 (pair);
							_g_object_unref0 (_pair_list);
							_g_object_unref0 (project);
							all_projects = (_vala_array_free (all_projects, all_projects_length1, (GDestroyNotify) g_object_unref), NULL);
							_g_free0 (uri);
							_g_variant_unref0 (changes);
							_g_variant_unref0 (document);
							return;
						}
						_tmp50_ = source_file;
						_tmp51_ = vala_source_file_get_content (_tmp50_);
						_tmp52_ = _tmp51_;
						if (_tmp52_ == NULL) {
							g_error ("server.vala:656: %s", "[textDocument/didChange] source content is null!");
						}
						_tmp53_ = changes;
						_tmp54_ = g_variant_iter_new (_tmp53_);
						iter = _tmp54_;
						elem = NULL;
						_tmp55_ = source;
						_tmp56_ = vala_source_file_get_content ((ValaSourceFile*) _tmp55_);
						_tmp57_ = _tmp56_;
						_tmp58_ = g_string_new (_tmp57_);
						sb = _tmp58_;
						while (TRUE) {
							GVariantIter* _tmp59_;
							GVariant* _tmp60_;
							GVariant* _tmp61_;
							LspTextDocumentContentChangeEvent* changeEvent = NULL;
							GVariant* _tmp62_;
							gpointer _tmp63_;
							LspTextDocumentContentChangeEvent* _tmp64_;
							LspRange* _tmp65_;
							LspRange* _tmp66_;
							_tmp59_ = iter;
							_tmp60_ = g_variant_iter_next_value (_tmp59_);
							_g_variant_unref0 (elem);
							elem = _tmp60_;
							_tmp61_ = elem;
							if (!(_tmp61_ != NULL)) {
								break;
							}
							_tmp62_ = elem;
							_tmp63_ = vls_util_parse_variant (LSP_TYPE_TEXT_DOCUMENT_CONTENT_CHANGE_EVENT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _tmp62_);
							changeEvent = (LspTextDocumentContentChangeEvent*) _tmp63_;
							_tmp64_ = changeEvent;
							_tmp65_ = lsp_text_document_content_change_event_get_range (_tmp64_);
							_tmp66_ = _tmp65_;
							if (_tmp66_ == NULL) {
								GString* _tmp67_;
								LspTextDocumentContentChangeEvent* _tmp68_;
								const gchar* _tmp69_;
								const gchar* _tmp70_;
								_tmp67_ = sb;
								_tmp68_ = changeEvent;
								_tmp69_ = lsp_text_document_content_change_event_get_text (_tmp68_);
								_tmp70_ = _tmp69_;
								g_string_assign (_tmp67_, _tmp70_);
							} else {
								LspPosition* start = NULL;
								LspTextDocumentContentChangeEvent* _tmp71_;
								LspRange* _tmp72_;
								LspRange* _tmp73_;
								LspPosition* _tmp74_;
								LspPosition* _tmp75_;
								LspPosition* _tmp76_;
								LspPosition* end = NULL;
								LspTextDocumentContentChangeEvent* _tmp77_;
								LspRange* _tmp78_;
								LspRange* _tmp79_;
								LspPosition* _tmp80_;
								LspPosition* _tmp81_;
								LspPosition* _tmp82_;
								gsize pos_begin = 0UL;
								GString* _tmp83_;
								const gchar* _tmp84_;
								LspPosition* _tmp85_;
								guint _tmp86_;
								guint _tmp87_;
								LspPosition* _tmp88_;
								guint _tmp89_;
								guint _tmp90_;
								gsize pos_end = 0UL;
								GString* _tmp91_;
								const gchar* _tmp92_;
								LspPosition* _tmp93_;
								guint _tmp94_;
								guint _tmp95_;
								LspPosition* _tmp96_;
								guint _tmp97_;
								guint _tmp98_;
								GString* _tmp99_;
								GString* _tmp100_;
								LspTextDocumentContentChangeEvent* _tmp101_;
								const gchar* _tmp102_;
								const gchar* _tmp103_;
								_tmp71_ = changeEvent;
								_tmp72_ = lsp_text_document_content_change_event_get_range (_tmp71_);
								_tmp73_ = _tmp72_;
								_tmp74_ = lsp_range_get_start (_tmp73_);
								_tmp75_ = _tmp74_;
								_tmp76_ = _g_object_ref0 (_tmp75_);
								start = _tmp76_;
								_tmp77_ = changeEvent;
								_tmp78_ = lsp_text_document_content_change_event_get_range (_tmp77_);
								_tmp79_ = _tmp78_;
								_tmp80_ = lsp_range_get_end (_tmp79_);
								_tmp81_ = _tmp80_;
								_tmp82_ = _g_object_ref0 (_tmp81_);
								end = _tmp82_;
								_tmp83_ = sb;
								_tmp84_ = _tmp83_->str;
								_tmp85_ = start;
								_tmp86_ = lsp_position_get_line (_tmp85_);
								_tmp87_ = _tmp86_;
								_tmp88_ = start;
								_tmp89_ = lsp_position_get_character (_tmp88_);
								_tmp90_ = _tmp89_;
								pos_begin = vls_util_get_string_pos (_tmp84_, _tmp87_, _tmp90_);
								_tmp91_ = sb;
								_tmp92_ = _tmp91_->str;
								_tmp93_ = end;
								_tmp94_ = lsp_position_get_line (_tmp93_);
								_tmp95_ = _tmp94_;
								_tmp96_ = end;
								_tmp97_ = lsp_position_get_character (_tmp96_);
								_tmp98_ = _tmp97_;
								pos_end = vls_util_get_string_pos (_tmp92_, _tmp95_, _tmp98_);
								_tmp99_ = sb;
								g_string_erase (_tmp99_, (gssize) pos_begin, (gssize) (pos_end - pos_begin));
								_tmp100_ = sb;
								_tmp101_ = changeEvent;
								_tmp102_ = lsp_text_document_content_change_event_get_text (_tmp101_);
								_tmp103_ = _tmp102_;
								g_string_insert (_tmp100_, (gssize) pos_begin, _tmp103_);
								_g_object_unref0 (end);
								_g_object_unref0 (start);
							}
							_g_object_unref0 (changeEvent);
						}
						_tmp104_ = source;
						_tmp105_ = sb;
						_tmp106_ = _tmp105_->str;
						vala_source_file_set_content ((ValaSourceFile*) _tmp104_, _tmp106_);
						_tmp107_ = source;
						_tmp108_ = g_time_zone_new_local ();
						_tmp109_ = _tmp108_;
						_tmp110_ = g_date_time_new_now (_tmp109_);
						_tmp111_ = _tmp110_;
						vls_text_document_set_last_updated (_tmp107_, _tmp111_);
						_g_date_time_unref0 (_tmp111_);
						_g_time_zone_unref0 (_tmp109_);
						_tmp112_ = source;
						vls_text_document_set_version (_tmp112_, (gint) version);
						vls_server_request_context_update (self, client);
						_g_string_free0 (sb);
						_g_variant_unref0 (elem);
						_g_variant_iter_free0 (iter);
						_vala_source_file_unref0 (source);
						_vala_source_file_unref0 (source_file);
						_g_object_unref0 (pair);
					}
					_g_object_unref0 (_pair_list);
				}
				_g_object_unref0 (project);
			}
		}
	}
	all_projects = (_vala_array_free (all_projects, all_projects_length1, (GDestroyNotify) g_object_unref), NULL);
	_g_free0 (uri);
	_g_variant_unref0 (changes);
	_g_variant_unref0 (document);
}

/** 
     * Indicate to the server that the code context(s) it is tracking may
     * need to be refreshed.
     * 
     * @param client        the client to eventually send a `publishDiagnostics` 
     *                      notification to, if the context is refreshed
     */
static void
vls_server_request_context_update (VlsServer* self,
                                   JsonrpcClient* client)
{
	JsonrpcClient* _tmp0_;
	gint64 delay_us = 0LL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (client != NULL);
	_tmp0_ = _g_object_ref0 (client);
	_g_object_unref0 (self->priv->update_context_client);
	self->priv->update_context_client = _tmp0_;
	self->priv->update_context_requests = self->priv->update_context_requests + 1;
	delay_us = MIN (VLS_SERVER_update_context_delay_inc_us * self->priv->update_context_requests, VLS_SERVER_update_context_delay_max_us);
	self->priv->update_context_time_us = g_get_monotonic_time () + delay_us;
}

/** 
     * Reconfigure the project if needed, and check whether we need to rebuild
     * the project and documentation engine if we have context update requests.
     */
static VlsProject**
_vala_array_dup16 (VlsProject** self,
                   gssize length)
{
	if (length >= 0) {
		VlsProject** result;
		gssize i;
		result = g_new0 (VlsProject*, length + 1);
		for (i = 0; i < length; i++) {
			VlsProject* _tmp0_;
			_tmp0_ = _g_object_ref0 (self[i]);
			result[i] = _tmp0_;
		}
		return result;
	}
	return NULL;
}

static void
_vala_array_add28 (VlsProject** * array,
                   gint* length,
                   gint* size,
                   VlsProject* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (VlsProject*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static gchar*
_________lambda49_ (VlsServer* self,
                    ValaSourceFile* f)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* result;
	g_return_val_if_fail (f != NULL, NULL);
	_tmp0_ = vala_source_file_get_filename (f);
	_tmp1_ = _tmp0_;
	_tmp2_ = g_strdup (_tmp1_);
	result = _tmp2_;
	_vala_source_file_unref0 (f);
	return result;
}

static gpointer
__________lambda49__gee_map_func (gpointer g,
                                  gpointer self)
{
	gpointer result;
	result = _________lambda49_ ((VlsServer*) self, (ValaSourceFile*) g);
	return result;
}

static gboolean
vls_server_check_update_context (VlsServer* self)
{
	gboolean _tmp0_ = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	if (self->priv->update_context_requests > ((gint64) 0)) {
		_tmp0_ = g_get_monotonic_time () >= self->priv->update_context_time_us;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		VlsProject** all_projects = NULL;
		GHashTable* _tmp1_;
		guint _tmp2_ = 0;
		gconstpointer* _tmp3_;
		VlsProject** _tmp4_;
		gint _tmp4__length1;
		gint all_projects_length1;
		gint _all_projects_size_;
		VlsDefaultProject* _tmp5_;
		VlsProject* _tmp6_;
		gboolean reconfigured_projects = FALSE;
		VlsProject** _tmp7_;
		gint _tmp7__length1;
		VlsGirDocumentation* _tmp168_;
		g_debug ("server.vala:707: updating contexts and publishing diagnostics...");
		self->priv->update_context_requests = (gint64) 0;
		self->priv->update_context_time_us = (gint64) 0;
		_tmp1_ = self->priv->projects;
		_tmp3_ = g_hash_table_get_keys_as_array (_tmp1_, &_tmp2_);
		_tmp4_ = (_tmp3_ != NULL) ? _vala_array_dup16 (_tmp3_, _tmp2_) : _tmp3_;
		_tmp4__length1 = _tmp2_;
		_tmp3_ = (g_free (_tmp3_), NULL);
		all_projects = _tmp4_;
		all_projects_length1 = _tmp4__length1;
		_all_projects_size_ = all_projects_length1;
		_tmp5_ = self->priv->default_project;
		_tmp6_ = _g_object_ref0 ((VlsProject*) _tmp5_);
		_vala_array_add28 (&all_projects, &all_projects_length1, &_all_projects_size_, _tmp6_);
		reconfigured_projects = FALSE;
		_tmp7_ = all_projects;
		_tmp7__length1 = all_projects_length1;
		{
			VlsProject** project_collection = NULL;
			gint project_collection_length1 = 0;
			gint _project_collection_size_ = 0;
			gint project_it = 0;
			project_collection = _tmp7_;
			project_collection_length1 = _tmp7__length1;
			for (project_it = 0; project_it < project_collection_length1; project_it = project_it + 1) {
				VlsProject* _tmp8_;
				VlsProject* project = NULL;
				_tmp8_ = _g_object_ref0 (project_collection[project_it]);
				project = _tmp8_;
				{
					{
						gboolean reconfigured = FALSE;
						VlsProject* _tmp9_;
						GCancellable* _tmp10_;
						VlsProject* _tmp11_;
						GCancellable* _tmp12_;
						gboolean _tmp13_ = FALSE;
						_tmp9_ = project;
						_tmp10_ = vls_server_cancellable;
						reconfigured = vls_project_reconfigure_if_stale (_tmp9_, _tmp10_, &_inner_error0_);
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
							goto __catch0_g_error;
						}
						reconfigured_projects |= reconfigured;
						_tmp11_ = project;
						_tmp12_ = vls_server_cancellable;
						vls_project_build_if_stale (_tmp11_, _tmp12_, &_inner_error0_);
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
							goto __catch0_g_error;
						}
						if (reconfigured) {
							VlsProject* _tmp14_;
							VlsDefaultProject* _tmp15_;
							_tmp14_ = project;
							_tmp15_ = self->priv->default_project;
							_tmp13_ = _tmp14_ != G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, VLS_TYPE_PROJECT, VlsProject);
						} else {
							_tmp13_ = FALSE;
						}
						if (_tmp13_) {
							GeeHashSet* newly_added = NULL;
							GeeHashSet* _tmp16_;
							_tmp16_ = gee_hash_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
							if (_tmp16_) {
								g_object_set_data ((GObject *) _tmp16_, "vala-creation-function", "Vls.Server.check_update_context");
							}
							newly_added = _tmp16_;
							{
								GeeArrayList* _compilation_list = NULL;
								VlsProject* _tmp17_;
								GeeArrayList* _tmp18_;
								gint _compilation_size = 0;
								GeeArrayList* _tmp19_;
								gint _tmp20_;
								gint _tmp21_;
								gint _compilation_index = 0;
								_tmp17_ = project;
								_tmp18_ = vls_project_get_compilations (_tmp17_);
								_compilation_list = _tmp18_;
								_tmp19_ = _compilation_list;
								_tmp20_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp19_);
								_tmp21_ = _tmp20_;
								_compilation_size = _tmp21_;
								_compilation_index = -1;
								while (TRUE) {
									gint _tmp22_;
									gint _tmp23_;
									VlsCompilation* compilation = NULL;
									GeeArrayList* _tmp24_;
									gpointer _tmp25_;
									GeeHashSet* _tmp26_;
									VlsCompilation* _tmp27_;
									GeeCollection* _tmp28_;
									GeeCollection* _tmp29_;
									GeeIterator* _tmp30_;
									GeeIterator* _tmp31_;
									_compilation_index = _compilation_index + 1;
									_tmp22_ = _compilation_index;
									_tmp23_ = _compilation_size;
									if (!(_tmp22_ < _tmp23_)) {
										break;
									}
									_tmp24_ = _compilation_list;
									_tmp25_ = gee_abstract_list_get ((GeeAbstractList*) _tmp24_, _compilation_index);
									compilation = (VlsCompilation*) _tmp25_;
									_tmp26_ = newly_added;
									_tmp27_ = compilation;
									_tmp28_ = vls_compilation_get_project_files (_tmp27_);
									_tmp29_ = _tmp28_;
									_tmp30_ = gee_traversable_map ((GeeTraversable*) _tmp29_, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, __________lambda49__gee_map_func, self);
									_tmp31_ = _tmp30_;
									gee_collection_add_all_iterator ((GeeCollection*) _tmp26_, _tmp31_);
									_g_object_unref0 (_tmp31_);
									_g_object_unref0 (_tmp29_);
									_g_object_unref0 (compilation);
								}
								_g_object_unref0 (_compilation_list);
							}
							{
								GeeArrayList* _compilation_list = NULL;
								VlsDefaultProject* _tmp32_;
								GeeArrayList* _tmp33_;
								gint _compilation_size = 0;
								GeeArrayList* _tmp34_;
								gint _tmp35_;
								gint _tmp36_;
								gint _compilation_index = 0;
								_tmp32_ = self->priv->default_project;
								_tmp33_ = vls_project_get_compilations ((VlsProject*) _tmp32_);
								_compilation_list = _tmp33_;
								_tmp34_ = _compilation_list;
								_tmp35_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp34_);
								_tmp36_ = _tmp35_;
								_compilation_size = _tmp36_;
								_compilation_index = -1;
								while (TRUE) {
									gint _tmp37_;
									gint _tmp38_;
									VlsCompilation* compilation = NULL;
									GeeArrayList* _tmp39_;
									gpointer _tmp40_;
									_compilation_index = _compilation_index + 1;
									_tmp37_ = _compilation_index;
									_tmp38_ = _compilation_size;
									if (!(_tmp37_ < _tmp38_)) {
										break;
									}
									_tmp39_ = _compilation_list;
									_tmp40_ = gee_abstract_list_get ((GeeAbstractList*) _tmp39_, _compilation_index);
									compilation = (VlsCompilation*) _tmp40_;
									{
										GeeIterator* _source_file_it = NULL;
										VlsCompilation* _tmp41_;
										GeeCollection* _tmp42_;
										GeeCollection* _tmp43_;
										GeeIterator* _tmp44_;
										GeeIterator* _tmp45_;
										_tmp41_ = compilation;
										_tmp42_ = vls_compilation_get_project_files (_tmp41_);
										_tmp43_ = _tmp42_;
										_tmp44_ = gee_iterable_iterator ((GeeIterable*) _tmp43_);
										_tmp45_ = _tmp44_;
										_g_object_unref0 (_tmp43_);
										_source_file_it = _tmp45_;
										while (TRUE) {
											GeeIterator* _tmp46_;
											ValaSourceFile* source_file = NULL;
											GeeIterator* _tmp47_;
											gpointer _tmp48_;
											GeeHashSet* _tmp49_;
											ValaSourceFile* _tmp50_;
											const gchar* _tmp51_;
											const gchar* _tmp52_;
											_tmp46_ = _source_file_it;
											if (!gee_iterator_next (_tmp46_)) {
												break;
											}
											_tmp47_ = _source_file_it;
											_tmp48_ = gee_iterator_get (_tmp47_);
											source_file = (ValaSourceFile*) _tmp48_;
											_tmp49_ = newly_added;
											_tmp50_ = source_file;
											_tmp51_ = vala_source_file_get_filename (_tmp50_);
											_tmp52_ = _tmp51_;
											if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp49_, _tmp52_)) {
												gchar* uri = NULL;
												ValaSourceFile* _tmp53_;
												const gchar* _tmp54_;
												const gchar* _tmp55_;
												GFile* _tmp56_;
												GFile* _tmp57_;
												gchar* _tmp58_;
												gchar* _tmp59_;
												_tmp53_ = source_file;
												_tmp54_ = vala_source_file_get_filename (_tmp53_);
												_tmp55_ = _tmp54_;
												_tmp56_ = g_file_new_for_path (_tmp55_);
												_tmp57_ = _tmp56_;
												_tmp58_ = g_file_get_uri (_tmp57_);
												_tmp59_ = _tmp58_;
												_g_object_unref0 (_tmp57_);
												uri = _tmp59_;
												{
													VlsDefaultProject* _tmp60_;
													const gchar* _tmp61_;
													GeeHashSet* _tmp62_;
													const gchar* _tmp63_;
													const gchar* _tmp64_;
													_tmp60_ = self->priv->default_project;
													_tmp61_ = uri;
													vls_project_close ((VlsProject*) _tmp60_, _tmp61_, &_inner_error0_);
													if (G_UNLIKELY (_inner_error0_ != NULL)) {
														goto __catch1_g_error;
													}
													_tmp62_ = self->priv->discarded_files;
													_tmp63_ = uri;
													gee_abstract_collection_add ((GeeAbstractCollection*) _tmp62_, _tmp63_);
													_tmp64_ = uri;
													g_debug ("server.vala:732: discarding %s from DefaultProject", _tmp64_);
												}
												goto __finally1;
												__catch1_g_error:
												{
													g_clear_error (&_inner_error0_);
												}
												__finally1:
												if (G_UNLIKELY (_inner_error0_ != NULL)) {
													_g_free0 (uri);
													_vala_source_file_unref0 (source_file);
													_g_object_unref0 (_source_file_it);
													_g_object_unref0 (compilation);
													_g_object_unref0 (_compilation_list);
													_g_object_unref0 (newly_added);
													goto __catch0_g_error;
												}
												_g_free0 (uri);
											}
											_vala_source_file_unref0 (source_file);
										}
										_g_object_unref0 (_source_file_it);
									}
									_g_object_unref0 (compilation);
								}
								_g_object_unref0 (_compilation_list);
							}
							_g_object_unref0 (newly_added);
						}
						{
							GeeArrayList* _compilation_list = NULL;
							VlsProject* _tmp65_;
							GeeArrayList* _tmp66_;
							gint _compilation_size = 0;
							GeeArrayList* _tmp67_;
							gint _tmp68_;
							gint _tmp69_;
							gint _compilation_index = 0;
							_tmp65_ = project;
							_tmp66_ = vls_project_get_compilations (_tmp65_);
							_compilation_list = _tmp66_;
							_tmp67_ = _compilation_list;
							_tmp68_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp67_);
							_tmp69_ = _tmp68_;
							_compilation_size = _tmp69_;
							_compilation_index = -1;
							while (TRUE) {
								gint _tmp70_;
								gint _tmp71_;
								VlsCompilation* compilation = NULL;
								GeeArrayList* _tmp72_;
								gpointer _tmp73_;
								VlsProject* _tmp74_;
								VlsCompilation* _tmp75_;
								JsonrpcClient* _tmp76_;
								_compilation_index = _compilation_index + 1;
								_tmp70_ = _compilation_index;
								_tmp71_ = _compilation_size;
								if (!(_tmp70_ < _tmp71_)) {
									break;
								}
								_tmp72_ = _compilation_list;
								_tmp73_ = gee_abstract_list_get ((GeeAbstractList*) _tmp72_, _compilation_index);
								compilation = (VlsCompilation*) _tmp73_;
								_tmp74_ = project;
								_tmp75_ = compilation;
								_tmp76_ = self->priv->update_context_client;
								vls_server_publish_diagnostics (self, _tmp74_, _tmp75_, _tmp76_);
								_g_object_unref0 (compilation);
							}
							_g_object_unref0 (_compilation_list);
						}
					}
					goto __finally0;
					__catch0_g_error:
					{
						GError* e = NULL;
						GError* _tmp77_;
						const gchar* _tmp78_;
						JsonrpcClient* _tmp79_;
						GError* _tmp80_;
						const gchar* _tmp81_;
						const gchar* _tmp82_;
						gchar* _tmp83_;
						gchar* _tmp84_;
						e = _inner_error0_;
						_inner_error0_ = NULL;
						_tmp77_ = e;
						_tmp78_ = _tmp77_->message;
						g_warning ("server.vala:749: Failed to rebuild and/or reconfigure project: %s", _tmp78_);
						_tmp79_ = self->priv->update_context_client;
						_tmp80_ = e;
						_tmp81_ = _tmp80_->message;
						_tmp82_ = string_to_string (_tmp81_);
						_tmp83_ = g_strconcat ("Failed to rebuild/reconfigure project: ", _tmp82_, NULL);
						_tmp84_ = _tmp83_;
						vls_server_show_message (self, _tmp79_, _tmp84_, LSP_MESSAGE_TYPE_Error);
						_g_free0 (_tmp84_);
						_g_error_free0 (e);
					}
					__finally0:
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						gboolean _tmp85_ = FALSE;
						_g_object_unref0 (project);
						all_projects = (_vala_array_free (all_projects, all_projects_length1, (GDestroyNotify) g_object_unref), NULL);
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return _tmp85_;
					}
					_g_object_unref0 (project);
				}
			}
		}
		if (reconfigured_projects) {
			GeeHashSet* orphaned_files = NULL;
			GeeHashSet* _tmp86_;
			GeeHashSet* _tmp87_;
			GeeHashSet* _tmp88_;
			GHashTable* _tmp89_;
			GList* _tmp90_;
			_tmp86_ = gee_hash_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
			if (_tmp86_) {
				g_object_set_data ((GObject *) _tmp86_, "vala-creation-function", "Vls.Server.check_update_context");
			}
			orphaned_files = _tmp86_;
			_tmp87_ = orphaned_files;
			_tmp88_ = self->priv->open_files;
			gee_collection_add_all ((GeeCollection*) _tmp87_, (GeeCollection*) _tmp88_);
			_tmp89_ = self->priv->projects;
			_tmp90_ = g_hash_table_get_keys (_tmp89_);
			{
				GList* project_collection = NULL;
				GList* project_it = NULL;
				project_collection = _tmp90_;
				for (project_it = project_collection; project_it != NULL; project_it = project_it->next) {
					VlsProject* project = NULL;
					project = (VlsProject*) project_it->data;
					{
						{
							GeeArrayList* _compilation_list = NULL;
							VlsProject* _tmp91_;
							GeeArrayList* _tmp92_;
							gint _compilation_size = 0;
							GeeArrayList* _tmp93_;
							gint _tmp94_;
							gint _tmp95_;
							gint _compilation_index = 0;
							_tmp91_ = project;
							_tmp92_ = vls_project_get_compilations (_tmp91_);
							_compilation_list = _tmp92_;
							_tmp93_ = _compilation_list;
							_tmp94_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp93_);
							_tmp95_ = _tmp94_;
							_compilation_size = _tmp95_;
							_compilation_index = -1;
							while (TRUE) {
								gint _tmp96_;
								gint _tmp97_;
								VlsCompilation* compilation = NULL;
								GeeArrayList* _tmp98_;
								gpointer _tmp99_;
								_compilation_index = _compilation_index + 1;
								_tmp96_ = _compilation_index;
								_tmp97_ = _compilation_size;
								if (!(_tmp96_ < _tmp97_)) {
									break;
								}
								_tmp98_ = _compilation_list;
								_tmp99_ = gee_abstract_list_get ((GeeAbstractList*) _tmp98_, _compilation_index);
								compilation = (VlsCompilation*) _tmp99_;
								{
									ValaList* _source_file_list = NULL;
									VlsCompilation* _tmp100_;
									ValaCodeContext* _tmp101_;
									ValaCodeContext* _tmp102_;
									ValaList* _tmp103_;
									gint _source_file_size = 0;
									ValaList* _tmp104_;
									gint _tmp105_;
									gint _tmp106_;
									gint _source_file_index = 0;
									_tmp100_ = compilation;
									_tmp101_ = vls_compilation_get_code_context (_tmp100_);
									_tmp102_ = _tmp101_;
									_tmp103_ = vala_code_context_get_source_files (_tmp102_);
									_source_file_list = _tmp103_;
									_tmp104_ = _source_file_list;
									_tmp105_ = vala_collection_get_size ((ValaCollection*) _tmp104_);
									_tmp106_ = _tmp105_;
									_source_file_size = _tmp106_;
									_source_file_index = -1;
									while (TRUE) {
										gint _tmp107_;
										gint _tmp108_;
										ValaSourceFile* source_file = NULL;
										ValaList* _tmp109_;
										gpointer _tmp110_;
										gchar* uri = NULL;
										ValaSourceFile* _tmp111_;
										const gchar* _tmp112_;
										const gchar* _tmp113_;
										GFile* _tmp114_;
										GFile* _tmp115_;
										gchar* _tmp116_;
										gchar* _tmp117_;
										GeeHashSet* _tmp118_;
										const gchar* _tmp119_;
										_source_file_index = _source_file_index + 1;
										_tmp107_ = _source_file_index;
										_tmp108_ = _source_file_size;
										if (!(_tmp107_ < _tmp108_)) {
											break;
										}
										_tmp109_ = _source_file_list;
										_tmp110_ = vala_list_get (_tmp109_, _source_file_index);
										source_file = (ValaSourceFile*) _tmp110_;
										_tmp111_ = source_file;
										_tmp112_ = vala_source_file_get_filename (_tmp111_);
										_tmp113_ = _tmp112_;
										_tmp114_ = g_file_new_for_path (_tmp113_);
										_tmp115_ = _tmp114_;
										_tmp116_ = g_file_get_uri (_tmp115_);
										_tmp117_ = _tmp116_;
										_g_object_unref0 (_tmp115_);
										uri = _tmp117_;
										_tmp118_ = orphaned_files;
										_tmp119_ = uri;
										gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp118_, _tmp119_);
										_g_free0 (uri);
										_vala_source_file_unref0 (source_file);
									}
								}
								_g_object_unref0 (compilation);
							}
							_g_object_unref0 (_compilation_list);
						}
					}
				}
				(project_collection == NULL) ? NULL : (project_collection = (g_list_free (project_collection), NULL));
			}
			{
				GeeIterator* _uri_it = NULL;
				GeeHashSet* _tmp120_;
				GeeIterator* _tmp121_;
				_tmp120_ = orphaned_files;
				_tmp121_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp120_);
				_uri_it = _tmp121_;
				while (TRUE) {
					GeeIterator* _tmp122_;
					gchar* uri = NULL;
					GeeIterator* _tmp123_;
					gpointer _tmp124_;
					_tmp122_ = _uri_it;
					if (!gee_iterator_next (_tmp122_)) {
						break;
					}
					_tmp123_ = _uri_it;
					_tmp124_ = gee_iterator_get (_tmp123_);
					uri = (gchar*) _tmp124_;
					{
						GeeArrayList* _tmp125_ = NULL;
						VlsDefaultProject* _tmp126_;
						const gchar* _tmp127_;
						GCancellable* _tmp128_;
						GeeArrayList* _tmp129_;
						VlsPair* opened = NULL;
						gpointer _tmp130_;
						ValaSourceFile* doc = NULL;
						VlsPair* _tmp131_;
						gconstpointer _tmp132_;
						gconstpointer _tmp133_;
						ValaSourceFile* _tmp134_;
						ValaSourceFile* _tmp135_;
						const gchar* _tmp136_;
						const gchar* _tmp137_;
						ValaSourceFile* _tmp139_;
						VlsDefaultProject* _tmp144_;
						VlsPair* _tmp145_;
						gconstpointer _tmp146_;
						gconstpointer _tmp147_;
						JsonrpcClient* _tmp148_;
						_tmp126_ = self->priv->default_project;
						_tmp127_ = uri;
						_tmp128_ = vls_server_cancellable;
						_tmp129_ = vls_project_open ((VlsProject*) _tmp126_, _tmp127_, NULL, _tmp128_, &_inner_error0_);
						_tmp125_ = _tmp129_;
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
							goto __catch2_g_error;
						}
						_tmp130_ = gee_list_first ((GeeList*) _tmp125_);
						opened = (VlsPair*) _tmp130_;
						_tmp131_ = opened;
						_tmp132_ = vls_pair_get_first (_tmp131_);
						_tmp133_ = _tmp132_;
						_tmp134_ = _vala_source_file_ref0 ((ValaSourceFile*) _tmp133_);
						doc = _tmp134_;
						_tmp135_ = doc;
						_tmp136_ = vala_source_file_get_content (_tmp135_);
						_tmp137_ = _tmp136_;
						if (_tmp137_ == NULL) {
							ValaSourceFile* _tmp138_;
							_tmp138_ = doc;
							vala_source_file_get_mapped_contents (_tmp138_);
						}
						_tmp139_ = doc;
						if (VLS_IS_TEXT_DOCUMENT (_tmp139_)) {
							ValaSourceFile* _tmp140_;
							ValaSourceFile* _tmp141_;
							const gchar* _tmp142_;
							const gchar* _tmp143_;
							_tmp140_ = doc;
							_tmp141_ = doc;
							_tmp142_ = vala_source_file_get_content (_tmp141_);
							_tmp143_ = _tmp142_;
							vls_text_document_set_last_saved_content (G_TYPE_CHECK_INSTANCE_CAST (_tmp140_, VLS_TYPE_TEXT_DOCUMENT, VlsTextDocument), _tmp143_);
						}
						_tmp144_ = self->priv->default_project;
						_tmp145_ = opened;
						_tmp146_ = vls_pair_get_second (_tmp145_);
						_tmp147_ = _tmp146_;
						_tmp148_ = self->priv->update_context_client;
						vls_server_publish_diagnostics (self, (VlsProject*) _tmp144_, (VlsCompilation*) _tmp147_, _tmp148_);
						_vala_source_file_unref0 (doc);
						_g_object_unref0 (opened);
						_g_object_unref0 (_tmp125_);
					}
					goto __finally2;
					__catch2_g_error:
					{
						GError* e = NULL;
						const gchar* _tmp149_;
						GError* _tmp150_;
						const gchar* _tmp151_;
						e = _inner_error0_;
						_inner_error0_ = NULL;
						_tmp149_ = uri;
						_tmp150_ = e;
						_tmp151_ = _tmp150_->message;
						g_warning ("server.vala:777: Failed to reopen in default project %s - %s", _tmp149_, _tmp151_);
						{
							JsonrpcClient* _tmp152_;
							const gchar* _tmp153_;
							GVariant* _tmp154_;
							GVariant* _tmp155_;
							const GVariantType* _tmp156_;
							GVariant** _tmp157_;
							GVariant** _tmp158_;
							gint _tmp158__length1;
							GVariant* _tmp159_;
							GVariant* _tmp160_;
							GVariant* _tmp161_;
							GVariant* _tmp162_;
							_tmp152_ = self->priv->update_context_client;
							_tmp153_ = uri;
							_tmp154_ = g_variant_new_string (_tmp153_);
							g_variant_ref_sink (_tmp154_);
							_tmp155_ = _tmp154_;
							_tmp156_ = G_VARIANT_TYPE_VARIANT;
							_tmp157_ = g_new0 (GVariant*, 0 + 1);
							_tmp158_ = _tmp157_;
							_tmp158__length1 = 0;
							_tmp159_ = g_variant_new_array (_tmp156_, _tmp158_, 0);
							g_variant_ref_sink (_tmp159_);
							_tmp160_ = _tmp159_;
							_tmp161_ = vls_server_build_dict (self, "uri", _tmp155_, "diagnostics", _tmp160_, NULL);
							_tmp162_ = _tmp161_;
							jsonrpc_client_send_notification (_tmp152_, "textDocument/publishDiagnostics", _tmp162_, NULL, &_inner_error0_);
							_g_variant_unref0 (_tmp162_);
							_g_variant_unref0 (_tmp160_);
							_tmp158_ = (_vala_array_free (_tmp158_, _tmp158__length1, (GDestroyNotify) g_variant_unref), NULL);
							_g_variant_unref0 (_tmp155_);
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
								goto __catch3_g_error;
							}
						}
						goto __finally3;
						__catch3_g_error:
						{
							GError* e = NULL;
							const gchar* _tmp163_;
							GError* _tmp164_;
							const gchar* _tmp165_;
							e = _inner_error0_;
							_inner_error0_ = NULL;
							_tmp163_ = uri;
							_tmp164_ = e;
							_tmp165_ = _tmp164_->message;
							g_warning ("server.vala:788: Failed to clear diagnostics for %s - %s", _tmp163_, _tmp165_);
							_g_error_free0 (e);
						}
						__finally3:
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
							gboolean _tmp166_ = FALSE;
							_g_error_free0 (e);
							_g_free0 (uri);
							_g_object_unref0 (_uri_it);
							_g_object_unref0 (orphaned_files);
							all_projects = (_vala_array_free (all_projects, all_projects_length1, (GDestroyNotify) g_object_unref), NULL);
							g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
							g_clear_error (&_inner_error0_);
							return _tmp166_;
						}
						_g_error_free0 (e);
					}
					__finally2:
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						gboolean _tmp167_ = FALSE;
						_g_free0 (uri);
						_g_object_unref0 (_uri_it);
						_g_object_unref0 (orphaned_files);
						all_projects = (_vala_array_free (all_projects, all_projects_length1, (GDestroyNotify) g_object_unref), NULL);
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
						g_clear_error (&_inner_error0_);
						return _tmp167_;
					}
					_g_free0 (uri);
				}
				_g_object_unref0 (_uri_it);
			}
			_g_object_unref0 (orphaned_files);
		}
		_tmp168_ = self->priv->documentation;
		vls_gir_documentation_rebuild_if_stale (_tmp168_);
		all_projects = (_vala_array_free (all_projects, all_projects_length1, (GDestroyNotify) g_object_unref), NULL);
	}
	result = !self->priv->shutting_down;
	return result;
}

/**
     * Rather than satisfying all requests in `check_update_context ()`,
     * to avoid race conditions, we have to spawn a timeout to check for 
     * the right conditions to call `on_context_updated_func ()`.
     */
void
vls_server_wait_for_context_update (VlsServer* self,
                                    GVariant* id,
                                    VlsServerOnContextUpdatedFunc on_context_updated_func,
                                    gpointer on_context_updated_func_target,
                                    GDestroyNotify on_context_updated_func_target_destroy_notify)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (id != NULL);
	if (self->priv->update_context_requests == ((gint64) 0)) {
		on_context_updated_func (FALSE, on_context_updated_func_target);
	} else {
		VlsRequest* req = NULL;
		VlsRequest* _tmp0_;
		GeeHashSet* _tmp1_;
		VlsRequest* _tmp2_;
		VlsRequest* _tmp8_;
		VlsServerOnContextUpdatedFunc _tmp9_;
		gpointer _tmp9__target;
		GDestroyNotify _tmp9__target_destroy_notify;
		_tmp0_ = vls_request_new (id, NULL);
		if (_tmp0_) {
			g_object_set_data ((GObject *) _tmp0_, "vala-creation-function", "Vls.Server.wait_for_context_update");
		}
		req = _tmp0_;
		_tmp1_ = self->priv->pending_requests;
		_tmp2_ = req;
		if (!gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, _tmp2_)) {
			VlsRequest* _tmp3_;
			gchar* _tmp4_;
			gchar* _tmp5_;
			gchar* _tmp6_;
			gchar* _tmp7_;
			_tmp3_ = req;
			_tmp4_ = vls_request_to_string (_tmp3_);
			_tmp5_ = _tmp4_;
			_tmp6_ = g_strconcat ("Request (", _tmp5_, "): request already in pending requests, this should not happen", NULL);
			_tmp7_ = _tmp6_;
			g_warning ("server.vala:814: %s", _tmp7_);
			_g_free0 (_tmp7_);
			_g_free0 (_tmp5_);
		}
		_tmp8_ = req;
		_tmp9_ = on_context_updated_func;
		_tmp9__target = on_context_updated_func_target;
		_tmp9__target_destroy_notify = on_context_updated_func_target_destroy_notify;
		on_context_updated_func = NULL;
		on_context_updated_func_target = NULL;
		on_context_updated_func_target_destroy_notify = NULL;
		vls_server_wait_for_context_update_aux (self, _tmp8_, _tmp9_, _tmp9__target, _tmp9__target_destroy_notify);
		_g_object_unref0 (req);
	}
	(on_context_updated_func_target_destroy_notify == NULL) ? NULL : (on_context_updated_func_target_destroy_notify (on_context_updated_func_target), NULL);
	on_context_updated_func = NULL;
	on_context_updated_func_target = NULL;
	on_context_updated_func_target_destroy_notify = NULL;
}

/**
     * Execute `on_context_updated_func ()` or wait.
     */
static Block29Data*
block29_data_ref (Block29Data* _data29_)
{
	g_atomic_int_inc (&_data29_->_ref_count_);
	return _data29_;
}

static void
block29_data_unref (void * _userdata_)
{
	Block29Data* _data29_;
	_data29_ = (Block29Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data29_->_ref_count_)) {
		VlsServer* self;
		self = _data29_->self;
		_g_object_unref0 (_data29_->req);
		(_data29_->on_context_updated_func_target_destroy_notify == NULL) ? NULL : (_data29_->on_context_updated_func_target_destroy_notify (_data29_->on_context_updated_func_target), NULL);
		_data29_->on_context_updated_func = NULL;
		_data29_->on_context_updated_func_target = NULL;
		_data29_->on_context_updated_func_target_destroy_notify = NULL;
		_g_object_unref0 (self);
		g_slice_free (Block29Data, _data29_);
	}
}

static gboolean
___lambda50_ (Block29Data* _data29_)
{
	VlsServer* self;
	GeeHashSet* _tmp0_;
	gboolean result;
	self = _data29_->self;
	_tmp0_ = self->priv->pending_requests;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, _data29_->req)) {
		VlsServerOnContextUpdatedFunc _tmp1_;
		gpointer _tmp1__target;
		GDestroyNotify _tmp1__target_destroy_notify;
		_tmp1_ = _data29_->on_context_updated_func;
		_tmp1__target = _data29_->on_context_updated_func_target;
		_tmp1__target_destroy_notify = _data29_->on_context_updated_func_target_destroy_notify;
		_data29_->on_context_updated_func = NULL;
		_data29_->on_context_updated_func_target = NULL;
		_data29_->on_context_updated_func_target_destroy_notify = NULL;
		vls_server_wait_for_context_update_aux (self, _data29_->req, _tmp1_, _tmp1__target, _tmp1__target_destroy_notify);
	} else {
		_data29_->on_context_updated_func (TRUE, _data29_->on_context_updated_func_target);
	}
	result = G_SOURCE_REMOVE;
	return result;
}

static gboolean
____lambda50__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda50_ (self);
	return result;
}

static void
vls_server_wait_for_context_update_aux (VlsServer* self,
                                        VlsRequest* req,
                                        VlsServerOnContextUpdatedFunc on_context_updated_func,
                                        gpointer on_context_updated_func_target,
                                        GDestroyNotify on_context_updated_func_target_destroy_notify)
{
	Block29Data* _data29_;
	VlsRequest* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (req != NULL);
	_data29_ = g_slice_new0 (Block29Data);
	_data29_->_ref_count_ = 1;
	_data29_->self = g_object_ref (self);
	_tmp0_ = _g_object_ref0 (req);
	_g_object_unref0 (_data29_->req);
	_data29_->req = _tmp0_;
	(_data29_->on_context_updated_func_target_destroy_notify == NULL) ? NULL : (_data29_->on_context_updated_func_target_destroy_notify (_data29_->on_context_updated_func_target), NULL);
	_data29_->on_context_updated_func = NULL;
	_data29_->on_context_updated_func_target = NULL;
	_data29_->on_context_updated_func_target_destroy_notify = NULL;
	_data29_->on_context_updated_func = on_context_updated_func;
	_data29_->on_context_updated_func_target = on_context_updated_func_target;
	_data29_->on_context_updated_func_target_destroy_notify = on_context_updated_func_target_destroy_notify;
	if (self->priv->update_context_requests == ((gint64) 0)) {
		GeeHashSet* _tmp1_;
		_tmp1_ = self->priv->pending_requests;
		if (!gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp1_, _data29_->req)) {
			_data29_->on_context_updated_func (TRUE, _data29_->on_context_updated_func_target);
		} else {
			_data29_->on_context_updated_func (FALSE, _data29_->on_context_updated_func_target);
		}
	} else {
		g_timeout_add_full (G_PRIORITY_DEFAULT, VLS_SERVER_wait_for_context_update_delay_ms, ____lambda50__gsource_func, block29_data_ref (_data29_), block29_data_unref);
	}
	block29_data_unref (_data29_);
	_data29_ = NULL;
}

static Block30Data*
block30_data_ref (Block30Data* _data30_)
{
	g_atomic_int_inc (&_data30_->_ref_count_);
	return _data30_;
}

static void
block30_data_unref (void * _userdata_)
{
	Block30Data* _data30_;
	_data30_ = (Block30Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data30_->_ref_count_)) {
		VlsServer* self;
		self = _data30_->self;
		_g_object_unref0 (_data30_->doc_diags);
		_json_array_unref0 (_data30_->diags_without_source);
		_g_object_unref0 (_data30_->target);
		_g_object_unref0 (self);
		g_slice_free (Block30Data, _data30_);
	}
}

static JsonNode*
_vala_JsonNode_copy (JsonNode* self)
{
	return g_boxed_copy (json_node_get_type (), self);
}

static gpointer
__vala_JsonNode_copy0 (gpointer self)
{
	return self ? _vala_JsonNode_copy (self) : NULL;
}

static void
_vala_JsonNode_free (JsonNode* self)
{
	g_boxed_free (json_node_get_type (), self);
}

static void
__lambda48_ (Block30Data* _data30_,
             VlsSourceMessage* err)
{
	VlsServer* self;
	ValaSourceReference* _tmp0_;
	ValaSourceReference* _tmp10_;
	ValaSourceFile* _tmp11_;
	ValaSourceFile* _tmp12_;
	ValaCodeContext* _tmp13_;
	ValaCodeContext* _tmp14_;
	ValaList* _tmp15_;
	ValaSourceReference* _tmp16_;
	ValaSourceFile* _tmp17_;
	ValaSourceFile* _tmp18_;
	LspDiagnostic* diag = NULL;
	ValaSourceReference* _tmp23_;
	ValaSourceLocation _tmp24_ = {0};
	ValaSourceLocation _tmp25_;
	ValaSourceReference* _tmp26_;
	ValaSourceLocation _tmp27_ = {0};
	ValaSourceLocation _tmp28_;
	LspPosition* _tmp29_ = NULL;
	ValaSourceReference* _tmp30_;
	ValaSourceLocation _tmp31_ = {0};
	ValaSourceLocation _tmp32_;
	ValaSourceReference* _tmp33_;
	ValaSourceLocation _tmp34_ = {0};
	ValaSourceLocation _tmp35_;
	LspPosition* _tmp36_ = NULL;
	LspRange* _tmp37_ = NULL;
	const gchar* _tmp38_;
	gchar* _tmp39_;
	LspDiagnostic* _tmp40_ = NULL;
	JsonNode* node = NULL;
	LspDiagnostic* _tmp41_;
	JsonNode* _tmp42_;
	gboolean _tmp43_ = FALSE;
	GeeHashMap* _tmp44_;
	ValaSourceReference* _tmp45_;
	ValaSourceFile* _tmp46_;
	ValaSourceFile* _tmp47_;
	GeeHashMap* _tmp60_;
	ValaSourceReference* _tmp61_;
	ValaSourceFile* _tmp62_;
	ValaSourceFile* _tmp63_;
	gpointer _tmp64_;
	JsonArray* _tmp65_;
	JsonNode* _tmp66_;
	JsonNode* _tmp67_;
	self = _data30_->self;
	g_return_if_fail (err != NULL);
	_tmp0_ = err->loc;
	if (_tmp0_ == NULL) {
		JsonArray* _tmp1_;
		LspPosition* _tmp2_ = NULL;
		LspPosition* _tmp3_ = NULL;
		LspRange* _tmp4_ = NULL;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		LspDiagnostic* _tmp7_ = NULL;
		LspDiagnostic* _tmp8_;
		JsonNode* _tmp9_;
		_tmp1_ = _data30_->diags_without_source;
		_tmp2_ = lsp_position_new ();
		lsp_position_set_line (_tmp2_, (guint) 1);
		lsp_position_set_character (_tmp2_, (guint) 1);
		_tmp3_ = lsp_position_new ();
		lsp_position_set_line (_tmp3_, (guint) 1);
		lsp_position_set_character (_tmp3_, (guint) 1);
		_tmp4_ = lsp_range_new ();
		lsp_range_set_start (_tmp4_, _tmp2_);
		_g_object_unref0 (_tmp2_);
		lsp_range_set_end (_tmp4_, _tmp3_);
		_g_object_unref0 (_tmp3_);
		_tmp5_ = err->message;
		_tmp6_ = g_strdup (_tmp5_);
		_tmp7_ = lsp_diagnostic_new ();
		lsp_diagnostic_set_range (_tmp7_, _tmp4_);
		_g_object_unref0 (_tmp4_);
		lsp_diagnostic_set_severity (_tmp7_, err->severity);
		lsp_diagnostic_set_message (_tmp7_, _tmp6_);
		_g_free0 (_tmp6_);
		_tmp8_ = _tmp7_;
		_tmp9_ = json_gobject_serialize ((GObject*) _tmp8_);
		json_array_add_element (_tmp1_, _tmp9_);
		_g_object_unref0 (_tmp8_);
		return;
	}
	_tmp10_ = err->loc;
	_tmp11_ = vala_source_reference_get_file (_tmp10_);
	_tmp12_ = _tmp11_;
	_vala_assert (_tmp12_ != NULL, "err.loc.file != null");
	_tmp13_ = vls_compilation_get_code_context (_data30_->target);
	_tmp14_ = _tmp13_;
	_tmp15_ = vala_code_context_get_source_files (_tmp14_);
	_tmp16_ = err->loc;
	_tmp17_ = vala_source_reference_get_file (_tmp16_);
	_tmp18_ = _tmp17_;
	if (!vala_collection_contains ((ValaCollection*) _tmp15_, _tmp18_)) {
		const gchar* _tmp19_;
		const gchar* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
		_tmp19_ = err->message;
		_tmp20_ = string_to_string (_tmp19_);
		_tmp21_ = g_strconcat ("diagnostic has source not in compilation! - ", _tmp20_, NULL);
		_tmp22_ = _tmp21_;
		g_warning ("server.vala:876: %s", _tmp22_);
		_g_free0 (_tmp22_);
		return;
	}
	_tmp23_ = err->loc;
	vala_source_reference_get_begin (_tmp23_, &_tmp24_);
	_tmp25_ = _tmp24_;
	_tmp26_ = err->loc;
	vala_source_reference_get_begin (_tmp26_, &_tmp27_);
	_tmp28_ = _tmp27_;
	_tmp29_ = lsp_position_new ();
	lsp_position_set_line (_tmp29_, (guint) (_tmp25_.line - 1));
	lsp_position_set_character (_tmp29_, (guint) (_tmp28_.column - 1));
	_tmp30_ = err->loc;
	vala_source_reference_get_end (_tmp30_, &_tmp31_);
	_tmp32_ = _tmp31_;
	_tmp33_ = err->loc;
	vala_source_reference_get_end (_tmp33_, &_tmp34_);
	_tmp35_ = _tmp34_;
	_tmp36_ = lsp_position_new ();
	lsp_position_set_line (_tmp36_, (guint) (_tmp32_.line - 1));
	lsp_position_set_character (_tmp36_, (guint) _tmp35_.column);
	_tmp37_ = lsp_range_new ();
	lsp_range_set_start (_tmp37_, _tmp29_);
	_g_object_unref0 (_tmp29_);
	lsp_range_set_end (_tmp37_, _tmp36_);
	_g_object_unref0 (_tmp36_);
	_tmp38_ = err->message;
	_tmp39_ = g_strdup (_tmp38_);
	_tmp40_ = lsp_diagnostic_new ();
	lsp_diagnostic_set_range (_tmp40_, _tmp37_);
	_g_object_unref0 (_tmp37_);
	lsp_diagnostic_set_severity (_tmp40_, err->severity);
	lsp_diagnostic_set_message (_tmp40_, _tmp39_);
	_g_free0 (_tmp39_);
	diag = _tmp40_;
	_tmp41_ = diag;
	_tmp42_ = json_gobject_serialize ((GObject*) _tmp41_);
	node = _tmp42_;
	_tmp44_ = _data30_->doc_diags;
	_tmp45_ = err->loc;
	_tmp46_ = vala_source_reference_get_file (_tmp45_);
	_tmp47_ = _tmp46_;
	if (!gee_abstract_map_has_key ((GeeAbstractMap*) _tmp44_, _tmp47_)) {
		_tmp43_ = TRUE;
	} else {
		GeeHashMap* _tmp48_;
		ValaSourceReference* _tmp49_;
		ValaSourceFile* _tmp50_;
		ValaSourceFile* _tmp51_;
		gpointer _tmp52_;
		JsonArray* _tmp53_;
		_tmp48_ = _data30_->doc_diags;
		_tmp49_ = err->loc;
		_tmp50_ = vala_source_reference_get_file (_tmp49_);
		_tmp51_ = _tmp50_;
		_tmp52_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp48_, _tmp51_);
		_tmp53_ = (JsonArray*) _tmp52_;
		_tmp43_ = _tmp53_ == NULL;
		_json_array_unref0 (_tmp53_);
	}
	if (_tmp43_) {
		GeeHashMap* _tmp54_;
		ValaSourceReference* _tmp55_;
		ValaSourceFile* _tmp56_;
		ValaSourceFile* _tmp57_;
		JsonArray* _tmp58_;
		JsonArray* _tmp59_;
		_tmp54_ = _data30_->doc_diags;
		_tmp55_ = err->loc;
		_tmp56_ = vala_source_reference_get_file (_tmp55_);
		_tmp57_ = _tmp56_;
		_tmp58_ = json_array_new ();
		_tmp59_ = _tmp58_;
		gee_abstract_map_set ((GeeAbstractMap*) _tmp54_, _tmp57_, _tmp59_);
		_json_array_unref0 (_tmp59_);
	}
	_tmp60_ = _data30_->doc_diags;
	_tmp61_ = err->loc;
	_tmp62_ = vala_source_reference_get_file (_tmp61_);
	_tmp63_ = _tmp62_;
	_tmp64_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp60_, _tmp63_);
	_tmp65_ = (JsonArray*) _tmp64_;
	_tmp66_ = node;
	_tmp67_ = __vala_JsonNode_copy0 (_tmp66_);
	json_array_add_element (_tmp65_, _tmp67_);
	_json_array_unref0 (_tmp65_);
	__vala_JsonNode_free0 (node);
	_g_object_unref0 (diag);
}

static void
___lambda48__gfunc (gconstpointer data,
                    gpointer self)
{
	__lambda48_ (self, (VlsSourceMessage*) data);
}

static void
vls_server_publish_diagnostics (VlsServer* self,
                                VlsProject* project,
                                VlsCompilation* target,
                                JsonrpcClient* client)
{
	Block30Data* _data30_;
	VlsCompilation* _tmp0_;
	JsonArray* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	GeeHashMap* _tmp4_;
	VlsReporter* _tmp17_;
	VlsReporter* _tmp18_;
	GPtrArray* _tmp19_;
	GeeArrayList* discarded_files_published = NULL;
	GeeArrayList* _tmp20_;
	GeeHashSet* _tmp41_;
	GeeArrayList* _tmp42_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (project != NULL);
	g_return_if_fail (target != NULL);
	g_return_if_fail (client != NULL);
	_data30_ = g_slice_new0 (Block30Data);
	_data30_->_ref_count_ = 1;
	_data30_->self = g_object_ref (self);
	_tmp0_ = _g_object_ref0 (target);
	_g_object_unref0 (_data30_->target);
	_data30_->target = _tmp0_;
	_tmp1_ = json_array_new ();
	_data30_->diags_without_source = _tmp1_;
	_tmp2_ = vls_build_target_get_id ((VlsBuildTarget*) _data30_->target);
	_tmp3_ = _tmp2_;
	g_debug ("server.vala:850: publishing diagnostics for Compilation target %s", _tmp3_);
	_tmp4_ = gee_hash_map_new (VALA_TYPE_SOURCE_FILE, (GBoxedCopyFunc) vala_source_file_ref, (GDestroyNotify) vala_source_file_unref, json_array_get_type (), (GBoxedCopyFunc) json_array_ref, (GDestroyNotify) json_array_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	if (_tmp4_) {
		g_object_set_data ((GObject *) _tmp4_, "vala-creation-function", "Vls.Server.publish_diagnostics");
	}
	_data30_->doc_diags = _tmp4_;
	{
		ValaList* _file_list = NULL;
		ValaCodeContext* _tmp5_;
		ValaCodeContext* _tmp6_;
		ValaList* _tmp7_;
		gint _file_size = 0;
		ValaList* _tmp8_;
		gint _tmp9_;
		gint _tmp10_;
		gint _file_index = 0;
		_tmp5_ = vls_compilation_get_code_context (_data30_->target);
		_tmp6_ = _tmp5_;
		_tmp7_ = vala_code_context_get_source_files (_tmp6_);
		_file_list = _tmp7_;
		_tmp8_ = _file_list;
		_tmp9_ = vala_collection_get_size ((ValaCollection*) _tmp8_);
		_tmp10_ = _tmp9_;
		_file_size = _tmp10_;
		_file_index = -1;
		while (TRUE) {
			gint _tmp11_;
			gint _tmp12_;
			ValaSourceFile* file = NULL;
			ValaList* _tmp13_;
			gpointer _tmp14_;
			GeeHashMap* _tmp15_;
			ValaSourceFile* _tmp16_;
			_file_index = _file_index + 1;
			_tmp11_ = _file_index;
			_tmp12_ = _file_size;
			if (!(_tmp11_ < _tmp12_)) {
				break;
			}
			_tmp13_ = _file_list;
			_tmp14_ = vala_list_get (_tmp13_, _file_index);
			file = (ValaSourceFile*) _tmp14_;
			_tmp15_ = _data30_->doc_diags;
			_tmp16_ = file;
			gee_abstract_map_set ((GeeAbstractMap*) _tmp15_, _tmp16_, NULL);
			_vala_source_file_unref0 (file);
		}
	}
	_tmp17_ = vls_compilation_get_reporter (_data30_->target);
	_tmp18_ = _tmp17_;
	_tmp19_ = _tmp18_->messages;
	g_ptr_array_foreach (_tmp19_, ___lambda48__gfunc, _data30_);
	_tmp20_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
	if (_tmp20_) {
		g_object_set_data ((GObject *) _tmp20_, "vala-creation-function", "Vls.Server.publish_diagnostics");
	}
	discarded_files_published = _tmp20_;
	{
		GeeIterator* _discarded_uri_it = NULL;
		GeeHashSet* _tmp21_;
		GeeIterator* _tmp22_;
		_tmp21_ = self->priv->discarded_files;
		_tmp22_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp21_);
		_discarded_uri_it = _tmp22_;
		while (TRUE) {
			GeeIterator* _tmp23_;
			gchar* discarded_uri = NULL;
			GeeIterator* _tmp24_;
			gpointer _tmp25_;
			_tmp23_ = _discarded_uri_it;
			if (!gee_iterator_next (_tmp23_)) {
				break;
			}
			_tmp24_ = _discarded_uri_it;
			_tmp25_ = gee_iterator_get (_tmp24_);
			discarded_uri = (gchar*) _tmp25_;
			{
				const gchar* _tmp26_;
				GVariant* _tmp27_;
				GVariant* _tmp28_;
				const GVariantType* _tmp29_;
				GVariant** _tmp30_;
				GVariant** _tmp31_;
				gint _tmp31__length1;
				GVariant* _tmp32_;
				GVariant* _tmp33_;
				GVariant* _tmp34_;
				GVariant* _tmp35_;
				GeeArrayList* _tmp36_;
				const gchar* _tmp37_;
				_tmp26_ = discarded_uri;
				_tmp27_ = g_variant_new_string (_tmp26_);
				g_variant_ref_sink (_tmp27_);
				_tmp28_ = _tmp27_;
				_tmp29_ = G_VARIANT_TYPE_VARIANT;
				_tmp30_ = g_new0 (GVariant*, 0 + 1);
				_tmp31_ = _tmp30_;
				_tmp31__length1 = 0;
				_tmp32_ = g_variant_new_array (_tmp29_, _tmp31_, 0);
				g_variant_ref_sink (_tmp32_);
				_tmp33_ = _tmp32_;
				_tmp34_ = vls_server_build_dict (self, "uri", _tmp28_, "diagnostics", _tmp33_, NULL);
				_tmp35_ = _tmp34_;
				jsonrpc_client_send_notification (client, "textDocument/publishDiagnostics", _tmp35_, NULL, &_inner_error0_);
				_g_variant_unref0 (_tmp35_);
				_g_variant_unref0 (_tmp33_);
				_tmp31_ = (_vala_array_free (_tmp31_, _tmp31__length1, (GDestroyNotify) g_variant_unref), NULL);
				_g_variant_unref0 (_tmp28_);
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					goto __catch0_g_error;
				}
				_tmp36_ = discarded_files_published;
				_tmp37_ = discarded_uri;
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp36_, _tmp37_);
			}
			goto __finally0;
			__catch0_g_error:
			{
				GError* e = NULL;
				const gchar* _tmp38_;
				GError* _tmp39_;
				const gchar* _tmp40_;
				e = _inner_error0_;
				_inner_error0_ = NULL;
				_tmp38_ = discarded_uri;
				_tmp39_ = e;
				_tmp40_ = _tmp39_->message;
				g_warning ("server.vala:914: [publishDiagnostics] failed to publish empty diags fo" \
"r %s: %s", _tmp38_, _tmp40_);
				_g_error_free0 (e);
			}
			__finally0:
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				_g_free0 (discarded_uri);
				_g_object_unref0 (_discarded_uri_it);
				_g_object_unref0 (discarded_files_published);
				block30_data_unref (_data30_);
				_data30_ = NULL;
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
			_g_free0 (discarded_uri);
		}
		_g_object_unref0 (_discarded_uri_it);
	}
	_tmp41_ = self->priv->discarded_files;
	_tmp42_ = discarded_files_published;
	gee_collection_remove_all ((GeeCollection*) _tmp41_, (GeeCollection*) _tmp42_);
	{
		GeeIterator* _entry_it = NULL;
		GeeHashMap* _tmp43_;
		GeeSet* _tmp44_;
		GeeSet* _tmp45_;
		GeeSet* _tmp46_;
		GeeIterator* _tmp47_;
		GeeIterator* _tmp48_;
		_tmp43_ = _data30_->doc_diags;
		_tmp44_ = gee_abstract_map_get_entries ((GeeAbstractMap*) _tmp43_);
		_tmp45_ = _tmp44_;
		_tmp46_ = _tmp45_;
		_tmp47_ = gee_iterable_iterator ((GeeIterable*) _tmp46_);
		_tmp48_ = _tmp47_;
		_g_object_unref0 (_tmp46_);
		_entry_it = _tmp48_;
		while (TRUE) {
			GeeIterator* _tmp49_;
			GeeMapEntry* entry = NULL;
			GeeIterator* _tmp50_;
			gpointer _tmp51_;
			GVariant* diags_variant_array = NULL;
			GFile* gfile = NULL;
			GeeMapEntry* _tmp52_;
			gconstpointer _tmp53_;
			gconstpointer _tmp54_;
			const gchar* _tmp55_;
			const gchar* _tmp56_;
			ValaCodeContext* _tmp57_;
			ValaCodeContext* _tmp58_;
			const gchar* _tmp59_;
			const gchar* _tmp60_;
			GFile* _tmp61_;
			GeeMapEntry* _tmp62_;
			gconstpointer _tmp63_;
			gconstpointer _tmp64_;
			_tmp49_ = _entry_it;
			if (!gee_iterator_next (_tmp49_)) {
				break;
			}
			_tmp50_ = _entry_it;
			_tmp51_ = gee_iterator_get (_tmp50_);
			entry = (GeeMapEntry*) _tmp51_;
			_tmp52_ = entry;
			_tmp53_ = gee_map_entry_get_key (_tmp52_);
			_tmp54_ = _tmp53_;
			_tmp55_ = vala_source_file_get_filename ((ValaSourceFile*) _tmp54_);
			_tmp56_ = _tmp55_;
			_tmp57_ = vls_compilation_get_code_context (_data30_->target);
			_tmp58_ = _tmp57_;
			_tmp59_ = vala_code_context_get_directory (_tmp58_);
			_tmp60_ = _tmp59_;
			_tmp61_ = g_file_new_for_commandline_arg_and_cwd (_tmp56_, _tmp60_);
			gfile = _tmp61_;
			_tmp62_ = entry;
			_tmp63_ = gee_map_entry_get_value (_tmp62_);
			_tmp64_ = _tmp63_;
			if (((JsonArray*) _tmp64_) != NULL) {
				{
					GVariant* _tmp65_ = NULL;
					JsonNode* _tmp66_;
					JsonNode* _tmp67_;
					GeeMapEntry* _tmp68_;
					gconstpointer _tmp69_;
					gconstpointer _tmp70_;
					JsonNode* _tmp71_;
					GVariant* _tmp72_;
					GVariant* _tmp73_;
					GVariant* _tmp74_;
					_tmp66_ = json_node_alloc ();
					_tmp67_ = _tmp66_;
					_tmp68_ = entry;
					_tmp69_ = gee_map_entry_get_value (_tmp68_);
					_tmp70_ = _tmp69_;
					_tmp71_ = json_node_init_array (_tmp67_, (JsonArray*) _tmp70_);
					_tmp72_ = json_gvariant_deserialize (_tmp71_, NULL, &_inner_error0_);
					_tmp73_ = _tmp72_;
					__vala_JsonNode_free0 (_tmp67_);
					_tmp65_ = _tmp73_;
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						goto __catch1_g_error;
					}
					_tmp74_ = _tmp65_;
					_tmp65_ = NULL;
					if (_tmp74_ != NULL) {
						g_variant_ref_sink (_tmp74_);
					}
					_g_variant_unref0 (diags_variant_array);
					diags_variant_array = _tmp74_;
					_g_variant_unref0 (_tmp65_);
				}
				goto __finally1;
				__catch1_g_error:
				{
					GError* e = NULL;
					GFile* _tmp75_;
					gchar* _tmp76_;
					gchar* _tmp77_;
					const gchar* _tmp78_;
					GError* _tmp79_;
					const gchar* _tmp80_;
					const gchar* _tmp81_;
					gchar* _tmp82_;
					gchar* _tmp83_;
					e = _inner_error0_;
					_inner_error0_ = NULL;
					_tmp75_ = gfile;
					_tmp76_ = g_file_get_uri (_tmp75_);
					_tmp77_ = _tmp76_;
					_tmp78_ = string_to_string (_tmp77_);
					_tmp79_ = e;
					_tmp80_ = _tmp79_->message;
					_tmp81_ = string_to_string (_tmp80_);
					_tmp82_ = g_strconcat ("[publishDiagnostics] failed to deserialize diags for `", _tmp78_, "': ", _tmp81_, NULL);
					_tmp83_ = _tmp82_;
					g_warning ("server.vala:930: %s", _tmp83_);
					_g_free0 (_tmp83_);
					_g_free0 (_tmp77_);
					_g_error_free0 (e);
					_g_object_unref0 (gfile);
					_g_variant_unref0 (diags_variant_array);
					_g_object_unref0 (entry);
					continue;
				}
				__finally1:
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					_g_object_unref0 (gfile);
					_g_variant_unref0 (diags_variant_array);
					_g_object_unref0 (entry);
					_g_object_unref0 (_entry_it);
					_g_object_unref0 (discarded_files_published);
					block30_data_unref (_data30_);
					_data30_ = NULL;
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return;
				}
			} else {
				const GVariantType* _tmp84_;
				GVariant** _tmp85_;
				GVariant** _tmp86_;
				gint _tmp86__length1;
				GVariant* _tmp87_;
				_tmp84_ = G_VARIANT_TYPE_VARIANT;
				_tmp85_ = g_new0 (GVariant*, 0 + 1);
				_tmp86_ = _tmp85_;
				_tmp86__length1 = 0;
				_tmp87_ = g_variant_new_array (_tmp84_, _tmp86_, 0);
				g_variant_ref_sink (_tmp87_);
				_g_variant_unref0 (diags_variant_array);
				diags_variant_array = _tmp87_;
				_tmp86_ = (_vala_array_free (_tmp86_, _tmp86__length1, (GDestroyNotify) g_variant_unref), NULL);
			}
			{
				GFile* _tmp88_;
				gchar* _tmp89_;
				gchar* _tmp90_;
				GVariant* _tmp91_;
				GVariant* _tmp92_;
				GVariant* _tmp93_;
				GVariant* _tmp94_;
				GVariant* _tmp95_;
				GCancellable* _tmp96_;
				_tmp88_ = gfile;
				_tmp89_ = g_file_get_uri (_tmp88_);
				_tmp90_ = _tmp89_;
				_tmp91_ = g_variant_new_string (_tmp90_);
				g_variant_ref_sink (_tmp91_);
				_tmp92_ = _tmp91_;
				_tmp93_ = diags_variant_array;
				_tmp94_ = vls_server_build_dict (self, "uri", _tmp92_, "diagnostics", _tmp93_, NULL);
				_tmp95_ = _tmp94_;
				_tmp96_ = vls_server_cancellable;
				jsonrpc_client_send_notification (client, "textDocument/publishDiagnostics", _tmp95_, _tmp96_, &_inner_error0_);
				_g_variant_unref0 (_tmp95_);
				_g_variant_unref0 (_tmp92_);
				_g_free0 (_tmp90_);
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					goto __catch2_g_error;
				}
			}
			goto __finally2;
			__catch2_g_error:
			{
				GError* e = NULL;
				GError* _tmp97_;
				const gchar* _tmp98_;
				const gchar* _tmp99_;
				gchar* _tmp100_;
				gchar* _tmp101_;
				e = _inner_error0_;
				_inner_error0_ = NULL;
				_tmp97_ = e;
				_tmp98_ = _tmp97_->message;
				_tmp99_ = string_to_string (_tmp98_);
				_tmp100_ = g_strconcat ("[publishDiagnostics] failed to notify client: ", _tmp99_, NULL);
				_tmp101_ = _tmp100_;
				g_warning ("server.vala:946: %s", _tmp101_);
				_g_free0 (_tmp101_);
				_g_error_free0 (e);
			}
			__finally2:
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				_g_object_unref0 (gfile);
				_g_variant_unref0 (diags_variant_array);
				_g_object_unref0 (entry);
				_g_object_unref0 (_entry_it);
				_g_object_unref0 (discarded_files_published);
				block30_data_unref (_data30_);
				_data30_ = NULL;
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return;
			}
			_g_object_unref0 (gfile);
			_g_variant_unref0 (diags_variant_array);
			_g_object_unref0 (entry);
		}
		_g_object_unref0 (_entry_it);
	}
	{
		GVariant* diags_wo_src_variant_array = NULL;
		JsonNode* _tmp102_;
		JsonNode* _tmp103_;
		JsonArray* _tmp104_;
		JsonNode* _tmp105_;
		GVariant* _tmp106_;
		GVariant* _tmp107_;
		const gchar* _tmp108_;
		const gchar* _tmp109_;
		GFile* _tmp110_;
		GFile* _tmp111_;
		gchar* _tmp112_;
		gchar* _tmp113_;
		GVariant* _tmp114_;
		GVariant* _tmp115_;
		GVariant* _tmp116_;
		GVariant* _tmp117_;
		GVariant* _tmp118_;
		GCancellable* _tmp119_;
		_tmp102_ = json_node_alloc ();
		_tmp103_ = _tmp102_;
		_tmp104_ = _data30_->diags_without_source;
		_tmp105_ = json_node_init_array (_tmp103_, _tmp104_);
		_tmp106_ = json_gvariant_deserialize (_tmp105_, NULL, &_inner_error0_);
		if (_tmp106_ != NULL) {
			g_variant_ref_sink (_tmp106_);
		}
		_tmp107_ = _tmp106_;
		__vala_JsonNode_free0 (_tmp103_);
		diags_wo_src_variant_array = _tmp107_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch3_g_error;
		}
		_tmp108_ = vls_project_get_root_path (project);
		_tmp109_ = _tmp108_;
		_tmp110_ = g_file_new_for_path (_tmp109_);
		_tmp111_ = _tmp110_;
		_tmp112_ = g_file_get_uri (_tmp111_);
		_tmp113_ = _tmp112_;
		_tmp114_ = g_variant_new_string (_tmp113_);
		g_variant_ref_sink (_tmp114_);
		_tmp115_ = _tmp114_;
		_tmp116_ = diags_wo_src_variant_array;
		_tmp117_ = vls_server_build_dict (self, "uri", _tmp115_, "diagnostics", _tmp116_, NULL);
		_tmp118_ = _tmp117_;
		_tmp119_ = vls_server_cancellable;
		jsonrpc_client_send_notification (client, "textDocument/publishDiagnostics", _tmp118_, _tmp119_, &_inner_error0_);
		_g_variant_unref0 (_tmp118_);
		_g_variant_unref0 (_tmp115_);
		_g_free0 (_tmp113_);
		_g_object_unref0 (_tmp111_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_variant_unref0 (diags_wo_src_variant_array);
			goto __catch3_g_error;
		}
		_g_variant_unref0 (diags_wo_src_variant_array);
	}
	goto __finally3;
	__catch3_g_error:
	{
		GError* e = NULL;
		GError* _tmp120_;
		const gchar* _tmp121_;
		const gchar* _tmp122_;
		gchar* _tmp123_;
		gchar* _tmp124_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp120_ = e;
		_tmp121_ = _tmp120_->message;
		_tmp122_ = string_to_string (_tmp121_);
		_tmp123_ = g_strconcat ("[publishDiagnostics] failed to publish diags without source: ", _tmp122_, NULL);
		_tmp124_ = _tmp123_;
		g_warning ("server.vala:963: %s", _tmp124_);
		_g_free0 (_tmp124_);
		_g_error_free0 (e);
	}
	__finally3:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_object_unref0 (discarded_files_published);
		block30_data_unref (_data30_);
		_data30_ = NULL;
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	_g_object_unref0 (discarded_files_published);
	block30_data_unref (_data30_);
	_data30_ = NULL;
}

static gpointer
_vala_code_node_ref0 (gpointer self)
{
	return self ? vala_code_node_ref (self) : NULL;
}

ValaCodeNode*
vls_server_get_best (VlsNodeSearch* fs,
                     ValaSourceFile* file)
{
	ValaCodeNode* best = NULL;
	ValaCodeNode* _tmp60_;
	ValaCodeNode* _tmp61_;
	ValaCodeNode* _tmp62_;
	ValaCodeNode* result;
	g_return_val_if_fail (fs != NULL, NULL);
	g_return_val_if_fail (file != NULL, NULL);
	best = NULL;
	{
		GeeList* _node_list = NULL;
		GeeList* _tmp0_;
		gint _node_size = 0;
		GeeList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _node_index = 0;
		_tmp0_ = fs->result;
		_node_list = _tmp0_;
		_tmp1_ = _node_list;
		_tmp2_ = gee_collection_get_size ((GeeCollection*) _tmp1_);
		_tmp3_ = _tmp2_;
		_node_size = _tmp3_;
		_node_index = -1;
		while (TRUE) {
			gint _tmp4_;
			gint _tmp5_;
			ValaCodeNode* node = NULL;
			GeeList* _tmp6_;
			gpointer _tmp7_;
			ValaCodeNode* _tmp8_;
			_node_index = _node_index + 1;
			_tmp4_ = _node_index;
			_tmp5_ = _node_size;
			if (!(_tmp4_ < _tmp5_)) {
				break;
			}
			_tmp6_ = _node_list;
			_tmp7_ = gee_list_get (_tmp6_, _node_index);
			node = (ValaCodeNode*) _tmp7_;
			_tmp8_ = best;
			if (_tmp8_ == NULL) {
				ValaCodeNode* _tmp9_;
				ValaCodeNode* _tmp10_;
				_tmp9_ = node;
				_tmp10_ = _vala_code_node_ref0 (_tmp9_);
				_vala_code_node_unref0 (best);
				best = _tmp10_;
			} else {
				LspPosition* best_begin = NULL;
				ValaCodeNode* _tmp11_;
				ValaSourceReference* _tmp12_;
				ValaSourceReference* _tmp13_;
				ValaSourceLocation _tmp14_ = {0};
				ValaSourceLocation _tmp15_;
				LspPosition* _tmp16_;
				LspPosition* best_end = NULL;
				ValaCodeNode* _tmp17_;
				ValaSourceReference* _tmp18_;
				ValaSourceReference* _tmp19_;
				ValaSourceLocation _tmp20_ = {0};
				ValaSourceLocation _tmp21_;
				LspPosition* _tmp22_;
				LspPosition* node_begin = NULL;
				ValaCodeNode* _tmp23_;
				ValaSourceReference* _tmp24_;
				ValaSourceReference* _tmp25_;
				ValaSourceLocation _tmp26_ = {0};
				ValaSourceLocation _tmp27_;
				LspPosition* _tmp28_;
				LspPosition* node_end = NULL;
				ValaCodeNode* _tmp29_;
				ValaSourceReference* _tmp30_;
				ValaSourceReference* _tmp31_;
				ValaSourceLocation _tmp32_ = {0};
				ValaSourceLocation _tmp33_;
				LspPosition* _tmp34_;
				gboolean _tmp35_ = FALSE;
				gboolean _tmp36_ = FALSE;
				LspPosition* _tmp37_;
				LspPosition* _tmp38_;
				_tmp11_ = best;
				_tmp12_ = vala_code_node_get_source_reference (_tmp11_);
				_tmp13_ = _tmp12_;
				vala_source_reference_get_begin (_tmp13_, &_tmp14_);
				_tmp15_ = _tmp14_;
				_tmp16_ = lsp_position_new_from_libvala (&_tmp15_);
				if (_tmp16_) {
					g_object_set_data ((GObject *) _tmp16_, "vala-creation-function", "Vls.Server.get_best");
				}
				best_begin = _tmp16_;
				_tmp17_ = best;
				_tmp18_ = vala_code_node_get_source_reference (_tmp17_);
				_tmp19_ = _tmp18_;
				vala_source_reference_get_end (_tmp19_, &_tmp20_);
				_tmp21_ = _tmp20_;
				_tmp22_ = lsp_position_new_from_libvala (&_tmp21_);
				if (_tmp22_) {
					g_object_set_data ((GObject *) _tmp22_, "vala-creation-function", "Vls.Server.get_best");
				}
				best_end = _tmp22_;
				_tmp23_ = node;
				_tmp24_ = vala_code_node_get_source_reference (_tmp23_);
				_tmp25_ = _tmp24_;
				vala_source_reference_get_begin (_tmp25_, &_tmp26_);
				_tmp27_ = _tmp26_;
				_tmp28_ = lsp_position_new_from_libvala (&_tmp27_);
				if (_tmp28_) {
					g_object_set_data ((GObject *) _tmp28_, "vala-creation-function", "Vls.Server.get_best");
				}
				node_begin = _tmp28_;
				_tmp29_ = node;
				_tmp30_ = vala_code_node_get_source_reference (_tmp29_);
				_tmp31_ = _tmp30_;
				vala_source_reference_get_end (_tmp31_, &_tmp32_);
				_tmp33_ = _tmp32_;
				_tmp34_ = lsp_position_new_from_libvala (&_tmp33_);
				if (_tmp34_) {
					g_object_set_data ((GObject *) _tmp34_, "vala-creation-function", "Vls.Server.get_best");
				}
				node_end = _tmp34_;
				_tmp37_ = best_begin;
				_tmp38_ = node_begin;
				if (gee_comparable_compare_to ((GeeComparable*) _tmp37_, _tmp38_) <= 0) {
					LspPosition* _tmp39_;
					LspPosition* _tmp40_;
					_tmp39_ = node_end;
					_tmp40_ = best_end;
					_tmp36_ = gee_comparable_compare_to ((GeeComparable*) _tmp39_, _tmp40_) <= 0;
				} else {
					_tmp36_ = FALSE;
				}
				if (_tmp36_) {
					gboolean _tmp41_ = FALSE;
					gboolean _tmp42_ = FALSE;
					gboolean _tmp43_ = FALSE;
					gboolean _tmp44_ = FALSE;
					LspPosition* _tmp45_;
					LspPosition* _tmp46_;
					_tmp45_ = best_begin;
					_tmp46_ = node_begin;
					if (gee_comparable_compare_to ((GeeComparable*) _tmp45_, _tmp46_) == 0) {
						LspPosition* _tmp47_;
						LspPosition* _tmp48_;
						_tmp47_ = node_end;
						_tmp48_ = best_end;
						_tmp44_ = gee_comparable_compare_to ((GeeComparable*) _tmp47_, _tmp48_) == 0;
					} else {
						_tmp44_ = FALSE;
					}
					if (!_tmp44_) {
						_tmp43_ = TRUE;
					} else {
						gboolean _tmp49_ = FALSE;
						ValaCodeNode* _tmp50_;
						_tmp50_ = best;
						if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp50_, VALA_TYPE_LOCAL_VARIABLE)) {
							ValaCodeNode* _tmp51_;
							_tmp51_ = node;
							_tmp49_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp51_, VALA_TYPE_LOCAL_VARIABLE);
						} else {
							_tmp49_ = FALSE;
						}
						_tmp43_ = _tmp49_;
					}
					if (_tmp43_) {
						_tmp42_ = TRUE;
					} else {
						gboolean _tmp52_ = FALSE;
						ValaCodeNode* _tmp53_;
						_tmp53_ = best;
						if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp53_, VALA_TYPE_FIELD)) {
							ValaCodeNode* _tmp54_;
							_tmp54_ = node;
							_tmp52_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp54_, VALA_TYPE_PROPERTY);
						} else {
							_tmp52_ = FALSE;
						}
						_tmp42_ = _tmp52_;
					}
					if (_tmp42_) {
						_tmp41_ = TRUE;
					} else {
						gboolean _tmp55_ = FALSE;
						ValaCodeNode* _tmp56_;
						_tmp56_ = best;
						if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp56_, VALA_TYPE_NULL_LITERAL)) {
							ValaCodeNode* _tmp57_;
							_tmp57_ = node;
							_tmp55_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp57_, VALA_TYPE_METHOD);
						} else {
							_tmp55_ = FALSE;
						}
						_tmp41_ = _tmp55_;
					}
					_tmp35_ = _tmp41_;
				} else {
					_tmp35_ = FALSE;
				}
				if (_tmp35_) {
					ValaCodeNode* _tmp58_;
					ValaCodeNode* _tmp59_;
					_tmp58_ = node;
					_tmp59_ = _vala_code_node_ref0 (_tmp58_);
					_vala_code_node_unref0 (best);
					best = _tmp59_;
				}
				_g_object_unref0 (node_end);
				_g_object_unref0 (node_begin);
				_g_object_unref0 (best_end);
				_g_object_unref0 (best_begin);
			}
			_vala_code_node_unref0 (node);
		}
	}
	_tmp60_ = best;
	_vala_assert (_tmp60_ != NULL, "best != null");
	_tmp61_ = best;
	_tmp62_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp61_, VALA_TYPE_CODE_NODE, ValaCodeNode));
	result = _tmp62_;
	_vala_code_node_unref0 (best);
	return result;
}

static Block31Data*
block31_data_ref (Block31Data* _data31_)
{
	g_atomic_int_inc (&_data31_->_ref_count_);
	return _data31_;
}

static void
block31_data_unref (void * _userdata_)
{
	Block31Data* _data31_;
	_data31_ = (Block31Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data31_->_ref_count_)) {
		VlsServer* self;
		self = _data31_->self;
		_g_object_unref0 (_data31_->p);
		_g_object_unref0 (_data31_->client);
		_g_free0 (_data31_->method);
		_g_variant_unref0 (_data31_->id);
		_g_object_unref0 (self);
		g_slice_free (Block31Data, _data31_);
	}
}

static void
__lambda51_ (Block31Data* _data31_,
             gboolean request_cancelled)
{
	VlsServer* self;
	VlsCompilation* compilation = NULL;
	VlsProject* project = NULL;
	ValaSourceFile* file = NULL;
	LspTextDocumentIdentifier* _tmp0_;
	LspTextDocumentIdentifier* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	VlsCompilation* _tmp4_ = NULL;
	VlsProject* _tmp5_ = NULL;
	ValaSourceFile* _tmp6_;
	ValaSourceFile* _tmp7_;
	VlsCompilation* _tmp12_;
	ValaCodeContext* _tmp13_;
	ValaCodeContext* _tmp14_;
	VlsNodeSearch* fs = NULL;
	ValaSourceFile* _tmp15_;
	LspPosition* _tmp16_;
	LspPosition* _tmp17_;
	VlsNodeSearch* _tmp18_;
	VlsNodeSearch* _tmp19_;
	GeeList* _tmp20_;
	gint _tmp21_;
	gint _tmp22_;
	ValaCodeNode* best = NULL;
	VlsNodeSearch* _tmp29_;
	ValaSourceFile* _tmp30_;
	ValaCodeNode* _tmp31_;
	gboolean _tmp32_ = FALSE;
	ValaCodeNode* _tmp33_;
	ValaCodeNode* _tmp131_;
	LspLocation* location = NULL;
	ValaCodeNode* _tmp135_;
	ValaSourceReference* _tmp136_;
	ValaSourceReference* _tmp137_;
	LspLocation* _tmp138_;
	LspLocation* _tmp139_;
	const gchar* _tmp140_;
	const gchar* _tmp141_;
	GError* _inner_error0_ = NULL;
	self = _data31_->self;
	if (request_cancelled) {
		vls_server_reply_null (_data31_->id, _data31_->client, _data31_->method);
		return;
	}
	_tmp0_ = lsp_text_document_position_params_get_textDocument (_data31_->p);
	_tmp1_ = _tmp0_;
	_tmp2_ = lsp_text_document_identifier_get_uri (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp6_ = vls_server_find_file (self, _tmp3_, &_tmp4_, &_tmp5_);
	_g_object_unref0 (compilation);
	compilation = _tmp4_;
	_g_object_unref0 (project);
	project = _tmp5_;
	file = _tmp6_;
	_tmp7_ = file;
	if (_tmp7_ == NULL) {
		LspTextDocumentIdentifier* _tmp8_;
		LspTextDocumentIdentifier* _tmp9_;
		const gchar* _tmp10_;
		const gchar* _tmp11_;
		_tmp8_ = lsp_text_document_position_params_get_textDocument (_data31_->p);
		_tmp9_ = _tmp8_;
		_tmp10_ = lsp_text_document_identifier_get_uri (_tmp9_);
		_tmp11_ = _tmp10_;
		g_debug ("server.vala:1018: [%s] file `%s' not found", _data31_->method, _tmp11_);
		vls_server_reply_null (_data31_->id, _data31_->client, _data31_->method);
		_vala_source_file_unref0 (file);
		_g_object_unref0 (project);
		_g_object_unref0 (compilation);
		return;
	}
	_tmp12_ = compilation;
	_tmp13_ = vls_compilation_get_code_context (_tmp12_);
	_tmp14_ = _tmp13_;
	vala_code_context_push (_tmp14_);
	_tmp15_ = file;
	_tmp16_ = lsp_text_document_position_params_get_position (_data31_->p);
	_tmp17_ = _tmp16_;
	_tmp18_ = vls_node_search_new (_tmp15_, _tmp17_, TRUE, NULL, TRUE);
	fs = _tmp18_;
	_tmp19_ = fs;
	_tmp20_ = _tmp19_->result;
	_tmp21_ = gee_collection_get_size ((GeeCollection*) _tmp20_);
	_tmp22_ = _tmp21_;
	if (_tmp22_ == 0) {
		g_debug ("server.vala:1027: [%s] find symbol is empty", _data31_->method);
		{
			const GVariantType* _tmp23_;
			GVariant* _tmp24_;
			GVariant* _tmp25_;
			GCancellable* _tmp26_;
			_tmp23_ = G_VARIANT_TYPE_VARIANT;
			_tmp24_ = g_variant_new_maybe (_tmp23_, NULL);
			g_variant_ref_sink (_tmp24_);
			_tmp25_ = _tmp24_;
			_tmp26_ = vls_server_cancellable;
			jsonrpc_client_reply (_data31_->client, _data31_->id, _tmp25_, _tmp26_, &_inner_error0_);
			_g_variant_unref0 (_tmp25_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				goto __catch0_g_error;
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp27_;
			const gchar* _tmp28_;
			e = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp27_ = e;
			_tmp28_ = _tmp27_->message;
			g_debug ("server.vala:1031: [textDocument/definition] failed to reply to client:" \
" %s", _tmp28_);
			_g_error_free0 (e);
		}
		__finally0:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_vala_code_visitor_unref0 (fs);
			_vala_source_file_unref0 (file);
			_g_object_unref0 (project);
			_g_object_unref0 (compilation);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		vala_code_context_pop ();
		_vala_code_visitor_unref0 (fs);
		_vala_source_file_unref0 (file);
		_g_object_unref0 (project);
		_g_object_unref0 (compilation);
		return;
	}
	_tmp29_ = fs;
	_tmp30_ = file;
	_tmp31_ = vls_server_get_best (_tmp29_, _tmp30_);
	best = _tmp31_;
	_tmp33_ = best;
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp33_, VALA_TYPE_EXPRESSION)) {
		ValaCodeNode* _tmp34_;
		_tmp34_ = best;
		_tmp32_ = !G_TYPE_CHECK_INSTANCE_TYPE (_tmp34_, VALA_TYPE_LITERAL);
	} else {
		_tmp32_ = FALSE;
	}
	if (_tmp32_) {
		ValaExpression* b = NULL;
		ValaCodeNode* _tmp35_;
		ValaExpression* _tmp36_;
		ValaCodeNode* _tmp37_;
		ValaExpression* _tmp38_;
		ValaSymbol* _tmp39_;
		ValaSymbol* _tmp40_;
		gboolean _tmp41_ = FALSE;
		ValaExpression* _tmp42_;
		ValaSymbol* _tmp43_;
		ValaSymbol* _tmp44_;
		_tmp35_ = best;
		_tmp36_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp35_, VALA_TYPE_EXPRESSION, ValaExpression));
		b = _tmp36_;
		_tmp37_ = best;
		_tmp38_ = b;
		_tmp39_ = vala_expression_get_symbol_reference (_tmp38_);
		_tmp40_ = _tmp39_;
		g_debug ("server.vala:1041: best (%p) is a Expression (symbol_reference = %p)", _tmp37_, _tmp40_);
		_tmp42_ = b;
		_tmp43_ = vala_expression_get_symbol_reference (_tmp42_);
		_tmp44_ = _tmp43_;
		if (_tmp44_ != NULL) {
			ValaExpression* _tmp45_;
			ValaSymbol* _tmp46_;
			ValaSymbol* _tmp47_;
			ValaSourceReference* _tmp48_;
			ValaSourceReference* _tmp49_;
			_tmp45_ = b;
			_tmp46_ = vala_expression_get_symbol_reference (_tmp45_);
			_tmp47_ = _tmp46_;
			_tmp48_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp47_);
			_tmp49_ = _tmp48_;
			_tmp41_ = _tmp49_ != NULL;
		} else {
			_tmp41_ = FALSE;
		}
		if (_tmp41_) {
			ValaExpression* _tmp50_;
			ValaSymbol* _tmp51_;
			ValaSymbol* _tmp52_;
			ValaCodeNode* _tmp53_;
			ValaCodeNode* _tmp54_;
			ValaCodeNode* _tmp55_;
			gchar* _tmp56_;
			gchar* _tmp57_;
			_tmp50_ = b;
			_tmp51_ = vala_expression_get_symbol_reference (_tmp50_);
			_tmp52_ = _tmp51_;
			_tmp53_ = _vala_code_node_ref0 ((ValaCodeNode*) _tmp52_);
			_vala_code_node_unref0 (best);
			best = _tmp53_;
			_tmp54_ = best;
			_tmp55_ = best;
			_tmp56_ = vala_code_node_to_string (_tmp55_);
			_tmp57_ = _tmp56_;
			g_debug ("server.vala:1044: best is now the symbol_referenece => %p (%s)", _tmp54_, _tmp57_);
			_g_free0 (_tmp57_);
		}
		_vala_code_node_unref0 (b);
	} else {
		ValaCodeNode* _tmp58_;
		_tmp58_ = best;
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp58_, VALA_TYPE_DATA_TYPE)) {
			ValaCodeNode* _tmp59_;
			ValaSymbol* _tmp60_;
			_tmp59_ = best;
			_tmp60_ = vls_symbol_references_get_symbol_data_type_refers_to (G_TYPE_CHECK_INSTANCE_CAST (_tmp59_, VALA_TYPE_DATA_TYPE, ValaDataType));
			_vala_code_node_unref0 (best);
			best = (ValaCodeNode*) _tmp60_;
		} else {
			ValaCodeNode* _tmp61_;
			_tmp61_ = best;
			if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp61_, VALA_TYPE_USING_DIRECTIVE)) {
				ValaCodeNode* _tmp62_;
				ValaSymbol* _tmp63_;
				ValaSymbol* _tmp64_;
				ValaCodeNode* _tmp65_;
				_tmp62_ = best;
				_tmp63_ = vala_using_directive_get_namespace_symbol (G_TYPE_CHECK_INSTANCE_CAST (_tmp62_, VALA_TYPE_USING_DIRECTIVE, ValaUsingDirective));
				_tmp64_ = _tmp63_;
				_tmp65_ = _vala_code_node_ref0 ((ValaCodeNode*) _tmp64_);
				_vala_code_node_unref0 (best);
				best = _tmp65_;
			} else {
				ValaCodeNode* _tmp66_;
				_tmp66_ = best;
				if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp66_, VALA_TYPE_METHOD)) {
					ValaMethod* m = NULL;
					ValaCodeNode* _tmp67_;
					ValaMethod* _tmp68_;
					gboolean _tmp69_ = FALSE;
					ValaMethod* _tmp70_;
					ValaMethod* _tmp71_;
					ValaMethod* _tmp72_;
					ValaMethod* _tmp73_;
					_tmp67_ = best;
					_tmp68_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp67_, VALA_TYPE_METHOD, ValaMethod));
					m = _tmp68_;
					_tmp70_ = m;
					_tmp71_ = vala_method_get_base_interface_method (_tmp70_);
					_tmp72_ = _tmp71_;
					_tmp73_ = m;
					if (_tmp72_ != _tmp73_) {
						ValaMethod* _tmp74_;
						ValaMethod* _tmp75_;
						ValaMethod* _tmp76_;
						_tmp74_ = m;
						_tmp75_ = vala_method_get_base_interface_method (_tmp74_);
						_tmp76_ = _tmp75_;
						_tmp69_ = _tmp76_ != NULL;
					} else {
						_tmp69_ = FALSE;
					}
					if (_tmp69_) {
						ValaMethod* _tmp77_;
						ValaMethod* _tmp78_;
						ValaMethod* _tmp79_;
						ValaCodeNode* _tmp80_;
						_tmp77_ = m;
						_tmp78_ = vala_method_get_base_interface_method (_tmp77_);
						_tmp79_ = _tmp78_;
						_tmp80_ = _vala_code_node_ref0 ((ValaCodeNode*) _tmp79_);
						_vala_code_node_unref0 (best);
						best = _tmp80_;
					} else {
						gboolean _tmp81_ = FALSE;
						ValaMethod* _tmp82_;
						ValaMethod* _tmp83_;
						ValaMethod* _tmp84_;
						ValaMethod* _tmp85_;
						_tmp82_ = m;
						_tmp83_ = vala_method_get_base_method (_tmp82_);
						_tmp84_ = _tmp83_;
						_tmp85_ = m;
						if (_tmp84_ != _tmp85_) {
							ValaMethod* _tmp86_;
							ValaMethod* _tmp87_;
							ValaMethod* _tmp88_;
							_tmp86_ = m;
							_tmp87_ = vala_method_get_base_method (_tmp86_);
							_tmp88_ = _tmp87_;
							_tmp81_ = _tmp88_ != NULL;
						} else {
							_tmp81_ = FALSE;
						}
						if (_tmp81_) {
							ValaMethod* _tmp89_;
							ValaMethod* _tmp90_;
							ValaMethod* _tmp91_;
							ValaCodeNode* _tmp92_;
							_tmp89_ = m;
							_tmp90_ = vala_method_get_base_method (_tmp89_);
							_tmp91_ = _tmp90_;
							_tmp92_ = _vala_code_node_ref0 ((ValaCodeNode*) _tmp91_);
							_vala_code_node_unref0 (best);
							best = _tmp92_;
						}
					}
					_vala_code_node_unref0 (m);
				} else {
					ValaCodeNode* _tmp93_;
					_tmp93_ = best;
					if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp93_, VALA_TYPE_PROPERTY)) {
						ValaProperty* prop = NULL;
						ValaCodeNode* _tmp94_;
						ValaProperty* _tmp95_;
						gboolean _tmp96_ = FALSE;
						ValaProperty* _tmp97_;
						ValaProperty* _tmp98_;
						ValaProperty* _tmp99_;
						ValaProperty* _tmp100_;
						_tmp94_ = best;
						_tmp95_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp94_, VALA_TYPE_PROPERTY, ValaProperty));
						prop = _tmp95_;
						_tmp97_ = prop;
						_tmp98_ = vala_property_get_base_interface_property (_tmp97_);
						_tmp99_ = _tmp98_;
						_tmp100_ = prop;
						if (_tmp99_ != _tmp100_) {
							ValaProperty* _tmp101_;
							ValaProperty* _tmp102_;
							ValaProperty* _tmp103_;
							_tmp101_ = prop;
							_tmp102_ = vala_property_get_base_interface_property (_tmp101_);
							_tmp103_ = _tmp102_;
							_tmp96_ = _tmp103_ != NULL;
						} else {
							_tmp96_ = FALSE;
						}
						if (_tmp96_) {
							ValaProperty* _tmp104_;
							ValaProperty* _tmp105_;
							ValaProperty* _tmp106_;
							ValaCodeNode* _tmp107_;
							_tmp104_ = prop;
							_tmp105_ = vala_property_get_base_interface_property (_tmp104_);
							_tmp106_ = _tmp105_;
							_tmp107_ = _vala_code_node_ref0 ((ValaCodeNode*) _tmp106_);
							_vala_code_node_unref0 (best);
							best = _tmp107_;
						} else {
							gboolean _tmp108_ = FALSE;
							ValaProperty* _tmp109_;
							ValaProperty* _tmp110_;
							ValaProperty* _tmp111_;
							ValaProperty* _tmp112_;
							_tmp109_ = prop;
							_tmp110_ = vala_property_get_base_property (_tmp109_);
							_tmp111_ = _tmp110_;
							_tmp112_ = prop;
							if (_tmp111_ != _tmp112_) {
								ValaProperty* _tmp113_;
								ValaProperty* _tmp114_;
								ValaProperty* _tmp115_;
								_tmp113_ = prop;
								_tmp114_ = vala_property_get_base_property (_tmp113_);
								_tmp115_ = _tmp114_;
								_tmp108_ = _tmp115_ != NULL;
							} else {
								_tmp108_ = FALSE;
							}
							if (_tmp108_) {
								ValaProperty* _tmp116_;
								ValaProperty* _tmp117_;
								ValaProperty* _tmp118_;
								ValaCodeNode* _tmp119_;
								_tmp116_ = prop;
								_tmp117_ = vala_property_get_base_property (_tmp116_);
								_tmp118_ = _tmp117_;
								_tmp119_ = _vala_code_node_ref0 ((ValaCodeNode*) _tmp118_);
								_vala_code_node_unref0 (best);
								best = _tmp119_;
							}
						}
						_vala_code_node_unref0 (prop);
					} else {
						const gchar* _tmp120_ = NULL;
						ValaCodeNode* _tmp121_;
						_tmp121_ = best;
						if (_tmp121_ != NULL) {
							ValaCodeNode* _tmp122_;
							const gchar* _tmp123_;
							const gchar* _tmp124_;
							_tmp122_ = best;
							_tmp123_ = vala_code_node_get_type_name (_tmp122_);
							_tmp124_ = _tmp123_;
							_tmp120_ = _tmp124_;
						} else {
							_tmp120_ = NULL;
						}
						g_debug ("server.vala:1065: [%s] best is %s, which we can't handle", _data31_->method, _tmp120_);
						{
							const GVariantType* _tmp125_;
							GVariant* _tmp126_;
							GVariant* _tmp127_;
							GCancellable* _tmp128_;
							_tmp125_ = G_VARIANT_TYPE_VARIANT;
							_tmp126_ = g_variant_new_maybe (_tmp125_, NULL);
							g_variant_ref_sink (_tmp126_);
							_tmp127_ = _tmp126_;
							_tmp128_ = vls_server_cancellable;
							jsonrpc_client_reply (_data31_->client, _data31_->id, _tmp127_, _tmp128_, &_inner_error0_);
							_g_variant_unref0 (_tmp127_);
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
								goto __catch1_g_error;
							}
						}
						goto __finally1;
						__catch1_g_error:
						{
							GError* e = NULL;
							GError* _tmp129_;
							const gchar* _tmp130_;
							e = _inner_error0_;
							_inner_error0_ = NULL;
							_tmp129_ = e;
							_tmp130_ = _tmp129_->message;
							g_debug ("server.vala:1069: [textDocument/definition] failed to reply to client:" \
" %s", _tmp130_);
							_g_error_free0 (e);
						}
						__finally1:
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
							_vala_code_node_unref0 (best);
							_vala_code_visitor_unref0 (fs);
							_vala_source_file_unref0 (file);
							_g_object_unref0 (project);
							_g_object_unref0 (compilation);
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
							g_clear_error (&_inner_error0_);
							return;
						}
						vala_code_context_pop ();
						_vala_code_node_unref0 (best);
						_vala_code_visitor_unref0 (fs);
						_vala_source_file_unref0 (file);
						_g_object_unref0 (project);
						_g_object_unref0 (compilation);
						return;
					}
				}
			}
		}
	}
	_tmp131_ = best;
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp131_, VALA_TYPE_SYMBOL)) {
		VlsProject* _tmp132_;
		ValaCodeNode* _tmp133_;
		ValaSymbol* _tmp134_;
		_tmp132_ = project;
		_tmp133_ = best;
		_tmp134_ = vls_symbol_references_find_real_symbol (_tmp132_, G_TYPE_CHECK_INSTANCE_CAST (_tmp133_, VALA_TYPE_SYMBOL, ValaSymbol));
		_vala_code_node_unref0 (best);
		best = (ValaCodeNode*) _tmp134_;
	}
	_tmp135_ = best;
	_tmp136_ = vala_code_node_get_source_reference (_tmp135_);
	_tmp137_ = _tmp136_;
	_tmp138_ = lsp_location_new_from_sourceref (_tmp137_);
	if (_tmp138_) {
		g_object_set_data ((GObject *) _tmp138_, "vala-creation-function", "Vls.Server.goto_definition._lambda51_");
	}
	location = _tmp138_;
	_tmp139_ = location;
	_tmp140_ = lsp_location_get_uri (_tmp139_);
	_tmp141_ = _tmp140_;
	g_debug ("server.vala:1079: [textDocument/definition] found location ... %s", _tmp141_);
	{
		GVariant* _tmp142_ = NULL;
		LspLocation* _tmp143_;
		GVariant* _tmp144_;
		GCancellable* _tmp145_;
		_tmp143_ = location;
		_tmp144_ = vls_util_object_to_variant ((GObject*) _tmp143_, &_inner_error0_);
		_tmp142_ = _tmp144_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch2_g_error;
		}
		_tmp145_ = vls_server_cancellable;
		jsonrpc_client_reply (_data31_->client, _data31_->id, _tmp142_, _tmp145_, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_variant_unref0 (_tmp142_);
			goto __catch2_g_error;
		}
		_g_variant_unref0 (_tmp142_);
	}
	goto __finally2;
	__catch2_g_error:
	{
		GError* e = NULL;
		GError* _tmp146_;
		const gchar* _tmp147_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp146_ = e;
		_tmp147_ = _tmp146_->message;
		g_debug ("server.vala:1083: [textDocument/definition] failed to reply to client:" \
" %s", _tmp147_);
		_g_error_free0 (e);
	}
	__finally2:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_object_unref0 (location);
		_vala_code_node_unref0 (best);
		_vala_code_visitor_unref0 (fs);
		_vala_source_file_unref0 (file);
		_g_object_unref0 (project);
		_g_object_unref0 (compilation);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	vala_code_context_pop ();
	_g_object_unref0 (location);
	_vala_code_node_unref0 (best);
	_vala_code_visitor_unref0 (fs);
	_vala_source_file_unref0 (file);
	_g_object_unref0 (project);
	_g_object_unref0 (compilation);
}

static void
___lambda51__vls_server_on_context_updated_func (gboolean request_cancelled,
                                                 gpointer self)
{
	__lambda51_ (self, request_cancelled);
}

static void
vls_server_goto_definition (VlsServer* self,
                            JsonrpcClient* client,
                            const gchar* method,
                            GVariant* id,
                            GVariant* params)
{
	Block31Data* _data31_;
	JsonrpcClient* _tmp0_;
	gchar* _tmp1_;
	GVariant* _tmp2_;
	gpointer _tmp3_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (client != NULL);
	g_return_if_fail (method != NULL);
	g_return_if_fail (id != NULL);
	g_return_if_fail (params != NULL);
	_data31_ = g_slice_new0 (Block31Data);
	_data31_->_ref_count_ = 1;
	_data31_->self = g_object_ref (self);
	_tmp0_ = _g_object_ref0 (client);
	_g_object_unref0 (_data31_->client);
	_data31_->client = _tmp0_;
	_tmp1_ = g_strdup (method);
	_g_free0 (_data31_->method);
	_data31_->method = _tmp1_;
	_tmp2_ = _g_variant_ref0 (id);
	_g_variant_unref0 (_data31_->id);
	_data31_->id = _tmp2_;
	_tmp3_ = vls_util_parse_variant (LSP_TYPE_TEXT_DOCUMENT_POSITION_PARAMS, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, params);
	_data31_->p = (LspTextDocumentPositionParams*) _tmp3_;
	vls_server_wait_for_context_update (self, _data31_->id, ___lambda51__vls_server_on_context_updated_func, block31_data_ref (_data31_), block31_data_unref);
	block31_data_unref (_data31_);
	_data31_ = NULL;
}

static Block32Data*
block32_data_ref (Block32Data* _data32_)
{
	g_atomic_int_inc (&_data32_->_ref_count_);
	return _data32_;
}

static void
block32_data_unref (void * _userdata_)
{
	Block32Data* _data32_;
	_data32_ = (Block32Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data32_->_ref_count_)) {
		VlsServer* self;
		self = _data32_->self;
		_g_object_unref0 (_data32_->p);
		_g_object_unref0 (_data32_->client);
		_g_free0 (_data32_->method);
		_g_variant_unref0 (_data32_->id);
		_g_object_unref0 (self);
		g_slice_free (Block32Data, _data32_);
	}
}

static void
__lambda52_ (Block32Data* _data32_,
             gboolean request_cancelled)
{
	VlsServer* self;
	VlsCompilation* compilation = NULL;
	VlsProject* project = NULL;
	ValaSourceFile* file = NULL;
	LspTextDocumentIdentifier* _tmp0_;
	LspTextDocumentIdentifier* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	VlsCompilation* _tmp4_ = NULL;
	VlsProject* _tmp5_ = NULL;
	ValaSourceFile* _tmp6_;
	ValaSourceFile* _tmp7_;
	VlsCompilation* _tmp12_;
	ValaCodeContext* _tmp13_;
	ValaCodeContext* _tmp14_;
	JsonArray* array = NULL;
	JsonArray* _tmp15_;
	VlsSymbolEnumerator* syms = NULL;
	VlsCompilation* _tmp16_;
	ValaSourceFile* _tmp17_;
	gpointer _tmp18_;
	LspInitializeParams* _tmp19_;
	LspClientCapabilities* _tmp20_;
	LspClientCapabilities* _tmp21_;
	LspTextDocumentClientCapabilities* _tmp22_;
	LspTextDocumentClientCapabilities* _tmp23_;
	LspDocumentSymbolCapabilities* _tmp24_;
	LspDocumentSymbolCapabilities* _tmp25_;
	gboolean _tmp26_;
	gboolean _tmp27_;
	GError* _inner_error0_ = NULL;
	self = _data32_->self;
	if (request_cancelled) {
		vls_server_reply_null (_data32_->id, _data32_->client, _data32_->method);
		return;
	}
	_tmp0_ = lsp_text_document_position_params_get_textDocument (_data32_->p);
	_tmp1_ = _tmp0_;
	_tmp2_ = lsp_text_document_identifier_get_uri (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp6_ = vls_server_find_file (self, _tmp3_, &_tmp4_, &_tmp5_);
	_g_object_unref0 (compilation);
	compilation = _tmp4_;
	_g_object_unref0 (project);
	project = _tmp5_;
	file = _tmp6_;
	_tmp7_ = file;
	if (_tmp7_ == NULL) {
		LspTextDocumentIdentifier* _tmp8_;
		LspTextDocumentIdentifier* _tmp9_;
		const gchar* _tmp10_;
		const gchar* _tmp11_;
		_tmp8_ = lsp_text_document_position_params_get_textDocument (_data32_->p);
		_tmp9_ = _tmp8_;
		_tmp10_ = lsp_text_document_identifier_get_uri (_tmp9_);
		_tmp11_ = _tmp10_;
		g_debug ("server.vala:1102: [%s] file `%s' not found", _data32_->method, _tmp11_);
		vls_server_reply_null (_data32_->id, _data32_->client, _data32_->method);
		_vala_source_file_unref0 (file);
		_g_object_unref0 (project);
		_g_object_unref0 (compilation);
		return;
	}
	_tmp12_ = compilation;
	_tmp13_ = vls_compilation_get_code_context (_tmp12_);
	_tmp14_ = _tmp13_;
	vala_code_context_push (_tmp14_);
	_tmp15_ = json_array_new ();
	array = _tmp15_;
	_tmp16_ = compilation;
	_tmp17_ = file;
	_tmp18_ = vls_compilation_get_analysis_for_file (_tmp16_, VLS_TYPE_SYMBOL_ENUMERATOR, (GBoxedCopyFunc) vala_code_visitor_ref, (GDestroyNotify) vala_code_visitor_unref, _tmp17_);
	syms = (VlsSymbolEnumerator*) _tmp18_;
	_tmp19_ = self->priv->init_params;
	_tmp20_ = lsp_initialize_params_get_capabilities (_tmp19_);
	_tmp21_ = _tmp20_;
	_tmp22_ = lsp_client_capabilities_get_textDocument (_tmp21_);
	_tmp23_ = _tmp22_;
	_tmp24_ = lsp_text_document_client_capabilities_get_documentSymbol (_tmp23_);
	_tmp25_ = _tmp24_;
	_tmp26_ = lsp_document_symbol_capabilities_get_hierarchicalDocumentSymbolSupport (_tmp25_);
	_tmp27_ = _tmp26_;
	if (_tmp27_) {
		{
			GeeIterator* _dsym_it = NULL;
			VlsSymbolEnumerator* _tmp28_;
			GeeIterator* _tmp29_;
			_tmp28_ = syms;
			_tmp29_ = vls_symbol_enumerator_iterator (_tmp28_);
			_dsym_it = _tmp29_;
			while (TRUE) {
				GeeIterator* _tmp30_;
				LspDocumentSymbol* dsym = NULL;
				GeeIterator* _tmp31_;
				gpointer _tmp32_;
				JsonArray* _tmp33_;
				LspDocumentSymbol* _tmp34_;
				JsonNode* _tmp35_;
				_tmp30_ = _dsym_it;
				if (!gee_iterator_next (_tmp30_)) {
					break;
				}
				_tmp31_ = _dsym_it;
				_tmp32_ = gee_iterator_get (_tmp31_);
				dsym = (LspDocumentSymbol*) _tmp32_;
				_tmp33_ = array;
				_tmp34_ = dsym;
				_tmp35_ = json_gobject_serialize ((GObject*) _tmp34_);
				json_array_add_element (_tmp33_, _tmp35_);
				_g_object_unref0 (dsym);
			}
			_g_object_unref0 (_dsym_it);
		}
	} else {
		{
			GeeIterator* _dsym_it = NULL;
			VlsSymbolEnumerator* _tmp36_;
			GeeIterable* _tmp37_;
			GeeIterable* _tmp38_;
			GeeIterator* _tmp39_;
			GeeIterator* _tmp40_;
			_tmp36_ = syms;
			_tmp37_ = vls_symbol_enumerator_flattened (_tmp36_);
			_tmp38_ = _tmp37_;
			_tmp39_ = gee_iterable_iterator (_tmp38_);
			_tmp40_ = _tmp39_;
			_g_object_unref0 (_tmp38_);
			_dsym_it = _tmp40_;
			while (TRUE) {
				GeeIterator* _tmp41_;
				LspSymbolInformation* dsym = NULL;
				GeeIterator* _tmp42_;
				gpointer _tmp43_;
				JsonArray* _tmp44_;
				LspSymbolInformation* _tmp45_;
				JsonNode* _tmp46_;
				_tmp41_ = _dsym_it;
				if (!gee_iterator_next (_tmp41_)) {
					break;
				}
				_tmp42_ = _dsym_it;
				_tmp43_ = gee_iterator_get (_tmp42_);
				dsym = (LspSymbolInformation*) _tmp43_;
				_tmp44_ = array;
				_tmp45_ = dsym;
				_tmp46_ = json_gobject_serialize ((GObject*) _tmp45_);
				json_array_add_element (_tmp44_, _tmp46_);
				_g_object_unref0 (dsym);
			}
			_g_object_unref0 (_dsym_it);
		}
	}
	{
		GVariant* _result_ = NULL;
		JsonNode* _tmp47_;
		JsonNode* _tmp48_;
		JsonArray* _tmp49_;
		JsonNode* _tmp50_;
		GVariant* _tmp51_;
		GVariant* _tmp52_;
		GVariant* _tmp53_;
		GCancellable* _tmp54_;
		_tmp47_ = json_node_alloc ();
		_tmp48_ = _tmp47_;
		_tmp49_ = array;
		_tmp50_ = json_node_init_array (_tmp48_, _tmp49_);
		_tmp51_ = json_gvariant_deserialize (_tmp50_, NULL, &_inner_error0_);
		if (_tmp51_ != NULL) {
			g_variant_ref_sink (_tmp51_);
		}
		_tmp52_ = _tmp51_;
		__vala_JsonNode_free0 (_tmp48_);
		_result_ = _tmp52_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp53_ = _result_;
		_tmp54_ = vls_server_cancellable;
		jsonrpc_client_reply (_data32_->client, _data32_->id, _tmp53_, _tmp54_, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_variant_unref0 (_result_);
			goto __catch0_g_error;
		}
		_g_variant_unref0 (_result_);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp55_;
		const gchar* _tmp56_;
		const gchar* _tmp57_;
		gchar* _tmp58_;
		gchar* _tmp59_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp55_ = e;
		_tmp56_ = _tmp55_->message;
		_tmp57_ = string_to_string (_tmp56_);
		_tmp58_ = g_strconcat ("[textDocument/documentSymbol] failed to reply to client: ", _tmp57_, NULL);
		_tmp59_ = _tmp58_;
		g_debug ("server.vala:1127: %s", _tmp59_);
		_g_free0 (_tmp59_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_vala_code_visitor_unref0 (syms);
		_json_array_unref0 (array);
		_vala_source_file_unref0 (file);
		_g_object_unref0 (project);
		_g_object_unref0 (compilation);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	vala_code_context_pop ();
	_vala_code_visitor_unref0 (syms);
	_json_array_unref0 (array);
	_vala_source_file_unref0 (file);
	_g_object_unref0 (project);
	_g_object_unref0 (compilation);
}

static void
___lambda52__vls_server_on_context_updated_func (gboolean request_cancelled,
                                                 gpointer self)
{
	__lambda52_ (self, request_cancelled);
}

static void
vls_server_document_symbol_outline (VlsServer* self,
                                    JsonrpcClient* client,
                                    const gchar* method,
                                    GVariant* id,
                                    GVariant* params)
{
	Block32Data* _data32_;
	JsonrpcClient* _tmp0_;
	gchar* _tmp1_;
	GVariant* _tmp2_;
	gpointer _tmp3_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (client != NULL);
	g_return_if_fail (method != NULL);
	g_return_if_fail (id != NULL);
	g_return_if_fail (params != NULL);
	_data32_ = g_slice_new0 (Block32Data);
	_data32_->_ref_count_ = 1;
	_data32_->self = g_object_ref (self);
	_tmp0_ = _g_object_ref0 (client);
	_g_object_unref0 (_data32_->client);
	_data32_->client = _tmp0_;
	_tmp1_ = g_strdup (method);
	_g_free0 (_data32_->method);
	_data32_->method = _tmp1_;
	_tmp2_ = _g_variant_ref0 (id);
	_g_variant_unref0 (_data32_->id);
	_data32_->id = _tmp2_;
	_tmp3_ = vls_util_parse_variant (LSP_TYPE_TEXT_DOCUMENT_POSITION_PARAMS, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, params);
	_data32_->p = (LspTextDocumentPositionParams*) _tmp3_;
	vls_server_wait_for_context_update (self, _data32_->id, ___lambda52__vls_server_on_context_updated_func, block32_data_ref (_data32_), block32_data_unref);
	block32_data_unref (_data32_);
	_data32_ = NULL;
}

static gpointer
_vala_comment_ref0 (gpointer self)
{
	return self ? vala_comment_ref (self) : NULL;
}

VlsDocComment*
vls_server_get_symbol_documentation (VlsServer* self,
                                     VlsProject* project,
                                     ValaSymbol* sym)
{
	VlsCompilation* compilation = NULL;
	ValaSymbol* real_sym = NULL;
	ValaSymbol* _tmp0_;
	ValaSymbol* _tmp1_;
	ValaSymbol* root = NULL;
	ValaSymbol* _tmp11_;
	VlsCompilation* _tmp28_;
	ValaComment* comment = NULL;
	VlsDocComment* doc_comment = NULL;
	ValaSymbol* gir_sym = NULL;
	VlsGirDocumentation* _tmp29_;
	ValaSymbol* _tmp30_;
	gboolean _tmp31_ = FALSE;
	ValaSymbol* _tmp32_;
	ValaComment* _tmp43_;
	gboolean _tmp65_ = FALSE;
	VlsDocComment* _tmp66_;
	GError* _inner_error0_ = NULL;
	VlsDocComment* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (project != NULL, NULL);
	g_return_val_if_fail (sym != NULL, NULL);
	compilation = NULL;
	_tmp0_ = vls_symbol_references_find_real_symbol (project, sym);
	real_sym = _tmp0_;
	_tmp1_ = real_sym;
	sym = _tmp1_;
	root = NULL;
	{
		ValaSymbol* node = NULL;
		ValaSymbol* _tmp2_;
		_tmp2_ = _vala_code_node_ref0 (sym);
		node = _tmp2_;
		{
			gboolean _tmp3_ = FALSE;
			_tmp3_ = TRUE;
			while (TRUE) {
				ValaSymbol* _tmp8_;
				ValaSymbol* _tmp9_;
				ValaSymbol* _tmp10_;
				if (!_tmp3_) {
					ValaSymbol* _tmp4_;
					ValaSymbol* _tmp5_;
					ValaSymbol* _tmp6_;
					ValaSymbol* _tmp7_;
					_tmp4_ = node;
					_tmp5_ = vala_symbol_get_parent_symbol (_tmp4_);
					_tmp6_ = _tmp5_;
					_tmp7_ = _vala_code_node_ref0 (_tmp6_);
					_vala_code_node_unref0 (node);
					node = _tmp7_;
				}
				_tmp3_ = FALSE;
				_tmp8_ = node;
				if (!(_tmp8_ != NULL)) {
					break;
				}
				_tmp9_ = node;
				_tmp10_ = _vala_code_node_ref0 (_tmp9_);
				_vala_code_node_unref0 (root);
				root = _tmp10_;
			}
		}
		_vala_code_node_unref0 (node);
	}
	_tmp11_ = root;
	_vala_assert (_tmp11_ != NULL, "root != null");
	{
		GeeArrayList* _project_compilation_list = NULL;
		GeeArrayList* _tmp12_;
		gint _project_compilation_size = 0;
		GeeArrayList* _tmp13_;
		gint _tmp14_;
		gint _tmp15_;
		gint _project_compilation_index = 0;
		_tmp12_ = vls_project_get_compilations (project);
		_project_compilation_list = _tmp12_;
		_tmp13_ = _project_compilation_list;
		_tmp14_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp13_);
		_tmp15_ = _tmp14_;
		_project_compilation_size = _tmp15_;
		_project_compilation_index = -1;
		while (TRUE) {
			gint _tmp16_;
			gint _tmp17_;
			VlsCompilation* project_compilation = NULL;
			GeeArrayList* _tmp18_;
			gpointer _tmp19_;
			VlsCompilation* _tmp20_;
			ValaCodeContext* _tmp21_;
			ValaCodeContext* _tmp22_;
			ValaNamespace* _tmp23_;
			ValaNamespace* _tmp24_;
			ValaSymbol* _tmp25_;
			_project_compilation_index = _project_compilation_index + 1;
			_tmp16_ = _project_compilation_index;
			_tmp17_ = _project_compilation_size;
			if (!(_tmp16_ < _tmp17_)) {
				break;
			}
			_tmp18_ = _project_compilation_list;
			_tmp19_ = gee_abstract_list_get ((GeeAbstractList*) _tmp18_, _project_compilation_index);
			project_compilation = (VlsCompilation*) _tmp19_;
			_tmp20_ = project_compilation;
			_tmp21_ = vls_compilation_get_code_context (_tmp20_);
			_tmp22_ = _tmp21_;
			_tmp23_ = vala_code_context_get_root (_tmp22_);
			_tmp24_ = _tmp23_;
			_tmp25_ = root;
			if (G_TYPE_CHECK_INSTANCE_CAST (_tmp24_, VALA_TYPE_SYMBOL, ValaSymbol) == _tmp25_) {
				VlsCompilation* _tmp26_;
				VlsCompilation* _tmp27_;
				_tmp26_ = project_compilation;
				_tmp27_ = _g_object_ref0 (_tmp26_);
				_g_object_unref0 (compilation);
				compilation = _tmp27_;
				_g_object_unref0 (project_compilation);
				break;
			}
			_g_object_unref0 (project_compilation);
		}
		_g_object_unref0 (_project_compilation_list);
	}
	_tmp28_ = compilation;
	if (_tmp28_ == NULL) {
		result = NULL;
		_vala_code_node_unref0 (root);
		_vala_code_node_unref0 (real_sym);
		_g_object_unref0 (compilation);
		return result;
	}
	comment = NULL;
	doc_comment = NULL;
	_tmp29_ = self->priv->documentation;
	_tmp30_ = vls_gir_documentation_find_gir_symbol (_tmp29_, sym);
	gir_sym = _tmp30_;
	_tmp32_ = gir_sym;
	if (_tmp32_ != NULL) {
		ValaSymbol* _tmp33_;
		ValaComment* _tmp34_;
		ValaComment* _tmp35_;
		_tmp33_ = gir_sym;
		_tmp34_ = vala_symbol_get_comment (_tmp33_);
		_tmp35_ = _tmp34_;
		_tmp31_ = _tmp35_ != NULL;
	} else {
		_tmp31_ = FALSE;
	}
	if (_tmp31_) {
		ValaSymbol* _tmp36_;
		ValaComment* _tmp37_;
		ValaComment* _tmp38_;
		ValaComment* _tmp39_;
		_tmp36_ = gir_sym;
		_tmp37_ = vala_symbol_get_comment (_tmp36_);
		_tmp38_ = _tmp37_;
		_tmp39_ = _vala_comment_ref0 (_tmp38_);
		_vala_comment_unref0 (comment);
		comment = _tmp39_;
	} else {
		ValaComment* _tmp40_;
		ValaComment* _tmp41_;
		ValaComment* _tmp42_;
		_tmp40_ = vala_symbol_get_comment (sym);
		_tmp41_ = _tmp40_;
		_tmp42_ = _vala_comment_ref0 (_tmp41_);
		_vala_comment_unref0 (comment);
		comment = _tmp42_;
	}
	_tmp43_ = comment;
	if (_tmp43_ != NULL) {
		{
			gboolean _tmp44_ = FALSE;
			ValaComment* _tmp45_;
			_tmp45_ = comment;
			if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp45_, VALA_TYPE_GIR_COMMENT)) {
				_tmp44_ = TRUE;
			} else {
				gboolean _tmp46_ = FALSE;
				ValaSymbol* _tmp47_;
				_tmp47_ = gir_sym;
				if (_tmp47_ != NULL) {
					ValaSymbol* _tmp48_;
					ValaComment* _tmp49_;
					ValaComment* _tmp50_;
					ValaComment* _tmp51_;
					_tmp48_ = gir_sym;
					_tmp49_ = vala_symbol_get_comment (_tmp48_);
					_tmp50_ = _tmp49_;
					_tmp51_ = comment;
					_tmp46_ = _tmp50_ == _tmp51_;
				} else {
					_tmp46_ = FALSE;
				}
				_tmp44_ = _tmp46_;
			}
			if (_tmp44_) {
				VlsDocComment* _tmp52_ = NULL;
				ValaComment* _tmp53_;
				VlsGirDocumentation* _tmp54_;
				VlsCompilation* _tmp55_;
				VlsDocComment* _tmp56_;
				VlsDocComment* _tmp57_;
				_tmp53_ = comment;
				_tmp54_ = self->priv->documentation;
				_tmp55_ = compilation;
				_tmp56_ = vls_doc_comment_new_from_gir_comment (_tmp53_, _tmp54_, _tmp55_, &_inner_error0_);
				_tmp52_ = _tmp56_;
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					if (_inner_error0_->domain == G_REGEX_ERROR) {
						goto __catch0_g_regex_error;
					}
					_vala_code_node_unref0 (gir_sym);
					_vls_doc_comment_unref0 (doc_comment);
					_vala_comment_unref0 (comment);
					_vala_code_node_unref0 (root);
					_vala_code_node_unref0 (real_sym);
					_g_object_unref0 (compilation);
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return NULL;
				}
				_tmp57_ = _tmp52_;
				_tmp52_ = NULL;
				_vls_doc_comment_unref0 (doc_comment);
				doc_comment = _tmp57_;
				_vls_doc_comment_unref0 (_tmp52_);
			} else {
				VlsDocComment* _tmp58_ = NULL;
				ValaComment* _tmp59_;
				VlsCompilation* _tmp60_;
				VlsDocComment* _tmp61_;
				VlsDocComment* _tmp62_;
				_tmp59_ = comment;
				_tmp60_ = compilation;
				_tmp61_ = vls_doc_comment_new_from_valadoc_comment (_tmp59_, sym, _tmp60_, &_inner_error0_);
				_tmp58_ = _tmp61_;
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					if (_inner_error0_->domain == G_REGEX_ERROR) {
						goto __catch0_g_regex_error;
					}
					_vala_code_node_unref0 (gir_sym);
					_vls_doc_comment_unref0 (doc_comment);
					_vala_comment_unref0 (comment);
					_vala_code_node_unref0 (root);
					_vala_code_node_unref0 (real_sym);
					_g_object_unref0 (compilation);
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return NULL;
				}
				_tmp62_ = _tmp58_;
				_tmp58_ = NULL;
				_vls_doc_comment_unref0 (doc_comment);
				doc_comment = _tmp62_;
				_vls_doc_comment_unref0 (_tmp58_);
			}
		}
		goto __finally0;
		__catch0_g_regex_error:
		{
			GError* e = NULL;
			GError* _tmp63_;
			const gchar* _tmp64_;
			e = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp63_ = e;
			_tmp64_ = _tmp63_->message;
			g_warning ("server.vala:1166: failed to render comment - %s", _tmp64_);
			_g_error_free0 (e);
		}
		__finally0:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_vala_code_node_unref0 (gir_sym);
			_vls_doc_comment_unref0 (doc_comment);
			_vala_comment_unref0 (comment);
			_vala_code_node_unref0 (root);
			_vala_code_node_unref0 (real_sym);
			_g_object_unref0 (compilation);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
	}
	_tmp66_ = doc_comment;
	if (_tmp66_ == NULL) {
		_tmp65_ = G_TYPE_CHECK_INSTANCE_TYPE (sym, VALA_TYPE_PARAMETER);
	} else {
		_tmp65_ = FALSE;
	}
	if (_tmp65_) {
		VlsDocComment* parent_doc = NULL;
		ValaSymbol* _tmp67_;
		ValaSymbol* _tmp68_;
		VlsDocComment* _tmp69_;
		VlsDocComment* _tmp70_;
		_tmp67_ = vala_symbol_get_parent_symbol (sym);
		_tmp68_ = _tmp67_;
		_tmp69_ = vls_server_get_symbol_documentation (self, project, _tmp68_);
		parent_doc = _tmp69_;
		_tmp70_ = parent_doc;
		if (_tmp70_ != NULL) {
			gchar* doc = NULL;
			VlsDocComment* _tmp71_;
			GeeHashMap* _tmp72_;
			GeeHashMap* _tmp73_;
			const gchar* _tmp74_;
			const gchar* _tmp75_;
			gpointer _tmp76_;
			const gchar* _tmp77_;
			_tmp71_ = parent_doc;
			_tmp72_ = vls_doc_comment_get_parameters (_tmp71_);
			_tmp73_ = _tmp72_;
			_tmp74_ = vala_symbol_get_name (sym);
			_tmp75_ = _tmp74_;
			_tmp76_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp73_, _tmp75_);
			doc = (gchar*) _tmp76_;
			_tmp77_ = doc;
			if (_tmp77_ != NULL) {
				const gchar* _tmp78_;
				VlsDocComment* _tmp79_;
				_tmp78_ = doc;
				_tmp79_ = vls_doc_comment_new (_tmp78_);
				_vls_doc_comment_unref0 (doc_comment);
				doc_comment = _tmp79_;
			}
			_g_free0 (doc);
		}
		_vls_doc_comment_unref0 (parent_doc);
	}
	result = doc_comment;
	_vala_code_node_unref0 (gir_sym);
	_vala_comment_unref0 (comment);
	_vala_code_node_unref0 (root);
	_vala_code_node_unref0 (real_sym);
	_g_object_unref0 (compilation);
	return result;
}

static void
vls_server_show_completion (VlsServer* self,
                            JsonrpcClient* client,
                            const gchar* method,
                            GVariant* id,
                            GVariant* params)
{
	LspCompletionParams* p = NULL;
	gpointer _tmp0_;
	VlsCompilation* compilation = NULL;
	VlsProject* project = NULL;
	ValaSourceFile* file = NULL;
	LspCompletionParams* _tmp1_;
	LspTextDocumentIdentifier* _tmp2_;
	LspTextDocumentIdentifier* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	VlsCompilation* _tmp6_ = NULL;
	VlsProject* _tmp7_ = NULL;
	ValaSourceFile* _tmp8_;
	ValaSourceFile* _tmp9_;
	VlsProject* _tmp15_;
	ValaSourceFile* _tmp16_;
	VlsCompilation* _tmp17_;
	LspCompletionParams* _tmp18_;
	LspPosition* _tmp19_;
	LspPosition* _tmp20_;
	LspCompletionParams* _tmp21_;
	LspCompletionContext* _tmp22_;
	LspCompletionContext* _tmp23_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (client != NULL);
	g_return_if_fail (method != NULL);
	g_return_if_fail (id != NULL);
	g_return_if_fail (params != NULL);
	_tmp0_ = vls_util_parse_variant (LSP_TYPE_COMPLETION_PARAMS, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, params);
	p = (LspCompletionParams*) _tmp0_;
	_tmp1_ = p;
	_tmp2_ = lsp_text_document_position_params_get_textDocument ((LspTextDocumentPositionParams*) _tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = lsp_text_document_identifier_get_uri (_tmp3_);
	_tmp5_ = _tmp4_;
	_tmp8_ = vls_server_find_file (self, _tmp5_, &_tmp6_, &_tmp7_);
	_g_object_unref0 (compilation);
	compilation = _tmp6_;
	_g_object_unref0 (project);
	project = _tmp7_;
	file = _tmp8_;
	_tmp9_ = file;
	if (_tmp9_ == NULL) {
		LspCompletionParams* _tmp10_;
		LspTextDocumentIdentifier* _tmp11_;
		LspTextDocumentIdentifier* _tmp12_;
		const gchar* _tmp13_;
		const gchar* _tmp14_;
		_tmp10_ = p;
		_tmp11_ = lsp_text_document_position_params_get_textDocument ((LspTextDocumentPositionParams*) _tmp10_);
		_tmp12_ = _tmp11_;
		_tmp13_ = lsp_text_document_identifier_get_uri (_tmp12_);
		_tmp14_ = _tmp13_;
		g_debug ("server.vala:1189: [%s] file `%s' not found", method, _tmp14_);
		vls_server_reply_null (id, client, method);
		_vala_source_file_unref0 (file);
		_g_object_unref0 (project);
		_g_object_unref0 (compilation);
		_g_object_unref0 (p);
		return;
	}
	_tmp15_ = project;
	_tmp16_ = file;
	_tmp17_ = compilation;
	_tmp18_ = p;
	_tmp19_ = lsp_text_document_position_params_get_position ((LspTextDocumentPositionParams*) _tmp18_);
	_tmp20_ = _tmp19_;
	_tmp21_ = p;
	_tmp22_ = lsp_completion_params_get_context (_tmp21_);
	_tmp23_ = _tmp22_;
	vls_completion_engine_begin_response (self, _tmp15_, client, id, method, _tmp16_, _tmp17_, _tmp20_, _tmp23_);
	_vala_source_file_unref0 (file);
	_g_object_unref0 (project);
	_g_object_unref0 (compilation);
	_g_object_unref0 (p);
}

static void
vls_server_show_signature_help (VlsServer* self,
                                JsonrpcClient* client,
                                const gchar* method,
                                GVariant* id,
                                GVariant* params)
{
	LspTextDocumentPositionParams* p = NULL;
	gpointer _tmp0_;
	VlsCompilation* compilation = NULL;
	VlsProject* project = NULL;
	ValaSourceFile* file = NULL;
	LspTextDocumentPositionParams* _tmp1_;
	LspTextDocumentIdentifier* _tmp2_;
	LspTextDocumentIdentifier* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	VlsCompilation* _tmp6_ = NULL;
	VlsProject* _tmp7_ = NULL;
	ValaSourceFile* _tmp8_;
	ValaSourceFile* _tmp9_;
	VlsProject* _tmp15_;
	ValaSourceFile* _tmp16_;
	VlsCompilation* _tmp17_;
	LspTextDocumentPositionParams* _tmp18_;
	LspPosition* _tmp19_;
	LspPosition* _tmp20_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (client != NULL);
	g_return_if_fail (method != NULL);
	g_return_if_fail (id != NULL);
	g_return_if_fail (params != NULL);
	_tmp0_ = vls_util_parse_variant (LSP_TYPE_TEXT_DOCUMENT_POSITION_PARAMS, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, params);
	p = (LspTextDocumentPositionParams*) _tmp0_;
	_tmp1_ = p;
	_tmp2_ = lsp_text_document_position_params_get_textDocument (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = lsp_text_document_identifier_get_uri (_tmp3_);
	_tmp5_ = _tmp4_;
	_tmp8_ = vls_server_find_file (self, _tmp5_, &_tmp6_, &_tmp7_);
	_g_object_unref0 (compilation);
	compilation = _tmp6_;
	_g_object_unref0 (project);
	project = _tmp7_;
	file = _tmp8_;
	_tmp9_ = file;
	if (_tmp9_ == NULL) {
		LspTextDocumentPositionParams* _tmp10_;
		LspTextDocumentIdentifier* _tmp11_;
		LspTextDocumentIdentifier* _tmp12_;
		const gchar* _tmp13_;
		const gchar* _tmp14_;
		_tmp10_ = p;
		_tmp11_ = lsp_text_document_position_params_get_textDocument (_tmp10_);
		_tmp12_ = _tmp11_;
		_tmp13_ = lsp_text_document_identifier_get_uri (_tmp12_);
		_tmp14_ = _tmp13_;
		g_debug ("server.vala:1207: [%s] file `%s' not found", method, _tmp14_);
		vls_server_reply_null (id, client, method);
		_vala_source_file_unref0 (file);
		_g_object_unref0 (project);
		_g_object_unref0 (compilation);
		_g_object_unref0 (p);
		return;
	}
	_tmp15_ = project;
	_tmp16_ = file;
	_tmp17_ = compilation;
	_tmp18_ = p;
	_tmp19_ = lsp_text_document_position_params_get_position (_tmp18_);
	_tmp20_ = _tmp19_;
	vls_signature_help_engine_begin_response (self, _tmp15_, client, id, method, _tmp16_, _tmp17_, _tmp20_);
	_vala_source_file_unref0 (file);
	_g_object_unref0 (project);
	_g_object_unref0 (compilation);
	_g_object_unref0 (p);
}

static Block33Data*
block33_data_ref (Block33Data* _data33_)
{
	g_atomic_int_inc (&_data33_->_ref_count_);
	return _data33_;
}

static void
block33_data_unref (void * _userdata_)
{
	Block33Data* _data33_;
	_data33_ = (Block33Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data33_->_ref_count_)) {
		VlsServer* self;
		self = _data33_->self;
		_g_object_unref0 (_data33_->p);
		_g_object_unref0 (_data33_->client);
		_g_free0 (_data33_->method);
		_g_variant_unref0 (_data33_->id);
		_g_object_unref0 (self);
		g_slice_free (Block33Data, _data33_);
	}
}

static gpointer
_vala_scope_ref0 (gpointer self)
{
	return self ? vala_scope_ref (self) : NULL;
}

static gpointer
_vala_iterable_ref0 (gpointer self)
{
	return self ? vala_iterable_ref (self) : NULL;
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result;
	g_return_val_if_fail (self != NULL, '\0');
	_tmp0_ = ((gchar*) self)[index];
	result = _tmp0_;
	return result;
}

static void
__lambda65_ (Block33Data* _data33_,
             gboolean request_cancelled)
{
	VlsServer* self;
	LspPosition* pos = NULL;
	LspPosition* _tmp0_;
	LspPosition* _tmp1_;
	LspPosition* _tmp2_;
	VlsCompilation* compilation = NULL;
	VlsProject* project = NULL;
	ValaSourceFile* doc = NULL;
	LspTextDocumentIdentifier* _tmp3_;
	LspTextDocumentIdentifier* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	VlsCompilation* _tmp7_ = NULL;
	VlsProject* _tmp8_ = NULL;
	ValaSourceFile* _tmp9_;
	ValaSourceFile* _tmp10_;
	VlsCompilation* _tmp15_;
	ValaCodeContext* _tmp16_;
	ValaCodeContext* _tmp17_;
	VlsNodeSearch* fs = NULL;
	ValaSourceFile* _tmp18_;
	LspPosition* _tmp19_;
	VlsNodeSearch* _tmp20_;
	VlsNodeSearch* _tmp21_;
	GeeList* _tmp22_;
	gint _tmp23_;
	gint _tmp24_;
	ValaScope* scope = NULL;
	ValaSourceFile* _tmp25_;
	LspPosition* _tmp26_;
	VlsFindScope* _tmp27_;
	VlsFindScope* _tmp28_;
	ValaSymbol* _tmp29_;
	ValaSymbol* _tmp30_;
	ValaScope* _tmp31_;
	ValaScope* _tmp32_;
	ValaScope* _tmp33_;
	ValaScope* _tmp34_;
	ValaCodeNode* _result_ = NULL;
	VlsNodeSearch* _tmp35_;
	ValaSourceFile* _tmp36_;
	ValaCodeNode* _tmp37_;
	gboolean _tmp38_ = FALSE;
	gboolean _tmp39_ = FALSE;
	ValaCodeNode* _tmp40_;
	ValaDataType* data_type = NULL;
	ValaList* method_type_arguments = NULL;
	ValaSymbol* symbol = NULL;
	ValaCodeNode* _tmp45_;
	gboolean _tmp112_ = FALSE;
	gboolean _tmp113_ = FALSE;
	gboolean _tmp114_ = FALSE;
	ValaSymbol* _tmp115_;
	LspHover* hoverInfo = NULL;
	LspHover* _tmp132_;
	LspRange* symbol_range = NULL;
	ValaSymbol* _tmp133_;
	LspRange* _tmp162_;
	gchar* representation = NULL;
	ValaDataType* _tmp169_;
	ValaSymbol* _tmp170_;
	ValaScope* _tmp171_;
	ValaList* _tmp172_;
	gchar* _tmp173_;
	const gchar* _tmp174_;
	GError* _inner_error0_ = NULL;
	self = _data33_->self;
	if (request_cancelled) {
		vls_server_reply_null (_data33_->id, _data33_->client, "textDocument/hover");
		return;
	}
	_tmp0_ = lsp_text_document_position_params_get_position (_data33_->p);
	_tmp1_ = _tmp0_;
	_tmp2_ = _g_object_ref0 (_tmp1_);
	pos = _tmp2_;
	_tmp3_ = lsp_text_document_position_params_get_textDocument (_data33_->p);
	_tmp4_ = _tmp3_;
	_tmp5_ = lsp_text_document_identifier_get_uri (_tmp4_);
	_tmp6_ = _tmp5_;
	_tmp9_ = vls_server_find_file (self, _tmp6_, &_tmp7_, &_tmp8_);
	_g_object_unref0 (compilation);
	compilation = _tmp7_;
	_g_object_unref0 (project);
	project = _tmp8_;
	doc = _tmp9_;
	_tmp10_ = doc;
	if (_tmp10_ == NULL) {
		LspTextDocumentIdentifier* _tmp11_;
		LspTextDocumentIdentifier* _tmp12_;
		const gchar* _tmp13_;
		const gchar* _tmp14_;
		_tmp11_ = lsp_text_document_position_params_get_textDocument (_data33_->p);
		_tmp12_ = _tmp11_;
		_tmp13_ = lsp_text_document_identifier_get_uri (_tmp12_);
		_tmp14_ = _tmp13_;
		g_debug ("server.vala:1232: [%s] file `%s' not found", _data33_->method, _tmp14_);
		vls_server_reply_null (_data33_->id, _data33_->client, _data33_->method);
		_vala_source_file_unref0 (doc);
		_g_object_unref0 (project);
		_g_object_unref0 (compilation);
		_g_object_unref0 (pos);
		return;
	}
	_tmp15_ = compilation;
	_tmp16_ = vls_compilation_get_code_context (_tmp15_);
	_tmp17_ = _tmp16_;
	vala_code_context_push (_tmp17_);
	_tmp18_ = doc;
	_tmp19_ = pos;
	_tmp20_ = vls_node_search_new (_tmp18_, _tmp19_, TRUE, NULL, TRUE);
	fs = _tmp20_;
	_tmp21_ = fs;
	_tmp22_ = _tmp21_->result;
	_tmp23_ = gee_collection_get_size ((GeeCollection*) _tmp22_);
	_tmp24_ = _tmp23_;
	if (_tmp24_ == 0) {
		vls_server_reply_null (_data33_->id, _data33_->client, _data33_->method);
		vala_code_context_pop ();
		_vala_code_visitor_unref0 (fs);
		_vala_source_file_unref0 (doc);
		_g_object_unref0 (project);
		_g_object_unref0 (compilation);
		_g_object_unref0 (pos);
		return;
	}
	_tmp25_ = doc;
	_tmp26_ = pos;
	_tmp27_ = vls_find_scope_new (_tmp25_, _tmp26_, TRUE);
	_tmp28_ = _tmp27_;
	_tmp29_ = vls_find_scope_get_best_block (_tmp28_);
	_tmp30_ = _tmp29_;
	_tmp31_ = vala_symbol_get_scope (_tmp30_);
	_tmp32_ = _tmp31_;
	_tmp33_ = _vala_scope_ref0 (_tmp32_);
	_tmp34_ = _tmp33_;
	_vala_code_visitor_unref0 (_tmp28_);
	scope = _tmp34_;
	_tmp35_ = fs;
	_tmp36_ = doc;
	_tmp37_ = vls_server_get_best (_tmp35_, _tmp36_);
	_result_ = _tmp37_;
	_tmp40_ = _result_;
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp40_, VALA_TYPE_METHOD)) {
		ValaCodeNode* _tmp41_;
		gboolean _tmp42_;
		gboolean _tmp43_;
		_tmp41_ = _result_;
		_tmp42_ = vala_method_get_closure (G_TYPE_CHECK_INSTANCE_CAST (_tmp41_, VALA_TYPE_METHOD, ValaMethod));
		_tmp43_ = _tmp42_;
		_tmp39_ = _tmp43_;
	} else {
		_tmp39_ = FALSE;
	}
	if (_tmp39_) {
		_tmp38_ = TRUE;
	} else {
		ValaCodeNode* _tmp44_;
		_tmp44_ = _result_;
		_tmp38_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp44_, VALA_TYPE_PROPERTY_ACCESSOR);
	}
	if (_tmp38_) {
		vls_server_reply_null (_data33_->id, _data33_->client, "textDocument/hover");
		vala_code_context_pop ();
		_vala_code_node_unref0 (_result_);
		_vala_scope_unref0 (scope);
		_vala_code_visitor_unref0 (fs);
		_vala_source_file_unref0 (doc);
		_g_object_unref0 (project);
		_g_object_unref0 (compilation);
		_g_object_unref0 (pos);
		return;
	}
	data_type = NULL;
	method_type_arguments = NULL;
	symbol = NULL;
	_tmp45_ = _result_;
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp45_, VALA_TYPE_EXPRESSION)) {
		ValaExpression* expr = NULL;
		ValaCodeNode* _tmp46_;
		ValaExpression* _tmp47_;
		ValaExpression* _tmp48_;
		ValaSymbol* _tmp49_;
		ValaSymbol* _tmp50_;
		ValaSymbol* _tmp51_;
		ValaExpression* _tmp52_;
		ValaDataType* _tmp53_;
		ValaDataType* _tmp54_;
		ValaDataType* _tmp55_;
		gboolean _tmp56_ = FALSE;
		ValaSymbol* _tmp57_;
		ValaExpression* _tmp79_;
		ValaCodeNode* _tmp80_;
		ValaCodeNode* _tmp81_;
		gboolean _tmp88_ = FALSE;
		gboolean _tmp89_ = FALSE;
		ValaSymbol* _tmp90_;
		_tmp46_ = _result_;
		_tmp47_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp46_, VALA_TYPE_EXPRESSION, ValaExpression));
		expr = _tmp47_;
		_tmp48_ = expr;
		_tmp49_ = vala_expression_get_symbol_reference (_tmp48_);
		_tmp50_ = _tmp49_;
		_tmp51_ = _vala_code_node_ref0 (_tmp50_);
		_vala_code_node_unref0 (symbol);
		symbol = _tmp51_;
		_tmp52_ = expr;
		_tmp53_ = vala_expression_get_value_type (_tmp52_);
		_tmp54_ = _tmp53_;
		_tmp55_ = _vala_code_node_ref0 (_tmp54_);
		_vala_code_node_unref0 (data_type);
		data_type = _tmp55_;
		_tmp57_ = symbol;
		if (_tmp57_ != NULL) {
			ValaExpression* _tmp58_;
			_tmp58_ = expr;
			_tmp56_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp58_, VALA_TYPE_MEMBER_ACCESS);
		} else {
			_tmp56_ = FALSE;
		}
		if (_tmp56_) {
			ValaMemberAccess* ma = NULL;
			ValaExpression* _tmp59_;
			ValaMemberAccess* _tmp60_;
			gboolean _tmp61_ = FALSE;
			ValaMemberAccess* _tmp62_;
			ValaExpression* _tmp63_;
			ValaExpression* _tmp64_;
			ValaMemberAccess* _tmp76_;
			ValaList* _tmp77_;
			ValaList* _tmp78_;
			_tmp59_ = expr;
			_tmp60_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp59_, VALA_TYPE_MEMBER_ACCESS, ValaMemberAccess));
			ma = _tmp60_;
			_tmp62_ = ma;
			_tmp63_ = vala_member_access_get_inner (_tmp62_);
			_tmp64_ = _tmp63_;
			if (_tmp64_ != NULL) {
				ValaMemberAccess* _tmp65_;
				ValaExpression* _tmp66_;
				ValaExpression* _tmp67_;
				ValaDataType* _tmp68_;
				ValaDataType* _tmp69_;
				_tmp65_ = ma;
				_tmp66_ = vala_member_access_get_inner (_tmp65_);
				_tmp67_ = _tmp66_;
				_tmp68_ = vala_expression_get_value_type (_tmp67_);
				_tmp69_ = _tmp68_;
				_tmp61_ = _tmp69_ != NULL;
			} else {
				_tmp61_ = FALSE;
			}
			if (_tmp61_) {
				ValaMemberAccess* _tmp70_;
				ValaExpression* _tmp71_;
				ValaExpression* _tmp72_;
				ValaDataType* _tmp73_;
				ValaDataType* _tmp74_;
				ValaDataType* _tmp75_;
				_tmp70_ = ma;
				_tmp71_ = vala_member_access_get_inner (_tmp70_);
				_tmp72_ = _tmp71_;
				_tmp73_ = vala_expression_get_value_type (_tmp72_);
				_tmp74_ = _tmp73_;
				_tmp75_ = _vala_code_node_ref0 (_tmp74_);
				_vala_code_node_unref0 (data_type);
				data_type = _tmp75_;
			}
			_tmp76_ = ma;
			_tmp77_ = vala_member_access_get_type_arguments (_tmp76_);
			_tmp78_ = _vala_iterable_ref0 (_tmp77_);
			_vala_iterable_unref0 (method_type_arguments);
			method_type_arguments = _tmp78_;
			_vala_code_node_unref0 (ma);
		}
		_tmp79_ = expr;
		_tmp80_ = vala_code_node_get_parent_node ((ValaCodeNode*) _tmp79_);
		_tmp81_ = _tmp80_;
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp81_, VALA_TYPE_OBJECT_CREATION_EXPRESSION)) {
			ValaExpression* _tmp82_;
			ValaCodeNode* _tmp83_;
			ValaCodeNode* _tmp84_;
			ValaDataType* _tmp85_;
			ValaDataType* _tmp86_;
			ValaDataType* _tmp87_;
			_tmp82_ = expr;
			_tmp83_ = vala_code_node_get_parent_node ((ValaCodeNode*) _tmp82_);
			_tmp84_ = _tmp83_;
			_tmp85_ = vala_expression_get_value_type ((ValaExpression*) G_TYPE_CHECK_INSTANCE_CAST (_tmp84_, VALA_TYPE_OBJECT_CREATION_EXPRESSION, ValaObjectCreationExpression));
			_tmp86_ = _tmp85_;
			_tmp87_ = _vala_code_node_ref0 (_tmp86_);
			_vala_code_node_unref0 (data_type);
			data_type = _tmp87_;
		}
		_tmp90_ = symbol;
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp90_, VALA_TYPE_VARIABLE)) {
			ValaDataType* _tmp91_;
			_tmp91_ = data_type;
			_tmp89_ = _tmp91_ != NULL;
		} else {
			_tmp89_ = FALSE;
		}
		if (_tmp89_) {
			ValaDataType* _tmp92_;
			ValaSymbol* _tmp93_;
			ValaDataType* _tmp94_;
			ValaDataType* _tmp95_;
			_tmp92_ = data_type;
			_tmp93_ = symbol;
			_tmp94_ = vala_variable_get_variable_type (G_TYPE_CHECK_INSTANCE_CAST (_tmp93_, VALA_TYPE_VARIABLE, ValaVariable));
			_tmp95_ = _tmp94_;
			_tmp88_ = vala_data_type_equals (_tmp92_, _tmp95_);
		} else {
			_tmp88_ = FALSE;
		}
		if (_tmp88_) {
			_vala_code_node_unref0 (data_type);
			data_type = NULL;
		}
		_vala_code_node_unref0 (expr);
	} else {
		ValaCodeNode* _tmp96_;
		_tmp96_ = _result_;
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp96_, VALA_TYPE_SYMBOL)) {
			ValaCodeNode* _tmp97_;
			ValaSymbol* _tmp98_;
			_tmp97_ = _result_;
			_tmp98_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp97_, VALA_TYPE_SYMBOL, ValaSymbol));
			_vala_code_node_unref0 (symbol);
			symbol = _tmp98_;
		} else {
			ValaCodeNode* _tmp99_;
			_tmp99_ = _result_;
			if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp99_, VALA_TYPE_DATA_TYPE)) {
				ValaCodeNode* _tmp100_;
				ValaDataType* _tmp101_;
				ValaDataType* _tmp102_;
				ValaSymbol* _tmp103_;
				_tmp100_ = _result_;
				_tmp101_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp100_, VALA_TYPE_DATA_TYPE, ValaDataType));
				_vala_code_node_unref0 (data_type);
				data_type = _tmp101_;
				_tmp102_ = data_type;
				_tmp103_ = vls_symbol_references_get_symbol_data_type_refers_to (_tmp102_);
				_vala_code_node_unref0 (symbol);
				symbol = _tmp103_;
			} else {
				ValaCodeNode* _tmp104_;
				_tmp104_ = _result_;
				if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp104_, VALA_TYPE_USING_DIRECTIVE)) {
					ValaCodeNode* _tmp105_;
					ValaSymbol* _tmp106_;
					ValaSymbol* _tmp107_;
					ValaSymbol* _tmp108_;
					_tmp105_ = _result_;
					_tmp106_ = vala_using_directive_get_namespace_symbol (G_TYPE_CHECK_INSTANCE_CAST (_tmp105_, VALA_TYPE_USING_DIRECTIVE, ValaUsingDirective));
					_tmp107_ = _tmp106_;
					_tmp108_ = _vala_code_node_ref0 (_tmp107_);
					_vala_code_node_unref0 (symbol);
					symbol = _tmp108_;
				} else {
					ValaCodeNode* _tmp109_;
					const gchar* _tmp110_;
					const gchar* _tmp111_;
					_tmp109_ = _result_;
					_tmp110_ = vala_code_node_get_type_name (_tmp109_);
					_tmp111_ = _tmp110_;
					g_warning ("server.vala:1292: result as %s not matched", _tmp111_);
				}
			}
		}
	}
	_tmp115_ = symbol;
	if (_tmp115_ != NULL) {
		ValaSymbol* _tmp116_;
		const gchar* _tmp117_;
		const gchar* _tmp118_;
		_tmp116_ = symbol;
		_tmp117_ = vala_symbol_get_name (_tmp116_);
		_tmp118_ = _tmp117_;
		_tmp114_ = _tmp118_ != NULL;
	} else {
		_tmp114_ = FALSE;
	}
	if (_tmp114_) {
		ValaSymbol* _tmp119_;
		const gchar* _tmp120_;
		const gchar* _tmp121_;
		_tmp119_ = symbol;
		_tmp120_ = vala_symbol_get_name (_tmp119_);
		_tmp121_ = _tmp120_;
		_tmp113_ = string_get (_tmp121_, (glong) 0) == '.';
	} else {
		_tmp113_ = FALSE;
	}
	if (_tmp113_) {
		ValaSymbol* _tmp122_;
		const gchar* _tmp123_;
		const gchar* _tmp124_;
		_tmp122_ = symbol;
		_tmp123_ = vala_symbol_get_name (_tmp122_);
		_tmp124_ = _tmp123_;
		_tmp112_ = g_ascii_isdigit (string_get (_tmp124_, (glong) 1));
	} else {
		_tmp112_ = FALSE;
	}
	if (_tmp112_) {
		gboolean _tmp125_ = FALSE;
		ValaSymbol* _tmp126_;
		_tmp126_ = symbol;
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp126_, VALA_TYPE_VARIABLE)) {
			ValaDataType* _tmp127_;
			_tmp127_ = data_type;
			_tmp125_ = _tmp127_ == NULL;
		} else {
			_tmp125_ = FALSE;
		}
		if (_tmp125_) {
			ValaSymbol* _tmp128_;
			ValaDataType* _tmp129_;
			ValaDataType* _tmp130_;
			ValaDataType* _tmp131_;
			_tmp128_ = symbol;
			_tmp129_ = vala_variable_get_variable_type (G_TYPE_CHECK_INSTANCE_CAST (_tmp128_, VALA_TYPE_VARIABLE, ValaVariable));
			_tmp130_ = _tmp129_;
			_tmp131_ = _vala_code_node_ref0 (_tmp130_);
			_vala_code_node_unref0 (data_type);
			data_type = _tmp131_;
		}
		_vala_code_node_unref0 (symbol);
		symbol = NULL;
	}
	_tmp132_ = lsp_hover_new ();
	if (_tmp132_) {
		g_object_set_data ((GObject *) _tmp132_, "vala-creation-function", "Vls.Server.hover._lambda65_");
	}
	hoverInfo = _tmp132_;
	symbol_range = NULL;
	_tmp133_ = symbol;
	if (_tmp133_ != NULL) {
		ValaCodeNode* _tmp134_;
		ValaSymbol* _tmp135_;
		LspRange* _tmp136_;
		LspRange* _tmp137_;
		_tmp134_ = _result_;
		_tmp135_ = symbol;
		_tmp136_ = vls_symbol_references_get_replacement_range (_tmp134_, _tmp135_);
		_g_object_unref0 (symbol_range);
		symbol_range = _tmp136_;
		_tmp137_ = symbol_range;
		if (_tmp137_ != NULL) {
			gboolean found_component = FALSE;
			LspRange* _tmp138_;
			LspPosition* _tmp139_;
			found_component = FALSE;
			_tmp138_ = symbol_range;
			_tmp139_ = pos;
			if (!lsp_range_contains (_tmp138_, _tmp139_)) {
				{
					GeeIterator* _component_it = NULL;
					ValaCodeNode* _tmp140_;
					GeeCollection* _tmp141_;
					GeeCollection* _tmp142_;
					GeeIterator* _tmp143_;
					GeeIterator* _tmp144_;
					_tmp140_ = _result_;
					_tmp141_ = vls_symbol_references_get_visible_components_of_code_node (_tmp140_);
					_tmp142_ = _tmp141_;
					_tmp143_ = gee_iterable_iterator ((GeeIterable*) _tmp142_);
					_tmp144_ = _tmp143_;
					_g_object_unref0 (_tmp142_);
					_component_it = _tmp144_;
					while (TRUE) {
						GeeIterator* _tmp145_;
						VlsPair* component = NULL;
						GeeIterator* _tmp146_;
						gpointer _tmp147_;
						VlsPair* _tmp148_;
						gconstpointer _tmp149_;
						gconstpointer _tmp150_;
						LspPosition* _tmp151_;
						_tmp145_ = _component_it;
						if (!gee_iterator_next (_tmp145_)) {
							break;
						}
						_tmp146_ = _component_it;
						_tmp147_ = gee_iterator_get (_tmp146_);
						component = (VlsPair*) _tmp147_;
						_tmp148_ = component;
						_tmp149_ = vls_pair_get_second (_tmp148_);
						_tmp150_ = _tmp149_;
						_tmp151_ = pos;
						if (lsp_range_contains ((LspRange*) _tmp150_, _tmp151_)) {
							LspHover* _tmp152_;
							VlsPair* _tmp153_;
							gconstpointer _tmp154_;
							gconstpointer _tmp155_;
							VlsPair* _tmp156_;
							gconstpointer _tmp157_;
							gconstpointer _tmp158_;
							ValaSymbol* _tmp159_;
							_tmp152_ = hoverInfo;
							_tmp153_ = component;
							_tmp154_ = vls_pair_get_second (_tmp153_);
							_tmp155_ = _tmp154_;
							lsp_hover_set_range (_tmp152_, (LspRange*) _tmp155_);
							_tmp156_ = component;
							_tmp157_ = vls_pair_get_first (_tmp156_);
							_tmp158_ = _tmp157_;
							_tmp159_ = _vala_code_node_ref0 ((ValaSymbol*) _tmp158_);
							_vala_code_node_unref0 (symbol);
							symbol = _tmp159_;
							_vala_code_node_unref0 (data_type);
							data_type = NULL;
							_vala_iterable_unref0 (method_type_arguments);
							method_type_arguments = NULL;
							found_component = TRUE;
							_g_object_unref0 (component);
							break;
						}
						_g_object_unref0 (component);
					}
					_g_object_unref0 (_component_it);
				}
			}
			if (!found_component) {
				LspHover* _tmp160_;
				LspRange* _tmp161_;
				_tmp160_ = hoverInfo;
				_tmp161_ = symbol_range;
				lsp_hover_set_range (_tmp160_, _tmp161_);
			}
		}
	}
	_tmp162_ = symbol_range;
	if (_tmp162_ == NULL) {
		LspHover* _tmp163_;
		ValaCodeNode* _tmp164_;
		ValaSourceReference* _tmp165_;
		ValaSourceReference* _tmp166_;
		LspRange* _tmp167_;
		LspRange* _tmp168_;
		_tmp163_ = hoverInfo;
		_tmp164_ = _result_;
		_tmp165_ = vala_code_node_get_source_reference (_tmp164_);
		_tmp166_ = _tmp165_;
		_tmp167_ = lsp_range_new_from_sourceref (_tmp166_);
		if (_tmp167_) {
			g_object_set_data ((GObject *) _tmp167_, "vala-creation-function", "Vls.Server.hover._lambda65_");
		}
		_tmp168_ = _tmp167_;
		lsp_hover_set_range (_tmp163_, _tmp168_);
		_g_object_unref0 (_tmp168_);
	}
	_tmp169_ = data_type;
	_tmp170_ = symbol;
	_tmp171_ = scope;
	_tmp172_ = method_type_arguments;
	_tmp173_ = vls_code_help_get_symbol_representation (_tmp169_, _tmp170_, _tmp171_, TRUE, _tmp172_, NULL, TRUE, FALSE, NULL, TRUE);
	representation = _tmp173_;
	_tmp174_ = representation;
	if (_tmp174_ != NULL) {
		LspHover* _tmp175_;
		GeeList* _tmp176_;
		GeeList* _tmp177_;
		gchar* _tmp178_;
		const gchar* _tmp179_;
		gchar* _tmp180_;
		LspMarkedString* _tmp181_ = NULL;
		LspMarkedString* _tmp182_;
		ValaSymbol* _tmp183_;
		_tmp175_ = hoverInfo;
		_tmp176_ = lsp_hover_get_contents (_tmp175_);
		_tmp177_ = _tmp176_;
		_tmp178_ = g_strdup ("vala");
		_tmp179_ = representation;
		_tmp180_ = g_strdup (_tmp179_);
		_tmp181_ = lsp_marked_string_new ();
		lsp_marked_string_set_language (_tmp181_, _tmp178_);
		_g_free0 (_tmp178_);
		lsp_marked_string_set_value (_tmp181_, _tmp180_);
		_g_free0 (_tmp180_);
		_tmp182_ = _tmp181_;
		gee_collection_add ((GeeCollection*) _tmp177_, _tmp182_);
		_g_object_unref0 (_tmp182_);
		_tmp183_ = symbol;
		if (_tmp183_ != NULL) {
			VlsDocComment* comment = NULL;
			VlsProject* _tmp184_;
			ValaSymbol* _tmp185_;
			VlsDocComment* _tmp186_;
			VlsDocComment* _tmp187_;
			_tmp184_ = project;
			_tmp185_ = symbol;
			_tmp186_ = vls_server_get_symbol_documentation (self, _tmp184_, _tmp185_);
			comment = _tmp186_;
			_tmp187_ = comment;
			if (_tmp187_ != NULL) {
				LspHover* _tmp188_;
				GeeList* _tmp189_;
				GeeList* _tmp190_;
				VlsDocComment* _tmp191_;
				const gchar* _tmp192_;
				const gchar* _tmp193_;
				gchar* _tmp194_;
				LspMarkedString* _tmp195_ = NULL;
				LspMarkedString* _tmp196_;
				_tmp188_ = hoverInfo;
				_tmp189_ = lsp_hover_get_contents (_tmp188_);
				_tmp190_ = _tmp189_;
				_tmp191_ = comment;
				_tmp192_ = vls_doc_comment_get_body (_tmp191_);
				_tmp193_ = _tmp192_;
				_tmp194_ = g_strdup (_tmp193_);
				_tmp195_ = lsp_marked_string_new ();
				lsp_marked_string_set_value (_tmp195_, _tmp194_);
				_g_free0 (_tmp194_);
				_tmp196_ = _tmp195_;
				gee_collection_add ((GeeCollection*) _tmp190_, _tmp196_);
				_g_object_unref0 (_tmp196_);
			}
			_vls_doc_comment_unref0 (comment);
		}
	}
	{
		GVariant* _tmp197_ = NULL;
		LspHover* _tmp198_;
		GVariant* _tmp199_;
		GCancellable* _tmp200_;
		_tmp198_ = hoverInfo;
		_tmp199_ = vls_util_object_to_variant ((GObject*) _tmp198_, &_inner_error0_);
		_tmp197_ = _tmp199_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp200_ = vls_server_cancellable;
		jsonrpc_client_reply (_data33_->client, _data33_->id, _tmp197_, _tmp200_, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_variant_unref0 (_tmp197_);
			goto __catch0_g_error;
		}
		_g_variant_unref0 (_tmp197_);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp201_;
		const gchar* _tmp202_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp201_ = e;
		_tmp202_ = _tmp201_->message;
		g_warning ("server.vala:1372: [%s] failed to reply to client: %s", _data33_->method, _tmp202_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_free0 (representation);
		_g_object_unref0 (symbol_range);
		_g_object_unref0 (hoverInfo);
		_vala_code_node_unref0 (symbol);
		_vala_iterable_unref0 (method_type_arguments);
		_vala_code_node_unref0 (data_type);
		_vala_code_node_unref0 (_result_);
		_vala_scope_unref0 (scope);
		_vala_code_visitor_unref0 (fs);
		_vala_source_file_unref0 (doc);
		_g_object_unref0 (project);
		_g_object_unref0 (compilation);
		_g_object_unref0 (pos);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	vala_code_context_pop ();
	_g_free0 (representation);
	_g_object_unref0 (symbol_range);
	_g_object_unref0 (hoverInfo);
	_vala_code_node_unref0 (symbol);
	_vala_iterable_unref0 (method_type_arguments);
	_vala_code_node_unref0 (data_type);
	_vala_code_node_unref0 (_result_);
	_vala_scope_unref0 (scope);
	_vala_code_visitor_unref0 (fs);
	_vala_source_file_unref0 (doc);
	_g_object_unref0 (project);
	_g_object_unref0 (compilation);
	_g_object_unref0 (pos);
}

static void
___lambda65__vls_server_on_context_updated_func (gboolean request_cancelled,
                                                 gpointer self)
{
	__lambda65_ (self, request_cancelled);
}

static void
vls_server_hover (VlsServer* self,
                  JsonrpcClient* client,
                  const gchar* method,
                  GVariant* id,
                  GVariant* params)
{
	Block33Data* _data33_;
	JsonrpcClient* _tmp0_;
	gchar* _tmp1_;
	GVariant* _tmp2_;
	gpointer _tmp3_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (client != NULL);
	g_return_if_fail (method != NULL);
	g_return_if_fail (id != NULL);
	g_return_if_fail (params != NULL);
	_data33_ = g_slice_new0 (Block33Data);
	_data33_->_ref_count_ = 1;
	_data33_->self = g_object_ref (self);
	_tmp0_ = _g_object_ref0 (client);
	_g_object_unref0 (_data33_->client);
	_data33_->client = _tmp0_;
	_tmp1_ = g_strdup (method);
	_g_free0 (_data33_->method);
	_data33_->method = _tmp1_;
	_tmp2_ = _g_variant_ref0 (id);
	_g_variant_unref0 (_data33_->id);
	_data33_->id = _tmp2_;
	_tmp3_ = vls_util_parse_variant (LSP_TYPE_TEXT_DOCUMENT_POSITION_PARAMS, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, params);
	_data33_->p = (LspTextDocumentPositionParams*) _tmp3_;
	vls_server_wait_for_context_update (self, _data33_->id, ___lambda65__vls_server_on_context_updated_func, block33_data_ref (_data33_), block33_data_unref);
	block33_data_unref (_data33_);
	_data33_ = NULL;
}

static LspDocumentHighlightKind
vls_server_determine_node_highlight_kind (VlsServer* self,
                                          ValaCodeNode* node)
{
	ValaCodeNode* previous_node = NULL;
	ValaCodeNode* _tmp0_;
	LspDocumentHighlightKind result;
	g_return_val_if_fail (self != NULL, LSP_DOCUMENT_HIGHLIGHT_KIND_Text);
	g_return_val_if_fail (node != NULL, LSP_DOCUMENT_HIGHLIGHT_KIND_Text);
	_tmp0_ = _vala_code_node_ref0 (node);
	previous_node = _tmp0_;
	{
		ValaCodeNode* current_node = NULL;
		ValaCodeNode* _tmp1_;
		ValaCodeNode* _tmp2_;
		ValaCodeNode* _tmp3_;
		_tmp1_ = vala_code_node_get_parent_node (node);
		_tmp2_ = _tmp1_;
		_tmp3_ = _vala_code_node_ref0 (_tmp2_);
		current_node = _tmp3_;
		{
			gboolean _tmp4_ = FALSE;
			_tmp4_ = TRUE;
			while (TRUE) {
				ValaCodeNode* _tmp11_;
				ValaCodeNode* _tmp12_;
				if (!_tmp4_) {
					ValaCodeNode* _tmp5_;
					ValaCodeNode* _tmp6_;
					ValaCodeNode* _tmp7_;
					ValaCodeNode* _tmp8_;
					ValaCodeNode* _tmp9_;
					ValaCodeNode* _tmp10_;
					_tmp5_ = current_node;
					_tmp6_ = vala_code_node_get_parent_node (_tmp5_);
					_tmp7_ = _tmp6_;
					_tmp8_ = _vala_code_node_ref0 (_tmp7_);
					_vala_code_node_unref0 (current_node);
					current_node = _tmp8_;
					_tmp9_ = current_node;
					_tmp10_ = _vala_code_node_ref0 (_tmp9_);
					_vala_code_node_unref0 (previous_node);
					previous_node = _tmp10_;
				}
				_tmp4_ = FALSE;
				_tmp11_ = current_node;
				if (!(_tmp11_ != NULL)) {
					break;
				}
				_tmp12_ = current_node;
				if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp12_, VALA_TYPE_METHOD_CALL)) {
					result = LSP_DOCUMENT_HIGHLIGHT_KIND_Read;
					_vala_code_node_unref0 (current_node);
					_vala_code_node_unref0 (previous_node);
					return result;
				} else {
					ValaCodeNode* _tmp13_;
					_tmp13_ = current_node;
					if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp13_, VALA_TYPE_ASSIGNMENT)) {
						ValaCodeNode* _tmp14_;
						ValaCodeNode* _tmp15_;
						ValaExpression* _tmp16_;
						ValaExpression* _tmp17_;
						_tmp14_ = previous_node;
						_tmp15_ = current_node;
						_tmp16_ = vala_assignment_get_left (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, VALA_TYPE_ASSIGNMENT, ValaAssignment));
						_tmp17_ = _tmp16_;
						if (_tmp14_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, VALA_TYPE_CODE_NODE, ValaCodeNode)) {
							result = LSP_DOCUMENT_HIGHLIGHT_KIND_Write;
							_vala_code_node_unref0 (current_node);
							_vala_code_node_unref0 (previous_node);
							return result;
						} else {
							ValaCodeNode* _tmp18_;
							ValaCodeNode* _tmp19_;
							ValaExpression* _tmp20_;
							ValaExpression* _tmp21_;
							_tmp18_ = previous_node;
							_tmp19_ = current_node;
							_tmp20_ = vala_assignment_get_right (G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, VALA_TYPE_ASSIGNMENT, ValaAssignment));
							_tmp21_ = _tmp20_;
							if (_tmp18_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, VALA_TYPE_CODE_NODE, ValaCodeNode)) {
								result = LSP_DOCUMENT_HIGHLIGHT_KIND_Read;
								_vala_code_node_unref0 (current_node);
								_vala_code_node_unref0 (previous_node);
								return result;
							}
						}
					} else {
						gboolean _tmp22_ = FALSE;
						ValaCodeNode* _tmp23_;
						_tmp23_ = current_node;
						if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp23_, VALA_TYPE_DECLARATION_STATEMENT)) {
							ValaCodeNode* _tmp24_;
							ValaSymbol* _tmp25_;
							ValaSymbol* _tmp26_;
							_tmp24_ = current_node;
							_tmp25_ = vala_declaration_statement_get_declaration (G_TYPE_CHECK_INSTANCE_CAST (_tmp24_, VALA_TYPE_DECLARATION_STATEMENT, ValaDeclarationStatement));
							_tmp26_ = _tmp25_;
							_tmp22_ = node == G_TYPE_CHECK_INSTANCE_CAST (_tmp26_, VALA_TYPE_CODE_NODE, ValaCodeNode);
						} else {
							_tmp22_ = FALSE;
						}
						if (_tmp22_) {
							result = LSP_DOCUMENT_HIGHLIGHT_KIND_Write;
							_vala_code_node_unref0 (current_node);
							_vala_code_node_unref0 (previous_node);
							return result;
						} else {
							gboolean _tmp27_ = FALSE;
							ValaCodeNode* _tmp28_;
							_tmp28_ = current_node;
							if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp28_, VALA_TYPE_FOREACH_STATEMENT)) {
								ValaCodeNode* _tmp29_;
								ValaLocalVariable* _tmp30_;
								ValaLocalVariable* _tmp31_;
								_tmp29_ = current_node;
								_tmp30_ = vala_foreach_statement_get_element_variable (G_TYPE_CHECK_INSTANCE_CAST (_tmp29_, VALA_TYPE_FOREACH_STATEMENT, ValaForeachStatement));
								_tmp31_ = _tmp30_;
								_tmp27_ = node == G_TYPE_CHECK_INSTANCE_CAST (_tmp31_, VALA_TYPE_CODE_NODE, ValaCodeNode);
							} else {
								_tmp27_ = FALSE;
							}
							if (_tmp27_) {
								result = LSP_DOCUMENT_HIGHLIGHT_KIND_Write;
								_vala_code_node_unref0 (current_node);
								_vala_code_node_unref0 (previous_node);
								return result;
							} else {
								ValaCodeNode* _tmp32_;
								_tmp32_ = current_node;
								if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp32_, VALA_TYPE_STATEMENT)) {
									result = LSP_DOCUMENT_HIGHLIGHT_KIND_Read;
									_vala_code_node_unref0 (current_node);
									_vala_code_node_unref0 (previous_node);
									return result;
								}
							}
						}
					}
				}
			}
		}
		_vala_code_node_unref0 (current_node);
	}
	result = LSP_DOCUMENT_HIGHLIGHT_KIND_Text;
	_vala_code_node_unref0 (previous_node);
	return result;
}

static Block34Data*
block34_data_ref (Block34Data* _data34_)
{
	g_atomic_int_inc (&_data34_->_ref_count_);
	return _data34_;
}

static void
block34_data_unref (void * _userdata_)
{
	Block34Data* _data34_;
	_data34_ = (Block34Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data34_->_ref_count_)) {
		VlsServer* self;
		self = _data34_->self;
		_g_object_unref0 (_data34_->p);
		_g_object_unref0 (_data34_->client);
		_g_free0 (_data34_->method);
		_g_variant_unref0 (_data34_->id);
		_g_object_unref0 (self);
		g_slice_free (Block34Data, _data34_);
	}
}

static void
__lambda66_ (Block34Data* _data34_,
             gboolean request_cancelled)
{
	VlsServer* self;
	gboolean is_highlight = FALSE;
	gboolean _tmp0_ = FALSE;
	LspReferenceParamsReferenceContext* _tmp1_;
	LspReferenceParamsReferenceContext* _tmp2_;
	gboolean include_declaration = FALSE;
	LspPosition* pos = NULL;
	LspPosition* _tmp7_;
	LspPosition* _tmp8_;
	LspPosition* _tmp9_;
	VlsCompilation* compilation = NULL;
	VlsProject* project = NULL;
	ValaSourceFile* doc = NULL;
	LspTextDocumentIdentifier* _tmp10_;
	LspTextDocumentIdentifier* _tmp11_;
	const gchar* _tmp12_;
	const gchar* _tmp13_;
	VlsCompilation* _tmp14_ = NULL;
	VlsProject* _tmp15_ = NULL;
	ValaSourceFile* _tmp16_;
	ValaSourceFile* _tmp17_;
	VlsCompilation* _tmp22_;
	ValaCodeContext* _tmp23_;
	ValaCodeContext* _tmp24_;
	VlsNodeSearch* fs = NULL;
	ValaSourceFile* _tmp25_;
	LspPosition* _tmp26_;
	VlsNodeSearch* _tmp27_;
	VlsNodeSearch* _tmp28_;
	GeeList* _tmp29_;
	gint _tmp30_;
	gint _tmp31_;
	ValaCodeNode* _result_ = NULL;
	VlsNodeSearch* _tmp35_;
	ValaSourceFile* _tmp36_;
	ValaCodeNode* _tmp37_;
	ValaSymbol* symbol = NULL;
	JsonArray* json_array = NULL;
	JsonArray* _tmp38_;
	GeeHashMap* references = NULL;
	GeeHashMap* _tmp39_;
	gboolean _tmp40_ = FALSE;
	ValaCodeNode* _tmp41_;
	gboolean _tmp61_ = FALSE;
	ValaCodeNode* _tmp62_;
	ValaCodeNode* _tmp68_;
	ValaSymbol* _tmp69_;
	const gchar* _tmp70_;
	ValaCodeNode* _tmp71_;
	gchar* _tmp72_;
	gchar* _tmp73_;
	ValaCodeNode* _tmp74_;
	const gchar* _tmp75_;
	const gchar* _tmp76_;
	const gchar* _tmp77_;
	gchar* _tmp78_;
	gchar* _tmp79_;
	gboolean _tmp80_ = FALSE;
	const gchar* _tmp138_;
	GeeHashMap* _tmp139_;
	gint _tmp140_;
	gint _tmp141_;
	gchar* _tmp142_;
	gchar* _tmp143_;
	gchar* _tmp144_;
	gchar* _tmp145_;
	GError* _inner_error0_ = NULL;
	self = _data34_->self;
	if (request_cancelled) {
		vls_server_reply_null (_data34_->id, _data34_->client, _data34_->method);
		return;
	}
	is_highlight = g_strcmp0 (_data34_->method, "textDocument/documentHighlight") == 0;
	_tmp1_ = lsp_reference_params_get_context (_data34_->p);
	_tmp2_ = _tmp1_;
	if (_tmp2_ != NULL) {
		LspReferenceParamsReferenceContext* _tmp3_;
		LspReferenceParamsReferenceContext* _tmp4_;
		gboolean _tmp5_;
		gboolean _tmp6_;
		_tmp3_ = lsp_reference_params_get_context (_data34_->p);
		_tmp4_ = _tmp3_;
		_tmp5_ = lsp_reference_params_reference_context_get_includeDeclaration (_tmp4_);
		_tmp6_ = _tmp5_;
		_tmp0_ = _tmp6_;
	} else {
		_tmp0_ = TRUE;
	}
	include_declaration = _tmp0_;
	_tmp7_ = lsp_text_document_position_params_get_position ((LspTextDocumentPositionParams*) _data34_->p);
	_tmp8_ = _tmp7_;
	_tmp9_ = _g_object_ref0 (_tmp8_);
	pos = _tmp9_;
	_tmp10_ = lsp_text_document_position_params_get_textDocument ((LspTextDocumentPositionParams*) _data34_->p);
	_tmp11_ = _tmp10_;
	_tmp12_ = lsp_text_document_identifier_get_uri (_tmp11_);
	_tmp13_ = _tmp12_;
	_tmp16_ = vls_server_find_file (self, _tmp13_, &_tmp14_, &_tmp15_);
	_g_object_unref0 (compilation);
	compilation = _tmp14_;
	_g_object_unref0 (project);
	project = _tmp15_;
	doc = _tmp16_;
	_tmp17_ = doc;
	if (_tmp17_ == NULL) {
		LspTextDocumentIdentifier* _tmp18_;
		LspTextDocumentIdentifier* _tmp19_;
		const gchar* _tmp20_;
		const gchar* _tmp21_;
		_tmp18_ = lsp_text_document_position_params_get_textDocument ((LspTextDocumentPositionParams*) _data34_->p);
		_tmp19_ = _tmp18_;
		_tmp20_ = lsp_text_document_identifier_get_uri (_tmp19_);
		_tmp21_ = _tmp20_;
		g_debug ("server.vala:1423: [%s] file `%s' not found", _data34_->method, _tmp21_);
		vls_server_reply_null (_data34_->id, _data34_->client, _data34_->method);
		_vala_source_file_unref0 (doc);
		_g_object_unref0 (project);
		_g_object_unref0 (compilation);
		_g_object_unref0 (pos);
		return;
	}
	_tmp22_ = compilation;
	_tmp23_ = vls_compilation_get_code_context (_tmp22_);
	_tmp24_ = _tmp23_;
	vala_code_context_push (_tmp24_);
	_tmp25_ = doc;
	_tmp26_ = pos;
	_tmp27_ = vls_node_search_new (_tmp25_, _tmp26_, TRUE, NULL, TRUE);
	fs = _tmp27_;
	_tmp28_ = fs;
	_tmp29_ = _tmp28_->result;
	_tmp30_ = gee_collection_get_size ((GeeCollection*) _tmp29_);
	_tmp31_ = _tmp30_;
	if (_tmp31_ == 0) {
		const gchar* _tmp32_;
		gchar* _tmp33_;
		gchar* _tmp34_;
		_tmp32_ = string_to_string (_data34_->method);
		_tmp33_ = g_strconcat ("[", _tmp32_, "] no results found", NULL);
		_tmp34_ = _tmp33_;
		g_debug ("server.vala:1433: %s", _tmp34_);
		_g_free0 (_tmp34_);
		vls_server_reply_null (_data34_->id, _data34_->client, _data34_->method);
		vala_code_context_pop ();
		_vala_code_visitor_unref0 (fs);
		_vala_source_file_unref0 (doc);
		_g_object_unref0 (project);
		_g_object_unref0 (compilation);
		_g_object_unref0 (pos);
		return;
	}
	_tmp35_ = fs;
	_tmp36_ = doc;
	_tmp37_ = vls_server_get_best (_tmp35_, _tmp36_);
	_result_ = _tmp37_;
	_tmp38_ = json_array_new ();
	json_array = _tmp38_;
	_tmp39_ = gee_hash_map_new (LSP_TYPE_RANGE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, VALA_TYPE_CODE_NODE, (GBoxedCopyFunc) vala_code_node_ref, (GDestroyNotify) vala_code_node_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	if (_tmp39_) {
		g_object_set_data ((GObject *) _tmp39_, "vala-creation-function", "Vls.Server.show_references._lambda66_");
	}
	references = _tmp39_;
	_tmp41_ = _result_;
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp41_, VALA_TYPE_EXPRESSION)) {
		ValaCodeNode* _tmp42_;
		ValaSymbol* _tmp43_;
		ValaSymbol* _tmp44_;
		_tmp42_ = _result_;
		_tmp43_ = vala_expression_get_symbol_reference (G_TYPE_CHECK_INSTANCE_CAST (_tmp42_, VALA_TYPE_EXPRESSION, ValaExpression));
		_tmp44_ = _tmp43_;
		_tmp40_ = _tmp44_ != NULL;
	} else {
		_tmp40_ = FALSE;
	}
	if (_tmp40_) {
		ValaCodeNode* _tmp45_;
		ValaSymbol* _tmp46_;
		ValaSymbol* _tmp47_;
		ValaCodeNode* _tmp48_;
		_tmp45_ = _result_;
		_tmp46_ = vala_expression_get_symbol_reference (G_TYPE_CHECK_INSTANCE_CAST (_tmp45_, VALA_TYPE_EXPRESSION, ValaExpression));
		_tmp47_ = _tmp46_;
		_tmp48_ = _vala_code_node_ref0 ((ValaCodeNode*) _tmp47_);
		_vala_code_node_unref0 (_result_);
		_result_ = _tmp48_;
	} else {
		ValaCodeNode* _tmp49_;
		_tmp49_ = _result_;
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp49_, VALA_TYPE_DATA_TYPE)) {
			ValaCodeNode* _tmp50_;
			ValaSymbol* _tmp51_;
			_tmp50_ = _result_;
			_tmp51_ = vls_symbol_references_get_symbol_data_type_refers_to (G_TYPE_CHECK_INSTANCE_CAST (_tmp50_, VALA_TYPE_DATA_TYPE, ValaDataType));
			_vala_code_node_unref0 (_result_);
			_result_ = (ValaCodeNode*) _tmp51_;
		} else {
			gboolean _tmp52_ = FALSE;
			ValaCodeNode* _tmp53_;
			_tmp53_ = _result_;
			if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp53_, VALA_TYPE_USING_DIRECTIVE)) {
				ValaCodeNode* _tmp54_;
				ValaSymbol* _tmp55_;
				ValaSymbol* _tmp56_;
				_tmp54_ = _result_;
				_tmp55_ = vala_using_directive_get_namespace_symbol (G_TYPE_CHECK_INSTANCE_CAST (_tmp54_, VALA_TYPE_USING_DIRECTIVE, ValaUsingDirective));
				_tmp56_ = _tmp55_;
				_tmp52_ = _tmp56_ != NULL;
			} else {
				_tmp52_ = FALSE;
			}
			if (_tmp52_) {
				ValaCodeNode* _tmp57_;
				ValaSymbol* _tmp58_;
				ValaSymbol* _tmp59_;
				ValaCodeNode* _tmp60_;
				_tmp57_ = _result_;
				_tmp58_ = vala_using_directive_get_namespace_symbol (G_TYPE_CHECK_INSTANCE_CAST (_tmp57_, VALA_TYPE_USING_DIRECTIVE, ValaUsingDirective));
				_tmp59_ = _tmp58_;
				_tmp60_ = _vala_code_node_ref0 ((ValaCodeNode*) _tmp59_);
				_vala_code_node_unref0 (_result_);
				_result_ = _tmp60_;
			}
		}
	}
	_tmp62_ = _result_;
	if (!G_TYPE_CHECK_INSTANCE_TYPE (_tmp62_, VALA_TYPE_SYMBOL)) {
		_tmp61_ = TRUE;
	} else {
		gboolean _tmp63_ = FALSE;
		ValaCodeNode* _tmp64_;
		_tmp64_ = _result_;
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp64_, VALA_TYPE_METHOD)) {
			ValaCodeNode* _tmp65_;
			gboolean _tmp66_;
			gboolean _tmp67_;
			_tmp65_ = _result_;
			_tmp66_ = vala_method_get_closure (G_TYPE_CHECK_INSTANCE_CAST (_tmp65_, VALA_TYPE_METHOD, ValaMethod));
			_tmp67_ = _tmp66_;
			_tmp63_ = _tmp67_;
		} else {
			_tmp63_ = FALSE;
		}
		_tmp61_ = _tmp63_;
	}
	if (_tmp61_) {
		vls_server_reply_null (_data34_->id, _data34_->client, _data34_->method);
		vala_code_context_pop ();
		_g_object_unref0 (references);
		_json_array_unref0 (json_array);
		_vala_code_node_unref0 (symbol);
		_vala_code_node_unref0 (_result_);
		_vala_code_visitor_unref0 (fs);
		_vala_source_file_unref0 (doc);
		_g_object_unref0 (project);
		_g_object_unref0 (compilation);
		_g_object_unref0 (pos);
		return;
	}
	_tmp68_ = _result_;
	_tmp69_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp68_, VALA_TYPE_SYMBOL, ValaSymbol));
	_vala_code_node_unref0 (symbol);
	symbol = _tmp69_;
	_tmp70_ = string_to_string (_data34_->method);
	_tmp71_ = _result_;
	_tmp72_ = vala_code_node_to_string (_tmp71_);
	_tmp73_ = _tmp72_;
	_tmp74_ = _result_;
	_tmp75_ = vala_code_node_get_type_name (_tmp74_);
	_tmp76_ = _tmp75_;
	_tmp77_ = string_to_string (_tmp76_);
	_tmp78_ = g_strconcat ("[", _tmp70_, "] got best: ", _tmp73_, " (", _tmp77_, ")", NULL);
	_tmp79_ = _tmp78_;
	g_debug ("server.vala:1461: %s", _tmp79_);
	_g_free0 (_tmp79_);
	_g_free0 (_tmp73_);
	if (is_highlight) {
		_tmp80_ = TRUE;
	} else {
		ValaSymbol* _tmp81_;
		_tmp81_ = symbol;
		_tmp80_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp81_, VALA_TYPE_LOCAL_VARIABLE);
	}
	if (_tmp80_) {
		ValaSourceFile* _tmp82_;
		ValaSymbol* _tmp83_;
		GeeHashMap* _tmp84_;
		_tmp82_ = doc;
		_tmp83_ = symbol;
		_tmp84_ = references;
		vls_symbol_references_list_in_file (_tmp82_, _tmp83_, include_declaration, TRUE, _tmp84_);
	} else {
		GeeHashSet* generated_vapis = NULL;
		GeeHashSet* _tmp85_;
		GeeHashSet* shown_files = NULL;
		GeeHashSet* _tmp99_;
		_tmp85_ = gee_hash_set_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _vls_util_file_hash_gee_hash_data_func, NULL, NULL, _vls_util_file_equal_gee_equal_data_func, NULL, NULL);
		if (_tmp85_) {
			g_object_set_data ((GObject *) _tmp85_, "vala-creation-function", "Vls.Server.show_references._lambda66_");
		}
		generated_vapis = _tmp85_;
		{
			GeeArrayList* _btarget_list = NULL;
			VlsProject* _tmp86_;
			GeeArrayList* _tmp87_;
			gint _btarget_size = 0;
			GeeArrayList* _tmp88_;
			gint _tmp89_;
			gint _tmp90_;
			gint _btarget_index = 0;
			_tmp86_ = project;
			_tmp87_ = vls_project_get_compilations (_tmp86_);
			_btarget_list = _tmp87_;
			_tmp88_ = _btarget_list;
			_tmp89_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp88_);
			_tmp90_ = _tmp89_;
			_btarget_size = _tmp90_;
			_btarget_index = -1;
			while (TRUE) {
				gint _tmp91_;
				gint _tmp92_;
				VlsCompilation* btarget = NULL;
				GeeArrayList* _tmp93_;
				gpointer _tmp94_;
				GeeHashSet* _tmp95_;
				VlsCompilation* _tmp96_;
				GeeArrayList* _tmp97_;
				GeeArrayList* _tmp98_;
				_btarget_index = _btarget_index + 1;
				_tmp91_ = _btarget_index;
				_tmp92_ = _btarget_size;
				if (!(_tmp91_ < _tmp92_)) {
					break;
				}
				_tmp93_ = _btarget_list;
				_tmp94_ = gee_abstract_list_get ((GeeAbstractList*) _tmp93_, _btarget_index);
				btarget = (VlsCompilation*) _tmp94_;
				_tmp95_ = generated_vapis;
				_tmp96_ = btarget;
				_tmp97_ = vls_build_target_get_output ((VlsBuildTarget*) _tmp96_);
				_tmp98_ = _tmp97_;
				gee_collection_add_all ((GeeCollection*) _tmp95_, (GeeCollection*) _tmp98_);
				_g_object_unref0 (btarget);
			}
			_g_object_unref0 (_btarget_list);
		}
		_tmp99_ = gee_hash_set_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _vls_util_file_hash_gee_hash_data_func, NULL, NULL, _vls_util_file_equal_gee_equal_data_func, NULL, NULL);
		if (_tmp99_) {
			g_object_set_data ((GObject *) _tmp99_, "vala-creation-function", "Vls.Server.show_references._lambda66_");
		}
		shown_files = _tmp99_;
		{
			GeeIterator* _btarget_w_sym_it = NULL;
			VlsProject* _tmp100_;
			ValaSymbol* _tmp101_;
			GeeCollection* _tmp102_;
			GeeCollection* _tmp103_;
			GeeIterator* _tmp104_;
			GeeIterator* _tmp105_;
			_tmp100_ = project;
			_tmp101_ = symbol;
			_tmp102_ = vls_symbol_references_get_compilations_using_symbol (_tmp100_, _tmp101_);
			_tmp103_ = _tmp102_;
			_tmp104_ = gee_iterable_iterator ((GeeIterable*) _tmp103_);
			_tmp105_ = _tmp104_;
			_g_object_unref0 (_tmp103_);
			_btarget_w_sym_it = _tmp105_;
			while (TRUE) {
				GeeIterator* _tmp106_;
				VlsPair* btarget_w_sym = NULL;
				GeeIterator* _tmp107_;
				gpointer _tmp108_;
				_tmp106_ = _btarget_w_sym_it;
				if (!gee_iterator_next (_tmp106_)) {
					break;
				}
				_tmp107_ = _btarget_w_sym_it;
				_tmp108_ = gee_iterator_get (_tmp107_);
				btarget_w_sym = (VlsPair*) _tmp108_;
				{
					ValaList* _project_file_list = NULL;
					VlsPair* _tmp109_;
					gconstpointer _tmp110_;
					gconstpointer _tmp111_;
					ValaCodeContext* _tmp112_;
					ValaCodeContext* _tmp113_;
					ValaList* _tmp114_;
					gint _project_file_size = 0;
					ValaList* _tmp115_;
					gint _tmp116_;
					gint _tmp117_;
					gint _project_file_index = 0;
					_tmp109_ = btarget_w_sym;
					_tmp110_ = vls_pair_get_first (_tmp109_);
					_tmp111_ = _tmp110_;
					_tmp112_ = vls_compilation_get_code_context ((VlsCompilation*) _tmp111_);
					_tmp113_ = _tmp112_;
					_tmp114_ = vala_code_context_get_source_files (_tmp113_);
					_project_file_list = _tmp114_;
					_tmp115_ = _project_file_list;
					_tmp116_ = vala_collection_get_size ((ValaCollection*) _tmp115_);
					_tmp117_ = _tmp116_;
					_project_file_size = _tmp117_;
					_project_file_index = -1;
					while (TRUE) {
						gint _tmp118_;
						gint _tmp119_;
						ValaSourceFile* project_file = NULL;
						ValaList* _tmp120_;
						gpointer _tmp121_;
						GFile* file = NULL;
						ValaSourceFile* _tmp122_;
						const gchar* _tmp123_;
						const gchar* _tmp124_;
						GFile* _tmp125_;
						gboolean _tmp126_ = FALSE;
						GeeHashSet* _tmp127_;
						GFile* _tmp128_;
						ValaSourceFile* _tmp131_;
						VlsPair* _tmp132_;
						gconstpointer _tmp133_;
						gconstpointer _tmp134_;
						GeeHashMap* _tmp135_;
						GeeHashSet* _tmp136_;
						GFile* _tmp137_;
						_project_file_index = _project_file_index + 1;
						_tmp118_ = _project_file_index;
						_tmp119_ = _project_file_size;
						if (!(_tmp118_ < _tmp119_)) {
							break;
						}
						_tmp120_ = _project_file_list;
						_tmp121_ = vala_list_get (_tmp120_, _project_file_index);
						project_file = (ValaSourceFile*) _tmp121_;
						_tmp122_ = project_file;
						_tmp123_ = vala_source_file_get_filename (_tmp122_);
						_tmp124_ = _tmp123_;
						_tmp125_ = g_file_new_for_commandline_arg (_tmp124_);
						file = _tmp125_;
						_tmp127_ = generated_vapis;
						_tmp128_ = file;
						if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp127_, _tmp128_)) {
							_tmp126_ = TRUE;
						} else {
							GeeHashSet* _tmp129_;
							GFile* _tmp130_;
							_tmp129_ = shown_files;
							_tmp130_ = file;
							_tmp126_ = gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp129_, _tmp130_);
						}
						if (_tmp126_) {
							_g_object_unref0 (file);
							_vala_source_file_unref0 (project_file);
							continue;
						}
						_tmp131_ = project_file;
						_tmp132_ = btarget_w_sym;
						_tmp133_ = vls_pair_get_second (_tmp132_);
						_tmp134_ = _tmp133_;
						_tmp135_ = references;
						vls_symbol_references_list_in_file (_tmp131_, (ValaSymbol*) _tmp134_, include_declaration, TRUE, _tmp135_);
						_tmp136_ = shown_files;
						_tmp137_ = file;
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp136_, _tmp137_);
						_g_object_unref0 (file);
						_vala_source_file_unref0 (project_file);
					}
				}
				_g_object_unref0 (btarget_w_sym);
			}
			_g_object_unref0 (_btarget_w_sym_it);
		}
		_g_object_unref0 (shown_files);
		_g_object_unref0 (generated_vapis);
	}
	_tmp138_ = string_to_string (_data34_->method);
	_tmp139_ = references;
	_tmp140_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp139_);
	_tmp141_ = _tmp140_;
	_tmp142_ = g_strdup_printf ("%i", _tmp141_);
	_tmp143_ = _tmp142_;
	_tmp144_ = g_strconcat ("[", _tmp138_, "] found ", _tmp143_, " reference(s)", NULL);
	_tmp145_ = _tmp144_;
	g_debug ("server.vala:1484: %s", _tmp145_);
	_g_free0 (_tmp145_);
	_g_free0 (_tmp143_);
	{
		GeeIterator* _entry_it = NULL;
		GeeHashMap* _tmp146_;
		GeeIterator* _tmp147_;
		_tmp146_ = references;
		_tmp147_ = gee_iterable_iterator ((GeeIterable*) _tmp146_);
		_entry_it = _tmp147_;
		while (TRUE) {
			GeeIterator* _tmp148_;
			GeeMapEntry* entry = NULL;
			GeeIterator* _tmp149_;
			gpointer _tmp150_;
			_tmp148_ = _entry_it;
			if (!gee_iterator_next (_tmp148_)) {
				break;
			}
			_tmp149_ = _entry_it;
			_tmp150_ = gee_iterator_get (_tmp149_);
			entry = (GeeMapEntry*) _tmp150_;
			if (is_highlight) {
				JsonArray* _tmp151_;
				GeeMapEntry* _tmp152_;
				gconstpointer _tmp153_;
				gconstpointer _tmp154_;
				LspRange* _tmp155_;
				GeeMapEntry* _tmp156_;
				gconstpointer _tmp157_;
				gconstpointer _tmp158_;
				LspDocumentHighlight* _tmp159_ = NULL;
				LspDocumentHighlight* _tmp160_;
				JsonNode* _tmp161_;
				_tmp151_ = json_array;
				_tmp152_ = entry;
				_tmp153_ = gee_map_entry_get_key (_tmp152_);
				_tmp154_ = _tmp153_;
				_tmp155_ = _g_object_ref0 ((LspRange*) _tmp154_);
				_tmp156_ = entry;
				_tmp157_ = gee_map_entry_get_value (_tmp156_);
				_tmp158_ = _tmp157_;
				_tmp159_ = lsp_document_highlight_new ();
				lsp_document_highlight_set_range (_tmp159_, _tmp155_);
				_g_object_unref0 (_tmp155_);
				lsp_document_highlight_set_kind (_tmp159_, vls_server_determine_node_highlight_kind (self, (ValaCodeNode*) _tmp158_));
				_tmp160_ = _tmp159_;
				_tmp161_ = json_gobject_serialize ((GObject*) _tmp160_);
				json_array_add_element (_tmp151_, _tmp161_);
				_g_object_unref0 (_tmp160_);
			} else {
				JsonArray* _tmp162_;
				GeeMapEntry* _tmp163_;
				gconstpointer _tmp164_;
				gconstpointer _tmp165_;
				ValaSourceReference* _tmp166_;
				ValaSourceReference* _tmp167_;
				ValaSourceFile* _tmp168_;
				ValaSourceFile* _tmp169_;
				const gchar* _tmp170_;
				const gchar* _tmp171_;
				GeeMapEntry* _tmp172_;
				gconstpointer _tmp173_;
				gconstpointer _tmp174_;
				LspLocation* _tmp175_;
				LspLocation* _tmp176_;
				JsonNode* _tmp177_;
				_tmp162_ = json_array;
				_tmp163_ = entry;
				_tmp164_ = gee_map_entry_get_value (_tmp163_);
				_tmp165_ = _tmp164_;
				_tmp166_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp165_);
				_tmp167_ = _tmp166_;
				_tmp168_ = vala_source_reference_get_file (_tmp167_);
				_tmp169_ = _tmp168_;
				_tmp170_ = vala_source_file_get_filename (_tmp169_);
				_tmp171_ = _tmp170_;
				_tmp172_ = entry;
				_tmp173_ = gee_map_entry_get_key (_tmp172_);
				_tmp174_ = _tmp173_;
				_tmp175_ = lsp_location_new (_tmp171_, (LspRange*) _tmp174_);
				if (_tmp175_) {
					g_object_set_data ((GObject *) _tmp175_, "vala-creation-function", "Vls.Server.show_references._lambda66_");
				}
				_tmp176_ = _tmp175_;
				_tmp177_ = json_gobject_serialize ((GObject*) _tmp176_);
				json_array_add_element (_tmp162_, _tmp177_);
				_g_object_unref0 (_tmp176_);
			}
			_g_object_unref0 (entry);
		}
		_g_object_unref0 (_entry_it);
	}
	{
		GVariant* variant_array = NULL;
		JsonNode* _tmp178_;
		JsonNode* _tmp179_;
		JsonArray* _tmp180_;
		JsonNode* _tmp181_;
		GVariant* _tmp182_;
		GVariant* _tmp183_;
		GVariant* _tmp184_;
		GCancellable* _tmp185_;
		_tmp178_ = json_node_alloc ();
		_tmp179_ = _tmp178_;
		_tmp180_ = json_array;
		_tmp181_ = json_node_init_array (_tmp179_, _tmp180_);
		_tmp182_ = json_gvariant_deserialize (_tmp181_, NULL, &_inner_error0_);
		if (_tmp182_ != NULL) {
			g_variant_ref_sink (_tmp182_);
		}
		_tmp183_ = _tmp182_;
		__vala_JsonNode_free0 (_tmp179_);
		variant_array = _tmp183_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp184_ = variant_array;
		_tmp185_ = vls_server_cancellable;
		jsonrpc_client_reply (_data34_->client, _data34_->id, _tmp184_, _tmp185_, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_variant_unref0 (variant_array);
			goto __catch0_g_error;
		}
		_g_variant_unref0 (variant_array);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp186_;
		GError* _tmp187_;
		const gchar* _tmp188_;
		const gchar* _tmp189_;
		gchar* _tmp190_;
		gchar* _tmp191_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp186_ = string_to_string (_data34_->method);
		_tmp187_ = e;
		_tmp188_ = _tmp187_->message;
		_tmp189_ = string_to_string (_tmp188_);
		_tmp190_ = g_strconcat ("[", _tmp186_, "] failed to reply to client: ", _tmp189_, NULL);
		_tmp191_ = _tmp190_;
		g_debug ("server.vala:1500: %s", _tmp191_);
		_g_free0 (_tmp191_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_object_unref0 (references);
		_json_array_unref0 (json_array);
		_vala_code_node_unref0 (symbol);
		_vala_code_node_unref0 (_result_);
		_vala_code_visitor_unref0 (fs);
		_vala_source_file_unref0 (doc);
		_g_object_unref0 (project);
		_g_object_unref0 (compilation);
		_g_object_unref0 (pos);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	vala_code_context_pop ();
	_g_object_unref0 (references);
	_json_array_unref0 (json_array);
	_vala_code_node_unref0 (symbol);
	_vala_code_node_unref0 (_result_);
	_vala_code_visitor_unref0 (fs);
	_vala_source_file_unref0 (doc);
	_g_object_unref0 (project);
	_g_object_unref0 (compilation);
	_g_object_unref0 (pos);
}

static void
___lambda66__vls_server_on_context_updated_func (gboolean request_cancelled,
                                                 gpointer self)
{
	__lambda66_ (self, request_cancelled);
}

static void
vls_server_show_references (VlsServer* self,
                            JsonrpcClient* client,
                            const gchar* method,
                            GVariant* id,
                            GVariant* params)
{
	Block34Data* _data34_;
	JsonrpcClient* _tmp0_;
	gchar* _tmp1_;
	GVariant* _tmp2_;
	gpointer _tmp3_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (client != NULL);
	g_return_if_fail (method != NULL);
	g_return_if_fail (id != NULL);
	g_return_if_fail (params != NULL);
	_data34_ = g_slice_new0 (Block34Data);
	_data34_->_ref_count_ = 1;
	_data34_->self = g_object_ref (self);
	_tmp0_ = _g_object_ref0 (client);
	_g_object_unref0 (_data34_->client);
	_data34_->client = _tmp0_;
	_tmp1_ = g_strdup (method);
	_g_free0 (_data34_->method);
	_data34_->method = _tmp1_;
	_tmp2_ = _g_variant_ref0 (id);
	_g_variant_unref0 (_data34_->id);
	_data34_->id = _tmp2_;
	_tmp3_ = vls_util_parse_variant (LSP_TYPE_REFERENCE_PARAMS, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, params);
	_data34_->p = (LspReferenceParams*) _tmp3_;
	vls_server_wait_for_context_update (self, _data34_->id, ___lambda66__vls_server_on_context_updated_func, block34_data_ref (_data34_), block34_data_unref);
	block34_data_unref (_data34_);
	_data34_ = NULL;
}

static Block35Data*
block35_data_ref (Block35Data* _data35_)
{
	g_atomic_int_inc (&_data35_->_ref_count_);
	return _data35_;
}

static void
block35_data_unref (void * _userdata_)
{
	Block35Data* _data35_;
	_data35_ = (Block35Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data35_->_ref_count_)) {
		VlsServer* self;
		self = _data35_->self;
		_g_object_unref0 (_data35_->p);
		_g_object_unref0 (_data35_->client);
		_g_free0 (_data35_->method);
		_g_variant_unref0 (_data35_->id);
		_g_object_unref0 (self);
		g_slice_free (Block35Data, _data35_);
	}
}

static gboolean
_______lambda68_ (ValaCodeNode* needle,
                  ValaCodeNode* node)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
	g_return_val_if_fail (needle != NULL, FALSE);
	g_return_val_if_fail (node != NULL, FALSE);
	if (G_TYPE_CHECK_INSTANCE_TYPE (node, VALA_TYPE_OBJECT_TYPE_SYMBOL)) {
		_tmp0_ = vala_typesymbol_is_subtype_of ((ValaTypeSymbol*) G_TYPE_CHECK_INSTANCE_CAST (node, VALA_TYPE_OBJECT_TYPE_SYMBOL, ValaObjectTypeSymbol), (ValaTypeSymbol*) G_TYPE_CHECK_INSTANCE_CAST (needle, VALA_TYPE_OBJECT_TYPE_SYMBOL, ValaObjectTypeSymbol));
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}

static gboolean
________lambda68__vls_node_search_filter (ValaCodeNode* needle,
                                          ValaCodeNode* hay_node)
{
	gboolean result;
	result = _______lambda68_ (needle, hay_node);
	return result;
}

static gboolean
________lambda69_ (ValaCodeNode* needle,
                   ValaCodeNode* node)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean result;
	g_return_val_if_fail (needle != NULL, FALSE);
	g_return_val_if_fail (node != NULL, FALSE);
	if (needle != node) {
		_tmp1_ = G_TYPE_CHECK_INSTANCE_TYPE (node, VALA_TYPE_METHOD);
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		gboolean _tmp2_ = FALSE;
		ValaMethod* _tmp3_;
		ValaMethod* _tmp4_;
		_tmp3_ = vala_method_get_base_method (G_TYPE_CHECK_INSTANCE_CAST (node, VALA_TYPE_METHOD, ValaMethod));
		_tmp4_ = _tmp3_;
		if (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, VALA_TYPE_CODE_NODE, ValaCodeNode) == needle) {
			_tmp2_ = TRUE;
		} else {
			ValaMethod* _tmp5_;
			ValaMethod* _tmp6_;
			_tmp5_ = vala_method_get_base_interface_method (G_TYPE_CHECK_INSTANCE_CAST (node, VALA_TYPE_METHOD, ValaMethod));
			_tmp6_ = _tmp5_;
			_tmp2_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, VALA_TYPE_CODE_NODE, ValaCodeNode) == needle;
		}
		_tmp0_ = _tmp2_;
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}

static gboolean
_________lambda69__vls_node_search_filter (ValaCodeNode* needle,
                                           ValaCodeNode* hay_node)
{
	gboolean result;
	result = ________lambda69_ (needle, hay_node);
	return result;
}

static gboolean
________lambda70_ (ValaCodeNode* needle,
                   ValaCodeNode* node)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean result;
	g_return_val_if_fail (needle != NULL, FALSE);
	g_return_val_if_fail (node != NULL, FALSE);
	if (needle != node) {
		_tmp1_ = G_TYPE_CHECK_INSTANCE_TYPE (node, VALA_TYPE_PROPERTY);
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		gboolean _tmp2_ = FALSE;
		ValaProperty* _tmp3_;
		ValaProperty* _tmp4_;
		_tmp3_ = vala_property_get_base_property (G_TYPE_CHECK_INSTANCE_CAST (node, VALA_TYPE_PROPERTY, ValaProperty));
		_tmp4_ = _tmp3_;
		if (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, VALA_TYPE_CODE_NODE, ValaCodeNode) == needle) {
			_tmp2_ = TRUE;
		} else {
			ValaProperty* _tmp5_;
			ValaProperty* _tmp6_;
			_tmp5_ = vala_property_get_base_interface_property (G_TYPE_CHECK_INSTANCE_CAST (node, VALA_TYPE_PROPERTY, ValaProperty));
			_tmp6_ = _tmp5_;
			_tmp2_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, VALA_TYPE_CODE_NODE, ValaCodeNode) == needle;
		}
		_tmp0_ = _tmp2_;
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}

static gboolean
_________lambda70__vls_node_search_filter (ValaCodeNode* needle,
                                           ValaCodeNode* hay_node)
{
	gboolean result;
	result = ________lambda70_ (needle, hay_node);
	return result;
}

static void
__lambda67_ (Block35Data* _data35_,
             gboolean request_cancelled)
{
	VlsServer* self;
	LspPosition* pos = NULL;
	LspPosition* _tmp0_;
	LspPosition* _tmp1_;
	LspPosition* _tmp2_;
	VlsCompilation* compilation = NULL;
	VlsProject* project = NULL;
	ValaSourceFile* doc = NULL;
	LspTextDocumentIdentifier* _tmp3_;
	LspTextDocumentIdentifier* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	VlsCompilation* _tmp7_ = NULL;
	VlsProject* _tmp8_ = NULL;
	ValaSourceFile* _tmp9_;
	ValaSourceFile* _tmp10_;
	VlsCompilation* _tmp15_;
	ValaCodeContext* _tmp16_;
	ValaCodeContext* _tmp17_;
	VlsNodeSearch* fs = NULL;
	ValaSourceFile* _tmp18_;
	LspPosition* _tmp19_;
	VlsNodeSearch* _tmp20_;
	VlsNodeSearch* _tmp21_;
	GeeList* _tmp22_;
	gint _tmp23_;
	gint _tmp24_;
	ValaCodeNode* _result_ = NULL;
	VlsNodeSearch* _tmp28_;
	ValaSourceFile* _tmp29_;
	ValaCodeNode* _tmp30_;
	ValaSymbol* symbol = NULL;
	JsonArray* json_array = NULL;
	JsonArray* _tmp31_;
	GeeArrayList* references = NULL;
	GeeArrayList* _tmp32_;
	gboolean _tmp33_ = FALSE;
	ValaCodeNode* _tmp34_;
	const gchar* _tmp42_;
	ValaCodeNode* _tmp43_;
	gchar* _tmp44_;
	gchar* _tmp45_;
	ValaCodeNode* _tmp46_;
	const gchar* _tmp47_;
	const gchar* _tmp48_;
	const gchar* _tmp49_;
	gchar* _tmp50_;
	gchar* _tmp51_;
	gboolean _tmp52_ = FALSE;
	ValaCodeNode* _tmp53_;
	gboolean is_abstract_type = FALSE;
	gboolean _tmp59_ = FALSE;
	ValaCodeNode* _tmp60_;
	gboolean is_abstract_or_virtual_method = FALSE;
	gboolean _tmp68_ = FALSE;
	ValaCodeNode* _tmp69_;
	gboolean is_abstract_or_virtual_property = FALSE;
	gboolean _tmp77_ = FALSE;
	gboolean _tmp78_ = FALSE;
	GeeHashSet* generated_vapis = NULL;
	GeeHashSet* _tmp84_;
	GeeHashSet* shown_files = NULL;
	GeeHashSet* _tmp98_;
	const gchar* _tmp148_;
	GeeArrayList* _tmp149_;
	gint _tmp150_;
	gint _tmp151_;
	gchar* _tmp152_;
	gchar* _tmp153_;
	gchar* _tmp154_;
	gchar* _tmp155_;
	GError* _inner_error0_ = NULL;
	self = _data35_->self;
	if (request_cancelled) {
		vls_server_reply_null (_data35_->id, _data35_->client, _data35_->method);
		return;
	}
	_tmp0_ = lsp_text_document_position_params_get_position (_data35_->p);
	_tmp1_ = _tmp0_;
	_tmp2_ = _g_object_ref0 (_tmp1_);
	pos = _tmp2_;
	_tmp3_ = lsp_text_document_position_params_get_textDocument (_data35_->p);
	_tmp4_ = _tmp3_;
	_tmp5_ = lsp_text_document_identifier_get_uri (_tmp4_);
	_tmp6_ = _tmp5_;
	_tmp9_ = vls_server_find_file (self, _tmp6_, &_tmp7_, &_tmp8_);
	_g_object_unref0 (compilation);
	compilation = _tmp7_;
	_g_object_unref0 (project);
	project = _tmp8_;
	doc = _tmp9_;
	_tmp10_ = doc;
	if (_tmp10_ == NULL) {
		LspTextDocumentIdentifier* _tmp11_;
		LspTextDocumentIdentifier* _tmp12_;
		const gchar* _tmp13_;
		const gchar* _tmp14_;
		_tmp11_ = lsp_text_document_position_params_get_textDocument (_data35_->p);
		_tmp12_ = _tmp11_;
		_tmp13_ = lsp_text_document_identifier_get_uri (_tmp12_);
		_tmp14_ = _tmp13_;
		g_debug ("server.vala:1522: [%s] file `%s' not found", _data35_->method, _tmp14_);
		vls_server_reply_null (_data35_->id, _data35_->client, _data35_->method);
		_vala_source_file_unref0 (doc);
		_g_object_unref0 (project);
		_g_object_unref0 (compilation);
		_g_object_unref0 (pos);
		return;
	}
	_tmp15_ = compilation;
	_tmp16_ = vls_compilation_get_code_context (_tmp15_);
	_tmp17_ = _tmp16_;
	vala_code_context_push (_tmp17_);
	_tmp18_ = doc;
	_tmp19_ = pos;
	_tmp20_ = vls_node_search_new (_tmp18_, _tmp19_, TRUE, NULL, TRUE);
	fs = _tmp20_;
	_tmp21_ = fs;
	_tmp22_ = _tmp21_->result;
	_tmp23_ = gee_collection_get_size ((GeeCollection*) _tmp22_);
	_tmp24_ = _tmp23_;
	if (_tmp24_ == 0) {
		const gchar* _tmp25_;
		gchar* _tmp26_;
		gchar* _tmp27_;
		_tmp25_ = string_to_string (_data35_->method);
		_tmp26_ = g_strconcat ("[", _tmp25_, "] no results found", NULL);
		_tmp27_ = _tmp26_;
		g_debug ("server.vala:1532: %s", _tmp27_);
		_g_free0 (_tmp27_);
		vls_server_reply_null (_data35_->id, _data35_->client, _data35_->method);
		vala_code_context_pop ();
		_vala_code_visitor_unref0 (fs);
		_vala_source_file_unref0 (doc);
		_g_object_unref0 (project);
		_g_object_unref0 (compilation);
		_g_object_unref0 (pos);
		return;
	}
	_tmp28_ = fs;
	_tmp29_ = doc;
	_tmp30_ = vls_server_get_best (_tmp28_, _tmp29_);
	_result_ = _tmp30_;
	_tmp31_ = json_array_new ();
	json_array = _tmp31_;
	_tmp32_ = gee_array_list_new (VALA_TYPE_CODE_NODE, (GBoxedCopyFunc) vala_code_node_ref, (GDestroyNotify) vala_code_node_unref, NULL, NULL, NULL);
	if (_tmp32_) {
		g_object_set_data ((GObject *) _tmp32_, "vala-creation-function", "Vls.Server.show_implementations._lambda67_");
	}
	references = _tmp32_;
	_tmp34_ = _result_;
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp34_, VALA_TYPE_DATA_TYPE)) {
		ValaCodeNode* _tmp35_;
		ValaTypeSymbol* _tmp36_;
		ValaTypeSymbol* _tmp37_;
		_tmp35_ = _result_;
		_tmp36_ = vala_data_type_get_type_symbol (G_TYPE_CHECK_INSTANCE_CAST (_tmp35_, VALA_TYPE_DATA_TYPE, ValaDataType));
		_tmp37_ = _tmp36_;
		_tmp33_ = _tmp37_ != NULL;
	} else {
		_tmp33_ = FALSE;
	}
	if (_tmp33_) {
		ValaCodeNode* _tmp38_;
		ValaTypeSymbol* _tmp39_;
		ValaTypeSymbol* _tmp40_;
		ValaCodeNode* _tmp41_;
		_tmp38_ = _result_;
		_tmp39_ = vala_data_type_get_type_symbol (G_TYPE_CHECK_INSTANCE_CAST (_tmp38_, VALA_TYPE_DATA_TYPE, ValaDataType));
		_tmp40_ = _tmp39_;
		_tmp41_ = _vala_code_node_ref0 ((ValaCodeNode*) _tmp40_);
		_vala_code_node_unref0 (_result_);
		_result_ = _tmp41_;
	}
	_tmp42_ = string_to_string (_data35_->method);
	_tmp43_ = _result_;
	_tmp44_ = vala_code_node_to_string (_tmp43_);
	_tmp45_ = _tmp44_;
	_tmp46_ = _result_;
	_tmp47_ = vala_code_node_get_type_name (_tmp46_);
	_tmp48_ = _tmp47_;
	_tmp49_ = string_to_string (_tmp48_);
	_tmp50_ = g_strconcat ("[", _tmp42_, "] got best: ", _tmp45_, " (", _tmp49_, ")", NULL);
	_tmp51_ = _tmp50_;
	g_debug ("server.vala:1547: %s", _tmp51_);
	_g_free0 (_tmp51_);
	_g_free0 (_tmp45_);
	_tmp53_ = _result_;
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp53_, VALA_TYPE_INTERFACE)) {
		_tmp52_ = TRUE;
	} else {
		gboolean _tmp54_ = FALSE;
		ValaCodeNode* _tmp55_;
		_tmp55_ = _result_;
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp55_, VALA_TYPE_CLASS)) {
			ValaCodeNode* _tmp56_;
			gboolean _tmp57_;
			gboolean _tmp58_;
			_tmp56_ = _result_;
			_tmp57_ = vala_class_get_is_abstract (G_TYPE_CHECK_INSTANCE_CAST (_tmp56_, VALA_TYPE_CLASS, ValaClass));
			_tmp58_ = _tmp57_;
			_tmp54_ = _tmp58_;
		} else {
			_tmp54_ = FALSE;
		}
		_tmp52_ = _tmp54_;
	}
	is_abstract_type = _tmp52_;
	_tmp60_ = _result_;
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp60_, VALA_TYPE_METHOD)) {
		gboolean _tmp61_ = FALSE;
		ValaCodeNode* _tmp62_;
		gboolean _tmp63_;
		gboolean _tmp64_;
		_tmp62_ = _result_;
		_tmp63_ = vala_method_get_is_abstract (G_TYPE_CHECK_INSTANCE_CAST (_tmp62_, VALA_TYPE_METHOD, ValaMethod));
		_tmp64_ = _tmp63_;
		if (_tmp64_) {
			_tmp61_ = TRUE;
		} else {
			ValaCodeNode* _tmp65_;
			gboolean _tmp66_;
			gboolean _tmp67_;
			_tmp65_ = _result_;
			_tmp66_ = vala_method_get_is_virtual (G_TYPE_CHECK_INSTANCE_CAST (_tmp65_, VALA_TYPE_METHOD, ValaMethod));
			_tmp67_ = _tmp66_;
			_tmp61_ = _tmp67_;
		}
		_tmp59_ = _tmp61_;
	} else {
		_tmp59_ = FALSE;
	}
	is_abstract_or_virtual_method = _tmp59_;
	_tmp69_ = _result_;
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp69_, VALA_TYPE_PROPERTY)) {
		gboolean _tmp70_ = FALSE;
		ValaCodeNode* _tmp71_;
		gboolean _tmp72_;
		gboolean _tmp73_;
		_tmp71_ = _result_;
		_tmp72_ = vala_property_get_is_abstract (G_TYPE_CHECK_INSTANCE_CAST (_tmp71_, VALA_TYPE_PROPERTY, ValaProperty));
		_tmp73_ = _tmp72_;
		if (_tmp73_) {
			_tmp70_ = TRUE;
		} else {
			ValaCodeNode* _tmp74_;
			gboolean _tmp75_;
			gboolean _tmp76_;
			_tmp74_ = _result_;
			_tmp75_ = vala_property_get_is_virtual (G_TYPE_CHECK_INSTANCE_CAST (_tmp74_, VALA_TYPE_PROPERTY, ValaProperty));
			_tmp76_ = _tmp75_;
			_tmp70_ = _tmp76_;
		}
		_tmp68_ = _tmp70_;
	} else {
		_tmp68_ = FALSE;
	}
	is_abstract_or_virtual_property = _tmp68_;
	if (!is_abstract_type) {
		_tmp78_ = !is_abstract_or_virtual_method;
	} else {
		_tmp78_ = FALSE;
	}
	if (_tmp78_) {
		_tmp77_ = !is_abstract_or_virtual_property;
	} else {
		_tmp77_ = FALSE;
	}
	if (_tmp77_) {
		const gchar* _tmp79_;
		gchar* _tmp80_;
		gchar* _tmp81_;
		_tmp79_ = string_to_string (_data35_->method);
		_tmp80_ = g_strconcat ("[", _tmp79_, "] best is neither an abstract type/interface nor abstract/virtual meth" \
"od/property", NULL);
		_tmp81_ = _tmp80_;
		g_debug ("server.vala:1555: %s", _tmp81_);
		_g_free0 (_tmp81_);
		vls_server_reply_null (_data35_->id, _data35_->client, _data35_->method);
		vala_code_context_pop ();
		_g_object_unref0 (references);
		_json_array_unref0 (json_array);
		_vala_code_node_unref0 (symbol);
		_vala_code_node_unref0 (_result_);
		_vala_code_visitor_unref0 (fs);
		_vala_source_file_unref0 (doc);
		_g_object_unref0 (project);
		_g_object_unref0 (compilation);
		_g_object_unref0 (pos);
		return;
	} else {
		ValaCodeNode* _tmp82_;
		ValaSymbol* _tmp83_;
		_tmp82_ = _result_;
		_tmp83_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp82_, VALA_TYPE_SYMBOL, ValaSymbol));
		_vala_code_node_unref0 (symbol);
		symbol = _tmp83_;
	}
	_tmp84_ = gee_hash_set_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _vls_util_file_hash_gee_hash_data_func, NULL, NULL, _vls_util_file_equal_gee_equal_data_func, NULL, NULL);
	if (_tmp84_) {
		g_object_set_data ((GObject *) _tmp84_, "vala-creation-function", "Vls.Server.show_implementations._lambda67_");
	}
	generated_vapis = _tmp84_;
	{
		GeeArrayList* _btarget_list = NULL;
		VlsProject* _tmp85_;
		GeeArrayList* _tmp86_;
		gint _btarget_size = 0;
		GeeArrayList* _tmp87_;
		gint _tmp88_;
		gint _tmp89_;
		gint _btarget_index = 0;
		_tmp85_ = project;
		_tmp86_ = vls_project_get_compilations (_tmp85_);
		_btarget_list = _tmp86_;
		_tmp87_ = _btarget_list;
		_tmp88_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp87_);
		_tmp89_ = _tmp88_;
		_btarget_size = _tmp89_;
		_btarget_index = -1;
		while (TRUE) {
			gint _tmp90_;
			gint _tmp91_;
			VlsCompilation* btarget = NULL;
			GeeArrayList* _tmp92_;
			gpointer _tmp93_;
			GeeHashSet* _tmp94_;
			VlsCompilation* _tmp95_;
			GeeArrayList* _tmp96_;
			GeeArrayList* _tmp97_;
			_btarget_index = _btarget_index + 1;
			_tmp90_ = _btarget_index;
			_tmp91_ = _btarget_size;
			if (!(_tmp90_ < _tmp91_)) {
				break;
			}
			_tmp92_ = _btarget_list;
			_tmp93_ = gee_abstract_list_get ((GeeAbstractList*) _tmp92_, _btarget_index);
			btarget = (VlsCompilation*) _tmp93_;
			_tmp94_ = generated_vapis;
			_tmp95_ = btarget;
			_tmp96_ = vls_build_target_get_output ((VlsBuildTarget*) _tmp95_);
			_tmp97_ = _tmp96_;
			gee_collection_add_all ((GeeCollection*) _tmp94_, (GeeCollection*) _tmp97_);
			_g_object_unref0 (btarget);
		}
		_g_object_unref0 (_btarget_list);
	}
	_tmp98_ = gee_hash_set_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _vls_util_file_hash_gee_hash_data_func, NULL, NULL, _vls_util_file_equal_gee_equal_data_func, NULL, NULL);
	if (_tmp98_) {
		g_object_set_data ((GObject *) _tmp98_, "vala-creation-function", "Vls.Server.show_implementations._lambda67_");
	}
	shown_files = _tmp98_;
	{
		GeeIterator* _btarget_w_sym_it = NULL;
		VlsProject* _tmp99_;
		ValaSymbol* _tmp100_;
		GeeCollection* _tmp101_;
		GeeCollection* _tmp102_;
		GeeIterator* _tmp103_;
		GeeIterator* _tmp104_;
		_tmp99_ = project;
		_tmp100_ = symbol;
		_tmp101_ = vls_symbol_references_get_compilations_using_symbol (_tmp99_, _tmp100_);
		_tmp102_ = _tmp101_;
		_tmp103_ = gee_iterable_iterator ((GeeIterable*) _tmp102_);
		_tmp104_ = _tmp103_;
		_g_object_unref0 (_tmp102_);
		_btarget_w_sym_it = _tmp104_;
		while (TRUE) {
			GeeIterator* _tmp105_;
			VlsPair* btarget_w_sym = NULL;
			GeeIterator* _tmp106_;
			gpointer _tmp107_;
			_tmp105_ = _btarget_w_sym_it;
			if (!gee_iterator_next (_tmp105_)) {
				break;
			}
			_tmp106_ = _btarget_w_sym_it;
			_tmp107_ = gee_iterator_get (_tmp106_);
			btarget_w_sym = (VlsPair*) _tmp107_;
			{
				ValaList* _file_list = NULL;
				VlsPair* _tmp108_;
				gconstpointer _tmp109_;
				gconstpointer _tmp110_;
				ValaCodeContext* _tmp111_;
				ValaCodeContext* _tmp112_;
				ValaList* _tmp113_;
				gint _file_size = 0;
				ValaList* _tmp114_;
				gint _tmp115_;
				gint _tmp116_;
				gint _file_index = 0;
				_tmp108_ = btarget_w_sym;
				_tmp109_ = vls_pair_get_first (_tmp108_);
				_tmp110_ = _tmp109_;
				_tmp111_ = vls_compilation_get_code_context ((VlsCompilation*) _tmp110_);
				_tmp112_ = _tmp111_;
				_tmp113_ = vala_code_context_get_source_files (_tmp112_);
				_file_list = _tmp113_;
				_tmp114_ = _file_list;
				_tmp115_ = vala_collection_get_size ((ValaCollection*) _tmp114_);
				_tmp116_ = _tmp115_;
				_file_size = _tmp116_;
				_file_index = -1;
				while (TRUE) {
					gint _tmp117_;
					gint _tmp118_;
					ValaSourceFile* file = NULL;
					ValaList* _tmp119_;
					gpointer _tmp120_;
					GFile* gfile = NULL;
					ValaSourceFile* _tmp121_;
					const gchar* _tmp122_;
					const gchar* _tmp123_;
					GFile* _tmp124_;
					gboolean _tmp125_ = FALSE;
					GeeHashSet* _tmp126_;
					GFile* _tmp127_;
					VlsNodeSearch* fs2 = NULL;
					GeeArrayList* _tmp143_;
					VlsNodeSearch* _tmp144_;
					GeeList* _tmp145_;
					GeeHashSet* _tmp146_;
					GFile* _tmp147_;
					_file_index = _file_index + 1;
					_tmp117_ = _file_index;
					_tmp118_ = _file_size;
					if (!(_tmp117_ < _tmp118_)) {
						break;
					}
					_tmp119_ = _file_list;
					_tmp120_ = vala_list_get (_tmp119_, _file_index);
					file = (ValaSourceFile*) _tmp120_;
					_tmp121_ = file;
					_tmp122_ = vala_source_file_get_filename (_tmp121_);
					_tmp123_ = _tmp122_;
					_tmp124_ = g_file_new_for_commandline_arg (_tmp123_);
					gfile = _tmp124_;
					_tmp126_ = generated_vapis;
					_tmp127_ = gfile;
					if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp126_, _tmp127_)) {
						_tmp125_ = TRUE;
					} else {
						GeeHashSet* _tmp128_;
						GFile* _tmp129_;
						_tmp128_ = shown_files;
						_tmp129_ = gfile;
						_tmp125_ = gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp128_, _tmp129_);
					}
					if (_tmp125_) {
						_g_object_unref0 (gfile);
						_vala_source_file_unref0 (file);
						continue;
					}
					if (is_abstract_type) {
						ValaSourceFile* _tmp130_;
						VlsPair* _tmp131_;
						gconstpointer _tmp132_;
						gconstpointer _tmp133_;
						VlsNodeSearch* _tmp134_;
						_tmp130_ = file;
						_tmp131_ = btarget_w_sym;
						_tmp132_ = vls_pair_get_second (_tmp131_);
						_tmp133_ = _tmp132_;
						_tmp134_ = vls_node_search_new_with_filter (_tmp130_, (ValaCodeNode*) ((ValaSymbol*) _tmp133_), ________lambda68__vls_node_search_filter, FALSE);
						_vala_code_visitor_unref0 (fs2);
						fs2 = _tmp134_;
					} else {
						if (is_abstract_or_virtual_method) {
							ValaSourceFile* _tmp135_;
							VlsPair* _tmp136_;
							gconstpointer _tmp137_;
							gconstpointer _tmp138_;
							VlsNodeSearch* _tmp139_;
							_tmp135_ = file;
							_tmp136_ = btarget_w_sym;
							_tmp137_ = vls_pair_get_second (_tmp136_);
							_tmp138_ = _tmp137_;
							_tmp139_ = vls_node_search_new_with_filter (_tmp135_, (ValaCodeNode*) ((ValaSymbol*) _tmp138_), _________lambda69__vls_node_search_filter, FALSE);
							_vala_code_visitor_unref0 (fs2);
							fs2 = _tmp139_;
						} else {
							ValaSourceFile* _tmp140_;
							ValaSymbol* _tmp141_;
							VlsNodeSearch* _tmp142_;
							_tmp140_ = file;
							_tmp141_ = symbol;
							_tmp142_ = vls_node_search_new_with_filter (_tmp140_, (ValaCodeNode*) _tmp141_, _________lambda70__vls_node_search_filter, FALSE);
							_vala_code_visitor_unref0 (fs2);
							fs2 = _tmp142_;
						}
					}
					_tmp143_ = references;
					_tmp144_ = fs2;
					_tmp145_ = _tmp144_->result;
					gee_array_list_add_all (_tmp143_, (GeeCollection*) _tmp145_);
					_tmp146_ = shown_files;
					_tmp147_ = gfile;
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp146_, _tmp147_);
					_vala_code_visitor_unref0 (fs2);
					_g_object_unref0 (gfile);
					_vala_source_file_unref0 (file);
				}
			}
			_g_object_unref0 (btarget_w_sym);
		}
		_g_object_unref0 (_btarget_w_sym_it);
	}
	_tmp148_ = string_to_string (_data35_->method);
	_tmp149_ = references;
	_tmp150_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp149_);
	_tmp151_ = _tmp150_;
	_tmp152_ = g_strdup_printf ("%i", _tmp151_);
	_tmp153_ = _tmp152_;
	_tmp154_ = g_strconcat ("[", _tmp148_, "] found ", _tmp153_, " reference(s)", NULL);
	_tmp155_ = _tmp154_;
	g_debug ("server.vala:1596: %s", _tmp155_);
	_g_free0 (_tmp155_);
	_g_free0 (_tmp153_);
	{
		GeeArrayList* _node_list = NULL;
		GeeArrayList* _tmp156_;
		gint _node_size = 0;
		GeeArrayList* _tmp157_;
		gint _tmp158_;
		gint _tmp159_;
		gint _node_index = 0;
		_tmp156_ = references;
		_node_list = _tmp156_;
		_tmp157_ = _node_list;
		_tmp158_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp157_);
		_tmp159_ = _tmp158_;
		_node_size = _tmp159_;
		_node_index = -1;
		while (TRUE) {
			gint _tmp160_;
			gint _tmp161_;
			ValaCodeNode* node = NULL;
			GeeArrayList* _tmp162_;
			gpointer _tmp163_;
			ValaCodeNode* real_node = NULL;
			ValaCodeNode* _tmp164_;
			ValaCodeNode* _tmp165_;
			ValaCodeNode* _tmp166_;
			JsonArray* _tmp170_;
			ValaCodeNode* _tmp171_;
			ValaSourceReference* _tmp172_;
			ValaSourceReference* _tmp173_;
			LspLocation* _tmp174_;
			LspLocation* _tmp175_;
			JsonNode* _tmp176_;
			_node_index = _node_index + 1;
			_tmp160_ = _node_index;
			_tmp161_ = _node_size;
			if (!(_tmp160_ < _tmp161_)) {
				break;
			}
			_tmp162_ = _node_list;
			_tmp163_ = gee_abstract_list_get ((GeeAbstractList*) _tmp162_, _node_index);
			node = (ValaCodeNode*) _tmp163_;
			_tmp164_ = node;
			_tmp165_ = _vala_code_node_ref0 (_tmp164_);
			real_node = _tmp165_;
			_tmp166_ = node;
			if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp166_, VALA_TYPE_SYMBOL)) {
				VlsProject* _tmp167_;
				ValaCodeNode* _tmp168_;
				ValaSymbol* _tmp169_;
				_tmp167_ = project;
				_tmp168_ = node;
				_tmp169_ = vls_symbol_references_find_real_symbol (_tmp167_, G_TYPE_CHECK_INSTANCE_CAST (_tmp168_, VALA_TYPE_SYMBOL, ValaSymbol));
				_vala_code_node_unref0 (real_node);
				real_node = (ValaCodeNode*) _tmp169_;
			}
			_tmp170_ = json_array;
			_tmp171_ = real_node;
			_tmp172_ = vala_code_node_get_source_reference (_tmp171_);
			_tmp173_ = _tmp172_;
			_tmp174_ = lsp_location_new_from_sourceref (_tmp173_);
			if (_tmp174_) {
				g_object_set_data ((GObject *) _tmp174_, "vala-creation-function", "Vls.Server.show_implementations._lambda67_");
			}
			_tmp175_ = _tmp174_;
			_tmp176_ = json_gobject_serialize ((GObject*) _tmp175_);
			json_array_add_element (_tmp170_, _tmp176_);
			_g_object_unref0 (_tmp175_);
			_vala_code_node_unref0 (real_node);
			_vala_code_node_unref0 (node);
		}
	}
	{
		GVariant* variant_array = NULL;
		JsonNode* _tmp177_;
		JsonNode* _tmp178_;
		JsonArray* _tmp179_;
		JsonNode* _tmp180_;
		GVariant* _tmp181_;
		GVariant* _tmp182_;
		GVariant* _tmp183_;
		GCancellable* _tmp184_;
		_tmp177_ = json_node_alloc ();
		_tmp178_ = _tmp177_;
		_tmp179_ = json_array;
		_tmp180_ = json_node_init_array (_tmp178_, _tmp179_);
		_tmp181_ = json_gvariant_deserialize (_tmp180_, NULL, &_inner_error0_);
		if (_tmp181_ != NULL) {
			g_variant_ref_sink (_tmp181_);
		}
		_tmp182_ = _tmp181_;
		__vala_JsonNode_free0 (_tmp178_);
		variant_array = _tmp182_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp183_ = variant_array;
		_tmp184_ = vls_server_cancellable;
		jsonrpc_client_reply (_data35_->client, _data35_->id, _tmp183_, _tmp184_, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_variant_unref0 (variant_array);
			goto __catch0_g_error;
		}
		_g_variant_unref0 (variant_array);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp185_;
		GError* _tmp186_;
		const gchar* _tmp187_;
		const gchar* _tmp188_;
		gchar* _tmp189_;
		gchar* _tmp190_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp185_ = string_to_string (_data35_->method);
		_tmp186_ = e;
		_tmp187_ = _tmp186_->message;
		_tmp188_ = string_to_string (_tmp187_);
		_tmp189_ = g_strconcat ("[", _tmp185_, "] failed to reply to client: ", _tmp188_, NULL);
		_tmp190_ = _tmp189_;
		g_debug ("server.vala:1608: %s", _tmp190_);
		_g_free0 (_tmp190_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_object_unref0 (shown_files);
		_g_object_unref0 (generated_vapis);
		_g_object_unref0 (references);
		_json_array_unref0 (json_array);
		_vala_code_node_unref0 (symbol);
		_vala_code_node_unref0 (_result_);
		_vala_code_visitor_unref0 (fs);
		_vala_source_file_unref0 (doc);
		_g_object_unref0 (project);
		_g_object_unref0 (compilation);
		_g_object_unref0 (pos);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	vala_code_context_pop ();
	_g_object_unref0 (shown_files);
	_g_object_unref0 (generated_vapis);
	_g_object_unref0 (references);
	_json_array_unref0 (json_array);
	_vala_code_node_unref0 (symbol);
	_vala_code_node_unref0 (_result_);
	_vala_code_visitor_unref0 (fs);
	_vala_source_file_unref0 (doc);
	_g_object_unref0 (project);
	_g_object_unref0 (compilation);
	_g_object_unref0 (pos);
}

static void
___lambda67__vls_server_on_context_updated_func (gboolean request_cancelled,
                                                 gpointer self)
{
	__lambda67_ (self, request_cancelled);
}

static void
vls_server_show_implementations (VlsServer* self,
                                 JsonrpcClient* client,
                                 const gchar* method,
                                 GVariant* id,
                                 GVariant* params)
{
	Block35Data* _data35_;
	JsonrpcClient* _tmp0_;
	gchar* _tmp1_;
	GVariant* _tmp2_;
	gpointer _tmp3_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (client != NULL);
	g_return_if_fail (method != NULL);
	g_return_if_fail (id != NULL);
	g_return_if_fail (params != NULL);
	_data35_ = g_slice_new0 (Block35Data);
	_data35_->_ref_count_ = 1;
	_data35_->self = g_object_ref (self);
	_tmp0_ = _g_object_ref0 (client);
	_g_object_unref0 (_data35_->client);
	_data35_->client = _tmp0_;
	_tmp1_ = g_strdup (method);
	_g_free0 (_data35_->method);
	_data35_->method = _tmp1_;
	_tmp2_ = _g_variant_ref0 (id);
	_g_variant_unref0 (_data35_->id);
	_data35_->id = _tmp2_;
	_tmp3_ = vls_util_parse_variant (LSP_TYPE_TEXT_DOCUMENT_POSITION_PARAMS, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, params);
	_data35_->p = (LspTextDocumentPositionParams*) _tmp3_;
	vls_server_wait_for_context_update (self, _data35_->id, ___lambda67__vls_server_on_context_updated_func, block35_data_ref (_data35_), block35_data_unref);
	block35_data_unref (_data35_);
	_data35_ = NULL;
}

static void
vls_server_format (VlsServer* self,
                   JsonrpcClient* client,
                   const gchar* method,
                   GVariant* id,
                   GVariant* params)
{
	LspDocumentRangeFormattingParams* p = NULL;
	gpointer _tmp0_;
	VlsCompilation* compilation = NULL;
	ValaSourceFile* source_file = NULL;
	LspDocumentRangeFormattingParams* _tmp1_;
	LspTextDocumentIdentifier* _tmp2_;
	LspTextDocumentIdentifier* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	VlsCompilation* _tmp6_ = NULL;
	ValaSourceFile* _tmp7_;
	ValaSourceFile* _tmp8_;
	JsonArray* json_array = NULL;
	JsonArray* _tmp14_;
	LspTextEdit* edited = NULL;
	VlsCodeStyleAnalyzer* code_style = NULL;
	VlsCompilation* _tmp15_;
	ValaSourceFile* _tmp16_;
	gpointer _tmp17_;
	JsonArray* _tmp35_;
	LspTextEdit* _tmp36_;
	JsonNode* _tmp37_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (client != NULL);
	g_return_if_fail (method != NULL);
	g_return_if_fail (id != NULL);
	g_return_if_fail (params != NULL);
	_tmp0_ = vls_util_parse_variant (LSP_TYPE_DOCUMENT_RANGE_FORMATTING_PARAMS, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, params);
	p = (LspDocumentRangeFormattingParams*) _tmp0_;
	_tmp1_ = p;
	_tmp2_ = lsp_document_range_formatting_params_get_textDocument (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = lsp_text_document_identifier_get_uri (_tmp3_);
	_tmp5_ = _tmp4_;
	_tmp7_ = vls_server_find_file (self, _tmp5_, &_tmp6_, NULL);
	_g_object_unref0 (compilation);
	compilation = _tmp6_;
	source_file = _tmp7_;
	_tmp8_ = source_file;
	if (_tmp8_ == NULL) {
		LspDocumentRangeFormattingParams* _tmp9_;
		LspTextDocumentIdentifier* _tmp10_;
		LspTextDocumentIdentifier* _tmp11_;
		const gchar* _tmp12_;
		const gchar* _tmp13_;
		_tmp9_ = p;
		_tmp10_ = lsp_document_range_formatting_params_get_textDocument (_tmp9_);
		_tmp11_ = _tmp10_;
		_tmp12_ = lsp_text_document_identifier_get_uri (_tmp11_);
		_tmp13_ = _tmp12_;
		g_debug ("server.vala:1621: [%s] file `%s' not found", method, _tmp13_);
		vls_server_reply_null (id, client, method);
		_vala_source_file_unref0 (source_file);
		_g_object_unref0 (compilation);
		_g_object_unref0 (p);
		return;
	}
	_tmp14_ = json_array_new ();
	json_array = _tmp14_;
	_tmp15_ = compilation;
	_tmp16_ = source_file;
	_tmp17_ = vls_compilation_get_analysis_for_file (_tmp15_, VLS_TYPE_CODE_STYLE_ANALYZER, (GBoxedCopyFunc) vala_code_visitor_ref, (GDestroyNotify) vala_code_visitor_unref, _tmp16_);
	code_style = (VlsCodeStyleAnalyzer*) _tmp17_;
	{
		LspTextEdit* _tmp18_ = NULL;
		LspDocumentRangeFormattingParams* _tmp19_;
		LspFormattingOptions* _tmp20_;
		LspFormattingOptions* _tmp21_;
		VlsCodeStyleAnalyzer* _tmp22_;
		ValaSourceFile* _tmp23_;
		LspDocumentRangeFormattingParams* _tmp24_;
		LspRange* _tmp25_;
		LspRange* _tmp26_;
		GCancellable* _tmp27_;
		LspTextEdit* _tmp28_;
		LspTextEdit* _tmp29_;
		_tmp19_ = p;
		_tmp20_ = lsp_document_range_formatting_params_get_options (_tmp19_);
		_tmp21_ = _tmp20_;
		_tmp22_ = code_style;
		_tmp23_ = source_file;
		_tmp24_ = p;
		_tmp25_ = lsp_document_range_formatting_params_get_range (_tmp24_);
		_tmp26_ = _tmp25_;
		_tmp27_ = vls_server_cancellable;
		_tmp28_ = vls_formatter_format (_tmp21_, _tmp22_, _tmp23_, _tmp26_, _tmp27_, &_inner_error0_);
		_tmp18_ = _tmp28_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp29_ = _tmp18_;
		_tmp18_ = NULL;
		_g_object_unref0 (edited);
		edited = _tmp29_;
		_g_object_unref0 (_tmp18_);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp30_;
		const gchar* _tmp31_;
		GCancellable* _tmp32_;
		GError* _tmp33_;
		const gchar* _tmp34_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp30_ = e;
		_tmp31_ = _tmp30_->message;
		_tmp32_ = vls_server_cancellable;
		jsonrpc_client_reply_error_async (client, id, (gint) JSONRPC_CLIENT_ERROR_INTERNAL_ERROR, _tmp31_, _tmp32_, NULL, NULL);
		_tmp33_ = e;
		_tmp34_ = _tmp33_->message;
		g_warning ("server.vala:1637: Formatting failed: %s", _tmp34_);
		_g_error_free0 (e);
		_vala_code_visitor_unref0 (code_style);
		_g_object_unref0 (edited);
		_json_array_unref0 (json_array);
		_vala_source_file_unref0 (source_file);
		_g_object_unref0 (compilation);
		_g_object_unref0 (p);
		return;
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_vala_code_visitor_unref0 (code_style);
		_g_object_unref0 (edited);
		_json_array_unref0 (json_array);
		_vala_source_file_unref0 (source_file);
		_g_object_unref0 (compilation);
		_g_object_unref0 (p);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	_tmp35_ = json_array;
	_tmp36_ = edited;
	_tmp37_ = json_gobject_serialize ((GObject*) _tmp36_);
	json_array_add_element (_tmp35_, _tmp37_);
	{
		GVariant* variant_array = NULL;
		JsonNode* _tmp38_;
		JsonNode* _tmp39_;
		JsonArray* _tmp40_;
		JsonNode* _tmp41_;
		GVariant* _tmp42_;
		GVariant* _tmp43_;
		GVariant* _tmp44_;
		GCancellable* _tmp45_;
		_tmp38_ = json_node_alloc ();
		_tmp39_ = _tmp38_;
		_tmp40_ = json_array;
		_tmp41_ = json_node_init_array (_tmp39_, _tmp40_);
		_tmp42_ = json_gvariant_deserialize (_tmp41_, NULL, &_inner_error0_);
		if (_tmp42_ != NULL) {
			g_variant_ref_sink (_tmp42_);
		}
		_tmp43_ = _tmp42_;
		__vala_JsonNode_free0 (_tmp39_);
		variant_array = _tmp43_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch1_g_error;
		}
		_tmp44_ = variant_array;
		_tmp45_ = vls_server_cancellable;
		jsonrpc_client_reply (client, id, _tmp44_, _tmp45_, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_variant_unref0 (variant_array);
			goto __catch1_g_error;
		}
		_g_variant_unref0 (variant_array);
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp46_;
		GError* _tmp47_;
		const gchar* _tmp48_;
		const gchar* _tmp49_;
		gchar* _tmp50_;
		gchar* _tmp51_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp46_ = string_to_string (method);
		_tmp47_ = e;
		_tmp48_ = _tmp47_->message;
		_tmp49_ = string_to_string (_tmp48_);
		_tmp50_ = g_strconcat ("[", _tmp46_, "] failed to reply to client: ", _tmp49_, NULL);
		_tmp51_ = _tmp50_;
		g_debug ("server.vala:1645: %s", _tmp51_);
		_g_free0 (_tmp51_);
		_g_error_free0 (e);
	}
	__finally1:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_vala_code_visitor_unref0 (code_style);
		_g_object_unref0 (edited);
		_json_array_unref0 (json_array);
		_vala_source_file_unref0 (source_file);
		_g_object_unref0 (compilation);
		_g_object_unref0 (p);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	_vala_code_visitor_unref0 (code_style);
	_g_object_unref0 (edited);
	_json_array_unref0 (json_array);
	_vala_source_file_unref0 (source_file);
	_g_object_unref0 (compilation);
	_g_object_unref0 (p);
}

static void
vls_server_code_action (VlsServer* self,
                        JsonrpcClient* client,
                        const gchar* method,
                        GVariant* id,
                        GVariant* params)
{
	LspCodeActionParams* p = NULL;
	gpointer _tmp0_;
	VlsCompilation* compilation = NULL;
	ValaSourceFile* source_file = NULL;
	LspCodeActionParams* _tmp1_;
	LspTextDocumentIdentifier* _tmp2_;
	LspTextDocumentIdentifier* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	VlsCompilation* _tmp6_ = NULL;
	ValaSourceFile* _tmp7_;
	ValaSourceFile* _tmp8_;
	ValaSourceFile* _tmp14_;
	JsonArray* json_array = NULL;
	JsonArray* _tmp15_;
	VlsCompilation* _tmp16_;
	ValaCodeContext* _tmp17_;
	ValaCodeContext* _tmp18_;
	ValaCollection* code_actions = NULL;
	LspCodeActionParams* _tmp19_;
	LspCodeActionContext* _tmp20_;
	LspCodeActionContext* _tmp21_;
	VlsCompilation* _tmp22_;
	ValaSourceFile* _tmp23_;
	LspCodeActionParams* _tmp24_;
	LspRange* _tmp25_;
	LspRange* _tmp26_;
	LspCodeActionParams* _tmp27_;
	LspTextDocumentIdentifier* _tmp28_;
	LspTextDocumentIdentifier* _tmp29_;
	const gchar* _tmp30_;
	const gchar* _tmp31_;
	gchar* _tmp32_;
	gchar* _tmp33_;
	ValaCollection* _tmp34_;
	ValaCollection* _tmp35_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (client != NULL);
	g_return_if_fail (method != NULL);
	g_return_if_fail (id != NULL);
	g_return_if_fail (params != NULL);
	_tmp0_ = vls_util_parse_variant (LSP_TYPE_CODE_ACTION_PARAMS, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, params);
	p = (LspCodeActionParams*) _tmp0_;
	_tmp1_ = p;
	_tmp2_ = lsp_code_action_params_get_textDocument (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = lsp_text_document_identifier_get_uri (_tmp3_);
	_tmp5_ = _tmp4_;
	_tmp7_ = vls_server_find_file (self, _tmp5_, &_tmp6_, NULL);
	_g_object_unref0 (compilation);
	compilation = _tmp6_;
	source_file = _tmp7_;
	_tmp8_ = source_file;
	if (_tmp8_ == NULL) {
		LspCodeActionParams* _tmp9_;
		LspTextDocumentIdentifier* _tmp10_;
		LspTextDocumentIdentifier* _tmp11_;
		const gchar* _tmp12_;
		const gchar* _tmp13_;
		_tmp9_ = p;
		_tmp10_ = lsp_code_action_params_get_textDocument (_tmp9_);
		_tmp11_ = _tmp10_;
		_tmp12_ = lsp_text_document_identifier_get_uri (_tmp11_);
		_tmp13_ = _tmp12_;
		g_debug ("server.vala:1655: [%s] file `%s' not found", method, _tmp13_);
		vls_server_reply_null (id, client, method);
		_vala_source_file_unref0 (source_file);
		_g_object_unref0 (compilation);
		_g_object_unref0 (p);
		return;
	}
	_tmp14_ = source_file;
	if (!VLS_IS_TEXT_DOCUMENT (_tmp14_)) {
		vls_server_reply_null (id, client, method);
		_vala_source_file_unref0 (source_file);
		_g_object_unref0 (compilation);
		_g_object_unref0 (p);
		return;
	}
	_tmp15_ = json_array_new ();
	json_array = _tmp15_;
	_tmp16_ = compilation;
	_tmp17_ = vls_compilation_get_code_context (_tmp16_);
	_tmp18_ = _tmp17_;
	vala_code_context_push (_tmp18_);
	_tmp19_ = p;
	_tmp20_ = lsp_code_action_params_get_context (_tmp19_);
	_tmp21_ = _tmp20_;
	_tmp22_ = compilation;
	_tmp23_ = source_file;
	_tmp24_ = p;
	_tmp25_ = lsp_code_action_params_get_range (_tmp24_);
	_tmp26_ = _tmp25_;
	_tmp27_ = p;
	_tmp28_ = lsp_code_action_params_get_textDocument (_tmp27_);
	_tmp29_ = _tmp28_;
	_tmp30_ = lsp_text_document_identifier_get_uri (_tmp29_);
	_tmp31_ = _tmp30_;
	_tmp32_ = g_uri_unescape_string (_tmp31_, NULL);
	_tmp33_ = _tmp32_;
	_tmp34_ = vls_code_actions_extract (_tmp21_, _tmp22_, G_TYPE_CHECK_INSTANCE_CAST (_tmp23_, VLS_TYPE_TEXT_DOCUMENT, VlsTextDocument), _tmp26_, _tmp33_);
	_tmp35_ = _tmp34_;
	_g_free0 (_tmp33_);
	code_actions = _tmp35_;
	{
		ValaIterator* _action_it = NULL;
		ValaCollection* _tmp36_;
		ValaIterator* _tmp37_;
		_tmp36_ = code_actions;
		_tmp37_ = vala_iterable_iterator ((ValaIterable*) _tmp36_);
		_action_it = _tmp37_;
		while (TRUE) {
			ValaIterator* _tmp38_;
			LspCodeAction* action = NULL;
			ValaIterator* _tmp39_;
			gpointer _tmp40_;
			JsonArray* _tmp41_;
			LspCodeAction* _tmp42_;
			JsonNode* _tmp43_;
			_tmp38_ = _action_it;
			if (!vala_iterator_next (_tmp38_)) {
				break;
			}
			_tmp39_ = _action_it;
			_tmp40_ = vala_iterator_get (_tmp39_);
			action = (LspCodeAction*) _tmp40_;
			_tmp41_ = json_array;
			_tmp42_ = action;
			_tmp43_ = json_gobject_serialize ((GObject*) _tmp42_);
			json_array_add_element (_tmp41_, _tmp43_);
			_g_object_unref0 (action);
		}
		_vala_iterator_unref0 (_action_it);
	}
	vala_code_context_pop ();
	{
		GVariant* variant_array = NULL;
		JsonNode* _tmp44_;
		JsonNode* _tmp45_;
		JsonArray* _tmp46_;
		JsonNode* _tmp47_;
		GVariant* _tmp48_;
		GVariant* _tmp49_;
		GVariant* _tmp50_;
		GCancellable* _tmp51_;
		_tmp44_ = json_node_alloc ();
		_tmp45_ = _tmp44_;
		_tmp46_ = json_array;
		_tmp47_ = json_node_init_array (_tmp45_, _tmp46_);
		_tmp48_ = json_gvariant_deserialize (_tmp47_, NULL, &_inner_error0_);
		if (_tmp48_ != NULL) {
			g_variant_ref_sink (_tmp48_);
		}
		_tmp49_ = _tmp48_;
		__vala_JsonNode_free0 (_tmp45_);
		variant_array = _tmp49_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp50_ = variant_array;
		_tmp51_ = vls_server_cancellable;
		jsonrpc_client_reply (client, id, _tmp50_, _tmp51_, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_variant_unref0 (variant_array);
			goto __catch0_g_error;
		}
		_g_variant_unref0 (variant_array);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp52_;
		GError* _tmp53_;
		const gchar* _tmp54_;
		const gchar* _tmp55_;
		gchar* _tmp56_;
		gchar* _tmp57_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp52_ = string_to_string (method);
		_tmp53_ = e;
		_tmp54_ = _tmp53_->message;
		_tmp55_ = string_to_string (_tmp54_);
		_tmp56_ = g_strconcat ("[", _tmp52_, "] failed to reply to client: ", _tmp55_, NULL);
		_tmp57_ = _tmp56_;
		g_debug ("server.vala:1676: %s", _tmp57_);
		_g_free0 (_tmp57_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_vala_iterable_unref0 (code_actions);
		_json_array_unref0 (json_array);
		_vala_source_file_unref0 (source_file);
		_g_object_unref0 (compilation);
		_g_object_unref0 (p);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	_vala_iterable_unref0 (code_actions);
	_json_array_unref0 (json_array);
	_vala_source_file_unref0 (source_file);
	_g_object_unref0 (compilation);
	_g_object_unref0 (p);
}

static Block36Data*
block36_data_ref (Block36Data* _data36_)
{
	g_atomic_int_inc (&_data36_->_ref_count_);
	return _data36_;
}

static void
block36_data_unref (void * _userdata_)
{
	Block36Data* _data36_;
	_data36_ = (Block36Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data36_->_ref_count_)) {
		VlsServer* self;
		self = _data36_->self;
		_g_free0 (_data36_->query);
		_g_object_unref0 (_data36_->client);
		_g_free0 (_data36_->method);
		_g_variant_unref0 (_data36_->id);
		_g_object_unref0 (self);
		g_slice_free (Block36Data, _data36_);
	}
}

static gchar*
_variant_get10 (GVariant* value)
{
	return g_variant_dup_string (value, NULL);
}

static Block37Data*
block37_data_ref (Block37Data* _data37_)
{
	g_atomic_int_inc (&_data37_->_ref_count_);
	return _data37_;
}

static void
block37_data_unref (void * _userdata_)
{
	Block37Data* _data37_;
	_data37_ = (Block37Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data37_->_ref_count_)) {
		VlsServer* self;
		self = _data37_->_data36_->self;
		_json_array_unref0 (_data37_->json_array);
		block36_data_unref (_data37_->_data36_);
		_data37_->_data36_ = NULL;
		g_slice_free (Block37Data, _data37_);
	}
}

static VlsProject**
_vala_array_dup17 (VlsProject** self,
                   gssize length)
{
	if (length >= 0) {
		VlsProject** result;
		gssize i;
		result = g_new0 (VlsProject*, length + 1);
		for (i = 0; i < length; i++) {
			VlsProject* _tmp0_;
			_tmp0_ = _g_object_ref0 (self[i]);
			result[i] = _tmp0_;
		}
		return result;
	}
	return NULL;
}

static void
_vala_array_add29 (VlsProject** * array,
                   gint* length,
                   gint* size,
                   VlsProject* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (VlsProject*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static gboolean
_______lambda72_ (Block37Data* _data37_,
                  LspSymbolInformation* dsym)
{
	Block36Data* _data36_;
	VlsServer* self;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gboolean result;
	_data36_ = _data37_->_data36_;
	self = _data36_->self;
	g_return_val_if_fail (dsym != NULL, FALSE);
	_tmp0_ = lsp_symbol_information_get_name (dsym);
	_tmp1_ = _tmp0_;
	result = g_str_match_string (_data36_->query, _tmp1_, TRUE);
	return result;
}

static gboolean
________lambda72__gee_predicate (gconstpointer g,
                                 gpointer self)
{
	gboolean result;
	result = _______lambda72_ (self, (LspSymbolInformation*) g);
	return result;
}

static gboolean
_______lambda73_ (Block37Data* _data37_,
                  LspSymbolInformation* dsym)
{
	Block36Data* _data36_;
	VlsServer* self;
	JsonArray* _tmp0_;
	JsonNode* _tmp1_;
	gboolean result;
	_data36_ = _data37_->_data36_;
	self = _data36_->self;
	g_return_val_if_fail (dsym != NULL, FALSE);
	_tmp0_ = _data37_->json_array;
	_tmp1_ = json_gobject_serialize ((GObject*) dsym);
	json_array_add_element (_tmp0_, _tmp1_);
	result = TRUE;
	_g_object_unref0 (dsym);
	return result;
}

static gboolean
________lambda73__gee_forall_func (gpointer g,
                                   gpointer self)
{
	gboolean result;
	result = _______lambda73_ (self, (LspSymbolInformation*) g);
	return result;
}

static void
__lambda71_ (Block36Data* _data36_,
             gboolean request_cancelled)
{
	VlsServer* self;
	Block37Data* _data37_;
	JsonArray* _tmp0_;
	VlsProject** all_projects = NULL;
	GHashTable* _tmp1_;
	guint _tmp2_ = 0;
	gconstpointer* _tmp3_;
	VlsProject** _tmp4_;
	gint _tmp4__length1;
	gint all_projects_length1;
	gint _all_projects_size_;
	VlsDefaultProject* _tmp5_;
	VlsProject* _tmp6_;
	VlsProject** _tmp7_;
	gint _tmp7__length1;
	const gchar* _tmp37_;
	JsonArray* _tmp38_;
	gchar* _tmp39_;
	gchar* _tmp40_;
	const gchar* _tmp41_;
	gchar* _tmp42_;
	gchar* _tmp43_;
	GError* _inner_error0_ = NULL;
	self = _data36_->self;
	_data37_ = g_slice_new0 (Block37Data);
	_data37_->_ref_count_ = 1;
	_data37_->_data36_ = block36_data_ref (_data36_);
	if (request_cancelled) {
		vls_server_reply_null (_data36_->id, _data36_->client, _data36_->method);
		block37_data_unref (_data37_);
		_data37_ = NULL;
		return;
	}
	_tmp0_ = json_array_new ();
	_data37_->json_array = _tmp0_;
	_tmp1_ = self->priv->projects;
	_tmp3_ = g_hash_table_get_keys_as_array (_tmp1_, &_tmp2_);
	_tmp4_ = (_tmp3_ != NULL) ? _vala_array_dup17 (_tmp3_, _tmp2_) : _tmp3_;
	_tmp4__length1 = _tmp2_;
	_tmp3_ = (g_free (_tmp3_), NULL);
	all_projects = _tmp4_;
	all_projects_length1 = _tmp4__length1;
	_all_projects_size_ = all_projects_length1;
	_tmp5_ = self->priv->default_project;
	_tmp6_ = _g_object_ref0 ((VlsProject*) _tmp5_);
	_vala_array_add29 (&all_projects, &all_projects_length1, &_all_projects_size_, _tmp6_);
	_tmp7_ = all_projects;
	_tmp7__length1 = all_projects_length1;
	{
		VlsProject** project_collection = NULL;
		gint project_collection_length1 = 0;
		gint _project_collection_size_ = 0;
		gint project_it = 0;
		project_collection = _tmp7_;
		project_collection_length1 = _tmp7__length1;
		for (project_it = 0; project_it < project_collection_length1; project_it = project_it + 1) {
			VlsProject* _tmp8_;
			VlsProject* project = NULL;
			_tmp8_ = _g_object_ref0 (project_collection[project_it]);
			project = _tmp8_;
			{
				{
					GeeIterator* _source_pair_it = NULL;
					VlsProject* _tmp9_;
					GeeIterable* _tmp10_;
					GeeIterable* _tmp11_;
					GeeIterator* _tmp12_;
					GeeIterator* _tmp13_;
					_tmp9_ = project;
					_tmp10_ = vls_project_get_project_source_files (_tmp9_);
					_tmp11_ = _tmp10_;
					_tmp12_ = gee_iterable_iterator (_tmp11_);
					_tmp13_ = _tmp12_;
					_g_object_unref0 (_tmp11_);
					_source_pair_it = _tmp13_;
					while (TRUE) {
						GeeIterator* _tmp14_;
						GeeMapEntry* source_pair = NULL;
						GeeIterator* _tmp15_;
						gpointer _tmp16_;
						ValaSourceFile* text_document = NULL;
						GeeMapEntry* _tmp17_;
						gconstpointer _tmp18_;
						gconstpointer _tmp19_;
						ValaSourceFile* _tmp20_;
						VlsCompilation* compilation = NULL;
						GeeMapEntry* _tmp21_;
						gconstpointer _tmp22_;
						gconstpointer _tmp23_;
						VlsCompilation* _tmp24_;
						VlsCompilation* _tmp25_;
						ValaCodeContext* _tmp26_;
						ValaCodeContext* _tmp27_;
						VlsSymbolEnumerator* symbol_enumerator = NULL;
						VlsCompilation* _tmp28_;
						ValaSourceFile* _tmp29_;
						gpointer _tmp30_;
						VlsSymbolEnumerator* _tmp31_;
						_tmp14_ = _source_pair_it;
						if (!gee_iterator_next (_tmp14_)) {
							break;
						}
						_tmp15_ = _source_pair_it;
						_tmp16_ = gee_iterator_get (_tmp15_);
						source_pair = (GeeMapEntry*) _tmp16_;
						_tmp17_ = source_pair;
						_tmp18_ = gee_map_entry_get_key (_tmp17_);
						_tmp19_ = _tmp18_;
						_tmp20_ = _vala_source_file_ref0 ((ValaSourceFile*) _tmp19_);
						text_document = _tmp20_;
						_tmp21_ = source_pair;
						_tmp22_ = gee_map_entry_get_value (_tmp21_);
						_tmp23_ = _tmp22_;
						_tmp24_ = _g_object_ref0 ((VlsCompilation*) _tmp23_);
						compilation = _tmp24_;
						_tmp25_ = compilation;
						_tmp26_ = vls_compilation_get_code_context (_tmp25_);
						_tmp27_ = _tmp26_;
						vala_code_context_push (_tmp27_);
						_tmp28_ = compilation;
						_tmp29_ = text_document;
						_tmp30_ = vls_compilation_get_analysis_for_file (_tmp28_, VLS_TYPE_SYMBOL_ENUMERATOR, (GBoxedCopyFunc) vala_code_visitor_ref, (GDestroyNotify) vala_code_visitor_unref, _tmp29_);
						symbol_enumerator = (VlsSymbolEnumerator*) _tmp30_;
						_tmp31_ = symbol_enumerator;
						if (_tmp31_ != NULL) {
							VlsSymbolEnumerator* _tmp32_;
							GeeIterable* _tmp33_;
							GeeIterable* _tmp34_;
							GeeIterator* _tmp35_;
							GeeIterator* _tmp36_;
							_tmp32_ = symbol_enumerator;
							_tmp33_ = vls_symbol_enumerator_flattened (_tmp32_);
							_tmp34_ = _tmp33_;
							_tmp35_ = gee_traversable_filter ((GeeTraversable*) _tmp34_, ________lambda72__gee_predicate, block37_data_ref (_data37_), block37_data_unref);
							_tmp36_ = _tmp35_;
							gee_traversable_foreach ((GeeTraversable*) _tmp36_, ________lambda73__gee_forall_func, _data37_);
							_g_object_unref0 (_tmp36_);
							_g_object_unref0 (_tmp34_);
						}
						vala_code_context_pop ();
						_vala_code_visitor_unref0 (symbol_enumerator);
						_g_object_unref0 (compilation);
						_vala_source_file_unref0 (text_document);
						_g_object_unref0 (source_pair);
					}
					_g_object_unref0 (_source_pair_it);
				}
				_g_object_unref0 (project);
			}
		}
	}
	_tmp37_ = string_to_string (_data36_->method);
	_tmp38_ = _data37_->json_array;
	_tmp39_ = g_strdup_printf ("%u", json_array_get_length (_tmp38_));
	_tmp40_ = _tmp39_;
	_tmp41_ = string_to_string (_data36_->query);
	_tmp42_ = g_strconcat ("[", _tmp37_, "] found ", _tmp40_, " element(s) matching `", _tmp41_, "'", NULL);
	_tmp43_ = _tmp42_;
	g_debug ("server.vala:1713: %s", _tmp43_);
	_g_free0 (_tmp43_);
	_g_free0 (_tmp40_);
	{
		GVariant* variant_array = NULL;
		JsonNode* _tmp44_;
		JsonNode* _tmp45_;
		JsonArray* _tmp46_;
		JsonNode* _tmp47_;
		GVariant* _tmp48_;
		GVariant* _tmp49_;
		GVariant* _tmp50_;
		GCancellable* _tmp51_;
		_tmp44_ = json_node_alloc ();
		_tmp45_ = _tmp44_;
		_tmp46_ = _data37_->json_array;
		_tmp47_ = json_node_init_array (_tmp45_, _tmp46_);
		_tmp48_ = json_gvariant_deserialize (_tmp47_, NULL, &_inner_error0_);
		if (_tmp48_ != NULL) {
			g_variant_ref_sink (_tmp48_);
		}
		_tmp49_ = _tmp48_;
		__vala_JsonNode_free0 (_tmp45_);
		variant_array = _tmp49_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp50_ = variant_array;
		_tmp51_ = vls_server_cancellable;
		jsonrpc_client_reply (_data36_->client, _data36_->id, _tmp50_, _tmp51_, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_variant_unref0 (variant_array);
			goto __catch0_g_error;
		}
		_g_variant_unref0 (variant_array);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp52_;
		GError* _tmp53_;
		const gchar* _tmp54_;
		const gchar* _tmp55_;
		gchar* _tmp56_;
		gchar* _tmp57_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp52_ = string_to_string (_data36_->method);
		_tmp53_ = e;
		_tmp54_ = _tmp53_->message;
		_tmp55_ = string_to_string (_tmp54_);
		_tmp56_ = g_strconcat ("[", _tmp52_, "] failed to reply to client: ", _tmp55_, NULL);
		_tmp57_ = _tmp56_;
		g_debug ("server.vala:1718: %s", _tmp57_);
		_g_free0 (_tmp57_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		all_projects = (_vala_array_free (all_projects, all_projects_length1, (GDestroyNotify) g_object_unref), NULL);
		block37_data_unref (_data37_);
		_data37_ = NULL;
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	all_projects = (_vala_array_free (all_projects, all_projects_length1, (GDestroyNotify) g_object_unref), NULL);
	block37_data_unref (_data37_);
	_data37_ = NULL;
}

static void
___lambda71__vls_server_on_context_updated_func (gboolean request_cancelled,
                                                 gpointer self)
{
	__lambda71_ (self, request_cancelled);
}

static void
vls_server_search_workspace_symbols (VlsServer* self,
                                     JsonrpcClient* client,
                                     const gchar* method,
                                     GVariant* id,
                                     GVariant* params)
{
	Block36Data* _data36_;
	JsonrpcClient* _tmp0_;
	gchar* _tmp1_;
	GVariant* _tmp2_;
	const GVariantType* _tmp3_;
	GVariant* _tmp4_;
	GVariant* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (client != NULL);
	g_return_if_fail (method != NULL);
	g_return_if_fail (id != NULL);
	g_return_if_fail (params != NULL);
	_data36_ = g_slice_new0 (Block36Data);
	_data36_->_ref_count_ = 1;
	_data36_->self = g_object_ref (self);
	_tmp0_ = _g_object_ref0 (client);
	_g_object_unref0 (_data36_->client);
	_data36_->client = _tmp0_;
	_tmp1_ = g_strdup (method);
	_g_free0 (_data36_->method);
	_data36_->method = _tmp1_;
	_tmp2_ = _g_variant_ref0 (id);
	_g_variant_unref0 (_data36_->id);
	_data36_->id = _tmp2_;
	_tmp3_ = G_VARIANT_TYPE_STRING;
	_tmp4_ = g_variant_lookup_value (params, "query", _tmp3_);
	_tmp5_ = _tmp4_;
	_tmp6_ = _variant_get10 (_tmp5_);
	_tmp7_ = _tmp6_;
	_g_variant_unref0 (_tmp5_);
	_data36_->query = _tmp7_;
	vls_server_wait_for_context_update (self, _data36_->id, ___lambda71__vls_server_on_context_updated_func, block36_data_ref (_data36_), block36_data_unref);
	block36_data_unref (_data36_);
	_data36_ = NULL;
}

static Block38Data*
block38_data_ref (Block38Data* _data38_)
{
	g_atomic_int_inc (&_data38_->_ref_count_);
	return _data38_;
}

static void
block38_data_unref (void * _userdata_)
{
	Block38Data* _data38_;
	_data38_ = (Block38Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data38_->_ref_count_)) {
		VlsServer* self;
		self = _data38_->self;
		_g_object_unref0 (_data38_->p);
		_g_free0 (_data38_->new_name);
		_g_object_unref0 (_data38_->client);
		_g_free0 (_data38_->method);
		_g_variant_unref0 (_data38_->id);
		_g_object_unref0 (self);
		g_slice_free (Block38Data, _data38_);
	}
}

static gchar*
_variant_get11 (GVariant* value)
{
	return g_variant_dup_string (value, NULL);
}

static void
__lambda74_ (Block38Data* _data38_,
             gboolean request_cancelled)
{
	VlsServer* self;
	LspPosition* pos = NULL;
	LspTextDocumentPositionParams* _tmp0_;
	LspPosition* _tmp1_;
	LspPosition* _tmp2_;
	LspPosition* _tmp3_;
	VlsProject* project = NULL;
	VlsCompilation* compilation = NULL;
	ValaSourceFile* doc = NULL;
	LspTextDocumentPositionParams* _tmp4_;
	LspTextDocumentIdentifier* _tmp5_;
	LspTextDocumentIdentifier* _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	VlsCompilation* _tmp9_ = NULL;
	VlsProject* _tmp10_ = NULL;
	ValaSourceFile* _tmp11_;
	ValaSourceFile* _tmp12_;
	VlsCompilation* _tmp18_;
	ValaCodeContext* _tmp19_;
	ValaCodeContext* _tmp20_;
	VlsNodeSearch* fs = NULL;
	ValaSourceFile* _tmp21_;
	LspPosition* _tmp22_;
	VlsNodeSearch* _tmp23_;
	VlsNodeSearch* _tmp24_;
	GeeList* _tmp25_;
	gint _tmp26_;
	gint _tmp27_;
	ValaCodeNode* _result_ = NULL;
	VlsNodeSearch* _tmp31_;
	ValaSourceFile* _tmp32_;
	ValaCodeNode* _tmp33_;
	ValaSymbol* symbol = NULL;
	GeeHashMap* references = NULL;
	GeeHashMap* _tmp34_;
	gboolean _tmp35_ = FALSE;
	ValaCodeNode* _tmp36_;
	gboolean _tmp56_ = FALSE;
	ValaCodeNode* _tmp57_;
	ValaCodeNode* _tmp63_;
	ValaSymbol* _tmp64_;
	ValaSymbol* _tmp65_;
	gchar* _tmp66_;
	gchar* _tmp67_;
	ValaSymbol* _tmp68_;
	ValaSourceReference* _tmp69_;
	ValaSourceReference* _tmp70_;
	gchar* _tmp71_;
	gchar* _tmp72_;
	GeeHashSet* generated_vapis = NULL;
	GeeHashSet* _tmp73_;
	GeeHashSet* shown_files = NULL;
	GeeHashSet* _tmp87_;
	gboolean _tmp88_ = FALSE;
	gboolean _tmp89_ = FALSE;
	gboolean _tmp90_ = FALSE;
	ValaSymbol* _tmp91_;
	gboolean is_abstract_or_virtual = FALSE;
	GeeHashMap* _tmp183_;
	gint _tmp184_;
	gint _tmp185_;
	GeeHashMap* edits = NULL;
	GeeHashMap* _tmp186_;
	GeeHashMap* source_files = NULL;
	GeeHashMap* _tmp187_;
	JsonArray* text_document_edits_json = NULL;
	JsonArray* _tmp248_;
	GError* _inner_error0_ = NULL;
	self = _data38_->self;
	if (request_cancelled) {
		vls_server_reply_null (_data38_->id, _data38_->client, _data38_->method);
		return;
	}
	_tmp0_ = _data38_->p;
	_tmp1_ = lsp_text_document_position_params_get_position (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = _g_object_ref0 (_tmp2_);
	pos = _tmp3_;
	_tmp4_ = _data38_->p;
	_tmp5_ = lsp_text_document_position_params_get_textDocument (_tmp4_);
	_tmp6_ = _tmp5_;
	_tmp7_ = lsp_text_document_identifier_get_uri (_tmp6_);
	_tmp8_ = _tmp7_;
	_tmp11_ = vls_server_find_file (self, _tmp8_, &_tmp9_, &_tmp10_);
	_g_object_unref0 (compilation);
	compilation = _tmp9_;
	_g_object_unref0 (project);
	project = _tmp10_;
	doc = _tmp11_;
	_tmp12_ = doc;
	if (_tmp12_ == NULL) {
		LspTextDocumentPositionParams* _tmp13_;
		LspTextDocumentIdentifier* _tmp14_;
		LspTextDocumentIdentifier* _tmp15_;
		const gchar* _tmp16_;
		const gchar* _tmp17_;
		_tmp13_ = _data38_->p;
		_tmp14_ = lsp_text_document_position_params_get_textDocument (_tmp13_);
		_tmp15_ = _tmp14_;
		_tmp16_ = lsp_text_document_identifier_get_uri (_tmp15_);
		_tmp17_ = _tmp16_;
		g_debug ("server.vala:1749: [%s] file `%s' not found", _data38_->method, _tmp17_);
		vls_server_reply_null (_data38_->id, _data38_->client, _data38_->method);
		_vala_source_file_unref0 (doc);
		_g_object_unref0 (compilation);
		_g_object_unref0 (project);
		_g_object_unref0 (pos);
		return;
	}
	_tmp18_ = compilation;
	_tmp19_ = vls_compilation_get_code_context (_tmp18_);
	_tmp20_ = _tmp19_;
	vala_code_context_push (_tmp20_);
	_tmp21_ = doc;
	_tmp22_ = pos;
	_tmp23_ = vls_node_search_new (_tmp21_, _tmp22_, TRUE, NULL, TRUE);
	fs = _tmp23_;
	_tmp24_ = fs;
	_tmp25_ = _tmp24_->result;
	_tmp26_ = gee_collection_get_size ((GeeCollection*) _tmp25_);
	_tmp27_ = _tmp26_;
	if (_tmp27_ == 0) {
		const gchar* _tmp28_;
		gchar* _tmp29_;
		gchar* _tmp30_;
		_tmp28_ = string_to_string (_data38_->method);
		_tmp29_ = g_strconcat ("[", _tmp28_, "] no results found", NULL);
		_tmp30_ = _tmp29_;
		g_debug ("server.vala:1759: %s", _tmp30_);
		_g_free0 (_tmp30_);
		vls_server_reply_null (_data38_->id, _data38_->client, _data38_->method);
		vala_code_context_pop ();
		_vala_code_visitor_unref0 (fs);
		_vala_source_file_unref0 (doc);
		_g_object_unref0 (compilation);
		_g_object_unref0 (project);
		_g_object_unref0 (pos);
		return;
	}
	_tmp31_ = fs;
	_tmp32_ = doc;
	_tmp33_ = vls_server_get_best (_tmp31_, _tmp32_);
	_result_ = _tmp33_;
	_tmp34_ = gee_hash_map_new (LSP_TYPE_RANGE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, VALA_TYPE_CODE_NODE, (GBoxedCopyFunc) vala_code_node_ref, (GDestroyNotify) vala_code_node_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	if (_tmp34_) {
		g_object_set_data ((GObject *) _tmp34_, "vala-creation-function", "Vls.Server.rename_symbol._lambda74_");
	}
	references = _tmp34_;
	_tmp36_ = _result_;
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp36_, VALA_TYPE_EXPRESSION)) {
		ValaCodeNode* _tmp37_;
		ValaSymbol* _tmp38_;
		ValaSymbol* _tmp39_;
		_tmp37_ = _result_;
		_tmp38_ = vala_expression_get_symbol_reference (G_TYPE_CHECK_INSTANCE_CAST (_tmp37_, VALA_TYPE_EXPRESSION, ValaExpression));
		_tmp39_ = _tmp38_;
		_tmp35_ = _tmp39_ != NULL;
	} else {
		_tmp35_ = FALSE;
	}
	if (_tmp35_) {
		ValaCodeNode* _tmp40_;
		ValaSymbol* _tmp41_;
		ValaSymbol* _tmp42_;
		ValaCodeNode* _tmp43_;
		_tmp40_ = _result_;
		_tmp41_ = vala_expression_get_symbol_reference (G_TYPE_CHECK_INSTANCE_CAST (_tmp40_, VALA_TYPE_EXPRESSION, ValaExpression));
		_tmp42_ = _tmp41_;
		_tmp43_ = _vala_code_node_ref0 ((ValaCodeNode*) _tmp42_);
		_vala_code_node_unref0 (_result_);
		_result_ = _tmp43_;
	} else {
		ValaCodeNode* _tmp44_;
		_tmp44_ = _result_;
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp44_, VALA_TYPE_DATA_TYPE)) {
			ValaCodeNode* _tmp45_;
			ValaSymbol* _tmp46_;
			_tmp45_ = _result_;
			_tmp46_ = vls_symbol_references_get_symbol_data_type_refers_to (G_TYPE_CHECK_INSTANCE_CAST (_tmp45_, VALA_TYPE_DATA_TYPE, ValaDataType));
			_vala_code_node_unref0 (_result_);
			_result_ = (ValaCodeNode*) _tmp46_;
		} else {
			gboolean _tmp47_ = FALSE;
			ValaCodeNode* _tmp48_;
			_tmp48_ = _result_;
			if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp48_, VALA_TYPE_USING_DIRECTIVE)) {
				ValaCodeNode* _tmp49_;
				ValaSymbol* _tmp50_;
				ValaSymbol* _tmp51_;
				_tmp49_ = _result_;
				_tmp50_ = vala_using_directive_get_namespace_symbol (G_TYPE_CHECK_INSTANCE_CAST (_tmp49_, VALA_TYPE_USING_DIRECTIVE, ValaUsingDirective));
				_tmp51_ = _tmp50_;
				_tmp47_ = _tmp51_ != NULL;
			} else {
				_tmp47_ = FALSE;
			}
			if (_tmp47_) {
				ValaCodeNode* _tmp52_;
				ValaSymbol* _tmp53_;
				ValaSymbol* _tmp54_;
				ValaCodeNode* _tmp55_;
				_tmp52_ = _result_;
				_tmp53_ = vala_using_directive_get_namespace_symbol (G_TYPE_CHECK_INSTANCE_CAST (_tmp52_, VALA_TYPE_USING_DIRECTIVE, ValaUsingDirective));
				_tmp54_ = _tmp53_;
				_tmp55_ = _vala_code_node_ref0 ((ValaCodeNode*) _tmp54_);
				_vala_code_node_unref0 (_result_);
				_result_ = _tmp55_;
			}
		}
	}
	_tmp57_ = _result_;
	if (!G_TYPE_CHECK_INSTANCE_TYPE (_tmp57_, VALA_TYPE_SYMBOL)) {
		_tmp56_ = TRUE;
	} else {
		gboolean _tmp58_ = FALSE;
		ValaCodeNode* _tmp59_;
		_tmp59_ = _result_;
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp59_, VALA_TYPE_METHOD)) {
			ValaCodeNode* _tmp60_;
			gboolean _tmp61_;
			gboolean _tmp62_;
			_tmp60_ = _result_;
			_tmp61_ = vala_method_get_closure (G_TYPE_CHECK_INSTANCE_CAST (_tmp60_, VALA_TYPE_METHOD, ValaMethod));
			_tmp62_ = _tmp61_;
			_tmp58_ = _tmp62_;
		} else {
			_tmp58_ = FALSE;
		}
		_tmp56_ = _tmp58_;
	}
	if (_tmp56_) {
		g_debug ("server.vala:1779: [%s] result is not a symbol", _data38_->method);
		vls_server_reply_null (_data38_->id, _data38_->client, _data38_->method);
		vala_code_context_pop ();
		_g_object_unref0 (references);
		_vala_code_node_unref0 (symbol);
		_vala_code_node_unref0 (_result_);
		_vala_code_visitor_unref0 (fs);
		_vala_source_file_unref0 (doc);
		_g_object_unref0 (compilation);
		_g_object_unref0 (project);
		_g_object_unref0 (pos);
		return;
	}
	_tmp63_ = _result_;
	_tmp64_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp63_, VALA_TYPE_SYMBOL, ValaSymbol));
	_vala_code_node_unref0 (symbol);
	symbol = _tmp64_;
	_tmp65_ = symbol;
	_tmp66_ = vala_symbol_get_full_name (_tmp65_);
	_tmp67_ = _tmp66_;
	_tmp68_ = symbol;
	_tmp69_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp68_);
	_tmp70_ = _tmp69_;
	_tmp71_ = vala_source_reference_to_string (_tmp70_);
	_tmp72_ = _tmp71_;
	g_debug ("server.vala:1787: [%s] got symbol %s @ %s", _data38_->method, _tmp67_, _tmp72_);
	_g_free0 (_tmp72_);
	_g_free0 (_tmp67_);
	_tmp73_ = gee_hash_set_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _vls_util_file_hash_gee_hash_data_func, NULL, NULL, _vls_util_file_equal_gee_equal_data_func, NULL, NULL);
	if (_tmp73_) {
		g_object_set_data ((GObject *) _tmp73_, "vala-creation-function", "Vls.Server.rename_symbol._lambda74_");
	}
	generated_vapis = _tmp73_;
	{
		GeeArrayList* _btarget_list = NULL;
		VlsProject* _tmp74_;
		GeeArrayList* _tmp75_;
		gint _btarget_size = 0;
		GeeArrayList* _tmp76_;
		gint _tmp77_;
		gint _tmp78_;
		gint _btarget_index = 0;
		_tmp74_ = project;
		_tmp75_ = vls_project_get_compilations (_tmp74_);
		_btarget_list = _tmp75_;
		_tmp76_ = _btarget_list;
		_tmp77_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp76_);
		_tmp78_ = _tmp77_;
		_btarget_size = _tmp78_;
		_btarget_index = -1;
		while (TRUE) {
			gint _tmp79_;
			gint _tmp80_;
			VlsCompilation* btarget = NULL;
			GeeArrayList* _tmp81_;
			gpointer _tmp82_;
			GeeHashSet* _tmp83_;
			VlsCompilation* _tmp84_;
			GeeArrayList* _tmp85_;
			GeeArrayList* _tmp86_;
			_btarget_index = _btarget_index + 1;
			_tmp79_ = _btarget_index;
			_tmp80_ = _btarget_size;
			if (!(_tmp79_ < _tmp80_)) {
				break;
			}
			_tmp81_ = _btarget_list;
			_tmp82_ = gee_abstract_list_get ((GeeAbstractList*) _tmp81_, _btarget_index);
			btarget = (VlsCompilation*) _tmp82_;
			_tmp83_ = generated_vapis;
			_tmp84_ = btarget;
			_tmp85_ = vls_build_target_get_output ((VlsBuildTarget*) _tmp84_);
			_tmp86_ = _tmp85_;
			gee_collection_add_all ((GeeCollection*) _tmp83_, (GeeCollection*) _tmp86_);
			_g_object_unref0 (btarget);
		}
		_g_object_unref0 (_btarget_list);
	}
	_tmp87_ = gee_hash_set_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _vls_util_file_hash_gee_hash_data_func, NULL, NULL, _vls_util_file_equal_gee_equal_data_func, NULL, NULL);
	if (_tmp87_) {
		g_object_set_data ((GObject *) _tmp87_, "vala-creation-function", "Vls.Server.rename_symbol._lambda74_");
	}
	shown_files = _tmp87_;
	_tmp91_ = symbol;
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp91_, VALA_TYPE_PROPERTY)) {
		gboolean _tmp92_ = FALSE;
		ValaSymbol* _tmp93_;
		gboolean _tmp94_;
		gboolean _tmp95_;
		_tmp93_ = symbol;
		_tmp94_ = vala_property_get_is_virtual (G_TYPE_CHECK_INSTANCE_CAST (_tmp93_, VALA_TYPE_PROPERTY, ValaProperty));
		_tmp95_ = _tmp94_;
		if (_tmp95_) {
			_tmp92_ = TRUE;
		} else {
			ValaSymbol* _tmp96_;
			gboolean _tmp97_;
			gboolean _tmp98_;
			_tmp96_ = symbol;
			_tmp97_ = vala_property_get_is_abstract (G_TYPE_CHECK_INSTANCE_CAST (_tmp96_, VALA_TYPE_PROPERTY, ValaProperty));
			_tmp98_ = _tmp97_;
			_tmp92_ = _tmp98_;
		}
		_tmp90_ = _tmp92_;
	} else {
		_tmp90_ = FALSE;
	}
	if (_tmp90_) {
		_tmp89_ = TRUE;
	} else {
		gboolean _tmp99_ = FALSE;
		ValaSymbol* _tmp100_;
		_tmp100_ = symbol;
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp100_, VALA_TYPE_METHOD)) {
			gboolean _tmp101_ = FALSE;
			ValaSymbol* _tmp102_;
			gboolean _tmp103_;
			gboolean _tmp104_;
			_tmp102_ = symbol;
			_tmp103_ = vala_method_get_is_virtual (G_TYPE_CHECK_INSTANCE_CAST (_tmp102_, VALA_TYPE_METHOD, ValaMethod));
			_tmp104_ = _tmp103_;
			if (_tmp104_) {
				_tmp101_ = TRUE;
			} else {
				ValaSymbol* _tmp105_;
				gboolean _tmp106_;
				gboolean _tmp107_;
				_tmp105_ = symbol;
				_tmp106_ = vala_method_get_is_abstract (G_TYPE_CHECK_INSTANCE_CAST (_tmp105_, VALA_TYPE_METHOD, ValaMethod));
				_tmp107_ = _tmp106_;
				_tmp101_ = _tmp107_;
			}
			_tmp99_ = _tmp101_;
		} else {
			_tmp99_ = FALSE;
		}
		_tmp89_ = _tmp99_;
	}
	if (_tmp89_) {
		_tmp88_ = TRUE;
	} else {
		gboolean _tmp108_ = FALSE;
		ValaSymbol* _tmp109_;
		_tmp109_ = symbol;
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp109_, VALA_TYPE_SIGNAL)) {
			ValaSymbol* _tmp110_;
			gboolean _tmp111_;
			gboolean _tmp112_;
			_tmp110_ = symbol;
			_tmp111_ = vala_signal_get_is_virtual (G_TYPE_CHECK_INSTANCE_CAST (_tmp110_, VALA_TYPE_SIGNAL, ValaSignal));
			_tmp112_ = _tmp111_;
			_tmp108_ = _tmp112_;
		} else {
			_tmp108_ = FALSE;
		}
		_tmp88_ = _tmp108_;
	}
	is_abstract_or_virtual = _tmp88_;
	{
		GeeIterator* _btarget_w_sym_it = NULL;
		VlsProject* _tmp113_;
		ValaSymbol* _tmp114_;
		GeeCollection* _tmp115_;
		GeeCollection* _tmp116_;
		GeeIterator* _tmp117_;
		GeeIterator* _tmp118_;
		_tmp113_ = project;
		_tmp114_ = symbol;
		_tmp115_ = vls_symbol_references_get_compilations_using_symbol (_tmp113_, _tmp114_);
		_tmp116_ = _tmp115_;
		_tmp117_ = gee_iterable_iterator ((GeeIterable*) _tmp116_);
		_tmp118_ = _tmp117_;
		_g_object_unref0 (_tmp116_);
		_btarget_w_sym_it = _tmp118_;
		while (TRUE) {
			GeeIterator* _tmp119_;
			VlsPair* btarget_w_sym = NULL;
			GeeIterator* _tmp120_;
			gpointer _tmp121_;
			_tmp119_ = _btarget_w_sym_it;
			if (!gee_iterator_next (_tmp119_)) {
				break;
			}
			_tmp120_ = _btarget_w_sym_it;
			_tmp121_ = gee_iterator_get (_tmp120_);
			btarget_w_sym = (VlsPair*) _tmp121_;
			{
				ValaList* _project_file_list = NULL;
				VlsPair* _tmp122_;
				gconstpointer _tmp123_;
				gconstpointer _tmp124_;
				ValaCodeContext* _tmp125_;
				ValaCodeContext* _tmp126_;
				ValaList* _tmp127_;
				gint _project_file_size = 0;
				ValaList* _tmp128_;
				gint _tmp129_;
				gint _tmp130_;
				gint _project_file_index = 0;
				_tmp122_ = btarget_w_sym;
				_tmp123_ = vls_pair_get_first (_tmp122_);
				_tmp124_ = _tmp123_;
				_tmp125_ = vls_compilation_get_code_context ((VlsCompilation*) _tmp124_);
				_tmp126_ = _tmp125_;
				_tmp127_ = vala_code_context_get_source_files (_tmp126_);
				_project_file_list = _tmp127_;
				_tmp128_ = _project_file_list;
				_tmp129_ = vala_collection_get_size ((ValaCollection*) _tmp128_);
				_tmp130_ = _tmp129_;
				_project_file_size = _tmp130_;
				_project_file_index = -1;
				while (TRUE) {
					gint _tmp131_;
					gint _tmp132_;
					ValaSourceFile* project_file = NULL;
					ValaList* _tmp133_;
					gpointer _tmp134_;
					GFile* file = NULL;
					ValaSourceFile* _tmp135_;
					const gchar* _tmp136_;
					const gchar* _tmp137_;
					GFile* _tmp138_;
					gboolean _tmp139_ = FALSE;
					GeeHashSet* _tmp140_;
					GFile* _tmp141_;
					GeeHashMap* file_references = NULL;
					GeeHashMap* _tmp144_;
					GFile* _tmp145_;
					gchar* _tmp146_;
					gchar* _tmp147_;
					ValaSourceFile* _tmp148_;
					VlsPair* _tmp149_;
					gconstpointer _tmp150_;
					gconstpointer _tmp151_;
					GeeHashMap* _tmp152_;
					gboolean _tmp161_ = FALSE;
					ValaSourceFile* _tmp162_;
					GeeHashSet* _tmp181_;
					GFile* _tmp182_;
					_project_file_index = _project_file_index + 1;
					_tmp131_ = _project_file_index;
					_tmp132_ = _project_file_size;
					if (!(_tmp131_ < _tmp132_)) {
						break;
					}
					_tmp133_ = _project_file_list;
					_tmp134_ = vala_list_get (_tmp133_, _project_file_index);
					project_file = (ValaSourceFile*) _tmp134_;
					_tmp135_ = project_file;
					_tmp136_ = vala_source_file_get_filename (_tmp135_);
					_tmp137_ = _tmp136_;
					_tmp138_ = g_file_new_for_commandline_arg (_tmp137_);
					file = _tmp138_;
					_tmp140_ = generated_vapis;
					_tmp141_ = file;
					if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp140_, _tmp141_)) {
						_tmp139_ = TRUE;
					} else {
						GeeHashSet* _tmp142_;
						GFile* _tmp143_;
						_tmp142_ = shown_files;
						_tmp143_ = file;
						_tmp139_ = gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp142_, _tmp143_);
					}
					if (_tmp139_) {
						_g_object_unref0 (file);
						_vala_source_file_unref0 (project_file);
						continue;
					}
					_tmp144_ = gee_hash_map_new (LSP_TYPE_RANGE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, VALA_TYPE_CODE_NODE, (GBoxedCopyFunc) vala_code_node_ref, (GDestroyNotify) vala_code_node_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
					if (_tmp144_) {
						g_object_set_data ((GObject *) _tmp144_, "vala-creation-function", "Vls.Server.rename_symbol._lambda74_");
					}
					file_references = _tmp144_;
					_tmp145_ = file;
					_tmp146_ = g_file_get_uri (_tmp145_);
					_tmp147_ = _tmp146_;
					g_debug ("server.vala:1805: [%s] looking for references in %s ...", _data38_->method, _tmp147_);
					_g_free0 (_tmp147_);
					_tmp148_ = project_file;
					_tmp149_ = btarget_w_sym;
					_tmp150_ = vls_pair_get_second (_tmp149_);
					_tmp151_ = _tmp150_;
					_tmp152_ = file_references;
					vls_symbol_references_list_in_file (_tmp148_, (ValaSymbol*) _tmp151_, TRUE, FALSE, _tmp152_);
					if (is_abstract_or_virtual) {
						GFile* _tmp153_;
						gchar* _tmp154_;
						gchar* _tmp155_;
						ValaSourceFile* _tmp156_;
						VlsPair* _tmp157_;
						gconstpointer _tmp158_;
						gconstpointer _tmp159_;
						GeeHashMap* _tmp160_;
						_tmp153_ = file;
						_tmp154_ = g_file_get_uri (_tmp153_);
						_tmp155_ = _tmp154_;
						g_debug ("server.vala:1808: [%s] looking for implementations of abstract/virtual" \
" symbol in %s ...", _data38_->method, _tmp155_);
						_g_free0 (_tmp155_);
						_tmp156_ = project_file;
						_tmp157_ = btarget_w_sym;
						_tmp158_ = vls_pair_get_second (_tmp157_);
						_tmp159_ = _tmp158_;
						_tmp160_ = file_references;
						vls_symbol_references_list_implementations_of_virtual_symbol (_tmp156_, (ValaSymbol*) _tmp159_, _tmp160_);
					}
					_tmp162_ = project_file;
					if (!VLS_IS_TEXT_DOCUMENT (_tmp162_)) {
						GeeHashMap* _tmp163_;
						gint _tmp164_;
						gint _tmp165_;
						_tmp163_ = file_references;
						_tmp164_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp163_);
						_tmp165_ = _tmp164_;
						_tmp161_ = _tmp165_ > 0;
					} else {
						_tmp161_ = FALSE;
					}
					if (_tmp161_) {
						ValaSourceFile* _tmp166_;
						const gchar* _tmp167_;
						const gchar* _tmp168_;
						_tmp166_ = project_file;
						_tmp167_ = vala_source_file_get_filename (_tmp166_);
						_tmp168_ = _tmp167_;
						g_debug ("server.vala:1814: [%s] disallowing requested modification of %s", _data38_->method, _tmp168_);
						vls_server_reply_null (_data38_->id, _data38_->client, _data38_->method);
						vala_code_context_pop ();
						_g_object_unref0 (file_references);
						_g_object_unref0 (file);
						_vala_source_file_unref0 (project_file);
						_g_object_unref0 (btarget_w_sym);
						_g_object_unref0 (_btarget_w_sym_it);
						_g_object_unref0 (shown_files);
						_g_object_unref0 (generated_vapis);
						_g_object_unref0 (references);
						_vala_code_node_unref0 (symbol);
						_vala_code_node_unref0 (_result_);
						_vala_code_visitor_unref0 (fs);
						_vala_source_file_unref0 (doc);
						_g_object_unref0 (compilation);
						_g_object_unref0 (project);
						_g_object_unref0 (pos);
						return;
					}
					{
						GeeIterator* _entry_it = NULL;
						GeeHashMap* _tmp169_;
						GeeIterator* _tmp170_;
						_tmp169_ = file_references;
						_tmp170_ = gee_iterable_iterator ((GeeIterable*) _tmp169_);
						_entry_it = _tmp170_;
						while (TRUE) {
							GeeIterator* _tmp171_;
							GeeMapEntry* entry = NULL;
							GeeIterator* _tmp172_;
							gpointer _tmp173_;
							GeeHashMap* _tmp174_;
							GeeMapEntry* _tmp175_;
							gconstpointer _tmp176_;
							gconstpointer _tmp177_;
							GeeMapEntry* _tmp178_;
							gconstpointer _tmp179_;
							gconstpointer _tmp180_;
							_tmp171_ = _entry_it;
							if (!gee_iterator_next (_tmp171_)) {
								break;
							}
							_tmp172_ = _entry_it;
							_tmp173_ = gee_iterator_get (_tmp172_);
							entry = (GeeMapEntry*) _tmp173_;
							_tmp174_ = references;
							_tmp175_ = entry;
							_tmp176_ = gee_map_entry_get_key (_tmp175_);
							_tmp177_ = _tmp176_;
							_tmp178_ = entry;
							_tmp179_ = gee_map_entry_get_value (_tmp178_);
							_tmp180_ = _tmp179_;
							gee_abstract_map_set ((GeeAbstractMap*) _tmp174_, (LspRange*) _tmp177_, (ValaCodeNode*) _tmp180_);
							_g_object_unref0 (entry);
						}
						_g_object_unref0 (_entry_it);
					}
					_tmp181_ = shown_files;
					_tmp182_ = file;
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp181_, _tmp182_);
					_g_object_unref0 (file_references);
					_g_object_unref0 (file);
					_vala_source_file_unref0 (project_file);
				}
			}
			_g_object_unref0 (btarget_w_sym);
		}
		_g_object_unref0 (_btarget_w_sym_it);
	}
	_tmp183_ = references;
	_tmp184_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp183_);
	_tmp185_ = _tmp184_;
	g_debug ("server.vala:1824: [%s] found %d references", _data38_->method, _tmp185_);
	_tmp186_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, GEE_TYPE_ARRAY_LIST, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	if (_tmp186_) {
		g_object_set_data ((GObject *) _tmp186_, "vala-creation-function", "Vls.Server.rename_symbol._lambda74_");
	}
	edits = _tmp186_;
	_tmp187_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, VALA_TYPE_SOURCE_FILE, (GBoxedCopyFunc) vala_source_file_ref, (GDestroyNotify) vala_source_file_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	if (_tmp187_) {
		g_object_set_data ((GObject *) _tmp187_, "vala-creation-function", "Vls.Server.rename_symbol._lambda74_");
	}
	source_files = _tmp187_;
	{
		GeeIterator* _entry_it = NULL;
		GeeHashMap* _tmp188_;
		GeeIterator* _tmp189_;
		_tmp188_ = references;
		_tmp189_ = gee_iterable_iterator ((GeeIterable*) _tmp188_);
		_entry_it = _tmp189_;
		while (TRUE) {
			GeeIterator* _tmp190_;
			GeeMapEntry* entry = NULL;
			GeeIterator* _tmp191_;
			gpointer _tmp192_;
			ValaCodeNode* code_node = NULL;
			GeeMapEntry* _tmp193_;
			gconstpointer _tmp194_;
			gconstpointer _tmp195_;
			ValaCodeNode* _tmp196_;
			LspRange* source_range = NULL;
			GeeMapEntry* _tmp197_;
			gconstpointer _tmp198_;
			gconstpointer _tmp199_;
			LspRange* _tmp200_;
			ValaCodeNode* _tmp201_;
			gchar* _tmp202_;
			gchar* _tmp203_;
			ValaCodeNode* _tmp204_;
			ValaSourceReference* _tmp205_;
			ValaSourceReference* _tmp206_;
			gchar* _tmp207_;
			gchar* _tmp208_;
			GFile* file = NULL;
			ValaCodeNode* _tmp209_;
			ValaSourceReference* _tmp210_;
			ValaSourceReference* _tmp211_;
			ValaSourceFile* _tmp212_;
			ValaSourceFile* _tmp213_;
			const gchar* _tmp214_;
			const gchar* _tmp215_;
			GFile* _tmp216_;
			GeeHashMap* _tmp217_;
			GFile* _tmp218_;
			gchar* _tmp219_;
			gchar* _tmp220_;
			gboolean _tmp221_;
			GeeArrayList* file_edits = NULL;
			GeeHashMap* _tmp228_;
			GFile* _tmp229_;
			gchar* _tmp230_;
			gchar* _tmp231_;
			gpointer _tmp232_;
			GeeArrayList* _tmp233_;
			GeeArrayList* _tmp234_;
			LspRange* _tmp235_;
			const gchar* _tmp236_;
			LspTextEdit* _tmp237_;
			LspTextEdit* _tmp238_;
			GeeHashMap* _tmp239_;
			GFile* _tmp240_;
			gchar* _tmp241_;
			gchar* _tmp242_;
			ValaCodeNode* _tmp243_;
			ValaSourceReference* _tmp244_;
			ValaSourceReference* _tmp245_;
			ValaSourceFile* _tmp246_;
			ValaSourceFile* _tmp247_;
			_tmp190_ = _entry_it;
			if (!gee_iterator_next (_tmp190_)) {
				break;
			}
			_tmp191_ = _entry_it;
			_tmp192_ = gee_iterator_get (_tmp191_);
			entry = (GeeMapEntry*) _tmp192_;
			_tmp193_ = entry;
			_tmp194_ = gee_map_entry_get_value (_tmp193_);
			_tmp195_ = _tmp194_;
			_tmp196_ = _vala_code_node_ref0 ((ValaCodeNode*) _tmp195_);
			code_node = _tmp196_;
			_tmp197_ = entry;
			_tmp198_ = gee_map_entry_get_key (_tmp197_);
			_tmp199_ = _tmp198_;
			_tmp200_ = _g_object_ref0 ((LspRange*) _tmp199_);
			source_range = _tmp200_;
			_tmp201_ = code_node;
			_tmp202_ = vls_code_help_get_code_node_source (_tmp201_);
			_tmp203_ = _tmp202_;
			_tmp204_ = code_node;
			_tmp205_ = vala_code_node_get_source_reference (_tmp204_);
			_tmp206_ = _tmp205_;
			_tmp207_ = vala_source_reference_to_string (_tmp206_);
			_tmp208_ = _tmp207_;
			g_debug ("server.vala:1834: [%s] editing reference %s @ %s ...", _data38_->method, _tmp203_, _tmp208_);
			_g_free0 (_tmp208_);
			_g_free0 (_tmp203_);
			_tmp209_ = code_node;
			_tmp210_ = vala_code_node_get_source_reference (_tmp209_);
			_tmp211_ = _tmp210_;
			_tmp212_ = vala_source_reference_get_file (_tmp211_);
			_tmp213_ = _tmp212_;
			_tmp214_ = vala_source_file_get_filename (_tmp213_);
			_tmp215_ = _tmp214_;
			_tmp216_ = g_file_new_for_commandline_arg (_tmp215_);
			file = _tmp216_;
			_tmp217_ = edits;
			_tmp218_ = file;
			_tmp219_ = g_file_get_uri (_tmp218_);
			_tmp220_ = _tmp219_;
			_tmp221_ = !gee_abstract_map_has_key ((GeeAbstractMap*) _tmp217_, _tmp220_);
			_g_free0 (_tmp220_);
			if (_tmp221_) {
				GeeHashMap* _tmp222_;
				GFile* _tmp223_;
				gchar* _tmp224_;
				gchar* _tmp225_;
				GeeArrayList* _tmp226_;
				GeeArrayList* _tmp227_;
				_tmp222_ = edits;
				_tmp223_ = file;
				_tmp224_ = g_file_get_uri (_tmp223_);
				_tmp225_ = _tmp224_;
				_tmp226_ = gee_array_list_new (LSP_TYPE_TEXT_EDIT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
				if (_tmp226_) {
					g_object_set_data ((GObject *) _tmp226_, "vala-creation-function", "Vls.Server.rename_symbol._lambda74_");
				}
				_tmp227_ = _tmp226_;
				gee_abstract_map_set ((GeeAbstractMap*) _tmp222_, _tmp225_, _tmp227_);
				_g_object_unref0 (_tmp227_);
				_g_free0 (_tmp225_);
			}
			_tmp228_ = edits;
			_tmp229_ = file;
			_tmp230_ = g_file_get_uri (_tmp229_);
			_tmp231_ = _tmp230_;
			_tmp232_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp228_, _tmp231_);
			_tmp233_ = (GeeArrayList*) _tmp232_;
			_g_free0 (_tmp231_);
			file_edits = _tmp233_;
			_tmp234_ = file_edits;
			_tmp235_ = source_range;
			_tmp236_ = _data38_->new_name;
			_tmp237_ = lsp_text_edit_new (_tmp235_, _tmp236_);
			if (_tmp237_) {
				g_object_set_data ((GObject *) _tmp237_, "vala-creation-function", "Vls.Server.rename_symbol._lambda74_");
			}
			_tmp238_ = _tmp237_;
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp234_, _tmp238_);
			_g_object_unref0 (_tmp238_);
			_tmp239_ = source_files;
			_tmp240_ = file;
			_tmp241_ = g_file_get_uri (_tmp240_);
			_tmp242_ = _tmp241_;
			_tmp243_ = code_node;
			_tmp244_ = vala_code_node_get_source_reference (_tmp243_);
			_tmp245_ = _tmp244_;
			_tmp246_ = vala_source_reference_get_file (_tmp245_);
			_tmp247_ = _tmp246_;
			gee_abstract_map_set ((GeeAbstractMap*) _tmp239_, _tmp242_, _tmp247_);
			_g_free0 (_tmp242_);
			_g_object_unref0 (file_edits);
			_g_object_unref0 (file);
			_g_object_unref0 (source_range);
			_vala_code_node_unref0 (code_node);
			_g_object_unref0 (entry);
		}
		_g_object_unref0 (_entry_it);
	}
	_tmp248_ = json_array_new ();
	text_document_edits_json = _tmp248_;
	{
		GeeIterator* _uri_it = NULL;
		GeeHashMap* _tmp249_;
		GeeSet* _tmp250_;
		GeeSet* _tmp251_;
		GeeSet* _tmp252_;
		GeeIterator* _tmp253_;
		GeeIterator* _tmp254_;
		_tmp249_ = edits;
		_tmp250_ = gee_abstract_map_get_keys ((GeeAbstractMap*) _tmp249_);
		_tmp251_ = _tmp250_;
		_tmp252_ = _tmp251_;
		_tmp253_ = gee_iterable_iterator ((GeeIterable*) _tmp252_);
		_tmp254_ = _tmp253_;
		_g_object_unref0 (_tmp252_);
		_uri_it = _tmp254_;
		while (TRUE) {
			GeeIterator* _tmp255_;
			gchar* uri = NULL;
			GeeIterator* _tmp256_;
			gpointer _tmp257_;
			LspVersionedTextDocumentIdentifier* document_id = NULL;
			GeeHashMap* _tmp258_;
			const gchar* _tmp259_;
			gpointer _tmp260_;
			VlsTextDocument* _tmp261_;
			gint _tmp262_;
			gint _tmp263_;
			const gchar* _tmp264_;
			gchar* _tmp265_;
			LspVersionedTextDocumentIdentifier* _tmp266_ = NULL;
			LspVersionedTextDocumentIdentifier* _tmp267_;
			JsonArray* _tmp268_;
			LspVersionedTextDocumentIdentifier* _tmp269_;
			GeeHashMap* _tmp270_;
			const gchar* _tmp271_;
			gpointer _tmp272_;
			LspTextDocumentEdit* _tmp273_ = NULL;
			LspTextDocumentEdit* _tmp274_;
			JsonNode* _tmp275_;
			_tmp255_ = _uri_it;
			if (!gee_iterator_next (_tmp255_)) {
				break;
			}
			_tmp256_ = _uri_it;
			_tmp257_ = gee_iterator_get (_tmp256_);
			uri = (gchar*) _tmp257_;
			_tmp258_ = source_files;
			_tmp259_ = uri;
			_tmp260_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp258_, _tmp259_);
			_tmp261_ = G_TYPE_CHECK_INSTANCE_CAST ((ValaSourceFile*) _tmp260_, VLS_TYPE_TEXT_DOCUMENT, VlsTextDocument);
			_tmp262_ = vls_text_document_get_version (_tmp261_);
			_tmp263_ = _tmp262_;
			_tmp264_ = uri;
			_tmp265_ = g_strdup (_tmp264_);
			_tmp266_ = lsp_versioned_text_document_identifier_new ();
			lsp_versioned_text_document_identifier_set_version (_tmp266_, _tmp263_);
			lsp_text_document_identifier_set_uri ((LspTextDocumentIdentifier*) _tmp266_, _tmp265_);
			_g_free0 (_tmp265_);
			_tmp267_ = _tmp266_;
			_vala_source_file_unref0 (_tmp261_);
			document_id = _tmp267_;
			_tmp268_ = text_document_edits_json;
			_tmp269_ = document_id;
			_tmp270_ = edits;
			_tmp271_ = uri;
			_tmp272_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp270_, _tmp271_);
			_tmp273_ = lsp_text_document_edit_new (_tmp269_);
			lsp_text_document_edit_set_edits (_tmp273_, (GeeArrayList*) _tmp272_);
			_g_object_unref0 (_tmp272_);
			_tmp274_ = _tmp273_;
			_tmp275_ = json_gobject_serialize ((GObject*) _tmp274_);
			json_array_add_element (_tmp268_, _tmp275_);
			_g_object_unref0 (_tmp274_);
			_g_object_unref0 (document_id);
			_g_free0 (uri);
		}
		_g_object_unref0 (_uri_it);
	}
	{
		GVariant* changes = NULL;
		JsonNode* _tmp276_;
		JsonNode* _tmp277_;
		JsonArray* _tmp278_;
		JsonNode* _tmp279_;
		GVariant* _tmp280_;
		GVariant* _tmp281_;
		GVariant* _tmp282_;
		GVariant* _tmp283_;
		GVariant* _tmp284_;
		GCancellable* _tmp285_;
		_tmp276_ = json_node_alloc ();
		_tmp277_ = _tmp276_;
		_tmp278_ = text_document_edits_json;
		_tmp279_ = json_node_init_array (_tmp277_, _tmp278_);
		_tmp280_ = json_gvariant_deserialize (_tmp279_, NULL, &_inner_error0_);
		if (_tmp280_ != NULL) {
			g_variant_ref_sink (_tmp280_);
		}
		_tmp281_ = _tmp280_;
		__vala_JsonNode_free0 (_tmp277_);
		changes = _tmp281_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp282_ = changes;
		_tmp283_ = vls_server_build_dict (self, "documentChanges", _tmp282_, NULL);
		_tmp284_ = _tmp283_;
		_tmp285_ = vls_server_cancellable;
		jsonrpc_client_reply (_data38_->client, _data38_->id, _tmp284_, _tmp285_, &_inner_error0_);
		_g_variant_unref0 (_tmp284_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_variant_unref0 (changes);
			goto __catch0_g_error;
		}
		_g_variant_unref0 (changes);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp286_;
		const gchar* _tmp287_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp286_ = e;
		_tmp287_ = _tmp286_->message;
		g_warning ("server.vala:1868: [%s] failed to reply to client - %s", _data38_->method, _tmp287_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_json_array_unref0 (text_document_edits_json);
		_g_object_unref0 (source_files);
		_g_object_unref0 (edits);
		_g_object_unref0 (shown_files);
		_g_object_unref0 (generated_vapis);
		_g_object_unref0 (references);
		_vala_code_node_unref0 (symbol);
		_vala_code_node_unref0 (_result_);
		_vala_code_visitor_unref0 (fs);
		_vala_source_file_unref0 (doc);
		_g_object_unref0 (compilation);
		_g_object_unref0 (project);
		_g_object_unref0 (pos);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	vala_code_context_pop ();
	_json_array_unref0 (text_document_edits_json);
	_g_object_unref0 (source_files);
	_g_object_unref0 (edits);
	_g_object_unref0 (shown_files);
	_g_object_unref0 (generated_vapis);
	_g_object_unref0 (references);
	_vala_code_node_unref0 (symbol);
	_vala_code_node_unref0 (_result_);
	_vala_code_visitor_unref0 (fs);
	_vala_source_file_unref0 (doc);
	_g_object_unref0 (compilation);
	_g_object_unref0 (project);
	_g_object_unref0 (pos);
}

static void
___lambda74__vls_server_on_context_updated_func (gboolean request_cancelled,
                                                 gpointer self)
{
	__lambda74_ (self, request_cancelled);
}

static void
vls_server_rename_symbol (VlsServer* self,
                          JsonrpcClient* client,
                          const gchar* method,
                          GVariant* id,
                          GVariant* params)
{
	Block38Data* _data38_;
	JsonrpcClient* _tmp0_;
	gchar* _tmp1_;
	GVariant* _tmp2_;
	const GVariantType* _tmp3_;
	GVariant* _tmp4_;
	GVariant* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	const gchar* _tmp8_;
	gpointer _tmp10_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (client != NULL);
	g_return_if_fail (method != NULL);
	g_return_if_fail (id != NULL);
	g_return_if_fail (params != NULL);
	_data38_ = g_slice_new0 (Block38Data);
	_data38_->_ref_count_ = 1;
	_data38_->self = g_object_ref (self);
	_tmp0_ = _g_object_ref0 (client);
	_g_object_unref0 (_data38_->client);
	_data38_->client = _tmp0_;
	_tmp1_ = g_strdup (method);
	_g_free0 (_data38_->method);
	_data38_->method = _tmp1_;
	_tmp2_ = _g_variant_ref0 (id);
	_g_variant_unref0 (_data38_->id);
	_data38_->id = _tmp2_;
	_tmp3_ = G_VARIANT_TYPE_STRING;
	_tmp4_ = g_variant_lookup_value (params, "newName", _tmp3_);
	_tmp5_ = _tmp4_;
	_tmp6_ = _variant_get11 (_tmp5_);
	_tmp7_ = _tmp6_;
	_g_variant_unref0 (_tmp5_);
	_data38_->new_name = _tmp7_;
	_tmp8_ = _data38_->new_name;
	if (!g_regex_match (_thread_safe_regex_init (&_tmp_regex_1, "^(?=[^\\d])[^\\s~`!#%^&*()\\-\\+={}\\[\\]|\\\\\\/?.>,<'\";:]+$", 0), _tmp8_, 0, NULL)) {
		GCancellable* _tmp9_;
		_tmp9_ = vls_server_cancellable;
		jsonrpc_client_reply_error_async (_data38_->client, _data38_->id, (gint) JSONRPC_CLIENT_ERROR_INVALID_REQUEST, "Invalid symbol name. Symbol names cannot start with a number and must " \
"not contain any operators.", _tmp9_, NULL, NULL);
		block38_data_unref (_data38_);
		_data38_ = NULL;
		return;
	}
	_tmp10_ = vls_util_parse_variant (LSP_TYPE_TEXT_DOCUMENT_POSITION_PARAMS, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, params);
	_data38_->p = (LspTextDocumentPositionParams*) _tmp10_;
	vls_server_wait_for_context_update (self, _data38_->id, ___lambda74__vls_server_on_context_updated_func, block38_data_ref (_data38_), block38_data_unref);
	block38_data_unref (_data38_);
	_data38_ = NULL;
}

static Block39Data*
block39_data_ref (Block39Data* _data39_)
{
	g_atomic_int_inc (&_data39_->_ref_count_);
	return _data39_;
}

static void
block39_data_unref (void * _userdata_)
{
	Block39Data* _data39_;
	_data39_ = (Block39Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data39_->_ref_count_)) {
		VlsServer* self;
		self = _data39_->self;
		_g_object_unref0 (_data39_->p);
		_g_object_unref0 (_data39_->client);
		_g_free0 (_data39_->method);
		_g_variant_unref0 (_data39_->id);
		_g_object_unref0 (self);
		g_slice_free (Block39Data, _data39_);
	}
}

static void
__lambda75_ (Block39Data* _data39_,
             gboolean request_cancelled)
{
	VlsServer* self;
	LspPosition* pos = NULL;
	LspPosition* _tmp0_;
	LspPosition* _tmp1_;
	LspPosition* _tmp2_;
	VlsProject* project = NULL;
	VlsCompilation* compilation = NULL;
	ValaSourceFile* doc = NULL;
	LspTextDocumentIdentifier* _tmp3_;
	LspTextDocumentIdentifier* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	VlsCompilation* _tmp7_ = NULL;
	VlsProject* _tmp8_ = NULL;
	ValaSourceFile* _tmp9_;
	ValaSourceFile* _tmp10_;
	VlsCompilation* _tmp15_;
	ValaCodeContext* _tmp16_;
	ValaCodeContext* _tmp17_;
	VlsNodeSearch* fs = NULL;
	ValaSourceFile* _tmp18_;
	LspPosition* _tmp19_;
	VlsNodeSearch* _tmp20_;
	VlsNodeSearch* _tmp21_;
	GeeList* _tmp22_;
	gint _tmp23_;
	gint _tmp24_;
	ValaCodeNode* initial_result = NULL;
	VlsNodeSearch* _tmp26_;
	ValaSourceFile* _tmp27_;
	ValaCodeNode* _tmp28_;
	ValaCodeNode* _result_ = NULL;
	ValaCodeNode* _tmp29_;
	ValaCodeNode* _tmp30_;
	ValaSymbol* symbol = NULL;
	gboolean _tmp31_ = FALSE;
	ValaCodeNode* _tmp32_;
	gboolean _tmp52_ = FALSE;
	ValaCodeNode* _tmp53_;
	ValaCodeNode* _tmp60_;
	ValaSymbol* _tmp61_;
	LspRange* replacement_range = NULL;
	ValaCodeNode* _tmp62_;
	ValaSymbol* _tmp63_;
	LspRange* _tmp64_;
	gboolean _tmp65_ = FALSE;
	LspRange* _tmp66_;
	GError* _inner_error0_ = NULL;
	self = _data39_->self;
	if (request_cancelled) {
		vls_server_reply_null (_data39_->id, _data39_->client, _data39_->method);
		return;
	}
	_tmp0_ = lsp_text_document_position_params_get_position (_data39_->p);
	_tmp1_ = _tmp0_;
	_tmp2_ = _g_object_ref0 (_tmp1_);
	pos = _tmp2_;
	_tmp3_ = lsp_text_document_position_params_get_textDocument (_data39_->p);
	_tmp4_ = _tmp3_;
	_tmp5_ = lsp_text_document_identifier_get_uri (_tmp4_);
	_tmp6_ = _tmp5_;
	_tmp9_ = vls_server_find_file (self, _tmp6_, &_tmp7_, &_tmp8_);
	_g_object_unref0 (compilation);
	compilation = _tmp7_;
	_g_object_unref0 (project);
	project = _tmp8_;
	doc = _tmp9_;
	_tmp10_ = doc;
	if (_tmp10_ == NULL) {
		LspTextDocumentIdentifier* _tmp11_;
		LspTextDocumentIdentifier* _tmp12_;
		const gchar* _tmp13_;
		const gchar* _tmp14_;
		_tmp11_ = lsp_text_document_position_params_get_textDocument (_data39_->p);
		_tmp12_ = _tmp11_;
		_tmp13_ = lsp_text_document_identifier_get_uri (_tmp12_);
		_tmp14_ = _tmp13_;
		g_debug ("server.vala:1889: [%s] file `%s' not found", _data39_->method, _tmp14_);
		vls_server_reply_null (_data39_->id, _data39_->client, _data39_->method);
		_vala_source_file_unref0 (doc);
		_g_object_unref0 (compilation);
		_g_object_unref0 (project);
		_g_object_unref0 (pos);
		return;
	}
	_tmp15_ = compilation;
	_tmp16_ = vls_compilation_get_code_context (_tmp15_);
	_tmp17_ = _tmp16_;
	vala_code_context_push (_tmp17_);
	_tmp18_ = doc;
	_tmp19_ = pos;
	_tmp20_ = vls_node_search_new (_tmp18_, _tmp19_, TRUE, NULL, TRUE);
	fs = _tmp20_;
	_tmp21_ = fs;
	_tmp22_ = _tmp21_->result;
	_tmp23_ = gee_collection_get_size ((GeeCollection*) _tmp22_);
	_tmp24_ = _tmp23_;
	if (_tmp24_ == 0) {
		GCancellable* _tmp25_;
		_tmp25_ = vls_server_cancellable;
		jsonrpc_client_reply_error_async (_data39_->client, _data39_->id, (gint) JSONRPC_CLIENT_ERROR_INVALID_REQUEST, "There is no symbol at the cursor.", _tmp25_, NULL, NULL);
		vala_code_context_pop ();
		_vala_code_visitor_unref0 (fs);
		_vala_source_file_unref0 (doc);
		_g_object_unref0 (compilation);
		_g_object_unref0 (project);
		_g_object_unref0 (pos);
		return;
	}
	_tmp26_ = fs;
	_tmp27_ = doc;
	_tmp28_ = vls_server_get_best (_tmp26_, _tmp27_);
	initial_result = _tmp28_;
	_tmp29_ = initial_result;
	_tmp30_ = _vala_code_node_ref0 (_tmp29_);
	_result_ = _tmp30_;
	_tmp32_ = _result_;
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp32_, VALA_TYPE_EXPRESSION)) {
		ValaCodeNode* _tmp33_;
		ValaSymbol* _tmp34_;
		ValaSymbol* _tmp35_;
		_tmp33_ = _result_;
		_tmp34_ = vala_expression_get_symbol_reference (G_TYPE_CHECK_INSTANCE_CAST (_tmp33_, VALA_TYPE_EXPRESSION, ValaExpression));
		_tmp35_ = _tmp34_;
		_tmp31_ = _tmp35_ != NULL;
	} else {
		_tmp31_ = FALSE;
	}
	if (_tmp31_) {
		ValaCodeNode* _tmp36_;
		ValaSymbol* _tmp37_;
		ValaSymbol* _tmp38_;
		ValaCodeNode* _tmp39_;
		_tmp36_ = _result_;
		_tmp37_ = vala_expression_get_symbol_reference (G_TYPE_CHECK_INSTANCE_CAST (_tmp36_, VALA_TYPE_EXPRESSION, ValaExpression));
		_tmp38_ = _tmp37_;
		_tmp39_ = _vala_code_node_ref0 ((ValaCodeNode*) _tmp38_);
		_vala_code_node_unref0 (_result_);
		_result_ = _tmp39_;
	} else {
		ValaCodeNode* _tmp40_;
		_tmp40_ = _result_;
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp40_, VALA_TYPE_DATA_TYPE)) {
			ValaCodeNode* _tmp41_;
			ValaSymbol* _tmp42_;
			_tmp41_ = _result_;
			_tmp42_ = vls_symbol_references_get_symbol_data_type_refers_to (G_TYPE_CHECK_INSTANCE_CAST (_tmp41_, VALA_TYPE_DATA_TYPE, ValaDataType));
			_vala_code_node_unref0 (_result_);
			_result_ = (ValaCodeNode*) _tmp42_;
		} else {
			gboolean _tmp43_ = FALSE;
			ValaCodeNode* _tmp44_;
			_tmp44_ = _result_;
			if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp44_, VALA_TYPE_USING_DIRECTIVE)) {
				ValaCodeNode* _tmp45_;
				ValaSymbol* _tmp46_;
				ValaSymbol* _tmp47_;
				_tmp45_ = _result_;
				_tmp46_ = vala_using_directive_get_namespace_symbol (G_TYPE_CHECK_INSTANCE_CAST (_tmp45_, VALA_TYPE_USING_DIRECTIVE, ValaUsingDirective));
				_tmp47_ = _tmp46_;
				_tmp43_ = _tmp47_ != NULL;
			} else {
				_tmp43_ = FALSE;
			}
			if (_tmp43_) {
				ValaCodeNode* _tmp48_;
				ValaSymbol* _tmp49_;
				ValaSymbol* _tmp50_;
				ValaCodeNode* _tmp51_;
				_tmp48_ = _result_;
				_tmp49_ = vala_using_directive_get_namespace_symbol (G_TYPE_CHECK_INSTANCE_CAST (_tmp48_, VALA_TYPE_USING_DIRECTIVE, ValaUsingDirective));
				_tmp50_ = _tmp49_;
				_tmp51_ = _vala_code_node_ref0 ((ValaCodeNode*) _tmp50_);
				_vala_code_node_unref0 (_result_);
				_result_ = _tmp51_;
			}
		}
	}
	_tmp53_ = _result_;
	if (!G_TYPE_CHECK_INSTANCE_TYPE (_tmp53_, VALA_TYPE_SYMBOL)) {
		_tmp52_ = TRUE;
	} else {
		gboolean _tmp54_ = FALSE;
		ValaCodeNode* _tmp55_;
		_tmp55_ = _result_;
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp55_, VALA_TYPE_METHOD)) {
			ValaCodeNode* _tmp56_;
			gboolean _tmp57_;
			gboolean _tmp58_;
			_tmp56_ = _result_;
			_tmp57_ = vala_method_get_closure (G_TYPE_CHECK_INSTANCE_CAST (_tmp56_, VALA_TYPE_METHOD, ValaMethod));
			_tmp58_ = _tmp57_;
			_tmp54_ = _tmp58_;
		} else {
			_tmp54_ = FALSE;
		}
		_tmp52_ = _tmp54_;
	}
	if (_tmp52_) {
		GCancellable* _tmp59_;
		_tmp59_ = vls_server_cancellable;
		jsonrpc_client_reply_error_async (_data39_->client, _data39_->id, (gint) JSONRPC_CLIENT_ERROR_INVALID_REQUEST, "There is no symbol at the cursor.", _tmp59_, NULL, NULL);
		vala_code_context_pop ();
		_vala_code_node_unref0 (symbol);
		_vala_code_node_unref0 (_result_);
		_vala_code_node_unref0 (initial_result);
		_vala_code_visitor_unref0 (fs);
		_vala_source_file_unref0 (doc);
		_g_object_unref0 (compilation);
		_g_object_unref0 (project);
		_g_object_unref0 (pos);
		return;
	}
	_tmp60_ = _result_;
	_tmp61_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp60_, VALA_TYPE_SYMBOL, ValaSymbol));
	_vala_code_node_unref0 (symbol);
	symbol = _tmp61_;
	_tmp62_ = initial_result;
	_tmp63_ = symbol;
	_tmp64_ = vls_symbol_references_get_replacement_range (_tmp62_, _tmp63_);
	replacement_range = _tmp64_;
	_tmp66_ = replacement_range;
	if (_tmp66_ == NULL) {
		_tmp65_ = TRUE;
	} else {
		ValaSymbol* _tmp67_;
		ValaSourceReference* _tmp68_;
		ValaSourceReference* _tmp69_;
		_tmp67_ = symbol;
		_tmp68_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp67_);
		_tmp69_ = _tmp68_;
		_tmp65_ = _tmp69_ == NULL;
	}
	if (_tmp65_) {
		GCancellable* _tmp70_;
		_tmp70_ = vls_server_cancellable;
		jsonrpc_client_reply_error_async (_data39_->client, _data39_->id, (gint) JSONRPC_CLIENT_ERROR_INVALID_REQUEST, "There is no symbol at the cursor.", _tmp70_, NULL, NULL);
		vala_code_context_pop ();
		_g_object_unref0 (replacement_range);
		_vala_code_node_unref0 (symbol);
		_vala_code_node_unref0 (_result_);
		_vala_code_node_unref0 (initial_result);
		_vala_code_visitor_unref0 (fs);
		_vala_source_file_unref0 (doc);
		_g_object_unref0 (compilation);
		_g_object_unref0 (project);
		_g_object_unref0 (pos);
		return;
	}
	{
		GeeIterator* _btarget_w_sym_it = NULL;
		VlsProject* _tmp71_;
		ValaSymbol* _tmp72_;
		GeeCollection* _tmp73_;
		GeeCollection* _tmp74_;
		GeeIterator* _tmp75_;
		GeeIterator* _tmp76_;
		_tmp71_ = project;
		_tmp72_ = symbol;
		_tmp73_ = vls_symbol_references_get_compilations_using_symbol (_tmp71_, _tmp72_);
		_tmp74_ = _tmp73_;
		_tmp75_ = gee_iterable_iterator ((GeeIterable*) _tmp74_);
		_tmp76_ = _tmp75_;
		_g_object_unref0 (_tmp74_);
		_btarget_w_sym_it = _tmp76_;
		while (TRUE) {
			GeeIterator* _tmp77_;
			VlsPair* btarget_w_sym = NULL;
			GeeIterator* _tmp78_;
			gpointer _tmp79_;
			VlsPair* _tmp80_;
			gconstpointer _tmp81_;
			gconstpointer _tmp82_;
			ValaSourceReference* _tmp83_;
			ValaSourceReference* _tmp84_;
			ValaSourceFile* _tmp85_;
			ValaSourceFile* _tmp86_;
			_tmp77_ = _btarget_w_sym_it;
			if (!gee_iterator_next (_tmp77_)) {
				break;
			}
			_tmp78_ = _btarget_w_sym_it;
			_tmp79_ = gee_iterator_get (_tmp78_);
			btarget_w_sym = (VlsPair*) _tmp79_;
			_tmp80_ = btarget_w_sym;
			_tmp81_ = vls_pair_get_second (_tmp80_);
			_tmp82_ = _tmp81_;
			_tmp83_ = vala_code_node_get_source_reference ((ValaCodeNode*) ((ValaSymbol*) _tmp82_));
			_tmp84_ = _tmp83_;
			_tmp85_ = vala_source_reference_get_file (_tmp84_);
			_tmp86_ = _tmp85_;
			if (!VLS_IS_TEXT_DOCUMENT (_tmp86_)) {
				gchar* pkg = NULL;
				VlsPair* _tmp87_;
				gconstpointer _tmp88_;
				gconstpointer _tmp89_;
				ValaSourceReference* _tmp90_;
				ValaSourceReference* _tmp91_;
				ValaSourceFile* _tmp92_;
				ValaSourceFile* _tmp93_;
				const gchar* _tmp94_;
				const gchar* _tmp95_;
				gchar* _tmp96_;
				gchar* _tmp97_ = NULL;
				const gchar* _tmp98_;
				gchar* _tmp103_;
				gchar* _tmp104_;
				GCancellable* _tmp105_;
				_tmp87_ = btarget_w_sym;
				_tmp88_ = vls_pair_get_second (_tmp87_);
				_tmp89_ = _tmp88_;
				_tmp90_ = vala_code_node_get_source_reference ((ValaCodeNode*) ((ValaSymbol*) _tmp89_));
				_tmp91_ = _tmp90_;
				_tmp92_ = vala_source_reference_get_file (_tmp91_);
				_tmp93_ = _tmp92_;
				_tmp94_ = vala_source_file_get_package_name (_tmp93_);
				_tmp95_ = _tmp94_;
				_tmp96_ = g_strdup (_tmp95_);
				pkg = _tmp96_;
				_tmp98_ = pkg;
				if (_tmp98_ != NULL) {
					const gchar* _tmp99_;
					const gchar* _tmp100_;
					gchar* _tmp101_;
					_tmp99_ = pkg;
					_tmp100_ = string_to_string (_tmp99_);
					_tmp101_ = g_strconcat (" (", _tmp100_, ").", NULL);
					_g_free0 (_tmp97_);
					_tmp97_ = _tmp101_;
				} else {
					gchar* _tmp102_;
					_tmp102_ = g_strdup (".");
					_g_free0 (_tmp97_);
					_tmp97_ = _tmp102_;
				}
				_tmp103_ = g_strconcat ("Cannot rename a symbol defined in a system library", _tmp97_, NULL);
				_tmp104_ = _tmp103_;
				_tmp105_ = vls_server_cancellable;
				jsonrpc_client_reply_error_async (_data39_->client, _data39_->id, (gint) JSONRPC_CLIENT_ERROR_INVALID_REQUEST, _tmp104_, _tmp105_, NULL, NULL);
				_g_free0 (_tmp104_);
				vala_code_context_pop ();
				_g_free0 (_tmp97_);
				_g_free0 (pkg);
				_g_object_unref0 (btarget_w_sym);
				_g_object_unref0 (_btarget_w_sym_it);
				_g_object_unref0 (replacement_range);
				_vala_code_node_unref0 (symbol);
				_vala_code_node_unref0 (_result_);
				_vala_code_node_unref0 (initial_result);
				_vala_code_visitor_unref0 (fs);
				_vala_source_file_unref0 (doc);
				_g_object_unref0 (compilation);
				_g_object_unref0 (project);
				_g_object_unref0 (pos);
				return;
			}
			_g_object_unref0 (btarget_w_sym);
		}
		_g_object_unref0 (_btarget_w_sym_it);
	}
	{
		GVariant* _tmp106_ = NULL;
		LspRange* _tmp107_;
		GVariant* _tmp108_;
		ValaSymbol* _tmp109_;
		const gchar* _tmp110_;
		const gchar* _tmp111_;
		GVariant* _tmp112_;
		GVariant* _tmp113_;
		GVariant* _tmp114_;
		GVariant* _tmp115_;
		GCancellable* _tmp116_;
		_tmp107_ = replacement_range;
		_tmp108_ = vls_util_object_to_variant ((GObject*) _tmp107_, &_inner_error0_);
		_tmp106_ = _tmp108_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp109_ = symbol;
		_tmp110_ = vala_symbol_get_name (_tmp109_);
		_tmp111_ = _tmp110_;
		_tmp112_ = g_variant_new_string (_tmp111_);
		g_variant_ref_sink (_tmp112_);
		_tmp113_ = _tmp112_;
		_tmp114_ = vls_server_build_dict (self, "range", _tmp106_, "placeholder", _tmp113_, NULL);
		_tmp115_ = _tmp114_;
		_tmp116_ = vls_server_cancellable;
		jsonrpc_client_reply (_data39_->client, _data39_->id, _tmp115_, _tmp116_, &_inner_error0_);
		_g_variant_unref0 (_tmp115_);
		_g_variant_unref0 (_tmp113_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_variant_unref0 (_tmp106_);
			goto __catch0_g_error;
		}
		_g_variant_unref0 (_tmp106_);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp117_;
		const gchar* _tmp118_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp117_ = e;
		_tmp118_ = _tmp117_->message;
		g_warning ("server.vala:1972: [%s] failed to reply with success - %s", _data39_->method, _tmp118_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_object_unref0 (replacement_range);
		_vala_code_node_unref0 (symbol);
		_vala_code_node_unref0 (_result_);
		_vala_code_node_unref0 (initial_result);
		_vala_code_visitor_unref0 (fs);
		_vala_source_file_unref0 (doc);
		_g_object_unref0 (compilation);
		_g_object_unref0 (project);
		_g_object_unref0 (pos);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	vala_code_context_pop ();
	_g_object_unref0 (replacement_range);
	_vala_code_node_unref0 (symbol);
	_vala_code_node_unref0 (_result_);
	_vala_code_node_unref0 (initial_result);
	_vala_code_visitor_unref0 (fs);
	_vala_source_file_unref0 (doc);
	_g_object_unref0 (compilation);
	_g_object_unref0 (project);
	_g_object_unref0 (pos);
}

static void
___lambda75__vls_server_on_context_updated_func (gboolean request_cancelled,
                                                 gpointer self)
{
	__lambda75_ (self, request_cancelled);
}

static void
vls_server_prepare_rename_symbol (VlsServer* self,
                                  JsonrpcClient* client,
                                  const gchar* method,
                                  GVariant* id,
                                  GVariant* params)
{
	Block39Data* _data39_;
	JsonrpcClient* _tmp0_;
	gchar* _tmp1_;
	GVariant* _tmp2_;
	gpointer _tmp3_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (client != NULL);
	g_return_if_fail (method != NULL);
	g_return_if_fail (id != NULL);
	g_return_if_fail (params != NULL);
	_data39_ = g_slice_new0 (Block39Data);
	_data39_->_ref_count_ = 1;
	_data39_->self = g_object_ref (self);
	_tmp0_ = _g_object_ref0 (client);
	_g_object_unref0 (_data39_->client);
	_data39_->client = _tmp0_;
	_tmp1_ = g_strdup (method);
	_g_free0 (_data39_->method);
	_data39_->method = _tmp1_;
	_tmp2_ = _g_variant_ref0 (id);
	_g_variant_unref0 (_data39_->id);
	_data39_->id = _tmp2_;
	_tmp3_ = vls_util_parse_variant (LSP_TYPE_TEXT_DOCUMENT_POSITION_PARAMS, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, params);
	_data39_->p = (LspTextDocumentPositionParams*) _tmp3_;
	vls_server_wait_for_context_update (self, _data39_->id, ___lambda75__vls_server_on_context_updated_func, block39_data_ref (_data39_), block39_data_unref);
	block39_data_unref (_data39_);
	_data39_ = NULL;
}

/**
     * handle an incoming `textDocument/codeLens` request
     */
static gchar*
_variant_get12 (GVariant* value)
{
	return g_variant_dup_string (value, NULL);
}

static void
vls_server_code_lens (VlsServer* self,
                      JsonrpcClient* client,
                      const gchar* method,
                      GVariant* id,
                      GVariant* params)
{
	GVariant* document = NULL;
	const GVariantType* _tmp0_;
	GVariant* _tmp1_;
	gchar* _tmp2_ = NULL;
	GVariant* _tmp3_;
	gchar* uri = NULL;
	gchar* _tmp9_;
	gboolean _tmp10_ = FALSE;
	GVariant* _tmp11_;
	VlsProject* project = NULL;
	VlsCompilation* compilation = NULL;
	ValaSourceFile* file = NULL;
	const gchar* _tmp13_;
	VlsCompilation* _tmp14_ = NULL;
	VlsProject* _tmp15_ = NULL;
	ValaSourceFile* _tmp16_;
	ValaSourceFile* _tmp17_;
	VlsProject* _tmp19_;
	ValaSourceFile* _tmp20_;
	VlsCompilation* _tmp21_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (client != NULL);
	g_return_if_fail (method != NULL);
	g_return_if_fail (id != NULL);
	g_return_if_fail (params != NULL);
	_tmp0_ = G_VARIANT_TYPE_VARDICT;
	_tmp1_ = g_variant_lookup_value (params, "textDocument", _tmp0_);
	document = _tmp1_;
	_tmp3_ = document;
	if (_tmp3_ != NULL) {
		GVariant* _tmp4_;
		const GVariantType* _tmp5_;
		GVariant* _tmp6_;
		GVariant* _tmp7_;
		gchar* _tmp8_;
		_tmp4_ = document;
		_tmp5_ = G_VARIANT_TYPE_STRING;
		_tmp6_ = g_variant_lookup_value (_tmp4_, "uri", _tmp5_);
		_tmp7_ = _tmp6_;
		_tmp8_ = _variant_get12 (_tmp7_);
		_g_free0 (_tmp2_);
		_tmp2_ = _tmp8_;
		_g_variant_unref0 (_tmp7_);
	} else {
		_g_free0 (_tmp2_);
		_tmp2_ = NULL;
	}
	_tmp9_ = g_strdup (_tmp2_);
	uri = _tmp9_;
	_tmp11_ = document;
	if (_tmp11_ == NULL) {
		_tmp10_ = TRUE;
	} else {
		const gchar* _tmp12_;
		_tmp12_ = uri;
		_tmp10_ = _tmp12_ == NULL;
	}
	if (_tmp10_) {
		g_warning ("server.vala:1986: [%s] `textDocument` or `uri` not provided as expecte" \
"d", method);
		vls_server_reply_null (id, client, method);
		_g_free0 (uri);
		_g_free0 (_tmp2_);
		_g_variant_unref0 (document);
		return;
	}
	_tmp13_ = uri;
	_tmp16_ = vls_server_find_file (self, _tmp13_, &_tmp14_, &_tmp15_);
	_g_object_unref0 (compilation);
	compilation = _tmp14_;
	_g_object_unref0 (project);
	project = _tmp15_;
	file = _tmp16_;
	_tmp17_ = file;
	if (_tmp17_ == NULL) {
		const gchar* _tmp18_;
		_tmp18_ = uri;
		g_debug ("server.vala:1995: [%s] file `%s' not found", method, _tmp18_);
		vls_server_reply_null (id, client, method);
		_vala_source_file_unref0 (file);
		_g_object_unref0 (compilation);
		_g_object_unref0 (project);
		_g_free0 (uri);
		_g_free0 (_tmp2_);
		_g_variant_unref0 (document);
		return;
	}
	_tmp19_ = project;
	_tmp20_ = file;
	_tmp21_ = compilation;
	vls_code_lens_engine_begin_response (self, _tmp19_, client, id, method, _tmp20_, _tmp21_);
	_vala_source_file_unref0 (file);
	_g_object_unref0 (compilation);
	_g_object_unref0 (project);
	_g_free0 (uri);
	_g_free0 (_tmp2_);
	_g_variant_unref0 (document);
}

static void
vls_server_prepare_call_hierarchy (VlsServer* self,
                                   JsonrpcClient* client,
                                   const gchar* method,
                                   GVariant* id,
                                   GVariant* params)
{
	LspTextDocumentPositionParams* p = NULL;
	gpointer _tmp0_;
	VlsProject* project = NULL;
	VlsCompilation* compilation = NULL;
	ValaSourceFile* doc = NULL;
	LspTextDocumentPositionParams* _tmp1_;
	LspTextDocumentIdentifier* _tmp2_;
	LspTextDocumentIdentifier* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	VlsCompilation* _tmp6_ = NULL;
	VlsProject* _tmp7_ = NULL;
	ValaSourceFile* _tmp8_;
	ValaSourceFile* _tmp9_;
	VlsCompilation* _tmp15_;
	ValaCodeContext* _tmp16_;
	ValaCodeContext* _tmp17_;
	VlsNodeSearch* fs = NULL;
	ValaSourceFile* _tmp18_;
	LspTextDocumentPositionParams* _tmp19_;
	LspPosition* _tmp20_;
	LspPosition* _tmp21_;
	VlsNodeSearch* _tmp22_;
	VlsNodeSearch* _tmp23_;
	GeeList* _tmp24_;
	gint _tmp25_;
	gint _tmp26_;
	ValaCodeNode* _result_ = NULL;
	VlsNodeSearch* _tmp30_;
	ValaSourceFile* _tmp31_;
	ValaCodeNode* _tmp32_;
	ValaMethod* method_sym = NULL;
	ValaCodeNode* _tmp33_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (client != NULL);
	g_return_if_fail (method != NULL);
	g_return_if_fail (id != NULL);
	g_return_if_fail (params != NULL);
	_tmp0_ = vls_util_parse_variant (LSP_TYPE_TEXT_DOCUMENT_POSITION_PARAMS, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, params);
	p = (LspTextDocumentPositionParams*) _tmp0_;
	_tmp1_ = p;
	_tmp2_ = lsp_text_document_position_params_get_textDocument (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = lsp_text_document_identifier_get_uri (_tmp3_);
	_tmp5_ = _tmp4_;
	_tmp8_ = vls_server_find_file (self, _tmp5_, &_tmp6_, &_tmp7_);
	_g_object_unref0 (compilation);
	compilation = _tmp6_;
	_g_object_unref0 (project);
	project = _tmp7_;
	doc = _tmp8_;
	_tmp9_ = doc;
	if (_tmp9_ == NULL) {
		LspTextDocumentPositionParams* _tmp10_;
		LspTextDocumentIdentifier* _tmp11_;
		LspTextDocumentIdentifier* _tmp12_;
		const gchar* _tmp13_;
		const gchar* _tmp14_;
		_tmp10_ = p;
		_tmp11_ = lsp_text_document_position_params_get_textDocument (_tmp10_);
		_tmp12_ = _tmp11_;
		_tmp13_ = lsp_text_document_identifier_get_uri (_tmp12_);
		_tmp14_ = _tmp13_;
		g_debug ("server.vala:2010: [%s] file `%s' not found", method, _tmp14_);
		vls_server_reply_null (id, client, method);
		_vala_source_file_unref0 (doc);
		_g_object_unref0 (compilation);
		_g_object_unref0 (project);
		_g_object_unref0 (p);
		return;
	}
	_tmp15_ = compilation;
	_tmp16_ = vls_compilation_get_code_context (_tmp15_);
	_tmp17_ = _tmp16_;
	vala_code_context_push (_tmp17_);
	_tmp18_ = doc;
	_tmp19_ = p;
	_tmp20_ = lsp_text_document_position_params_get_position (_tmp19_);
	_tmp21_ = _tmp20_;
	_tmp22_ = vls_node_search_new (_tmp18_, _tmp21_, FALSE, NULL, TRUE);
	fs = _tmp22_;
	_tmp23_ = fs;
	_tmp24_ = _tmp23_->result;
	_tmp25_ = gee_collection_get_size ((GeeCollection*) _tmp24_);
	_tmp26_ = _tmp25_;
	if (_tmp26_ == 0) {
		const gchar* _tmp27_;
		gchar* _tmp28_;
		gchar* _tmp29_;
		_tmp27_ = string_to_string (method);
		_tmp28_ = g_strconcat ("[", _tmp27_, "] no results found", NULL);
		_tmp29_ = _tmp28_;
		g_debug ("server.vala:2020: %s", _tmp29_);
		_g_free0 (_tmp29_);
		vls_server_reply_null (id, client, method);
		vala_code_context_pop ();
		_vala_code_visitor_unref0 (fs);
		_vala_source_file_unref0 (doc);
		_g_object_unref0 (compilation);
		_g_object_unref0 (project);
		_g_object_unref0 (p);
		return;
	}
	_tmp30_ = fs;
	_tmp31_ = doc;
	_tmp32_ = vls_server_get_best (_tmp30_, _tmp31_);
	_result_ = _tmp32_;
	vala_code_context_pop ();
	_tmp33_ = _result_;
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp33_, VALA_TYPE_METHOD)) {
		ValaCodeNode* _tmp34_;
		ValaMethod* _tmp35_;
		_tmp34_ = _result_;
		_tmp35_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp34_, VALA_TYPE_METHOD, ValaMethod));
		_vala_code_node_unref0 (method_sym);
		method_sym = _tmp35_;
	} else {
		ValaCodeNode* _tmp36_;
		_tmp36_ = _result_;
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp36_, VALA_TYPE_METHOD_CALL)) {
			ValaMethod* call_method = NULL;
			ValaCodeNode* _tmp37_;
			ValaExpression* _tmp38_;
			ValaExpression* _tmp39_;
			ValaSymbol* _tmp40_;
			ValaSymbol* _tmp41_;
			ValaMethod* _tmp42_;
			ValaMethod* _tmp43_;
			ValaMethod* _tmp44_;
			ValaMethod* _tmp45_;
			_tmp37_ = _result_;
			_tmp38_ = vala_callable_expression_get_call ((ValaCallableExpression*) G_TYPE_CHECK_INSTANCE_CAST (_tmp37_, VALA_TYPE_METHOD_CALL, ValaMethodCall));
			_tmp39_ = _tmp38_;
			_tmp40_ = vala_expression_get_symbol_reference (_tmp39_);
			_tmp41_ = _tmp40_;
			_tmp42_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp41_, VALA_TYPE_METHOD) ? ((ValaMethod*) _tmp41_) : NULL);
			call_method = _tmp42_;
			_tmp43_ = call_method;
			if (_tmp43_ == NULL) {
				vls_server_reply_null (id, client, method);
				_vala_code_node_unref0 (call_method);
				_vala_code_node_unref0 (method_sym);
				_vala_code_node_unref0 (_result_);
				_vala_code_visitor_unref0 (fs);
				_vala_source_file_unref0 (doc);
				_g_object_unref0 (compilation);
				_g_object_unref0 (project);
				_g_object_unref0 (p);
				return;
			}
			_tmp44_ = call_method;
			_tmp45_ = _vala_code_node_ref0 (_tmp44_);
			_vala_code_node_unref0 (method_sym);
			method_sym = _tmp45_;
			_vala_code_node_unref0 (call_method);
		} else {
			gboolean _tmp46_ = FALSE;
			ValaCodeNode* _tmp47_;
			_tmp47_ = _result_;
			if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp47_, VALA_TYPE_EXPRESSION)) {
				ValaCodeNode* _tmp48_;
				ValaSymbol* _tmp49_;
				ValaSymbol* _tmp50_;
				_tmp48_ = _result_;
				_tmp49_ = vala_expression_get_symbol_reference (G_TYPE_CHECK_INSTANCE_CAST (_tmp48_, VALA_TYPE_EXPRESSION, ValaExpression));
				_tmp50_ = _tmp49_;
				_tmp46_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp50_, VALA_TYPE_METHOD);
			} else {
				_tmp46_ = FALSE;
			}
			if (_tmp46_) {
				ValaCodeNode* _tmp51_;
				ValaSymbol* _tmp52_;
				ValaSymbol* _tmp53_;
				ValaMethod* _tmp54_;
				_tmp51_ = _result_;
				_tmp52_ = vala_expression_get_symbol_reference (G_TYPE_CHECK_INSTANCE_CAST (_tmp51_, VALA_TYPE_EXPRESSION, ValaExpression));
				_tmp53_ = _tmp52_;
				_tmp54_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp53_, VALA_TYPE_METHOD, ValaMethod));
				_vala_code_node_unref0 (method_sym);
				method_sym = _tmp54_;
			} else {
				vls_server_reply_null (id, client, method);
				_vala_code_node_unref0 (method_sym);
				_vala_code_node_unref0 (_result_);
				_vala_code_visitor_unref0 (fs);
				_vala_source_file_unref0 (doc);
				_g_object_unref0 (compilation);
				_g_object_unref0 (project);
				_g_object_unref0 (p);
				return;
			}
		}
	}
	{
		GVariant* _tmp55_ = NULL;
		ValaMethod* _tmp56_;
		LspCallHierarchyItem* _tmp57_;
		LspCallHierarchyItem* _tmp58_;
		GVariant* _tmp59_;
		GVariant* _tmp60_;
		GVariant* array = NULL;
		GVariant* _tmp61_;
		GVariant** _tmp62_;
		GVariant** _tmp63_;
		gint _tmp63__length1;
		GVariant* _tmp64_;
		GVariant* _tmp65_;
		GVariant* _tmp66_;
		GCancellable* _tmp67_;
		_tmp56_ = method_sym;
		_tmp57_ = lsp_call_hierarchy_item_new_from_symbol ((ValaSymbol*) _tmp56_);
		if (_tmp57_) {
			g_object_set_data ((GObject *) _tmp57_, "vala-creation-function", "Vls.Server.prepare_call_hierarchy");
		}
		_tmp58_ = _tmp57_;
		_tmp59_ = vls_util_object_to_variant ((GObject*) _tmp58_, &_inner_error0_);
		_tmp60_ = _tmp59_;
		_g_object_unref0 (_tmp58_);
		_tmp55_ = _tmp60_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp61_ = _tmp55_;
		_tmp55_ = NULL;
		_tmp62_ = g_new0 (GVariant*, 1 + 1);
		_tmp62_[0] = _tmp61_;
		_tmp63_ = _tmp62_;
		_tmp63__length1 = 1;
		_tmp64_ = g_variant_new_array (NULL, _tmp63_, 1);
		g_variant_ref_sink (_tmp64_);
		_tmp65_ = _tmp64_;
		_tmp63_ = (_vala_array_free (_tmp63_, _tmp63__length1, (GDestroyNotify) g_variant_unref), NULL);
		array = _tmp65_;
		_tmp66_ = array;
		_tmp67_ = vls_server_cancellable;
		jsonrpc_client_reply (client, id, _tmp66_, _tmp67_, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_variant_unref0 (array);
			_g_variant_unref0 (_tmp55_);
			goto __catch0_g_error;
		}
		_g_variant_unref0 (array);
		_g_variant_unref0 (_tmp55_);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp68_;
		GError* _tmp69_;
		const gchar* _tmp70_;
		const gchar* _tmp71_;
		gchar* _tmp72_;
		gchar* _tmp73_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp68_ = string_to_string (method);
		_tmp69_ = e;
		_tmp70_ = _tmp69_->message;
		_tmp71_ = string_to_string (_tmp70_);
		_tmp72_ = g_strconcat ("[", _tmp68_, "] failed to reply to client: ", _tmp71_, NULL);
		_tmp73_ = _tmp72_;
		g_debug ("server.vala:2053: %s", _tmp73_);
		_g_free0 (_tmp73_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_vala_code_node_unref0 (method_sym);
		_vala_code_node_unref0 (_result_);
		_vala_code_visitor_unref0 (fs);
		_vala_source_file_unref0 (doc);
		_g_object_unref0 (compilation);
		_g_object_unref0 (project);
		_g_object_unref0 (p);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	_vala_code_node_unref0 (method_sym);
	_vala_code_node_unref0 (_result_);
	_vala_code_visitor_unref0 (fs);
	_vala_source_file_unref0 (doc);
	_g_object_unref0 (compilation);
	_g_object_unref0 (project);
	_g_object_unref0 (p);
}

static void
_vala_array_add30 (GVariant** * array,
                   gint* length,
                   gint* size,
                   GVariant* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (GVariant*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
vls_server_call_hierarchy_incoming_calls (VlsServer* self,
                                          JsonrpcClient* client,
                                          const gchar* method,
                                          GVariant* id,
                                          GVariant* params)
{
	GVariant* itemv = NULL;
	const GVariantType* _tmp0_;
	GVariant* _tmp1_;
	LspCallHierarchyItem* item = NULL;
	GVariant* _tmp2_;
	gpointer _tmp3_;
	VlsProject* project = NULL;
	VlsCompilation* compilation = NULL;
	ValaSourceFile* doc = NULL;
	LspCallHierarchyItem* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	VlsCompilation* _tmp7_ = NULL;
	VlsProject* _tmp8_ = NULL;
	ValaSourceFile* _tmp9_;
	ValaSourceFile* _tmp10_;
	VlsCompilation* _tmp14_;
	ValaCodeContext* _tmp15_;
	ValaCodeContext* _tmp16_;
	ValaSymbol* symbol = NULL;
	LspCallHierarchyItem* _tmp17_;
	const gchar* _tmp18_;
	const gchar* _tmp19_;
	VlsCompilation* _tmp20_;
	ValaCodeContext* _tmp21_;
	ValaCodeContext* _tmp22_;
	ValaNamespace* _tmp23_;
	ValaNamespace* _tmp24_;
	ValaScope* _tmp25_;
	ValaScope* _tmp26_;
	ValaSymbol* _tmp27_;
	gboolean _tmp28_ = FALSE;
	ValaSymbol* _tmp29_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (client != NULL);
	g_return_if_fail (method != NULL);
	g_return_if_fail (id != NULL);
	g_return_if_fail (params != NULL);
	_tmp0_ = G_VARIANT_TYPE_VARDICT;
	_tmp1_ = g_variant_lookup_value (params, "item", _tmp0_);
	itemv = _tmp1_;
	_tmp2_ = itemv;
	_tmp3_ = vls_util_parse_variant (LSP_TYPE_CALL_HIERARCHY_ITEM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _tmp2_);
	item = (LspCallHierarchyItem*) _tmp3_;
	_tmp4_ = item;
	_tmp5_ = lsp_call_hierarchy_item_get_uri (_tmp4_);
	_tmp6_ = _tmp5_;
	_tmp9_ = vls_server_find_file (self, _tmp6_, &_tmp7_, &_tmp8_);
	_g_object_unref0 (compilation);
	compilation = _tmp7_;
	_g_object_unref0 (project);
	project = _tmp8_;
	doc = _tmp9_;
	_tmp10_ = doc;
	if (_tmp10_ == NULL) {
		LspCallHierarchyItem* _tmp11_;
		const gchar* _tmp12_;
		const gchar* _tmp13_;
		_tmp11_ = item;
		_tmp12_ = lsp_call_hierarchy_item_get_uri (_tmp11_);
		_tmp13_ = _tmp12_;
		g_debug ("server.vala:2065: [%s] file `%s' not found", method, _tmp13_);
		vls_server_reply_null (id, client, method);
		_vala_source_file_unref0 (doc);
		_g_object_unref0 (compilation);
		_g_object_unref0 (project);
		_g_object_unref0 (item);
		_g_variant_unref0 (itemv);
		return;
	}
	_tmp14_ = compilation;
	_tmp15_ = vls_compilation_get_code_context (_tmp14_);
	_tmp16_ = _tmp15_;
	vala_code_context_push (_tmp16_);
	_tmp17_ = item;
	_tmp18_ = lsp_call_hierarchy_item_get_name (_tmp17_);
	_tmp19_ = _tmp18_;
	_tmp20_ = compilation;
	_tmp21_ = vls_compilation_get_code_context (_tmp20_);
	_tmp22_ = _tmp21_;
	_tmp23_ = vala_code_context_get_root (_tmp22_);
	_tmp24_ = _tmp23_;
	_tmp25_ = vala_symbol_get_scope ((ValaSymbol*) _tmp24_);
	_tmp26_ = _tmp25_;
	_tmp27_ = vls_code_help_lookup_symbol_full_name (_tmp19_, _tmp26_, NULL);
	symbol = _tmp27_;
	_tmp29_ = symbol;
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp29_, VALA_TYPE_CALLABLE)) {
		_tmp28_ = TRUE;
	} else {
		ValaSymbol* _tmp30_;
		_tmp30_ = symbol;
		_tmp28_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp30_, VALA_TYPE_SUBROUTINE);
	}
	if (!_tmp28_) {
		vala_code_context_pop ();
		vls_server_reply_null (id, client, method);
		_vala_code_node_unref0 (symbol);
		_vala_source_file_unref0 (doc);
		_g_object_unref0 (compilation);
		_g_object_unref0 (project);
		_g_object_unref0 (item);
		_g_variant_unref0 (itemv);
		return;
	}
	{
		GVariant** incoming_va = NULL;
		GVariant** _tmp31_;
		gint incoming_va_length1;
		gint _incoming_va_size_;
		VlsProject* _tmp32_;
		ValaSymbol* _tmp33_;
		gint _tmp34_ = 0;
		LspCallHierarchyIncomingCall** _tmp35_;
		const GVariantType* _tmp41_;
		GVariant** _tmp42_;
		gint _tmp42__length1;
		GVariant* _tmp43_;
		GVariant* _tmp44_;
		GCancellable* _tmp45_;
		_tmp31_ = g_new0 (GVariant*, 0 + 1);
		incoming_va = _tmp31_;
		incoming_va_length1 = 0;
		_incoming_va_size_ = incoming_va_length1;
		_tmp32_ = project;
		_tmp33_ = symbol;
		_tmp35_ = vls_call_hierarchy_get_incoming_calls (_tmp32_, _tmp33_, &_tmp34_);
		{
			LspCallHierarchyIncomingCall** incoming_call_collection = NULL;
			gint incoming_call_collection_length1 = 0;
			gint _incoming_call_collection_size_ = 0;
			gint incoming_call_it = 0;
			incoming_call_collection = _tmp35_;
			incoming_call_collection_length1 = _tmp34_;
			for (incoming_call_it = 0; incoming_call_it < incoming_call_collection_length1; incoming_call_it = incoming_call_it + 1) {
				LspCallHierarchyIncomingCall* _tmp36_;
				LspCallHierarchyIncomingCall* incoming_call = NULL;
				_tmp36_ = _g_object_ref0 (incoming_call_collection[incoming_call_it]);
				incoming_call = _tmp36_;
				{
					GVariant* _tmp37_ = NULL;
					LspCallHierarchyIncomingCall* _tmp38_;
					GVariant* _tmp39_;
					GVariant* _tmp40_;
					_tmp38_ = incoming_call;
					_tmp39_ = vls_util_object_to_variant ((GObject*) _tmp38_, &_inner_error0_);
					_tmp37_ = _tmp39_;
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						_g_object_unref0 (incoming_call);
						incoming_call_collection = (_vala_array_free (incoming_call_collection, incoming_call_collection_length1, (GDestroyNotify) g_object_unref), NULL);
						incoming_va = (_vala_array_free (incoming_va, incoming_va_length1, (GDestroyNotify) g_variant_unref), NULL);
						goto __catch0_g_error;
					}
					_tmp40_ = _tmp37_;
					_tmp37_ = NULL;
					_vala_array_add30 (&incoming_va, &incoming_va_length1, &_incoming_va_size_, _tmp40_);
					_g_variant_unref0 (_tmp37_);
					_g_object_unref0 (incoming_call);
				}
			}
			incoming_call_collection = (_vala_array_free (incoming_call_collection, incoming_call_collection_length1, (GDestroyNotify) g_object_unref), NULL);
		}
		vala_code_context_pop ();
		_tmp41_ = G_VARIANT_TYPE_VARDICT;
		_tmp42_ = incoming_va;
		_tmp42__length1 = incoming_va_length1;
		_tmp43_ = g_variant_new_array (_tmp41_, _tmp42_, _tmp42__length1);
		g_variant_ref_sink (_tmp43_);
		_tmp44_ = _tmp43_;
		_tmp45_ = vls_server_cancellable;
		jsonrpc_client_reply (client, id, _tmp44_, _tmp45_, &_inner_error0_);
		_g_variant_unref0 (_tmp44_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			incoming_va = (_vala_array_free (incoming_va, incoming_va_length1, (GDestroyNotify) g_variant_unref), NULL);
			goto __catch0_g_error;
		}
		incoming_va = (_vala_array_free (incoming_va, incoming_va_length1, (GDestroyNotify) g_variant_unref), NULL);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp46_;
		GError* _tmp47_;
		const gchar* _tmp48_;
		const gchar* _tmp49_;
		gchar* _tmp50_;
		gchar* _tmp51_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp46_ = string_to_string (method);
		_tmp47_ = e;
		_tmp48_ = _tmp47_->message;
		_tmp49_ = string_to_string (_tmp48_);
		_tmp50_ = g_strconcat ("[", _tmp46_, "] failed to reply to client: ", _tmp49_, NULL);
		_tmp51_ = _tmp50_;
		g_debug ("server.vala:2087: %s", _tmp51_);
		_g_free0 (_tmp51_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_vala_code_node_unref0 (symbol);
		_vala_source_file_unref0 (doc);
		_g_object_unref0 (compilation);
		_g_object_unref0 (project);
		_g_object_unref0 (item);
		_g_variant_unref0 (itemv);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	_vala_code_node_unref0 (symbol);
	_vala_source_file_unref0 (doc);
	_g_object_unref0 (compilation);
	_g_object_unref0 (project);
	_g_object_unref0 (item);
	_g_variant_unref0 (itemv);
}

static void
_vala_array_add31 (GVariant** * array,
                   gint* length,
                   gint* size,
                   GVariant* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (GVariant*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
vls_server_call_hierarchy_outgoing_calls (VlsServer* self,
                                          JsonrpcClient* client,
                                          const gchar* method,
                                          GVariant* id,
                                          GVariant* params)
{
	GVariant* itemv = NULL;
	const GVariantType* _tmp0_;
	GVariant* _tmp1_;
	LspCallHierarchyItem* item = NULL;
	GVariant* _tmp2_;
	gpointer _tmp3_;
	VlsProject* project = NULL;
	VlsCompilation* compilation = NULL;
	ValaSourceFile* doc = NULL;
	LspCallHierarchyItem* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	VlsCompilation* _tmp7_ = NULL;
	VlsProject* _tmp8_ = NULL;
	ValaSourceFile* _tmp9_;
	ValaSourceFile* _tmp10_;
	VlsCompilation* _tmp14_;
	ValaCodeContext* _tmp15_;
	ValaCodeContext* _tmp16_;
	ValaSubroutine* subroutine = NULL;
	LspCallHierarchyItem* _tmp17_;
	const gchar* _tmp18_;
	const gchar* _tmp19_;
	VlsCompilation* _tmp20_;
	ValaCodeContext* _tmp21_;
	ValaCodeContext* _tmp22_;
	ValaNamespace* _tmp23_;
	ValaNamespace* _tmp24_;
	ValaScope* _tmp25_;
	ValaScope* _tmp26_;
	ValaSymbol* _tmp27_;
	ValaSubroutine* _tmp28_;
	ValaSubroutine* _tmp29_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (client != NULL);
	g_return_if_fail (method != NULL);
	g_return_if_fail (id != NULL);
	g_return_if_fail (params != NULL);
	_tmp0_ = G_VARIANT_TYPE_VARDICT;
	_tmp1_ = g_variant_lookup_value (params, "item", _tmp0_);
	itemv = _tmp1_;
	_tmp2_ = itemv;
	_tmp3_ = vls_util_parse_variant (LSP_TYPE_CALL_HIERARCHY_ITEM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _tmp2_);
	item = (LspCallHierarchyItem*) _tmp3_;
	_tmp4_ = item;
	_tmp5_ = lsp_call_hierarchy_item_get_uri (_tmp4_);
	_tmp6_ = _tmp5_;
	_tmp9_ = vls_server_find_file (self, _tmp6_, &_tmp7_, &_tmp8_);
	_g_object_unref0 (compilation);
	compilation = _tmp7_;
	_g_object_unref0 (project);
	project = _tmp8_;
	doc = _tmp9_;
	_tmp10_ = doc;
	if (_tmp10_ == NULL) {
		LspCallHierarchyItem* _tmp11_;
		const gchar* _tmp12_;
		const gchar* _tmp13_;
		_tmp11_ = item;
		_tmp12_ = lsp_call_hierarchy_item_get_uri (_tmp11_);
		_tmp13_ = _tmp12_;
		g_debug ("server.vala:2099: [%s] file `%s' not found", method, _tmp13_);
		vls_server_reply_null (id, client, method);
		_vala_source_file_unref0 (doc);
		_g_object_unref0 (compilation);
		_g_object_unref0 (project);
		_g_object_unref0 (item);
		_g_variant_unref0 (itemv);
		return;
	}
	_tmp14_ = compilation;
	_tmp15_ = vls_compilation_get_code_context (_tmp14_);
	_tmp16_ = _tmp15_;
	vala_code_context_push (_tmp16_);
	_tmp17_ = item;
	_tmp18_ = lsp_call_hierarchy_item_get_name (_tmp17_);
	_tmp19_ = _tmp18_;
	_tmp20_ = compilation;
	_tmp21_ = vls_compilation_get_code_context (_tmp20_);
	_tmp22_ = _tmp21_;
	_tmp23_ = vala_code_context_get_root (_tmp22_);
	_tmp24_ = _tmp23_;
	_tmp25_ = vala_symbol_get_scope ((ValaSymbol*) _tmp24_);
	_tmp26_ = _tmp25_;
	_tmp27_ = vls_code_help_lookup_symbol_full_name (_tmp19_, _tmp26_, NULL);
	_tmp28_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp27_, VALA_TYPE_SUBROUTINE) ? ((ValaSubroutine*) _tmp27_) : NULL;
	if (_tmp28_ == NULL) {
		_vala_code_node_unref0 (_tmp27_);
	}
	subroutine = _tmp28_;
	_tmp29_ = subroutine;
	if (_tmp29_ == NULL) {
		vala_code_context_pop ();
		vls_server_reply_null (id, client, method);
		_vala_code_node_unref0 (subroutine);
		_vala_source_file_unref0 (doc);
		_g_object_unref0 (compilation);
		_g_object_unref0 (project);
		_g_object_unref0 (item);
		_g_variant_unref0 (itemv);
		return;
	}
	{
		GVariant** outgoing_va = NULL;
		GVariant** _tmp30_;
		gint outgoing_va_length1;
		gint _outgoing_va_size_;
		VlsProject* _tmp31_;
		ValaSubroutine* _tmp32_;
		gint _tmp33_ = 0;
		LspCallHierarchyOutgoingCall** _tmp34_;
		const GVariantType* _tmp40_;
		GVariant** _tmp41_;
		gint _tmp41__length1;
		GVariant* _tmp42_;
		GVariant* _tmp43_;
		GCancellable* _tmp44_;
		_tmp30_ = g_new0 (GVariant*, 0 + 1);
		outgoing_va = _tmp30_;
		outgoing_va_length1 = 0;
		_outgoing_va_size_ = outgoing_va_length1;
		_tmp31_ = project;
		_tmp32_ = subroutine;
		_tmp34_ = vls_call_hierarchy_get_outgoing_calls (_tmp31_, _tmp32_, &_tmp33_);
		{
			LspCallHierarchyOutgoingCall** outgoing_call_collection = NULL;
			gint outgoing_call_collection_length1 = 0;
			gint _outgoing_call_collection_size_ = 0;
			gint outgoing_call_it = 0;
			outgoing_call_collection = _tmp34_;
			outgoing_call_collection_length1 = _tmp33_;
			for (outgoing_call_it = 0; outgoing_call_it < outgoing_call_collection_length1; outgoing_call_it = outgoing_call_it + 1) {
				LspCallHierarchyOutgoingCall* _tmp35_;
				LspCallHierarchyOutgoingCall* outgoing_call = NULL;
				_tmp35_ = _g_object_ref0 (outgoing_call_collection[outgoing_call_it]);
				outgoing_call = _tmp35_;
				{
					GVariant* _tmp36_ = NULL;
					LspCallHierarchyOutgoingCall* _tmp37_;
					GVariant* _tmp38_;
					GVariant* _tmp39_;
					_tmp37_ = outgoing_call;
					_tmp38_ = vls_util_object_to_variant ((GObject*) _tmp37_, &_inner_error0_);
					_tmp36_ = _tmp38_;
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						_g_object_unref0 (outgoing_call);
						outgoing_call_collection = (_vala_array_free (outgoing_call_collection, outgoing_call_collection_length1, (GDestroyNotify) g_object_unref), NULL);
						outgoing_va = (_vala_array_free (outgoing_va, outgoing_va_length1, (GDestroyNotify) g_variant_unref), NULL);
						goto __catch0_g_error;
					}
					_tmp39_ = _tmp36_;
					_tmp36_ = NULL;
					_vala_array_add31 (&outgoing_va, &outgoing_va_length1, &_outgoing_va_size_, _tmp39_);
					_g_variant_unref0 (_tmp36_);
					_g_object_unref0 (outgoing_call);
				}
			}
			outgoing_call_collection = (_vala_array_free (outgoing_call_collection, outgoing_call_collection_length1, (GDestroyNotify) g_object_unref), NULL);
		}
		vala_code_context_pop ();
		_tmp40_ = G_VARIANT_TYPE_VARDICT;
		_tmp41_ = outgoing_va;
		_tmp41__length1 = outgoing_va_length1;
		_tmp42_ = g_variant_new_array (_tmp40_, _tmp41_, _tmp41__length1);
		g_variant_ref_sink (_tmp42_);
		_tmp43_ = _tmp42_;
		_tmp44_ = vls_server_cancellable;
		jsonrpc_client_reply (client, id, _tmp43_, _tmp44_, &_inner_error0_);
		_g_variant_unref0 (_tmp43_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			outgoing_va = (_vala_array_free (outgoing_va, outgoing_va_length1, (GDestroyNotify) g_variant_unref), NULL);
			goto __catch0_g_error;
		}
		outgoing_va = (_vala_array_free (outgoing_va, outgoing_va_length1, (GDestroyNotify) g_variant_unref), NULL);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp45_;
		GError* _tmp46_;
		const gchar* _tmp47_;
		const gchar* _tmp48_;
		gchar* _tmp49_;
		gchar* _tmp50_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp45_ = string_to_string (method);
		_tmp46_ = e;
		_tmp47_ = _tmp46_->message;
		_tmp48_ = string_to_string (_tmp47_);
		_tmp49_ = g_strconcat ("[", _tmp45_, "] failed to reply to client: ", _tmp48_, NULL);
		_tmp50_ = _tmp49_;
		g_debug ("server.vala:2121: %s", _tmp50_);
		_g_free0 (_tmp50_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_vala_code_node_unref0 (subroutine);
		_vala_source_file_unref0 (doc);
		_g_object_unref0 (compilation);
		_g_object_unref0 (project);
		_g_object_unref0 (item);
		_g_variant_unref0 (itemv);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	_vala_code_node_unref0 (subroutine);
	_vala_source_file_unref0 (doc);
	_g_object_unref0 (compilation);
	_g_object_unref0 (project);
	_g_object_unref0 (item);
	_g_variant_unref0 (itemv);
}

static void
_vala_array_add32 (LspInlayHint** * array,
                   gint* length,
                   gint* size,
                   LspInlayHint* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (LspInlayHint*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
_vala_array_add33 (LspInlayHint** * array,
                   gint* length,
                   gint* size,
                   LspInlayHint* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (LspInlayHint*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
_vala_array_add34 (LspInlayHint** * array,
                   gint* length,
                   gint* size,
                   LspInlayHint* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (LspInlayHint*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
_vala_array_add35 (LspInlayHint** * array,
                   gint* length,
                   gint* size,
                   LspInlayHint* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (LspInlayHint*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
_vala_array_add36 (GVariant** * array,
                   gint* length,
                   gint* size,
                   GVariant* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (GVariant*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
vls_server_show_inlay_hints (VlsServer* self,
                             JsonrpcClient* client,
                             const gchar* method,
                             GVariant* id,
                             GVariant* params)
{
	LspInlayHintParams* p = NULL;
	gpointer _tmp0_;
	VlsCompilation* compilation = NULL;
	ValaSourceFile* file = NULL;
	LspInlayHintParams* _tmp1_;
	LspTextDocumentIdentifier* _tmp2_;
	LspTextDocumentIdentifier* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	VlsCompilation* _tmp6_ = NULL;
	ValaSourceFile* _tmp7_;
	ValaSourceFile* _tmp8_;
	VlsCompilation* _tmp14_;
	ValaCodeContext* _tmp15_;
	ValaCodeContext* _tmp16_;
	VlsNodeSearch* query = NULL;
	ValaSourceFile* _tmp17_;
	LspInlayHintParams* _tmp18_;
	LspRange* _tmp19_;
	LspRange* _tmp20_;
	VlsNodeSearch* _tmp21_;
	VlsNodeSearch* _tmp22_;
	GeeList* _tmp23_;
	gboolean _tmp24_;
	gboolean _tmp25_;
	LspInlayHint** hints = NULL;
	LspInlayHint** _tmp31_;
	gint hints_length1;
	gint _hints_size_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (client != NULL);
	g_return_if_fail (method != NULL);
	g_return_if_fail (id != NULL);
	g_return_if_fail (params != NULL);
	_tmp0_ = vls_util_parse_variant (LSP_TYPE_INLAY_HINT_PARAMS, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, params);
	p = (LspInlayHintParams*) _tmp0_;
	_tmp1_ = p;
	_tmp2_ = lsp_inlay_hint_params_get_textDocument (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = lsp_text_document_identifier_get_uri (_tmp3_);
	_tmp5_ = _tmp4_;
	_tmp7_ = vls_server_find_file (self, _tmp5_, &_tmp6_, NULL);
	_g_object_unref0 (compilation);
	compilation = _tmp6_;
	file = _tmp7_;
	_tmp8_ = file;
	if (_tmp8_ == NULL) {
		LspInlayHintParams* _tmp9_;
		LspTextDocumentIdentifier* _tmp10_;
		LspTextDocumentIdentifier* _tmp11_;
		const gchar* _tmp12_;
		const gchar* _tmp13_;
		_tmp9_ = p;
		_tmp10_ = lsp_inlay_hint_params_get_textDocument (_tmp9_);
		_tmp11_ = _tmp10_;
		_tmp12_ = lsp_text_document_identifier_get_uri (_tmp11_);
		_tmp13_ = _tmp12_;
		g_debug ("server.vala:2131: [%s] file `%s' not found", method, _tmp13_);
		vls_server_reply_null (id, client, method);
		_vala_source_file_unref0 (file);
		_g_object_unref0 (compilation);
		_g_object_unref0 (p);
		return;
	}
	_tmp14_ = compilation;
	_tmp15_ = vls_compilation_get_code_context (_tmp14_);
	_tmp16_ = _tmp15_;
	vala_code_context_push (_tmp16_);
	_tmp17_ = file;
	_tmp18_ = p;
	_tmp19_ = lsp_inlay_hint_params_get_range (_tmp18_);
	_tmp20_ = _tmp19_;
	_tmp21_ = vls_node_search_new_within (_tmp17_, _tmp20_, FALSE);
	query = _tmp21_;
	_tmp22_ = query;
	_tmp23_ = _tmp22_->result;
	_tmp24_ = gee_collection_get_is_empty ((GeeCollection*) _tmp23_);
	_tmp25_ = _tmp24_;
	if (_tmp25_) {
		LspInlayHintParams* _tmp26_;
		LspRange* _tmp27_;
		LspRange* _tmp28_;
		gchar* _tmp29_;
		gchar* _tmp30_;
		_tmp26_ = p;
		_tmp27_ = lsp_inlay_hint_params_get_range (_tmp26_);
		_tmp28_ = _tmp27_;
		_tmp29_ = lsp_range_to_string (_tmp28_);
		_tmp30_ = _tmp29_;
		g_debug ("server.vala:2139: [%s] nothing found at %s", method, _tmp30_);
		_g_free0 (_tmp30_);
		vala_code_context_pop ();
		vls_server_reply_null (id, client, method);
		_vala_code_visitor_unref0 (query);
		_vala_source_file_unref0 (file);
		_g_object_unref0 (compilation);
		_g_object_unref0 (p);
		return;
	}
	_tmp31_ = g_new0 (LspInlayHint*, 0 + 1);
	hints = _tmp31_;
	hints_length1 = 0;
	_hints_size_ = hints_length1;
	{
		GeeList* _item_list = NULL;
		VlsNodeSearch* _tmp32_;
		GeeList* _tmp33_;
		gint _item_size = 0;
		GeeList* _tmp34_;
		gint _tmp35_;
		gint _tmp36_;
		gint _item_index = 0;
		_tmp32_ = query;
		_tmp33_ = _tmp32_->result;
		_item_list = _tmp33_;
		_tmp34_ = _item_list;
		_tmp35_ = gee_collection_get_size ((GeeCollection*) _tmp34_);
		_tmp36_ = _tmp35_;
		_item_size = _tmp36_;
		_item_index = -1;
		while (TRUE) {
			gint _tmp37_;
			gint _tmp38_;
			ValaCodeNode* item = NULL;
			GeeList* _tmp39_;
			gpointer _tmp40_;
			ValaLocalVariable* local = NULL;
			gchar* representation = NULL;
			ValaCodeNode* _tmp41_;
			gchar* _tmp42_;
			GMatchInfo* foreach_match = NULL;
			ValaCodeNode* _tmp43_;
			gboolean _tmp48_ = FALSE;
			gboolean _tmp49_ = FALSE;
			gboolean _tmp50_ = FALSE;
			ValaLocalVariable* _tmp51_;
			_item_index = _item_index + 1;
			_tmp37_ = _item_index;
			_tmp38_ = _item_size;
			if (!(_tmp37_ < _tmp38_)) {
				break;
			}
			_tmp39_ = _item_list;
			_tmp40_ = gee_list_get (_tmp39_, _item_index);
			item = (ValaCodeNode*) _tmp40_;
			local = NULL;
			_tmp41_ = item;
			_tmp42_ = vls_code_help_get_code_node_source (_tmp41_);
			representation = _tmp42_;
			_tmp43_ = item;
			if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp43_, VALA_TYPE_DECLARATION_STATEMENT)) {
				ValaCodeNode* _tmp44_;
				ValaSymbol* _tmp45_;
				ValaSymbol* _tmp46_;
				ValaLocalVariable* _tmp47_;
				_tmp44_ = item;
				_tmp45_ = vala_declaration_statement_get_declaration (G_TYPE_CHECK_INSTANCE_CAST (_tmp44_, VALA_TYPE_DECLARATION_STATEMENT, ValaDeclarationStatement));
				_tmp46_ = _tmp45_;
				_tmp47_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp46_, VALA_TYPE_LOCAL_VARIABLE) ? ((ValaLocalVariable*) _tmp46_) : NULL);
				_vala_code_node_unref0 (local);
				local = _tmp47_;
			}
			_tmp51_ = local;
			if (_tmp51_ != NULL) {
				ValaLocalVariable* _tmp52_;
				ValaSourceReference* _tmp53_;
				ValaSourceReference* _tmp54_;
				_tmp52_ = local;
				_tmp53_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp52_);
				_tmp54_ = _tmp53_;
				_tmp50_ = _tmp54_ != NULL;
			} else {
				_tmp50_ = FALSE;
			}
			if (_tmp50_) {
				ValaLocalVariable* _tmp55_;
				ValaExpression* _tmp56_;
				ValaExpression* _tmp57_;
				_tmp55_ = local;
				_tmp56_ = vala_variable_get_initializer ((ValaVariable*) _tmp55_);
				_tmp57_ = _tmp56_;
				_tmp49_ = !G_TYPE_CHECK_INSTANCE_TYPE (_tmp57_, VALA_TYPE_OBJECT_CREATION_EXPRESSION);
			} else {
				_tmp49_ = FALSE;
			}
			if (_tmp49_) {
				VlsCompilation* _tmp58_;
				GeeHashSet* _tmp59_;
				GeeHashSet* _tmp60_;
				ValaLocalVariable* _tmp61_;
				_tmp58_ = compilation;
				_tmp59_ = vls_compilation_get_var_decls (_tmp58_);
				_tmp60_ = _tmp59_;
				_tmp61_ = local;
				_tmp48_ = gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp60_, _tmp61_);
			} else {
				_tmp48_ = FALSE;
			}
			if (_tmp48_) {
				ValaLocalVariable* _tmp62_;
				ValaSourceReference* _tmp63_;
				ValaSourceReference* _tmp64_;
				ValaSourceLocation _tmp65_ = {0};
				ValaSourceLocation _tmp66_;
				LspPosition* _tmp67_;
				ValaLocalVariable* _tmp68_;
				ValaDataType* _tmp69_;
				ValaDataType* _tmp70_;
				gchar* _tmp71_;
				gchar* _tmp72_;
				gchar* _tmp73_;
				LspInlayHint* _tmp74_ = NULL;
				_tmp62_ = local;
				_tmp63_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp62_);
				_tmp64_ = _tmp63_;
				vala_source_reference_get_end (_tmp64_, &_tmp65_);
				_tmp66_ = _tmp65_;
				_tmp67_ = lsp_position_new_from_libvala (&_tmp66_);
				if (_tmp67_) {
					g_object_set_data ((GObject *) _tmp67_, "vala-creation-function", "Vls.Server.show_inlay_hints");
				}
				_tmp68_ = local;
				_tmp69_ = vala_variable_get_variable_type ((ValaVariable*) _tmp68_);
				_tmp70_ = _tmp69_;
				_tmp71_ = vls_code_help_get_data_type_representation (_tmp70_, NULL, FALSE);
				_tmp72_ = _tmp71_;
				_tmp73_ = g_strdup_printf (":%s", _tmp72_);
				_tmp74_ = lsp_inlay_hint_new ();
				lsp_inlay_hint_set_position (_tmp74_, _tmp67_);
				_g_object_unref0 (_tmp67_);
				lsp_inlay_hint_set_label (_tmp74_, _tmp73_);
				_g_free0 (_tmp73_);
				lsp_inlay_hint_set_kind (_tmp74_, LSP_INLAY_HINT_KIND_TYPE);
				lsp_inlay_hint_set_paddingLeft (_tmp74_, TRUE);
				_vala_array_add32 (&hints, &hints_length1, &_hints_size_, _tmp74_);
				_g_free0 (_tmp72_);
			} else {
				const gchar* _tmp75_;
				GMatchInfo* _tmp76_ = NULL;
				gboolean _tmp77_;
				_tmp75_ = representation;
				_tmp77_ = g_regex_match (_thread_safe_regex_init (&_tmp_regex_2, "foreach\\s*\\(\\s*var\\s+(\\w+)", 0 | G_REGEX_MULTILINE), _tmp75_, 0, &_tmp76_);
				_g_match_info_unref0 (foreach_match);
				foreach_match = _tmp76_;
				if (_tmp77_) {
					gint start = 0;
					gint end = 0;
					GMatchInfo* _tmp78_;
					gint _tmp79_ = 0;
					gint _tmp80_ = 0;
					gboolean _tmp81_;
					_tmp78_ = foreach_match;
					_tmp81_ = g_match_info_fetch_pos (_tmp78_, 1, &_tmp79_, &_tmp80_);
					start = _tmp79_;
					end = _tmp80_;
					if (_tmp81_) {
						ValaDataType* element_type = NULL;
						gboolean _tmp82_ = FALSE;
						gboolean _tmp83_ = FALSE;
						ValaCodeNode* _tmp84_;
						LspRange* range = NULL;
						ValaCodeNode* _tmp117_;
						ValaSourceReference* _tmp118_;
						ValaSourceReference* _tmp119_;
						const gchar* _tmp120_;
						LspRange* _tmp121_;
						LspRange* _tmp122_;
						LspPosition* _tmp123_;
						LspPosition* _tmp124_;
						LspPosition* _tmp125_;
						ValaDataType* _tmp126_;
						gchar* _tmp127_;
						gchar* _tmp128_;
						gchar* _tmp129_;
						LspInlayHint* _tmp130_ = NULL;
						element_type = NULL;
						_tmp84_ = item;
						if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp84_, VALA_TYPE_FOREACH_STATEMENT)) {
							ValaCodeNode* _tmp85_;
							ValaDataType* _tmp86_;
							ValaDataType* _tmp87_;
							_tmp85_ = item;
							_tmp86_ = vala_foreach_statement_get_type_reference (G_TYPE_CHECK_INSTANCE_CAST (_tmp85_, VALA_TYPE_FOREACH_STATEMENT, ValaForeachStatement));
							_tmp87_ = _tmp86_;
							_tmp83_ = !G_TYPE_CHECK_INSTANCE_TYPE (_tmp87_, VALA_TYPE_VAR_TYPE);
						} else {
							_tmp83_ = FALSE;
						}
						if (_tmp83_) {
							ValaCodeNode* _tmp88_;
							ValaLocalVariable* _tmp89_;
							ValaLocalVariable* _tmp90_;
							_tmp88_ = item;
							_tmp89_ = vala_foreach_statement_get_element_variable (G_TYPE_CHECK_INSTANCE_CAST (_tmp88_, VALA_TYPE_FOREACH_STATEMENT, ValaForeachStatement));
							_tmp90_ = _tmp89_;
							_tmp82_ = _tmp90_ != NULL;
						} else {
							_tmp82_ = FALSE;
						}
						if (_tmp82_) {
							ValaCodeNode* _tmp91_;
							ValaDataType* _tmp92_;
							ValaDataType* _tmp93_;
							ValaDataType* _tmp94_;
							_tmp91_ = item;
							_tmp92_ = vala_foreach_statement_get_type_reference (G_TYPE_CHECK_INSTANCE_CAST (_tmp91_, VALA_TYPE_FOREACH_STATEMENT, ValaForeachStatement));
							_tmp93_ = _tmp92_;
							_tmp94_ = _vala_code_node_ref0 (_tmp93_);
							_vala_code_node_unref0 (element_type);
							element_type = _tmp94_;
						} else {
							ValaLocalVariable* _tmp95_;
							_tmp95_ = local;
							if (_tmp95_ != NULL) {
								ValaLocalVariable* _tmp96_;
								ValaDataType* _tmp97_;
								ValaDataType* _tmp98_;
								ValaDataType* _tmp99_;
								gboolean is_element_var = FALSE;
								_tmp96_ = local;
								_tmp97_ = vala_variable_get_variable_type ((ValaVariable*) _tmp96_);
								_tmp98_ = _tmp97_;
								_tmp99_ = _vala_code_node_ref0 (_tmp98_);
								_vala_code_node_unref0 (element_type);
								element_type = _tmp99_;
								is_element_var = FALSE;
								{
									ValaCodeNode* current_node = NULL;
									ValaLocalVariable* _tmp100_;
									ValaCodeNode* _tmp101_;
									_tmp100_ = local;
									_tmp101_ = _vala_code_node_ref0 ((ValaCodeNode*) _tmp100_);
									current_node = _tmp101_;
									{
										gboolean _tmp102_ = FALSE;
										_tmp102_ = TRUE;
										while (TRUE) {
											ValaCodeNode* _tmp107_;
											ValaCodeNode* _tmp108_;
											if (!_tmp102_) {
												ValaCodeNode* _tmp103_;
												ValaCodeNode* _tmp104_;
												ValaCodeNode* _tmp105_;
												ValaCodeNode* _tmp106_;
												_tmp103_ = current_node;
												_tmp104_ = vala_code_node_get_parent_node (_tmp103_);
												_tmp105_ = _tmp104_;
												_tmp106_ = _vala_code_node_ref0 (_tmp105_);
												_vala_code_node_unref0 (current_node);
												current_node = _tmp106_;
											}
											_tmp102_ = FALSE;
											_tmp107_ = current_node;
											if (!(_tmp107_ != NULL)) {
												break;
											}
											_tmp108_ = current_node;
											if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp108_, VALA_TYPE_FOREACH_STATEMENT)) {
												ValaForeachStatement* stmt = NULL;
												ValaCodeNode* _tmp109_;
												ValaForeachStatement* _tmp110_;
												ValaForeachStatement* _tmp111_;
												const gchar* _tmp112_;
												const gchar* _tmp113_;
												ValaLocalVariable* _tmp114_;
												const gchar* _tmp115_;
												const gchar* _tmp116_;
												_tmp109_ = current_node;
												_tmp110_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp109_, VALA_TYPE_FOREACH_STATEMENT, ValaForeachStatement));
												stmt = _tmp110_;
												_tmp111_ = stmt;
												_tmp112_ = vala_foreach_statement_get_variable_name (_tmp111_);
												_tmp113_ = _tmp112_;
												_tmp114_ = local;
												_tmp115_ = vala_symbol_get_name ((ValaSymbol*) _tmp114_);
												_tmp116_ = _tmp115_;
												is_element_var = g_strcmp0 (_tmp113_, _tmp116_) == 0;
												_vala_code_node_unref0 (stmt);
												break;
											}
										}
									}
									_vala_code_node_unref0 (current_node);
								}
								if (!is_element_var) {
									_vala_code_node_unref0 (element_type);
									_g_match_info_unref0 (foreach_match);
									_g_free0 (representation);
									_vala_code_node_unref0 (local);
									_vala_code_node_unref0 (item);
									continue;
								}
							} else {
								_vala_code_node_unref0 (element_type);
								_g_match_info_unref0 (foreach_match);
								_g_free0 (representation);
								_vala_code_node_unref0 (local);
								_vala_code_node_unref0 (item);
								continue;
							}
						}
						_tmp117_ = item;
						_tmp118_ = vala_code_node_get_source_reference (_tmp117_);
						_tmp119_ = _tmp118_;
						_tmp120_ = representation;
						_tmp121_ = vls_symbol_references_get_narrowed_source_reference (_tmp119_, _tmp120_, start, end);
						range = _tmp121_;
						_tmp122_ = range;
						_tmp123_ = lsp_range_get_end (_tmp122_);
						_tmp124_ = _tmp123_;
						_tmp125_ = _g_object_ref0 (_tmp124_);
						_tmp126_ = element_type;
						_tmp127_ = vls_code_help_get_data_type_representation (_tmp126_, NULL, FALSE);
						_tmp128_ = _tmp127_;
						_tmp129_ = g_strdup_printf (":%s", _tmp128_);
						_tmp130_ = lsp_inlay_hint_new ();
						lsp_inlay_hint_set_position (_tmp130_, _tmp125_);
						_g_object_unref0 (_tmp125_);
						lsp_inlay_hint_set_label (_tmp130_, _tmp129_);
						_g_free0 (_tmp129_);
						lsp_inlay_hint_set_kind (_tmp130_, LSP_INLAY_HINT_KIND_TYPE);
						lsp_inlay_hint_set_paddingLeft (_tmp130_, TRUE);
						_vala_array_add33 (&hints, &hints_length1, &_hints_size_, _tmp130_);
						_g_free0 (_tmp128_);
						_g_object_unref0 (range);
						_vala_code_node_unref0 (element_type);
					}
				} else {
					ValaCodeNode* _tmp131_;
					_tmp131_ = item;
					if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp131_, VALA_TYPE_LAMBDA_EXPRESSION)) {
						ValaLambdaExpression* lambda = NULL;
						ValaCodeNode* _tmp132_;
						ValaLambdaExpression* _tmp133_;
						_tmp132_ = item;
						_tmp133_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp132_, VALA_TYPE_LAMBDA_EXPRESSION, ValaLambdaExpression));
						lambda = _tmp133_;
						{
							ValaList* _param_list = NULL;
							ValaLambdaExpression* _tmp134_;
							ValaList* _tmp135_;
							gint _param_size = 0;
							ValaList* _tmp136_;
							gint _tmp137_;
							gint _tmp138_;
							gint _param_index = 0;
							_tmp134_ = lambda;
							_tmp135_ = vala_lambda_expression_get_parameters (_tmp134_);
							_param_list = _tmp135_;
							_tmp136_ = _param_list;
							_tmp137_ = vala_collection_get_size ((ValaCollection*) _tmp136_);
							_tmp138_ = _tmp137_;
							_param_size = _tmp138_;
							_param_index = -1;
							while (TRUE) {
								gint _tmp139_;
								gint _tmp140_;
								ValaParameter* param = NULL;
								ValaList* _tmp141_;
								gpointer _tmp142_;
								LspRange* range = NULL;
								ValaParameter* _tmp143_;
								ValaSourceReference* _tmp144_;
								ValaSourceReference* _tmp145_;
								LspRange* _tmp146_;
								LspRange* _tmp147_;
								LspPosition* _tmp148_;
								LspPosition* _tmp149_;
								LspPosition* _tmp150_;
								ValaParameter* _tmp151_;
								ValaDataType* _tmp152_;
								ValaDataType* _tmp153_;
								gchar* _tmp154_;
								LspInlayHint* _tmp155_ = NULL;
								_param_index = _param_index + 1;
								_tmp139_ = _param_index;
								_tmp140_ = _param_size;
								if (!(_tmp139_ < _tmp140_)) {
									break;
								}
								_tmp141_ = _param_list;
								_tmp142_ = vala_list_get (_tmp141_, _param_index);
								param = (ValaParameter*) _tmp142_;
								_tmp143_ = param;
								_tmp144_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp143_);
								_tmp145_ = _tmp144_;
								_tmp146_ = lsp_range_new_from_sourceref (_tmp145_);
								if (_tmp146_) {
									g_object_set_data ((GObject *) _tmp146_, "vala-creation-function", "Vls.Server.show_inlay_hints");
								}
								range = _tmp146_;
								_tmp147_ = range;
								_tmp148_ = lsp_range_get_start (_tmp147_);
								_tmp149_ = _tmp148_;
								_tmp150_ = _g_object_ref0 (_tmp149_);
								_tmp151_ = param;
								_tmp152_ = vala_variable_get_variable_type ((ValaVariable*) _tmp151_);
								_tmp153_ = _tmp152_;
								_tmp154_ = vls_code_help_get_data_type_representation (_tmp153_, NULL, FALSE);
								_tmp155_ = lsp_inlay_hint_new ();
								lsp_inlay_hint_set_position (_tmp155_, _tmp150_);
								_g_object_unref0 (_tmp150_);
								lsp_inlay_hint_set_label (_tmp155_, _tmp154_);
								_g_free0 (_tmp154_);
								lsp_inlay_hint_set_kind (_tmp155_, LSP_INLAY_HINT_KIND_PARAMETER);
								lsp_inlay_hint_set_paddingRight (_tmp155_, TRUE);
								_vala_array_add34 (&hints, &hints_length1, &_hints_size_, _tmp155_);
								_g_object_unref0 (range);
								_vala_code_node_unref0 (param);
							}
						}
						_vala_code_node_unref0 (lambda);
					} else {
						gboolean _tmp156_ = FALSE;
						gboolean _tmp157_ = FALSE;
						ValaCodeNode* _tmp158_;
						_tmp158_ = item;
						if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp158_, VALA_TYPE_METHOD_CALL)) {
							_tmp157_ = TRUE;
						} else {
							ValaCodeNode* _tmp159_;
							_tmp159_ = item;
							_tmp157_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp159_, VALA_TYPE_OBJECT_CREATION_EXPRESSION);
						}
						if (_tmp157_) {
							VlsCompilation* _tmp160_;
							GeeHashMap* _tmp161_;
							GeeHashMap* _tmp162_;
							ValaCodeNode* _tmp163_;
							_tmp160_ = compilation;
							_tmp161_ = vls_compilation_get_method_calls (_tmp160_);
							_tmp162_ = _tmp161_;
							_tmp163_ = item;
							_tmp156_ = gee_abstract_map_has_key ((GeeAbstractMap*) _tmp162_, _tmp163_);
						} else {
							_tmp156_ = FALSE;
						}
						if (_tmp156_) {
							ValaList* parameters = NULL;
							ValaCodeNode* _tmp164_;
							ValaList* _tmp195_;
							parameters = NULL;
							_tmp164_ = item;
							if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp164_, VALA_TYPE_METHOD_CALL)) {
								ValaCodeNode* _tmp165_;
								ValaExpression* _tmp166_;
								ValaExpression* _tmp167_;
								ValaDataType* _tmp168_;
								ValaDataType* _tmp169_;
								ValaList* _tmp170_;
								ValaList* _tmp171_;
								_tmp165_ = item;
								_tmp166_ = vala_callable_expression_get_call ((ValaCallableExpression*) G_TYPE_CHECK_INSTANCE_CAST (_tmp165_, VALA_TYPE_METHOD_CALL, ValaMethodCall));
								_tmp167_ = _tmp166_;
								_tmp168_ = vala_expression_get_value_type (_tmp167_);
								_tmp169_ = _tmp168_;
								_tmp170_ = vala_data_type_get_parameters (_tmp169_);
								_tmp171_ = _vala_iterable_ref0 (_tmp170_);
								_vala_iterable_unref0 (parameters);
								parameters = _tmp171_;
							} else {
								ValaObjectCreationExpression* oce = NULL;
								ValaCodeNode* _tmp172_;
								ValaObjectCreationExpression* _tmp173_;
								gboolean _tmp174_ = FALSE;
								ValaObjectCreationExpression* _tmp175_;
								ValaMemberAccess* _tmp176_;
								ValaMemberAccess* _tmp177_;
								_tmp172_ = item;
								_tmp173_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp172_, VALA_TYPE_OBJECT_CREATION_EXPRESSION, ValaObjectCreationExpression));
								oce = _tmp173_;
								_tmp175_ = oce;
								_tmp176_ = vala_object_creation_expression_get_member_name (_tmp175_);
								_tmp177_ = _tmp176_;
								if (_tmp177_ != NULL) {
									ValaObjectCreationExpression* _tmp178_;
									ValaMemberAccess* _tmp179_;
									ValaMemberAccess* _tmp180_;
									ValaSymbol* _tmp181_;
									ValaSymbol* _tmp182_;
									_tmp178_ = oce;
									_tmp179_ = vala_object_creation_expression_get_member_name (_tmp178_);
									_tmp180_ = _tmp179_;
									_tmp181_ = vala_expression_get_symbol_reference ((ValaExpression*) _tmp180_);
									_tmp182_ = _tmp181_;
									_tmp174_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp182_, VALA_TYPE_CALLABLE);
								} else {
									_tmp174_ = FALSE;
								}
								if (_tmp174_) {
									ValaObjectCreationExpression* _tmp183_;
									ValaMemberAccess* _tmp184_;
									ValaMemberAccess* _tmp185_;
									ValaSymbol* _tmp186_;
									ValaSymbol* _tmp187_;
									ValaList* _tmp188_;
									ValaList* _tmp189_;
									_tmp183_ = oce;
									_tmp184_ = vala_object_creation_expression_get_member_name (_tmp183_);
									_tmp185_ = _tmp184_;
									_tmp186_ = vala_expression_get_symbol_reference ((ValaExpression*) _tmp185_);
									_tmp187_ = _tmp186_;
									_tmp188_ = vala_callable_get_parameters (G_TYPE_CHECK_INSTANCE_CAST (_tmp187_, VALA_TYPE_CALLABLE, ValaCallable));
									_tmp189_ = _vala_iterable_ref0 (_tmp188_);
									_vala_iterable_unref0 (parameters);
									parameters = _tmp189_;
								} else {
									ValaObjectCreationExpression* _tmp190_;
									ValaDataType* _tmp191_;
									ValaDataType* _tmp192_;
									ValaList* _tmp193_;
									ValaList* _tmp194_;
									_tmp190_ = oce;
									_tmp191_ = vala_object_creation_expression_get_type_reference (_tmp190_);
									_tmp192_ = _tmp191_;
									_tmp193_ = vala_data_type_get_parameters (_tmp192_);
									_tmp194_ = _vala_iterable_ref0 (_tmp193_);
									_vala_iterable_unref0 (parameters);
									parameters = _tmp194_;
								}
								_vala_code_node_unref0 (oce);
							}
							_tmp195_ = parameters;
							if (_tmp195_ != NULL) {
								gint orig_param_count = 0;
								VlsCompilation* _tmp196_;
								GeeHashMap* _tmp197_;
								GeeHashMap* _tmp198_;
								ValaCodeNode* _tmp199_;
								gpointer _tmp200_;
								ValaIterator* iter = NULL;
								ValaList* _tmp201_;
								ValaIterator* _tmp202_;
								gint args_i = 0;
								ValaParameter* last_ellipsis = NULL;
								ValaList* argument_list = NULL;
								ValaCodeNode* _tmp203_;
								_tmp196_ = compilation;
								_tmp197_ = vls_compilation_get_method_calls (_tmp196_);
								_tmp198_ = _tmp197_;
								_tmp199_ = item;
								_tmp200_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp198_, _tmp199_);
								orig_param_count = (gint) ((gintptr) _tmp200_);
								_tmp201_ = parameters;
								_tmp202_ = vala_iterable_iterator ((ValaIterable*) _tmp201_);
								iter = _tmp202_;
								args_i = 0;
								last_ellipsis = NULL;
								_tmp203_ = item;
								if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp203_, VALA_TYPE_METHOD_CALL)) {
									ValaCodeNode* _tmp204_;
									ValaList* _tmp205_;
									ValaList* _tmp206_;
									_tmp204_ = item;
									_tmp205_ = vala_callable_expression_get_argument_list ((ValaCallableExpression*) G_TYPE_CHECK_INSTANCE_CAST (_tmp204_, VALA_TYPE_METHOD_CALL, ValaMethodCall));
									_tmp206_ = _vala_iterable_ref0 (_tmp205_);
									_vala_iterable_unref0 (argument_list);
									argument_list = _tmp206_;
								} else {
									ValaCodeNode* _tmp207_;
									ValaList* _tmp208_;
									ValaList* _tmp209_;
									_tmp207_ = item;
									_tmp208_ = vala_callable_expression_get_argument_list ((ValaCallableExpression*) G_TYPE_CHECK_INSTANCE_CAST (_tmp207_, VALA_TYPE_OBJECT_CREATION_EXPRESSION, ValaObjectCreationExpression));
									_tmp209_ = _vala_iterable_ref0 (_tmp208_);
									_vala_iterable_unref0 (argument_list);
									argument_list = _tmp209_;
								}
								{
									ValaList* _arg_list = NULL;
									ValaList* _tmp210_;
									gint _arg_size = 0;
									ValaList* _tmp211_;
									gint _tmp212_;
									gint _tmp213_;
									gint _arg_index = 0;
									_tmp210_ = argument_list;
									_arg_list = _tmp210_;
									_tmp211_ = _arg_list;
									_tmp212_ = vala_collection_get_size ((ValaCollection*) _tmp211_);
									_tmp213_ = _tmp212_;
									_arg_size = _tmp213_;
									_arg_index = -1;
									while (TRUE) {
										gint _tmp214_;
										gint _tmp215_;
										ValaExpression* arg = NULL;
										ValaList* _tmp216_;
										gpointer _tmp217_;
										ValaExpression* _tmp218_;
										ValaSourceReference* _tmp219_;
										ValaSourceReference* _tmp220_;
										ValaExpression* _tmp222_;
										gboolean _tmp224_ = FALSE;
										ValaIterator* _tmp225_;
										ValaParameter* _tmp227_ = NULL;
										ValaParameter* _tmp228_;
										ValaParameter* _tmp229_;
										ValaParameter* formal_parameter = NULL;
										ValaParameter* _tmp232_;
										ValaParameter* _tmp233_;
										gboolean _tmp234_;
										gboolean _tmp235_;
										gchar* _tmp238_ = NULL;
										ValaParameter* _tmp239_;
										const gchar* _tmp240_;
										const gchar* _tmp241_;
										gchar* _tmp242_;
										gchar* parameter_name = NULL;
										gchar* _tmp246_;
										ValaExpression* argument = NULL;
										ValaExpression* _tmp247_;
										ValaExpression* _tmp248_;
										gboolean _tmp249_ = FALSE;
										ValaExpression* _tmp250_;
										ValaExpression* _tmp262_;
										gchar* _tmp263_;
										gchar* _tmp264_;
										gchar* _tmp265_;
										gchar* _tmp266_;
										const gchar* _tmp267_;
										gchar* _tmp268_;
										gchar* _tmp269_;
										gboolean _tmp270_;
										LspRange* range = NULL;
										ValaExpression* _tmp272_;
										ValaSourceReference* _tmp273_;
										ValaSourceReference* _tmp274_;
										LspRange* _tmp275_;
										LspRange* _tmp276_;
										LspPosition* _tmp277_;
										LspPosition* _tmp278_;
										LspPosition* _tmp279_;
										const gchar* _tmp280_;
										gchar* _tmp281_;
										LspInlayHint* _tmp282_ = NULL;
										gint _tmp283_;
										_arg_index = _arg_index + 1;
										_tmp214_ = _arg_index;
										_tmp215_ = _arg_size;
										if (!(_tmp214_ < _tmp215_)) {
											break;
										}
										_tmp216_ = _arg_list;
										_tmp217_ = vala_list_get (_tmp216_, _arg_index);
										arg = (ValaExpression*) _tmp217_;
										_tmp218_ = arg;
										_tmp219_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp218_);
										_tmp220_ = _tmp219_;
										if (_tmp220_ == NULL) {
											gint _tmp221_;
											_tmp221_ = args_i;
											args_i = _tmp221_ + 1;
											_vala_code_node_unref0 (arg);
											continue;
										}
										if (args_i >= orig_param_count) {
											_vala_code_node_unref0 (arg);
											break;
										}
										_tmp222_ = arg;
										if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp222_, VALA_TYPE_NAMED_ARGUMENT)) {
											gint _tmp223_;
											_tmp223_ = args_i;
											args_i = _tmp223_ + 1;
											_vala_code_node_unref0 (arg);
											continue;
										}
										_tmp225_ = iter;
										if (!vala_iterator_next (_tmp225_)) {
											ValaParameter* _tmp226_;
											_tmp226_ = last_ellipsis;
											_tmp224_ = _tmp226_ == NULL;
										} else {
											_tmp224_ = FALSE;
										}
										if (_tmp224_) {
											_vala_code_node_unref0 (arg);
											break;
										}
										_tmp228_ = last_ellipsis;
										_tmp229_ = _vala_code_node_ref0 (_tmp228_);
										_tmp227_ = _tmp229_;
										if (_tmp227_ == NULL) {
											ValaIterator* _tmp230_;
											gpointer _tmp231_;
											_tmp230_ = iter;
											_tmp231_ = vala_iterator_get (_tmp230_);
											_vala_code_node_unref0 (_tmp227_);
											_tmp227_ = (ValaParameter*) _tmp231_;
										}
										_tmp232_ = _tmp227_;
										_tmp227_ = NULL;
										formal_parameter = _tmp232_;
										_tmp233_ = formal_parameter;
										_tmp234_ = vala_parameter_get_ellipsis (_tmp233_);
										_tmp235_ = _tmp234_;
										if (_tmp235_) {
											ValaParameter* _tmp236_;
											ValaParameter* _tmp237_;
											_tmp236_ = formal_parameter;
											_tmp237_ = _vala_code_node_ref0 (_tmp236_);
											_vala_code_node_unref0 (last_ellipsis);
											last_ellipsis = _tmp237_;
										}
										_tmp239_ = formal_parameter;
										_tmp240_ = vala_symbol_get_name ((ValaSymbol*) _tmp239_);
										_tmp241_ = _tmp240_;
										_tmp242_ = g_strdup (_tmp241_);
										_tmp238_ = _tmp242_;
										if (_tmp238_ == NULL) {
											gchar* _tmp243_;
											gchar* _tmp244_;
											gchar* _tmp245_;
											_tmp243_ = g_strdup_printf ("%i", args_i);
											_tmp244_ = _tmp243_;
											_tmp245_ = g_strconcat ("arg", _tmp244_, NULL);
											_g_free0 (_tmp238_);
											_tmp238_ = _tmp245_;
											_g_free0 (_tmp244_);
										}
										_tmp246_ = _tmp238_;
										_tmp238_ = NULL;
										parameter_name = _tmp246_;
										_tmp247_ = arg;
										_tmp248_ = _vala_code_node_ref0 (_tmp247_);
										argument = _tmp248_;
										_tmp250_ = argument;
										if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp250_, VALA_TYPE_UNARY_EXPRESSION)) {
											gboolean _tmp251_ = FALSE;
											ValaExpression* _tmp252_;
											ValaUnaryOperator _tmp253_;
											ValaUnaryOperator _tmp254_;
											_tmp252_ = argument;
											_tmp253_ = vala_unary_expression_get_operator (G_TYPE_CHECK_INSTANCE_CAST (_tmp252_, VALA_TYPE_UNARY_EXPRESSION, ValaUnaryExpression));
											_tmp254_ = _tmp253_;
											if (_tmp254_ == VALA_UNARY_OPERATOR_REF) {
												_tmp251_ = TRUE;
											} else {
												ValaExpression* _tmp255_;
												ValaUnaryOperator _tmp256_;
												ValaUnaryOperator _tmp257_;
												_tmp255_ = argument;
												_tmp256_ = vala_unary_expression_get_operator (G_TYPE_CHECK_INSTANCE_CAST (_tmp255_, VALA_TYPE_UNARY_EXPRESSION, ValaUnaryExpression));
												_tmp257_ = _tmp256_;
												_tmp251_ = _tmp257_ == VALA_UNARY_OPERATOR_OUT;
											}
											_tmp249_ = _tmp251_;
										} else {
											_tmp249_ = FALSE;
										}
										if (_tmp249_) {
											ValaExpression* _tmp258_;
											ValaExpression* _tmp259_;
											ValaExpression* _tmp260_;
											ValaExpression* _tmp261_;
											_tmp258_ = argument;
											_tmp259_ = vala_unary_expression_get_inner (G_TYPE_CHECK_INSTANCE_CAST (_tmp258_, VALA_TYPE_UNARY_EXPRESSION, ValaUnaryExpression));
											_tmp260_ = _tmp259_;
											_tmp261_ = _vala_code_node_ref0 (_tmp260_);
											_vala_code_node_unref0 (argument);
											argument = _tmp261_;
										}
										_tmp262_ = argument;
										_tmp263_ = vls_code_help_get_code_node_source ((ValaCodeNode*) _tmp262_);
										_tmp264_ = _tmp263_;
										_tmp265_ = g_utf8_casefold (_tmp264_, (gssize) -1);
										_tmp266_ = _tmp265_;
										_tmp267_ = parameter_name;
										_tmp268_ = g_utf8_casefold (_tmp267_, (gssize) -1);
										_tmp269_ = _tmp268_;
										_tmp270_ = g_strcmp0 (_tmp266_, _tmp269_) == 0;
										_g_free0 (_tmp269_);
										_g_free0 (_tmp266_);
										_g_free0 (_tmp264_);
										if (_tmp270_) {
											gint _tmp271_;
											_tmp271_ = args_i;
											args_i = _tmp271_ + 1;
											_vala_code_node_unref0 (argument);
											_g_free0 (parameter_name);
											_g_free0 (_tmp238_);
											_vala_code_node_unref0 (formal_parameter);
											_vala_code_node_unref0 (_tmp227_);
											_vala_code_node_unref0 (arg);
											continue;
										}
										_tmp272_ = arg;
										_tmp273_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp272_);
										_tmp274_ = _tmp273_;
										_tmp275_ = lsp_range_new_from_sourceref (_tmp274_);
										if (_tmp275_) {
											g_object_set_data ((GObject *) _tmp275_, "vala-creation-function", "Vls.Server.show_inlay_hints");
										}
										range = _tmp275_;
										_tmp276_ = range;
										_tmp277_ = lsp_range_get_start (_tmp276_);
										_tmp278_ = _tmp277_;
										_tmp279_ = _g_object_ref0 (_tmp278_);
										_tmp280_ = parameter_name;
										_tmp281_ = g_strdup_printf ("%s:", _tmp280_);
										_tmp282_ = lsp_inlay_hint_new ();
										lsp_inlay_hint_set_position (_tmp282_, _tmp279_);
										_g_object_unref0 (_tmp279_);
										lsp_inlay_hint_set_label (_tmp282_, _tmp281_);
										_g_free0 (_tmp281_);
										lsp_inlay_hint_set_kind (_tmp282_, LSP_INLAY_HINT_KIND_PARAMETER);
										lsp_inlay_hint_set_paddingRight (_tmp282_, TRUE);
										_vala_array_add35 (&hints, &hints_length1, &_hints_size_, _tmp282_);
										_tmp283_ = args_i;
										args_i = _tmp283_ + 1;
										_g_object_unref0 (range);
										_vala_code_node_unref0 (argument);
										_g_free0 (parameter_name);
										_g_free0 (_tmp238_);
										_vala_code_node_unref0 (formal_parameter);
										_vala_code_node_unref0 (_tmp227_);
										_vala_code_node_unref0 (arg);
									}
								}
								_vala_iterable_unref0 (argument_list);
								_vala_code_node_unref0 (last_ellipsis);
								_vala_iterator_unref0 (iter);
							}
							_vala_iterable_unref0 (parameters);
						}
					}
				}
			}
			_g_match_info_unref0 (foreach_match);
			_g_free0 (representation);
			_vala_code_node_unref0 (local);
			_vala_code_node_unref0 (item);
		}
	}
	vala_code_context_pop ();
	{
		GVariant** array = NULL;
		GVariant** _tmp284_;
		gint array_length1;
		gint _array_size_;
		LspInlayHint** _tmp285_;
		gint _tmp285__length1;
		const GVariantType* _tmp291_;
		GVariant** _tmp292_;
		gint _tmp292__length1;
		GVariant* _tmp293_;
		GVariant* _tmp294_;
		GCancellable* _tmp295_;
		_tmp284_ = g_new0 (GVariant*, 0 + 1);
		array = _tmp284_;
		array_length1 = 0;
		_array_size_ = array_length1;
		_tmp285_ = hints;
		_tmp285__length1 = hints_length1;
		{
			LspInlayHint** hint_collection = NULL;
			gint hint_collection_length1 = 0;
			gint _hint_collection_size_ = 0;
			gint hint_it = 0;
			hint_collection = _tmp285_;
			hint_collection_length1 = _tmp285__length1;
			for (hint_it = 0; hint_it < hint_collection_length1; hint_it = hint_it + 1) {
				LspInlayHint* _tmp286_;
				LspInlayHint* hint = NULL;
				_tmp286_ = _g_object_ref0 (hint_collection[hint_it]);
				hint = _tmp286_;
				{
					GVariant* _tmp287_ = NULL;
					LspInlayHint* _tmp288_;
					GVariant* _tmp289_;
					GVariant* _tmp290_;
					_tmp288_ = hint;
					_tmp289_ = vls_util_object_to_variant ((GObject*) _tmp288_, &_inner_error0_);
					_tmp287_ = _tmp289_;
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						_g_object_unref0 (hint);
						array = (_vala_array_free (array, array_length1, (GDestroyNotify) g_variant_unref), NULL);
						goto __catch0_g_error;
					}
					_tmp290_ = _tmp287_;
					_tmp287_ = NULL;
					_vala_array_add36 (&array, &array_length1, &_array_size_, _tmp290_);
					_g_variant_unref0 (_tmp287_);
					_g_object_unref0 (hint);
				}
			}
		}
		_tmp291_ = G_VARIANT_TYPE_VARDICT;
		_tmp292_ = array;
		_tmp292__length1 = array_length1;
		_tmp293_ = g_variant_new_array (_tmp291_, _tmp292_, _tmp292__length1);
		g_variant_ref_sink (_tmp293_);
		_tmp294_ = _tmp293_;
		_tmp295_ = vls_server_cancellable;
		jsonrpc_client_reply (client, id, _tmp294_, _tmp295_, &_inner_error0_);
		_g_variant_unref0 (_tmp294_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			array = (_vala_array_free (array, array_length1, (GDestroyNotify) g_variant_unref), NULL);
			goto __catch0_g_error;
		}
		array = (_vala_array_free (array, array_length1, (GDestroyNotify) g_variant_unref), NULL);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp296_;
		GError* _tmp297_;
		const gchar* _tmp298_;
		const gchar* _tmp299_;
		gchar* _tmp300_;
		gchar* _tmp301_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp296_ = string_to_string (method);
		_tmp297_ = e;
		_tmp298_ = _tmp297_->message;
		_tmp299_ = string_to_string (_tmp298_);
		_tmp300_ = g_strconcat ("[", _tmp296_, "] failed to reply to client: ", _tmp299_, NULL);
		_tmp301_ = _tmp300_;
		g_debug ("server.vala:2279: %s", _tmp301_);
		_g_free0 (_tmp301_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		hints = (_vala_array_free (hints, hints_length1, (GDestroyNotify) g_object_unref), NULL);
		_vala_code_visitor_unref0 (query);
		_vala_source_file_unref0 (file);
		_g_object_unref0 (compilation);
		_g_object_unref0 (p);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	hints = (_vala_array_free (hints, hints_length1, (GDestroyNotify) g_object_unref), NULL);
	_vala_code_visitor_unref0 (query);
	_vala_source_file_unref0 (file);
	_g_object_unref0 (compilation);
	_g_object_unref0 (p);
}

static void
vls_server_prepare_type_hierarchy (VlsServer* self,
                                   JsonrpcClient* client,
                                   const gchar* method,
                                   GVariant* id,
                                   GVariant* params)
{
	LspTextDocumentPositionParams* p = NULL;
	gpointer _tmp0_;
	VlsProject* project = NULL;
	VlsCompilation* compilation = NULL;
	ValaSourceFile* doc = NULL;
	LspTextDocumentPositionParams* _tmp1_;
	LspTextDocumentIdentifier* _tmp2_;
	LspTextDocumentIdentifier* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	VlsCompilation* _tmp6_ = NULL;
	VlsProject* _tmp7_ = NULL;
	ValaSourceFile* _tmp8_;
	ValaSourceFile* _tmp9_;
	VlsCompilation* _tmp15_;
	ValaCodeContext* _tmp16_;
	ValaCodeContext* _tmp17_;
	VlsNodeSearch* fs = NULL;
	ValaSourceFile* _tmp18_;
	LspTextDocumentPositionParams* _tmp19_;
	LspPosition* _tmp20_;
	LspPosition* _tmp21_;
	VlsNodeSearch* _tmp22_;
	VlsNodeSearch* _tmp23_;
	GeeList* _tmp24_;
	gint _tmp25_;
	gint _tmp26_;
	ValaCodeNode* _result_ = NULL;
	VlsNodeSearch* _tmp30_;
	ValaSourceFile* _tmp31_;
	ValaCodeNode* _tmp32_;
	ValaTypeSymbol* type_symbol = NULL;
	ValaCodeNode* _tmp33_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (client != NULL);
	g_return_if_fail (method != NULL);
	g_return_if_fail (id != NULL);
	g_return_if_fail (params != NULL);
	_tmp0_ = vls_util_parse_variant (LSP_TYPE_TEXT_DOCUMENT_POSITION_PARAMS, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, params);
	p = (LspTextDocumentPositionParams*) _tmp0_;
	_tmp1_ = p;
	_tmp2_ = lsp_text_document_position_params_get_textDocument (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = lsp_text_document_identifier_get_uri (_tmp3_);
	_tmp5_ = _tmp4_;
	_tmp8_ = vls_server_find_file (self, _tmp5_, &_tmp6_, &_tmp7_);
	_g_object_unref0 (compilation);
	compilation = _tmp6_;
	_g_object_unref0 (project);
	project = _tmp7_;
	doc = _tmp8_;
	_tmp9_ = doc;
	if (_tmp9_ == NULL) {
		LspTextDocumentPositionParams* _tmp10_;
		LspTextDocumentIdentifier* _tmp11_;
		LspTextDocumentIdentifier* _tmp12_;
		const gchar* _tmp13_;
		const gchar* _tmp14_;
		_tmp10_ = p;
		_tmp11_ = lsp_text_document_position_params_get_textDocument (_tmp10_);
		_tmp12_ = _tmp11_;
		_tmp13_ = lsp_text_document_identifier_get_uri (_tmp12_);
		_tmp14_ = _tmp13_;
		g_debug ("server.vala:2290: [%s] file `%s' not found", method, _tmp14_);
		vls_server_reply_null (id, client, method);
		_vala_source_file_unref0 (doc);
		_g_object_unref0 (compilation);
		_g_object_unref0 (project);
		_g_object_unref0 (p);
		return;
	}
	_tmp15_ = compilation;
	_tmp16_ = vls_compilation_get_code_context (_tmp15_);
	_tmp17_ = _tmp16_;
	vala_code_context_push (_tmp17_);
	_tmp18_ = doc;
	_tmp19_ = p;
	_tmp20_ = lsp_text_document_position_params_get_position (_tmp19_);
	_tmp21_ = _tmp20_;
	_tmp22_ = vls_node_search_new (_tmp18_, _tmp21_, FALSE, NULL, TRUE);
	fs = _tmp22_;
	_tmp23_ = fs;
	_tmp24_ = _tmp23_->result;
	_tmp25_ = gee_collection_get_size ((GeeCollection*) _tmp24_);
	_tmp26_ = _tmp25_;
	if (_tmp26_ == 0) {
		const gchar* _tmp27_;
		gchar* _tmp28_;
		gchar* _tmp29_;
		_tmp27_ = string_to_string (method);
		_tmp28_ = g_strconcat ("[", _tmp27_, "] no results found", NULL);
		_tmp29_ = _tmp28_;
		g_debug ("server.vala:2300: %s", _tmp29_);
		_g_free0 (_tmp29_);
		vls_server_reply_null (id, client, method);
		vala_code_context_pop ();
		_vala_code_visitor_unref0 (fs);
		_vala_source_file_unref0 (doc);
		_g_object_unref0 (compilation);
		_g_object_unref0 (project);
		_g_object_unref0 (p);
		return;
	}
	_tmp30_ = fs;
	_tmp31_ = doc;
	_tmp32_ = vls_server_get_best (_tmp30_, _tmp31_);
	_result_ = _tmp32_;
	vala_code_context_pop ();
	_tmp33_ = _result_;
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp33_, VALA_TYPE_TYPESYMBOL)) {
		ValaCodeNode* _tmp34_;
		ValaTypeSymbol* _tmp35_;
		_tmp34_ = _result_;
		_tmp35_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp34_, VALA_TYPE_TYPESYMBOL, ValaTypeSymbol));
		_vala_code_node_unref0 (type_symbol);
		type_symbol = _tmp35_;
	} else {
		gboolean _tmp36_ = FALSE;
		ValaCodeNode* _tmp37_;
		_tmp37_ = _result_;
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp37_, VALA_TYPE_DATA_TYPE)) {
			ValaCodeNode* _tmp38_;
			ValaTypeSymbol* _tmp39_;
			ValaTypeSymbol* _tmp40_;
			_tmp38_ = _result_;
			_tmp39_ = vala_data_type_get_type_symbol (G_TYPE_CHECK_INSTANCE_CAST (_tmp38_, VALA_TYPE_DATA_TYPE, ValaDataType));
			_tmp40_ = _tmp39_;
			_tmp36_ = _tmp40_ != NULL;
		} else {
			_tmp36_ = FALSE;
		}
		if (_tmp36_) {
			ValaCodeNode* _tmp41_;
			ValaTypeSymbol* _tmp42_;
			ValaTypeSymbol* _tmp43_;
			ValaTypeSymbol* _tmp44_;
			_tmp41_ = _result_;
			_tmp42_ = vala_data_type_get_type_symbol (G_TYPE_CHECK_INSTANCE_CAST (_tmp41_, VALA_TYPE_DATA_TYPE, ValaDataType));
			_tmp43_ = _tmp42_;
			_tmp44_ = _vala_code_node_ref0 (_tmp43_);
			_vala_code_node_unref0 (type_symbol);
			type_symbol = _tmp44_;
		} else {
			gboolean _tmp45_ = FALSE;
			ValaCodeNode* _tmp46_;
			_tmp46_ = _result_;
			if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp46_, VALA_TYPE_EXPRESSION)) {
				ValaCodeNode* _tmp47_;
				ValaSymbol* _tmp48_;
				ValaSymbol* _tmp49_;
				_tmp47_ = _result_;
				_tmp48_ = vala_expression_get_symbol_reference (G_TYPE_CHECK_INSTANCE_CAST (_tmp47_, VALA_TYPE_EXPRESSION, ValaExpression));
				_tmp49_ = _tmp48_;
				_tmp45_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp49_, VALA_TYPE_TYPESYMBOL);
			} else {
				_tmp45_ = FALSE;
			}
			if (_tmp45_) {
				ValaCodeNode* _tmp50_;
				ValaSymbol* _tmp51_;
				ValaSymbol* _tmp52_;
				ValaTypeSymbol* _tmp53_;
				_tmp50_ = _result_;
				_tmp51_ = vala_expression_get_symbol_reference (G_TYPE_CHECK_INSTANCE_CAST (_tmp50_, VALA_TYPE_EXPRESSION, ValaExpression));
				_tmp52_ = _tmp51_;
				_tmp53_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp52_, VALA_TYPE_TYPESYMBOL, ValaTypeSymbol));
				_vala_code_node_unref0 (type_symbol);
				type_symbol = _tmp53_;
				{
					GeeIterator* _pair_it = NULL;
					ValaCodeNode* _tmp54_;
					GeeCollection* _tmp55_;
					GeeCollection* _tmp56_;
					GeeIterator* _tmp57_;
					GeeIterator* _tmp58_;
					_tmp54_ = _result_;
					_tmp55_ = vls_symbol_references_get_visible_components_of_code_node (_tmp54_);
					_tmp56_ = _tmp55_;
					_tmp57_ = gee_iterable_iterator ((GeeIterable*) _tmp56_);
					_tmp58_ = _tmp57_;
					_g_object_unref0 (_tmp56_);
					_pair_it = _tmp58_;
					while (TRUE) {
						GeeIterator* _tmp59_;
						VlsPair* pair = NULL;
						GeeIterator* _tmp60_;
						gpointer _tmp61_;
						ValaSymbol* symbol = NULL;
						VlsPair* _tmp62_;
						gconstpointer _tmp63_;
						gconstpointer _tmp64_;
						ValaSymbol* _tmp65_;
						LspRange* range = NULL;
						VlsPair* _tmp66_;
						gconstpointer _tmp67_;
						gconstpointer _tmp68_;
						LspRange* _tmp69_;
						gboolean _tmp70_ = FALSE;
						ValaSymbol* _tmp71_;
						_tmp59_ = _pair_it;
						if (!gee_iterator_next (_tmp59_)) {
							break;
						}
						_tmp60_ = _pair_it;
						_tmp61_ = gee_iterator_get (_tmp60_);
						pair = (VlsPair*) _tmp61_;
						_tmp62_ = pair;
						_tmp63_ = vls_pair_get_first (_tmp62_);
						_tmp64_ = _tmp63_;
						_tmp65_ = _vala_code_node_ref0 ((ValaSymbol*) _tmp64_);
						symbol = _tmp65_;
						_tmp66_ = pair;
						_tmp67_ = vls_pair_get_second (_tmp66_);
						_tmp68_ = _tmp67_;
						_tmp69_ = _g_object_ref0 ((LspRange*) _tmp68_);
						range = _tmp69_;
						_tmp71_ = symbol;
						if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp71_, VALA_TYPE_TYPESYMBOL)) {
							LspRange* _tmp72_;
							LspTextDocumentPositionParams* _tmp73_;
							LspPosition* _tmp74_;
							LspPosition* _tmp75_;
							_tmp72_ = range;
							_tmp73_ = p;
							_tmp74_ = lsp_text_document_position_params_get_position (_tmp73_);
							_tmp75_ = _tmp74_;
							_tmp70_ = lsp_range_contains (_tmp72_, _tmp75_);
						} else {
							_tmp70_ = FALSE;
						}
						if (_tmp70_) {
							ValaSymbol* _tmp76_;
							ValaTypeSymbol* _tmp77_;
							_tmp76_ = symbol;
							_tmp77_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp76_, VALA_TYPE_TYPESYMBOL, ValaTypeSymbol));
							_vala_code_node_unref0 (type_symbol);
							type_symbol = _tmp77_;
							_g_object_unref0 (range);
							_vala_code_node_unref0 (symbol);
							_g_object_unref0 (pair);
							break;
						}
						_g_object_unref0 (range);
						_vala_code_node_unref0 (symbol);
						_g_object_unref0 (pair);
					}
					_g_object_unref0 (_pair_it);
				}
			} else {
				vls_server_reply_null (id, client, method);
				_vala_code_node_unref0 (type_symbol);
				_vala_code_node_unref0 (_result_);
				_vala_code_visitor_unref0 (fs);
				_vala_source_file_unref0 (doc);
				_g_object_unref0 (compilation);
				_g_object_unref0 (project);
				_g_object_unref0 (p);
				return;
			}
		}
	}
	{
		GVariant* _tmp78_ = NULL;
		ValaTypeSymbol* _tmp79_;
		LspTypeHierarchyItem* _tmp80_;
		LspTypeHierarchyItem* _tmp81_;
		GVariant* _tmp82_;
		GVariant* _tmp83_;
		GVariant* array = NULL;
		GVariant* _tmp84_;
		GVariant** _tmp85_;
		GVariant** _tmp86_;
		gint _tmp86__length1;
		GVariant* _tmp87_;
		GVariant* _tmp88_;
		GVariant* _tmp89_;
		GCancellable* _tmp90_;
		_tmp79_ = type_symbol;
		_tmp80_ = lsp_typehierarchy_item_new_from_symbol (_tmp79_);
		if (_tmp80_) {
			g_object_set_data ((GObject *) _tmp80_, "vala-creation-function", "Vls.Server.prepare_type_hierarchy");
		}
		_tmp81_ = _tmp80_;
		_tmp82_ = vls_util_object_to_variant ((GObject*) _tmp81_, &_inner_error0_);
		_tmp83_ = _tmp82_;
		_g_object_unref0 (_tmp81_);
		_tmp78_ = _tmp83_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp84_ = _tmp78_;
		_tmp78_ = NULL;
		_tmp85_ = g_new0 (GVariant*, 1 + 1);
		_tmp85_[0] = _tmp84_;
		_tmp86_ = _tmp85_;
		_tmp86__length1 = 1;
		_tmp87_ = g_variant_new_array (NULL, _tmp86_, 1);
		g_variant_ref_sink (_tmp87_);
		_tmp88_ = _tmp87_;
		_tmp86_ = (_vala_array_free (_tmp86_, _tmp86__length1, (GDestroyNotify) g_variant_unref), NULL);
		array = _tmp88_;
		_tmp89_ = array;
		_tmp90_ = vls_server_cancellable;
		jsonrpc_client_reply (client, id, _tmp89_, _tmp90_, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_variant_unref0 (array);
			_g_variant_unref0 (_tmp78_);
			goto __catch0_g_error;
		}
		_g_variant_unref0 (array);
		_g_variant_unref0 (_tmp78_);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp91_;
		GError* _tmp92_;
		const gchar* _tmp93_;
		const gchar* _tmp94_;
		gchar* _tmp95_;
		gchar* _tmp96_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp91_ = string_to_string (method);
		_tmp92_ = e;
		_tmp93_ = _tmp92_->message;
		_tmp94_ = string_to_string (_tmp93_);
		_tmp95_ = g_strconcat ("[", _tmp91_, "] failed to reply to client: ", _tmp94_, NULL);
		_tmp96_ = _tmp95_;
		g_debug ("server.vala:2336: %s", _tmp96_);
		_g_free0 (_tmp96_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_vala_code_node_unref0 (type_symbol);
		_vala_code_node_unref0 (_result_);
		_vala_code_visitor_unref0 (fs);
		_vala_source_file_unref0 (doc);
		_g_object_unref0 (compilation);
		_g_object_unref0 (project);
		_g_object_unref0 (p);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	_vala_code_node_unref0 (type_symbol);
	_vala_code_node_unref0 (_result_);
	_vala_code_visitor_unref0 (fs);
	_vala_source_file_unref0 (doc);
	_g_object_unref0 (compilation);
	_g_object_unref0 (project);
	_g_object_unref0 (p);
}

static void
_vala_array_add37 (GVariant** * array,
                   gint* length,
                   gint* size,
                   GVariant* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (GVariant*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
_vala_array_add38 (GVariant** * array,
                   gint* length,
                   gint* size,
                   GVariant* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (GVariant*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static GVariant*
_variant_new1 (GVariant** value,
               gint value_length1)
{
	GVariant** _tmp49_;
	GVariantBuilder _tmp50_;
	gint _tmp51_;
	_tmp49_ = value;
	g_variant_builder_init (&_tmp50_, G_VARIANT_TYPE ("av"));
	for (_tmp51_ = 0; _tmp51_ < value_length1; _tmp51_++) {
		g_variant_builder_add_value (&_tmp50_, g_variant_new_variant (*_tmp49_));
		_tmp49_++;
	}
	return g_variant_ref_sink (g_variant_builder_end (&_tmp50_));
}

static void
vls_server_show_type_hierarchy (VlsServer* self,
                                JsonrpcClient* client,
                                const gchar* method,
                                GVariant* id,
                                GVariant* params,
                                gboolean supertypes)
{
	GVariant* itemv = NULL;
	const GVariantType* _tmp0_;
	GVariant* _tmp1_;
	LspTypeHierarchyItem* item = NULL;
	GVariant* _tmp2_;
	gpointer _tmp3_;
	VlsProject* project = NULL;
	VlsCompilation* compilation = NULL;
	ValaSourceFile* doc = NULL;
	LspTypeHierarchyItem* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	VlsCompilation* _tmp7_ = NULL;
	VlsProject* _tmp8_ = NULL;
	ValaSourceFile* _tmp9_;
	ValaSourceFile* _tmp10_;
	VlsCompilation* _tmp14_;
	ValaCodeContext* _tmp15_;
	ValaCodeContext* _tmp16_;
	ValaSymbol* symbol = NULL;
	LspTypeHierarchyItem* _tmp17_;
	const gchar* _tmp18_;
	const gchar* _tmp19_;
	VlsCompilation* _tmp20_;
	ValaCodeContext* _tmp21_;
	ValaCodeContext* _tmp22_;
	ValaNamespace* _tmp23_;
	ValaNamespace* _tmp24_;
	ValaScope* _tmp25_;
	ValaScope* _tmp26_;
	ValaSymbol* _tmp27_;
	ValaSymbol* _tmp28_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (client != NULL);
	g_return_if_fail (method != NULL);
	g_return_if_fail (id != NULL);
	g_return_if_fail (params != NULL);
	_tmp0_ = G_VARIANT_TYPE_VARDICT;
	_tmp1_ = g_variant_lookup_value (params, "item", _tmp0_);
	itemv = _tmp1_;
	_tmp2_ = itemv;
	_tmp3_ = vls_util_parse_variant (LSP_TYPE_TYPEHIERARCHY_ITEM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _tmp2_);
	item = (LspTypeHierarchyItem*) _tmp3_;
	_tmp4_ = item;
	_tmp5_ = lsp_typehierarchy_item_get_uri (_tmp4_);
	_tmp6_ = _tmp5_;
	_tmp9_ = vls_server_find_file (self, _tmp6_, &_tmp7_, &_tmp8_);
	_g_object_unref0 (compilation);
	compilation = _tmp7_;
	_g_object_unref0 (project);
	project = _tmp8_;
	doc = _tmp9_;
	_tmp10_ = doc;
	if (_tmp10_ == NULL) {
		LspTypeHierarchyItem* _tmp11_;
		const gchar* _tmp12_;
		const gchar* _tmp13_;
		_tmp11_ = item;
		_tmp12_ = lsp_typehierarchy_item_get_uri (_tmp11_);
		_tmp13_ = _tmp12_;
		g_debug ("server.vala:2348: [%s] file `%s' not found", method, _tmp13_);
		vls_server_reply_null (id, client, method);
		_vala_source_file_unref0 (doc);
		_g_object_unref0 (compilation);
		_g_object_unref0 (project);
		_g_object_unref0 (item);
		_g_variant_unref0 (itemv);
		return;
	}
	_tmp14_ = compilation;
	_tmp15_ = vls_compilation_get_code_context (_tmp14_);
	_tmp16_ = _tmp15_;
	vala_code_context_push (_tmp16_);
	_tmp17_ = item;
	_tmp18_ = lsp_typehierarchy_item_get_name (_tmp17_);
	_tmp19_ = _tmp18_;
	_tmp20_ = compilation;
	_tmp21_ = vls_compilation_get_code_context (_tmp20_);
	_tmp22_ = _tmp21_;
	_tmp23_ = vala_code_context_get_root (_tmp22_);
	_tmp24_ = _tmp23_;
	_tmp25_ = vala_symbol_get_scope ((ValaSymbol*) _tmp24_);
	_tmp26_ = _tmp25_;
	_tmp27_ = vls_code_help_lookup_symbol_full_name (_tmp19_, _tmp26_, NULL);
	symbol = _tmp27_;
	_tmp28_ = symbol;
	if (!G_TYPE_CHECK_INSTANCE_TYPE (_tmp28_, VALA_TYPE_TYPESYMBOL)) {
		vala_code_context_pop ();
		vls_server_reply_null (id, client, method);
		_vala_code_node_unref0 (symbol);
		_vala_source_file_unref0 (doc);
		_g_object_unref0 (compilation);
		_g_object_unref0 (project);
		_g_object_unref0 (item);
		_g_variant_unref0 (itemv);
		return;
	}
	{
		GVariant** array = NULL;
		GVariant** _tmp29_;
		gint array_length1;
		gint _array_size_;
		GVariant** _tmp48_;
		gint _tmp48__length1;
		GVariant* _tmp52_;
		GCancellable* _tmp53_;
		_tmp29_ = g_new0 (GVariant*, 0 + 1);
		array = _tmp29_;
		array_length1 = 0;
		_array_size_ = array_length1;
		if (supertypes) {
			VlsProject* _tmp30_;
			ValaSymbol* _tmp31_;
			gint _tmp32_ = 0;
			LspTypeHierarchyItem** _tmp33_;
			_tmp30_ = project;
			_tmp31_ = symbol;
			_tmp33_ = vls_type_hierarchy_get_supertypes (_tmp30_, G_TYPE_CHECK_INSTANCE_CAST (_tmp31_, VALA_TYPE_TYPESYMBOL, ValaTypeSymbol), &_tmp32_);
			{
				LspTypeHierarchyItem** supertype_collection = NULL;
				gint supertype_collection_length1 = 0;
				gint _supertype_collection_size_ = 0;
				gint supertype_it = 0;
				supertype_collection = _tmp33_;
				supertype_collection_length1 = _tmp32_;
				for (supertype_it = 0; supertype_it < supertype_collection_length1; supertype_it = supertype_it + 1) {
					LspTypeHierarchyItem* _tmp34_;
					LspTypeHierarchyItem* supertype = NULL;
					_tmp34_ = _g_object_ref0 (supertype_collection[supertype_it]);
					supertype = _tmp34_;
					{
						GVariant* _tmp35_ = NULL;
						LspTypeHierarchyItem* _tmp36_;
						GVariant* _tmp37_;
						GVariant* _tmp38_;
						_tmp36_ = supertype;
						_tmp37_ = vls_util_object_to_variant ((GObject*) _tmp36_, &_inner_error0_);
						_tmp35_ = _tmp37_;
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
							_g_object_unref0 (supertype);
							supertype_collection = (_vala_array_free (supertype_collection, supertype_collection_length1, (GDestroyNotify) g_object_unref), NULL);
							array = (_vala_array_free (array, array_length1, (GDestroyNotify) g_variant_unref), NULL);
							goto __catch0_g_error;
						}
						_tmp38_ = _tmp35_;
						_tmp35_ = NULL;
						_vala_array_add37 (&array, &array_length1, &_array_size_, _tmp38_);
						_g_variant_unref0 (_tmp35_);
						_g_object_unref0 (supertype);
					}
				}
				supertype_collection = (_vala_array_free (supertype_collection, supertype_collection_length1, (GDestroyNotify) g_object_unref), NULL);
			}
		} else {
			VlsProject* _tmp39_;
			ValaSymbol* _tmp40_;
			gint _tmp41_ = 0;
			LspTypeHierarchyItem** _tmp42_;
			_tmp39_ = project;
			_tmp40_ = symbol;
			_tmp42_ = vls_type_hierarchy_get_subtypes (_tmp39_, G_TYPE_CHECK_INSTANCE_CAST (_tmp40_, VALA_TYPE_TYPESYMBOL, ValaTypeSymbol), &_tmp41_);
			{
				LspTypeHierarchyItem** subtype_collection = NULL;
				gint subtype_collection_length1 = 0;
				gint _subtype_collection_size_ = 0;
				gint subtype_it = 0;
				subtype_collection = _tmp42_;
				subtype_collection_length1 = _tmp41_;
				for (subtype_it = 0; subtype_it < subtype_collection_length1; subtype_it = subtype_it + 1) {
					LspTypeHierarchyItem* _tmp43_;
					LspTypeHierarchyItem* subtype = NULL;
					_tmp43_ = _g_object_ref0 (subtype_collection[subtype_it]);
					subtype = _tmp43_;
					{
						GVariant* _tmp44_ = NULL;
						LspTypeHierarchyItem* _tmp45_;
						GVariant* _tmp46_;
						GVariant* _tmp47_;
						_tmp45_ = subtype;
						_tmp46_ = vls_util_object_to_variant ((GObject*) _tmp45_, &_inner_error0_);
						_tmp44_ = _tmp46_;
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
							_g_object_unref0 (subtype);
							subtype_collection = (_vala_array_free (subtype_collection, subtype_collection_length1, (GDestroyNotify) g_object_unref), NULL);
							array = (_vala_array_free (array, array_length1, (GDestroyNotify) g_variant_unref), NULL);
							goto __catch0_g_error;
						}
						_tmp47_ = _tmp44_;
						_tmp44_ = NULL;
						_vala_array_add38 (&array, &array_length1, &_array_size_, _tmp47_);
						_g_variant_unref0 (_tmp44_);
						_g_object_unref0 (subtype);
					}
				}
				subtype_collection = (_vala_array_free (subtype_collection, subtype_collection_length1, (GDestroyNotify) g_object_unref), NULL);
			}
		}
		vala_code_context_pop ();
		_tmp48_ = array;
		_tmp48__length1 = array_length1;
		_tmp52_ = _variant_new1 (_tmp48_, _tmp48__length1);
		_tmp53_ = vls_server_cancellable;
		jsonrpc_client_reply (client, id, _tmp52_, _tmp53_, &_inner_error0_);
		_g_variant_unref0 (_tmp52_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			array = (_vala_array_free (array, array_length1, (GDestroyNotify) g_variant_unref), NULL);
			goto __catch0_g_error;
		}
		array = (_vala_array_free (array, array_length1, (GDestroyNotify) g_variant_unref), NULL);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp54_;
		const gchar* _tmp55_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp54_ = e;
		_tmp55_ = _tmp54_->message;
		g_debug ("server.vala:2373: [%s] failed to reply to client: %s", method, _tmp55_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_vala_code_node_unref0 (symbol);
		_vala_source_file_unref0 (doc);
		_g_object_unref0 (compilation);
		_g_object_unref0 (project);
		_g_object_unref0 (item);
		_g_variant_unref0 (itemv);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	_vala_code_node_unref0 (symbol);
	_vala_source_file_unref0 (doc);
	_g_object_unref0 (compilation);
	_g_object_unref0 (project);
	_g_object_unref0 (item);
	_g_variant_unref0 (itemv);
}

static void
vls_server_shutdown (VlsServer* self)
{
	GCancellable* _tmp0_;
	GHashTable* _tmp1_;
	guint _tmp2_ = 0;
	gconstpointer* _tmp3_;
	guint* _tmp8_;
	gint _tmp8__length1;
	g_return_if_fail (self != NULL);
	g_debug ("server.vala:2378: shutting down...");
	self->priv->shutting_down = TRUE;
	_tmp0_ = vls_server_cancellable;
	g_cancellable_cancel (_tmp0_);
	if (self->priv->client_closed_event_id != ((gulong) 0)) {
		g_signal_handler_disconnect ((GObject*) self, self->priv->client_closed_event_id);
	}
	_tmp1_ = self->priv->projects;
	_tmp3_ = g_hash_table_get_keys_as_array (_tmp1_, &_tmp2_);
	{
		VlsProject** project_collection = NULL;
		gint project_collection_length1 = 0;
		gint _project_collection_size_ = 0;
		gint project_it = 0;
		project_collection = _tmp3_;
		project_collection_length1 = _tmp2_;
		for (project_it = 0; project_it < project_collection_length1; project_it = project_it + 1) {
			VlsProject* project = NULL;
			project = project_collection[project_it];
			{
				VlsProject* _tmp4_;
				GHashTable* _tmp5_;
				VlsProject* _tmp6_;
				gconstpointer _tmp7_;
				_tmp4_ = project;
				_tmp5_ = self->priv->projects;
				_tmp6_ = project;
				_tmp7_ = g_hash_table_lookup (_tmp5_, _tmp6_);
				g_signal_handler_disconnect ((GObject*) _tmp4_, (gulong) ((guintptr) _tmp7_));
			}
		}
		project_collection = (g_free (project_collection), NULL);
	}
	_tmp8_ = self->priv->g_sources;
	_tmp8__length1 = self->priv->g_sources_length1;
	{
		guint* source_id_collection = NULL;
		gint source_id_collection_length1 = 0;
		gint _source_id_collection_size_ = 0;
		gint source_id_it = 0;
		source_id_collection = _tmp8_;
		source_id_collection_length1 = _tmp8__length1;
		for (source_id_it = 0; source_id_it < source_id_collection_length1; source_id_it = source_id_it + 1) {
			guint source_id = 0U;
			source_id = source_id_collection[source_id_it];
			{
				g_source_remove (source_id);
			}
		}
	}
}

static void
vls_server_exit (VlsServer* self)
{
	GMainLoop* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->loop;
	g_main_loop_quit (_tmp0_);
}

static void
_vls_server___lambda77_ (void)
{
	vls_server_received_signal = TRUE;
}

static void
__vls_server___lambda77____sighandler_t (gint signum)
{
	_vls_server___lambda77_ ();
}

static void
_vls_server___lambda78_ (void)
{
	vls_server_received_signal = TRUE;
}

static void
__vls_server___lambda78____sighandler_t (gint signum)
{
	_vls_server___lambda78_ ();
}

static void
vls_server_class_init (VlsServerClass * klass,
                       gpointer klass_data)
{
	GCancellable* _tmp0_;
	vls_server_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &VlsServer_private_offset);
	((JsonrpcServerClass *) klass)->notification = (void (*) (JsonrpcServer*, JsonrpcClient*, const gchar*, GVariant*)) vls_server_real_notification;
	((JsonrpcServerClass *) klass)->handle_call = (gboolean (*) (JsonrpcServer*, JsonrpcClient*, const gchar*, GVariant*, GVariant*)) vls_server_real_handle_call;
	((JsonrpcServerClass *) klass)->client_closed = (void (*) (JsonrpcServer*, JsonrpcClient*)) vls_server_real_client_closed;
	G_OBJECT_CLASS (klass)->finalize = vls_server_finalize;
	_tmp0_ = g_cancellable_new ();
	if (_tmp0_) {
		g_object_set_data ((GObject *) _tmp0_, "vala-creation-function", "");
	}
	vls_server_cancellable = _tmp0_;
	signal (SIGINT, __vls_server___lambda77____sighandler_t);
	signal (SIGTERM, __vls_server___lambda78____sighandler_t);
}

static void
vls_server_instance_init (VlsServer * self,
                          gpointer klass)
{
	guint* _tmp0_;
	GeeHashSet* _tmp1_;
	GeeHashSet* _tmp2_;
	VlsFileCache* _tmp3_;
	self->priv = vls_server_get_instance_private (self);
	self->priv->shutting_down = FALSE;
	_tmp0_ = g_new0 (guint, 0);
	self->priv->g_sources = _tmp0_;
	self->priv->g_sources_length1 = 0;
	self->priv->_g_sources_size_ = self->priv->g_sources_length1;
	_tmp1_ = gee_hash_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
	if (_tmp1_) {
		g_object_set_data ((GObject *) _tmp1_, "vala-creation-function", "");
	}
	self->priv->discarded_files = _tmp1_;
	_tmp2_ = gee_hash_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
	if (_tmp2_) {
		g_object_set_data ((GObject *) _tmp2_, "vala-creation-function", "");
	}
	self->priv->open_files = _tmp2_;
	_tmp3_ = vls_file_cache_new ();
	if (_tmp3_) {
		g_object_set_data ((GObject *) _tmp3_, "vala-creation-function", "");
	}
	self->priv->file_cache = _tmp3_;
	self->priv->update_context_client = NULL;
	self->priv->update_context_requests = (gint64) 0;
	self->priv->update_context_time_us = (gint64) 0;
}

static void
vls_server_finalize (GObject * obj)
{
	VlsServer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VLS_TYPE_SERVER, VlsServer);
	_g_main_loop_unref0 (self->priv->loop);
	_g_object_unref0 (self->priv->init_params);
	_vls_gir_documentation_unref0 (self->priv->documentation);
	_g_object_unref0 (self->priv->pending_requests);
	self->priv->g_sources = (g_free (self->priv->g_sources), NULL);
	_g_hash_table_unref0 (self->priv->projects);
	_g_object_unref0 (self->priv->default_project);
	_g_object_unref0 (self->priv->discarded_files);
	_g_object_unref0 (self->priv->open_files);
	_g_object_unref0 (self->priv->file_cache);
	_g_object_unref0 (self->priv->update_context_client);
	G_OBJECT_CLASS (vls_server_parent_class)->finalize (obj);
}

 G_GNUC_NO_INLINE static GType
vls_server_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (VlsServerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vls_server_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (VlsServer), 0, (GInstanceInitFunc) vls_server_instance_init, NULL };
	GType vls_server_type_id;
	vls_server_type_id = g_type_register_static (jsonrpc_server_get_type (), "VlsServer", &g_define_type_info, 0);
	VlsServer_private_offset = g_type_add_instance_private (vls_server_type_id, sizeof (VlsServerPrivate));
	return vls_server_type_id;
}

GType
vls_server_get_type (void)
{
	static gsize vls_server_type_id__once = 0;
	if (g_once_init_enter (&vls_server_type_id__once)) {
		GType vls_server_type_id;
		vls_server_type_id = vls_server_get_type_once ();
		g_once_init_leave (&vls_server_type_id__once, vls_server_type_id);
	}
	return vls_server_type_id__once;
}

static gint
_vala_main (gchar** args,
            gint args_length1)
{
	GOptionContext* ocontext = NULL;
	GOptionContext* _tmp0_;
	GOptionContext* _tmp1_;
	GOptionContext* _tmp2_;
	GOptionContext* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	GMainLoop* loop = NULL;
	GMainLoop* _tmp15_;
	GMainLoop* _tmp16_;
	VlsServer* _tmp17_;
	VlsServer* _tmp18_;
	GMainLoop* _tmp19_;
	GError* _inner_error0_ = NULL;
	gint result;
	g_set_prgname ("vala-language-server");
	_tmp0_ = g_option_context_new ("- vala-language-server");
	ocontext = _tmp0_;
	_tmp1_ = ocontext;
	g_option_context_add_main_entries (_tmp1_, entries, NULL);
	_tmp2_ = ocontext;
	g_option_context_set_summary (_tmp2_, "A language server for Vala");
	_tmp3_ = ocontext;
	_tmp4_ = string_to_string (CONFIG_PROJECT_BUGSITE);
	_tmp5_ = g_strconcat ("Report bugs to ", _tmp4_, NULL);
	_tmp6_ = _tmp5_;
	g_option_context_set_description (_tmp3_, _tmp6_);
	_g_free0 (_tmp6_);
	{
		GOptionContext* _tmp7_;
		_tmp7_ = ocontext;
		g_option_context_parse (_tmp7_, (gint*) (&args_length1), &args, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		FILE* _tmp8_;
		GError* _tmp9_;
		const gchar* _tmp10_;
		FILE* _tmp11_;
		const gchar* _tmp12_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp8_ = stderr;
		_tmp9_ = e;
		_tmp10_ = _tmp9_->message;
		fprintf (_tmp8_, "%s\n", _tmp10_);
		_tmp11_ = stderr;
		_tmp12_ = args[0];
		fprintf (_tmp11_, "Run '%s --version' to print version, or no arguments to run the langua" \
"ge server.\n", _tmp12_);
		result = 1;
		_g_error_free0 (e);
		_g_option_context_free0 (ocontext);
		return result;
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		gint _tmp13_ = -1;
		_g_option_context_free0 (ocontext);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return _tmp13_;
	}
	if (opt_version) {
		FILE* _tmp14_;
		_tmp14_ = stdout;
		fprintf (_tmp14_, "%s %s\n", CONFIG_PROJECT_NAME, CONFIG_PROJECT_VERSION);
		result = 1;
		_g_option_context_free0 (ocontext);
		return result;
	}
	_tmp15_ = g_main_loop_new (NULL, FALSE);
	loop = _tmp15_;
	_tmp16_ = loop;
	_tmp17_ = vls_server_new (_tmp16_);
	if (_tmp17_) {
		g_object_set_data ((GObject *) _tmp17_, "vala-creation-function", "main");
	}
	_tmp18_ = _tmp17_;
	_g_object_unref0 (_tmp18_);
	_tmp19_ = loop;
	g_main_loop_run (_tmp19_);
	result = 0;
	_g_main_loop_unref0 (loop);
	_g_option_context_free0 (ocontext);
	return result;
}

int
main (int argc,
      char ** argv)
{
	return _vala_main (argv, argc);
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

